/*************************************************************************
 *
 *  $RCSfile: sc_scendlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:44:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// auto strip #include "scitems.hxx"

// auto strip #ifndef _SFXPOOLITEM_HXX
// auto strip #include <svtools/poolitem.hxx>
// auto strip #endif

// auto strip #include <bf_svx/drawitem.hxx>
// auto strip #include <bf_svx/xtable.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <svtools/useroptions.hxx>
// auto strip #include <vcl/msgbox.hxx>

// auto strip #ifndef _UNOTOOLS_LOCALEDATAWRAPPER_HXX
// auto strip #include <unotools/localedatawrapper.hxx>
// auto strip #endif

// auto strip #include "global.hxx"
#include "globstr.hrc"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "document.hxx"
// auto strip #include "scresid.hxx"
#include "scendlg.hrc"
// auto strip #include "scendlg.hxx"
namespace binfilter {

//========================================================================

//STRIP001 ScNewScenarioDlg::ScNewScenarioDlg( Window* pParent, const String& rName, BOOL bEdit )
//STRIP001 
//STRIP001 	:	ModalDialog 	( pParent, ScResId( RID_SCDLG_NEWSCENARIO ) ),
//STRIP001 		aBtnOk			( this, ScResId( BTN_OK ) ),
//STRIP001 		aBtnCancel		( this, ScResId( BTN_CANCEL ) ),
//STRIP001 		aBtnHelp		( this, ScResId( BTN_HELP ) ),
//STRIP001 		aEdName 		( this, ScResId( ED_NAME ) ),
//STRIP001 		aEdComment		( this, ScResId( ED_COMMENT ) ),
//STRIP001 		aCbShowFrame	( this, ResId( CB_SHOWFRAME ) ),
//STRIP001 		aLbColor		( this, ResId( LB_COLOR ) ),
//STRIP001 		//aCbPrintFrame	( this, ResId( CB_PRINTFRAME ) ),
//STRIP001 		aCbTwoWay		( this, ResId( CB_TWOWAY ) ),
//STRIP001 		//aCbAttrib		( this, ResId( CB_ATTRIB ) ),
//STRIP001 		//aCbValue		( this, ResId( CB_VALUE ) ),
//STRIP001 		aCbCopyAll		( this, ResId( CB_COPYALL ) ),
//STRIP001         aFlName         ( this, ResId( FL_NAME )),
//STRIP001         aFlComment      ( this, ResId( FL_COMMENT ) ),
//STRIP001         aFlOptions      ( this, ResId( FL_OPTIONS ) ),
//STRIP001 		aDefScenarioName( rName ),
//STRIP001 		bIsEdit			( bEdit )
//STRIP001 {
//STRIP001 	if (bIsEdit)
//STRIP001 		SetText(String(ResId(STR_EDIT)));
//STRIP001 
//STRIP001 	SfxObjectShell*	pDocSh = SfxObjectShell::Current();
//STRIP001 	if ( pDocSh )
//STRIP001 	{
//STRIP001 		const SfxPoolItem* pItem = pDocSh->GetItem( ITEMID_COLOR_TABLE );
//STRIP001 		if ( pItem )
//STRIP001 		{
//STRIP001 			XColorTable* pColorTable = ((SvxColorTableItem*)pItem)->GetColorTable();
//STRIP001 			if (pColorTable)
//STRIP001 			{
//STRIP001 				aLbColor.SetUpdateMode( FALSE );
//STRIP001 				long nCount = pColorTable->Count();
//STRIP001 				for ( long n=0; n<nCount; n++ )
//STRIP001 				{
//STRIP001 					XColorEntry* pEntry = pColorTable->Get(n);
//STRIP001 					aLbColor.InsertEntry( pEntry->GetColor(), pEntry->GetName() );
//STRIP001 				}
//STRIP001 				aLbColor.SetUpdateMode( TRUE );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	SvtUserOptions aUserOpt;
//STRIP001 
//STRIP001 	String aComment( ScResId( STR_CREATEDBY ) );
//STRIP001 
//STRIP001 	aComment += ' ';
//STRIP001 	aComment += aUserOpt.GetFirstName();
//STRIP001 	aComment += ' ';
//STRIP001 	aComment += aUserOpt.GetLastName();
//STRIP001 	aComment.AppendAscii(RTL_CONSTASCII_STRINGPARAM( ", " ));
//STRIP001 	aComment += String( ScResId( STR_ON ) );
//STRIP001 	aComment += ' ';
//STRIP001     aComment += ScGlobal::pLocaleData->getDate( Date() );
//STRIP001 	aComment.AppendAscii(RTL_CONSTASCII_STRINGPARAM( ", " ));
//STRIP001     aComment += ScGlobal::pLocaleData->getTime( Time() );
//STRIP001 
//STRIP001 	aEdComment	.SetText( aComment );
//STRIP001 	aEdName 	.SetText( rName );
//STRIP001 	aBtnOk		.SetClickHdl( LINK( this, ScNewScenarioDlg, OkHdl ) );
//STRIP001     aCbShowFrame.SetClickHdl( LINK( this, ScNewScenarioDlg, EnableHdl ) );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aLbColor.SelectEntry( Color( COL_LIGHTGRAY ) );
//STRIP001 	aCbShowFrame.Check(TRUE);
//STRIP001 	//aCbPrintFrame.Check(TRUE);
//STRIP001 	aCbTwoWay.Check(TRUE);
//STRIP001 	//aCbAttrib.Check(FALSE);
//STRIP001 	//aCbValue.Check(FALSE);
//STRIP001 	aCbCopyAll.Check(FALSE);
//STRIP001 
//STRIP001 	if (bIsEdit)
//STRIP001 		aCbCopyAll.Enable(FALSE);
//STRIP001 
//STRIP001 	//!	die drei funktionieren noch nicht...
//STRIP001 	/*
//STRIP001 	aCbPrintFrame.Enable(FALSE);
//STRIP001 	aCbAttrib.Enable(FALSE);
//STRIP001 	aCbValue.Enable(FALSE);
//STRIP001 	*/
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 __EXPORT ScNewScenarioDlg::~ScNewScenarioDlg()
//STRIP001 {
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 void ScNewScenarioDlg::GetScenarioData( String& rName, String& rComment,
//STRIP001 										Color& rColor, USHORT& rFlags ) const
//STRIP001 {
//STRIP001 	rComment = aEdComment.GetText();
//STRIP001 	rName	 = aEdName.GetText();
//STRIP001 
//STRIP001 	if ( rName.Len() == 0 )
//STRIP001 		rName = aDefScenarioName;
//STRIP001 
//STRIP001 	rColor = aLbColor.GetSelectEntryColor();
//STRIP001 	USHORT nBits = 0;
//STRIP001 	if (aCbShowFrame.IsChecked())
//STRIP001 		nBits |= SC_SCENARIO_SHOWFRAME;
//STRIP001 	/*
//STRIP001 	if (aCbPrintFrame.IsChecked())
//STRIP001 		nBits |= SC_SCENARIO_PRINTFRAME;
//STRIP001 	*/
//STRIP001 	if (aCbTwoWay.IsChecked())
//STRIP001 		nBits |= SC_SCENARIO_TWOWAY;
//STRIP001 	/*
//STRIP001 	if (aCbAttrib.IsChecked())
//STRIP001 		nBits |= SC_SCENARIO_ATTRIB;
//STRIP001 	if (aCbValue.IsChecked())
//STRIP001 		nBits |= SC_SCENARIO_VALUE;
//STRIP001 	*/
//STRIP001 	if (aCbCopyAll.IsChecked())
//STRIP001 		nBits |= SC_SCENARIO_COPYALL;
//STRIP001 	rFlags = nBits;
//STRIP001 }

//STRIP001 void ScNewScenarioDlg::SetScenarioData( const String& rName, const String& rComment,
//STRIP001 										const Color& rColor, USHORT nFlags )
//STRIP001 {
//STRIP001 	aEdComment.SetText(rComment);
//STRIP001 	aEdName.SetText(rName);
//STRIP001 	aLbColor.SelectEntry(rColor);
//STRIP001 
//STRIP001 	aCbShowFrame.Check ( (nFlags & SC_SCENARIO_SHOWFRAME)  != 0 );
//STRIP001     EnableHdl( &aCbShowFrame );
//STRIP001 	//aCbPrintFrame.Check( (nFlags & SC_SCENARIO_PRINTFRAME) != 0 );
//STRIP001 	aCbTwoWay.Check    ( (nFlags & SC_SCENARIO_TWOWAY)     != 0 );
//STRIP001 	//aCbAttrib.Check    ( (nFlags & SC_SCENARIO_ATTRIB)     != 0 );
//STRIP001 	//aCbValue.Check     ( (nFlags & SC_SCENARIO_VALUE)      != 0 );
//STRIP001 	//	CopyAll nicht
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScNewScenarioDlg, OkHdl, OKButton *, EMPTYARG )
//STRIP001 {
//STRIP001 	String		aName	( aEdName.GetText() );
//STRIP001 	ScDocument* pDoc	= ((ScTabViewShell*)SfxViewShell::Current())->
//STRIP001 								GetViewData()->GetDocument();
//STRIP001 
//STRIP001 	aName.EraseLeadingChars( ' ' );
//STRIP001 	aName.EraseTrailingChars( ' ' );
//STRIP001 	aEdName.SetText( aName );
//STRIP001 
//STRIP001 	if ( !pDoc->ValidTabName( aName ) )
//STRIP001 	{
//STRIP001 		InfoBox( this, ScGlobal::GetRscString( STR_INVALIDTABNAME ) ).
//STRIP001 			Execute();
//STRIP001 		aEdName.GrabFocus();
//STRIP001 	}
//STRIP001 	else if ( !bIsEdit && !pDoc->ValidNewTabName( aName ) )
//STRIP001 	{
//STRIP001 		InfoBox( this, ScGlobal::GetRscString( STR_NEWTABNAMENOTUNIQUE ) ).
//STRIP001 			Execute();
//STRIP001 		aEdName.GrabFocus();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		EndDialog( RET_OK );
//STRIP001 	return 0;
//STRIP001 
//STRIP001 	//!	beim Editieren testen, ob eine andere Tabelle den Namen hat!
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScNewScenarioDlg, EnableHdl, CheckBox *, pBox )
//STRIP001 {
//STRIP001     if( pBox == &aCbShowFrame )
//STRIP001         aLbColor.Enable( aCbShowFrame.IsChecked() );
//STRIP001     return 0;
//STRIP001 }

}
