/*************************************************************************
 *
 *  $RCSfile: dbnamdlg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:29:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_DBNAMDLG_HXX
#define SC_DBNAMDLG_HXX

#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _MOREBTN_HXX //autogen
#include <vcl/morebtn.hxx>
#endif

#ifndef SC_ANYREFDG_HXX
#include "anyrefdg.hxx"
#endif

#ifndef SC_DBCOLECT_HXX
#include "dbcolect.hxx"
#endif

#ifndef _SC_EXPFTEXT_HXX
#include "expftext.hxx"
#endif
namespace binfilter {

class ScViewData;
class ScDocument;


//============================================================================

//STRIP001 class ScDbNameDlg : public ScAnyRefDlg
//STRIP001 {
//STRIP001 public:
//STRIP001 					ScDbNameDlg( SfxBindings* pB, SfxChildWindow* pCW, Window* pParent,
//STRIP001 								 ScViewData*	ptrViewData );
//STRIP001 					~ScDbNameDlg();
//STRIP001 
//STRIP001 	virtual void	SetReference( const ScRange& rRef, ScDocument* pDoc );
//STRIP001 
//STRIP001 	virtual BOOL	IsRefInputMode() const;
//STRIP001 	virtual void	SetActive();
//STRIP001 	virtual BOOL	Close();
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine           aFlName;
//STRIP001 	ComboBox			aEdName;
//STRIP001 
//STRIP001     FixedLine           aFlAssign;
//STRIP001 	ScRefEdit			aEdAssign;
//STRIP001 	ScRefButton			aRbAssign;
//STRIP001 
//STRIP001     FixedLine           aFlOptions;
//STRIP001 	CheckBox			aBtnHeader;
//STRIP001 	CheckBox			aBtnDoSize;
//STRIP001 	CheckBox			aBtnKeepFmt;
//STRIP001 	CheckBox			aBtnStripData;
//STRIP001 	ScExpandedFixedText	aFTSource;	   //@18.09.97 erweiterter FixedText
//STRIP001 	FixedText			aFTOperations;
//STRIP001 
//STRIP001 	OKButton		aBtnOk;
//STRIP001 	CancelButton	aBtnCancel;
//STRIP001 	HelpButton		aBtnHelp;
//STRIP001 	PushButton		aBtnAdd;
//STRIP001 	PushButton		aBtnRemove;
//STRIP001 	MoreButton		aBtnMore;
//STRIP001 
//STRIP001 	BOOL			bSaved;
//STRIP001 
//STRIP001 
//STRIP001 	const String	aStrAdd;	// "Hinzufuegen"
//STRIP001 	const String	aStrModify;	// "Aendern"
//STRIP001 	const String	aStrNoName; // "unbenannt"
//STRIP001 	const String	aStrInvalid;
//STRIP001 
//STRIP001 	String			aStrSource;
//STRIP001 	String			aStrOperations;
//STRIP001 
//STRIP001 	ScViewData*		pViewData;
//STRIP001 	ScDocument*		pDoc;
//STRIP001 	BOOL			bRefInputMode;
//STRIP001 
//STRIP001 	ScDBCollection	aLocalDbCol;
//STRIP001 	ScRange			theCurArea;
//STRIP001 	List			aRemoveList;
//STRIP001 
//STRIP001 #ifdef _DBNAMDLG_CXX
//STRIP001 private:
//STRIP001 	void			Init();
//STRIP001 	void			UpdateNames();
//STRIP001 	void			UpdateDBData( const String& rStrName );
//STRIP001 	void			SetInfoStrings( const ScDBData* pDBData );
//STRIP001 
//STRIP001 	DECL_LINK( CancelBtnHdl, void * );
//STRIP001 	DECL_LINK( OkBtnHdl, void * );
//STRIP001 	DECL_LINK( AddBtnHdl, void * );
//STRIP001 	DECL_LINK( RemoveBtnHdl, void * );
//STRIP001 	DECL_LINK( NameModifyHdl, void * );
//STRIP001 	DECL_LINK( AssModifyHdl, void * );
//STRIP001 #endif
//STRIP001 };



} //namespace binfilter
#endif // SC_DBNAMDLG_HXX

