/*************************************************************************
 *
 *  $RCSfile: tpsort.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:30:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_TPSORT_HXX
#define SC_TPSORT_HXX


#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#ifndef _SVX_LANGBOX_HXX
#include <bf_svx/langbox.hxx>
#endif


#ifndef SC_SCGLOB_HXX
#include "global.hxx"
#endif
class CollatorWrapper;
namespace binfilter {

//------------------------------------------------------------------------

#define SC_MAXFIELDS	200

class ScViewData;
class ScSortDlg;
struct ScSortParam;

//========================================================================
// Kriterien

//STRIP001 class ScTabPageSortFields : public SfxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 				ScTabPageSortFields( Window*			 pParent,
//STRIP001 									 const SfxItemSet&	 rArgSet );
//STRIP001 				~ScTabPageSortFields();
//STRIP001 
//STRIP001 	static	SfxTabPage*	Create		( Window*				pParent,
//STRIP001 									  const SfxItemSet& 	rArgSet );
//STRIP001 	static	USHORT*		GetRanges	();
//STRIP001 	virtual	BOOL		FillItemSet	( SfxItemSet& rArgSet );
//STRIP001 	virtual	void		Reset		( const SfxItemSet& rArgSet );
//STRIP001 
//STRIP001 protected:
//STRIP001 // fuer Datenaustausch (sollte noch umgestellt werden!)
//STRIP001 //	virtual void		ActivatePage	( const SfxItemSet& rSet );
//STRIP001 	virtual void		ActivatePage	();
//STRIP001 	virtual int			DeactivatePage	( SfxItemSet* pSet = 0);
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine       aFlSort1;
//STRIP001 	ListBox			aLbSort1;
//STRIP001 	RadioButton		aBtnUp1;
//STRIP001 	RadioButton 	aBtnDown1;
//STRIP001 
//STRIP001     FixedLine       aFlSort2;
//STRIP001 	ListBox			aLbSort2;
//STRIP001 	RadioButton		aBtnUp2;
//STRIP001 	RadioButton 	aBtnDown2;
//STRIP001 
//STRIP001     FixedLine       aFlSort3;
//STRIP001 	ListBox			aLbSort3;
//STRIP001 	RadioButton		aBtnUp3;
//STRIP001 	RadioButton 	aBtnDown3;
//STRIP001 
//STRIP001 	String			aStrUndefined;
//STRIP001 	String			aStrColumn;
//STRIP001 	String			aStrRow;
//STRIP001 
//STRIP001 	const USHORT		nWhichSort;
//STRIP001 	ScSortDlg*			pDlg;
//STRIP001 	ScViewData*			pViewData;
//STRIP001 	const ScSortParam&	rSortData;
//STRIP001 	USHORT				nFieldArr[SC_MAXFIELDS];
//STRIP001 	USHORT				nFieldCount;
//STRIP001 	USHORT				nFirstCol;
//STRIP001 	USHORT				nFirstRow;
//STRIP001 	BOOL				bHasHeader;
//STRIP001 	BOOL				bSortByRows;
//STRIP001 
//STRIP001 	ListBox*			aSortLbArr[3];
//STRIP001 	RadioButton*		aDirBtnArr[3][2];
//STRIP001     FixedLine*          aFlArr[3];
//STRIP001 
//STRIP001 #ifdef _TPSORT_CXX
//STRIP001 private:
//STRIP001 	void	Init			();
//STRIP001 	void	DisableField	( USHORT nField );
//STRIP001 	void	EnableField		( USHORT nField );
//STRIP001 	void	FillFieldLists	();
//STRIP001 	USHORT	GetFieldSelPos	( USHORT nField );
//STRIP001 
//STRIP001 	// Handler ------------------------
//STRIP001 	DECL_LINK( SelectHdl, ListBox * );
//STRIP001 #endif
//STRIP001 };

//========================================================================
// Sortieroptionen:

class ScDocument;
class ScRangeData;
class CollatorRessource;

//STRIP001 class ScTabPageSortOptions : public SfxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 				ScTabPageSortOptions( Window*			 pParent,
//STRIP001 									  const SfxItemSet&	 rArgSet );
//STRIP001 				~ScTabPageSortOptions();
//STRIP001 
//STRIP001 	static	SfxTabPage*	Create		( Window*				pParent,
//STRIP001 									  const SfxItemSet& 	rArgSet );
//STRIP001 	static	USHORT*		GetRanges	();
//STRIP001 	virtual	BOOL		FillItemSet	( SfxItemSet& rArgSet );
//STRIP001 	virtual	void		Reset		( const SfxItemSet& rArgSet );
//STRIP001 
//STRIP001 protected:
//STRIP001 // fuer Datenaustausch (sollte noch umgestellt werden!)
//STRIP001 //	virtual void		ActivatePage	( const SfxItemSet& rSet );
//STRIP001 	virtual void		ActivatePage	();
//STRIP001 	virtual int			DeactivatePage	( SfxItemSet* pSet = 0);
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001     CheckBox            aBtnCase;
//STRIP001     CheckBox            aBtnHeader;
//STRIP001     CheckBox            aBtnFormats;
//STRIP001 
//STRIP001     CheckBox            aBtnCopyResult;
//STRIP001     ListBox             aLbOutPos;
//STRIP001     Edit                aEdOutPos;
//STRIP001 
//STRIP001     CheckBox            aBtnSortUser;
//STRIP001     ListBox             aLbSortUser;
//STRIP001 
//STRIP001     FixedText           aFtLanguage;
//STRIP001     SvxLanguageBox      aLbLanguage;
//STRIP001     FixedText           aFtAlgorithm;
//STRIP001     ListBox             aLbAlgorithm;
//STRIP001 
//STRIP001     FixedLine           aLineDirection;
//STRIP001     RadioButton         aBtnTopDown;
//STRIP001     RadioButton         aBtnLeftRight;
//STRIP001 
//STRIP001     FixedText           aFtAreaLabel;
//STRIP001 //  FixedInfo           aFtArea;
//STRIP001     String              aStrRowLabel;
//STRIP001     String              aStrColLabel;
//STRIP001     String              aStrUndefined;
//STRIP001     String              aStrNoName;
//STRIP001     String              aStrAreaLabel;
//STRIP001 
//STRIP001 	const USHORT		nWhichSort;
//STRIP001 	const ScSortParam&	rSortData;
//STRIP001 	ScViewData*			pViewData;
//STRIP001 	ScDocument*			pDoc;
//STRIP001 	ScSortDlg*			pDlg;
//STRIP001 	ScAddress			theOutPos;
//STRIP001 
//STRIP001 	CollatorRessource*	pColRes;
//STRIP001 	CollatorWrapper*	pColWrap;
//STRIP001 
//STRIP001 #ifdef _TPSORT_CXX
//STRIP001 private:
//STRIP001 	void Init					();
//STRIP001 	void FillUserSortListBox	();
//STRIP001 	void FillOutPosList 		();
//STRIP001 
//STRIP001 	// Handler ------------------------
//STRIP001 	DECL_LINK( EnableHdl, CheckBox * );
//STRIP001 	DECL_LINK( SelOutPosHdl, ListBox * );
//STRIP001 	void EdOutPosModHdl	( Edit* pEd );
//STRIP001 	DECL_LINK( SortDirHdl, RadioButton * );
//STRIP001 	DECL_LINK( FillAlgorHdl, void * );
//STRIP001 #endif
//STRIP001 };



} //namespace binfilter
#endif // SC_TPSORT_HXX

