/*************************************************************************
 *
 *  $RCSfile: tpview.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:30:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_TPVIEW_HXX
#define SC_TPVIEW_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif

#ifndef _SVX_STRARRAY_HXX //autogen
#include <bf_svx/strarray.hxx>
#endif
namespace binfilter {

//========================================================================
// View-Optionen:

class ScViewOptions;

//========================================================================
// TabPage Inhalte

//STRIP001 class ScTpContentOptions : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aLinesGB;
//STRIP001 	CheckBox		aGridCB;
//STRIP001 	FixedText		aColorFT;
//STRIP001 	ColorListBox	aColorLB;
//STRIP001 	CheckBox		aBreakCB;
//STRIP001 	CheckBox		aGuideLineCB;
//STRIP001 	CheckBox		aHandleCB;
//STRIP001 	CheckBox		aBigHandleCB;
//STRIP001 
//STRIP001     FixedLine       aSeparator1FL;
//STRIP001 
//STRIP001     FixedLine       aDisplayGB;
//STRIP001     CheckBox        aFormulaCB;
//STRIP001     CheckBox        aNilCB;
//STRIP001     CheckBox        aAnnotCB;
//STRIP001     CheckBox        aValueCB;
//STRIP001     CheckBox        aAnchorCB;
//STRIP001     CheckBox        aClipMarkCB;
//STRIP001     CheckBox        aRangeFindCB;
//STRIP001 
//STRIP001     FixedLine       aObjectGB;
//STRIP001     FixedText       aObjGrfFT;
//STRIP001     ListBox         aObjGrfLB;
//STRIP001     FixedText       aDiagramFT;
//STRIP001     ListBox         aDiagramLB;
//STRIP001     FixedText       aDrawFT;
//STRIP001     ListBox         aDrawLB;
//STRIP001 
//STRIP001     FixedLine       aSeparator2FL;
//STRIP001 
//STRIP001     FixedLine       aWindowGB;
//STRIP001 	CheckBox		aRowColHeaderCB;
//STRIP001 	CheckBox		aHScrollCB;
//STRIP001 	CheckBox		aVScrollCB;
//STRIP001 	CheckBox		aTblRegCB;
//STRIP001 	CheckBox		aOutlineCB;
//STRIP001 
//STRIP001     ScViewOptions*  pLocalOptions;
//STRIP001 
//STRIP001     void    InitGridOpt();
//STRIP001 	DECL_LINK( GridHdl, CheckBox* );
//STRIP001     DECL_LINK( SelLbObjHdl, ListBox* );
//STRIP001 	DECL_LINK( CBHdl, CheckBox* );
//STRIP001 
//STRIP001 			ScTpContentOptions( Window*			pParent,
//STRIP001 							 const SfxItemSet&	rArgSet );
//STRIP001 			~ScTpContentOptions();
//STRIP001 
//STRIP001 public:
//STRIP001 	static	SfxTabPage*	Create			( Window*		 		pParent,
//STRIP001 										  const SfxItemSet&		rCoreSet );
//STRIP001 	virtual	BOOL		FillItemSet		( SfxItemSet& rCoreSet );
//STRIP001 	virtual	void		Reset			( const SfxItemSet& rCoreSet );
//STRIP001 	virtual void		ActivatePage( const SfxItemSet& );
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 
//STRIP001 };

//========================================================================
// TabPage Layout
class ScDocument;
//STRIP001 class ScTpLayoutOptions : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aUnitGB;
//STRIP001     FixedText       aUnitFT;
//STRIP001     ListBox         aUnitLB;
//STRIP001     FixedText       aTabFT;
//STRIP001     MetricField     aTabMF;
//STRIP001 
//STRIP001     FixedLine       aSeparatorFL;
//STRIP001     FixedLine       aLinkGB;
//STRIP001     FixedText       aLinkFT;
//STRIP001     RadioButton     aAlwaysRB;
//STRIP001     RadioButton     aRequestRB;
//STRIP001     RadioButton     aNeverRB;
//STRIP001 
//STRIP001     FixedLine       aOptionsGB;
//STRIP001 	CheckBox		aAlignCB;
//STRIP001 	ListBox			aAlignLB;
//STRIP001 	CheckBox		aEditModeCB;
//STRIP001 	CheckBox		aFormatCB;
//STRIP001     CheckBox        aExpRefCB;
//STRIP001 	CheckBox		aMarkHdrCB;
//STRIP001 	CheckBox		aTextFmtCB;
//STRIP001     CheckBox        aReplWarnCB;
//STRIP001 
//STRIP001 	SvxStringArray 	aUnitArr;
//STRIP001 
//STRIP001     DECL_LINK( CBHdl, CheckBox* );
//STRIP001 
//STRIP001     DECL_LINK(MetricHdl, ListBox*);
//STRIP001     DECL_LINK( AlignHdl, CheckBox* );
//STRIP001 
//STRIP001     ScDocument *pDoc;
//STRIP001 
//STRIP001 	DECL_LINK(	UpdateHdl, CheckBox* );
//STRIP001 
//STRIP001 			ScTpLayoutOptions( Window*			pParent,
//STRIP001 							 const SfxItemSet&	rArgSet );
//STRIP001 			~ScTpLayoutOptions();
//STRIP001 
//STRIP001 public:
//STRIP001 	static	SfxTabPage*	Create			( Window*		 		pParent,
//STRIP001 										  const SfxItemSet&		rCoreSet );
//STRIP001 	virtual	BOOL		FillItemSet		( SfxItemSet& rCoreSet );
//STRIP001 	virtual	void		Reset			( const SfxItemSet& rCoreSet );
//STRIP001 	virtual void		ActivatePage( const SfxItemSet& );
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001     void                SetDocument(ScDocument* pPtr){pDoc = pPtr;}
//STRIP001 
//STRIP001 };
//========================================================================

} //namespace binfilter
#endif // SC_TPUSRLST_HXX

