#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:22:55 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..$/..
BFPRJ=..$/..$/..

PROJECTPCH=sch
PROJECTPCHSOURCE=$(BFPRJ)$/util$/sch_sch

PRJNAME=binfilter
TARGET=sch_dlg

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

AUTOSEG=true

# --- Settings -----------------------------------------------------
.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk
INC+= -I$(PRJ)$/inc$/bf_sch
# --- ImageLists ---------------------------------------------------

#IMGLST_SRS=$(SRS)$/dlg.srs
#BMP_IN=$(BFPRJ)$/res

# --- Files --------------------------------------------------------

CXXFILES = $(BFPRJ)$/util$/sch_sch.cxx \
		sch_viewdlg.cxx	\
		sch_dlggraut.cxx	\
	    sch_datstat.cxx	\
		sch_databrws.cxx	\
		sch_dataedit.cxx	\
		sch_diagrtyp.cxx	\
		sch_dgrdata.cxx	\
		sch_title.cxx	\
		sch_legend.cxx	\
		sch_datdescr.cxx	\
		sch_axisgrid.cxx	\
		sch_attrib.cxx	\
		sch_tpalign.cxx	\
		sch_tplegend.cxx	\
		sch_tpdescr.cxx	\
	    sch_tpstat.cxx	\
	    sch_tpoption.cxx	\
	    sch_tplayout.cxx	\
		sch_tpdefcol.cxx	\
		sch_tplabel.cxx	\
		sch_tpscaley.cxx \
		sch_transform.cxx

SRS1NAME=$(TARGET)
SRC1FILES = \
		sch_viewdlg.src	\
		sch_dlggraut.src	\
		sch_diagrtyp.src	\
	        sch_datstat.src	\
		sch_dgrdata.src	\
		sch_title.src	\
		sch_legend.src	\
		sch_datdescr.src	\
		sch_axisgrid.src	\
		sch_attrib.src	\
		sch_attrib2.src	\
		sch_attrib3.src	\
		sch_attrib4.src	\
		sch_tpappopt.src	\
		sch_tplabel.src	\
		sch_tpscaley.src


SLOFILES =	\
		$(SLO)$/sch_viewdlg.obj	\
		$(SLO)$/sch_dlggraut.obj	\
		$(SLO)$/sch_databrws.obj	\
	        $(SLO)$/sch_datstat.obj	\
		$(SLO)$/sch_dataedit.obj	\
		$(SLO)$/sch_diagrtyp.obj	\
		$(SLO)$/sch_dgrdata.obj	\
		$(SLO)$/sch_title.obj	\
		$(SLO)$/sch_legend.obj	\
		$(SLO)$/sch_datdescr.obj 	\
		$(SLO)$/sch_axisgrid.obj	\
		$(SLO)$/sch_attrib.obj	\
		$(SLO)$/sch_tpalign.obj	\
		$(SLO)$/sch_tplegend.obj	\
		$(SLO)$/sch_tpdescr.obj	\
		$(SLO)$/sch_tpstat.obj	\
		$(SLO)$/sch_tpoption.obj	\
	    $(SLO)$/sch_tplayout.obj	\
		$(SLO)$/sch_tpdefcol.obj	\
		$(SLO)$/sch_tplabel.obj	\
		$(SLO)$/sch_tpscaley.obj \
		$(SLO)$/sch_transform.obj

# --- Tagets -------------------------------------------------------

.INCLUDE :  target.mk

