/*************************************************************************
 *
 *  $RCSfile: sch_title.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif


#include "title.hrc"
#include "axisgrid.hrc"

#include "schresid.hxx"
#include "schdll.hxx"
#include "title.hxx"
#include <bf_sfx2/sfx.hrc>
namespace binfilter {


/*************************************************************************
|*
|* Dialog zum Aendern des Titels
|*
\************************************************************************/

//STRIP001 SchTitleDlg::SchTitleDlg(Window* pWindow, const SfxItemSet& rInAttrs,
//STRIP001 						 BOOL bAxis, BOOL b3D) :
//STRIP001 	ModalDialog(pWindow, SchResId(DLG_TITLE)),
//STRIP001 	aCbxMain(this, ResId(CBX_MAINTITLE)),
//STRIP001 	aEdtMain(this, ResId(EDT_MAINTITLE)),
//STRIP001 	aCbxSub(this, ResId(CBX_SUBTITLE)),
//STRIP001 	aEdtSub(this, ResId(EDT_SUBTITLE)),
//STRIP001 	aCbxXAxis(this, ResId(CBX_TITLE_X_AXIS)),
//STRIP001 	aEdtXAxis(this, ResId(EDT_X_AXIS)),
//STRIP001 	aCbxYAxis(this, ResId(CBX_TITLE_Y_AXIS)),
//STRIP001 	aEdtYAxis(this, ResId(EDT_Y_AXIS)),
//STRIP001 	aCbxZAxis(this, ResId(CBX_TITLE_Z_AXIS)),
//STRIP001 	aEdtZAxis(this, ResId(EDT_Z_AXIS)),
//STRIP001 	aBtnOK(this, ResId(BTN_OK)),
//STRIP001 	aBtnCancel(this, ResId(BTN_CANCEL)),
//STRIP001 	aBtnHelp(this, ResId(BTN_HELP)),
//STRIP001 	rOutAttrs(rInAttrs)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aCbxMain.SetClickHdl(LINK(this, SchTitleDlg, EnableTitleHdl));
//STRIP001 	aCbxSub.SetClickHdl(LINK(this, SchTitleDlg, EnableTitleHdl));
//STRIP001 
//STRIP001 	if (bAxis)
//STRIP001 	{
//STRIP001 		aCbxXAxis.SetClickHdl(LINK(this, SchTitleDlg, EnableTitleHdl));
//STRIP001 		aCbxYAxis.SetClickHdl(LINK(this, SchTitleDlg, EnableTitleHdl));
//STRIP001 
//STRIP001 		if (b3D)
//STRIP001 			aCbxZAxis.SetClickHdl(LINK(this, SchTitleDlg, EnableTitleHdl));
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aCbxZAxis.Disable();
//STRIP001 			aEdtZAxis.Disable();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aCbxXAxis.Disable();
//STRIP001 		aEdtXAxis.Disable();
//STRIP001 		aCbxYAxis.Disable();
//STRIP001 		aEdtYAxis.Disable();
//STRIP001 		aCbxZAxis.Disable();
//STRIP001 		aEdtZAxis.Disable();
//STRIP001 	}
//STRIP001 
//STRIP001 	Reset();
//STRIP001 }

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

//STRIP001 SchTitleDlg::~SchTitleDlg()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*	Titel-Editierfelder je nach Checkbox-Markierung enablen/disablen
|*
*************************************************************************/

//STRIP001 IMPL_LINK( SchTitleDlg, EnableTitleHdl, CheckBox *, pCbx )
//STRIP001 {
//STRIP001 	if (pCbx == &aCbxMain)
//STRIP001 	{
//STRIP001 		aEdtMain.Enable(aCbxMain.IsChecked());
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxSub)
//STRIP001 	{
//STRIP001 		aEdtSub.Enable(aCbxSub.IsChecked());
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxXAxis)
//STRIP001 	{
//STRIP001 		aEdtXAxis.Enable(aCbxXAxis.IsChecked());
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxYAxis)
//STRIP001 	{
//STRIP001 		aEdtYAxis.Enable(aCbxYAxis.IsChecked());
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxZAxis)
//STRIP001 	{
//STRIP001 		aEdtZAxis.Enable(aCbxZAxis.IsChecked());
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/*************************************************************************
|*
|*	Initialisierung
|*
*************************************************************************/

//STRIP001 void SchTitleDlg::Reset()
//STRIP001 {
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	if (rOutAttrs.GetItemState(CHATTR_TITLE_SHOW_MAIN, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxMain.Check(((const SfxBoolItem*) pPoolItem)->GetValue());
//STRIP001 	if (rOutAttrs.GetItemState(CHATTR_TITLE_MAIN, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aEdtMain.SetText(((const SfxStringItem*) pPoolItem)->GetValue());
//STRIP001 	EnableTitleHdl(&aCbxMain);
//STRIP001 
//STRIP001 	if (rOutAttrs.GetItemState(CHATTR_TITLE_SHOW_SUB, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxSub.Check(((const SfxBoolItem*) pPoolItem)->GetValue());
//STRIP001 	if (rOutAttrs.GetItemState(CHATTR_TITLE_SUB, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aEdtSub.SetText(((const SfxStringItem*) pPoolItem)->GetValue());
//STRIP001 	EnableTitleHdl(&aCbxSub);
//STRIP001 
//STRIP001 	if (aCbxXAxis.IsEnabled())
//STRIP001 	{
//STRIP001 		if (rOutAttrs.GetItemState(CHATTR_TITLE_SHOW_X_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 			aCbxXAxis.Check(((const SfxBoolItem*) pPoolItem)->GetValue());
//STRIP001 		if (rOutAttrs.GetItemState(CHATTR_TITLE_X_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 			aEdtXAxis.SetText(((const SfxStringItem*) pPoolItem)->GetValue());
//STRIP001 		EnableTitleHdl(&aCbxXAxis);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aCbxYAxis.IsEnabled())
//STRIP001 	{
//STRIP001 		if (rOutAttrs.GetItemState(CHATTR_TITLE_SHOW_Y_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 			aCbxYAxis.Check(((const SfxBoolItem*) pPoolItem)->GetValue());
//STRIP001 		if (rOutAttrs.GetItemState(CHATTR_TITLE_Y_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 			aEdtYAxis.SetText(((const SfxStringItem*) pPoolItem)->GetValue());
//STRIP001 		EnableTitleHdl(&aCbxYAxis);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aCbxZAxis.IsEnabled())
//STRIP001 	{
//STRIP001 		if (rOutAttrs.GetItemState(CHATTR_TITLE_SHOW_Z_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 			aCbxZAxis.Check(((const SfxBoolItem*) pPoolItem)->GetValue());
//STRIP001 		if (rOutAttrs.GetItemState(CHATTR_TITLE_Z_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 			aEdtZAxis.SetText(((const SfxStringItem*) pPoolItem)->GetValue());
//STRIP001 		EnableTitleHdl(&aCbxZAxis);
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|*    Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
|*
*************************************************************************/

//STRIP001 void SchTitleDlg::GetAttr(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	rOutAttrs.Put(SfxBoolItem(CHATTR_TITLE_SHOW_MAIN, aCbxMain.IsChecked()));
//STRIP001 	rOutAttrs.Put(SfxStringItem(CHATTR_TITLE_MAIN, aEdtMain.GetText()));
//STRIP001 	rOutAttrs.Put(SfxBoolItem(CHATTR_TITLE_SHOW_SUB, aCbxSub.IsChecked()));
//STRIP001 	rOutAttrs.Put(SfxStringItem(CHATTR_TITLE_SUB, aEdtSub.GetText()));
//STRIP001 
//STRIP001 	if (aCbxXAxis.IsEnabled())
//STRIP001 	{
//STRIP001 		rOutAttrs.Put(SfxBoolItem(CHATTR_TITLE_SHOW_X_AXIS, aCbxXAxis.IsChecked()));
//STRIP001 		rOutAttrs.Put(SfxStringItem(CHATTR_TITLE_X_AXIS, aEdtXAxis.GetText()));
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aCbxYAxis.IsEnabled())
//STRIP001 	{
//STRIP001 		rOutAttrs.Put(SfxBoolItem(CHATTR_TITLE_SHOW_Y_AXIS, aCbxYAxis.IsChecked()));
//STRIP001 		rOutAttrs.Put(SfxStringItem(CHATTR_TITLE_Y_AXIS, aEdtYAxis.GetText()));
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aCbxZAxis.IsEnabled())
//STRIP001 	{
//STRIP001 		rOutAttrs.Put(SfxBoolItem(CHATTR_TITLE_SHOW_Z_AXIS, aCbxZAxis.IsChecked()));
//STRIP001 		rOutAttrs.Put(SfxStringItem(CHATTR_TITLE_Z_AXIS, aEdtZAxis.GetText()));
//STRIP001 	}
//STRIP001 }



}
