/*************************************************************************
 *
 *  $RCSfile: sch_tplegend.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS
#ifndef _SVX_CHRTITEM_HXX //autogen
#include <bf_svx/chrtitem.hxx>
#endif

#include "schresid.hxx"
#include "chtmodel.hxx"
#include "attrib.hxx"
#include "attrib.hrc"
namespace binfilter {


/*************************************************************************
|*
|* Dialog zur Ausrichtung der Legende
|*
\************************************************************************/

//STRIP001 SchLegendPosTabPage::SchLegendPosTabPage(Window* pWindow,
//STRIP001 										 const SfxItemSet& rInAttrs) :
//STRIP001 	SfxTabPage(pWindow, SchResId(TP_LEGEND_POS), rInAttrs),
//STRIP001 	aRbtLeft(this, ResId(RBT_LEFT)),
//STRIP001 	aRbtTop(this, ResId(RBT_TOP)),
//STRIP001 	aRbtRight(this, ResId(RBT_RIGHT)),
//STRIP001 	aRbtBottom(this, ResId(RBT_BOTTOM)),
//STRIP001 	aGrpLegend(this, ResId(GRP_LEGEND)),
//STRIP001 	rOutAttrs(rInAttrs)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 }

/*************************************************************************
|*
|* Dtor
|*
/************************************************************************/

//STRIP001 SchLegendPosTabPage::~SchLegendPosTabPage()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Erzeugung
|*
\*************************************************************************/

//STRIP001 SfxTabPage* SchLegendPosTabPage::Create(Window* pWindow,
//STRIP001 										const SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	return new SchLegendPosTabPage(pWindow, rOutAttrs);
//STRIP001 }

/*************************************************************************
|*
|* Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
|*
\*************************************************************************/

//STRIP001 BOOL SchLegendPosTabPage::FillItemSet(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	SvxChartLegendPos ePos;
//STRIP001 
//STRIP001 	if (aRbtLeft.IsChecked())
//STRIP001 		ePos = CHLEGEND_LEFT;
//STRIP001 	else if (aRbtTop.IsChecked())
//STRIP001 		ePos = CHLEGEND_TOP;
//STRIP001 	else if (aRbtRight.IsChecked())
//STRIP001 		ePos = CHLEGEND_RIGHT;
//STRIP001 	else if (aRbtBottom.IsChecked())
//STRIP001 		ePos = CHLEGEND_BOTTOM;
//STRIP001 	else
//STRIP001 		ePos = CHLEGEND_NONE;
//STRIP001 
//STRIP001 	rOutAttrs.Put(SvxChartLegendPosItem(ePos));
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

/*************************************************************************
|*
|* Initialisierung
|*
\*************************************************************************/

//STRIP001 void SchLegendPosTabPage::Reset(const SfxItemSet& rInAttrs)
//STRIP001 {
//STRIP001 	SvxChartLegendPos ePos = CHLEGEND_NONE;
//STRIP001 	
//STRIP001 	const SfxPoolItem* pPoolItem = NULL;
//STRIP001 	if( rInAttrs.GetItemState( SCHATTR_LEGEND_POS,
//STRIP001 							   TRUE, &pPoolItem ) != SFX_ITEM_SET )
//STRIP001 		pPoolItem = &(rInAttrs.GetPool()->GetDefaultItem( SCHATTR_LEGEND_POS ));
//STRIP001 
//STRIP001 	if( pPoolItem )
//STRIP001 		ePos = ((const SvxChartLegendPosItem*)pPoolItem)->GetValue();
//STRIP001 
//STRIP001 	switch( ePos )
//STRIP001 	{
//STRIP001 		case CHLEGEND_LEFT:
//STRIP001 			aRbtLeft.Check(TRUE);
//STRIP001 			break;
//STRIP001 		case CHLEGEND_TOP:
//STRIP001 			aRbtTop.Check(TRUE);
//STRIP001 			break;
//STRIP001 		case CHLEGEND_RIGHT:
//STRIP001 			aRbtRight.Check(TRUE);
//STRIP001 			break;
//STRIP001 		case CHLEGEND_BOTTOM:
//STRIP001 			aRbtBottom.Check(TRUE);
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }
}
