/*************************************************************************
 *
 *  $RCSfile: sch_tpoption.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include "schattr.hxx"
#include "schresid.hxx"
#include "chtmodel.hxx"
#include "attrib.hxx"
#include "attrib.hrc"

#ifndef _SVX_SVXIDS_HRC //autogen
#include <bf_svx/svxids.hrc>
#endif
namespace binfilter {

//STRIP001 SchOptionTabPage::SchOptionTabPage(Window* pWindow,const SfxItemSet& rInAttrs) :
//STRIP001 	SfxTabPage(pWindow, SchResId(TP_OPTIONS), rInAttrs),
//STRIP001 	aGrpAxis(this, ResId(GRP_OPT_AXIS)),
//STRIP001 	aGrpBar(this, ResId(GB_BAR)),
//STRIP001 	aRbtAxis1(this,ResId(RBT_OPT_AXIS_1)),
//STRIP001 	aRbtAxis2(this,ResId(RBT_OPT_AXIS_2)),
//STRIP001 	aMTOverlap(this,ResId(MT_OVERLAP)),
//STRIP001 	aMTGap(this,ResId(MT_GAP)),
//STRIP001 	aFTOverlap(this,ResId(FT_OVERLAP)),
//STRIP001 	aFTGap(this,ResId(FT_GAP)),
//STRIP001 	aCBConnect(this,ResId(CB_CONNECTOR)),
//STRIP001 	rOutAttrs(rInAttrs)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 }
/*************************************************************************
|*
|* Dtor
|*
/************************************************************************/

//STRIP001 SchOptionTabPage::~SchOptionTabPage()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Erzeugung
|*
\*************************************************************************/

//STRIP001 SfxTabPage* SchOptionTabPage::Create(Window* pWindow,const SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	return new SchOptionTabPage(pWindow, rOutAttrs);
//STRIP001 }

/*************************************************************************
|*
|* Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
|*
\*************************************************************************/
//STRIP001 BOOL SchOptionTabPage::FillItemSet(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	if(aRbtAxis2.IsChecked())
//STRIP001 		rOutAttrs.Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_SECONDARY_Y));
//STRIP001 	else
//STRIP001 		rOutAttrs.Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_PRIMARY_Y));
//STRIP001 
//STRIP001 	if(aMTGap.IsVisible())
//STRIP001 		rOutAttrs.Put(SfxInt32Item(CHATTR_DIAGRAM_GAPWIDTH,aMTGap.GetValue()));
//STRIP001 
//STRIP001 	if(aMTOverlap.IsVisible())
//STRIP001 		rOutAttrs.Put(SfxInt32Item(CHATTR_DIAGRAM_OVERLAP,aMTOverlap.GetValue()));
//STRIP001 
//STRIP001 	if(aCBConnect.IsVisible())
//STRIP001 		rOutAttrs.Put(SfxBoolItem(CHATTR_BARCONNECT,aCBConnect.IsChecked()));
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
/*************************************************************************
|*
|* Initialisierung
|*
\*************************************************************************/

//STRIP001 void SchOptionTabPage::Reset(const SfxItemSet& rInAttrs)
//STRIP001 {
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	aRbtAxis1.Check(TRUE);
//STRIP001 	aRbtAxis2.Check(FALSE);
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		long nVal=((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 		if(nVal==CHART_AXIS_SECONDARY_Y)
//STRIP001 		{
//STRIP001 			aRbtAxis2.Check(TRUE);
//STRIP001 			aRbtAxis1.Check(FALSE);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	long nTmp;
//STRIP001 	if (rInAttrs.GetItemState(CHATTR_DIAGRAM_GAPWIDTH, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		nTmp = (long)((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 		aMTGap.SetValue(nTmp);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aMTGap.Show(FALSE);
//STRIP001 		aFTGap.Show(FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(CHATTR_DIAGRAM_OVERLAP, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		nTmp = (long)((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 		aMTOverlap.SetValue(nTmp);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aMTOverlap.Show(FALSE);
//STRIP001 		aFTOverlap.Show(FALSE);
//STRIP001 	}
//STRIP001 	if (rInAttrs.GetItemState(CHATTR_BARCONNECT, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		nTmp = (long)((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 		aCBConnect.Check(nTmp);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aCBConnect.Show(FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 }



}
