/*************************************************************************
 *
 *  $RCSfile: sch_fugrid.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:33:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include "dlg_grid.hxx"

#include "schattr.hxx"
#include "schview.hxx"
#include "viewshel.hxx"
#include "fugrid.hxx"
namespace binfilter {


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchFuGrid::SchFuGrid(SchViewShell* pViewSh, SchWindow* pWin, SchView* pView,
//STRIP001 				 ChartModel* pDoc, SfxRequest& rReq)
//STRIP001 	   : SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	UINT32	lValueX, lValueY, lFineX, lFineY;
//STRIP001 
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 	if( !pArgs )
//STRIP001 	{
//STRIP001 		SfxItemSet aNewAttr( pViewSh->GetPool(), ATTR_GRID_START, ATTR_GRID_END );
//STRIP001 
//STRIP001 		// Zeichengitter
//STRIP001 		lValueX = pView->GetGridCoarse().Width();
//STRIP001 		lValueY = pView->GetGridCoarse().Height();
//STRIP001 		aNewAttr.Put( SfxUInt32Item( ATTR_GRID_DRAW_X, lValueX ) );
//STRIP001 		aNewAttr.Put( SfxUInt32Item( ATTR_GRID_DRAW_Y, lValueY ) );
//STRIP001 
//STRIP001 		// Unterteilung
//STRIP001 		lFineX = pView->GetGridFine().Width();
//STRIP001 		lFineY = pView->GetGridFine().Height();
//STRIP001 		aNewAttr.Put( SfxUInt16Item( ATTR_GRID_DIVISION_X, lFineX ? (UINT16) (lValueX / lFineX) : 0 ) );
//STRIP001 		aNewAttr.Put( SfxUInt16Item( ATTR_GRID_DIVISION_Y, lFineY ? (UINT16) (lValueY / lFineY) : 0 ) );
//STRIP001 
//STRIP001 		// Fangraster
//STRIP001 		lValueX = pView->GetSnapGrid().Width();
//STRIP001 		lValueY = pView->GetSnapGrid().Height();
//STRIP001 		aNewAttr.Put( SfxUInt32Item( ATTR_GRID_SNAP_X, lValueX ) );
//STRIP001 		aNewAttr.Put( SfxUInt32Item( ATTR_GRID_SNAP_Y, lValueY ) );
//STRIP001 
//STRIP001 		// Ursprung
//STRIP001 		Point aPt; // = pView->GetGridOrigin(); <-- ???
//STRIP001 		aNewAttr.Put( SfxUInt32Item( ATTR_GRID_ORIGIN_X, aPt.X() ) );
//STRIP001 		aNewAttr.Put( SfxUInt32Item( ATTR_GRID_ORIGIN_Y, aPt.Y() ) );
//STRIP001 
//STRIP001 		aNewAttr.Put( SfxBoolItem( ATTR_GRID_USE, pView->IsGridSnap() ) );
//STRIP001 
//STRIP001 //      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//STRIP001 //      stattfindet waehrend dieser Dialog geoeffnet ist.
//STRIP001 //		SdGridDlg* pDlg = new SdGridDlg( &( pViewSh->GetViewFrame()->GetWindow() ), aNewAttr );
//STRIP001 		SdGridDlg* pDlg = new SdGridDlg( NULL, aNewAttr );
//STRIP001 
//STRIP001 		USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 		switch( nResult )
//STRIP001 		{
//STRIP001 			case RET_OK:
//STRIP001 			{
//STRIP001 				pDlg->GetAttr( aNewAttr );
//STRIP001 				rReq.Done( aNewAttr );
//STRIP001 
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			default:
//STRIP001 			{
//STRIP001 				delete( pDlg );
//STRIP001 			}
//STRIP001 			return; // Abbruch
//STRIP001 		}
//STRIP001 		delete( pDlg );
//STRIP001 
//STRIP001 		pChDoc->CanRebuild (TRUE);
//STRIP001 	}
//STRIP001 	else pChDoc->CanRebuild (FALSE);
//STRIP001 
//STRIP001 	// Zeichengitter
//STRIP001 	lValueX = ( ( const SfxUInt32Item& ) pArgs->
//STRIP001 					Get( ATTR_GRID_DRAW_X ) ).GetValue();
//STRIP001 	lValueY = ( ( const SfxUInt32Item& ) pArgs->
//STRIP001 					Get( ATTR_GRID_DRAW_Y ) ).GetValue();
//STRIP001 	pView->SetGridCoarse( Size( lValueX, lValueY ) );
//STRIP001 
//STRIP001 	// Unterteilung
//STRIP001 	UINT16 nValueX = ( ( const SfxUInt16Item& ) pArgs->
//STRIP001 					Get( ATTR_GRID_DIVISION_X ) ).GetValue();
//STRIP001 	UINT16 nValueY = ( ( const SfxUInt16Item& ) pArgs->
//STRIP001 					Get( ATTR_GRID_DIVISION_Y ) ).GetValue();
//STRIP001 	pView->SetGridFine( Size( nValueX ? (long) (lValueX / nValueX) : 0,
//STRIP001 							  nValueY ? (long) (lValueY / nValueY) : 0 ) );
//STRIP001 
//STRIP001 	// Fangraster
//STRIP001 	lValueX = ( ( const SfxUInt32Item& ) pArgs->
//STRIP001 					Get( ATTR_GRID_SNAP_X ) ).GetValue();
//STRIP001 	lValueY = ( ( const SfxUInt32Item& ) pArgs->
//STRIP001 					Get( ATTR_GRID_SNAP_Y ) ).GetValue();
//STRIP001 	pView->SetSnapGrid( Size( lValueX, lValueY ) );
//STRIP001 
//STRIP001 	// Ursprung ???
//STRIP001 	// lValueX = ( ( const SfxUInt32Item& ) pArgs->
//STRIP001 	//				Get( ATTR_GRID_ORIGIN_X ) ).GetValue();
//STRIP001 	// lValueY = ( ( const SfxUInt32Item& ) pArgs->
//STRIP001 	//				Get( ATTR_GRID_ORIGIN_Y ) ).GetValue();
//STRIP001 	// pView->SetGridOrigin( Point( lValueX, lValueY ) ); <-- ???
//STRIP001 
//STRIP001 	pView->SetGridSnap( ( ( const SfxBoolItem& ) pArgs->
//STRIP001 					Get( ATTR_GRID_USE ) ).GetValue() );
//STRIP001 }



}
