/*************************************************************************
 *
 *  $RCSfile: sch_undgraxi.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:33:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


// TOOLS
//STRIP001 #define _BIGINT_HXX
//STRIP001 #define _SFXMULTISEL_HXX
//STRIP001 #define _STACK_HXX
//STRIP001 #define _QUEUE_HXX
//STRIP001 #define _DYNARR_HXX
//STRIP001 #define _TREELIST_HXX
//STRIP001 #define _CACHESTR_HXX
//STRIP001 #define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
//STRIP001 #define _DYNARY_HXX
//#define _UNQIDX_HXX
//STRIP001 #define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
//STRIP001 #define _CACHESTR_HXX
//STRIP001 #define _SV_MULTISEL_HXX

//SV
//#define _CLIP_HXX
//#define _CONFIG_HXX ***
//STRIP001 #define _CURSOR_HXX
//STRIP001 #define _FONTDLG_HXX
//STRIP001 #define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
//STRIP001 #define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
//STRIP001 #define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
//#define _SELENG_HXX
//#define _SPLIT_HXX
//STRIP001 #define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX
//#define _TOOLBOX_HXX
//#define _STATUS_HXX
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
//#define _FILDLG_HXX
//#define _PRNDLG_HXX
//STRIP001 #define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _MENU_HXX
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
//STRIP001 #define _SOUND_HXX
//STRIP001 
//STRIP001 
//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SFX_OBJSH_HXX //autogen
//STRIP001 #include <bf_sfx2/objsh.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 #include "schdll.hxx"
//STRIP001 #include "schresid.hxx"
//STRIP001 #include "strings.hrc"
//STRIP001 #include "schview.hxx"
//STRIP001 #ifndef _CHTMODEL_HXX
//STRIP001 #include "chtmodel.hxx"
//STRIP001 #endif
//STRIP001 #include "objid.hxx"
//STRIP001 #include "undgraxi.hxx"
//STRIP001 
//STRIP001 TYPEINIT1(SchUndoDiagramAxis, SchUndoAttr);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchUndoDiagramAxis::SchUndoDiagramAxis(ChartModel& rChDoc, UINT16 nId,
//STRIP001 									   const SfxItemSet& rOldXAxisAttr,
//STRIP001 									   const SfxItemSet& rOldYAxisAttr,
//STRIP001 									   const SfxItemSet& rOldZAxisAttr,
//STRIP001 									   const SfxItemSet& rOldAttr,
//STRIP001 									   const SfxItemSet& rNewAttr) :
//STRIP001 	SchUndoAttr(rChDoc, rOldAttr, rNewAttr),
//STRIP001 	nAxisId(nId),
//STRIP001 	pOldXAxisAttr(new SfxItemSet(rOldXAxisAttr)),
//STRIP001 	pOldYAxisAttr(new SfxItemSet(rOldYAxisAttr)),
//STRIP001 	pOldZAxisAttr(new SfxItemSet(rOldZAxisAttr))
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchUndoDiagramAxis::~SchUndoDiagramAxis()
//STRIP001 {
//STRIP001 	delete pOldXAxisAttr;
//STRIP001 	delete pOldYAxisAttr;
//STRIP001 	delete pOldZAxisAttr;
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDiagramAxis::Undo()
//STRIP001 {
//STRIP001 	if (nAxisId == 0)
//STRIP001 		rDoc.ChangeAxisAttr(*pOldXAxisAttr, *pOldYAxisAttr,
//STRIP001 							*pOldZAxisAttr, FALSE);
//STRIP001 	else
//STRIP001 		rDoc.ChangeAxisAttr(*pOldAttr,
//STRIP001 							(SdrObjGroup*)rDoc.GetChartObj(nAxisId),
//STRIP001 							FALSE);
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDiagramAxis::Redo()
//STRIP001 {
//STRIP001 	rDoc.ChangeAxisAttr(*pNewAttr,
//STRIP001 						(SdrObjGroup*)rDoc.GetChartObj(nAxisId));
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDiagramAxis::Repeat(SfxRepeatTarget& rView)
//STRIP001 {
//STRIP001 	if (((SchView&)rView).HasMarkedObj())
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 			SchObjectId* pObjId = GetObjectId(*pObj);
//STRIP001 
//STRIP001 			if (pObjId)
//STRIP001 			{
//STRIP001 				UINT16 nId = pObjId->GetObjId();
//STRIP001 
//STRIP001 				switch (nId)
//STRIP001 				{
//STRIP001 					//TVM: Tja, so ein Sch*, die Ids hier wurden nie gesetzt und sind zu
//STRIP001 					//allem berflu?auch noch doppelt belegt (weia!)
//STRIP001 					//ToDo: Testen, _GROUP entfernen, testen, IDs aus defines.hxx lschen!
//STRIP001 					case CHOBJID_DIAGRAM_X_AXIS_GROUP:
//STRIP001 					case CHOBJID_DIAGRAM_Y_AXIS_GROUP:
//STRIP001 					case CHOBJID_DIAGRAM_Z_AXIS_GROUP:
//STRIP001 					{
//STRIP001 						SfxItemSet aOldAttr(rDoc.GetAxisAttr((SdrObjGroup*)pObj));
//STRIP001 						SfxItemSet aOldXAxisAttr ( rDoc.GetAttr(CHOBJID_DIAGRAM_X_AXIS));
//STRIP001 						SfxItemSet aOldYAxisAttr ( rDoc.GetAttr(CHOBJID_DIAGRAM_Y_AXIS));
//STRIP001 						SfxItemSet aOldZAxisAttr ( rDoc.GetAttr(CHOBJID_DIAGRAM_Z_AXIS));
//STRIP001 
//STRIP001 						if (rDoc.ChangeAxisAttr(*pNewAttr,
//STRIP001 												 (SdrObjGroup*)pObj))
//STRIP001 						{
//STRIP001 							SchUndoDiagramAxis* pUndo =
//STRIP001 								new SchUndoDiagramAxis(rDoc, nId,
//STRIP001 													   aOldXAxisAttr,
//STRIP001 													   aOldYAxisAttr,
//STRIP001 													   aOldZAxisAttr,
//STRIP001 													   aOldAttr, *pNewAttr);
//STRIP001 							pUndo->SetComment
//STRIP001 								(String(SchResId(STR_UNDO_DIAGRAM_AXIS)));
//STRIP001 
//STRIP001 							rDoc.GetObjectShell()->
//STRIP001 								GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 						}
//STRIP001 						break;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 BOOL SchUndoDiagramAxis::CanRepeat(SfxRepeatTarget& rView) const
//STRIP001 {
//STRIP001 	if (((SchView&)rView).HasMarkedObj())
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SchObjectId* pObjId =
//STRIP001 				GetObjectId(*rMarkList.GetMark(0)->GetObj());
//STRIP001 
//STRIP001 			if (pObjId)
//STRIP001 				switch (pObjId->GetObjId())
//STRIP001 				{
//STRIP001 					case CHOBJID_DIAGRAM_X_AXIS:
//STRIP001 					case CHOBJID_DIAGRAM_Y_AXIS:
//STRIP001 					case CHOBJID_DIAGRAM_Z_AXIS:
//STRIP001 						return TRUE;
//STRIP001 				}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }




