/*************************************************************************
 *
 *  $RCSfile: sd_pglink.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:28:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop
// auto strip #include <so3/iface.hxx>
// auto strip #ifndef _SVXLINK_HXX
// auto strip #include <bf_svx/linkmgr.hxx>
// auto strip #endif

// auto strip #include "pglink.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "drawdoc.hxx"
namespace binfilter {


//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*		Ctor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPageLink::SdPageLink(SdPage* pPg, const String& rFileName,
//STRIP001 					   const String& rBookmarkName) :
//STRIP001 	::so3::SvBaseLink(::so3::LINKUPDATE_ONCALL, FORMAT_FILE),
//STRIP001 	pPage(pPg)
//STRIP001 {
//STRIP001 	pPage->SetFileName(rFileName);
//STRIP001 	pPage->SetBookmarkName(rBookmarkName);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Dtor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 
//STRIP001 SdPageLink::~SdPageLink()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Daten haben sich geaendert
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageLink::DataChanged( const String& ,
//STRIP001 									   const ::com::sun::star::uno::Any& )
//STRIP001 {
//STRIP001 	SdDrawDocument* pDoc = (SdDrawDocument*) pPage->GetModel();
//STRIP001 	SvxLinkManager* pLinkManager = pDoc!=NULL ? pDoc->GetLinkManager() : NULL;
//STRIP001 
//STRIP001 	if (pLinkManager)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Nur Standardseiten duerfen gelinkt sein
//STRIP001 		* Die entsprechenden Notizseiten werden automatisch aktualisiert
//STRIP001 		**********************************************************************/
//STRIP001 		String aFileName;
//STRIP001 		String aBookmarkName;
//STRIP001 		String aFilterName;
//STRIP001 		pLinkManager->GetDisplayNames( this,0, &aFileName, &aBookmarkName,
//STRIP001 									  &aFilterName);
//STRIP001 		pPage->SetFileName(aFileName);
//STRIP001 		pPage->SetBookmarkName(aBookmarkName);
//STRIP001 
//STRIP001 		SdDrawDocument* pBookmarkDoc = pDoc->OpenBookmarkDoc(aFileName);
//STRIP001 
//STRIP001 		if (pBookmarkDoc)
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Die gelinkte Seite wird im Model replaced
//STRIP001 			******************************************************************/
//STRIP001 			if (aBookmarkName.Len() == 0)
//STRIP001 			{
//STRIP001 				// Kein Seitenname angegeben: es wird die erste Seite genommen
//STRIP001 				aBookmarkName = pBookmarkDoc->GetSdPage(0, PK_STANDARD)->GetName();
//STRIP001 				pPage->SetBookmarkName(aBookmarkName);
//STRIP001 			}
//STRIP001 
//STRIP001 			List aBookmarkList;
//STRIP001 			aBookmarkList.Insert(&aBookmarkName);
//STRIP001 			USHORT nInsertPos = pPage->GetPageNum();
//STRIP001 			BOOL bLink = TRUE;
//STRIP001 			BOOL bReplace = TRUE;
//STRIP001 			BOOL bNoDialogs = FALSE;
//STRIP001 			BOOL bCopy = FALSE;
//STRIP001 
//STRIP001 			if( pDoc->pDocLockedInsertingLinks )
//STRIP001 			{
//STRIP001 				// resolving links while loading pDoc
//STRIP001 				bNoDialogs = TRUE;
//STRIP001 				bCopy = TRUE;
//STRIP001 			}
//STRIP001 
//STRIP001 			pDoc->InsertBookmarkAsPage(&aBookmarkList, NULL, bLink, bReplace,
//STRIP001 									   nInsertPos, bNoDialogs, NULL, bCopy, TRUE, TRUE);
//STRIP001 
//STRIP001 			if( !pDoc->pDocLockedInsertingLinks )
//STRIP001 				pDoc->CloseBookmarkDoc();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Link an oder abmelden
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageLink::Closed()
//STRIP001 {
//STRIP001 	// Die Verbindung wird aufgehoben
//STRIP001 	pPage->SetFileName(String());
//STRIP001 	pPage->SetBookmarkName(String());
//STRIP001 
//STRIP001 	SvBaseLink::Closed();
//STRIP001 }



}
