/*************************************************************************
 *
 *  $RCSfile: sd_fudspord.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:48:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include <bf_svx/svxids.hrc>
// auto strip #ifndef _VCL_POINTR_HXX //autogen
// auto strip #include <vcl/pointr.hxx>
// auto strip #endif

#include "app.hrc"
// auto strip #include "fudspord.hxx"
// auto strip #include "fupoor.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1( FuDisplayOrder, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuDisplayOrder::FuDisplayOrder(SdViewShell* 	pViewSh,
//STRIP001 							   SdWindow*		pWin,
//STRIP001 							   SdView*			pView,
//STRIP001 							   SdDrawDocument*	pDoc,
//STRIP001 							   SfxRequest&		rReq) :
//STRIP001 	FuPoor(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	pUserMarker(NULL),
//STRIP001 	pRefObj(NULL)
//STRIP001 {
//STRIP001 	pUserMarker = new SdrViewUserMarker(pView);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuDisplayOrder::~FuDisplayOrder()
//STRIP001 {
//STRIP001 	delete pUserMarker;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuDisplayOrder::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuDisplayOrder::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	SdrObject* pPickObj;
//STRIP001 	SdrPageView* pPV;
//STRIP001 	Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 	USHORT nHitLog = USHORT ( pWindow->PixelToLogic(Size(HITPIX,0)).Width() );
//STRIP001 
//STRIP001 	if ( pView->PickObj(aPnt, pPickObj, pPV) )
//STRIP001 	{
//STRIP001 		if (pRefObj != pPickObj)
//STRIP001 		{
//STRIP001 			pRefObj = pPickObj;
//STRIP001 			pUserMarker->SetXPolyPolygon(pRefObj, pView->GetPageViewPvNum(0));
//STRIP001 			pUserMarker->Show();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pRefObj = NULL;
//STRIP001 		pUserMarker->Hide();
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuDisplayOrder::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	SdrPageView* pPV = NULL;
//STRIP001 	Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 	USHORT nHitLog = USHORT ( pWindow->PixelToLogic(Size(HITPIX,0)).Width() );
//STRIP001 
//STRIP001 	if ( pView->PickObj(aPnt, pRefObj, pPV) )
//STRIP001 	{
//STRIP001 		if (nSlotId == SID_BEFORE_OBJ)
//STRIP001 		{
//STRIP001 			pView->PutMarkedInFrontOfObj(pRefObj);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pView->PutMarkedBehindObj(pRefObj);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	pViewShell->Cancel();
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuDisplayOrder::Activate()
//STRIP001 {
//STRIP001 	aPtr = pWindow->GetPointer();
//STRIP001 	pWindow->SetPointer( Pointer( POINTER_REFHAND ) );
//STRIP001 
//STRIP001 	if (pUserMarker)
//STRIP001 	{
//STRIP001 		pUserMarker->Show();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuDisplayOrder::Deactivate()
//STRIP001 {
//STRIP001 	if (pUserMarker)
//STRIP001 	{
//STRIP001 		pUserMarker->Hide();
//STRIP001 	}
//STRIP001 
//STRIP001 	pWindow->SetPointer( aPtr );
//STRIP001 }


}
