/*************************************************************************
 *
 *  $RCSfile: sd_fuslshw5.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:55:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define FUSLIDESHOW_INTERN

// auto strip #ifndef _SV_BMPACC_HXX //autogen
// auto strip #include <vcl/bmpacc.hxx>
// auto strip #endif
// auto strip #include <bf_svx/xoutx.hxx>
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #include <bf_svx/outliner.hxx>
#include <bf_svx/eeitemid.hxx>

#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

// auto strip #include <bf_svx/colritem.hxx>
// auto strip #ifndef _SVDOATTR_HXX //autogen
// auto strip #include <bf_svx/svdoattr.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX //autogen
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLINEIT0_HXX //autogen
// auto strip #include <bf_svx/xlineit0.hxx>
// auto strip #endif
// auto strip #ifndef SVX_XFILLIT0_HXX //autogen
// auto strip #include <bf_svx/xfillit0.hxx>
// auto strip #endif
// auto strip #ifndef _SVDORECT_HXX //autogen
// auto strip #include <bf_svx/svdorect.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SV_GRAPH_HXX //autogen
// auto strip #include <vcl/graph.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOATTR_HXX //autogen
// auto strip #include <bf_svx/svdoattr.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX //autogen
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLOBJ_HXX //autogen
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOATTR_HXX //autogen
// auto strip #include <bf_svx/svdoattr.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX //autogen
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif
// auto strip #ifndef _SVDITER_HXX //autogen
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRP_HXX
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif
// auto strip #include "drawdoc.hxx"
#include "sdpage.hxx"
// auto strip #include "anminfo.hxx"
// auto strip #include "mover.hxx"
#include "glob.hrc"
// auto strip #include "showview.hxx"
// auto strip #include "outlinfo.hxx"
// auto strip #include "fuslshow.hxx"
namespace binfilter {

using namespace ::com::sun::star;

// ------------------
// - SdAnimPageList -
// ------------------

//STRIP001 SdAnimPageList::SdAnimPageList() :
//STRIP001 	mnCurPagePos( 0 ),
//STRIP001 	mnNextPagePos( 0 ),
//STRIP001 	mnRealNextPagePos( 0 ),
//STRIP001 	mnPreparedPageNum( PAGE_NO_END ),
//STRIP001 	mbEndlessMode( FALSE ),
//STRIP001 	mbPauseMode( FALSE ),
//STRIP001 	mbSoftendMode( FALSE ),
//STRIP001 	mnCurrentHidenPage( -1 )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 SdAnimPageList::~SdAnimPageList()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SdAnimPageList::GetCurrentPageNum()
//STRIP001 {
//STRIP001 	if( mnCurrentHidenPage != -1 )
//STRIP001 		return mnCurrentHidenPage;
//STRIP001 
//STRIP001 	return( mnCurPagePos < Count() ) ? (USHORT)(ULONG) GetObject( mnCurPagePos ) : mnCurPagePos;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SdAnimPageList::GetNextPageNum()
//STRIP001 {
//STRIP001 	return( mnNextPagePos < Count() ) ? (USHORT)(ULONG) GetObject( mnNextPagePos ) : mnNextPagePos;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SdAnimPageList::GetRealNextPageNum()
//STRIP001 {
//STRIP001 	return( mnRealNextPagePos < Count() ) ? (USHORT)(ULONG) GetObject( mnRealNextPagePos ) : mnRealNextPagePos;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SdAnimPageList::IsPageNumIncluded( USHORT nSdPageNum )
//STRIP001 {
//STRIP001 	if( nSdPageNum == mnCurrentHidenPage )
//STRIP001 		return TRUE;
//STRIP001 
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	for( ULONG i = 0, nCount = Count(); i < nCount; i++ )
//STRIP001 	{
//STRIP001 		if( ( (USHORT)(ULONG) GetObject( i ) ) == nSdPageNum )
//STRIP001 		{
//STRIP001 			bRet = TRUE;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SdAnimPageList::CalcNextPageNum( BOOL bForward )
//STRIP001 {
//STRIP001 	if( Count() )
//STRIP001 	{
//STRIP001 		if( bForward )
//STRIP001 		{
//STRIP001 			if( mnCurPagePos < ( Count() - 1 ) )
//STRIP001 				mnRealNextPagePos = mnNextPagePos = ( mnCurPagePos + 1 );
//STRIP001 			else if( mbEndlessMode )
//STRIP001 			{
//STRIP001 				mnRealNextPagePos = 0;
//STRIP001 				mnNextPagePos = ( mbPauseMode ? PAGE_NO_PAUSE : mnRealNextPagePos );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				mnRealNextPagePos = mnNextPagePos = ( mbSoftendMode ? PAGE_NO_SOFTEND : PAGE_NO_END );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if( mnCurPagePos )
//STRIP001 				mnRealNextPagePos = mnNextPagePos = ( mnCurPagePos - 1 );
//STRIP001 			else if( mbEndlessMode )
//STRIP001 			{
//STRIP001 				mnRealNextPagePos = (USHORT) Count() - 1;
//STRIP001 				mnNextPagePos = ( mbPauseMode ? PAGE_NO_PAUSE : mnRealNextPagePos );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				mnRealNextPagePos = mnNextPagePos = mnCurPagePos;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		mnCurPagePos = mnNextPagePos = mnRealNextPagePos = ( mbSoftendMode ? PAGE_NO_SOFTEND : PAGE_NO_END );
//STRIP001 		mnCurrentHidenPage = -1;
//STRIP001 	}
//STRIP001 
//STRIP001 	return( GetNextPageNum() );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SdAnimPageList::MakePageNumCurrent( USHORT nSdPageNum )
//STRIP001 {
//STRIP001 	mnCurrentHidenPage = -1;

//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	if( nSdPageNum >= PAGE_NO_FIRSTDEF )
//STRIP001 	{
//STRIP001 		mnCurPagePos = nSdPageNum;
//STRIP001 		bRet = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if( GetNextPageNum() == nSdPageNum )
//STRIP001 		{
//STRIP001 			mnCurPagePos = mnNextPagePos;
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			for( ULONG i = 0, nCount = Count(); i < nCount; i++ )
//STRIP001 			{
//STRIP001 				if( ( (USHORT)(ULONG) GetObject( i ) ) == nSdPageNum )
//STRIP001 				{
//STRIP001 					mnCurPagePos = (USHORT) i;
//STRIP001 					bRet = TRUE;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdAnimPageList::SetStartPage( USHORT nSdPageNum )
//STRIP001 {
//STRIP001 	mnCurrentHidenPage = -1;
//STRIP001 
//STRIP001 	BOOL bFound = FALSE;
//STRIP001 
//STRIP001 	for( ULONG i = 0, nCount = Count(); ( i < nCount ) && !bFound; i++ )
//STRIP001 	{
//STRIP001 		if( ( (USHORT)(ULONG) GetObject( i ) ) == nSdPageNum )
//STRIP001 		{
//STRIP001 			mnCurPagePos = mnNextPagePos = (USHORT) i;
//STRIP001 			bFound = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !bFound )
//STRIP001 		mnCurPagePos = mnNextPagePos = 0;
//STRIP001 }
//STRIP001 
//STRIP001 void SdAnimPageList::JumpToHidenPage( USHORT nSdPageNum )
//STRIP001 {
//STRIP001 	mnCurrentHidenPage = nSdPageNum;
//STRIP001 }

//STRIP001 // ---------------
//STRIP001 // - FuSlideShow -
//STRIP001 // ---------------
//STRIP001 
//STRIP001 BOOL FuSlideShow::HideOrVanishObject( SdrObject* pActionObject, BOOL bHide )
//STRIP001 {
//STRIP001 	SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo( pActionObject );
//STRIP001 	BOOL				bResult = FALSE;
//STRIP001 
//STRIP001 	// anstehende Gliederungsanimationen und Abblendungen werden beim
//STRIP001 	// Verschwinden eines Objektes verworfen
//STRIP001 	pCurAnmList->Remove( pLayoutText );
//STRIP001 	pDimObject = pHideObject = NULL;
//STRIP001 	pInfo->bShow = FALSE;
//STRIP001 	RepaintVDev( pActualPage, TRUE );
//STRIP001 
//STRIP001 	// Animationsinfo temporaer veraendern
//STRIP001 	if( bHide )
//STRIP001 	{
//STRIP001 		presentation::AnimationEffect eOldEffect = pInfo->eEffect;
//STRIP001 		presentation::AnimationEffect eOldTextEffect = pInfo->eTextEffect;
//STRIP001 
//STRIP001 		pInfo->eEffect = presentation::AnimationEffect_HIDE;
//STRIP001 		pInfo->eTextEffect = presentation::AnimationEffect_NONE;
//STRIP001 
//STRIP001 		// das Objekt in der Liste nach vorn schieben und Animation starten
//STRIP001 		pCurAnmList->Remove( pActionObject );
//STRIP001 		pCurAnmList->Insert( pActionObject, (ULONG) 0 );
//STRIP001 		bResult = AnimateObject();
//STRIP001 
//STRIP001 		// Animationsinfo zuruecksetzen
//STRIP001 		pInfo->eEffect = eOldEffect;
//STRIP001 		pInfo->eTextEffect = eOldTextEffect;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		String          aOldSound( pInfo->aSoundFile );
//STRIP001 		presentation::AnimationEffect eOldEffect = pInfo->eEffect;
//STRIP001 		presentation::AnimationEffect eOldTextEffect = pInfo->eTextEffect;
//STRIP001 		presentation::AnimationSpeed  eOldSpeed = pInfo->eSpeed;
//STRIP001 		BOOL            bOldActive = pInfo->bActive;
//STRIP001 		BOOL            bOldSoundOn = pInfo->bSoundOn;
//STRIP001 		BOOL            bOldPlayFull = pInfo->bPlayFull;
//STRIP001 
//STRIP001 		pInfo->aSoundFile = pInfo->aBookmark;
//STRIP001 		pInfo->eEffect = pInfo->eSecondEffect;
//STRIP001 		pInfo->eTextEffect = presentation::AnimationEffect_NONE;
//STRIP001 		pInfo->eSpeed = pInfo->eSecondSpeed;
//STRIP001 		pInfo->bActive = TRUE;
//STRIP001 		pInfo->bSoundOn = pInfo->bSecondSoundOn;
//STRIP001 		pInfo->bPlayFull = pInfo->bSecondPlayFull;
//STRIP001 
//STRIP001 		// das Objekt in der Liste nach vorn schieben und Animation starten
//STRIP001 		pCurAnmList->Remove( pActionObject );
//STRIP001 		pCurAnmList->Insert( pActionObject, (ULONG) 0 );
//STRIP001 
//STRIP001 		bResult = AnimateObject();
//STRIP001 
//STRIP001 		// Animationsinfo zuruecksetzen
//STRIP001 		pInfo->aSoundFile = aOldSound;
//STRIP001 		pInfo->eEffect = eOldEffect;
//STRIP001 		pInfo->eTextEffect = eOldTextEffect;
//STRIP001 		pInfo->eSpeed = eOldSpeed;
//STRIP001 		pInfo->bActive = bOldActive;
//STRIP001 		pInfo->bSoundOn = bOldSoundOn;
//STRIP001 		pInfo->bPlayFull = bOldPlayFull;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nMagic != SLIDESHOW_MAGIC )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	pDimObject = NULL;
//STRIP001 	pInfo->bIsShown = pInfo->bShow = FALSE;
//STRIP001 
//STRIP001 	BOOL bWasSlow = IsSlowObj( (SdrAttrObj*) pActionObject );
//STRIP001 	BOOL bWasDimmed = pInfo->bDimmed;
//STRIP001 	pInfo->bDimmed = FALSE;
//STRIP001 	BOOL bIsSlow = IsSlowObj( (SdrAttrObj*) pActionObject );
//STRIP001 
//STRIP001 	// wenn das Objekt aufgrund der fehlenden Abblendung jetzt ein 'schnelles'
//STRIP001 	// Objekt geworden ist, muessen die Label im Metafile angepasst und der
//STRIP001 	// SlowObjRecord geloescht werden
//STRIP001 	if( pMetaFile && bWasSlow && !bIsSlow )
//STRIP001 	{
//STRIP001 		pMetaFile->ReplaceMarker( OBJ_START( pActionObject, TRUE ), OBJ_START( pActionObject, FALSE ) );
//STRIP001 		pMetaFile->ReplaceMarker( OBJ_END( pDimObject, TRUE ), OBJ_END( pDimObject, FALSE ) );
//STRIP001 
//STRIP001 		if( pSlowObjList )
//STRIP001 			delete (SdSlowObjRecord*) pSlowObjList->Remove( GetSlowObjRecord( (SdrAttrObj*) pActionObject ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	// falls ein nicht mehr abgeblendetes Objekt immer noch 'langsam' ist, muss der SlowObjRecord ersetzt werden
//STRIP001 	if( pSlowObjList && bIsSlow && bWasDimmed )
//STRIP001 	{
//STRIP001 		delete (SdSlowObjRecord*) pSlowObjList->Remove( GetSlowObjRecord( (SdrAttrObj*) pActionObject ) );
//STRIP001 
//STRIP001 		if( CreateSlowObjRecord( (SdrAttrObj*) pActionObject ) )
//STRIP001 		{
//STRIP001 			if( pMetaFile && !bWasSlow )
//STRIP001 			{
//STRIP001 				pMetaFile->ReplaceMarker( OBJ_START( pActionObject, FALSE ), OBJ_START( pActionObject, TRUE ) );
//STRIP001 				pMetaFile->ReplaceMarker( OBJ_END( pDimObject, FALSE ), OBJ_END( pDimObject, TRUE ) );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( pMetaFile && bWasSlow )
//STRIP001 		{
//STRIP001 			pMetaFile->ReplaceMarker( OBJ_START( pActionObject, TRUE ), OBJ_START( pActionObject, FALSE ) );
//STRIP001 			pMetaFile->ReplaceMarker( OBJ_END( pDimObject, TRUE ), OBJ_END( pDimObject, FALSE ) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( AffectsOwnPage(pActionObject) )
//STRIP001 		nVisibleAffectingObjects--;
//STRIP001 
//STRIP001 	return bResult;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Paint-Handler fuer Objekte, markiert bestimmte Objekte im Metafile
//STRIP001 |* mit Start- und Endmarke. Die Endmarke liegt auf der ersten Aktion
//STRIP001 |* HINTER dem Objekt, da beim Abspielen die zu einem genannten Ziel
//STRIP001 |* gehoerende Aktion nicht ausgefuehrt wird.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( FuSlideShow, PaintProc, SdrPaintProcRec *, pRecord )
//STRIP001 {
//STRIP001 	SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo( pRecord->pObj );
//STRIP001 	const BOOL			bMeta = pRecord->rOut.GetOutDev()->GetConnectMetaFile() == pMetaFile;
//STRIP001 	BOOL				bMasterObj = pRecord->pObj->GetPage()->IsMasterPage();
//STRIP001 
//STRIP001 	// Beginn der Zeichenseite markieren
//STRIP001 	if( !pRecord->pObj->GetOrdNum() && !bMasterObj )
//STRIP001 	{
//STRIP001 		const Marker aFirstStart( FIRST_START );
//STRIP001 
//STRIP001 		pMetaFile->InsertMarker( PAGE_START );
//STRIP001 
//STRIP001 		// falls noch kein First-Marker gesetzt ist, wird dies jetzt gemacht
//STRIP001 		if( !pMetaFile->HasMarker( aFirstStart ) )
//STRIP001 			pMetaFile->InsertMarker( aFirstStart );
//STRIP001 	}
//STRIP001 
//STRIP001 	// leere Praesentationsobjekte sollen nicht in der Show angezeigt werden
//STRIP001 	// (Sonderfall Hintergrundrechteck: hat faelschlicherweise ein Leer-Flag,
//STRIP001 	//	aber eine Aenderung kurz vor der Auslieferung ist zu riskant, deshalb
//STRIP001 	//	an dieser Stelle abfangen)
//STRIP001 	if( ( ANIMATIONMODE_PREVIEW != eAnimationMode ) && pRecord->pObj->IsEmptyPresObj() && pRecord->pObj != pBckgndRect )
//STRIP001 		return 0;
//STRIP001 
//STRIP001 	// falls nur der Hintergrund gecached wird, ist das erste Objekt das Objekt an Position 1 der Masterpage
//STRIP001 	if( bMasterObj && ( SDR_MASTERPAGECACHE_BACKGROUND == nMasterPageCacheMode ) && ( pRecord->pObj->GetOrdNum() == 1 ) )
//STRIP001 		pMetaFile->InsertMarker( FIRST_START );
//STRIP001 
//STRIP001 	if( pRecord->pObj == pBckgndRect )
//STRIP001 	{
//STRIP001 		// wenn es das Hintergrundrechteck ist
//STRIP001 		if( bMeta )
//STRIP001 		{
//STRIP001 			// falls nicht gecached wird, ist das erste Objekt das Objekt an Position 0 der Masterpage
//STRIP001 			if( SDR_MASTERPAGECACHE_NONE == nMasterPageCacheMode )
//STRIP001 				pMetaFile->InsertMarker( FIRST_START );
//STRIP001 
//STRIP001 			pMetaFile->InsertMarker( BACKOBJ_START );
//STRIP001 			pRecord->pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 			pMetaFile->InsertMarker( BACKOBJ_END );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pRecord->pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 	}
//STRIP001 	else if( pInfo && !pRecord->pObj->GetUpGroup() )
//STRIP001 	{
//STRIP001 		// Objekt mit Animationsinfo: im Metafile mit Labels klammern
//STRIP001 		BOOL bIsSlow = FALSE;
//STRIP001 
//STRIP001 		// ShowStati fuer MasterPageObjekte werden an anderer Stelle
//STRIP001 		// initialisiert ( ==> ::DoPageFade, ::PrepareForPage )
//STRIP001 		if( bInitShowStatus && !bMasterObj )
//STRIP001 			InitShowStatus( pInfo );
//STRIP001 
//STRIP001 		// Image
//STRIP001 		if( bMeta )
//STRIP001 		{
//STRIP001 			if( IsSlowObj( (SdrAttrObj*) pRecord->pObj ) && !( pShowView->IsMasterPagePaintCaching() && bMasterObj ) )
//STRIP001 				bIsSlow = CreateSlowObjRecord( (SdrAttrObj*) pRecord->pObj );
//STRIP001 
//STRIP001 			pMetaFile->InsertMarker( OBJ_START( pRecord->pObj, bIsSlow ) );
//STRIP001 
//STRIP001             // #92365# Record only the last frame of an animation
//STRIP001             if( pInfo->bIsMovie )
//STRIP001             {
//STRIP001                 // nur das letzte Bild
//STRIP001                 SdrObjList* pObjList = ((SdrObjGroup*)pRecord->pObj)->GetSubList();
//STRIP001                 SdrObject* pLast = (SdrObject*)pObjList->GetObj(pObjList->GetObjCount() - 1);
//STRIP001                 pLast->Paint(pRecord->rOut, pRecord->rInfoRec);
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001                 pRecord->pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001             }

//STRIP001 			pMetaFile->InsertMarker( OBJ_END( pRecord->pObj, bIsSlow ) );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pRecord->pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// ein ganz normales Wald- und Wiesenobjekt: zeichnen, wenn es zu sehen
//STRIP001 		// ist, ansonsten unterdruecken (das spart Zeit beim Abspielen des Metafiles)
//STRIP001 		const SdrPage*	pPage = (SdrPage*) pDoc->GetSdPage( 0, PK_STANDARD );
//STRIP001 		Point			aPnt( pPage->GetLftBorder(), pPage->GetUppBorder() );
//STRIP001 		const Rectangle	aRect( aPnt, aPageSize );
//STRIP001 
//STRIP001 		if( aRect.IsOver( pRecord->pObj->GetBoundRect() ) )
//STRIP001 		{
//STRIP001 			SdrObject*	pObj;
//STRIP001 			BOOL		bIsSlow = IsSlowObj( (SdrAttrObj*) pRecord->pObj );
//STRIP001 			BOOL		bIsTextClone = !bAnimationAllowed && OBJIS_TEXTANIM( pRecord->pObj );
//STRIP001 
//STRIP001 			// falls es sich um ein animiertes Textobjekt handelt,
//STRIP001 			// das nicht animiert dargestellt werden soll, muessen
//STRIP001 			// wir ein nicht animiertes Clone-Objekt im Mtf aufzeichnen
//STRIP001 			if( bIsTextClone )
//STRIP001 			{
//STRIP001 				// nicht animierten Clone zeichnen
//STRIP001 				SfxItemSet aTempAttr( pDoc->GetPool(), SDRATTR_TEXT_ANIKIND, SDRATTR_TEXT_ANIKIND );
//STRIP001 				pObj = pRecord->pObj->Clone();
//STRIP001 
//STRIP001 				aTempAttr.Set(pObj->GetItemSet());
//STRIP001 				
//STRIP001 				aTempAttr.Put( SdrTextAniKindItem() );
//STRIP001 
//STRIP001 				pObj->SetItemSet(aTempAttr);
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pObj = pRecord->pObj;
//STRIP001 
//STRIP001 			if( bIsSlow && bMeta )
//STRIP001 			{
//STRIP001 				bIsSlow = CreateSlowObjRecord( (SdrAttrObj*) pRecord->pObj );
//STRIP001 				pMetaFile->InsertMarker( OBJ_START( pRecord->pObj, bIsSlow ) );
//STRIP001 				pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 				pMetaFile->InsertMarker( OBJ_END( pRecord->pObj, bIsSlow ) );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 
//STRIP001 			if( bIsTextClone )
//STRIP001 				delete pObj;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ein bestimmtes Animationsobjekt verstecken und wieder anzeigen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuSlideShow::HideAndAnimateObject(SdrObject* pObject)
//STRIP001 {
//STRIP001 	if( !IsInputLocked() )
//STRIP001 	{
//STRIP001 		SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo(pObject);
//STRIP001 		SdPage*				pPage = (SdPage*) pObject->GetPage();
//STRIP001 		BOOL				bAbort = FALSE;
//STRIP001 
//STRIP001 		DBG_ASSERT( pInfo, "Objekt ohne Effekt" );
//STRIP001 
//STRIP001 		if( pPage->IsMasterPage() &&
//STRIP001 			( pObject->GetObjInventor() == SdrInventor ) &&
//STRIP001 			( pObject->GetObjIdentifier() == OBJ_TITLETEXT || pObject->GetObjIdentifier() == OBJ_OUTLINETEXT ) )
//STRIP001 		{
//STRIP001 			return bAbort;
//STRIP001 		}
//STRIP001 
//STRIP001 		pPage = pDoc->GetSdPage( aAnimPageList.GetCurrentPageNum(), PK_STANDARD );
//STRIP001 		PrepareForPage( pPage, FALSE );
//STRIP001 
//STRIP001 		// wenn in einer Preview EIN Objekt animiert werden soll, sind alle anderen Animationsobjekte sichtbar
//STRIP001 		if( eAnimationMode != ANIMATIONMODE_SHOW )
//STRIP001 		{
//STRIP001 			// Zeichenseite
//STRIP001 			SdrObjListIter aMasterIter( *pPage->GetMasterPage( 0 ), IM_FLAT );
//STRIP001 			SdrObjListIter aIter( *pPage, IM_FLAT );
//STRIP001 
//STRIP001 			for( SdrObject*	pMasterO = aMasterIter.Next(); pMasterO; pMasterO = aMasterIter.Next() )
//STRIP001 			{
//STRIP001 				SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pMasterO );
//STRIP001 				if( pInfo )
//STRIP001 					pInfo->bShow = pInfo->bIsShown = TRUE;
//STRIP001 			}
//STRIP001 
//STRIP001 			for( SdrObject*	pO = aIter.Next(); pO; pO = aIter.Next() )
//STRIP001 			{
//STRIP001 				SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pO );
//STRIP001 				if( pInfo )
//STRIP001 					pInfo->bShow = pInfo->bIsShown = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		// pActualPage wird fuer Objekteffekte benoetigt
//STRIP001 		if( !pActualPage )
//STRIP001 			pActualPage = pPage;
//STRIP001 
//STRIP001 		// verstecken
//STRIP001 		const BOOL bSoundOn = pInfo->bSoundOn;
//STRIP001 		pInfo->bSoundOn = FALSE;
//STRIP001 		HideOrVanishObject( pObject, pInfo->eClickAction != presentation::ClickAction_VANISH );
//STRIP001 		pInfo->bSoundOn = bSoundOn;
//STRIP001 
//STRIP001 		// im Reschedule des Effekts zerstoert?
//STRIP001 		if( nMagic != SLIDESHOW_MAGIC )
//STRIP001 			return TRUE;
//STRIP001 
//STRIP001 		// und wieder zeigen
//STRIP001 		pCurAnmList->Insert( pObject, (ULONG) 0 );
//STRIP001 
//STRIP001 		// wenn es das Gliederungstextobjekt ist, den Zeiger auf NULL zurueck
//STRIP001 		// setzen, damit die Initialisierungssequenz in AnimateLayoutText()
//STRIP001 		// durchlaufen wird
//STRIP001 		if( pObject == pLayoutText )
//STRIP001 			pLayoutText = NULL;
//STRIP001 
//STRIP001 		// solange KeyEvents simulieren, bis das Objekt aus der Animationsliste
//STRIP001 		// verschwunden ist (z. B. Gliederung mit mehreren Absaetzen)
//STRIP001 		// (oder bis die Show im Reschedule eines Effekts zerstoert wurde)
//STRIP001 		const KeyEvent aKEvt( 32, KeyCode( KEY_SPACE ) );
//STRIP001 
//STRIP001 		while( nMagic == SLIDESHOW_MAGIC && ( pCurAnmList->Count() || pDimObject ) )
//STRIP001 			KeyInput( aKEvt );
//STRIP001 
//STRIP001 		return bAbort;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* BitmapEx als TopLayer erzeugen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuSlideShow::CreateTopLayer( OutputDevice* pOut,
//STRIP001 								  const Marker& rStartMarker,
//STRIP001 								  const Marker& rEndMarker )
//STRIP001 {
//STRIP001 	BOOL bRet;
//STRIP001 
//STRIP001 	// alten TopLayer loeschen
//STRIP001 	delete pTopLayer;
//STRIP001 	pTopLayer = NULL;
//STRIP001 
//STRIP001 	// BitmapEx fuer TopLayer erzeugen
//STRIP001 	VirtualDevice*	pTempDev = new VirtualDevice( *pWindow );
//STRIP001 	const Size		aSizePix( pVDev->GetOutputSizePixel() );
//STRIP001 	Bitmap			aPaint;
//STRIP001 	Bitmap			aMask;
//STRIP001 
//STRIP001 	// Maske
//STRIP001 	pTempDev->SetOutputSizePixel( aSizePix );
//STRIP001 	pTempDev->SetMapMode( pVDev->GetMapMode() );
//STRIP001 	pTempDev->SetDrawMode( DRAWMODE_BLACKLINE | DRAWMODE_BLACKFILL | DRAWMODE_BLACKTEXT |
//STRIP001 						   DRAWMODE_BLACKGRADIENT | DRAWMODE_BLACKBITMAP );
//STRIP001 	pMetaFile->Play( pTempDev, rStartMarker, rEndMarker, TRUE );
//STRIP001 	pTempDev->SetMapMode( MapMode() );
//STRIP001 	aMask = pTempDev->GetBitmap( Point(), aSizePix );
//STRIP001 	delete pTempDev;
//STRIP001 
//STRIP001 	// Zeichenbitmap
//STRIP001 	pTempDev = new VirtualDevice( *pWindow );
//STRIP001 	bRet = pTempDev->SetOutputSizePixel( aSizePix );
//STRIP001 	pTempDev->SetMapMode( pVDev->GetMapMode() );
//STRIP001 	pMetaFile->Play( pTempDev, rStartMarker, rEndMarker );
//STRIP001 	pTempDev->SetMapMode( MapMode() );
//STRIP001 	aPaint = pTempDev->GetBitmap( Point(), aSizePix );
//STRIP001 	delete pTempDev;
//STRIP001 	pTopLayer = new BitmapEx( aPaint, aMask );
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ShowStatus an der Info setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuSlideShow::InitShowStatus( SdAnimationInfo* pInfo )
//STRIP001 {
//STRIP001 	if( pInfo )
//STRIP001 	{
//STRIP001 		if( pInfo->bActive && ( pInfo->eEffect == presentation::AnimationEffect_HIDE ) )
//STRIP001 		{
//STRIP001 			pInfo->bShow = pInfo->bIsShown = TRUE;
//STRIP001 		}
//STRIP001 		else if( pInfo->bActive &&
//STRIP001 				 ( pInfo->eEffect != presentation::AnimationEffect_NONE || pInfo->eEffect == presentation::AnimationEffect_NONE && pInfo->bIsMovie ) ||
//STRIP001 				 ( pInfo->eTextEffect != presentation::AnimationEffect_NONE ) )
//STRIP001 		{
//STRIP001 			pInfo->bShow = pInfo->bIsShown = FALSE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pInfo->bShow = pInfo->bIsShown = TRUE;
//STRIP001 
//STRIP001 		pInfo->bDimmed = FALSE;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Farbe, die zum Ausmaskieren benutzt wird, bestimmen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 Color FuSlideShow::GetVDevColor( const Color& rColor )
//STRIP001 {
//STRIP001 	return rColor;
//STRIP001 /*
//STRIP001 	VirtualDevice		aVDev( *pShowWindow );
//STRIP001 	const Size			aSz( 2, 2 );
//STRIP001 	Bitmap				aBmp;
//STRIP001 	BitmapReadAccess*	pAcc;
//STRIP001 	Color				aCol;
//STRIP001 
//STRIP001 	aVDev.SetBackground( rColor );
//STRIP001 	aVDev.SetOutputSizePixel( aSz );
//STRIP001 	aBmp = aVDev.GetBitmap( Point(), aSz );
//STRIP001 
//STRIP001 	if( ( pAcc = aBmp.AcquireReadAccess() ) != NULL )
//STRIP001 	{
//STRIP001 		if( pAcc->HasPalette() )
//STRIP001 			aCol = pAcc->GetPaletteColor( pAcc->GetPixel( 0, 0 ) );
//STRIP001 		else
//STRIP001 			aCol = pAcc->GetPixel( 0, 0 );
//STRIP001 
//STRIP001 		aBmp.ReleaseAccess( pAcc );
//STRIP001 	}
//STRIP001 
//STRIP001 	return aCol;
//STRIP001 */
//STRIP001 }

}
