/*************************************************************************
 *
 *  $RCSfile: sd_drviews1.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:11:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// auto strip #include <so3/iface.hxx>

#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
#ifndef _SVDPAGV_HXX //autogen
#include <bf_svx/svdpagv.hxx>
#endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
#ifndef _SVDOOLE2_HXX //autogen
#include <bf_svx/svdoole2.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _SV_SCRBAR_HXX //autogen
// auto strip #include <vcl/scrbar.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SVSTOR_HXX //autogen
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
#ifndef _SVX_FMSHELL_HXX //autogen
#include <bf_svx/fmshell.hxx>
#endif
// auto strip #ifndef _E3D_GLOBL3D_HXX
// auto strip #include <bf_svx/globl3d.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FMGLOB_HXX
// auto strip #include <bf_svx/fmglob.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLINER_HXX //autogen
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #endif
// auto strip #ifndef _OFF_APP_HXX //autogen
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif

#pragma hdrstop

// auto strip #include "misc.hxx"

#ifdef STARIMAGE_AVAILABLE
// auto strip #ifndef _SIMDLL_HXX
// auto strip #include <sim2/simdll.hxx>
// auto strip #endif
#endif

// #define ITEMID_SIZE             0

#include "glob.hrc"
#include "app.hrc"
#include "res_bmp.hrc"
#include "strings.hrc"
#include "helpids.h"

// auto strip #include "app.hxx"
// auto strip #include "fupoor.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "fusel.hxx"
#include "sdpage.hxx"
#include "frmview.hxx"
// auto strip #include "stlpool.hxx"
#include "sdwindow.hxx"
#include "drawview.hxx"
#include "drawdoc.hxx"
#include "docshell.hxx"
#include "drviewsh.hxx"
#include "sdruler.hxx"
#include "sdclient.hxx"
//STRIP001 #include "preview.hxx"
#include "prevchld.hxx"
#include "fuslshow.hxx"
// auto strip #include "optsitem.hxx"
// auto strip #include "fusearch.hxx"
// auto strip #include "fuspell.hxx"
// auto strip #include "sdoutl.hxx"
#include "animobjs.hxx"
#include "SdUnoDrawView.hxx"
namespace binfilter {

#ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
#define SO2_DECL_SVINPLACEOBJECT_DEFINED
SO2_DECL_REF(SvInPlaceObject)
#endif
#ifndef SO2_DECL_SVSTORAGE_DEFINED
#define SO2_DECL_SVSTORAGE_DEFINED
SO2_DECL_REF(SvStorage)
#endif

#ifdef WNT
#pragma optimize ( "", off )
#endif

/*************************************************************************
|*
|* Activate(), beim ersten Aufruf wird eine Shell fuer den Object Bar erzeugt
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::Activate(BOOL bIsMDIActivate)
//STRIP001 {
//STRIP001 	SdViewShell::Activate(bIsMDIActivate);
//STRIP001 	if (nCurrentObjectBar == 0)    // nur wenn noch kein Object Bar existent
//STRIP001 	{
//STRIP001 		nCurrentObjectBar = RID_DRAW_OBJ_TOOLBOX;
//STRIP001 
//STRIP001 		RemoveSubShell();
//STRIP001 		AddSubShell( *(SfxShell*) aShellTable.Get( RID_FORMLAYER_TOOLBOX ) );
//STRIP001 
//STRIP001 		AddSubShell( *(SfxShell*) aShellTable.Get( nCurrentObjectBar ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bIsMDIActivate)
//STRIP001 	{
//STRIP001 		BOOL bPreview = FALSE;
//STRIP001 
//STRIP001 		if (eEditMode == EM_PAGE)
//STRIP001 			bPreview = pFrameView->IsShowPreviewInPageMode() != 0;
//STRIP001 		else
//STRIP001 			bPreview = pFrameView->IsShowPreviewInMasterPageMode() != 0;
//STRIP001 
//STRIP001 		SfxBoolItem aItem(SID_PREVIEW_WIN, bPreview);
//STRIP001 		GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 			SID_PREVIEW_WIN, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L);
//STRIP001 	}
//STRIP001 }

//STRIP001 void SdDrawViewShell::UIActivate( SvInPlaceObject *pIPObj )
//STRIP001 {
//STRIP001 	SdViewShell::UIActivate(pIPObj);
//STRIP001 
//STRIP001     // #94252# Disable own controls
//STRIP001     aTabControl.Disable();
//STRIP001     aLayerTab.Disable();
//STRIP001     aPageBtn.Disable();
//STRIP001     aMasterPageBtn.Disable();
//STRIP001     aLayerBtn.Disable();
//STRIP001 }

//STRIP001 void SdDrawViewShell::UIDeactivate( SvInPlaceObject *pIPObj )
//STRIP001 {
//STRIP001     // #94252# Enable own controls
//STRIP001     aTabControl.Enable();
//STRIP001     aLayerTab.Enable();
//STRIP001 
//STRIP001     // #94951# handout and notes are no separate views, 
//STRIP001     // handle difference in enabled functionality
//STRIP001     if (ePageKind == PK_NOTES)
//STRIP001     {
//STRIP001         aPageBtn.Enable();
//STRIP001         aMasterPageBtn.Enable();
//STRIP001         aLayerBtn.Disable();
//STRIP001     }
//STRIP001     else if (ePageKind == PK_HANDOUT)
//STRIP001     {
//STRIP001         aPageBtn.Disable();
//STRIP001         aMasterPageBtn.Enable();
//STRIP001         aLayerBtn.Disable();
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         aPageBtn.Enable();
//STRIP001         aMasterPageBtn.Enable();
//STRIP001         aLayerBtn.Enable();
//STRIP001     }
//STRIP001 
//STRIP001 	SdViewShell::UIDeactivate(pIPObj);
//STRIP001 }

/*************************************************************************
|*
|* Deactivate()
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::Deactivate(BOOL bIsMDIActivate)
/*N*/ {
/*N*/ 	SdViewShell::Deactivate(bIsMDIActivate);
/*N*/ }

/*************************************************************************
|*
|* Wird gerufen, wenn sich der Selektionszustand der View aendert
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::SelectionHasChanged()
/*N*/ {
/*N*/ 	// Um die Performance zu steigern wird jetzt die komplette
/*N*/ 	// Shell invalidiert statt alle Slots einzeln
/*N*/ 	Invalidate();
/*N*/ 
/*N*/ 	// Damit das Effekte-Window auch einen aktuellen Status bekommt
/*N*/ 	UpdateEffectWindow();
/*N*/ 
/*N*/ 	//Update3DWindow(); // 3D-Controller
/*N*/ 	SfxBoolItem aItem( SID_3D_STATE, TRUE );
/*N*/ 	GetViewFrame()->GetDispatcher()->Execute(
/*N*/ 		SID_3D_STATE, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );
/*N*/ 
/*N*/ 	SdrOle2Obj* pOleObj = NULL;
/*N*/ 	SdrGrafObj* pGrafObj = NULL;
/*N*/ 
/*N*/ 	if ( pDrView->HasMarkedObj() )
/*N*/ 	{
/*?*/ 		const SdrMarkList& rMarkList = pDrView->GetMarkList();
/*?*/ 
/*?*/ 		if (rMarkList.GetMarkCount() == 1)
/*?*/ 		{
/*?*/ 			SdrMark* pMark = rMarkList.GetMark(0);
/*?*/ 			SdrObject* pObj = pMark->GetObj();
/*?*/ 
/*?*/ 			UINT32 nInv = pObj->GetObjInventor();
/*?*/ 			UINT16 nSdrObjKind = pObj->GetObjIdentifier();
/*?*/ 
/*?*/ 			if (nInv = SdrInventor && nSdrObjKind == OBJ_OLE2)
/*?*/ 			{
/*?*/ 				DBG_BF_ASSERT(0, "STRIP"); //STRIP001 pOleObj = (SdrOle2Obj*) pObj;
//STRIP001 /*?*/ 				UpdateIMapDlg( pObj );
/*?*/ 			}
/*?*/ 			else if (nSdrObjKind == OBJ_GRAF)
/*?*/ 			{
/*?*/ 				DBG_BF_ASSERT(0, "STRIP"); //STRIP001 pGrafObj = (SdrGrafObj*) pObj;
//STRIP001 /*?*/ 				UpdateIMapDlg( pObj );
/*?*/ 			}
/*?*/ 		}
/*?*/ 	}
/*N*/ 
/*N*/ 	SdClient* pIPClient = (SdClient*) GetIPClient();
/*N*/ 
/*N*/ 	if ( pIPClient && pIPClient->IsInPlaceActive() )
/*N*/ 	{
		/**********************************************************************
		* Ggf. OLE-Objekt beruecksichtigen und deaktivieren
		**********************************************************************/
/*?*/ 
/*?*/ 		// if we have no ole object marked and have an inplace active ipc client
/*?*/ 		// this means we recently deselected an inplace active ole object so
/*?*/ 		// we need to deselect it now
/*?*/ 		if (!pOleObj)
/*?*/ 		{
/*?*/ 			pIPClient->GetProtocol().Reset2Open();
/*?*/ 
/*?*/ 			SFX_APP()->SetViewFrame( GetViewFrame() );
/*?*/ 			SetVerbs(0);
/*?*/ 			pDrView->ShowMarkHdl(NULL);
/*?*/ 		}
/*?*/ 		else
/*?*/ 		{
/*?*/ 			SvInPlaceObjectRef aIPObj = pOleObj->GetObjRef();
/*?*/ 
/*?*/ 			if ( aIPObj.Is() )
/*?*/ 			{
/*?*/ 				SetVerbs( &aIPObj->GetVerbList() );
/*?*/ 			}
/*?*/ 			else
/*?*/ 			{
/*?*/ 				SetVerbs(NULL);
/*?*/ 			}
/*?*/ 		}
/*N*/ 	}
/*N*/ 	else
/*N*/ 	{
/*?*/ #ifdef STARIMAGE_AVAILABLE
/*?*/ 		if ( pGrafObj && pGrafObj->GetGraphicType() == GRAPHIC_BITMAP && SFX_APP()->HasFeature(SFX_FEATURE_SIMAGE))
/*?*/ 		{
/*?*/ 			SvVerb aVerb( 0, String( SdResId(STR_EDIT_OBJ) ) );
/*?*/ 			SvVerbList aVerbList;
/*?*/ 			aVerbList.Append( aVerb );
/*?*/ 			SetVerbs( &aVerbList );
/*?*/ 		}
/*?*/ 		else
/*?*/ #endif
/*N*/ 		if ( pOleObj )
/*N*/ 		{
/*?*/ 			SvInPlaceObjectRef aIPObj = pOleObj->GetObjRef();
/*?*/ 
/*?*/ 			if ( aIPObj.Is() )
/*?*/ 			{
/*?*/ 				SetVerbs( &aIPObj->GetVerbList() );
/*?*/ 			}
/*?*/ 			else
/*?*/ 			{
/*?*/ 				SetVerbs(NULL);
/*?*/ 			}
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
/*N*/ 			SetVerbs(NULL);
/*N*/ 		}
/*N*/ 	}

/*N*/ 	if( pFuActual )
/*?*/ 	{
/*?*/ 		pFuActual->SelectionHasChanged();
/*?*/ 	}
/*N*/ 	else
/*N*/ 	{
/*N*/ 		USHORT nObjBarId;
/*N*/ 
/*N*/ 		if (pView->GetContext() == SDRCONTEXT_POINTEDIT)
/*N*/ 			nObjBarId = RID_BEZIER_TOOLBOX;
/*N*/ 		else if (pView->GetContext() == SDRCONTEXT_GRAPHIC)
/*N*/ 			nObjBarId = RID_DRAW_GRAF_TOOLBOX;
/*N*/ 		else if (pView->GetContext() == SDRCONTEXT_TEXTEDIT)
/*N*/ 			nObjBarId = RID_DRAW_TEXT_TOOLBOX;	// #96124# Keep text bar when in textedit
/*N*/ 		else
/*N*/ 			nObjBarId = RID_DRAW_OBJ_TOOLBOX;
/*N*/ 
/*N*/ 		SwitchObjectBar(nObjBarId);
/*N*/ 	}
/*N*/ 
/*N*/     // #96124# Invalidate for every subshell
/*N*/     SfxShell* pShell = (SfxShell*) aShellTable.Get( GetObjectBar() );
/*N*/     if( pShell )
/*N*/         pShell->Invalidate();
/*N*/ 
/*N*/ 	if( SFX_APP()->GetHelpPI() )
/*?*/ 		{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 SetHelpIdBySelection();

/*N*/     pDrView->UpdateSelectionClipboard( FALSE );

/*N*/ 	if( pController )
/*?*/ 		pController->fireSelectionChangeListener();
/*N*/ }


/*************************************************************************
|*
|* Zoomfaktor setzen
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::SetZoom( long nZoom )
//STRIP001 {
//STRIP001     // Make sure that the zoom factor will not be recalculated on 
//STRIP001     // following window resizings.
//STRIP001     bZoomOnPage = FALSE;
//STRIP001 	SdViewShell::SetZoom( nZoom );
//STRIP001 	GetViewFrame()->GetBindings().Invalidate( SID_ATTR_ZOOM );
//STRIP001 }

/*************************************************************************
|*
|* Zoomrechteck fuer aktives Fenster einstellen
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::SetZoomRect( const Rectangle& rZoomRect )
//STRIP001 {
//STRIP001 	SdViewShell::SetZoomRect( rZoomRect );
//STRIP001 	GetViewFrame()->GetBindings().Invalidate( SID_ATTR_ZOOM );
//STRIP001 }

/*************************************************************************
|*
|* Modus-Umschaltung (Draw, Slide, Outline)
|*
\************************************************************************/

IMPL_LINK( SdDrawViewShell, TabModeBtnHdl, Button *, pButton )
{
	DBG_BF_ASSERT(0, "STRIP"); //STRIP001 if ( !((ImageButton*) pButton)->IsChecked() ||
//STRIP001 		 pButton == &aLayerBtn)
//STRIP001 	{
//STRIP001 		USHORT nSlotId;
//STRIP001 
//STRIP001 		if ( pButton == &aPageBtn )
//STRIP001 			nSlotId = SID_PAGEMODE;
//STRIP001 		else if ( pButton == &aMasterPageBtn )
//STRIP001 			nSlotId = SID_MASTERPAGE;
//STRIP001 		else if ( pButton == &aLayerBtn )
//STRIP001 			nSlotId = SID_LAYERMODE;
//STRIP001 
//STRIP001 		GetViewFrame()->GetDispatcher()->Execute(nSlotId,
//STRIP001 					SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 	}
//STRIP001 
//STRIP001 	pWindow->GrabFocus();         // SdWindow soll den Focus erhalten
//STRIP001 
	return 0;
}

/*************************************************************************
|*
|* PrepareClose, ggfs. Texteingabe beenden, damit andere Viewshells ein
|* aktualisiertes Textobjekt vorfinden
|*
\************************************************************************/

/*N*/ USHORT SdDrawViewShell::PrepareClose( BOOL bUI, BOOL bForBrowsing )
/*N*/ {
/*N*/ 	if ( SdViewShell::PrepareClose(bUI, bForBrowsing) != TRUE )
/*N*/ 		return FALSE;
/*N*/ 
/*N*/ 	SfxChildWindow* pPreviewChild = GetViewFrame()->GetChildWindow( SdPreviewChildWindow::GetChildWindowId() );
/*N*/ 	BOOL			bRet = TRUE;
/*N*/ 
/*N*/ 	if( pFuSlideShow )
/*?*/ 	{
/*?*/ 		pFuSlideShow->Terminate();
/*?*/ 		bRet = FALSE;
/*?*/ 	}
/*N*/ 
/*N*/ 	if( pPreviewChild && pPreviewChild->GetWindow() )
/*?*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 SdPreviewWin*	pPreviewWin = (SdPreviewWin*) pPreviewChild->GetWindow();
//STRIP001 /*?*/ 		FuSlideShow*	pShow = pPreviewWin ? pPreviewWin->GetSlideShow() : NULL;
//STRIP001 
//STRIP001 /*?*/ 		if( pPreviewWin->GetDoc() == pDoc && pShow && pShow->IsInputLocked() )
//STRIP001 /*?*/ 		{
//STRIP001             //			pShow->Terminate();
//STRIP001             //			bRet = FALSE;
//STRIP001             pShow->Destroy ();
//STRIP001 /*?*/ 		}
/*?*/ 	}

/*N*/ 	if( bRet && pFuActual )
/*N*/ 	{
/*N*/ 		USHORT nID = pFuActual->GetSlotID();
/*N*/ 		if (nID == SID_TEXTEDIT || nID == SID_ATTR_CHAR)
/*?*/ 		{
/*?*/ 			pDrView->EndTextEdit();
/*?*/ 		}
/*N*/ 	}
/*N*/ 	else if( !bRet )
/*?*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 aCloseTimer.SetTimeoutHdl( LINK( this, SdDrawViewShell, CloseHdl ) );
//STRIP001 /*?*/ 		aCloseTimer.SetTimeout( 20 );
//STRIP001 /*?*/ 		aCloseTimer.Start();
/*?*/ 	}
/*N*/ 
/*N*/ 	return bRet;
/*N*/ }

/*************************************************************************
|*
|* Status (Enabled/Disabled) von Menue-SfxSlots setzen
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::ChangeEditMode(EditMode eEMode, BOOL bLMode)
/*N*/ {
/*N*/ 	if (eEditMode != eEMode || bLayerMode != bLMode)
/*N*/ 	{
/*N*/         USHORT nActualPageNum = 0;
/*N*/ 
/*N*/ 		if( pController )
/*N*/ 		{
/*N*/ 			pController->fireChangeEditMode( eEMode == EM_MASTERPAGE );
/*N*/ 			pController->fireChangeLayerMode( bLMode );
/*N*/ 		}
/*N*/ 
/*N*/ 		if ( pDrView->IsTextEdit() )
/*N*/ 		{
/*?*/ 			pDrView->EndTextEdit();
/*?*/ 		}
/*?*/ 
/*N*/ 		aLayerTab.EndEditMode();
/*N*/ 		aTabControl.EndEditMode();
/*N*/ 
/*N*/ 		if (ePageKind == PK_HANDOUT)
/*N*/ 		{
/*N*/ 			// Bei Handzetteln nur MasterPage zulassen
/*N*/ 			eEMode = EM_MASTERPAGE;
/*N*/ 		}
/*N*/ 
/*N*/ 		eEditMode = eEMode;
/*N*/ 		bLayerMode = bLMode;
/*N*/ 
/*N*/ 		if (eEditMode == EM_PAGE)
/*N*/ 		{
			/******************************************************************
			* PAGEMODE
			******************************************************************/
            // Emulate radio button behaviour.  Order of checking buttons on
            // or off is important for accessibility.
/*N*/ 			aMasterPageBtn.Check(FALSE);
/*N*/ 			aPageBtn.Check(TRUE);
/*N*/ 
/*N*/ 			aTabControl.Clear();
/*N*/ 
/*N*/ 			SdPage* pPage;
/*N*/ 			String aPageName;
/*N*/ 			USHORT nPageCnt = pDoc->GetSdPageCount(ePageKind);
/*N*/ 
/*N*/ 			for (USHORT i = 0; i < nPageCnt; i++)
/*N*/ 			{
/*N*/ 				pPage = pDoc->GetSdPage(i, ePageKind);
/*N*/ 				aPageName = pPage->GetName();
/*N*/ 				aTabControl.InsertPage(i + 1, aPageName);
/*N*/ 
/*N*/ 				if ( pPage->IsSelected() && nActualPageNum == 0 )
/*N*/ 				{
/*N*/ 					nActualPageNum = i;
/*N*/ 				}
/*N*/ 			}
/*N*/ 
/*N*/             aTabControl.SetCurPageId(nActualPageNum + 1);
/*N*/ 
/*N*/ 			SwitchPage(nActualPageNum);
/*N*/ 
/*N*/ 			SfxBoolItem aItem(SID_PREVIEW_WIN, pFrameView->IsShowPreviewInPageMode() != 0 );
/*N*/ 			GetViewFrame()->GetDispatcher()->Execute(
/*N*/ 				SID_PREVIEW_WIN, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
			/******************************************************************
			* MASTERPAGE
			******************************************************************/
/*?*/ 			GetViewFrame()->SetChildWindow(SdAnimationChildWindow::GetChildWindowId(), FALSE );
/*?*/ 
            // Emulate radio button behaviour.  Order of checking buttons on
            // or off is important for accessibility.
/*?*/ 			aPageBtn.Check(FALSE);
/*?*/ 			aMasterPageBtn.Check(TRUE);
/*?*/ 
/*?*/ 			if (!pActualPage)
/*?*/ 			{
/*?*/ 				// Sofern es keine pActualPage gibt, wird die erste genommen
/*?*/ 				pActualPage = pDoc->GetSdPage(0, ePageKind);
/*?*/ 			}
/*?*/ 
/*?*/ 			SdPage* pPreviewPage = pActualPage;
/*?*/ 
/*?*/ 			aTabControl.Clear();
/*?*/ 			USHORT nActualMasterPageNum = 0;
/*?*/ 			USHORT nMasterPageCnt = pDoc->GetMasterSdPageCount(ePageKind);
/*?*/ 
/*?*/ 			for (USHORT i = 0; i < nMasterPageCnt; i++)
/*?*/ 			{
/*?*/ 				SdPage* pMaster = pDoc->GetMasterSdPage(i, ePageKind);
/*?*/ 				String aLayoutName(pMaster->GetLayoutName());
/*?*/ 				aLayoutName.Erase(aLayoutName.SearchAscii(SD_LT_SEPARATOR));
/*?*/ 
/*?*/ 				aTabControl.InsertPage(i + 1, aLayoutName);
/*?*/ 
/*?*/ 				if (pActualPage->GetMasterPage(0) == pMaster)
/*?*/ 				{
/*?*/ 					nActualMasterPageNum = i;
/*?*/ 				}
/*?*/ 			}
/*?*/ 
/*?*/ 			aTabControl.SetCurPageId(nActualMasterPageNum + 1);
/*?*/ 			SwitchPage(nActualMasterPageNum);
/*?*/ 
/*?*/ 			SfxBoolItem aItem(SID_PREVIEW_WIN, pFrameView->IsShowPreviewInMasterPageMode() != 0 );
/*?*/ 			GetViewFrame()->GetDispatcher()->Execute(
/*?*/ 				SID_PREVIEW_WIN, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );
/*N*/  		}

/*N*/ 		if (bLayerMode)
/*N*/ 		{
			/******************************************************************
			* LAYER ein
			******************************************************************/
/*N*/  			aTabControl.Hide();
/*N*/  			aLayerTab.Show();
/*N*/  			aLayerBtn.Check(TRUE);
/*N*/  		}
/*N*/  		else
/*N*/ 		{
			/******************************************************************
			* LAYER aus
			******************************************************************/
/*N*/ 			aTabControl.Show();
/*N*/ 			aLayerTab.Hide();
/*N*/ 			aLayerBtn.Check(FALSE);
            // Set the tab control only for draw pages.  For master page
            // this has been done already above.
/*N*/             if (eEditMode == EM_PAGE)
/*N*/                 aTabControl.SetCurPageId (nActualPageNum + 1);
/*N*/ 		}
/*N*/ 
/*N*/ 		ResetActualLayer();
/*N*/ 
/*N*/ 		Invalidate( SID_PAGEMODE );
/*N*/ 		Invalidate( SID_LAYERMODE );
/*N*/ 		Invalidate( SID_MASTERPAGE );
/*N*/ 		Invalidate( SID_SLIDE_MASTERPAGE );
/*N*/ 		Invalidate( SID_TITLE_MASTERPAGE );
/*N*/ 		Invalidate( SID_NOTES_MASTERPAGE );
/*N*/ 		Invalidate( SID_HANDOUT_MASTERPAGE );
/*N*/ 		Invalidate(SID_PREVIEW_WIN);
/*N*/ 	}
/*N*/ }

/*************************************************************************
|*
|* Groesse des TabControls und der ModeButtons zurueckgeben
|*
\************************************************************************/

//STRIP001 long SdDrawViewShell::GetHCtrlWidth()
//STRIP001 {
//STRIP001 	return ( aTabControl.GetSizePixel().Width() +
//STRIP001 			 aPageBtn.GetSizePixel().Width() * 3 );
//STRIP001 }


/*************************************************************************
|*
|* Horizontales Lineal erzeugen
|*
\************************************************************************/

//STRIP001 SvxRuler* SdDrawViewShell::CreateHRuler(SdWindow* pWin, BOOL bIsFirst)
//STRIP001 {
//STRIP001 	SdRuler* pRuler;
//STRIP001 	WinBits  aWBits;
//STRIP001 	USHORT	 nFlags = SVXRULER_SUPPORT_OBJECT;
//STRIP001 
//STRIP001 	if ( bIsFirst )
//STRIP001 	{
//STRIP001 		aWBits	= WB_HSCROLL | WB_3DLOOK | WB_BORDER | WB_EXTRAFIELD;
//STRIP001 		nFlags |= ( SVXRULER_SUPPORT_SET_NULLOFFSET |
//STRIP001 					SVXRULER_SUPPORT_TABS |
//STRIP001 					SVXRULER_SUPPORT_PARAGRAPH_MARGINS ); // Neu
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aWBits = WB_HSCROLL | WB_3DLOOK | WB_BORDER;
//STRIP001 
//STRIP001 	pRuler = new SdRuler(*this, &GetViewFrame()->GetWindow(), pWin, nFlags,
//STRIP001 						  GetViewFrame()->GetBindings(), aWBits);
//STRIP001 	pRuler->SetSourceUnit(pWin->GetMapMode().GetMapUnit());
//STRIP001 
//STRIP001 	// Metric ...
//STRIP001 	UINT16 nMetric = pDoc->GetUIUnit();
//STRIP001 
//STRIP001 	if( nMetric == 0xffff )
//STRIP001 		nMetric = GetModuleFieldUnit();
//STRIP001 
//STRIP001 	pRuler->SetUnit( FieldUnit( nMetric ) );
//STRIP001 
//STRIP001 	// ... und auch DefTab am Lineal einstellen
//STRIP001 	pRuler->SetDefTabDist( pDoc->GetDefaultTabulator() ); // Neu
//STRIP001 
//STRIP001 	Fraction aUIScale(pWin->GetMapMode().GetScaleX());
//STRIP001 	aUIScale *= pDoc->GetUIScale();
//STRIP001 	pRuler->SetZoom(aUIScale);
//STRIP001 
//STRIP001 	return pRuler;
//STRIP001 }

/*************************************************************************
|*
|* Vertikales Lineal erzeugen
|*
\************************************************************************/

//STRIP001 SvxRuler* SdDrawViewShell::CreateVRuler(SdWindow* pWin)
//STRIP001 {
//STRIP001 	SdRuler* pRuler;
//STRIP001 	WinBits  aWBits = WB_VSCROLL | WB_3DLOOK | WB_BORDER;
//STRIP001 	USHORT	 nFlags = SVXRULER_SUPPORT_OBJECT;
//STRIP001 
//STRIP001 	pRuler = new SdRuler(*this, &GetViewFrame()->GetWindow(), pWin, nFlags,
//STRIP001 						  GetViewFrame()->GetBindings(), aWBits);
//STRIP001 	pRuler->SetSourceUnit(pWin->GetMapMode().GetMapUnit());
//STRIP001 
//STRIP001 	// #96629# Metric same as HRuler, use document setting
//STRIP001 	UINT16 nMetric = pDoc->GetUIUnit();
//STRIP001 
//STRIP001 	if( nMetric == 0xffff )
//STRIP001 		nMetric = GetModuleFieldUnit();
//STRIP001 
//STRIP001 	pRuler->SetUnit( FieldUnit( nMetric ) );
//STRIP001 
//STRIP001 	Fraction aUIScale(pWin->GetMapMode().GetScaleY());
//STRIP001 	aUIScale *= pDoc->GetUIScale();
//STRIP001 	pRuler->SetZoom(aUIScale);
//STRIP001 
//STRIP001 	return pRuler;
//STRIP001 }

/*************************************************************************
|*
|* Horizontales Lineal aktualisieren
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::UpdateHRuler()
/*N*/ {
/*N*/ 	Invalidate( SID_ATTR_LONG_LRSPACE );
/*N*/ 	Invalidate( SID_RULER_PAGE_POS );
/*N*/ 	Invalidate( SID_RULER_OBJECT );
/*N*/ 	Invalidate( SID_RULER_TEXT_RIGHT_TO_LEFT );
/*N*/ 
/*N*/ 	for (USHORT nIndex=0; nIndex<MAX_HSPLIT_CNT; nIndex++)
/*N*/ 	{
/*N*/ 		if (pHRulerArray[nIndex])
/*N*/ 		{
/*?*/ 			pHRulerArray[nIndex]->ForceUpdate();
/*N*/ 		}
/*N*/ 	}
/*N*/ }

/*************************************************************************
|*
|* Vertikales Lineal aktualisieren
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::UpdateVRuler()
/*N*/ {
/*N*/ 	Invalidate( SID_ATTR_LONG_LRSPACE );
/*N*/ 	Invalidate( SID_RULER_PAGE_POS );
/*N*/ 	Invalidate( SID_RULER_OBJECT );
/*N*/ 
/*N*/ 	for (USHORT nIndex=0; nIndex<MAX_VSPLIT_CNT; nIndex++)
/*N*/ 	{
/*N*/ 		if (pVRulerArray[nIndex])
/*N*/ 		{
/*N*/ 			pVRulerArray[nIndex]->ForceUpdate();
/*N*/ 		}
/*N*/ 	}
/*N*/ }

/*************************************************************************
|*
|* Metrik setzen
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::SetUIUnit(FieldUnit eUnit)
//STRIP001 {
//STRIP001 	SdViewShell::SetUIUnit(eUnit);
//STRIP001 }

/*************************************************************************
|*
|* TabControl nach Splitteraenderung aktualisieren
|*
\************************************************************************/

IMPL_LINK( SdDrawViewShell, TabSplitHdl, TabBar *, pTab )
{
	DBG_BF_ASSERT(0, "STRIP"); //STRIP001 long nMax = aHSplit.GetPosPixel().X() - aTabControl.GetPosPixel().X();
//STRIP001 
//STRIP001 	Size aTabSize = aTabControl.GetSizePixel();
//STRIP001 	aTabSize.Width() = Min(pTab->GetSplitSize(), (long)(nMax-1));
//STRIP001 
//STRIP001 	aTabControl.SetSizePixel(aTabSize);
//STRIP001 	aLayerTab.SetSizePixel(aTabSize);
//STRIP001 
//STRIP001 	Point aPos = aTabControl.GetPosPixel();
//STRIP001 	aPos.X() += aTabSize.Width();
//STRIP001 
//STRIP001 	Size aScrSize(nMax - aTabSize.Width(), aScrBarWH.Height());
//STRIP001 	pHScrlArray[0]->SetPosSizePixel(aPos, aScrSize);
//STRIP001 
	return 0;
}

/*************************************************************************
|*
|* neue aktuelle Seite auswaehlen, falls sich die Seitenfolge geaendert
|* hat (z. B. durch Undo)
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::ResetActualPage()
/*N*/ {
/*N*/ 	USHORT nCurrentPage = aTabControl.GetCurPageId() - 1;
/*N*/ 	USHORT nPageCount	= (eEditMode == EM_PAGE)?pDoc->GetSdPageCount(ePageKind):pDoc->GetMasterSdPageCount(ePageKind);
/*N*/ 	if (nPageCount > 0)
/*N*/ 		nCurrentPage = Min((USHORT)(nPageCount - 1), nCurrentPage);
/*N*/ 	else
/*N*/ 		nCurrentPage = 0;
/*N*/ 
/*N*/ 	if (eEditMode == EM_PAGE)
/*N*/ 	{
/*N*/ 
/*N*/ 		// Update fuer TabControl
/*N*/ 		aTabControl.Clear();
/*N*/ 
/*N*/ 		SdPage* pPage = NULL;
/*N*/ 		String aPageName;
/*N*/ 
/*N*/ 		for (USHORT i = 0; i < nPageCount; i++)
/*N*/ 		{
/*N*/ 			pPage = pDoc->GetSdPage(i, ePageKind);
/*N*/ 			aPageName = pPage->GetName();
/*N*/ 			aTabControl.InsertPage(i + 1, aPageName);
/*N*/ 
/*N*/ 			// Selektionskennungen der Seiten korrigieren
/*N*/ 			pDoc->SetSelected(pPage, i == nCurrentPage);
/*N*/ 		}
/*N*/ 
/*N*/ 		aTabControl.SetCurPageId(nCurrentPage + 1);
/*N*/ 	}
/*N*/ 	else // EM_MASTERPAGE
/*N*/ 	{
/*?*/ 		SdPage* pActualPage = pDoc->GetMasterSdPage(nCurrentPage, ePageKind);
/*?*/ 		aTabControl.Clear();
/*?*/ 		USHORT nActualMasterPageNum = 0;
/*?*/ 
/*?*/ 		USHORT nMasterPageCnt = pDoc->GetMasterSdPageCount(ePageKind);
/*?*/ 		for (USHORT i = 0; i < nMasterPageCnt; i++)
/*?*/ 		{
/*?*/ 			SdPage* pMaster = pDoc->GetMasterSdPage(i, ePageKind);
/*?*/ 			String aLayoutName(pMaster->GetLayoutName());
/*?*/ 			aLayoutName.Erase(aLayoutName.SearchAscii(SD_LT_SEPARATOR));
/*?*/ 			aTabControl.InsertPage(i + 1, aLayoutName);
/*?*/ 
/*?*/ 			if (pActualPage == pMaster)
/*?*/ 				nActualMasterPageNum = i;
/*?*/ 		}
/*?*/ 
/*?*/ 		aTabControl.SetCurPageId(nActualMasterPageNum + 1);
/*?*/ 		SwitchPage(nActualMasterPageNum);
/*?*/ 	}
/*N*/ 
/*N*/ 	GetViewFrame()->GetDispatcher()->Execute(SID_SWITCHPAGE,
/*N*/ 				SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD);
/*N*/ }

/*************************************************************************
|*
|* Verb auf OLE-Objekt anwenden
|*
\************************************************************************/


//STRIP001 ErrCode SdDrawViewShell::DoVerb(long nVerb)
//STRIP001 {
//STRIP001 	if ( pDrView->HasMarkedObj() )
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 			SdrObject* pObj = pMark->GetObj();
//STRIP001 
//STRIP001 			UINT32 nInv = pObj->GetObjInventor();
//STRIP001 			UINT16 nSdrObjKind = pObj->GetObjIdentifier();
//STRIP001 
//STRIP001 			if (nInv = SdrInventor && nSdrObjKind == OBJ_OLE2)
//STRIP001 			{
//STRIP001 				ActivateObject( (SdrOle2Obj*) pObj, nVerb);
//STRIP001 			}
//STRIP001 #ifdef STARIMAGE_AVAILABLE
//STRIP001 			else if (nInv = SdrInventor && nSdrObjKind == OBJ_GRAF &&
//STRIP001 					 ((SdrGrafObj*) pObj)->GetGraphicType() == GRAPHIC_BITMAP &&
//STRIP001 					 SFX_APP()->HasFeature(SFX_FEATURE_SIMAGE))
//STRIP001 			{
//STRIP001 				SdrGrafObj* pSdrGrafObj = (SdrGrafObj*) pObj;
//STRIP001 				short nOK = RET_YES;
//STRIP001 
//STRIP001 				if ( pSdrGrafObj->GetFileName().Len() )
//STRIP001 				{
//STRIP001 					// Graphik ist gelinkt, soll der Link aufgehoben werden?
//STRIP001 					QueryBox aBox(pWindow, WB_YES_NO | WB_DEF_YES,
//STRIP001 								  String( SdResId(STR_REMOVE_LINK) ) );
//STRIP001 					nOK = aBox.Execute();
//STRIP001 
//STRIP001 					if (nOK == RET_YES)
//STRIP001 					{
//STRIP001 						// Link aufheben (File- und Filtername zuruecksetzen)
//STRIP001 						pSdrGrafObj->SetGraphicLink(String(), String());
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				if (nOK == RET_YES)
//STRIP001 				{
//STRIP001 					/**************************************************************
//STRIP001 					* OLE-Objekt erzeugen, StarImage starten
//STRIP001 					* Grafik-Objekt loeschen (durch OLE-Objekt ersetzt)
//STRIP001 					**************************************************************/
//STRIP001 					pDrView->HideMarkHdl(NULL);
//STRIP001 
//STRIP001 					SvStorageRef aStor = new SvStorage(String());
//STRIP001 					SvInPlaceObjectRef aNewIPObj = &((SvFactory*)SvInPlaceObject::ClassFactory())
//STRIP001 					->CreateAndInit(SimModuleDummy::GetID(SOFFICE_FILEFORMAT_CURRENT), aStor);
//STRIP001 					if ( aNewIPObj.Is() )
//STRIP001 					{
//STRIP001 						SdrGrafObj* pTempSdrGrafObj = (SdrGrafObj*) pSdrGrafObj->Clone ();
//STRIP001 
//STRIP001 						SvEmbeddedInfoObject * pInfo;
//STRIP001 						pInfo = GetViewFrame()->GetObjectShell()->
//STRIP001 									   InsertObject( aNewIPObj, String() );
//STRIP001 
//STRIP001 						String aName;
//STRIP001 						if (pInfo)
//STRIP001 						{
//STRIP001 							aName = pInfo->GetObjName();
//STRIP001 						}
//STRIP001 
//STRIP001 						Rectangle aRect = pObj->GetLogicRect();
//STRIP001 						SdrOle2Obj* pSdrOle2Obj = new SdrOle2Obj( aNewIPObj,
//STRIP001 																  aName, aRect );
//STRIP001 
//STRIP001 						SdrPageView* pPV = pDrView->GetPageViewPvNum(0);
//STRIP001 
//STRIP001 						pPV->GetObjList()->InsertObject( pSdrOle2Obj );
//STRIP001 						pDrView->ReplaceObject( pObj, *pPV, pTempSdrGrafObj );
//STRIP001 
//STRIP001 						pSdrOle2Obj->SetLogicRect(aRect);
//STRIP001 						aNewIPObj->SetVisAreaSize(aRect.GetSize());
//STRIP001 
//STRIP001 						SimDLL::Update(aNewIPObj, pTempSdrGrafObj->GetGraphic(), pWindow);
//STRIP001 						ActivateObject(pSdrOle2Obj, SVVERB_SHOW);
//STRIP001 
//STRIP001 						SdClient* pClient = (SdClient*) GetIPClient();
//STRIP001 
//STRIP001 						if (pClient)
//STRIP001 							pClient->SetSdrGrafObj( pTempSdrGrafObj );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 #endif
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }


/*************************************************************************
|*
|* OLE-Object aktivieren
|*
\************************************************************************/

//STRIP001 BOOL SdDrawViewShell::ActivateObject(SdrOle2Obj* pObj, long nVerb)
//STRIP001 {
//STRIP001 	BOOL bActivated = FALSE;
//STRIP001 
//STRIP001 	if ( !pDocSh->IsUIActive() )
//STRIP001 	{
//STRIP001 		bActivated = SdViewShell::ActivateObject(pObj, nVerb);
//STRIP001 
//STRIP001 		SdClient* pClient = (SdClient*) GetIPClient();
//STRIP001 
//STRIP001 		if (pClient)
//STRIP001 		{
//STRIP001 			pClient->SetSdrGrafObj(NULL);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return(bActivated);
//STRIP001 }

/*************************************************************************
|*
|* Auf gewuenschte Seite schalten
|* Der Parameter nSelectedPage bezieht sich auf den aktuellen EditMode
|*
\************************************************************************/

/*N*/ BOOL SdDrawViewShell::SwitchPage(USHORT nSelectedPage)
/*N*/ {
/*N*/ 	BOOL bOK = FALSE;
/*N*/ 
/*N*/ 	if (IsSwitchPageAllowed())
/*N*/ 	{
/*N*/ 		bOK = TRUE;
/*N*/ 
/*N*/ 		BOOL bIsChanged = pDoc->IsChanged();
/*N*/ 
/*N*/ 		if (pActualPage)
/*N*/ 		{
/*N*/  			SdPage* pNewPage = pDoc->GetSdPage(nSelectedPage, ePageKind);
/*N*/  
/*N*/  			if (pActualPage == pNewPage)
/*N*/  			{
/*N*/  				if (eEditMode == EM_MASTERPAGE)
/*N*/  				{
/*?*/ 					pNewPage = (SdPage*) pNewPage->GetMasterPage(0);
/*?*/ 				}
/*N*/  
/*N*/  				SdrPageView* pPV = pDrView->GetPageViewPvNum(0);
/*N*/  
/*N*/  				if (pPV && pNewPage == (SdPage*) pPV->GetPage() &&
/*N*/  					pNewPage->GetName() == aTabControl.GetPageText(nSelectedPage+1))
/*N*/  				{
/*N*/  					// Die Seite wird schon angezeigt
/*N*/  					return(TRUE);
/*N*/  				}
/*N*/  			}
/*N*/ 		}
/*N*/ 
/*N*/ 		pActualPage = NULL;
/*N*/ 
/*N*/ 		if (eEditMode == EM_PAGE)
/*N*/ 		{
/*N*/ 			pActualPage = pDoc->GetSdPage(nSelectedPage, ePageKind);
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
/*?*/ 			SdPage* pMaster = pDoc->GetMasterSdPage(nSelectedPage, ePageKind);
/*?*/ 
/*?*/ 			// Passt die selektierte Seite zur MasterPage?
/*?*/ 			USHORT nPageCount = pDoc->GetSdPageCount(ePageKind);
/*?*/ 			for (USHORT i = 0; i < nPageCount; i++)
/*?*/ 			{
/*?*/ 				SdPage* pPage = pDoc->GetSdPage(i, ePageKind);
/*?*/ 				if(pPage && pPage->IsSelected() && pPage->GetMasterPage(0) == pMaster)
/*?*/ 				{
/*?*/ 					pActualPage = pPage;
/*?*/ 					break;
/*?*/ 				}
/*?*/ 			}
/*?*/ 
/*?*/ 			if (!pActualPage)
/*?*/ 			{
/*?*/ 				// Die erste Seite nehmen, welche zur MasterPage passt
/*?*/ 				for (USHORT i = 0; i < nPageCount; i++)
/*?*/ 				{
/*?*/ 					SdPage* pPage = pDoc->GetSdPage(i, ePageKind);
/*?*/ 					if(pPage && pPage->GetMasterPage(0) == pMaster)
/*?*/ 					{
/*?*/ 						pActualPage = pPage;
/*?*/ 						break;
/*?*/ 					}
/*?*/ 				}
/*?*/ 			}
/*?*/ 		}

/*N*/ 		for (USHORT i = 0; i < pDoc->GetSdPageCount(ePageKind); i++)
/*N*/ 		{
/*N*/ 			// Alle Seiten deselektieren
/*N*/ 			pDoc->SetSelected( pDoc->GetSdPage(i, ePageKind), FALSE);
/*N*/ 		}
/*N*/ 
/*N*/ 		if (!pActualPage)
/*N*/ 		{
			// Sofern es keine pActualPage gibt, wird die erste genommen
/*?*/ 			pActualPage = pDoc->GetSdPage(0, ePageKind);
		}

		// diese Seite auch selektieren (pActualPage zeigt immer auf Zeichenseite,
		// nie auf eine Masterpage)
/*N*/ 		pDoc->SetSelected(pActualPage, TRUE);
/*N*/ 
/*N*/         if( !pFuSlideShow || ( pFuSlideShow->GetAnimationMode() != ANIMATIONMODE_SHOW ) )
/*N*/         {
    		// VisArea zuziehen, um ggf. Objekte zu deaktivieren
            // !!! only if we are not in presentation mode (#96279) !!!
/*N*/     		DisconnectAllClients();
/*N*/     		VisAreaChanged(Rectangle(Point(), Size(1, 1)));
/*N*/         }
/*N*/ 
/*N*/ 		if( pActualPage )
/*N*/ 			pActualPage->SetAutoLayout( pActualPage->GetAutoLayout() );
/*N*/ 
/*N*/ 		if (eEditMode == EM_PAGE)
/*N*/ 		{
			/**********************************************************************
			* PAGEMODE
			**********************************************************************/
/*N*/ 			pDoc->SetSelected(pActualPage, TRUE);
/*N*/ 
/*N*/ 			SdrPageView* pPageView = pDrView->GetPageViewPvNum(0);
/*N*/ 
/*N*/ 			if (pPageView)
/*N*/ 			{
/*N*/ 				pFrameView->SetVisibleLayers( pPageView->GetVisibleLayers() );
/*N*/ 				pFrameView->SetPrintableLayers( pPageView->GetPrintableLayers() );
/*N*/ 				pFrameView->SetLockedLayers( pPageView->GetLockedLayers() );
/*N*/ 
/*N*/ 				if (ePageKind == PK_NOTES)
/*N*/ 				{
/*?*/ 					pFrameView->SetNotesHelpLines( pPageView->GetHelpLines() );
/*N*/ 				}
/*N*/ 				else if (ePageKind == PK_HANDOUT)
/*N*/ 				{
/*?*/ 					pFrameView->SetHandoutHelpLines( pPageView->GetHelpLines() );
/*N*/ 				}
/*N*/ 				else
/*N*/ 				{
/*N*/ 					pFrameView->SetStandardHelpLines( pPageView->GetHelpLines() );
/*N*/ 				}
/*N*/ 			}
/*N*/ 
/*N*/ 			pDrView->HideAllPages();
/*N*/ 			pDrView->ShowPage(pActualPage, Point(0, 0));
/*N*/ 			if( pController )
/*?*/ 				pController->fireSwitchCurrentPage( pActualPage );
/*N*/ 
/*N*/ 			SdrPageView* pNewPageView = pDrView->GetPageViewPvNum(0);
/*N*/ 
/*N*/ 			if (pNewPageView)
/*N*/ 			{
/*N*/ 				pNewPageView->SetVisibleLayers( pFrameView->GetVisibleLayers() );
/*N*/ 				pNewPageView->SetPrintableLayers( pFrameView->GetPrintableLayers() );
/*N*/ 				pNewPageView->SetLockedLayers( pFrameView->GetLockedLayers() );
/*N*/ 
/*N*/ 				if (ePageKind == PK_NOTES)
/*N*/ 				{
/*N*/ 					pNewPageView->SetHelpLines( pFrameView->GetNotesHelpLines() );
/*N*/ 				}
/*N*/ 				else if (ePageKind == PK_HANDOUT)
/*N*/ 				{
/*N*/ 					pNewPageView->SetHelpLines( pFrameView->GetHandoutHelpLines() );
/*N*/ 				}
/*N*/ 				else
/*N*/ 				{
/*N*/ 					pNewPageView->SetHelpLines( pFrameView->GetStandardHelpLines() );
/*N*/ 				}
/*N*/ 			}
/*N*/ 
/*N*/ 			aTabControl.SetCurPageId(nSelectedPage+1);
/*N*/ 			String aPageName = pActualPage->GetName();
/*N*/ 
/*N*/ 			if (aTabControl.GetPageText(nSelectedPage+1) != aPageName)
/*N*/ 			{
/*?*/ 				aTabControl.SetPageText(nSelectedPage+1, aPageName);
/*?*/ 			}
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
			/**********************************************************************
			* MASTERPAGE
			**********************************************************************/
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 SdrPageView* pPageView = pDrView->GetPageViewPvNum(0);
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if (pPageView)
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				pFrameView->SetVisibleLayers( pPageView->GetVisibleLayers() );
//STRIP001 /*?*/ 				pFrameView->SetPrintableLayers( pPageView->GetPrintableLayers() );
//STRIP001 /*?*/ 				pFrameView->SetLockedLayers( pPageView->GetLockedLayers() );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				if (ePageKind == PK_NOTES)
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pFrameView->SetNotesHelpLines( pPageView->GetHelpLines() );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 				else if (ePageKind == PK_HANDOUT)
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pFrameView->SetHandoutHelpLines( pPageView->GetHelpLines() );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 				else
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pFrameView->SetStandardHelpLines( pPageView->GetHelpLines() );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			pDrView->HideAllPages();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			SdPage* pMaster = pDoc->GetMasterSdPage(nSelectedPage, ePageKind);
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( !pMaster )              // Falls es diese Page nicht geben sollte
//STRIP001 /*?*/ 				pMaster = pDoc->GetMasterSdPage(0, ePageKind);
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			USHORT nNum = pMaster->GetPageNum();
//STRIP001 /*?*/ 			pDrView->ShowMasterPagePgNum(nNum, Point(0, 0));
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( pController )
//STRIP001 /*?*/ 				pController->fireSwitchCurrentPage( pMaster );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			SdrPageView* pNewPageView = pDrView->GetPageViewPvNum(0);
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if (pNewPageView)
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				pNewPageView->SetVisibleLayers( pFrameView->GetVisibleLayers() );
//STRIP001 /*?*/ 				pNewPageView->SetPrintableLayers( pFrameView->GetPrintableLayers() );
//STRIP001 /*?*/ 				pNewPageView->SetLockedLayers( pFrameView->GetLockedLayers() );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				if (ePageKind == PK_NOTES)
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pNewPageView->SetHelpLines( pFrameView->GetNotesHelpLines() );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 				else if (ePageKind == PK_HANDOUT)
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pNewPageView->SetHelpLines( pFrameView->GetHandoutHelpLines() );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 				else
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pNewPageView->SetHelpLines( pFrameView->GetStandardHelpLines() );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			String aLayoutName(pMaster->GetLayoutName());
//STRIP001 /*?*/ 			aLayoutName.Erase(aLayoutName.SearchAscii(SD_LT_SEPARATOR));
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			aTabControl.SetCurPageId(nSelectedPage+1);
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if (aTabControl.GetPageText(nSelectedPage+1) != aLayoutName)
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				aTabControl.SetPageText(nSelectedPage+1, aLayoutName);
//STRIP001 /*?*/ 			}
/*N*/ 		}

/*N*/ 		Size aVisSizePixel = pWindow->GetOutputSizePixel();
/*N*/ 		Rectangle aVisAreaWin = pWindow->PixelToLogic( Rectangle( Point(0,0), aVisSizePixel) );
/*N*/ 		VisAreaChanged(aVisAreaWin);
/*N*/ 		pDrView->VisAreaChanged(pWindow);
/*N*/ 
/*N*/ 		// Damit der Navigator (und das Effekte-Window) das mitbekommt (/-men)
/*N*/ 		SfxBindings& rBindings = GetViewFrame()->GetBindings();
/*N*/ 		rBindings.Invalidate(SID_NAVIGATOR_PAGENAME, TRUE, FALSE);
/*N*/ 		rBindings.Invalidate(SID_EFFECT_STATE, TRUE, FALSE);
/*N*/ 		rBindings.Invalidate(SID_STATUS_PAGE, TRUE, FALSE);
/*N*/ 		UpdateSlideChangeWindow();
/*N*/ 		UpdatePreview( pActualPage );
/*N*/ 
/*N*/ 		if (pDrView->GetSlideShow())
/*N*/ 		{
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 pDrView->SetAnimationMode(TRUE);
/*?*/ 		}
/*N*/ 
/*N*/ 		pDoc->SetChanged(bIsChanged);
/*N*/ 	}
/*N*/ 
/*N*/ 	return (bOK);
/*N*/ }


/*************************************************************************
|*
|* Pruefen, ob ein Seitenwechsel erlaubt ist
|*
\************************************************************************/

/*N*/ BOOL SdDrawViewShell::IsSwitchPageAllowed() const
/*N*/ {
/*N*/ 	BOOL bOK = TRUE;
/*N*/ 
/*N*/ 	FmFormShell* pShell = (FmFormShell*) aShellTable.Get(RID_FORMLAYER_TOOLBOX);
/*N*/ 
/*N*/ 	if (pShell && !pShell->PrepareClose(FALSE))
/*N*/ 	{
/*N*/ 		bOK = FALSE;
/*N*/ 	}
/*N*/ 
/*N*/ 	return( bOK && !bInEffectAssignment );
/*N*/ }

/*************************************************************************
|*
|* neue aktuelle Seite auswaehlen, falls sich die Seitenfolge geaendert
|* hat (z. B. durch Undo)
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::ResetActualLayer()
/*N*/ {
/*N*/ 	// remember old layer cound and current layer id
/*N*/ 	// this is needed when one layer is renamed to
/*N*/ 	// restore current layer
/*N*/ 	USHORT nOldLayerCnt = aLayerTab.GetPageCount();
/*N*/ 	USHORT nOldLayerId = aLayerTab.GetCurPageId();

	/*************************************************************
	* Update fuer LayerTab
	*************************************************************/
/*N*/ 	aLayerTab.Clear();
/*N*/ 
/*N*/ 	String aName;
/*N*/ 	String aActiveLayer = pDrView->GetActiveLayer();
/*N*/ 	String aBackgroundLayer( SdResId(STR_LAYER_BCKGRND) );
/*N*/ 	String aBackgroundObjLayer( SdResId(STR_LAYER_BCKGRNDOBJ) );
/*N*/ 	String aLayoutLayer( SdResId(STR_LAYER_LAYOUT) );
/*N*/ 	String aControlsLayer( SdResId(STR_LAYER_CONTROLS) );
/*N*/ 	String aMeasureLinesLayer( SdResId(STR_LAYER_MEASURELINES) );
/*N*/ 	USHORT nNewLayer = 0;
/*N*/ 	USHORT nActiveLayer = SDRLAYER_NOTFOUND;
/*N*/ 	SdrLayerAdmin& rLayerAdmin = pDoc->GetLayerAdmin();
/*N*/ 	USHORT nLayerCnt = rLayerAdmin.GetLayerCount();
/*N*/ 
/*N*/ 	for ( USHORT nLayer = 0; nLayer < nLayerCnt; nLayer++ )
/*N*/ 	{
/*N*/ 		aName = rLayerAdmin.GetLayer(nLayer)->GetName();
/*N*/ 
/*N*/ 		if ( aName == aActiveLayer )
/*N*/ 		{
/*N*/ 			nActiveLayer = nLayer;
/*N*/ 		}
/*N*/ 
/*N*/ 		if ( aName != aBackgroundLayer )
/*N*/ 		{
/*N*/ 			if (eEditMode == EM_MASTERPAGE)
/*?*/ 			{
/*?*/ 				// Layer der Page nicht auf MasterPage anzeigen
/*?*/ 				if (aName != aLayoutLayer   &&
/*?*/ 					aName != aControlsLayer &&
/*?*/ 					aName != aMeasureLinesLayer)
/*?*/ 				{
/*?*/ 					aLayerTab.InsertPage(nLayer+1, aName);
/*?*/ 
/*?*/ 					TabBarPageBits nBits = 0;
/*?*/ 					SdrPageView* pPV = pDrView->GetPageViewPvNum(0);
/*?*/ 
/*?*/ 					if (pPV && !pPV->IsLayerVisible(aName))
/*?*/ 					{
/*?*/ 						// Unsichtbare Layer werden anders dargestellt
/*?*/ 						nBits = TPB_SPECIAL;
/*?*/ 					}
/*?*/ 
/*?*/ 					aLayerTab.SetPageBits(nLayer+1, nBits);
/*?*/ 				}
/*?*/ 			}
/*N*/ 			else
/*N*/ 			{
/*N*/ 				// Layer der MasterPage nicht auf Page anzeigen
/*N*/ 				if ( aName != aBackgroundObjLayer )
/*N*/ 				{
/*N*/ 					aLayerTab.InsertPage(nLayer+1, aName);
/*N*/ 
/*N*/ 					TabBarPageBits nBits = 0;
/*N*/ 
/*N*/ 					if (!pDrView->GetPageViewPvNum(0)->IsLayerVisible(aName))
/*N*/ 					{
/*N*/ 						// Unsichtbare Layer werden anders dargestellt
/*N*/ 						nBits = TPB_SPECIAL;
/*N*/ 					}
/*N*/ 
/*N*/ 					aLayerTab.SetPageBits(nLayer+1, nBits);
/*N*/ 				}
/*N*/ 			}
/*N*/ 		}
/*N*/ 	}

/*N*/ 	if ( nActiveLayer == SDRLAYER_NOTFOUND )
/*N*/ 	{
/*N*/ 		if( nOldLayerCnt == aLayerTab.GetPageCount() )
/*N*/ 		{
/*N*/ 			nActiveLayer = nOldLayerId - 1;
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
/*N*/ 			nActiveLayer = ( eEditMode == EM_MASTERPAGE ) ? 2 : 0;
/*N*/ 		}
/*N*/ 
/*N*/ 		pDrView->SetActiveLayer( aLayerTab.GetPageText(nActiveLayer + 1) );
/*N*/ 	}
/*N*/ 
/*N*/ 	aLayerTab.SetCurPageId(nActiveLayer + 1);
/*N*/ 	GetViewFrame()->GetBindings().Invalidate( SID_MODIFYLAYER );
/*N*/ }

/*************************************************************************
|*
|* Verzoegertes Close ausfuehren
|*
\************************************************************************/

//STRIP001 IMPL_LINK( SdDrawViewShell, CloseHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	pTimer->Stop();
//STRIP001 	GetViewFrame()->GetBindings().Execute( SID_CLOSEWIN );
//STRIP001 	return 0L;
//STRIP001 }

/*************************************************************************
|*
|* Setzt die HelpId in Abhaengigkeit von der Selektion
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::SetHelpIdBySelection()
//STRIP001 {
//STRIP001 	UINT32 nHelpId = 0;
//STRIP001 	const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() > 0 )
//STRIP001 	{
//STRIP001 		SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 		UINT32 nInventor = pObj->GetObjInventor();
//STRIP001 		UINT16 nObjId = pObj->GetObjIdentifier();
//STRIP001 
//STRIP001 		if( nInventor == SdrInventor)
//STRIP001 		{
//STRIP001 			switch ( nObjId )
//STRIP001 			{
//STRIP001 				case OBJ_LINE:
//STRIP001 					// Alle Linien
//STRIP001 					nHelpId = SID_DRAWTBX_LINES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_RECT:
//STRIP001 					// Gefuellt:   Rechteck, Quadrat, Rechteck abgerundet, Quadrat abgerundet
//STRIP001 					// Ungefuellt: Rechteck, Quadrat, Rechteck abgerundet, Quadrat abgerundet
//STRIP001 					nHelpId = SID_DRAWTBX_RECTANGLES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_CIRC:
//STRIP001 					// Gefuellt:   Ellipse, Kreis
//STRIP001 					// Ungefuellt: Ellipse, Kreis
//STRIP001 					nHelpId = SID_DRAWTBX_ELLIPSES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_SECT:
//STRIP001 					// Gefuellt:   Ellipsensektor, Kreissektor
//STRIP001 					// Ungefuellt: Ellipsensektor, Kreissektor
//STRIP001 					nHelpId = SID_DRAWTBX_ELLIPSES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_CARC:
//STRIP001 					// Ellipsenbogen, Kreisbogen
//STRIP001 					nHelpId = SID_DRAWTBX_ELLIPSES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_CCUT:
//STRIP001 					// Gefuellt:   Ellipsensegment, Kreissegment
//STRIP001 					// Ungefuellt: Ellipsensegment, Kreissegment
//STRIP001 					nHelpId = SID_DRAWTBX_ELLIPSES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_POLY:
//STRIP001 					// Gefuellt: Polygon, Polygon 45
//STRIP001 					nHelpId = SID_DRAWTBX_LINES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_PLIN:
//STRIP001 					// Ungefuellt: Polygon, Polygon 45
//STRIP001 					nHelpId = SID_DRAWTBX_LINES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_PATHLINE:
//STRIP001 					// Ungefuellt: Kurve, Freihandlinie
//STRIP001 					nHelpId = SID_DRAWTBX_LINES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_PATHFILL:
//STRIP001 					// Gefuellt: Kurve, Freihandlinie
//STRIP001 					nHelpId = SID_DRAWTBX_LINES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_TEXT:
//STRIP001 					// Text, Text an Rahmen
//STRIP001 					nHelpId = SID_DRAWTBX_TEXT;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_TITLETEXT:
//STRIP001 					nHelpId = SID_DRAWTBX_TEXT;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_OUTLINETEXT:
//STRIP001 					nHelpId = SID_DRAWTBX_TEXT;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_GRAF:
//STRIP001 					// Graphik
//STRIP001 					nHelpId = 0;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_OLE2:
//STRIP001 					// OLE
//STRIP001 					nHelpId = 0;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_EDGE:
//STRIP001 					// Alle Verbinder
//STRIP001 					nHelpId = SID_DRAWTBX_CONNECTORS;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_CAPTION:
//STRIP001 					// Legende
//STRIP001 					nHelpId = SID_DRAWTBX_TEXT;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_PAGE:
//STRIP001 					// Seitendarstellungsobjekt
//STRIP001 					nHelpId = 0;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_MEASURE:
//STRIP001 					// Masslinie
//STRIP001 					nHelpId = SID_DRAWTBX_LINES;
//STRIP001 				break;
//STRIP001 
//STRIP001 				case OBJ_UNO:
//STRIP001 					// UNO
//STRIP001 					nHelpId = 0;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( nInventor == E3dInventor)
//STRIP001 		{
//STRIP001 			// Alle 3D-Objekte
//STRIP001 			nHelpId = SID_DRAWTBX_3D_OBJECTS;
//STRIP001 		}
//STRIP001 		else if( nInventor == FmFormInventor)
//STRIP001 		{
//STRIP001 			// Alle FormControls
//STRIP001 			nHelpId = HID_FM_CTL_SELECTION;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* AcceptDrop
|*
\************************************************************************/

//STRIP001 sal_Int8 SdDrawViewShell::AcceptDrop( const AcceptDropEvent& rEvt, DropTargetHelper& rTargetHelper,
//STRIP001                                       SdWindow* pTargetWindow, USHORT nPage, USHORT nLayer )
//STRIP001 {
//STRIP001 	if( nPage != SDRPAGE_NOTFOUND )
//STRIP001 		nPage = pDoc->GetSdPage( nPage, ePageKind )->GetPageNum();
//STRIP001 
//STRIP001 	if( pFuSlideShow )
//STRIP001 	{
//STRIP001 		if( !pFuSlideShow->IsLivePresentation() )
//STRIP001 		{
//STRIP001 			return DND_ACTION_NONE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pDrView->AcceptDrop( rEvt, rTargetHelper, pTargetWindow, nPage, nLayer );
//STRIP001 }

/*************************************************************************
|*
|* ExecuteDrop
|*
\************************************************************************/

//STRIP001 sal_Int8 SdDrawViewShell::ExecuteDrop( const ExecuteDropEvent& rEvt, DropTargetHelper& rTargetHelper,
//STRIP001                                        SdWindow* pTargetWindow, USHORT nPage, USHORT nLayer )
//STRIP001 {
//STRIP001 	if( nPage != SDRPAGE_NOTFOUND )
//STRIP001 		nPage = pDoc->GetSdPage( nPage, ePageKind )->GetPageNum();
//STRIP001 
//STRIP001 	if( pFuSlideShow )
//STRIP001 	{
//STRIP001 		if( !pFuSlideShow->IsLivePresentation() )
//STRIP001 		{
//STRIP001 			return DND_ACTION_NONE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pDrView->ExecuteDrop( rEvt, rTargetHelper, pTargetWindow, nPage, nLayer );
//STRIP001 }

#ifdef WNT
#pragma optimize ( "", on )
#endif
    
}
