/*************************************************************************
 *
 *  $RCSfile: sd_drviewsg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:15:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
// auto strip #ifndef _IMAPDLG_HXX
// auto strip #include <bf_svx/imapdlg.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOOLE2_HXX //autogen
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #endif

#pragma hdrstop

#include "app.hrc"

// auto strip #include "drviewsh.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "fuslshow.hxx"
// auto strip #include "imapinfo.hxx"
// auto strip #include "sdmod.hxx"
// auto strip #include "optsitem.hxx"
// auto strip #include "frmview.hxx"
// auto strip #include "drawview.hxx"
namespace binfilter {


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::ExecIMap( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	// waehrend einer Diashow wird nichts ausgefuehrt!
//STRIP001 	if (pFuActual && pFuActual->GetSlotID() == SID_PRESENTATION)
//STRIP001 		return;
//STRIP001 
//STRIP001 	if ( rReq.GetSlot() == SID_IMAP_EXEC )
//STRIP001 	{
//STRIP001 		SdrMark* pMark = pDrView->GetMarkList().GetMark(0);
//STRIP001 
//STRIP001 		if ( pMark )
//STRIP001 		{
//STRIP001 			SdrObject*	pSdrObj = pMark->GetObj();
//STRIP001 			SvxIMapDlg* pDlg = SVXIMAPDLG();
//STRIP001 
//STRIP001 			if ( pDlg->GetEditingObject() == (void*) pSdrObj )
//STRIP001 			{
//STRIP001 				const ImageMap& rImageMap = pDlg->GetImageMap();
//STRIP001 				SdIMapInfo* 	pIMapInfo = pDoc->GetIMapInfo( pSdrObj );
//STRIP001 
//STRIP001 				if ( !pIMapInfo )
//STRIP001 					pSdrObj->InsertUserData( new SdIMapInfo( rImageMap ) );
//STRIP001 				else
//STRIP001 					pIMapInfo->SetImageMap( rImageMap );
//STRIP001 
//STRIP001                 pDoc->SetChanged( sal_True );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdDrawViewShell::GetIMapState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	BOOL bDisable = TRUE;
//STRIP001 
//STRIP001 	if( GetViewFrame()->HasChildWindow( SvxIMapDlgChildWindow::GetChildWindowId() ) )
//STRIP001 	{
//STRIP001 		const SdrMarkList&	rMarkList = pDrView->GetMarkList();
//STRIP001 		const SdrObject*	pObj = NULL;
//STRIP001 		ULONG				nMarkCount = rMarkList.GetMarkCount();
//STRIP001 
//STRIP001 		if ( nMarkCount == 1 )
//STRIP001 		{
//STRIP001 			pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 			if ( ( pObj->ISA( SdrGrafObj ) || pObj->ISA( SdrOle2Obj ) ) &&
//STRIP001 				 ( SVXIMAPDLG()->GetEditingObject() == (void*) pObj ) )
//STRIP001 			{
//STRIP001 				bDisable = FALSE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	rSet.Put( SfxBoolItem( SID_IMAP_EXEC, bDisable ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Execute-Methode der Optionsleiste
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdDrawViewShell::ExecOptionsBar( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	// waehrend einer Diashow wird nichts ausgefuehrt!
//STRIP001 	if (pFuActual && pFuActual->GetSlotID() == SID_PRESENTATION)
//STRIP001 		return;
//STRIP001 
//STRIP001 	BOOL   bDefault = FALSE;
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	FrameView* pFrameView = GetFrameView();
//STRIP001 
//STRIP001 	SdOptions* pOptions = SD_MOD()->GetSdOptions(pDoc->GetDocumentType());
//STRIP001 
//STRIP001 	switch( nSlot )
//STRIP001 	{
//STRIP001 		// Ersatzdarstellung-Optionen
//STRIP001 		case SID_GRAPHIC_DRAFT:
//STRIP001 			pOptions->SetExternGraphic( !pDrView->IsGrafDraft() );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_FILL_DRAFT:
//STRIP001 			pOptions->SetOutlineMode( !pDrView->IsFillDraft() );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_TEXT_DRAFT:
//STRIP001 			pOptions->SetNoText( !pDrView->IsTextDraft() );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_LINE_DRAFT:
//STRIP001 			pOptions->SetHairlineMode( !pDrView->IsLineDraft() );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_HANDLES_DRAFT:
//STRIP001 			pOptions->SetSolidMarkHdl( !pDrView->IsSolidMarkHdl() );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_SOLID_CREATE:
//STRIP001 			pOptions->SetSolidDragging( !pDrView->IsSolidDragging() );
//STRIP001 		break;
//STRIP001 
//STRIP001 
//STRIP001 		// Raster- / Hilfslinien-Optionen
//STRIP001 		case SID_GRID_VISIBLE: // noch nicht hier !
//STRIP001 		{
//STRIP001 			pOptions->SetGridVisible( !pDrView->IsGridVisible() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GRID_USE:
//STRIP001 		{
//STRIP001 			pOptions->SetUseGridSnap( !pDrView->IsGridSnap() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_HELPLINES_VISIBLE: // noch nicht hier !
//STRIP001 		{
//STRIP001 			pOptions->SetHelplines( !pDrView->IsHlplVisible() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_HELPLINES_USE:
//STRIP001 		{
//STRIP001 			pOptions->SetSnapHelplines( !pDrView->IsHlplSnap() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_HELPLINES_MOVE:
//STRIP001 		{
//STRIP001 			pOptions->SetDragStripes( !pDrView->IsDragStripes() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 
//STRIP001 		case SID_SNAP_BORDER:
//STRIP001 		{
//STRIP001 			pOptions->SetSnapBorder( !pDrView->IsBordSnap() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_SNAP_FRAME:
//STRIP001 		{
//STRIP001 			pOptions->SetSnapFrame( !pDrView->IsOFrmSnap() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_SNAP_POINTS:
//STRIP001 		{
//STRIP001 			pOptions->SetSnapPoints( !pDrView->IsOPntSnap() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 
//STRIP001 		case SID_QUICKEDIT:
//STRIP001 		{
//STRIP001 			pOptions->SetQuickEdit( !pDrView->IsQuickTextEditMode() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_PICK_THROUGH:
//STRIP001 		{
//STRIP001 			pOptions->SetPickThrough(
//STRIP001 				!pDrView->GetModel()->IsPickThroughTransparentTextFrames() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_BIG_HANDLES:
//STRIP001 		{
//STRIP001 			pOptions->SetBigHandles( !pFrameView->IsBigHandles() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DOUBLECLICK_TEXTEDIT:
//STRIP001 		{
//STRIP001 			pOptions->SetDoubleClickTextEdit( !pFrameView->IsDoubleClickTextEdit() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_CLICK_CHANGE_ROTATION:
//STRIP001 		{
//STRIP001 			pOptions->SetClickChangeRotation( !pFrameView->IsClickChangeRotation() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			bDefault = TRUE;
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !bDefault )
//STRIP001 	{
//STRIP001 		pOptions->StoreConfig();
//STRIP001 
//STRIP001 		// Speichert die Konfiguration SOFORT
//STRIP001 		// SFX_APP()->SaveConfiguration();
//STRIP001 		WriteFrameViewData();
//STRIP001 
//STRIP001 		//FrameView* pFrameView = pViewShell->GetFrameView(); schon oben
//STRIP001 		pFrameView->Update( pOptions );
//STRIP001 		ReadFrameViewData( pFrameView );
//STRIP001 
//STRIP001 		Invalidate( nSlot );
//STRIP001 		rReq.Done();
//STRIP001 	}
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	State-Methode der Optionsleiste
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdDrawViewShell::GetOptionsBarState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	FrameView* pFrameView = GetFrameView();
//STRIP001 
//STRIP001 	rSet.Put( SfxBoolItem( SID_GRAPHIC_DRAFT, pDrView->IsGrafDraft() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_FILL_DRAFT, pDrView->IsFillDraft() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_TEXT_DRAFT, pDrView->IsTextDraft() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_LINE_DRAFT, pDrView->IsLineDraft() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_HANDLES_DRAFT, !pDrView->IsSolidMarkHdl() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_SOLID_CREATE, pDrView->IsSolidDragging() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_GRID_VISIBLE, pDrView->IsGridVisible() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_GRID_USE, pDrView->IsGridSnap() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_HELPLINES_VISIBLE, pDrView->IsHlplVisible() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_HELPLINES_USE, pDrView->IsHlplSnap() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_HELPLINES_MOVE, pDrView->IsDragStripes() ) );
//STRIP001 
//STRIP001 	rSet.Put( SfxBoolItem( SID_SNAP_BORDER, pDrView->IsBordSnap() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_SNAP_FRAME, pDrView->IsOFrmSnap() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_SNAP_POINTS, pDrView->IsOPntSnap() ) );
//STRIP001 
//STRIP001 	rSet.Put( SfxBoolItem( SID_QUICKEDIT, pDrView->IsQuickTextEditMode() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_PICK_THROUGH,
//STRIP001 				pDrView->GetModel()->IsPickThroughTransparentTextFrames() ) );
//STRIP001 
//STRIP001 	rSet.Put( SfxBoolItem( SID_BIG_HANDLES, pFrameView->IsBigHandles() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_DOUBLECLICK_TEXTEDIT, pFrameView->IsDoubleClickTextEdit() ) );
//STRIP001 	rSet.Put( SfxBoolItem( SID_CLICK_CHANGE_ROTATION, pFrameView->IsClickChangeRotation() ) );
//STRIP001 }



}
