/*************************************************************************
 *
 *  $RCSfile: sfx2_eventdlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:42:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ***************************************************************

// auto strip #ifndef _SVEDIT_HXX //autogen
// auto strip #include <svtools/svmedit.hxx>
// auto strip #endif
#pragma hdrstop

// auto strip #include "eventdlg.hxx"

#include "eventdlg.hrc"
#include "sfxresid.hxx"
// auto strip #include "evntconf.hxx"
// auto strip #include "macrconf.hxx"
// auto strip #include "minfitem.hxx"
// auto strip #include "app.hxx"
// auto strip #include "objsh.hxx"
// auto strip #include "objshimp.hxx"
// auto strip #include "cfg.hxx"
// auto strip #include "docfac.hxx"
// auto strip #include "fcontnr.hxx"

// auto strip #ifndef _HEADERTABLISTBOX_HXX
// auto strip #include "headertablistbox.hxx"
// auto strip #endif
// auto strip #ifndef _MACROPG_IMPL_HXX
// auto strip #include "macropg_impl.hxx"
// auto strip #endif
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 SfxEventConfigPage::SfxEventConfigPage( Window* pParent, const SfxItemSet& rSet ) :
//STRIP001 
//STRIP001 	_SfxMacroTabPage( pParent, SfxResId(TP_CONFIG_EVENT), rSet ),
//STRIP001 
//STRIP001 	aStarOfficeRB		( this, ResId( RB_STAROFFICE ) ),
//STRIP001 	aDocumentRB			( this, ResId( RB_DOCUMENT ) ),
//STRIP001 
//STRIP001 	pAppItem	( NULL ),
//STRIP001 	pDocItem	( NULL ),
//STRIP001 	bAppConfig	( TRUE )
//STRIP001 {
//STRIP001 	mpImpl->pStrEvent			= new String( SfxResId( STR_EVENT ) );
//STRIP001 	mpImpl->pAssignedMacro		= new String( SfxResId( STR_ASSMACRO ) );
//STRIP001 	mpImpl->pEventLB			= new _HeaderTabListBox( this, SfxResId( LB_EVENT ) );
//STRIP001 	mpImpl->pAssignPB			= new PushButton( this, SfxResId( PB_ASSIGN ) );
//STRIP001 	mpImpl->pDeletePB			= new PushButton( this, SfxResId( PB_DELETE ) );
//STRIP001 	mpImpl->pScriptTypeLB		= new ListBox( this, SfxResId( LB_SCRIPTTYPE ) );
//STRIP001     mpImpl->pMacroFT			= new FixedText( this, SfxResId( FT_MACRO ) );
//STRIP001 	mpImpl->pGroupLB			= new SfxConfigGroupListBox_Impl( this, SfxResId( LB_GROUP ) );
//STRIP001 	mpImpl->pFT_MacroLBLabel	= new FixedText( this, SfxResId( FT_LABEL4LB_MACROS ) );
//STRIP001 	mpImpl->pMacroLB			= new SfxConfigFunctionListBox_Impl( this, SfxResId( LB_MACROS ) );
//STRIP001 	mpImpl->pMacroStr			= new String( SfxResId( STR_MACROS ) );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001     mpImpl->pScriptTypeLB->Hide();
//STRIP001 
//STRIP001 	Link aLink = LINK( this, SfxEventConfigPage, SelectHdl_Impl );
//STRIP001 	aStarOfficeRB.SetClickHdl( aLink );
//STRIP001 	aDocumentRB.SetClickHdl( aLink );
//STRIP001 
//STRIP001 	InitAndSetHandler();
//STRIP001 	SfxEventConfiguration *pEvCfg = SFX_APP()->GetEventConfig();
//STRIP001 	pEvCfg->AddEvents( (SfxMacroTabPage*) this );
//STRIP001 
//STRIP001 	pAppItem = new SvxMacroItem;
//STRIP001 	pAppItem->SetMacroTable( *pEvCfg->GetAppEventTable() );
//STRIP001 	if ( SfxObjectShell::Current() )
//STRIP001 	{
//STRIP001 		pDocItem = new SvxMacroItem;
//STRIP001 		SvxMacroTableDtor* pTable = pEvCfg->GetDocEventTable( SfxObjectShell::Current() );
//STRIP001 		if ( !pTable )
//STRIP001 			pTable = new SvxMacroTableDtor( 2,2 );
//STRIP001 		pDocItem->SetMacroTable( *pTable );
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bEnable = ( pDocItem != NULL && SfxObjectShell::Current()->Get_Impl()->bSupportsEventMacros );
//STRIP001 	if ( !SfxObjectShell::Current()->GetFactory().GetFilterContainer()->GetFilterCount() )
//STRIP001 		bEnable = FALSE;
//STRIP001 
//STRIP001 	aDocumentRB.Enable( bEnable );
//STRIP001 	if ( bEnable )
//STRIP001 		aDocumentRB.Check();
//STRIP001 	else
//STRIP001 		aStarOfficeRB.Check();
//STRIP001 
//STRIP001 	((SfxItemSet&)rSet).Put( *pAppItem );
//STRIP001     ScriptChanged( String(SfxResId(STR_BASICNAME)));
//STRIP001 	SelectHdl_Impl( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxEventConfigPage::~SfxEventConfigPage()
//STRIP001 {
//STRIP001 	delete pAppItem;
//STRIP001 	delete pDocItem;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SfxEventConfigPage, SelectHdl_Impl, RadioButton *, pBtn )
//STRIP001 {
//STRIP001 	BOOL bApp = aStarOfficeRB.IsChecked();
//STRIP001 	if ( bApp == bAppConfig )
//STRIP001 		return TRUE;
//STRIP001 
//STRIP001 	if ( pBtn )
//STRIP001 	{
//STRIP001 		// Zuerst die bisher konfigurierten Events auslesen
//STRIP001 		SfxItemSet aSet( SFX_APP()->GetPool(), SID_ATTR_MACROITEM, SID_ATTR_MACROITEM );
//STRIP001 		if ( _SfxMacroTabPage::FillItemSet( aSet ) )
//STRIP001 		{
//STRIP001 			const SfxPoolItem* pItem;
//STRIP001 			SfxItemState eState = aSet.GetItemState( SID_ATTR_MACROITEM, FALSE, &pItem );
//STRIP001 			if ( eState == SFX_ITEM_SET )
//STRIP001 			{
//STRIP001 				// Es wurde etwas ver"andert
//STRIP001 				if ( bApp )
//STRIP001 				{
//STRIP001 					// Ver"anderte Doc-Config merken
//STRIP001 					delete pDocItem;
//STRIP001 					pDocItem = (SvxMacroItem*) pItem->Clone();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					// Ver"anderte App-Config merken
//STRIP001 					delete pAppItem;
//STRIP001 					pAppItem = (SvxMacroItem*) pItem->Clone();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 				DBG_ERROR( "FillItemSet returned TRUE, aber kein Item!" );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Die aktuelle Konfiguration in den Dialog einbringen
//STRIP001 	mpImpl->pEventLB->SetUpdateMode( FALSE );
//STRIP001 	bAppConfig = bApp;
//STRIP001 	if ( bApp )
//STRIP001 	{
//STRIP001 		SetReadOnly( FALSE );
//STRIP001 		((SfxItemSet&)GetItemSet()).Put( *pAppItem );
//STRIP001 		_SfxMacroTabPage::Reset( GetItemSet() );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SetReadOnly( SfxObjectShell::Current()->IsReadOnly() );
//STRIP001 		((SfxItemSet&)GetItemSet()).Put( *pDocItem );
//STRIP001 		_SfxMacroTabPage::Reset( GetItemSet() );
//STRIP001 	}
//STRIP001 
//STRIP001 	mpImpl->pEventLB->SetUpdateMode( TRUE );
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SfxEventConfigPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001     BOOL bRet = FALSE;
//STRIP001     SfxEventConfiguration *pEC = SFX_APP()->GetEventConfig();
//STRIP001 	if ( _SfxMacroTabPage::FillItemSet( rSet ) )
//STRIP001 	{
//STRIP001 		const SfxPoolItem *pItem;
//STRIP001 		SfxItemState eState = rSet.GetItemState( SID_ATTR_MACROITEM, FALSE, &pItem );
//STRIP001 		if ( eState == SFX_ITEM_SET )
//STRIP001 		{
//STRIP001 			if ( bAppConfig )
//STRIP001 			{
//STRIP001 				// Ver"anderte App-Config merken
//STRIP001 				delete pAppItem;
//STRIP001 				pAppItem = (SvxMacroItem*) pItem->Clone();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// Ver"anderte Doc-Config merken
//STRIP001 				delete pDocItem;
//STRIP001 				pDocItem = (SvxMacroItem*) pItem->Clone();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( ! ( pAppItem->GetMacroTable() == (*pEC->GetAppEventTable()) ) )
//STRIP001 	{
//STRIP001 		bRet = TRUE;
//STRIP001 		pEC->SetAppEventTable( pAppItem->GetMacroTable() );
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxObjectShell *pDoc = SfxObjectShell::Current();
//STRIP001 	if ( pDoc )
//STRIP001 	{
//STRIP001 		SvxMacroTableDtor *pTable = pEC->GetDocEventTable(pDoc);
//STRIP001 		if ( !pTable && pDocItem->GetMacroTable().Count() || pTable &&
//STRIP001 			! ( pDocItem->GetMacroTable() == (*pTable) ) )
//STRIP001 		{
//STRIP001 			bRet = TRUE;
//STRIP001 			pEC->SetDocEventTable( pDoc, pDocItem->GetMacroTable() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxEventConfigPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	_SfxMacroTabPage::Reset( rSet );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxEventConfigPage::SelectMacro(const SfxMacroInfoItem *pItem)
//STRIP001 {
//STRIP001 	mpImpl->pGroupLB->SelectMacro( pItem );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxEventConfigPage::SelectMacro( const SvxMacro *pMacro )
//STRIP001 {
//STRIP001 	// Macro und dazugeh"origes BASIC selektieren
//STRIP001 	String aBasic( pMacro->GetLibName() );
//STRIP001 	String aMacro( pMacro->GetMacName() );
//STRIP001 	mpImpl->pGroupLB->SelectMacro( aBasic, aMacro );
//STRIP001 }

}
