/*************************************************************************
 *
 *  $RCSfile: sfx2_mailwindow.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:44:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes --------------------------------------------------------------

// auto strip #include "mailwindow.hxx"
// auto strip #include <mailmodel.hxx>
#if SUPD<613//MUSTINI
// auto strip #include "inimgr.hxx"
#endif
// auto strip #include "sfxtypes.hxx"
// auto strip #include "sfxresid.hxx"
// auto strip #include "bindings.hxx"
#include "sfxsids.hrc"
#include "mailwindow.hrc"
#include "dialog.hrc"

// auto strip #include <vcl/msgbox.hxx>	// InfoBox
namespace binfilter {
//#include <svtools/useroptions.hxx>

// class AddressEdit_Impl ------------------------------------------------

//STRIP001 AddressEdit_Impl::AddressEdit_Impl( MailWindow_Impl* pWin, const ResId& rResId ) :
//STRIP001 
//STRIP001 	Edit( pWin, rResId ),
//STRIP001 
//STRIP001 	mpWindow( pWin )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void AddressEdit_Impl::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001 	switch ( rKEvt.GetKeyCode().GetCode() )
//STRIP001 	{
//STRIP001 		case KEY_RETURN:
//STRIP001 			mpWindow->ReceiveAddress();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case KEY_ESCAPE:
//STRIP001 			mpWindow->ClearAddress();
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			Edit::KeyInput( rKEvt );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // class AddressListBox_Impl ---------------------------------------------
//STRIP001 
//STRIP001 AddressListBox_Impl::AddressListBox_Impl( MailWindow_Impl* pWin, const ResId& rResId ) :
//STRIP001 
//STRIP001 	ListBox( pWin, rResId ),
//STRIP001 
//STRIP001 	mpWindow( pWin )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 long AddressListBox_Impl::Notify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	long nRet = 0;
//STRIP001 
//STRIP001 	if ( rNEvt.GetType() == EVENT_KEYINPUT )
//STRIP001 	{
//STRIP001 		const KeyCode& rKey = rNEvt.GetKeyEvent()->GetKeyCode();
//STRIP001 
//STRIP001 		if ( rKey.GetCode() == KEY_DELETE )
//STRIP001 		{
//STRIP001 			mpWindow->DeleteAddress();
//STRIP001 			nRet = 1;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nRet ? nRet : ListBox::Notify( rNEvt );
//STRIP001 }
//STRIP001 
//STRIP001 // class MailWindow_Impl -------------------------------------------------
//STRIP001 
//STRIP001 MailWindow_Impl::MailWindow_Impl( Window* pParent, SfxBindings* pBinds, const ResId& rResId ) :
//STRIP001 
//STRIP001 	Window( pParent, rResId ),
//STRIP001 
//STRIP001 	aSendBtn	( this, ResId( PB_MAILWIN_SEND ) ),
//STRIP001 	aCloseBtn	( this, ResId( PB_MAILWIN_CLOSE ) ),
//STRIP001 	aRoleLB		( this, ResId( LB_MAILWIN_ROLE ) ),
//STRIP001 	aRoleEdit	( this, ResId( ED_MAILWIN_ROLE ) ),
//STRIP001 	aAddressLB	( this, ResId( LB_MAILWIN_ADDRESS ) ),
//STRIP001 	aSubjectFT	( this, ResId( FT_MAILWIN_SUBJECT ) ),
//STRIP001 	aSubjectEdit( this, ResId( ED_MAILWIN_SUBJECT ) ),
//STRIP001 	aFromFT		( this, ResId( FT_MAILWIN_FROM ) ),
//STRIP001 	aFromEdit	( this, ResId( ED_MAILWIN_FROM ) ),
//STRIP001 	aPrioFT		( this, ResId( FT_MAILWIN_PRIO ) ),
//STRIP001 	aPrioLB		( this, ResId( LB_MAILWIN_PRIO ) ),
//STRIP001 	aSendImage	(		ResId( IMG_MAILWIN_SEND ) ),
//STRIP001 	aCloseImage	(		ResId( IMG_MAILWIN_CLOSE ) ),
//STRIP001 
//STRIP001 	bSend			( sal_False ),
//STRIP001 	pBindings		( pBinds )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aSendBtn.SetClickHdl( LINK( this, MailWindow_Impl, SendHdl ) );
//STRIP001 	aCloseBtn.SetClickHdl( LINK( this, MailWindow_Impl, CloseHdl ) );
//STRIP001 	Link aLink( LINK( this, MailWindow_Impl, ModifyHdl ) );
//STRIP001 	aRoleEdit.SetModifyHdl( aLink );
//STRIP001 	aSubjectEdit.SetModifyHdl( aLink );
//STRIP001 	aFromEdit.SetModifyHdl( aLink );
//STRIP001 
//STRIP001 /*! (pb) not implemented in VCL
//STRIP001 	aSendBtn.SetImage( aSendImage );
//STRIP001 	aSendBtn.SetImageAlign( IMAGEALIGN_LEFT );
//STRIP001 	aCloseBtn.SetImage( aCloseImage );
//STRIP001 	aCloseBtn.SetImageAlign( IMAGEALIGN_LEFT );
//STRIP001 */
//STRIP001 
//STRIP001 	String aFrom;
//STRIP001 	if ( CreateFromAddress_Impl( aFrom ) )
//STRIP001 		aFromEdit.SetText( aFrom );
//STRIP001 
//STRIP001 	aRoleLB.SelectEntryPos(0);	// To
//STRIP001 	aPrioLB.SelectEntryPos(2);	// Normal
//STRIP001 	n6Size = LogicToPixel( Size( 6, 6 ), MAP_APPFONT ).Width();
//STRIP001 	nMinWidth = ( aSubjectEdit.GetSizePixel().Width() / 2 ) + n6Size +
//STRIP001 				aPrioFT.GetSizePixel().Width() + aPrioLB.GetSizePixel().Width();
//STRIP001 
//STRIP001 	ModifyHdl( NULL );
//STRIP001 
//STRIP001 	aCloseTimer.SetTimeout( 200 );
//STRIP001 	aCloseTimer.SetTimeoutHdl( LINK( this, MailWindow_Impl, CloseHdl ) );
//STRIP001 
//STRIP001 	aInitTimer.SetTimeout( 500 );
//STRIP001 	aInitTimer.SetTimeoutHdl( LINK( this, MailWindow_Impl, InitHdl ) );
//STRIP001 	aInitTimer.Start();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 MailWindow_Impl::~MailWindow_Impl()
//STRIP001 {}
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void MailWindow_Impl::FillModel( SfxMailModel_Impl& rModel )
//STRIP001 {
//STRIP001 	if ( aRoleEdit.GetText().Len() > 0 )
//STRIP001 		ReceiveAddress();
//STRIP001 	USHORT i, nCount = aAddressLB.GetEntryCount();
//STRIP001 	String aPrefix( DEFINE_CONST_UNICODE(": ") );
//STRIP001 	for ( i = 0; i < nCount; ++i )
//STRIP001 	{
//STRIP001 		String aAddress = aAddressLB.GetEntry(i);
//STRIP001 		USHORT nPos = aAddress.Search( aPrefix );
//STRIP001 		aAddress.Erase( 0, nPos + 2 );
//STRIP001 		SfxMailModel_Impl::AddressRole eRole =
//STRIP001 			(SfxMailModel_Impl::AddressRole)(long)aAddressLB.GetEntryData(i);
//STRIP001 		rModel.AddAddress( aAddress, eRole );
//STRIP001 	}
//STRIP001 	rModel.SetSubject( aSubjectEdit.GetText() );
//STRIP001 	rModel.SetPriority( (SfxMailModel_Impl::MailPriority)aPrioLB.GetSelectEntryPos() );
//STRIP001 	rModel.SetFromAddress( aFromEdit.GetText() );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( MailWindow_Impl, SendHdl, PushButton*, EMPTYARG )
//STRIP001 {
//STRIP001 	Send();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( MailWindow_Impl, CloseHdl, void*, EMPTYARG )
//STRIP001 {
//STRIP001     pBindings->Execute( SID_MAIL_CHILDWIN );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( MailWindow_Impl, ModifyHdl, Edit*, EMPTYARG )
//STRIP001 {
//STRIP001 	aSendBtn.Enable( CanSend() );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( MailWindow_Impl, ChangeHdl, MailListener_Impl*, pListener )
//STRIP001 {
//STRIP001 	ModifyHdl( NULL );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( MailWindow_Impl, InitHdl, Timer*, EMPTYARG )
//STRIP001 {
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void MailWindow_Impl::Resize()
//STRIP001 {
//STRIP001 	Size aWinSize = GetSizePixel();
//STRIP001 	Point aPos = aFromEdit.GetPosPixel();
//STRIP001 	Size aOldSize = aFromEdit.GetSizePixel();
//STRIP001 	Size aNewSize = aOldSize;
//STRIP001 	aNewSize.Width() = aWinSize.Width() - aPos.X() - n6Size;
//STRIP001 
//STRIP001 	if ( nMinWidth < aNewSize.Width() )
//STRIP001 	{
//STRIP001 		Size aAddressSize = aAddressLB.GetSizePixel();
//STRIP001 		aAddressSize.Width() = aNewSize.Width();
//STRIP001 		aAddressLB.SetSizePixel( aAddressSize );
//STRIP001 
//STRIP001 		aRoleEdit.SetSizePixel( aNewSize );
//STRIP001 		aSubjectEdit.SetSizePixel( aNewSize );
//STRIP001 
//STRIP001 		Size aPrioSize1 = aPrioFT.GetSizePixel();
//STRIP001 		Size aPrioSize2 = aPrioLB.GetSizePixel();
//STRIP001 		aNewSize.Width() -= ( n6Size + aPrioSize1.Width() + aPrioSize2.Width() );
//STRIP001 		aFromEdit.SetSizePixel( aNewSize );
//STRIP001 
//STRIP001 		long nNewXPos = aFromEdit.GetPosPixel().X() + aNewSize.Width() + ( n6Size / 2 );
//STRIP001 		Point aNewPos = aPrioFT.GetPosPixel();
//STRIP001 		aNewPos.X() = nNewXPos;
//STRIP001 		aPrioFT.SetPosPixel( aNewPos );
//STRIP001 		aNewPos = aPrioLB.GetPosPixel();
//STRIP001 		aNewPos.X() = nNewXPos + aPrioSize1.Width() + ( n6Size / 2 );
//STRIP001 		aPrioLB.SetPosPixel( aNewPos );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 sal_Bool MailWindow_Impl::CanSend() const
//STRIP001 {
//STRIP001 	return ( aSubjectEdit.GetText().Len() > 0 &&
//STRIP001 			 aFromEdit.GetText().Len() > 0 &&
//STRIP001 			 ( aRoleEdit.GetText().Len() > 0 || aAddressLB.GetEntryCount() > 0 ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void MailWindow_Impl::Send()
//STRIP001 {
//STRIP001 	SfxMailModel_Impl aModel( pBindings );
//STRIP001 	EnterWait();
//STRIP001 	FillModel( aModel );
//STRIP001 	SfxMailModel_Impl::SendMailResult eResult = 
//STRIP001 		aModel.Send( SfxMailModel_Impl::TYPE_SELF );
//STRIP001 	LeaveWait();
//STRIP001 	if ( eResult == SfxMailModel_Impl::SEND_MAIL_ERROR )
//STRIP001 	{
//STRIP001 		ErrorBox aBox( this, SfxResId( RID_ERRBOX_SEND_FAILED ) );
//STRIP001 		aBox.Execute();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void MailWindow_Impl::ReceiveAddress()
//STRIP001 {
//STRIP001 	USHORT nRole = aRoleLB.GetSelectEntryPos();
//STRIP001 	String aAddress = aRoleLB.GetEntry( nRole );
//STRIP001 	aAddress += DEFINE_CONST_UNICODE(": ");
//STRIP001 	aAddress += aRoleEdit.GetText();
//STRIP001 	USHORT nPos = aAddressLB.InsertEntry( aAddress );
//STRIP001 	aAddressLB.SetEntryData( nPos, (void*)(long)nRole );
//STRIP001 	aRoleEdit.SetText( String() );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void MailWindow_Impl::ClearAddress()
//STRIP001 {
//STRIP001 	aRoleEdit.SetText( String() );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void MailWindow_Impl::DeleteAddress()
//STRIP001 {
//STRIP001 	USHORT nPos = aAddressLB.GetSelectEntryPos();
//STRIP001 	aAddressLB.RemoveEntry( nPos );
//STRIP001 	USHORT nCount = aAddressLB.GetEntryCount();
//STRIP001 
//STRIP001 	if ( nCount )
//STRIP001 	{
//STRIP001 		if ( nPos >= nCount )
//STRIP001 			nPos = ( nCount - 1 );
//STRIP001 		aAddressLB.SelectEntryPos( nPos );
//STRIP001 	}
//STRIP001 }


}
