/*************************************************************************
 *
 *  $RCSfile: sfx2_register.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:46:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #include "sfxresid.hxx"
// auto strip #include "register.hxx"

#include "dialog.hrc"
#include "register.hrc"
namespace binfilter {


//STRIP001 StarOfficeRegisterDlg::StarOfficeRegisterDlg( Window *pParent ) :
//STRIP001 	ModalDialog			( pParent, SfxResId(RID_REGISTER_DLG) ),
//STRIP001 	aFT_InfoText		( this, SfxResId(FT_INFOTEXT) ),
//STRIP001 	aFT_RegNr			( this, SfxResId(FT_REGNR) ),
//STRIP001 	aED_RegNr			( this, SfxResId(ED_REGNR) ),
//STRIP001 	aFT_Email			( this, SfxResId(FT_EMAIL) ),
//STRIP001 	aED_Email			( this, SfxResId(ED_EMAIL) ),
//STRIP001 	aFL_Line1			( this, SfxResId(FL_LINE1) ),
//STRIP001 	aBTN_Register		( this, SfxResId(BTN_REGISTER) ),
//STRIP001 	aBTN_StartOffice	( this, SfxResId(BTN_STARTOFFICE) ),
//STRIP001 	aBTN_GetFree		( this, SfxResId(BTN_GETFREE) ),
//STRIP001 	aStr_WrongData		( SfxResId(STR_WRONG_NUMBER) )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aED_RegNr.SetModifyHdl( LINK( this, StarOfficeRegisterDlg, ModifyHdl ) );
//STRIP001 	aED_Email.SetModifyHdl( LINK( this, StarOfficeRegisterDlg, ModifyHdl ) );
//STRIP001 
//STRIP001 	aBTN_Register.SetClickHdl( LINK( this, StarOfficeRegisterDlg, ClickHdl ) );
//STRIP001 	aBTN_StartOffice.SetClickHdl( LINK( this, StarOfficeRegisterDlg, ClickHdl ) );
//STRIP001 	aBTN_GetFree.SetClickHdl( LINK( this, StarOfficeRegisterDlg, ClickHdl ) );
//STRIP001 
//STRIP001 	aBTN_GetFree.Enable( FALSE );
//STRIP001 }
//STRIP001 
//STRIP001 StarOfficeRegisterDlg::~StarOfficeRegisterDlg()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 BOOL StarOfficeRegisterDlg::Close()
//STRIP001 {
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 void StarOfficeRegisterDlg::SetEmail(const XubString& rEmail)
//STRIP001 {
//STRIP001 	aED_Email.SetText(rEmail);
//STRIP001 }
//STRIP001 
//STRIP001 void StarOfficeRegisterDlg::CheckReg()
//STRIP001 {
//STRIP001 	XubString aRegNr( aED_RegNr.GetText() );
//STRIP001 	XubString aEMail( aED_Email.GetText() );
//STRIP001 	long nCoded = 0;
//STRIP001 
//STRIP001 	for( USHORT i = 0; i < 8; ++i )
//STRIP001 	{
//STRIP001 		unsigned char cCodedChar = 0x00;
//STRIP001 		for( USHORT x = i; x < aEMail.Len(); ++x )
//STRIP001 		{
//STRIP001 			if( ((x+1) % (i+1)) == 0 )
//STRIP001 				cCodedChar += aEMail.GetChar(x);
//STRIP001 		}
//STRIP001 
//STRIP001 		cCodedChar %= 10;
//STRIP001 		nCoded *= 10;
//STRIP001 		nCoded += cCodedChar;
//STRIP001 	}
//STRIP001 
//STRIP001 	XubString strCoded;
//STRIP001 	while( nCoded != 0 )
//STRIP001 	{
//STRIP001 		int r = nCoded % 9;
//STRIP001 		nCoded /= 9;
//STRIP001 		strCoded.Insert( (char)(r + '0'), 0 );
//STRIP001 	}
//STRIP001 	strCoded.InsertAscii( "00000000", 0 );
//STRIP001 	if( strCoded.Len() > 8 )
//STRIP001 		strCoded.Erase( 0, strCoded.Len() - 8 );
//STRIP001 
//STRIP001 	XubString aRealRegNr;
//STRIP001 	for( USHORT nx = 0; nx <= aRegNr.Len(); ++nx )
//STRIP001 		if( ((nx) % 2) == 0 )
//STRIP001 			aRealRegNr += aRegNr.GetChar(nx);
//STRIP001 
//STRIP001 	// 8010207336707402 == ok@stardivision.de
//STRIP001 	if( aRealRegNr == strCoded )
//STRIP001 		EndDialog(3); // erfolgreich
//STRIP001 	else
//STRIP001 	{
//STRIP001 		InfoBox( this, aStr_WrongData ).Execute();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( StarOfficeRegisterDlg, ClickHdl, PushButton*, pBtn )
//STRIP001 {
//STRIP001 	if( pBtn == &aBTN_StartOffice )
//STRIP001 		EndDialog(1);
//STRIP001 	else if( pBtn == &aBTN_Register )
//STRIP001 		EndDialog(2);
//STRIP001 	else if( pBtn == &aBTN_GetFree )
//STRIP001 		CheckReg();
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( StarOfficeRegisterDlg, ModifyHdl, Edit*, pEdit )
//STRIP001 {
//STRIP001 	if( aED_RegNr.GetText().Len() && aED_Email.GetText().Len() )
//STRIP001 	{
//STRIP001 		if( !aBTN_GetFree.IsEnabled() )
//STRIP001 			aBTN_GetFree.Enable( TRUE );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aBTN_GetFree.Enable( FALSE );
//STRIP001 
//STRIP001 	return 1;
//STRIP001 }


}
