/*************************************************************************
 *
 *  $RCSfile: sfx2_inetslot.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:40:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#if SUPD<613//MUSTINI
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#endif

#include <tools/urlobj.hxx>
#include <svtools/urihelper.hxx>
namespace binfilter {

//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #if SUPD<613//MUSTINI
//STRIP001 #include "inimgr.hxx"
//STRIP001 #endif
//STRIP001 #include "app.hxx"
//STRIP001 #include "request.hxx"
//STRIP001 #include "inettbc.hxx"
//STRIP001 #include "viewfrm.hxx"
//STRIP001 #include "dispatch.hxx"
//STRIP001 #include "appdata.hxx"
//STRIP001 #include "objsh.hxx"
//STRIP001 #include "docfac.hxx"
//STRIP001 #include "docfile.hxx"
//STRIP001 #include "sfxtypes.hxx"
//STRIP001 #include "statcach.hxx"
//STRIP001 #include "arrdecl.hxx"
//STRIP001 #include "sfxsids.hrc"
//STRIP001 
//STRIP001 //***************************************************************************
//STRIP001 
//STRIP001 void SfxApplication::INetExecute_Impl( SfxRequest& rRequest )
//STRIP001 /*
//STRIP001 	[Beschreibung]
//STRIP001 	Slothandler fuer Executeevents im INetbereich
//STRIP001 */
//STRIP001 {
//STRIP001 	switch( rRequest.GetSlot() )
//STRIP001 	{
//STRIP001 		case SID_BROWSE_STOP:
//STRIP001 		{
//STRIP001 			if ( rRequest.GetModifier() & KEY_MOD1 )
//STRIP001 			{
//STRIP001 				SfxFrameArr_Impl& rArr = *SFX_APP()->Get_Impl()->pTopFrames;
//STRIP001 				for( USHORT nPos = rArr.Count(); nPos--; )
//STRIP001 					rArr[ nPos ]->GetCancelManager()->Cancel( TRUE );
//STRIP001 				GetCancelManager()->Cancel( TRUE );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// jobs in current task canceln
//STRIP001 				SfxViewFrame *pFrm = SfxViewFrame::Current();
//STRIP001 				SfxCancelManager *pCancelMgr = SfxViewFrame::Current()
//STRIP001 						? SfxViewFrame::Current()->GetCancelManager()
//STRIP001 						: GetCancelManager();
//STRIP001 				if ( pCancelMgr )
//STRIP001 					pCancelMgr->Cancel( TRUE );
//STRIP001 
//STRIP001 				// jobs in hidden tasks canceln
//STRIP001 				SfxFrameArr_Impl& rArr = *SFX_APP()->Get_Impl()->pTopFrames;
//STRIP001 				for( USHORT nPos = rArr.Count(); nPos--; )
//STRIP001 				{
//STRIP001 					SfxFrame *pFrame = rArr[ nPos ];
//STRIP001 					if ( TRUE || !pFrame->GetCurrentViewFrame() )
//STRIP001 						pFrame->GetCancelManager()->Cancel( TRUE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_FOCUSURLBOX:
//STRIP001 		{
//STRIP001 			SfxStateCache *pCache = SfxViewFrame::Current()->GetBindings().GetAnyStateCache_Impl( SID_OPENURL );
//STRIP001 			if( pCache )
//STRIP001 			{
//STRIP001 				SfxControllerItem* pCtrl = pCache->GetItemLink();
//STRIP001 				while( pCtrl )
//STRIP001 				{
//STRIP001 					pCtrl->StateChanged(
//STRIP001 						SID_FOCUSURLBOX, SFX_ITEM_UNKNOWN, 0 );
//STRIP001 					pCtrl = pCtrl->GetItemLink();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Recording
//STRIP001 	rRequest.Done();
//STRIP001 }
//STRIP001 
//STRIP001 //***************************************************************************
//STRIP001 
//STRIP001 StopButtonTimer_Impl::StopButtonTimer_Impl()
//STRIP001 	: bState( FALSE )
//STRIP001 {
//STRIP001 	SetTimeout( 200 );
//STRIP001 }
//STRIP001 
//STRIP001 void StopButtonTimer_Impl::SetButtonState( BOOL bStateP )
//STRIP001 {
//STRIP001 	if( bStateP )
//STRIP001 	{
//STRIP001 		bState = TRUE;
//STRIP001 		Stop();
//STRIP001 	}
//STRIP001 	else if( bState )
//STRIP001 		Start();
//STRIP001 }
//STRIP001 
//STRIP001 void StopButtonTimer_Impl::Timeout()
//STRIP001 {
//STRIP001 	bState = FALSE;
//STRIP001 	SFX_APP()->Invalidate( SID_BROWSE_STOP );
//STRIP001 }
//STRIP001 
//STRIP001 void SfxApplication::INetState_Impl( SfxItemSet& rItemSet )
//STRIP001 /*
//STRIP001 	[Beschreibung]
//STRIP001 	Slothandler fuer Statusevents im INetbereich
//STRIP001 */
//STRIP001 {
//STRIP001 	StopButtonTimer_Impl*& pTimer = SFX_APP()->Get_Impl()->pStopButtonTimer;
//STRIP001 	if ( !pTimer )
//STRIP001 		pTimer = new StopButtonTimer_Impl;
//STRIP001 	SfxFrameArr_Impl& rArr = *SFX_APP()->Get_Impl()->pTopFrames;
//STRIP001 	USHORT nPos;
//STRIP001 	for( nPos = rArr.Count(); nPos--; )
//STRIP001 		if( rArr[ nPos ]->GetCancelManager()->CanCancel() )
//STRIP001 			break;
//STRIP001 	pTimer->SetButtonState(
//STRIP001 		nPos != USHRT_MAX || SFX_APP()->GetCancelManager()->CanCancel());
//STRIP001 	if ( !pTimer->GetButtonState() )
//STRIP001 		rItemSet.DisableItem( SID_BROWSE_STOP );
//STRIP001 }
//STRIP001 
//STRIP001 //-------------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxCancelManager *SfxApplication::GetCancelManager() const
//STRIP001 {
//STRIP001 	if ( !pAppData_Impl->pCancelMgr )
//STRIP001 	{
//STRIP001 		pAppData_Impl->pCancelMgr = new SfxCancelManager;
//STRIP001 		pAppData_Impl->StartListening( *pAppData_Impl->pCancelMgr );
//STRIP001 	}
//STRIP001 	return pAppData_Impl->pCancelMgr;
//STRIP001 }


}
