/*************************************************************************
 *
 *  $RCSfile: SvXMLAutoCorrectImport.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:31:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
*
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Martin Gallwey (gallwey@sun.com)
 *
 *
 ************************************************************************/
#ifndef _SV_XMLAUTOCORRECTIMPORT_HXX
#define _SV_XMLAUTOCORRECTIMPORT_HXX

// auto strip #ifndef _SVSTOR_HXX 
// auto strip #include <so3/svstor.hxx>
// auto strip #endif

// auto strip #ifndef _XMLOFF_XMLICTXT_HXX
// auto strip #include <bf_xmloff/xmlictxt.hxx>
// auto strip #endif

// auto strip #ifndef _XMLOFF_XMLIMP_HXX
// auto strip #include <bf_xmloff/xmlimp.hxx>
// auto strip #endif

// auto strip #ifndef _XMLOFF_NMSPMAP_HXX
// auto strip #include <bf_xmloff/nmspmap.hxx>
// auto strip #endif

// auto strip #ifndef _XMLOFF_XMLNMSPE_HXX
// auto strip #include <bf_xmloff/xmlnmspe.hxx>
// auto strip #endif
// auto strip #ifndef _MySVXACORR_HXX
// auto strip #include "svxacorr.hxx"
// auto strip #endif
namespace binfilter {

//STRIP001 class SvXMLAutoCorrectImport : public SvXMLImport
//STRIP001 {
//STRIP001 protected:
//STRIP001 
//STRIP001 	// This method is called after the namespace map has been updated, but
//STRIP001 	// before a context for the current element has been pushed.
//STRIP001 	virtual SvXMLImportContext *CreateContext( sal_uInt16 nPrefix,
//STRIP001 				  const ::rtl::OUString& rLocalName,
//STRIP001 				  const ::com::sun::star::uno::Reference<
//STRIP001 					::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 public:
//STRIP001 	SvxAutocorrWordList		*pAutocorr_List;
//STRIP001 	SvxAutoCorrect			&rAutoCorrect;
//STRIP001 	SvStorageRef			&rStorage;
//STRIP001 	// #110680#
//STRIP001 	SvXMLAutoCorrectImport( 
//STRIP001 		const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 		SvxAutocorrWordList *pNewAutocorr_List, 
//STRIP001 		SvxAutoCorrect &rNewAutoCorrect, 
//STRIP001 		SvStorageRef & rNewStorage);
//STRIP001 	~SvXMLAutoCorrectImport ( void ) throw ();
//STRIP001 };

//STRIP001 class SvXMLWordListContext : public SvXMLImportContext
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvXMLAutoCorrectImport & rLocalRef;
//STRIP001 public:
//STRIP001 	SvXMLWordListContext ( SvXMLAutoCorrectImport& rImport,
//STRIP001 						   sal_uInt16 nPrefix, 
//STRIP001 						   const ::rtl::OUString& rLocalName,
//STRIP001 						   const ::com::sun::star::uno::Reference< 
//STRIP001 						   ::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 	virtual SvXMLImportContext *CreateChildContext( sal_uInt16 nPrefix,
//STRIP001 						   const ::rtl::OUString& rLocalName,
//STRIP001 						   const ::com::sun::star::uno::Reference< 
//STRIP001 						   ::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 	~SvXMLWordListContext ( void );
//STRIP001 };

//STRIP001 class SvXMLWordContext : public SvXMLImportContext
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvXMLAutoCorrectImport & rLocalRef;
//STRIP001 public:
//STRIP001 	SvXMLWordContext ( SvXMLAutoCorrectImport& rImport,
//STRIP001 						   sal_uInt16 nPrefix, 
//STRIP001 						   const ::rtl::OUString& rLocalName,
//STRIP001 						   const ::com::sun::star::uno::Reference< 
//STRIP001 						   ::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 	~SvXMLWordContext ( void );
//STRIP001 };


//STRIP001 class SvXMLExceptionListImport : public SvXMLImport
//STRIP001 {
//STRIP001 protected:
//STRIP001 
//STRIP001 	// This method is called after the namespace map has been updated, but
//STRIP001 	// before a context for the current element has been pushed.
//STRIP001 	virtual SvXMLImportContext *CreateContext( sal_uInt16 nPrefix,
//STRIP001 				  const ::rtl::OUString& rLocalName,
//STRIP001 				  const ::com::sun::star::uno::Reference<
//STRIP001 					::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 public:
//STRIP001 	SvStringsISortDtor 	&rList;
//STRIP001 	// #110680#
//STRIP001 	SvXMLExceptionListImport( 
//STRIP001 		const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 		SvStringsISortDtor & rNewList );
//STRIP001 	~SvXMLExceptionListImport ( void ) throw ();
//STRIP001 };

//STRIP001 class SvXMLExceptionListContext : public SvXMLImportContext
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvXMLExceptionListImport & rLocalRef;
//STRIP001 public:
//STRIP001 	SvXMLExceptionListContext ( SvXMLExceptionListImport& rImport,
//STRIP001 						   sal_uInt16 nPrefix, 
//STRIP001 						   const ::rtl::OUString& rLocalName,
//STRIP001 						   const ::com::sun::star::uno::Reference< 
//STRIP001 						   ::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 	virtual SvXMLImportContext *CreateChildContext( sal_uInt16 nPrefix,
//STRIP001 						   const ::rtl::OUString& rLocalName,
//STRIP001 						   const ::com::sun::star::uno::Reference< 
//STRIP001 						   ::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 	~SvXMLExceptionListContext ( void );
//STRIP001 };

//STRIP001 class SvXMLExceptionContext : public SvXMLImportContext
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvXMLExceptionListImport & rLocalRef;
//STRIP001 public:
//STRIP001 	SvXMLExceptionContext ( SvXMLExceptionListImport& rImport,
//STRIP001 						   sal_uInt16 nPrefix, 
//STRIP001 						   const ::rtl::OUString& rLocalName,
//STRIP001 						   const ::com::sun::star::uno::Reference< 
//STRIP001 						   ::com::sun::star::xml::sax::XAttributeList > & xAttrList );
//STRIP001 	~SvXMLExceptionContext ( void );
//STRIP001 };


}//end of namespace binfilter
#endif
