/*************************************************************************
 *
 *  $RCSfile: galctrl.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:52:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_GALCTRL_HXX_
#define _SVX_GALCTRL_HXX_

// auto strip #include <vcl/dialog.hxx>
// auto strip #include <vcl/graph.hxx>
// auto strip #include <vcl/fixed.hxx>
// auto strip #include <vcl/group.hxx>
// auto strip #include <vcl/button.hxx>
// auto strip #include <vcl/lstbox.hxx>
// auto strip #include <vcl/menu.hxx>
// auto strip #include <vcl/edit.hxx>
// auto strip #include <vcl/combobox.hxx>
// auto strip #include <vcl/sound.hxx>
// auto strip #include <svtools/slstitm.hxx>
// auto strip #include <svtools/transfer.hxx> 
// auto strip #include <svtools/valueset.hxx>
// auto strip #include <svtools/brwbox.hxx>
// auto strip #include <goodies/grfmgr.hxx>
// auto strip #include "galmisc.hxx"
namespace binfilter {

// ------------
// - Forwards -
// ------------

class GalleryTheme;
class GalleryBrowser2;

// ------------------
// - GalleryPreview -
// ------------------

//STRIP001 class GalleryPreview : public Window, public DropTargetHelper, public DragSourceHelper
//STRIP001 {
//STRIP001 private:
//STRIP001 	
//STRIP001     GraphicObject		aGraphicObj;
//STRIP001 	Rectangle			aPreviewRect;
//STRIP001 	Sound				aSound;
//STRIP001     GalleryTheme*       mpTheme;
//STRIP001 						
//STRIP001 	BOOL				ImplGetGraphicCenterRect( const Graphic& rGraphic, Rectangle& rResultRect ) const;
//STRIP001     void                InitSettings();
//STRIP001 						
//STRIP001 	// Window
//STRIP001 	virtual void 		Paint(const Rectangle& rRect);
//STRIP001 	virtual void 		MouseButtonDown(const MouseEvent& rMEvt);
//STRIP001 	virtual void		Command(const CommandEvent& rCEvt);
//STRIP001 	virtual void	    KeyInput( const KeyEvent& rKEvt );
//STRIP001     virtual void        DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 
//STRIP001 	// DropTargetHelper
//STRIP001 	virtual sal_Int8	AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	virtual sal_Int8	ExecuteDrop( const ExecuteDropEvent& rEvt );
//STRIP001 
//STRIP001     // DragSourceHelper
//STRIP001 	virtual void		StartDrag( sal_Int8 nAction, const Point& rPosPixel );
//STRIP001 
//STRIP001 						DECL_LINK( MenuSelectHdl, Menu* );
//STRIP001 						DECL_LINK( SoundEndHdl, Sound* );
//STRIP001 						
//STRIP001 public:					
//STRIP001 						
//STRIP001 						GalleryPreview( GalleryBrowser2* pParent, GalleryTheme* pTheme );
//STRIP001                         GalleryPreview( Window* pParent, const ResId& rResId  );
//STRIP001 						~GalleryPreview();
//STRIP001 						
//STRIP001 	void				SetGraphic( const Graphic& rGraphic ) { aGraphicObj.SetGraphic( rGraphic ); }
//STRIP001 	void				PreviewSound( const INetURLObject& rURL );
//STRIP001 };

// -------------------
// - GalleryIconView -
// -------------------

//STRIP001 class GalleryIconView : public ValueSet, public DropTargetHelper, public DragSourceHelper
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	GalleryTheme*		mpTheme;
//STRIP001 
//STRIP001     void                InitSettings();
//STRIP001 
//STRIP001 	// ValueSet
//STRIP001 	virtual void 		UserDraw( const UserDrawEvent& rUDEvt );
//STRIP001 	
//STRIP001     // Window
//STRIP001     virtual void		MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void		Command( const CommandEvent& rCEvt );
//STRIP001 	virtual void	    KeyInput( const KeyEvent& rKEvt );
//STRIP001     virtual void        DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 	// DropTargetHelper
//STRIP001 	virtual sal_Int8	AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	virtual sal_Int8	ExecuteDrop( const ExecuteDropEvent& rEvt );
//STRIP001 
//STRIP001     // DragSourceHelper
//STRIP001 	virtual void		StartDrag( sal_Int8 nAction, const Point& rPosPixel );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						GalleryIconView( GalleryBrowser2* pParent, GalleryTheme* pTheme );
//STRIP001 						~GalleryIconView();
//STRIP001 };

// -------------------
// - GalleryListView -
// -------------------

//STRIP001 class GalleryListView : public BrowseBox
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Link                maSelectHdl;
//STRIP001     GalleryTheme*		mpTheme;
//STRIP001     ULONG               mnCurRow;
//STRIP001     BOOL                mbInit;
//STRIP001 
//STRIP001     void                InitSettings();
//STRIP001 
//STRIP001 	// BrowseBox
//STRIP001 	virtual BOOL        SeekRow( long nRow );
//STRIP001 	virtual void        PaintField( OutputDevice& rDev, const Rectangle& rRect, USHORT nColumnId ) const;
//STRIP001 	virtual void        DoubleClick( const BrowserMouseEvent& rEvt );
//STRIP001 	virtual void        Select();
//STRIP001 	virtual sal_Int8    AcceptDrop( const BrowserAcceptDropEvent& rEvt );
//STRIP001 	virtual sal_Int8    ExecuteDrop( const BrowserExecuteDropEvent& rEvt );
//STRIP001 	virtual void	    KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001 	// Window
//STRIP001     virtual void		Command( const CommandEvent& rCEvt );
//STRIP001     virtual void        DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001     // DragSourceHelper
//STRIP001 	virtual void		StartDrag( sal_Int8 nAction, const Point& rPosPixel );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						GalleryListView( GalleryBrowser2* pParent, GalleryTheme* pTheme );
//STRIP001 						~GalleryListView();
//STRIP001 
//STRIP001     void                SetSelectHdl( const Link& rSelectHdl ) { maSelectHdl = rSelectHdl; }
//STRIP001 
//STRIP001 	/** GetCellText returns the text at the given position
//STRIP001 		@param	_nRow
//STRIP001 			the number of the row
//STRIP001 		@param	_nColId
//STRIP001 			the ID of the column
//STRIP001 		@return
//STRIP001 			the text out of the cell
//STRIP001 	*/
//STRIP001 	virtual String	GetCellText(long _nRow, USHORT _nColId) const;
//STRIP001 
//STRIP001     // from IAccessibleTableProvider
//STRIP001 	virtual Rectangle GetFieldCharacterBounds(sal_Int32 _nRow,sal_Int32 _nColumnPos,sal_Int32 nIndex);
//STRIP001 	virtual sal_Int32 GetFieldIndexAtPoint(sal_Int32 _nRow,sal_Int32 _nColumnPos,const Point& _rPoint);
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_GALCTRL_HXX_
