/*************************************************************************
 *
 *  $RCSfile: svx_numinf.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:04:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#pragma hdrstop

#define _SVX_NUMINF_CXX
#define ITEMID_NUMBERINFO	0

// auto strip #include "numinf.hxx"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 TYPEINIT1(SvxNumberInfoItem, SfxPoolItem);
//STRIP001 
//STRIP001 // class SvxNumberInfoItem -----------------------------------------------
//STRIP001 
//STRIP001 #define INIT(pNum,eVal,nDouble,rStr)	\
//STRIP001 	SfxPoolItem		( nId ),			\
//STRIP001 										\
//STRIP001 	pFormatter		( pNum ),			\
//STRIP001 	eValueType		( eVal ),			\
//STRIP001 	nDoubleVal		( nDouble ),		\
//STRIP001     aStringVal		( rStr ), 			\
//STRIP001 	pDelFormatArr	( NULL ),			\
//STRIP001 	nDelCount		( 0 )
//STRIP001 
//STRIP001 SvxNumberInfoItem::SvxNumberInfoItem( const sal_uInt16 nId ) :
//STRIP001 
//STRIP001 	INIT( NULL, SVX_VALUE_TYPE_UNDEFINED, 0, String() )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxNumberInfoItem::SvxNumberInfoItem( SvNumberFormatter* pNumFormatter,
//STRIP001 									  const sal_uInt16 nId ) :
//STRIP001 
//STRIP001 	INIT( pNumFormatter, SVX_VALUE_TYPE_UNDEFINED, 0, String() )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxNumberInfoItem::SvxNumberInfoItem( SvNumberFormatter* pNumFormatter,
//STRIP001 									  const String& rVal, const sal_uInt16 nId ) :
//STRIP001 
//STRIP001 	INIT( pNumFormatter, SVX_VALUE_TYPE_STRING, 0, rVal )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxNumberInfoItem::SvxNumberInfoItem( SvNumberFormatter* pNumFormatter,
//STRIP001 									  const double& rVal, const sal_uInt16 nId ) :
//STRIP001 
//STRIP001 	INIT( pNumFormatter, SVX_VALUE_TYPE_NUMBER, rVal, String() )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxNumberInfoItem::SvxNumberInfoItem( SvNumberFormatter* pNumFormatter,
//STRIP001 									  const double& rVal, const String& rValueStr,
//STRIP001 									  const sal_uInt16 nId ) :
//STRIP001 
//STRIP001 	INIT( pNumFormatter, SVX_VALUE_TYPE_NUMBER, rVal, rValueStr )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 #undef INIT
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxNumberInfoItem::SvxNumberInfoItem( const SvxNumberInfoItem& rItem ) :
//STRIP001 
//STRIP001 	SfxPoolItem( rItem.Which() ),
//STRIP001 
//STRIP001 	pFormatter	 ( rItem.pFormatter ),
//STRIP001 	eValueType	 ( rItem.eValueType ),
//STRIP001 	nDoubleVal	 ( rItem.nDoubleVal ),
//STRIP001 	aStringVal	 ( rItem.aStringVal ),
//STRIP001 	pDelFormatArr( NULL ),
//STRIP001 	nDelCount	 ( rItem.nDelCount )
//STRIP001 
//STRIP001 {
//STRIP001 	if ( rItem.nDelCount > 0 )
//STRIP001 	{
//STRIP001 		pDelFormatArr = new sal_uInt32[ rItem.nDelCount ];
//STRIP001 
//STRIP001 		for ( sal_uInt16 i = 0; i < rItem.nDelCount; ++i )
//STRIP001 			pDelFormatArr[i] = rItem.pDelFormatArr[i];
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxNumberInfoItem::~SvxNumberInfoItem()
//STRIP001 {
//STRIP001 	if ( pDelFormatArr )
//STRIP001 		delete []pDelFormatArr;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxItemPresentation SvxNumberInfoItem::GetPresentation
//STRIP001 (
//STRIP001 	SfxItemPresentation ePres,
//STRIP001 	SfxMapUnit			eCoreUnit,
//STRIP001 	SfxMapUnit			ePresUnit,
//STRIP001     String&             rText, const IntlWrapper *
//STRIP001 )	const
//STRIP001 {
//STRIP001 	rText.Erase();
//STRIP001 	return SFX_ITEM_PRESENTATION_NONE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 int SvxNumberInfoItem::operator==( const SfxPoolItem& rItem ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( SfxPoolItem::operator==( rItem ), "unequal which or type" );
//STRIP001 
//STRIP001 	SvxNumberInfoItem& rOther = (SvxNumberInfoItem&)rItem;
//STRIP001 
//STRIP001 	sal_Bool bEqual = sal_False;
//STRIP001 
//STRIP001 	if ( nDelCount == rOther.nDelCount )
//STRIP001 	{
//STRIP001 		if ( nDelCount > 0 )
//STRIP001 		{
//STRIP001 			if ( pDelFormatArr != NULL && rOther.pDelFormatArr != NULL )
//STRIP001 			{
//STRIP001 				bEqual = sal_True;
//STRIP001 
//STRIP001 				for ( sal_uInt16 i = 0; i < nDelCount && bEqual; ++i )
//STRIP001 					bEqual = ( pDelFormatArr[i] == rOther.pDelFormatArr[i] );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if ( nDelCount == 0 )
//STRIP001 			bEqual = ( pDelFormatArr == NULL && rOther.pDelFormatArr == NULL );
//STRIP001 
//STRIP001 		bEqual = bEqual &&
//STRIP001 				 pFormatter == rOther.pFormatter &&
//STRIP001 				 eValueType == rOther.eValueType &&
//STRIP001 				 nDoubleVal == rOther.nDoubleVal &&
//STRIP001 				 aStringVal == rOther.aStringVal;
//STRIP001 	}
//STRIP001 	return bEqual;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPoolItem* SvxNumberInfoItem::Clone( SfxItemPool * ) const
//STRIP001 {
//STRIP001 	return new SvxNumberInfoItem( *this );
//STRIP001 }
//STRIP001 
//STRIP001 // Laden/Speichern wird nicht gebraucht!
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPoolItem* SvxNumberInfoItem::Create( SvStream& rStream, sal_uInt16 ) const
//STRIP001 {
//STRIP001 	return new SvxNumberInfoItem( *this );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvStream& SvxNumberInfoItem::Store( SvStream &rStream, sal_uInt16 nItemVersion ) const
//STRIP001 {
//STRIP001 	return rStream;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxNumberInfoItem::SetNumberFormatter( SvNumberFormatter* pNumFormatter )
//STRIP001 {
//STRIP001 	pFormatter = pNumFormatter;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxNumberInfoItem::SetStringValue( const String& rNewVal )
//STRIP001 {
//STRIP001 	aStringVal = rNewVal;
//STRIP001 	eValueType = SVX_VALUE_TYPE_STRING;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxNumberInfoItem::SetDoubleValue( const double& rNewVal )
//STRIP001 {
//STRIP001 	nDoubleVal = rNewVal;
//STRIP001 	eValueType = SVX_VALUE_TYPE_NUMBER;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxNumberInfoItem::SetDelFormatArray( const sal_uInt32* pData,
//STRIP001 										   const sal_uInt32 nCount )
//STRIP001 {
//STRIP001 	if ( pDelFormatArr )
//STRIP001 	{
//STRIP001 		delete []pDelFormatArr;
//STRIP001 		pDelFormatArr = NULL;
//STRIP001 	}
//STRIP001 
//STRIP001 	nDelCount = nCount;
//STRIP001 
//STRIP001 	if ( nCount > 0 )
//STRIP001 	{
//STRIP001 		pDelFormatArr = new sal_uInt32[ nCount ];
//STRIP001 
//STRIP001 		if ( pData != NULL )
//STRIP001 		{
//STRIP001 			for ( sal_uInt16 i = 0; i < nCount; ++i )
//STRIP001 				pDelFormatArr[i] = pData[i];
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
