/*************************************************************************
 *
 *  $RCSfile: svx_ldapdlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif
#pragma hdrstop

#include "ldapdlg.hxx"
#include "dialmgr.hxx"

#include "dialogs.hrc"
#include "optldap.hrc"
namespace binfilter {

// class SvxLDAPServerDlg_Impl -------------------------------------------

//STRIP001 IMPL_LINK( SvxLDAPServerDlg_Impl, ModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	String aStr = aPortED.GetText();
//STRIP001 
//STRIP001 	if ( !ByteString(aStr,RTL_TEXTENCODING_UTF8).IsNumericAscii() )
//STRIP001 	{
//STRIP001 		aPortED.SetText( aStr.Copy( 0, aStr.Len() - 1 ) );
//STRIP001 		aPortED.SetSelection( Selection( SELECTION_MAX, SELECTION_MAX ) );
//STRIP001 		Sound::Beep();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxLDAPServerDlg_Impl::SvxLDAPServerDlg_Impl( Window* pParent ) :
//STRIP001 
//STRIP001 	ModalDialog( pParent, SVX_RES( RID_SVXDLG_LDAP ) ),
//STRIP001 
//STRIP001 	aDescriptionFT	( this, ResId( FT_LDAP_PROP_DESC ) ),
//STRIP001 	aDescriptionED	( this, ResId( ED_LDAP_PROP_DESC ) ),
//STRIP001 	aServerFT		( this, ResId( FT_LDAP_PROP_SERVER ) ),
//STRIP001 	aServerED		( this, ResId( ED_LDAP_PROP_SERVER ) ),
//STRIP001 	aRootFT			( this, ResId( FT_LDAP_PROP_ROOT ) ),
//STRIP001 	aRootED			( this, ResId( ED_LDAP_PROP_ROOT ) ),
//STRIP001 	aPortFT			( this, ResId( FT_LDAP_PROP_PORT ) ),
//STRIP001 	aPortED			( this, ResId( ED_LDAP_PROP_PORT ) ),
//STRIP001 	aMaxHitsFT		( this, ResId( FT_LDAP_PROP_MAXHITS ) ),
//STRIP001 	aMaxHitsED		( this, ResId( ED_LDAP_PROP_MAXHITS ) ),
//STRIP001 	aMaxHitsNullFT	( this, ResId( FT_LDAP_PROP_MAXHITS_NULL ) ),
//STRIP001 	aPropertyBox	( this, ResId( GB_LDAP_PROP ) ),
//STRIP001 	aOKBtn			( this, ResId( BTN_LDAP_PROP_OK ) ),
//STRIP001 	aCancelBtn		( this, ResId( BTN_LDAP_PROP_CANCEL ) ),
//STRIP001 	aHelpBtn		( this, ResId( BTN_LDAP_PROP_HELP ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aPortED.SetModifyHdl( LINK( this, SvxLDAPServerDlg_Impl, ModifyHdl ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxLDAPServerDlg_Impl::~SvxLDAPServerDlg_Impl()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 String SvxLDAPServerDlg_Impl::GetIniString() const
//STRIP001 {
//STRIP001 	String aIniStr = aDescriptionED.GetText();
//STRIP001 	( aIniStr += LDAP_TOKEN_DELIM ) += aServerED.GetText();
//STRIP001 	( aIniStr += LDAP_TOKEN_DELIM ) += aRootED.GetText();
//STRIP001 	( aIniStr += LDAP_TOKEN_DELIM ) += aPortED.GetText();
//STRIP001 	( aIniStr += LDAP_TOKEN_DELIM ) += aMaxHitsED.GetText();
//STRIP001 	return aIniStr;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxLDAPServerDlg_Impl::SetIniString( const String& rIniStr )
//STRIP001 {
//STRIP001 	DBG_ASSERT( rIniStr.GetTokenCount( LDAP_TOKEN_DELIM ) == 5,
//STRIP001 				"wrong token count" );
//STRIP001 
//STRIP001 	aDescriptionED.SetText( rIniStr.GetToken( 0, LDAP_TOKEN_DELIM ) );
//STRIP001 	aServerED.SetText( rIniStr.GetToken( 1, LDAP_TOKEN_DELIM ) );
//STRIP001 	aRootED.SetText( rIniStr.GetToken( 2, LDAP_TOKEN_DELIM ) );
//STRIP001 	aPortED.SetText( rIniStr.GetToken( 3, LDAP_TOKEN_DELIM ) );
//STRIP001 	aMaxHitsED.SetText( rIniStr.GetToken( 4, LDAP_TOKEN_DELIM ) );
//STRIP001 }


}
