/*************************************************************************
 *
 *  $RCSfile: svx_optasian.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SVX_OPTASIAN_HXX
#include <optasian.hxx>
#endif
#ifndef _EEITEMID_HXX
#include <eeitemid.hxx>
#endif
#ifndef _SVX_LANGITEM_HXX
#include <langitem.hxx>
#endif
#ifndef _UNO_LINGU_HXX
#include <unolingu.hxx>
#endif
#include <optasian.hrc>
#include <dialmgr.hxx>
#include "dialogs.hrc"
#ifndef _TABLE_HXX //autogen
#include <tools/table.hxx>
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SVX_ASIANCFG_HXX
#include <asiancfg.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_I18N_XFORBIDDENCHARACTERS_HPP_
#include <com/sun/star/i18n/XForbiddenCharacters.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <bf_sfx2/viewfrm.hxx>
#endif
#ifndef _SFX_OBJSH_HXX
#include <bf_sfx2/objsh.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif
#ifndef _UNOTOOLS_LOCALEDATAWRAPPER_HXX
#include <unotools/localedatawrapper.hxx>
#endif

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::i18n;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::beans;
using namespace rtl;

//STRIP001 #define C2U(cChar) ::rtl::OUString::createFromAscii(cChar)
//STRIP001 
//STRIP001 const sal_Char cIsKernAsianPunctuation[] = "IsKernAsianPunctuation";
//STRIP001 const sal_Char cCharacterCompressionType[] = "CharacterCompressionType";
//STRIP001 
//STRIP001 struct SvxForbiddenChars_Impl
//STRIP001 {
//STRIP001 	sal_Bool 				bRemoved;
//STRIP001 	ForbiddenCharacters*	pCharacters;
//STRIP001 };
//STRIP001 
//STRIP001 DECLARE_TABLE( _SvxForbiddenCharacterTable_Impl, SvxForbiddenChars_Impl* )
//STRIP001 
//STRIP001 class SvxForbiddenCharacterTable_Impl : public _SvxForbiddenCharacterTable_Impl
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxForbiddenCharacterTable_Impl()
//STRIP001 		: _SvxForbiddenCharacterTable_Impl( 4, 4 )
//STRIP001 	{}
//STRIP001 	~SvxForbiddenCharacterTable_Impl();
//STRIP001 };
//STRIP001 
//STRIP001 struct SvxAsianLayoutPage_Impl
//STRIP001 {
//STRIP001 	SvxAsianConfig 	aConfig;
//STRIP001 		SvxAsianLayoutPage_Impl() :
//STRIP001 			aConfig(sal_False){}
//STRIP001 
//STRIP001 	Reference< XForbiddenCharacters > 	xForbidden;
//STRIP001     Reference< XPropertySet >           xPrSet;
//STRIP001     Reference< XPropertySetInfo >       xPrSetInfo;
//STRIP001     SvxForbiddenCharacterTable_Impl     aChangedLanguagesTbl;
//STRIP001 
//STRIP001 	sal_Bool				hasForbiddenCharacters(LanguageType eLang);
//STRIP001 	SvxForbiddenChars_Impl* getForbiddenCharacters(LanguageType eLang);
//STRIP001 	void					addForbiddenCharacters(LanguageType eLang, ForbiddenCharacters* pForbidden);
//STRIP001 };
//STRIP001 /* -----------------------------24.01.01 14:50--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 SvxForbiddenCharacterTable_Impl::~SvxForbiddenCharacterTable_Impl()
//STRIP001 {
//STRIP001 	for( SvxForbiddenChars_Impl*  pDel = First(); pDel; pDel = Next() )
//STRIP001 	{
//STRIP001 		delete pDel->pCharacters;
//STRIP001 		delete pDel;
//STRIP001 	}
//STRIP001 }
//STRIP001 /* -----------------------------24.01.01 14:50--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 sal_Bool	SvxAsianLayoutPage_Impl::hasForbiddenCharacters(LanguageType eLang)
//STRIP001 {
//STRIP001 	return 0 != aChangedLanguagesTbl.Get(eLang);
//STRIP001 }
//STRIP001 /* -----------------------------24.01.01 14:50--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 SvxForbiddenChars_Impl* SvxAsianLayoutPage_Impl::getForbiddenCharacters(LanguageType eLang)
//STRIP001 {
//STRIP001 	SvxForbiddenChars_Impl* pImp = aChangedLanguagesTbl.Get(eLang);
//STRIP001 	DBG_ASSERT(pImp, "language not available")
//STRIP001 	if(pImp)
//STRIP001 		return pImp;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /* -----------------------------24.01.01 14:50--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void SvxAsianLayoutPage_Impl::addForbiddenCharacters(
//STRIP001 	LanguageType eLang, ForbiddenCharacters* pForbidden)
//STRIP001 {
//STRIP001 	SvxForbiddenChars_Impl* pOld = aChangedLanguagesTbl.Get(eLang);
//STRIP001 	if( !pOld )
//STRIP001 	{
//STRIP001 		pOld = new SvxForbiddenChars_Impl;
//STRIP001 		pOld->bRemoved = 0 == pForbidden;
//STRIP001 		pOld->pCharacters = pForbidden ? new ForbiddenCharacters(*pForbidden) : 0;
//STRIP001 		aChangedLanguagesTbl.Insert( eLang, pOld );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pOld->bRemoved = 0 == pForbidden;
//STRIP001 		delete pOld->pCharacters;
//STRIP001 		pOld->pCharacters = pForbidden ? new ForbiddenCharacters(*pForbidden) : 0;
//STRIP001 	}
//STRIP001 
//STRIP001 }
//STRIP001 /*-- 09.01.01 13:29:02---------------------------------------------------
//STRIP001 
//STRIP001   -----------------------------------------------------------------------*/
//STRIP001 static LanguageType eLastUsedLanguageTypeForForbiddenCharacters = USHRT_MAX;
//STRIP001 
//STRIP001 SvxAsianLayoutPage::SvxAsianLayoutPage( Window* pParent, const SfxItemSet& rSet ) :
//STRIP001 	SfxTabPage(pParent, ResId( RID_SVXPAGE_ASIAN_LAYOUT, DIALOG_MGR() ), rSet),
//STRIP001 	aKerningGB(				this, ResId(GB_KERNING			)),
//STRIP001 	aCharKerningRB(			this, ResId(RB_CHAR_KERNING		)),
//STRIP001 	aCharPunctKerningRB(	this, ResId(RB_CHAR_PUNCT		)),
//STRIP001 	aCharDistGB(			this, ResId(GB_CHAR_DIST		)),
//STRIP001 	aNoCompressionRB(		this, ResId(RB_NO_COMP			)),
//STRIP001 	aPunctCompressionRB(	this, ResId(RB_PUNCT_COMP		)),
//STRIP001  	aPunctKanaCompressionRB(this, ResId(RB_PUNCT_KANA_COMP	)),
//STRIP001 	aStartEndGB(			this, ResId(GB_START_END		)),
//STRIP001 	aLanguageFT(			this, ResId(FT_LANGUAGE			)),
//STRIP001 	aLanguageLB(			this, ResId(LB_LANGUAGE			)),
//STRIP001 	aStandardCB(			this, ResId(CB_STANDARD			)),
//STRIP001 	aStartFT(				this, ResId(FT_START			)),
//STRIP001 	aStartED(				this, ResId(ED_START			)),
//STRIP001 	aEndFT(					this, ResId(FT_END				)),
//STRIP001 	aEndED(					this, ResId(ED_END				)),
//STRIP001 	aHintFT(				this, ResId(FT_HINT				)),
//STRIP001 	pImpl(new SvxAsianLayoutPage_Impl)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	LanguageHdl(&aLanguageLB);
//STRIP001 	aLanguageLB.SetSelectHdl(LINK(this, SvxAsianLayoutPage, LanguageHdl));
//STRIP001 	aStandardCB.SetClickHdl(LINK(this, SvxAsianLayoutPage, ChangeStandardHdl));
//STRIP001 	Link aLk(LINK(this, SvxAsianLayoutPage, ModifyHdl));
//STRIP001 	aStartED.SetModifyHdl(aLk);
//STRIP001 	aEndED.SetModifyHdl(aLk);
//STRIP001 
//STRIP001 	aLanguageLB.SetLanguageList( LANG_LIST_FBD_CHARS, FALSE, FALSE );
//STRIP001 }
//STRIP001 /*-- 09.01.01 13:29:02---------------------------------------------------
//STRIP001 
//STRIP001   -----------------------------------------------------------------------*/
//STRIP001 SvxAsianLayoutPage::~SvxAsianLayoutPage()
//STRIP001 {
//STRIP001 	delete pImpl;
//STRIP001 }
//STRIP001 /*-- 09.01.01 13:29:02---------------------------------------------------
//STRIP001 
//STRIP001   -----------------------------------------------------------------------*/
//STRIP001 SfxTabPage*	SvxAsianLayoutPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new SvxAsianLayoutPage(pParent, rAttrSet);
//STRIP001 }
//STRIP001 /*-- 09.01.01 13:29:03---------------------------------------------------
//STRIP001 
//STRIP001   -----------------------------------------------------------------------*/
//STRIP001 BOOL SvxAsianLayoutPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	if(aCharKerningRB.IsChecked() != aCharKerningRB.GetSavedValue())
//STRIP001     {
//STRIP001 		pImpl->aConfig.SetKerningWesternTextOnly(aCharKerningRB.IsChecked());
//STRIP001         OUString sPunct(C2U(cIsKernAsianPunctuation));
//STRIP001         if(pImpl->xPrSetInfo.is() && pImpl->xPrSetInfo->hasPropertyByName(sPunct))
//STRIP001         {
//STRIP001             Any aVal;
//STRIP001             BOOL bVal = !aCharKerningRB.IsChecked();
//STRIP001             aVal.setValue(&bVal, ::getBooleanCppuType());
//STRIP001             pImpl->xPrSet->setPropertyValue(sPunct, aVal);
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001 	if(aNoCompressionRB.IsChecked() != aNoCompressionRB.GetSavedValue() ||
//STRIP001 			aPunctCompressionRB.IsChecked() != aPunctCompressionRB.GetSavedValue())
//STRIP001 	{
//STRIP001 		sal_Int16 nSet = aNoCompressionRB.IsChecked() ? 0 :
//STRIP001 							aPunctCompressionRB.IsChecked() ? 1 : 2;
//STRIP001 		pImpl->aConfig.SetCharDistanceCompression(nSet);
//STRIP001         OUString sCompress(C2U(cCharacterCompressionType));
//STRIP001         if(pImpl->xPrSetInfo.is() && pImpl->xPrSetInfo->hasPropertyByName(sCompress))
//STRIP001         {
//STRIP001             Any aVal;
//STRIP001             aVal <<= nSet;
//STRIP001             pImpl->xPrSet->setPropertyValue(sCompress, aVal);
//STRIP001         }
//STRIP001     }
//STRIP001 	if(pImpl->aConfig.IsModified())
//STRIP001 		pImpl->aConfig.Commit();
//STRIP001 	if(pImpl->xForbidden.is())
//STRIP001 	{
//STRIP001 		try
//STRIP001 		{
//STRIP001 			for( SvxForbiddenChars_Impl*  pElem = pImpl->aChangedLanguagesTbl.First();
//STRIP001 				pElem; pElem = pImpl->aChangedLanguagesTbl.Next() )
//STRIP001 			{
//STRIP001 				ULONG nLang = pImpl->aChangedLanguagesTbl.GetKey( pElem );
//STRIP001 				Locale aLocale;
//STRIP001 				SvxLanguageToLocale(aLocale, (USHORT)nLang );
//STRIP001 				if(pElem->bRemoved)
//STRIP001 					pImpl->xForbidden->removeForbiddenCharacters( aLocale );
//STRIP001 				else if(pElem->pCharacters)
//STRIP001 					pImpl->xForbidden->setForbiddenCharacters( aLocale, *pElem->pCharacters );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		catch(Exception&)
//STRIP001 		{
//STRIP001 			DBG_ERROR("exception in XForbiddenCharacters")
//STRIP001 		}
//STRIP001 	}
//STRIP001     eLastUsedLanguageTypeForForbiddenCharacters = aLanguageLB.GetSelectLanguage();
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 /*-- 09.01.01 13:29:03---------------------------------------------------
//STRIP001 
//STRIP001   -----------------------------------------------------------------------*/
//STRIP001 void SvxAsianLayoutPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	SfxViewFrame* pCurFrm = SfxViewFrame::Current();
//STRIP001 	SfxObjectShell* pDocSh = pCurFrm ? pCurFrm->GetObjectShell() : 0;
//STRIP001 	Reference< XModel >	xModel;
//STRIP001 	if(pDocSh)
//STRIP001 		xModel = pDocSh->GetModel();
//STRIP001     Reference<XMultiServiceFactory> xFact(xModel, UNO_QUERY);
//STRIP001     if(xFact.is())
//STRIP001 	{
//STRIP001 		pImpl->xPrSet = Reference<XPropertySet>(
//STRIP001 			xFact->createInstance(C2U("com.sun.star.document.Settings")), UNO_QUERY);
//STRIP001 	}
//STRIP001     if( pImpl->xPrSet.is() )
//STRIP001         pImpl->xPrSetInfo = pImpl->xPrSet->getPropertySetInfo();
//STRIP001 	OUString sForbidden(C2U("ForbiddenCharacters"));
//STRIP001     sal_Bool bKernWesternText = pImpl->aConfig.IsKerningWesternTextOnly();
//STRIP001     sal_Int16 nCompress = pImpl->aConfig.GetCharDistanceCompression();
//STRIP001     if(pImpl->xPrSetInfo.is())
//STRIP001     {
//STRIP001         if(pImpl->xPrSetInfo->hasPropertyByName(sForbidden))
//STRIP001         {
//STRIP001             Any aForbidden = pImpl->xPrSet->getPropertyValue(sForbidden);
//STRIP001             aForbidden >>= pImpl->xForbidden;
//STRIP001         }
//STRIP001         OUString sCompress(C2U(cCharacterCompressionType));
//STRIP001         if(pImpl->xPrSetInfo->hasPropertyByName(sCompress))
//STRIP001         {
//STRIP001             Any aVal = pImpl->xPrSet->getPropertyValue(sCompress);
//STRIP001             aVal >>= nCompress;
//STRIP001         }
//STRIP001         OUString sPunct(C2U(cIsKernAsianPunctuation));
//STRIP001         if(pImpl->xPrSetInfo->hasPropertyByName(sPunct))
//STRIP001         {
//STRIP001             Any aVal = pImpl->xPrSet->getPropertyValue(sPunct);
//STRIP001             bKernWesternText = !*(sal_Bool*)aVal.getValue();
//STRIP001         }
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         aStartEndGB.Enable(FALSE);
//STRIP001         aLanguageFT.Enable(FALSE);
//STRIP001         aLanguageLB.Enable(FALSE);
//STRIP001         aStandardCB.Enable(FALSE);
//STRIP001         aStartFT.Enable(FALSE);
//STRIP001         aStartED.Enable(FALSE);
//STRIP001         aEndFT.Enable(FALSE);
//STRIP001         aEndED.Enable(FALSE);
//STRIP001         aHintFT.Enable(FALSE);
//STRIP001     }        
//STRIP001     if(bKernWesternText)
//STRIP001 		aCharKerningRB.Check(TRUE);
//STRIP001 	else
//STRIP001 		aCharPunctKerningRB.Check(TRUE);
//STRIP001     switch(nCompress)
//STRIP001 	{
//STRIP001 		case 0 : aNoCompressionRB.Check();        break;
//STRIP001 		case 1 : aPunctCompressionRB.Check();     break;
//STRIP001 		default: aPunctKanaCompressionRB.Check();
//STRIP001 	}
//STRIP001 	aCharKerningRB.SaveValue();
//STRIP001 	aNoCompressionRB.SaveValue();
//STRIP001 	aPunctCompressionRB.SaveValue();
//STRIP001 	aPunctKanaCompressionRB.SaveValue();
//STRIP001 
//STRIP001 	aLanguageLB.SelectEntryPos(0);
//STRIP001     //preselect the system language in the box - if available
//STRIP001     if(USHRT_MAX == eLastUsedLanguageTypeForForbiddenCharacters)
//STRIP001     {
//STRIP001         eLastUsedLanguageTypeForForbiddenCharacters = SvxLocaleToLanguage(
//STRIP001             Application::GetSettings().GetLocale() );
//STRIP001         switch(eLastUsedLanguageTypeForForbiddenCharacters)
//STRIP001         {
//STRIP001             case  LANGUAGE_CHINESE            :
//STRIP001             case  LANGUAGE_CHINESE_SINGAPORE  :
//STRIP001                 eLastUsedLanguageTypeForForbiddenCharacters = LANGUAGE_CHINESE_SIMPLIFIED;
//STRIP001             break;
//STRIP001             case  LANGUAGE_CHINESE_HONGKONG   :
//STRIP001             case  LANGUAGE_CHINESE_MACAU      :
//STRIP001                 eLastUsedLanguageTypeForForbiddenCharacters = LANGUAGE_CHINESE_TRADITIONAL;
//STRIP001             break;
//STRIP001         }
//STRIP001     }
//STRIP001     aLanguageLB.SelectLanguage( eLastUsedLanguageTypeForForbiddenCharacters );
//STRIP001     LanguageHdl(&aLanguageLB);
//STRIP001 }
//STRIP001 /* -----------------------------17.01.01 11:02--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 IMPL_LINK(SvxAsianLayoutPage, LanguageHdl, SvxLanguageBox*, pBox)
//STRIP001 {
//STRIP001 	//set current value
//STRIP001 	Locale aLocale;
//STRIP001 	LanguageType eSelectLanguage = aLanguageLB.GetSelectLanguage();
//STRIP001 	SvxLanguageToLocale(aLocale, eSelectLanguage );
//STRIP001 
//STRIP001 	OUString sStart, sEnd;
//STRIP001 	sal_Bool bAvail;
//STRIP001 	if(pImpl->xForbidden.is())
//STRIP001 	{
//STRIP001 		bAvail = pImpl->hasForbiddenCharacters(eSelectLanguage);
//STRIP001 		if(bAvail)
//STRIP001 		{
//STRIP001 			SvxForbiddenChars_Impl* pElement = pImpl->getForbiddenCharacters(eSelectLanguage);
//STRIP001 			if(pElement->bRemoved || !pElement->pCharacters)
//STRIP001 			{
//STRIP001 				bAvail = FALSE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				sStart = pElement->pCharacters->beginLine;
//STRIP001 				sEnd = pElement->pCharacters->endLine;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			try
//STRIP001 			{
//STRIP001 				bAvail = pImpl->xForbidden->hasForbiddenCharacters(aLocale);
//STRIP001 				if(bAvail)
//STRIP001 				{
//STRIP001 					ForbiddenCharacters aForbidden = pImpl->xForbidden->getForbiddenCharacters( aLocale );
//STRIP001 					sStart = aForbidden.beginLine;
//STRIP001 					sEnd = aForbidden.endLine;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			catch(Exception&)
//STRIP001 			{
//STRIP001 				DBG_ERROR("exception in XForbiddenCharacters")
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bAvail = pImpl->aConfig.GetStartEndChars( aLocale, sStart, sEnd );
//STRIP001 	}
//STRIP001 	if(!bAvail)
//STRIP001 	{
//STRIP001 		Reference< XMultiServiceFactory > xMSF = ::legacy_binfilters::getLegacyProcessServiceFactory());
//STRIP001 		LocaleDataWrapper aWrap( xMSF, aLocale );
//STRIP001 		ForbiddenCharacters aForbidden = aWrap.getForbiddenCharacters();
//STRIP001 		sStart = aForbidden.beginLine;
//STRIP001 		sEnd = aForbidden.endLine;
//STRIP001 	}
//STRIP001 	aStandardCB.Check(!bAvail);
//STRIP001 	aStartED.Enable(bAvail);
//STRIP001 	aEndED.Enable(bAvail);
//STRIP001 	aStartFT.Enable(bAvail);
//STRIP001 	aEndFT.Enable(bAvail);
//STRIP001 	aStartED.SetText(sStart);
//STRIP001 	aEndED.SetText(sEnd);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /* -----------------------------17.01.01 11:02--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 IMPL_LINK(SvxAsianLayoutPage, ChangeStandardHdl, CheckBox*, pBox)
//STRIP001 {
//STRIP001 	sal_Bool bCheck = pBox->IsChecked();
//STRIP001 	aStartED.Enable(!bCheck);
//STRIP001 	aEndED.Enable(!bCheck);
//STRIP001 	aStartFT.Enable(!bCheck);
//STRIP001 	aEndFT.Enable(!bCheck);
//STRIP001 
//STRIP001 	ModifyHdl(&aStartED);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /* -----------------------------17.01.01 12:26--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 IMPL_LINK(SvxAsianLayoutPage, ModifyHdl, Edit*, pEdit)
//STRIP001 {
//STRIP001 	Locale aLocale;
//STRIP001 	LanguageType eSelectLanguage = aLanguageLB.GetSelectLanguage();
//STRIP001 	SvxLanguageToLocale(aLocale, eSelectLanguage );
//STRIP001 	OUString sStart = aStartED.GetText();
//STRIP001 	OUString sEnd = aEndED.GetText();
//STRIP001 	sal_Bool bEnable = pEdit->IsEnabled();
//STRIP001 	if(pImpl->xForbidden.is())
//STRIP001 	{
//STRIP001 		try
//STRIP001 		{
//STRIP001 			if(bEnable)
//STRIP001 			{
//STRIP001 				ForbiddenCharacters aSet;
//STRIP001 				aSet.beginLine = sStart;
//STRIP001 				aSet.endLine = sEnd;
//STRIP001 //				pImpl->xForbidden->setForbiddenCharacters( aLocale, aSet );
//STRIP001 				pImpl->addForbiddenCharacters(eSelectLanguage, &aSet);
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pImpl->addForbiddenCharacters(eSelectLanguage, 0);
//STRIP001 //				pImpl->xForbidden->removeForbiddenCharacters( aLocale );
//STRIP001 		}
//STRIP001 		catch(Exception&)
//STRIP001 		{
//STRIP001 			DBG_ERROR("exception in XForbiddenCharacters")
//STRIP001 		}
//STRIP001 	}
//STRIP001 	pImpl->aConfig.SetStartEndChars( aLocale, bEnable ? &sStart : 0, bEnable ? &sEnd : 0);
//STRIP001 	return 0;
//STRIP001 }

}
