/*************************************************************************
 *
 *  $RCSfile: svx_optinet2.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:41:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _CONFIG_HXX
#include <tools/config.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSLSTITM_HXX //autogen
#include <svtools/slstitm.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <bf_sfx2/fcontnr.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <bf_sfx2/docfilt.hxx>
#endif
#ifndef _SFXSIDS_HRC
#include <bf_sfx2/sfxsids.hrc>
#endif
#ifndef _TOOLS_INETDEF_HXX
#include <tools/inetdef.hxx>
#endif
#ifndef SVTOOLS_URIHELPER_HXX
#include <svtools/urihelper.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _SVTOOLS_INETOPTIONS_HXX_
#include <svtools/inetoptions.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <bf_sfx2/app.hxx>
#endif
#ifndef _UTL_BOOTSTRAP_HXX
#include <unotools/bootstrap.hxx>
#endif
#ifndef _SV_HELP_HXX
#include <vcl/help.hxx>
#endif

#ifndef _SFXVIEWFRM_HXX
#include <bf_sfx2/viewfrm.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#include <svtools/pathoptions.hxx>
#endif
#ifndef _SVTOOLS_JAVAPTIONS_HXX
#include <svtools/javaoptions.hxx>
#endif
#ifndef _UNOTOOLS_LOCALFILEHELPER_HXX
#include <unotools/localfilehelper.hxx>
#endif

#ifndef INCLUDED_SVTOOLS_EXTENDEDSECURITYOPTIONS_HXX
#include <svtools/extendedsecurityoptions.hxx>
#endif

#define _SVX_OPTINET2_CXX

#ifndef _SVX_DIALMGR_HXX
#include "dialmgr.hxx"
#endif
#ifndef _SVX_OPTINET_HXX
#include "optinet2.hxx"
#endif
#ifndef _SVX_MULTIFIL_HXX
#include "multifil.hxx"
#endif
#ifndef _SVX_DIALOGS_HRC
#include "dialogs.hrc"
#endif
#ifndef _SVX_OPTINET_HRC
#include "optinet2.hrc"
#endif
#ifndef _SVX_HELPID_HRC
#include "helpid.hrc"
#endif
#include "so3/staticbaseurl.hxx"
namespace binfilter {

// static ----------------------------------------------------------------

//STRIP001 #define INET_SEARCH_TOKEN 	'"'
//STRIP001 #define RET_ALL				((short)200)
//STRIP001 #define CFG_READONLY_DEFAULT    FALSE
//STRIP001 
//STRIP001 SV_IMPL_PTRARR( SfxFilterPtrArr, SfxFilterPtr )
//STRIP001 
//STRIP001 const char* SEARCHENGINE_INI	= "srcheng.ini";
//STRIP001 const char* SEARCHENGINE_GROUP	= "SearchEngines-$(vlang)";
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 String lcl_MakeTabEntry(const SfxFilter* pFilter)
//STRIP001 {
//STRIP001 	String sEntry(pFilter->GetMimeType());
//STRIP001 	sEntry += '\t';
//STRIP001 	sEntry += pFilter->GetWildcard().GetWildCard();
//STRIP001 	sEntry += '\t';
//STRIP001 	sEntry += pFilter->GetName();
//STRIP001 #if defined(OS2) || defined(MAC)
//STRIP001 	sEntry += '\t';
//STRIP001 	sEntry += pFilter->GetTypeName();
//STRIP001 #endif
//STRIP001 	return sEntry;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL IsJavaInstalled_Impl( /*!!!SfxIniManager* pIniMgr*/ )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 /*!!! (pb) needs new implementation
//STRIP001 	String aIniEntry;
//STRIP001 	String aFullName = Config::GetConfigName( pIniMgr->Get( SFX_KEY_USERCONFIG_PATH ),
//STRIP001 											  String::CreateFromAscii("java") );
//STRIP001 	INetURLObject aIniFileObj( aFullName, INET_PROT_FILE );
//STRIP001 	String aIniPath = aIniFileObj.getName();
//STRIP001 	if ( pIniMgr->SearchFile( aIniPath ) )
//STRIP001 	{
//STRIP001 		Config aJavaCfg( aIniPath );
//STRIP001 		aJavaCfg.SetGroup( "Java" );
//STRIP001 		ByteString sTemp = aJavaCfg.ReadKey( ByteString(::rtl::OUStringToOString(pIniMgr->GetKeyName( SFX_KEY_JAVA_SYSTEMCLASSPATH ),RTL_TEXTENCODING_UTF8)) );
//STRIP001 		String aJavaSystemClassPath = ::rtl::OStringToOUString(sTemp,RTL_TEXTENCODING_UTF8);
//STRIP001 		String aJavaRuntimeLib = ::rtl::OStringToOUString(aJavaCfg.ReadKey( "RuntimeLib" ),RTL_TEXTENCODING_UTF8);
//STRIP001 		if ( aJavaSystemClassPath.Len() && aJavaRuntimeLib.Len() )
//STRIP001 			bRet = TRUE;
//STRIP001 	}
//STRIP001 */
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxNoSpaceEdit::KeyInput( const KeyEvent& rKEvent )
//STRIP001 {
//STRIP001 	if ( bOnlyNumeric )
//STRIP001 	{
//STRIP001 		const KeyCode& rKeyCode = rKEvent.GetKeyCode();
//STRIP001 		USHORT nGroup = rKeyCode.GetGroup();
//STRIP001 		USHORT nKey = rKeyCode.GetCode();
//STRIP001 		BOOL bValid = ( KEYGROUP_NUM == nGroup || KEYGROUP_CURSOR == nGroup ||
//STRIP001 						( KEYGROUP_MISC == nGroup && ( nKey < KEY_ADD || nKey > KEY_EQUAL ) ) );
//STRIP001 		if ( !bValid && ( rKeyCode.IsMod1() && (
//STRIP001 			 KEY_A == nKey || KEY_C == nKey || KEY_V == nKey || KEY_X == nKey || KEY_Z == nKey ) ) )
//STRIP001 			// Erase, Copy, Paste, Select All und Undo soll funktionieren
//STRIP001 			bValid = TRUE;
//STRIP001 
//STRIP001 		if ( bValid )
//STRIP001 			Edit::KeyInput(rKEvent);
//STRIP001 	}
//STRIP001 	else if( rKEvent.GetKeyCode().GetCode() != KEY_SPACE )
//STRIP001 		Edit::KeyInput(rKEvent);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxNoSpaceEdit::Modify()
//STRIP001 {
//STRIP001 	Edit::Modify();
//STRIP001 
//STRIP001 	if ( bOnlyNumeric )
//STRIP001 	{
//STRIP001 		XubString aValue = GetText();
//STRIP001 
//STRIP001 		if ( !ByteString(::rtl::OUStringToOString(aValue,RTL_TEXTENCODING_UTF8)).IsNumericAscii() || (long)aValue.ToInt32() > USHRT_MAX )
//STRIP001 			// der Hchstwert einer Portnummer ist USHRT_MAX
//STRIP001 			ErrorBox( this, SVX_RES( RID_SVXERR_OPT_PROXYPORTS ) ).Execute();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /********************************************************************/
//STRIP001 /********************************************************************/
//STRIP001 /*                                                                  */
//STRIP001 /* 	SvxProxyTabPage                                                 */
//STRIP001 /*                                                                  */
//STRIP001 /*                                                                  */
//STRIP001 /********************************************************************/
//STRIP001 /********************************************************************/
//STRIP001 
//STRIP001 SvxProxyTabPage::SvxProxyTabPage(Window* pParent, const SfxItemSet& rSet ) :
//STRIP001 	SfxTabPage( pParent, ResId( RID_SVXPAGE_INET_PROXY, DIALOG_MGR() ), rSet ),
//STRIP001 	aOptionGB   (this, ResId(GB_SETTINGS)),
//STRIP001 
//STRIP001 	aProxyModeFT  (this, ResId(FT_PROXYMODE)),
//STRIP001 	aProxyModeLB  (this, ResId(LB_PROXYMODE)),
//STRIP001 
//STRIP001 	aHttpProxyFT      (this, ResId( FT_HTTP_PROXY	  )),
//STRIP001 	aHttpProxyED      (this, ResId( ED_HTTP_PROXY     )),
//STRIP001 	aHttpPortFT       (this, ResId( FT_HTTP_PORT      )),
//STRIP001 	aHttpPortED       (this, ResId( ED_HTTP_PORT      ), TRUE),
//STRIP001 
//STRIP001 	aFtpProxyFT       (this, ResId( FT_FTP_PROXY      )),
//STRIP001 	aFtpProxyED       (this, ResId( ED_FTP_PROXY      )),
//STRIP001 	aFtpPortFT        (this, ResId( FT_FTP_PORT       )),
//STRIP001 	aFtpPortED        (this, ResId( ED_FTP_PORT       ), TRUE),
//STRIP001 
//STRIP001 // 	aSocksProxyFT     (this, ResId( FT_SOCKS_PROXY    )),
//STRIP001 // 	aSocksProxyED     (this, ResId( ED_SOCKS_PROXY    )),
//STRIP001 // 	aSocksPortFT      (this, ResId( FT_SOCKS_PORT     )),
//STRIP001 // 	aSocksPortED      (this, ResId( ED_SOCKS_PORT     ), TRUE),
//STRIP001 
//STRIP001 	aNoProxyForFT     (this, ResId( FT_NOPROXYFOR     )),
//STRIP001 	aNoProxyForED     (this, ResId( ED_NOPROXYFOR     )),
//STRIP001     aNoProxyDescFT    (this, ResId( ED_NOPROXYDESC    )),
//STRIP001 //     aDNSGB              ( this, ResId( GB_DNS ) ),
//STRIP001 // 	aDNSAutoRB			( this, ResId( RB_DNS_AUTO ) ),
//STRIP001 // 	aDNSManualRB		( this, ResId( RB_DNS_MANUAL ) ),
//STRIP001 // 	aDNSED				( this, ResId( ED_DNS ) ),
//STRIP001 	sMsg255_0			(		ResId( ST_MSG_255_0 ) ),
//STRIP001     sMsg255_1           (       ResId( ST_MSG_255_1 ) ),
//STRIP001     sFromBrowser        (       ResId( ST_PROXY_FROM_BROWSER ) )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aHttpPortED.SetMaxTextLen(5);
//STRIP001 	aFtpPortED.SetMaxTextLen(5);
//STRIP001 // 	aSocksPortED.SetMaxTextLen(5);
//STRIP001 	Link aLink = LINK( this, SvxProxyTabPage, LoseFocusHdl_Impl );
//STRIP001 	aHttpPortED.SetLoseFocusHdl( aLink );
//STRIP001 	aFtpPortED.SetLoseFocusHdl( aLink );
//STRIP001 // 	aSocksPortED.SetLoseFocusHdl( aLink );
//STRIP001 
//STRIP001 	aProxyModeLB.SetSelectHdl(LINK( this, SvxProxyTabPage, ProxyHdl_Impl ));
//STRIP001 //     aDNSED.SelectFixedFont();
//STRIP001 // 	aDNSED.SetFormatFlags(PATTERN_FORMAT_EMPTYLITERALS);
//STRIP001 //     aDNSAutoRB.SetClickHdl( LINK(this, SvxProxyTabPage, AutoDNSHdl_Impl) );
//STRIP001 //     aDNSManualRB.SetClickHdl( LINK(this, SvxProxyTabPage, AutoDNSHdl_Impl) );
//STRIP001 
//STRIP001     if(SfxApplication::IsPlugin())
//STRIP001     {
//STRIP001         aProxyModeLB.InsertEntry(sFromBrowser);
//STRIP001         aFtpProxyFT.Show(FALSE);
//STRIP001         aFtpProxyED.Show(FALSE);
//STRIP001         aFtpPortFT.Show(FALSE);
//STRIP001         aFtpPortED.Show(FALSE);
//STRIP001 
//STRIP001 //#105461# obsolet entries
//STRIP001 //         aSocksProxyFT.Show(FALSE);
//STRIP001 //         aSocksProxyED.Show(FALSE);
//STRIP001 //         aSocksPortFT.Show(FALSE);
//STRIP001 //         aSocksPortED.Show(FALSE);
//STRIP001 
//STRIP001         aNoProxyForFT.Show(FALSE);
//STRIP001         aNoProxyForED.Show(FALSE);
//STRIP001         aNoProxyDescFT.Show(FALSE);
//STRIP001 
//STRIP001 //#105461# obsolet entries
//STRIP001 //         aDNSGB.Show(FALSE);
//STRIP001 //         aDNSAutoRB.Show(FALSE);
//STRIP001 //         aDNSManualRB.Show(FALSE);
//STRIP001 //         aDNSED.Show(FALSE);
//STRIP001     }
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------12.08.96 14.55-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 SvxProxyTabPage::~SvxProxyTabPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------12.08.96 14.55-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 SfxTabPage*	SvxProxyTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new SvxProxyTabPage(pParent, rAttrSet);
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------12.08.96 14.55-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 void SvxProxyTabPage::Reset(const SfxItemSet&)
//STRIP001 {
//STRIP001     SfxItemState      eItemState = SFX_ITEM_UNKNOWN;
//STRIP001 	const SfxItemSet&		rSet = GetItemSet();
//STRIP001 	const SfxPoolItem*		pAttr = NULL;
//STRIP001 	for ( USHORT i = SID_INET_PROXY_TYPE; i <= SID_INET_SECURITY_PROXY_PORT; ++i  )
//STRIP001 	{
//STRIP001 		USHORT nWhich = GetWhich(i);
//STRIP001 		eItemState = rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pAttr );
//STRIP001 
//STRIP001 		if ( eItemState != SFX_ITEM_SET )
//STRIP001 			pAttr = NULL;
//STRIP001 
//STRIP001 		switch ( i )
//STRIP001 		{
//STRIP001 			case SID_INET_PROXY_TYPE:
//STRIP001 			{
//STRIP001 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxUInt16Item), "UInt16Item erwartet" );
//STRIP001                 //none == 0, manual == 2 , automatic only in PluginMode
//STRIP001                 USHORT nProxy = pAttr ? ( (const SfxUInt16Item*)pAttr )->GetValue() : 0;
//STRIP001                 USHORT nPos = 0;
//STRIP001                 switch(nProxy)
//STRIP001                 {
//STRIP001                     case SvtInetOptions::NONE:      nPos = 0; break;
//STRIP001                     case SvtInetOptions::MANUAL:    nPos = 1; break;
//STRIP001                     case SvtInetOptions::AUTOMATIC:
//STRIP001                         nPos = aProxyModeLB.GetEntryCount() == 3 ? 2 : 0;
//STRIP001                     break;
//STRIP001                 }
//STRIP001                 aProxyModeLB.SelectEntryPos( nPos );
//STRIP001                 BOOL bEnableProxyControls = nProxy == SvtInetOptions::MANUAL;
//STRIP001 				aProxyModeLB.SaveValue();
//STRIP001 				EnableControls_Impl( bEnableProxyControls );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_INET_HTTP_PROXY_NAME:
//STRIP001 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
//STRIP001 				if ( pAttr )
//STRIP001 					aHttpProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
//STRIP001 				aHttpProxyED.SaveValue();
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_INET_HTTP_PROXY_PORT:
//STRIP001 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
//STRIP001 				if ( pAttr )
//STRIP001 					aHttpPortED.SetText(
//STRIP001 						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
//STRIP001 				aHttpPortED.SaveValue();
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_INET_FTP_PROXY_NAME:
//STRIP001 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
//STRIP001 				if ( pAttr )
//STRIP001 					aFtpProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
//STRIP001 				aFtpProxyED.SaveValue();
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_INET_FTP_PROXY_PORT:
//STRIP001 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
//STRIP001 				if ( pAttr )
//STRIP001 					aFtpPortED.SetText(
//STRIP001 						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
//STRIP001 				aFtpPortED.SaveValue();
//STRIP001 			break;
//STRIP001 
//STRIP001 //#105461# obsolet entries
//STRIP001 // 			case SID_INET_SOCKS_PROXY_NAME:
//STRIP001 // 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
//STRIP001 // 				if ( pAttr )
//STRIP001 // 					aSocksProxyED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
//STRIP001 // 				aSocksProxyED.SaveValue();
//STRIP001 // 			break;
//STRIP001 
//STRIP001 // 			case SID_INET_SOCKS_PROXY_PORT:
//STRIP001 // 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxInt32Item), "Int32Item erwartet" );
//STRIP001 // 				if ( pAttr )
//STRIP001 // 					aSocksPortED.SetText(
//STRIP001 // 						String::CreateFromInt32( ( (const SfxInt32Item*)pAttr )->GetValue() ) );
//STRIP001 // 				aSocksPortED.SaveValue();
//STRIP001 // 			break;
//STRIP001 
//STRIP001 			case SID_INET_NOPROXY:
//STRIP001 				DBG_ASSERT( !pAttr || pAttr->ISA(SfxStringItem), "StringItem erwartet" );
//STRIP001 				if ( pAttr )
//STRIP001 					aNoProxyForED.SetText( ( (const SfxStringItem*)pAttr )->GetValue() );
//STRIP001 				aNoProxyForED.SaveValue();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		pAttr = NULL;
//STRIP001 	}
//STRIP001     // DNS Server
//STRIP001 //#105461# obsolet entries
//STRIP001 //     if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_DNS_AUTO, FALSE, &pAttr) )
//STRIP001 // 	{
//STRIP001 //         DBG_ASSERT(pAttr->ISA(SfxBoolItem), "SfxBoolItem erwartet");
//STRIP001 //         aDNSAutoRB.Check(((const SfxBoolItem*)pAttr)->GetValue());
//STRIP001 // 	}
//STRIP001 // 	aDNSAutoRB.SaveValue();
//STRIP001 // 	if( aDNSAutoRB.IsChecked() )
//STRIP001 // 	{
//STRIP001 // 		aDNSManualRB.Check( FALSE );
//STRIP001 // 		aDNSED.Enable( FALSE );
//STRIP001 // 	}
//STRIP001 // 	else
//STRIP001 // 		aDNSManualRB.Check(TRUE);
//STRIP001 //     if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_DNS_SERVER, FALSE, &pAttr) )
//STRIP001 // 	{
//STRIP001 //         DBG_ASSERT(pAttr->ISA(SfxStringItem), "SfxStringItem erwartet");
//STRIP001 //         String sValue(((const SfxStringItem*)pAttr)->GetValue());
//STRIP001 // 		USHORT nCount = sValue.GetTokenCount('.');
//STRIP001 // 		// Format soll wieder an das PatternField angepasst werden
//STRIP001 // 		for( USHORT i = 0; i < nCount; i++ )
//STRIP001 // 		{
//STRIP001 // 			String sPart(sValue.GetToken(i, '.'));
//STRIP001 // 			while(sPart.Len() < 3)
//STRIP001 // 				sPart.Insert(' ', 0);
//STRIP001 // 			sValue.SetToken(i ,'.', sPart);
//STRIP001 // 		}
//STRIP001 // 		aDNSED.SetText(sValue);
//STRIP001 // 	}
//STRIP001 // 	if(!aDNSED.GetText().Len())
//STRIP001 // 		aDNSED.SetText(aDNSED.GetLiteralMask());
//STRIP001 // 	aDNSED.SaveValue();
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------12.08.96 16.34-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL SvxProxyTabPage::FillItemSet(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	BOOL bModified=FALSE;
//STRIP001 	USHORT nSelPos = aProxyModeLB.GetSelectEntryPos();
//STRIP001 	if(aProxyModeLB.GetSavedValue() != nSelPos)
//STRIP001 	{
//STRIP001         USHORT nPut = 0;
//STRIP001         switch(nSelPos)
//STRIP001         {
//STRIP001             case  0: nPut = SvtInetOptions::NONE;     break;
//STRIP001             case  1: nPut = SvtInetOptions::MANUAL;   break;
//STRIP001             case  2: nPut = SvtInetOptions::AUTOMATIC;break;
//STRIP001         }
//STRIP001         rSet.Put(SfxUInt16Item( SID_INET_PROXY_TYPE, nPut));
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 	if(aHttpProxyED.GetSavedValue() != aHttpProxyED.GetText())
//STRIP001 	{
//STRIP001 		rSet.Put(SfxStringItem( SID_INET_HTTP_PROXY_NAME, aHttpProxyED.GetText()));
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aHttpPortED.GetSavedValue() != aHttpPortED.GetText() )
//STRIP001 	{
//STRIP001 		rSet.Put(SfxInt32Item(SID_INET_HTTP_PROXY_PORT, aHttpPortED.GetText().ToInt32()));
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 	if(aFtpProxyED.GetSavedValue() != aFtpProxyED.GetText())
//STRIP001 	{
//STRIP001 		rSet.Put(SfxStringItem( SID_INET_FTP_PROXY_NAME, aFtpProxyED.GetText()));
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aFtpPortED.GetSavedValue() != aFtpPortED.GetText() )
//STRIP001 	{
//STRIP001 		rSet.Put(SfxInt32Item(SID_INET_FTP_PROXY_PORT, aFtpPortED.GetText().ToInt32()));
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 //#105461# obsolet entries
//STRIP001 // 	if(aSocksProxyED.GetSavedValue() != aSocksProxyED.GetText())
//STRIP001 // 	{
//STRIP001 // 		rSet.Put(SfxStringItem( SID_INET_SOCKS_PROXY_NAME, aSocksProxyED.GetText()));
//STRIP001 // 		bModified = TRUE;
//STRIP001 // 	}
//STRIP001 
//STRIP001 // 	if ( aSocksPortED.GetSavedValue() != aSocksPortED.GetText() )
//STRIP001 // 	{
//STRIP001 // 		rSet.Put(SfxInt32Item(SID_INET_SOCKS_PROXY_PORT, aSocksPortED.GetText().ToInt32()));
//STRIP001 // 		bModified = TRUE;
//STRIP001 // 	}
//STRIP001 	if ( aNoProxyForED.GetSavedValue() != aNoProxyForED.GetText() )
//STRIP001 	{
//STRIP001 		rSet.Put(SfxStringItem(SID_INET_NOPROXY, aNoProxyForED.GetText()));
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 //#105461# obsolet entries
//STRIP001 //     if ( aDNSManualRB.IsChecked() && aDNSED.IsModified() )
//STRIP001 // 	{
//STRIP001 // 		ErrorBox aErrBox( this, WB_OK, String() );
//STRIP001 // 		String sEntry( aDNSED.GetText() );
//STRIP001 // 		String sPart( sEntry.GetToken( 0, '.' ) );
//STRIP001 // 		USHORT i, nPart( (USHORT)sPart.EraseLeadingChars().ToInt32() );
//STRIP001 // 		BOOL bSet = FALSE;
//STRIP001 // 		if ( sPart.Len() && ( !nPart || nPart > 255 ) )
//STRIP001 // 		{
//STRIP001 // 			// der erste Part darf nicht 0 und nicht gr"osser 255 sein
//STRIP001 // 			XubString sMsg( sPart );
//STRIP001 // 			sMsg += ' ';
//STRIP001 // 			sMsg += sMsg255_1;
//STRIP001 // 			aErrBox.SetMessText( sMsg );
//STRIP001 // 			aErrBox.Execute();
//STRIP001 
//STRIP001 // 			if ( nPart == 0 )
//STRIP001 // 				sPart = String::CreateFromAscii("  1");
//STRIP001 // 			else
//STRIP001 // 				sPart = String::CreateFromAscii("255");
//STRIP001 // 			sEntry.SetToken( 0, '.', sPart );
//STRIP001 // 			bSet = TRUE;
//STRIP001 // 		};
//STRIP001 
//STRIP001 // 		for ( i = 1; i < 4; i++ )
//STRIP001 // 		{
//STRIP001 // 			// die anderen Parts d"urfen nicht gr"osser 255 sein
//STRIP001 // 			sPart = sEntry.GetToken( i, '.' );
//STRIP001 // 			nPart = (USHORT)sPart.EraseLeadingChars().ToInt32();
//STRIP001 
//STRIP001 // 			if ( nPart > 255 )
//STRIP001 // 			{
//STRIP001 // 				String sMsg( sPart );
//STRIP001 // 				sMsg += ' ';
//STRIP001 // 				sMsg += sMsg255_0;
//STRIP001 // 				aErrBox.SetMessText( sMsg );
//STRIP001 // 				aErrBox.Execute();
//STRIP001 
//STRIP001 // 				if ( nPart == 0 )
//STRIP001 // 					sPart = String::CreateFromAscii("  1");
//STRIP001 // 				else
//STRIP001 // 					sPart = String::CreateFromAscii("255");
//STRIP001 // 				sEntry.SetToken( i, '.', sPart );
//STRIP001 // 				bSet = TRUE;
//STRIP001 // 			};
//STRIP001 // 		}
//STRIP001 
//STRIP001 // 		if ( bSet )
//STRIP001 // 		{
//STRIP001 // 			aDNSED.GrabFocus();
//STRIP001 // 			aDNSED.SetText( sEntry );
//STRIP001 // 		}
//STRIP001 // 	}
//STRIP001 
//STRIP001     // DNS Server
//STRIP001 	// Flag muss auch geputtet werden, wenn sich nur der Wert im
//STRIP001 	// Edit geaendert hat
//STRIP001 // 	BOOL bDNSModified = aDNSED.GetSavedValue() != aDNSED.GetText();
//STRIP001 // 	if( bDNSModified || aDNSAutoRB.GetSavedValue() != aDNSAutoRB.IsChecked() )
//STRIP001 // 	{
//STRIP001 // 		rSet.Put( SfxBoolItem(SID_INET_DNS_AUTO, aDNSAutoRB.IsChecked()) );
//STRIP001 // 		bModified = TRUE;
//STRIP001 // 	}
//STRIP001 // 	if( bDNSModified )
//STRIP001 // 	{
//STRIP001 // 		String sValue(aDNSED.GetText());
//STRIP001 // 		sValue.EraseAllChars(' ');
//STRIP001 // 		rSet.Put( SfxStringItem(SID_INET_DNS_SERVER, sValue) );
//STRIP001 // 		bModified = TRUE;
//STRIP001 // 	}
//STRIP001     return bModified;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------21.06.97 13.47-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SvxProxyTabPage, AutoDNSHdl_Impl, RadioButton*,  pBtn )
//STRIP001 {
//STRIP001 //#105461# obsolet entries
//STRIP001 // 	if( pBtn == &aDNSAutoRB )
//STRIP001 // 	{
//STRIP001 // 		aDNSED.Enable( FALSE );
//STRIP001 // 		aDNSManualRB.Check( FALSE );
//STRIP001 // 	}
//STRIP001 // 	else if( pBtn == &aDNSManualRB )
//STRIP001 // 	{
//STRIP001 // 		aDNSED.Enable( TRUE );
//STRIP001 // 		aDNSED.GrabFocus();
//STRIP001 // 		aDNSAutoRB.Check( FALSE );
//STRIP001 // 	}
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 /*-----------------12.08.96 13.38-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 void SvxProxyTabPage::EnableControls_Impl(BOOL bEnable)
//STRIP001 {
//STRIP001 	aHttpProxyFT.Enable(bEnable);
//STRIP001 	aHttpProxyED.Enable(bEnable);
//STRIP001 	aHttpPortFT.Enable(bEnable);
//STRIP001 	aHttpPortED.Enable(bEnable);
//STRIP001 
//STRIP001 	aFtpProxyFT.Enable(bEnable);
//STRIP001 	aFtpProxyED.Enable(bEnable);
//STRIP001 	aFtpPortFT.Enable(bEnable);
//STRIP001 	aFtpPortED.Enable(bEnable);
//STRIP001 
//STRIP001 //#105461# obsolet entries
//STRIP001 // 	aSocksProxyFT.Enable(bEnable);
//STRIP001 // 	aSocksProxyED.Enable(bEnable);
//STRIP001 // 	aSocksPortFT.Enable(bEnable);
//STRIP001 // 	aSocksPortED.Enable(bEnable);
//STRIP001 
//STRIP001 	aNoProxyForFT.Enable(bEnable);
//STRIP001 	aNoProxyForED.Enable(bEnable);
//STRIP001 	aNoProxyDescFT.Enable(bEnable);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxProxyTabPage, ProxyHdl_Impl, ListBox *, pBox )
//STRIP001 {
//STRIP001     BOOL bEnableProxyControls = pBox->GetSelectEntryPos() == 1;
//STRIP001 	EnableControls_Impl(bEnableProxyControls);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxProxyTabPage, LoseFocusHdl_Impl, Edit *, pEdit )
//STRIP001 {
//STRIP001 	XubString aValue = pEdit->GetText();
//STRIP001 
//STRIP001 	if ( !ByteString(::rtl::OUStringToOString(aValue,RTL_TEXTENCODING_UTF8)).IsNumericAscii() || (long)aValue.ToInt32() > USHRT_MAX )
//STRIP001 		pEdit->SetText( '0' );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /********************************************************************/
//STRIP001 /********************************************************************/
//STRIP001 /*                                                                  */
//STRIP001 /* 	SvxSearchTabPage                                                */
//STRIP001 /*                                                                  */
//STRIP001 /*                                                                  */
//STRIP001 /********************************************************************/
//STRIP001 /********************************************************************/
//STRIP001 
//STRIP001 SvxSearchTabPage::SvxSearchTabPage(Window* pParent, const SfxItemSet& rSet ) :
//STRIP001 
//STRIP001 	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_INET_SEARCH ), rSet ),
//STRIP001 
//STRIP001 	aSearchGB		( this, ResId( GB_SEARCH ) ),
//STRIP001 	aSearchFT		( this, ResId( FT_SEARCH ) ),
//STRIP001 	aSearchLB		( this, ResId( LB_SEARCH ) ),
//STRIP001 	aSearchNameFT	( this, ResId( FT_SEARCH_NAME ) ),
//STRIP001 	aSearchNameED	( this, ResId( ED_SEARCH_NAME ) ),
//STRIP001 	aURLFT			( this, ResId( FT_URL ) ),
//STRIP001 	aURLED			( this, ResId( ED_URL ) ),
//STRIP001 	aAndRB			( this, ResId( RB_AND ) ),
//STRIP001 	aOrRB			( this, ResId( RB_OR ) ),
//STRIP001 	aExactRB		( this, ResId( RB_EXACT ) ),
//STRIP001 	aSeparatorFT	( this, ResId( FT_SEPARATOR ) ),
//STRIP001 	aSeparatorED	( this, ResId( ED_SEPARATOR ) ),
//STRIP001 	aPostFixFT		( this, ResId( FT_POSTFIX ) ),
//STRIP001 	aPostFixED		( this, ResId( ED_POSTFIX ) ),
//STRIP001 	aCaseFT			( this, ResId( FT_CASE ) ),
//STRIP001 	aCaseED			( this, ResId( ED_CASE ) ),
//STRIP001 	aNewPB			( this, ResId( PB_NEW ) ),
//STRIP001 	aAddPB			( this, ResId( PB_ADD ) ),
//STRIP001 	aChangePB		( this, ResId( PB_CHANGE ) ),
//STRIP001     aDeletePB       ( this, ResId( PB_DELETE ) ),
//STRIP001     sModifyMsg(ResId(MSG_MODIFY))
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001     SetExchangeSupport();
//STRIP001 	aCaseED.SelectEntryPos(0); // falls kein Eintrag vorhanden ist, kann es sonst "Arger geben
//STRIP001 
//STRIP001 	aNewPB.SetClickHdl(LINK( this, SvxSearchTabPage, NewSearchHdl_Impl ) );
//STRIP001 	aAddPB.SetClickHdl(LINK( this, SvxSearchTabPage, AddSearchHdl_Impl ) );
//STRIP001 	aChangePB.SetClickHdl(LINK( this, SvxSearchTabPage, ChangeSearchHdl_Impl ) );
//STRIP001 	aDeletePB.SetClickHdl(LINK( this, SvxSearchTabPage, DeleteSearchHdl_Impl ) );
//STRIP001 	aSearchLB.SetSelectHdl(LINK( this, SvxSearchTabPage, SearchEntryHdl_Impl ) );
//STRIP001 
//STRIP001 	Link aLink = LINK( this, SvxSearchTabPage, SearchModifyHdl_Impl );
//STRIP001 	aSearchNameED.SetModifyHdl( aLink );
//STRIP001 	aURLED.SetModifyHdl( aLink );
//STRIP001 	aSeparatorED.SetModifyHdl( aLink );
//STRIP001 	aPostFixED.SetModifyHdl( aLink );
//STRIP001 	aCaseED.SetSelectHdl( aLink );
//STRIP001 
//STRIP001 	aLink = LINK( this, SvxSearchTabPage, SearchPartHdl_Impl );
//STRIP001 	aAndRB.SetClickHdl( aLink );
//STRIP001 	aOrRB.SetClickHdl( aLink );
//STRIP001 	aExactRB.SetClickHdl( aLink );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 SvxSearchTabPage::~SvxSearchTabPage()
//STRIP001 {
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxTabPage*	SvxSearchTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new SvxSearchTabPage(pParent, rAttrSet);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxSearchTabPage::Reset( const SfxItemSet& )
//STRIP001 {
//STRIP001 	//The two lines below are moved here from the last part of this method by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 	aChangePB.Disable();
//STRIP001 	aAddPB.Disable();
//STRIP001 
//STRIP001 	sal_uInt16 nCount = aSearchConfig.Count();
//STRIP001 	aSearchLB.Clear();  //add by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001     for(sal_uInt16 i = 0; i < nCount; i++)
//STRIP001     {
//STRIP001         const SvxSearchEngineData& rData = aSearchConfig.GetData(i);
//STRIP001         aSearchLB.InsertEntry(rData.sEngineName);
//STRIP001     }
//STRIP001 
//STRIP001 	if ( nCount )
//STRIP001 	{
//STRIP001 		aSearchLB.SelectEntryPos(0);
//STRIP001 		SearchEntryHdl_Impl( &aSearchLB );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aDeletePB.Disable();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SvxSearchTabPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001     if(aSearchConfig.IsModified())
//STRIP001         aSearchConfig.Commit();
//STRIP001     return TRUE;
//STRIP001 }
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SvxSearchTabPage::ActivatePage( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 int SvxSearchTabPage::DeactivatePage( SfxItemSet* pSet )
//STRIP001 {
//STRIP001 	//Modified by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 	if(!ConfirmLeave(String()))
//STRIP001 		return KEEP_PAGE;
//STRIP001 
//STRIP001     if ( pSet )
//STRIP001 		FillItemSet( *pSet );
//STRIP001 	return LEAVE_PAGE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 //add by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 BOOL SvxSearchTabPage::ConfirmLeave( const String& rStringSelection)
//STRIP001 {
//STRIP001     if(aChangePB.IsEnabled())
//STRIP001     {
//STRIP001         QueryBox aQuery(this, WB_YES_NO_CANCEL|WB_DEF_YES, sModifyMsg);
//STRIP001         USHORT nRet = aQuery.Execute();
//STRIP001         if(RET_CANCEL == nRet)
//STRIP001 		{
//STRIP001 			if(rStringSelection.Len())
//STRIP001 				aSearchLB.SelectEntry(sLastSelectedEntry);
//STRIP001             return FALSE;
//STRIP001 		}
//STRIP001         else if(RET_YES == nRet)
//STRIP001 		{
//STRIP001 			USHORT nEntryPos = aSearchLB.GetEntryPos( aSearchNameED.GetText() );
//STRIP001 			if ( nEntryPos != LISTBOX_ENTRY_NOTFOUND  )
//STRIP001 				aSearchLB.SelectEntryPos(nEntryPos);
//STRIP001 			else
//STRIP001 				aSearchLB.SetNoSelection();
//STRIP001             ChangeSearchHdl_Impl(0);
//STRIP001 			if(rStringSelection.Len())
//STRIP001 				aSearchLB.SelectEntry(rStringSelection);
//STRIP001 		}
//STRIP001 		else if(RET_NO == nRet)
//STRIP001 		{
//STRIP001 			aChangePB.Enable(FALSE);
//STRIP001 			aAddPB.Enable(FALSE);
//STRIP001 			SearchEntryHdl_Impl(&aSearchLB);
//STRIP001 		}
//STRIP001     }
//STRIP001 	if(aAddPB.IsEnabled())
//STRIP001 	{
//STRIP001 		QueryBox aQuery(this, WB_YES_NO_CANCEL|WB_DEF_YES, sModifyMsg);
//STRIP001 		USHORT nRet = aQuery.Execute();
//STRIP001 		if(RET_CANCEL == nRet)
//STRIP001 		{
//STRIP001 			aSearchLB.SetNoSelection();
//STRIP001 			return FALSE;
//STRIP001 		}
//STRIP001 		else if(RET_YES == nRet)
//STRIP001 		{
//STRIP001 			aSearchLB.SetNoSelection();
//STRIP001 			AddSearchHdl_Impl(0);
//STRIP001 			if(rStringSelection.Len())
//STRIP001 				aSearchLB.SelectEntry(rStringSelection);
//STRIP001 		}
//STRIP001 		else if(RET_NO == nRet)
//STRIP001 		{
//STRIP001 			aAddPB.Enable(FALSE);
//STRIP001 			aChangePB.Enable(FALSE);
//STRIP001 			NewSearchHdl_Impl(0);
//STRIP001 		}
//STRIP001 
//STRIP001 	}
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, NewSearchHdl_Impl, PushButton *, EMPTYARG )
//STRIP001 {
//STRIP001 	//The 3 lines below is modified by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 	SearchEntryHdl_Impl(&aSearchLB);
//STRIP001 	if(aChangePB.IsEnabled() || aAddPB.IsEnabled())
//STRIP001 		return 0;
//STRIP001 	aSearchNameED.SetText( String() );
//STRIP001 	aSearchLB.SetNoSelection();
//STRIP001     aCurrentSrchData = SvxSearchEngineData();
//STRIP001     aAndRB.Check( TRUE );
//STRIP001 	SearchEntryHdl_Impl( &aSearchLB );
//STRIP001 	SearchPartHdl_Impl( &aAndRB );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, AddSearchHdl_Impl, PushButton *, EMPTYARG )
//STRIP001 {
//STRIP001 	//The following two lines is added by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 	aAddPB.Enable(FALSE);
//STRIP001     aChangePB.Enable(FALSE);
//STRIP001     aCurrentSrchData.sEngineName = aSearchNameED.GetText();
//STRIP001     aSearchConfig.SetData(aCurrentSrchData);
//STRIP001     aSearchLB.InsertEntry( aCurrentSrchData.sEngineName );
//STRIP001     aSearchLB.SelectEntry( aCurrentSrchData.sEngineName );
//STRIP001 	SearchEntryHdl_Impl( &aSearchLB );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, ChangeSearchHdl_Impl, PushButton *, EMPTYARG )
//STRIP001 {
//STRIP001 	//The following two lines is added by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 	aChangePB.Enable(FALSE);
//STRIP001 	aAddPB.Enable(FALSE);
//STRIP001 	USHORT nPos = aSearchLB.GetSelectEntryPos();
//STRIP001 	if ( nPos != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 	{
//STRIP001         String sEngine = aSearchLB.GetSelectEntry();
//STRIP001         aCurrentSrchData.sEngineName = sEngine;
//STRIP001         aSearchConfig.SetData(aCurrentSrchData);
//STRIP001         aSearchLB.SelectEntry(sEngine);
//STRIP001 		SearchEntryHdl_Impl(&aSearchLB);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SetUpdateMode(FALSE);
//STRIP001 		String sEntry = aSearchNameED.GetText();
//STRIP001 		// im AddHdl wird sLastSelectedEntry umgesetzt
//STRIP001 		String sTemp(sLastSelectedEntry);
//STRIP001 		AddSearchHdl_Impl(0);
//STRIP001 		aSearchLB.SelectEntry(sTemp);
//STRIP001 		DeleteSearchHdl_Impl(0);
//STRIP001 		aSearchLB.SelectEntry(sEntry);
//STRIP001 		SearchEntryHdl_Impl(&aSearchLB);
//STRIP001 		SetUpdateMode(TRUE);
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, DeleteSearchHdl_Impl, PushButton *, EMPTYARG)
//STRIP001 {
//STRIP001 	aChangePB.Enable(FALSE);     //add by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 	USHORT nPos = aSearchLB.GetSelectEntryPos();
//STRIP001 	DBG_ASSERT(nPos != LISTBOX_ENTRY_NOTFOUND, "kein Eintrag selektiert!")
//STRIP001     aSearchConfig.RemoveData(aSearchLB.GetSelectEntry());
//STRIP001     aSearchLB.RemoveEntry(nPos);
//STRIP001 	aSearchLB.SelectEntryPos(0);
//STRIP001 	SearchEntryHdl_Impl(&aSearchLB);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, SearchEntryHdl_Impl, ListBox*, pBox )
//STRIP001 {
//STRIP001 	USHORT nEntryPos = pBox->GetSelectEntryPos();
//STRIP001 	if ( nEntryPos != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 	{
//STRIP001         String sSelection(pBox->GetSelectEntry());
//STRIP001 		//Modified by BerryJia for fixing Bug102610 Time:2002-8-29 11:00 (China Standard Time GMT+08:00)
//STRIP001 		if(!ConfirmLeave(sSelection))
//STRIP001 			return 0;
//STRIP001 
//STRIP001 		const SvxSearchEngineData* pData = aSearchConfig.GetData(sSelection);
//STRIP001         DBG_ASSERT(pData, "SearchEngine not available")
//STRIP001         if(pData)
//STRIP001         {
//STRIP001             aSearchNameED.SetText(sSelection);
//STRIP001             sLastSelectedEntry = sSelection;
//STRIP001             sal_Bool bAnd = aAndRB.IsChecked();
//STRIP001             sal_Bool bOr = aOrRB.IsChecked();
//STRIP001 
//STRIP001             aURLED.SetText(bAnd ? pData->sAndPrefix : bOr ? pData->sOrPrefix : pData->sExactPrefix);
//STRIP001             aSeparatorED.SetText( bAnd ? pData->sAndSeparator : bOr ? pData->sOrSeparator : pData->sExactSeparator);
//STRIP001             aPostFixED.SetText(bAnd ? pData->sAndSuffix : bOr ? pData->sOrSuffix : pData->sExactSuffix );
//STRIP001             sal_Int32 nCase = bAnd ? pData->nAndCaseMatch : bOr ? pData->nOrCaseMatch : pData->nExactCaseMatch;
//STRIP001             aCaseED.SelectEntryPos( (USHORT)nCase );
//STRIP001             aCurrentSrchData = *pData;
//STRIP001         }
//STRIP001 		aDeletePB.Enable();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aDeletePB.Enable(FALSE);
//STRIP001 		sLastSelectedEntry.Erase();
//STRIP001 	}
//STRIP001 	aChangePB.Enable(FALSE);
//STRIP001 	aAddPB.Enable(FALSE);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, SearchModifyHdl_Impl, SvxNoSpaceEdit*, pEdit )
//STRIP001 {
//STRIP001 	if ( pEdit == &aSearchNameED )
//STRIP001 	{
//STRIP001 		BOOL bTextLen = ( 0 != pEdit->GetText().Len() );
//STRIP001 		BOOL bFound = FALSE;
//STRIP001 		if ( bTextLen )
//STRIP001 		{
//STRIP001 			USHORT nEntryPos = aSearchLB.GetEntryPos( pEdit->GetText() );
//STRIP001 			bFound = ( nEntryPos != LISTBOX_ENTRY_NOTFOUND );
//STRIP001 			if ( bFound )
//STRIP001 				aSearchLB.SelectEntryPos(nEntryPos);
//STRIP001 			else
//STRIP001 				aSearchLB.SetNoSelection();
//STRIP001 		}
//STRIP001 		aChangePB.Enable( sLastSelectedEntry.Len() > 0 );
//STRIP001 		aDeletePB.Enable(bFound);
//STRIP001 		aAddPB.Enable(bTextLen && !bFound);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( aSearchLB.GetSelectEntryCount() && sLastSelectedEntry.Len() > 0 )
//STRIP001 			aChangePB.Enable();
//STRIP001 
//STRIP001         if(aAndRB.IsChecked())
//STRIP001         {
//STRIP001             aCurrentSrchData.sAndPrefix = aURLED.GetText();
//STRIP001             aCurrentSrchData.sAndSeparator = aSeparatorED.GetText();
//STRIP001             aCurrentSrchData.sAndSuffix = aPostFixED.GetText();
//STRIP001             aCurrentSrchData.nAndCaseMatch = aCaseED.GetSelectEntryPos();
//STRIP001         }
//STRIP001         else if(aOrRB.IsChecked())
//STRIP001         {
//STRIP001             aCurrentSrchData.sOrPrefix = aURLED.GetText();
//STRIP001             aCurrentSrchData.sOrSeparator = aSeparatorED.GetText();
//STRIP001             aCurrentSrchData.sOrSuffix = aPostFixED.GetText();
//STRIP001             aCurrentSrchData.nOrCaseMatch = aCaseED.GetSelectEntryPos();
//STRIP001         }
//STRIP001         else
//STRIP001         {
//STRIP001             aCurrentSrchData.sExactPrefix = aURLED.GetText();
//STRIP001             aCurrentSrchData.sExactSeparator = aSeparatorED.GetText();
//STRIP001             aCurrentSrchData.sExactSuffix = aPostFixED.GetText();
//STRIP001             aCurrentSrchData.nExactCaseMatch = aCaseED.GetSelectEntryPos();
//STRIP001         }
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxSearchTabPage, SearchPartHdl_Impl, RadioButton *, pButton )
//STRIP001 {
//STRIP001     sal_Bool bAnd = aAndRB.IsChecked();
//STRIP001     sal_Bool bOr = aOrRB.IsChecked();
//STRIP001 
//STRIP001     aURLED.SetText(bAnd ? aCurrentSrchData.sAndPrefix : bOr ? aCurrentSrchData.sOrPrefix : aCurrentSrchData.sExactPrefix);
//STRIP001     aSeparatorED.SetText( bAnd ? aCurrentSrchData.sAndSeparator : bOr ? aCurrentSrchData.sOrSeparator : aCurrentSrchData.sExactSeparator);
//STRIP001     aPostFixED.SetText(bAnd ? aCurrentSrchData.sAndSuffix : bOr ? aCurrentSrchData.sOrSuffix : aCurrentSrchData.sExactSuffix );
//STRIP001     sal_Int32 nCase = bAnd ? aCurrentSrchData.nAndCaseMatch : bOr ? aCurrentSrchData.nOrCaseMatch : aCurrentSrchData.nExactCaseMatch;
//STRIP001     aCaseED.SelectEntryPos( (USHORT)nCase );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 /********************************************************************/
//STRIP001 /********************************************************************/
//STRIP001 /*                                                                  */
//STRIP001 /* 	SvxOtherTabPage                                                 */
//STRIP001 /*                                                                  */
//STRIP001 /********************************************************************/
//STRIP001 /********************************************************************/
//STRIP001 
//STRIP001 /*-----------------15.05.97 09:51-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 /*
//STRIP001 SvxPatternField::SvxPatternField( Window* pParent, const ResId& rResId ) :
//STRIP001 
//STRIP001 	PatternField( pParent, rResId ),
//STRIP001 
//STRIP001 	sMsg233	( ResId( ST_MSG_233 ) ),
//STRIP001 	sMsg255	( ResId( ST_MSG_255 ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	SelectFixedFont();
//STRIP001 } */
//STRIP001 
//STRIP001 /*-----------------15.05.97 09:51-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 /*void SvxPatternField::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001 	PatternField::KeyInput( rKEvt );
//STRIP001 	BOOL bDelete = ( rKEvt.GetKeyCode().GetCode() == KEY_DELETE );
//STRIP001 	String sEntry( GetText() );
//STRIP001 	sEntry[(USHORT)3] = '.';
//STRIP001 	sEntry[(USHORT)7] = '.';
//STRIP001 	sEntry[(USHORT)11] = '.';
//STRIP001 	Selection aSelection( GetSelection() );
//STRIP001 	String sPart( sEntry.GetToken( 0, '.' ) );
//STRIP001 	USHORT i, nPart( sPart.EraseLeadingChars() );
//STRIP001 	BOOL bSet = FALSE;
//STRIP001 
//STRIP001 	if ( sPart.Len() && ( !nPart || nPart > 255 ) )
//STRIP001 	{
//STRIP001 		// der erste Part darf nicht 0 und nicht gr"osser 255 sein
//STRIP001 		String sMsg( sPart );
//STRIP001 		sMsg += ' ';
//STRIP001 		sMsg += sMsg233;
//STRIP001 		InfoBox( this, sMsg ).Execute();
//STRIP001 
//STRIP001 		if ( nPart == 0 )
//STRIP001 			sPart = "  1";
//STRIP001 		else
//STRIP001 			sPart = "255";
//STRIP001 		sEntry.SetToken( 0, '.', sPart );
//STRIP001 		bSet = TRUE;
//STRIP001 	};
//STRIP001 
//STRIP001 	for ( i = 1; i < 4; i++ )
//STRIP001 	{
//STRIP001 		// die anderen Parts d"urfen nicht gr"osser 255 sein
//STRIP001 		sPart = sEntry.GetToken( i, '.' );
//STRIP001 		nPart = sPart.EraseLeadingChars();
//STRIP001 
//STRIP001 		if ( nPart > 255 )
//STRIP001 		{
//STRIP001 			String sMsg( sPart );
//STRIP001 			sMsg += ' ';
//STRIP001 			sMsg += sMsg255;
//STRIP001 			InfoBox( this, sMsg ).Execute();
//STRIP001 
//STRIP001 			if ( nPart == 0 )
//STRIP001 				sPart = "  1";
//STRIP001 			else
//STRIP001 				sPart = "255";
//STRIP001 			sEntry.SetToken( i, '.', sPart );
//STRIP001 			bSet = TRUE;
//STRIP001 		};
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( bSet )
//STRIP001 	{
//STRIP001 		SetText( sEntry );
//STRIP001 		SetSelection( aSelection );
//STRIP001 	}
//STRIP001 }
//STRIP001 */
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 #if 0
//STRIP001 long SvxPatternField::Notify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	return PatternField::Notify( rNEvt );
//STRIP001 /*!	long nHandled = 0;
//STRIP001 
//STRIP001 	if ( rNEvt.GetType() == EVENT_KEYUP )
//STRIP001 	{
//STRIP001 		const KeyEvent* pKEvt = rNEvt.GetKeyEvent();
//STRIP001 		KeyInput( *pKEvt );
//STRIP001 		nHandled = 1;
//STRIP001 	}
//STRIP001 	return nHandled;*/
//STRIP001 }
//STRIP001 #endif
//STRIP001 
//STRIP001 // class JavaScriptDisableQueryBox_Impl --------------------------------------
//STRIP001 
//STRIP001 class JavaScriptDisableQueryBox_Impl : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedImage		aImage;
//STRIP001 	FixedText		aWarningFT;
//STRIP001 	CheckBox		aDisableCB;
//STRIP001 	OKButton		aYesBtn;
//STRIP001 	CancelButton	aNoBtn;
//STRIP001 
//STRIP001 public:
//STRIP001 	JavaScriptDisableQueryBox_Impl( Window* pParent );
//STRIP001 
//STRIP001 	BOOL		IsWarningDisabled() const { return aDisableCB.IsChecked(); }
//STRIP001 };
//STRIP001 
//STRIP001 JavaScriptDisableQueryBox_Impl::JavaScriptDisableQueryBox_Impl( Window* pParent ) :
//STRIP001 
//STRIP001 	ModalDialog( pParent, SVX_RES( RID_SVXDLG_OPT_JAVASCRIPT_DISABLE ) ),
//STRIP001 
//STRIP001 	aImage		( this, ResId( IMG_JSCPT_WARNING ) ),
//STRIP001 	aWarningFT	( this, ResId( FT_JSCPT_WARNING ) ),
//STRIP001 	aDisableCB	( this, ResId( CB_JSCPT_DISABLE ) ),
//STRIP001 	aYesBtn		( this, ResId( BTN_JSCPT_YES ) ),
//STRIP001 	aNoBtn		( this, ResId( BTN_JSCPT_NO ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aYesBtn.SetText( Button::GetStandardText( BUTTON_YES ) );
//STRIP001 	aNoBtn.SetText( Button::GetStandardText( BUTTON_NO ) );
//STRIP001 	aImage.SetImage( WarningBox::GetStandardImage() );
//STRIP001 }
//STRIP001 
//STRIP001 //#98647#----------------------------------------------
//STRIP001 void SvxScriptExecListBox::RequestHelp( const HelpEvent& rHEvt )
//STRIP001 {   // try to show tips just like as on toolbars
//STRIP001 	USHORT nPos=LISTBOX_ENTRY_NOTFOUND;
//STRIP001 	USHORT nTop = GetTopEntry();
//STRIP001 	USHORT nCount = GetDisplayLineCount(); // Attention: Not GetLineCount()
//STRIP001 	Point aPt = ScreenToOutputPixel( rHEvt.GetMousePosPixel() );
//STRIP001 	Rectangle aItemRect;
//STRIP001 	if( nCount > 0 ) // if there're some entries, find it.
//STRIP001  		for( nPos = nTop ; nPos <= nTop+nCount-1 ; nPos++ ) {
//STRIP001 			aItemRect = GetBoundingRectangle(nPos);
//STRIP001 			if( aPt.Y() < aItemRect.Top() || aPt.Y() > aItemRect.Bottom() )
//STRIP001 				continue;
//STRIP001 			else
//STRIP001 				break;
//STRIP001 		}
//STRIP001  	else // if not, nothing happens.
//STRIP001  		return;
//STRIP001  	String aHelpText;
//STRIP001  	if( nPos <= nTop+nCount-1 ) // if find the matching entry, get its content.
//STRIP001  		aHelpText = GetEntry(nPos);
//STRIP001 	if( aHelpText.Len() && GetTextWidth(aHelpText)<GetOutputSizePixel().Width() )
//STRIP001 		aHelpText.Erase(); // if the entry is quite short, clear the helping tip content.
//STRIP001 	aItemRect = Rectangle(Point(0,0),GetSizePixel());
//STRIP001 	aPt = Point(OutputToScreenPixel( aItemRect.TopLeft() ));
//STRIP001 	aItemRect.Left()   = aPt.X();
//STRIP001 	aItemRect.Top()    = aPt.Y();
//STRIP001 	aPt = OutputToScreenPixel( aItemRect.BottomRight() );
//STRIP001 	aItemRect.Right()  = aPt.X();
//STRIP001 	aItemRect.Bottom() = aPt.Y();
//STRIP001 	if( rHEvt.GetMode() == HELPMODE_BALLOON )
//STRIP001 		Help::ShowBalloon( this, aItemRect.Center(), aItemRect, aHelpText);
//STRIP001 	else
//STRIP001 		Help::ShowQuickHelp( this, aItemRect, aHelpText );
//STRIP001 }
//STRIP001 
//STRIP001 /********************************************************************/
//STRIP001 /*                                                                  */
//STRIP001 /*  SvxScriptingTabPage                                             */
//STRIP001 /*                                                                  */
//STRIP001 /********************************************************************/
//STRIP001 
//STRIP001 SvxScriptingTabPage::SvxScriptingTabPage( Window* pParent, const SfxItemSet& rSet ) :
//STRIP001 
//STRIP001 	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_INET_SCRIPTING ), rSet ),
//STRIP001 
//STRIP001     aGrpScriptingStarBasic  ( this, ResId( GB_STARBASIC ) ),
//STRIP001     aExecMacroFT            ( this, ResId( FT_EXEC_MACRO ) ),
//STRIP001     aExecMacroLB            ( this, ResId( LB_EXEC_MACRO ) ),
//STRIP001     aConfirmCB              ( this, ResId( CB_CONFIRM ) ),
//STRIP001     aWarningCB              ( this, ResId( CB_WARNING ) ),
//STRIP001     aPathListFT             ( this, ResId( FT_PATH_LIST ) ),
//STRIP001     aLbScriptExec           ( this, ResId( LB_SCRIPT_EXEC ) ),
//STRIP001     aBtnScriptExecDelete    ( this, ResId( PB_SCRIPT_DELETE ) ),
//STRIP001     aBtnScriptExecDefault   ( this, ResId( PB_SCRIPT_DEFAULT ) ),
//STRIP001     aNewPathFT				( this, ResId( FT_NEW_PATH ) ),
//STRIP001     aEdtScriptExec          ( this, ResId( ED_SCRIPT_EXEC ) ),
//STRIP001     aBtnScriptExecInsert    ( this, ResId( PB_SCRIPT_INSERT ) ),
//STRIP001 	aHyperlinksFL			( this, ResId( FL_HYPERLINKS ) ),
//STRIP001 	aHyperlinksFT			( this, ResId( FT_HYPERLINKS ) ),
//STRIP001 	aHyperlinksLB			( this, ResId( LB_HYPERLINKS ) ),
//STRIP001     aJavaFL                 ( this, ResId( FL_JAVA ) ),
//STRIP001     aJavaEnableCB           ( this, ResId( CB_J_ENABLE ) ),
//STRIP001     aJavaSecurityCB         ( this, ResId( CB_J_SECURITY ) ),
//STRIP001     aNetAccessFT            ( this, ResId( FT_NETACCESS ) ),
//STRIP001     aNetAccessLB            ( this, ResId( LB_NETACCESS ) ),
//STRIP001     aClassPathFT            ( this, ResId( FT_CLASSPATH ) ),
//STRIP001     aClassPathED            ( this, ResId( ED_CLASSPATH ) ),
//STRIP001     aClassPathPB            ( this, ResId( PB_CLASSPATH ) ),
//STRIP001     aSeparatorFL            ( this, ResId( FL_SEPARATOR ) ),
//STRIP001     aExecuteGB              ( this, ResId( GB_EXECUTE ) ),
//STRIP001     aExePlugCB              ( this, ResId( CB_EXECUTE_PLUGINS ) ),
//STRIP001     aExecAppletsCB          ( this, ResId( CB_EXECUTE_APPLETS ) ),
//STRIP001 
//STRIP001     pJavaOptions            ( new SvtJavaOptions ),
//STRIP001 
//STRIP001     bROConfirm              ( CFG_READONLY_DEFAULT),
//STRIP001     bROWarning              ( CFG_READONLY_DEFAULT),
//STRIP001     bROScriptExec           ( CFG_READONLY_DEFAULT),
//STRIP001     bROExecMacro            ( CFG_READONLY_DEFAULT),
//STRIP001     bROExePlug              ( CFG_READONLY_DEFAULT)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aEdtScriptExec.SetModifyHdl( LINK(this, SvxScriptingTabPage, EditHdl_Impl) );
//STRIP001 	aLbScriptExec.SetSelectHdl( LINK(this, SvxScriptingTabPage, LBHdl_Impl) );
//STRIP001 
//STRIP001 	Link aLink( LINK(this, SvxScriptingTabPage, BtnHdl_Impl) );
//STRIP001 	aBtnScriptExecInsert.SetClickHdl( aLink );
//STRIP001 	aBtnScriptExecDelete.SetClickHdl( aLink );
//STRIP001 	aBtnScriptExecDefault.SetClickHdl( aLink );
//STRIP001 
//STRIP001     aExecMacroLB.SetSelectHdl(LINK( this, SvxScriptingTabPage, RunHdl_Impl ));
//STRIP001 	EditHdl_Impl( NULL );
//STRIP001 	ActivatePage( rSet );
//STRIP001 
//STRIP001 #ifdef SOLAR_JAVA
//STRIP001 	aLink = LINK(this, SvxScriptingTabPage, JavaEnableHdl_Impl);
//STRIP001     aJavaEnableCB.SetClickHdl( aLink );
//STRIP001     aJavaSecurityCB.SetClickHdl( aLink );
//STRIP001     aClassPathPB.SetClickHdl( LINK(this, SvxScriptingTabPage, ClassPathHdl_Impl) );
//STRIP001 #endif
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 SvxScriptingTabPage::~SvxScriptingTabPage()
//STRIP001 {
//STRIP001     delete pJavaOptions;
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 void SvxScriptingTabPage::EnableJava_Impl( BOOL bEnable, BOOL bOnlySecurity )
//STRIP001 {
//STRIP001 	if ( !bOnlySecurity )
//STRIP001 	{
//STRIP001 		aJavaSecurityCB.Enable( bEnable );
//STRIP001     	aClassPathFT.Enable( bEnable );
//STRIP001 	    aClassPathED.Enable( bEnable );
//STRIP001 	    aClassPathPB.Enable( bEnable );
//STRIP001 	    aExecAppletsCB.Enable( bEnable );
//STRIP001 	}
//STRIP001 
//STRIP001 	bEnable = ( bEnable && aJavaSecurityCB.IsChecked() );
//STRIP001     aNetAccessFT.Enable( bEnable );
//STRIP001     aNetAccessLB.Enable( bEnable );
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 IMPL_LINK( SvxScriptingTabPage, JavaEnableHdl_Impl, CheckBox*, pBox )
//STRIP001 {
//STRIP001 	EnableJava_Impl( pBox->IsChecked(), &aJavaSecurityCB == pBox );
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxScriptingTabPage, ClassPathHdl_Impl, PushButton*, EMPTYARG )
//STRIP001 {
//STRIP001 	SvxMultiFileDialog aDlg( this, TRUE );
//STRIP001 	aDlg.SetClassPathMode();
//STRIP001     aDlg.SetPath( aClassPathED.GetText() );
//STRIP001 	if ( aDlg.Execute() == RET_OK )
//STRIP001 	{
//STRIP001 		// convert to system path if necessary
//STRIP001 		String sNewPath, sPath = aDlg.GetPath();
//STRIP001 		xub_StrLen nCount = sPath.GetTokenCount( CLASSPATH_DELIMITER );
//STRIP001 		for ( USHORT i = 0; i < nCount; ++i )
//STRIP001 		{
//STRIP001         	String sTmp, sToken = sPath.GetToken( i, CLASSPATH_DELIMITER );
//STRIP001         	if ( ::utl::LocalFileHelper::ConvertURLToSystemPath( sToken, sTmp ) )
//STRIP001 				sToken = sTmp;
//STRIP001 			if ( sNewPath.Len() > 0 )
//STRIP001 				sNewPath += CLASSPATH_DELIMITER;
//STRIP001 			sNewPath += sToken;
//STRIP001 		}
//STRIP001 
//STRIP001 		aClassPathED.SetText( sNewPath );
//STRIP001 	}
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SfxTabPage*	SvxScriptingTabPage::Create(Window* pParent, const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new SvxScriptingTabPage(pParent, rAttrSet);
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SvxScriptingTabPage::ActivatePage( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 int SvxScriptingTabPage::DeactivatePage( SfxItemSet* pSet )
//STRIP001 {
//STRIP001     if ( pSet )
//STRIP001 		FillItemSet( *pSet );
//STRIP001 	return LEAVE_PAGE;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SvxScriptingTabPage::FillListBox_Impl()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SvxScriptingTabPage, EditHdl_Impl, Edit*, EMPTYARG )
//STRIP001 
//STRIP001 /*	[Beschreibung]
//STRIP001 
//STRIP001 	ModifyHandler vom Edit. Der 'Hinzuf"ugen'-Button wird nur enabled,
//STRIP001 	wenn der Text im Edit vorhanden ist und nicht nur aus Blanks besteht.
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001     if (bROScriptExec)
//STRIP001         return 1L;
//STRIP001 
//STRIP001     String aTxt = aEdtScriptExec.GetText();
//STRIP001     aTxt.EraseLeadingChars().EraseTrailingChars();
//STRIP001     aBtnScriptExecInsert.Enable( aTxt.Len() > 0 );
//STRIP001 	return 1L;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SvxScriptingTabPage, LBHdl_Impl, ListBox*, EMPTYARG )
//STRIP001 {
//STRIP001     if (bROScriptExec)
//STRIP001         return 1L;
//STRIP001 
//STRIP001     USHORT nPos = aLbScriptExec.GetSelectEntryPos();
//STRIP001     aBtnScriptExecDelete.Enable( nPos != LISTBOX_ENTRY_NOTFOUND );
//STRIP001 	return 1L;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SvxScriptingTabPage, BtnHdl_Impl, PushButton*, pBtn )
//STRIP001 {
//STRIP001     if (bROScriptExec)
//STRIP001         return 1L;
//STRIP001 
//STRIP001 	if( pBtn == &aBtnScriptExecInsert )
//STRIP001 	{
//STRIP001 		// Insert new entry if not found in listbox
//STRIP001 		String aNewEntry = aEdtScriptExec.GetText();
//STRIP001         aNewEntry.EraseLeadingChars().EraseTrailingChars();
//STRIP001         INetURLObject aINetObject(aNewEntry, INET_PROT_HTTP);
//STRIP001         if(INET_PROT_FILE == aINetObject.GetProtocol())
//STRIP001             aNewEntry = aINetObject.GetFull();
//STRIP001         else
//STRIP001             aNewEntry = aINetObject.GetMainURL( INetURLObject::DECODE_TO_IURI );
//STRIP001         // if it's not a URL of any kind the original string is used again
//STRIP001         if(!aNewEntry.Len())
//STRIP001             aNewEntry = aEdtScriptExec.GetText().EraseLeadingChars().EraseTrailingChars();
//STRIP001         aEdtScriptExec.SetText( aNewEntry );
//STRIP001 		FASTBOOL bFound = !aNewEntry.Len();
//STRIP001 
//STRIP001 		if ( !bFound )
//STRIP001 		{
//STRIP001 			for ( USHORT i = 0; i < aLbScriptExec.GetEntryCount(); ++i )
//STRIP001 			{
//STRIP001 				String aEntry = aLbScriptExec.GetEntry(i);
//STRIP001 
//STRIP001 				if ( aEntry.CompareIgnoreCaseToAscii( aNewEntry ) == COMPARE_EQUAL )
//STRIP001 				{
//STRIP001 					bFound = TRUE;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( !bFound )
//STRIP001 		{
//STRIP001 			aLbScriptExec.InsertEntry( aNewEntry );
//STRIP001 			aLbScriptExec.SelectEntry( aNewEntry );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( pBtn == &aBtnScriptExecDelete )
//STRIP001 	{
//STRIP001 		// delete selected entry
//STRIP001 		USHORT nPos = aLbScriptExec.GetSelectEntryPos();
//STRIP001 
//STRIP001 		if ( nPos != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 		{
//STRIP001 			aLbScriptExec.RemoveEntry( nPos );
//STRIP001 			USHORT nCount = aLbScriptExec.GetEntryCount();
//STRIP001 
//STRIP001 			if ( nCount > 0 )
//STRIP001 			{
//STRIP001 				if ( nPos >= nCount )
//STRIP001 					nPos = nCount - 1;
//STRIP001 			}
//STRIP001 			aLbScriptExec.SelectEntryPos( nPos );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( pBtn == &aBtnScriptExecDefault )
//STRIP001 	{
//STRIP001 		// Reset listbox and edit
//STRIP001 
//STRIP001         aLbScriptExec.Clear();
//STRIP001         SvtPathOptions aPathOpt;
//STRIP001 
//STRIP001         String sModule = so3::StaticBaseUrl::SmartRelToAbs( aPathOpt.GetModulePath() );
//STRIP001         INetURLObject aURLObject(sModule);
//STRIP001         aURLObject.removeSegment();
//STRIP001         aLbScriptExec.InsertEntry( aURLObject.GetFull() );
//STRIP001         // #102041# -------------------------------
//STRIP001         ::rtl::OUString aString;
//STRIP001         ::utl::Bootstrap::locateUserInstallation( aString );
//STRIP001         UniString aUniString( aString );
//STRIP001         aUniString.AppendAscii( "/user" );
//STRIP001         aURLObject = aUniString;
//STRIP001         aLbScriptExec.InsertEntry( aURLObject.GetFull() );
//STRIP001 		aEdtScriptExec.SetText( String() );
//STRIP001 	}
//STRIP001 	LBHdl_Impl( NULL );
//STRIP001 	EditHdl_Impl( NULL );
//STRIP001 
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SvxScriptingTabPage, RunHdl_Impl, ListBox*, pListBox )
//STRIP001 {
//STRIP001     sal_Bool bConfirm = sal_False;
//STRIP001     sal_Bool bWarning = sal_True;
//STRIP001     switch(pListBox->GetSelectEntryPos())
//STRIP001     {
//STRIP001         case 1 : //according to list
//STRIP001             bConfirm = sal_True;
//STRIP001         break;
//STRIP001         case 0: //never
//STRIP001             bWarning = sal_False;
//STRIP001         break;
//STRIP001 //        case 2 : //always
//STRIP001 //        break;
//STRIP001     }
//STRIP001     if (!bROConfirm)
//STRIP001         aConfirmCB.Enable(bConfirm);
//STRIP001     if (!bROWarning)
//STRIP001         aWarningCB.Enable(bWarning);
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL SvxScriptingTabPage::FillItemSet(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	// ggf. neuen Eintrag einf"ugen
//STRIP001 	BtnHdl_Impl( &aBtnScriptExecInsert );
//STRIP001 
//STRIP001 	BOOL bModified = FALSE;
//STRIP001 
//STRIP001 	// Liste fuer Scripting (Execute)
//STRIP001     if (!bROScriptExec)
//STRIP001     {
//STRIP001         List aList;
//STRIP001         USHORT nCount = aLbScriptExec.GetEntryCount();
//STRIP001         for( USHORT i = 0; i < nCount; i++ )
//STRIP001         {
//STRIP001             String sURL(so3::StaticBaseUrl::SmartRelToAbs(aLbScriptExec.GetEntry( i )));
//STRIP001             aList.Insert( new String( sURL ), LIST_APPEND );
//STRIP001         }
//STRIP001 
//STRIP001         // Vergleichen mit alter Liste
//STRIP001         const SfxItemSet&  rOldSet = GetItemSet();
//STRIP001         const SfxPoolItem* pItem;
//STRIP001         if( SFX_ITEM_SET == rOldSet.GetItemState( SID_SECURE_URL, FALSE, &pItem ) )
//STRIP001         {
//STRIP001             DBG_ASSERT( pItem->ISA(SfxStringListItem), "SfxStringListItem erwartet" );
//STRIP001             List* pList = ( (SfxStringListItem*)pItem )->GetList();
//STRIP001 
//STRIP001             if( pList )
//STRIP001             {
//STRIP001                 ULONG nOldCount = pList->Count();
//STRIP001                 if( nCount != nOldCount )
//STRIP001                     bModified = TRUE;
//STRIP001 
//STRIP001                 for ( ULONG i = 0; i < nOldCount && !bModified; i++ )
//STRIP001                 {
//STRIP001                     if ( *(String*)aList.GetObject(i) != *(String*)pList->GetObject(i) )
//STRIP001                         bModified = TRUE;
//STRIP001                 }
//STRIP001             }
//STRIP001         }
//STRIP001 
//STRIP001         if ( bModified )
//STRIP001         {
//STRIP001             rSet.Put( SfxStringListItem( SID_SECURE_URL, &aList ) );
//STRIP001         }
//STRIP001         // Liste (Inhalte) wieder loeschen
//STRIP001         for( String* pStr = (String*)aList.First(); pStr; pStr = (String*)aList.Next() )
//STRIP001             delete pStr;
//STRIP001     }
//STRIP001     if( !bROConfirm && aConfirmCB.GetSavedValue() != aConfirmCB.IsChecked() )
//STRIP001 	{
//STRIP001         rSet.Put( SfxBoolItem(SID_MACRO_CONFIRMATION, aConfirmCB.IsChecked()) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001     if( !bROWarning && aWarningCB.GetSavedValue() != aWarningCB.IsChecked() )
//STRIP001 	{
//STRIP001         rSet.Put( SfxBoolItem(SID_MACRO_WARNING, aWarningCB.IsChecked()) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Scripting
//STRIP001     if( !bROExecMacro && aExecMacroLB.GetSelectEntryPos() != aExecMacroLB.GetSavedValue())
//STRIP001 	{
//STRIP001         USHORT nSB = aExecMacroLB.GetSelectEntryPos();
//STRIP001 		rSet.Put( SfxUInt16Item( SID_BASIC_ENABLED, nSB ) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001     //  Execute
//STRIP001     if( !bROExePlug && aExePlugCB.GetSavedValue() != aExePlugCB.IsChecked() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem(SID_INET_EXE_PLUGIN, aExePlugCB.IsChecked()) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001     // Java
//STRIP001     sal_Bool bJavaOptionsModified = sal_False;
//STRIP001     if ( !pJavaOptions->IsReadOnly(SvtJavaOptions::E_ENABLED) && aJavaEnableCB.GetSavedValue() != aJavaEnableCB.IsChecked() )
//STRIP001     {
//STRIP001         pJavaOptions->SetEnabled(aJavaEnableCB.IsChecked());
//STRIP001         bJavaOptionsModified = sal_True;
//STRIP001     }
//STRIP001 
//STRIP001     // Applets
//STRIP001     if ( aExecAppletsCB.IsEnabled() &&
//STRIP001          aExecAppletsCB.GetSavedValue() != aExecAppletsCB.IsChecked() &&
//STRIP001          !pJavaOptions->IsReadOnly(SvtJavaOptions::E_EXECUTEAPPLETS) )
//STRIP001 	{
//STRIP001         pJavaOptions->SetExecuteApplets(aExecAppletsCB.IsChecked());
//STRIP001         bJavaOptionsModified = sal_True;
//STRIP001     }
//STRIP001 
//STRIP001     USHORT nSelPos = aNetAccessLB.GetSelectEntryPos();
//STRIP001     if( !pJavaOptions->IsReadOnly(SvtJavaOptions::E_NETACCESS) && aNetAccessLB.GetSavedValue() != nSelPos )
//STRIP001     {
//STRIP001         pJavaOptions->SetNetAccess(nSelPos);
//STRIP001         bJavaOptionsModified = sal_True;
//STRIP001     }
//STRIP001     if(!pJavaOptions->IsReadOnly(SvtJavaOptions::E_SECURITY) && aJavaSecurityCB.GetSavedValue() != aJavaSecurityCB.IsChecked() )
//STRIP001     {
//STRIP001         pJavaOptions->SetSecurity(aJavaSecurityCB.IsChecked() );
//STRIP001         bJavaOptionsModified = sal_True;
//STRIP001     }
//STRIP001     if(!pJavaOptions->IsReadOnly(SvtJavaOptions::E_USERCLASSPATH) && aClassPathED.GetSavedValue() != aClassPathED.GetText() )
//STRIP001     {
//STRIP001         String aNewPath = aClassPathED.GetText();
//STRIP001 		aNewPath.EraseLeadingChars().EraseTrailingChars();
//STRIP001         pJavaOptions->SetUserClassPath(aNewPath);
//STRIP001         bJavaOptionsModified = sal_True;
//STRIP001     }
//STRIP001     if(bJavaOptionsModified)
//STRIP001         pJavaOptions->Commit();
//STRIP001 
//STRIP001 	// hyperlinks
//STRIP001 	if ( aHyperlinksLB.GetSavedValue() != aHyperlinksLB.GetSelectEntryPos() )
//STRIP001 	{
//STRIP001 		SvtExtendedSecurityOptions::OpenHyperlinkMode eMode =
//STRIP001 			(SvtExtendedSecurityOptions::OpenHyperlinkMode)aHyperlinksLB.GetSelectEntryPos();
//STRIP001 		SvtExtendedSecurityOptions().SetOpenHyperlinkMode( eMode );
//STRIP001 	}
//STRIP001 
//STRIP001 	return bModified;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SvxScriptingTabPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 	// Execute
//STRIP001 	aLbScriptExec.Clear();
//STRIP001     bROScriptExec = TRUE;
//STRIP001 	if ( SFX_ITEM_SET == rSet.GetItemState(SID_SECURE_URL, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxStringListItem), "StringListItem erwartet" );
//STRIP001 		List* pList = ( (SfxStringListItem*)pItem )->GetList();
//STRIP001 
//STRIP001 		if ( pList )
//STRIP001 		{
//STRIP001 			ULONG nCount = pList->Count();
//STRIP001 
//STRIP001 			for ( ULONG i = 0; i < nCount; i++ )
//STRIP001             {
//STRIP001                 INetURLObject aURL(*(String*)pList->GetObject(i));
//STRIP001                 aLbScriptExec.InsertEntry(
//STRIP001                     INET_PROT_FILE == aURL.GetProtocol() ?
//STRIP001                         aURL.GetFull() : aURL.GetMainURL( INetURLObject::DECODE_TO_IURI ) );
//STRIP001             }
//STRIP001             bROScriptExec = FALSE;
//STRIP001 		}
//STRIP001 	}
//STRIP001     aLbScriptExec.Enable(!bROScriptExec);
//STRIP001     aEdtScriptExec.Enable(!bROScriptExec);
//STRIP001     aBtnScriptExecDelete.Enable(!bROScriptExec);
//STRIP001     aBtnScriptExecDefault.Enable(!bROScriptExec);
//STRIP001     aBtnScriptExecInsert.Enable(!bROScriptExec);
//STRIP001     aPathListFT.Enable(!bROScriptExec);
//STRIP001     aNewPathFT.Enable(!bROScriptExec);
//STRIP001 
//STRIP001     bROWarning = TRUE;
//STRIP001     if( SFX_ITEM_SET == rSet.GetItemState(SID_MACRO_WARNING, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
//STRIP001         aWarningCB.Check(((const SfxBoolItem*)pItem)->GetValue());
//STRIP001         bROWarning = FALSE;
//STRIP001 	}
//STRIP001     aWarningCB.SaveValue();
//STRIP001     aWarningCB.Enable(!bROWarning);
//STRIP001 
//STRIP001     bROConfirm = TRUE;
//STRIP001     if( SFX_ITEM_SET == rSet.GetItemState(SID_MACRO_CONFIRMATION, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
//STRIP001         aConfirmCB.Check(((const SfxBoolItem*)pItem)->GetValue());
//STRIP001         bROConfirm = FALSE;
//STRIP001 	}
//STRIP001     aConfirmCB.SaveValue();
//STRIP001     aConfirmCB.Enable(!bROConfirm);
//STRIP001 
//STRIP001     aExecMacroLB.SelectEntryPos(0);
//STRIP001     bROExecMacro = TRUE;
//STRIP001     if ( SFX_ITEM_SET == rSet.GetItemState( SID_BASIC_ENABLED, FALSE, &pItem ) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxUInt16Item), "SfxUInt16Item erwartet" );
//STRIP001 		USHORT nSB = ( (const SfxUInt16Item*)pItem )->GetValue();
//STRIP001         aExecMacroLB.SelectEntryPos(nSB);
//STRIP001         bROExecMacro = FALSE;
//STRIP001 	}
//STRIP001     if (bROExecMacro)
//STRIP001         aExecMacroLB.Clear();
//STRIP001     aExecMacroLB.Enable(!bROExecMacro);
//STRIP001     aExecMacroFT.Enable(!bROExecMacro);
//STRIP001     aExecMacroLB.SaveValue();
//STRIP001 
//STRIP001     // Execute
//STRIP001     bROExePlug = TRUE;
//STRIP001 	if( SFX_ITEM_SET == rSet.GetItemState(SID_INET_EXE_PLUGIN, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT(pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet");
//STRIP001 		aExePlugCB.Check(((const SfxBoolItem*)pItem)->GetValue());
//STRIP001         bROExePlug = FALSE;
//STRIP001 	}
//STRIP001     aExePlugCB.SaveValue();
//STRIP001     aExePlugCB.Enable(!bROExePlug);
//STRIP001 
//STRIP001 	EditHdl_Impl( NULL );
//STRIP001     RunHdl_Impl(&aExecMacroLB);
//STRIP001     LBHdl_Impl( NULL );
//STRIP001 
//STRIP001     // Java
//STRIP001     sal_Bool bROJavaEnabled = pJavaOptions->IsReadOnly(SvtJavaOptions::E_ENABLED);
//STRIP001     sal_Bool bROJavaSecurity = pJavaOptions->IsReadOnly(SvtJavaOptions::E_SECURITY);
//STRIP001     sal_Bool bROJavaNetAccess = pJavaOptions->IsReadOnly(SvtJavaOptions::E_NETACCESS);
//STRIP001     sal_Bool bROJavaUserClassPath = pJavaOptions->IsReadOnly(SvtJavaOptions::E_USERCLASSPATH);
//STRIP001     sal_Bool bROJavaExecuteApplets = pJavaOptions->IsReadOnly(SvtJavaOptions::E_EXECUTEAPPLETS);
//STRIP001 
//STRIP001     aJavaEnableCB.Check(FALSE);
//STRIP001     if (!bROJavaEnabled)
//STRIP001     {
//STRIP001         aJavaEnableCB.Check(pJavaOptions->IsEnabled());
//STRIP001         #ifndef SOLAR_JAVA
//STRIP001         aJavaEnableCB.Check(FALSE);
//STRIP001         #endif
//STRIP001         aJavaEnableCB.SaveValue();
//STRIP001     }
//STRIP001     aJavaEnableCB.Enable(!bROJavaEnabled);
//STRIP001 	EnableJava_Impl( aJavaEnableCB.IsChecked(), FALSE );
//STRIP001 
//STRIP001     if (!bROJavaNetAccess)
//STRIP001     {
//STRIP001         aNetAccessLB.SelectEntryPos((USHORT)pJavaOptions->GetNetAccess());
//STRIP001         aNetAccessLB.SaveValue();
//STRIP001     }
//STRIP001     aNetAccessLB.Enable(!bROJavaNetAccess);
//STRIP001 
//STRIP001     aJavaSecurityCB.Check(FALSE);
//STRIP001     if (!bROJavaSecurity)
//STRIP001     {
//STRIP001         aJavaSecurityCB.Check(pJavaOptions->IsSecurity());
//STRIP001         aJavaSecurityCB.SaveValue();
//STRIP001     }
//STRIP001     aJavaSecurityCB.Enable(!bROJavaSecurity);
//STRIP001 	EnableJava_Impl( ( aJavaEnableCB.IsChecked() && aJavaSecurityCB.IsChecked() ), TRUE );
//STRIP001 
//STRIP001     aClassPathED.SetText(String());
//STRIP001     if (!bROJavaUserClassPath)
//STRIP001     {
//STRIP001         aClassPathED.SetText(pJavaOptions->GetUserClassPath());
//STRIP001         aClassPathED.SaveValue();
//STRIP001     }
//STRIP001     aClassPathED.Enable(!bROJavaUserClassPath);
//STRIP001 
//STRIP001     // Execute Applets
//STRIP001     aExecAppletsCB.Check(FALSE);
//STRIP001     if (!bROJavaExecuteApplets)
//STRIP001     {
//STRIP001         aExecAppletsCB.Check( pJavaOptions->IsExecuteApplets() );
//STRIP001         aExecAppletsCB.SaveValue();
//STRIP001     }
//STRIP001     aExecAppletsCB.Enable(!bROJavaExecuteApplets);
//STRIP001 
//STRIP001 	// hyperlinks
//STRIP001 	SvtExtendedSecurityOptions::OpenHyperlinkMode eMode = SvtExtendedSecurityOptions().GetOpenHyperlinkMode();
//STRIP001 	aHyperlinksLB.SelectEntryPos( (USHORT)eMode );
//STRIP001 	aHyperlinksLB.SaveValue();
//STRIP001 
//STRIP001     // disable groups if all controls of it are disabled
//STRIP001     // But use real "enabled" states of the controls - not the readonly values of the configuration!
//STRIP001     // Because some controls are disabled programmaticly if another control will have a special value ...
//STRIP001 
//STRIP001     if (!aLbScriptExec.IsEnabled() &&
//STRIP001         !aEdtScriptExec.IsEnabled() &&
//STRIP001         !aBtnScriptExecDelete.IsEnabled() &&
//STRIP001         !aBtnScriptExecDefault.IsEnabled() &&
//STRIP001         !aBtnScriptExecInsert.IsEnabled() &&
//STRIP001         !aPathListFT.IsEnabled() &&
//STRIP001         !aNewPathFT.IsEnabled() &&
//STRIP001         !aExecMacroLB.IsEnabled() &&
//STRIP001         !aExecMacroFT.IsEnabled() &&
//STRIP001         !aWarningCB.IsEnabled() &&
//STRIP001         !aConfirmCB.IsEnabled())
//STRIP001     {
//STRIP001         aGrpScriptingStarBasic.Enable(FALSE);
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         aGrpScriptingStarBasic.Enable(TRUE);
//STRIP001     }
//STRIP001 
//STRIP001     if (!aExePlugCB.IsEnabled() &&
//STRIP001         !aExecAppletsCB.IsEnabled())
//STRIP001     {
//STRIP001         aExecuteGB.Enable(FALSE);
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         aExecuteGB.Enable(TRUE);
//STRIP001     }
//STRIP001 
//STRIP001     if (!aJavaEnableCB.IsEnabled() &&
//STRIP001         !aNetAccessLB.IsEnabled() &&
//STRIP001         !aJavaSecurityCB.IsEnabled() &&
//STRIP001         !aClassPathED.IsEnabled())
//STRIP001     {
//STRIP001         aJavaFL.Enable(FALSE);
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         aJavaFL.Enable(TRUE);
//STRIP001     }
//STRIP001 }
}
