/*************************************************************************
 *
 *  $RCSfile: svx_svdscrol.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:31:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include "svdscrol.hxx"
#include <math.h>
// auto strip #include "svdtrans.hxx"
// auto strip #include "svdpagv.hxx"
// auto strip #include "svdview.hxx"
namespace binfilter {

////////////////////////////////////////////////////////////////////////////////////////////////////

//STRIP001 void ImpMtfAnimationInfo::SaveBackground(const ImpSdrMtfAnimator& rAnimator, const Region* pClip)
//STRIP001 {
//STRIP001 	Point aZero;
//STRIP001 	MapMode aMapMode(pOutDev->GetMapMode());
//STRIP001 	aMapMode.SetOrigin(aZero);
//STRIP001 	aBackground.SetMapMode(aMapMode);
//STRIP001 	Size aOutputSize(rAnimator.aOutputRect.GetSize());
//STRIP001 	Point aOutputTopLeft(rAnimator.aOutputRect.TopLeft());
//STRIP001 	aOutputTopLeft+=aOffset;
//STRIP001 
//STRIP001 //	if (pClip!=NULL) {
//STRIP001 //		Region aRegion(*pClip);
//STRIP001 //		aRegion.Move(-aOutputTopLeft.X(),-aOutputTopLeft.Y());
//STRIP001 //		aBackground.SetClipRegion(aRegion);
//STRIP001 //	}
//STRIP001 
//STRIP001 	// #73647#
//STRIP001 	Region aBackClipRegion = pOutDev->GetActiveClipRegion();
//STRIP001 	aBackClipRegion.Move(-aOutputTopLeft.X(), -aOutputTopLeft.Y());
//STRIP001 	aBackground.SetClipRegion(aBackClipRegion);
//STRIP001 
//STRIP001 	aBackground.DrawOutDev(aZero,aOutputSize,aOutputTopLeft,aOutputSize,*pOutDev);
//STRIP001 
//STRIP001 // see #68462#
//STRIP001 //	if (pPageView!=NULL) { // Xor ggf. entfernen vom gesicherten Hintergrund
//STRIP001 //		const SdrView& rView=pPageView->GetView();
//STRIP001 //		if (rView.IsShownXorVisible(pOutDev)) {
//STRIP001 //			Point aPaintPos;
//STRIP001 //			aPaintPos-=aOutputTopLeft;
//STRIP001 //			aPaintPos+=aOffset;
//STRIP001 //			MapMode aMap(aBackground.GetMapMode());
//STRIP001 //			aMap.SetOrigin(aPaintPos);
//STRIP001 //			aBackground.SetMapMode(aMap);
//STRIP001 //			rView.ToggleShownXor(&aBackground,NULL);
//STRIP001 //			aMap.SetOrigin(aZero);
//STRIP001 //			aBackground.SetMapMode(aMap); // MapMode wieder zurueksetzen, sonst geht das DrawOutDev spaeter schief
//STRIP001 //		}
//STRIP001 //	}
//STRIP001 	aBackground.SetClipRegion();
//STRIP001 }
//STRIP001 
//STRIP001 void ImpMtfAnimationInfo::Paint(const ImpSdrMtfAnimator& rAnimator, OutputDevice& rOut) const
//STRIP001 {
//STRIP001 	Point aZero;
//STRIP001 	Size aOutputSize(rAnimator.aOutputRect.GetSize());
//STRIP001 	Point aOutputTopLeft(rAnimator.aOutputRect.TopLeft());
//STRIP001 	aOutputTopLeft+=aOffset;
//STRIP001 	Region aClipMerk;
//STRIP001 	FASTBOOL bClipMerk;
//STRIP001 	if (rAnimator.bClipRegion) {
//STRIP001 		bClipMerk=rOut.IsClipRegion();
//STRIP001 		aClipMerk=rOut.GetClipRegion();
//STRIP001 		if (aOffset==aZero) {
//STRIP001 			rOut.SetClipRegion(rAnimator.aClipRegion);
//STRIP001 		} else {
//STRIP001 			Region aTempRegion(rAnimator.aClipRegion);
//STRIP001 			aTempRegion.Move(aOffset.X(),aOffset.Y());
//STRIP001 			rOut.SetClipRegion(aTempRegion);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	rOut.DrawOutDev(aOutputTopLeft,aOutputSize,aZero,aOutputSize,aVirDev);
//STRIP001 	if (rAnimator.bClipRegion) {
//STRIP001 		if (bClipMerk) rOut.SetClipRegion(aClipMerk);
//STRIP001 		else rOut.SetClipRegion();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ImpMtfAnimationInfo::AnimateOneStep(ImpSdrMtfAnimator& rAnimator)
//STRIP001 {
//STRIP001 	if (bReady) return;
//STRIP001 	Point aZero;
//STRIP001 	Size aOutputSize(rAnimator.aOutputRect.GetSize());
//STRIP001 	Point aOutputTopLeft(rAnimator.aOutputRect.TopLeft());
//STRIP001 	aOutputTopLeft+=aOffset;
//STRIP001 	if (!bBackSaved) {
//STRIP001 		MapMode aMapMode(pOutDev->GetMapMode());
//STRIP001 		aMapMode.SetOrigin(aZero);
//STRIP001 		aBackground.SetMapMode(aMapMode);
//STRIP001 		if (!aBackground.SetOutputSize(aOutputSize)) {
//STRIP001 			DBG_ERROR("AnimateOneStep(): Zuwenig Speicherplatz zum sichern des Hintergrunds!");
//STRIP001 		}
//STRIP001 		SaveBackground(rAnimator);
//STRIP001 		bBackSaved=TRUE;
//STRIP001 		aVirDev.SetMapMode(aMapMode);
//STRIP001 		if (!aVirDev.SetOutputSize(aOutputSize)) {
//STRIP001 			DBG_ERROR("AnimateOneStep(): Zuwenig Speicherplatz fuer das Paint-VDev!");
//STRIP001 		}
//STRIP001 	}
//STRIP001 	// erstmal den Hintergrund ins VDev kopieren
//STRIP001 	aVirDev.DrawOutDev(aZero,aOutputSize,aZero,aOutputSize,aBackground);
//STRIP001 
//STRIP001 	SdrTextAniKind eAniKind=rAnimator.eAniKind;
//STRIP001 	SdrTextAniDirection eDirection=rAnimator.eDirection;
//STRIP001 	FASTBOOL bBlink=eAniKind==SDRTEXTANI_BLINK;
//STRIP001 	FASTBOOL bSlide=eAniKind==SDRTEXTANI_SLIDE;
//STRIP001 	FASTBOOL bHorz=eDirection==SDRTEXTANI_LEFT || eDirection==SDRTEXTANI_RIGHT;
//STRIP001 	FASTBOOL bVert=eDirection==SDRTEXTANI_UP || eDirection==SDRTEXTANI_DOWN;
//STRIP001 	FASTBOOL bRev=eDirection==SDRTEXTANI_RIGHT || eDirection==SDRTEXTANI_DOWN;
//STRIP001 	if (bBackTrack) bRev=!bRev; // Rueckweg bei Alternate (oder Slide)
//STRIP001 	FASTBOOL bStartInside=rAnimator.bStartInside && !bSlide;
//STRIP001 	FASTBOOL bStopInside=rAnimator.bStopInside || bSlide;
//STRIP001 	Rectangle aScrollFrameRect(rAnimator.aScrollFrameRect);
//STRIP001 	Rectangle aMtfBoundRect(rAnimator.aMtfBoundRect);
//STRIP001 	long nFL=bHorz?aScrollFrameRect.Left():aScrollFrameRect.Top();     // Frame Links bzw. Oben
//STRIP001 	long nFR=bHorz?aScrollFrameRect.Right():aScrollFrameRect.Bottom(); // Frame Rechts bzw. Unten
//STRIP001 	long nFW=nFR-nFL;                                                  // Frame Breite bzw. Hoehe
//STRIP001 	long nTL=bHorz?aMtfBoundRect.Left():aMtfBoundRect.Top();           // Text Links bzw. Oben
//STRIP001 	long nTR=bHorz?aMtfBoundRect.Right():aMtfBoundRect.Bottom();       // Text Rechts bzw. Unten
//STRIP001 	long nTW=nTR-nTL;                                                  // Text Breite bzw. Hoehe
//STRIP001 	if (bNeu) {
//STRIP001 		bNeu=FALSE;
//STRIP001 		bShown=TRUE;
//STRIP001 		if (bBlink) {
//STRIP001 			bShown=bStartInside;
//STRIP001 		} else {
//STRIP001 			if (bStartInside && nLoopNum==0) {
//STRIP001 				// Wenn der Text kleiner als der Scrollbereich, dann andere StartPos (wie bRev)
//STRIP001 				nLoopStep=0; // Die durch die Verankerung vorgegebene Position verwenden!
//STRIP001 			} else {
//STRIP001 				if (!bRev) nLoopStep=nFR-nTL;
//STRIP001 				else nLoopStep=nFL-nTR;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	} else {
//STRIP001 		USHORT nMaxLoop=rAnimator.nMaxCount;
//STRIP001 		if (bSlide && nMaxLoop==0) nMaxLoop=1;
//STRIP001 		if (bBlink && nMaxLoop!=0 && !bStartInside && !bStopInside) nMaxLoop++; // etwas andere Zaehlung beim Blinken
//STRIP001 		FASTBOOL bLastLoop=nMaxLoop>0 && nLoopNum>=nMaxLoop-1 && (!bSlide || !bBackTrack);
//STRIP001 		if (bBlink) {
//STRIP001 			bShown=!bShown;
//STRIP001 			if (bShown) nLoopNum++;
//STRIP001 			if (bLastLoop && bShown==bStopInside) bReady=TRUE;
//STRIP001 		} else {
//STRIP001 			bShown=TRUE;
//STRIP001 			long nStep=rAnimator.nAmount;
//STRIP001 			if (nStep==0) nStep=-1;
//STRIP001 			if (nStep<0) {
//STRIP001 				nStep=pOutDev->PixelToLogic(Size(-nStep,0)).Width();
//STRIP001 			}
//STRIP001 			if (!bRev) nStep=-nStep;
//STRIP001 			nLoopStep+=nStep;
//STRIP001 			// Nun den Maximalwert fuer nLoopStep berechnen
//STRIP001 			long nLoopStepMax=0;
//STRIP001 			FASTBOOL bScrollOut=FALSE;
//STRIP001 			if (eAniKind==SDRTEXTANI_SCROLL) {
//STRIP001 				if (bLastLoop && bStopInside) nLoopStepMax=0; // Die durch die Verankerung vorgegebene Position verwenden!
//STRIP001 				else bScrollOut=TRUE;
//STRIP001 			} else if (eAniKind==SDRTEXTANI_ALTERNATE) {
//STRIP001 				if (bLastLoop) {
//STRIP001 					if (!bStopInside) bScrollOut=TRUE;
//STRIP001 					else nLoopStepMax=0; // Die durch die Verankerung vorgegebene Position verwenden!
//STRIP001 				} else { // Am Rand wenden
//STRIP001 					// Je nachdem, ob die Textbreite oder der sichtbare Bereich
//STRIP001 					// groesser ist, ist der eine oder der andere Rand relevant.
//STRIP001 					if ((!bRev) != (nTW>=nFW)) nLoopStepMax=nFL-nTL;
//STRIP001 					else nLoopStepMax=nFR-nTR;
//STRIP001 				}
//STRIP001 			} else if (bSlide) {
//STRIP001 				if (bBackTrack) bScrollOut=TRUE;
//STRIP001 				else nLoopStepMax=0; // Die durch die Verankerung vorgegebene Position verwenden!
//STRIP001 			}
//STRIP001 			if (bScrollOut) { // Rausschieben
//STRIP001 				if (!bRev) nLoopStepMax=nFL-nTR;
//STRIP001 				else nLoopStepMax=nFR-nTL;
//STRIP001 			}
//STRIP001 			if ((!bRev && nLoopStep<=nLoopStepMax) || (bRev && nLoopStep>=nLoopStepMax)) {
//STRIP001 				// Anschlag erreicht
//STRIP001 				nLoopStep=nLoopStepMax;
//STRIP001 				if (bSlide) {
//STRIP001 					if (!bBackTrack) nLoopNum++;
//STRIP001 				} else {
//STRIP001 					nLoopNum++;
//STRIP001 				}
//STRIP001 				if (!bLastLoop) {
//STRIP001 					if (eAniKind==SDRTEXTANI_SCROLL) bNeu=TRUE; // Naechste Runde wieder von vorn
//STRIP001 					else bBackTrack=!bBackTrack; // Sonst Alternate oder Slide
//STRIP001 				} else {
//STRIP001 					bReady=TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rAnimator.pMtf!=NULL && bShown) {
//STRIP001 		rAnimator.pMtf->WindStart();
//STRIP001 		Point aPaintPos;
//STRIP001 		if (!bBlink) { // hier wird nun die Position bestimmt
//STRIP001 			long nRoundedDistance=nLoopStep;
//STRIP001 			if (rAnimator.nRotateAngle!=0) {
//STRIP001 				// ggf. auf Pixel alignen um tanzende Buchstaben
//STRIP001 				// bei gedrehtem Text einzuschraenken #33360#
//STRIP001 				long nWink=rAnimator.nRotateAngle;
//STRIP001 				if (bVert) nWink+=9000;
//STRIP001 				nWink=NormAngle360(nWink);
//STRIP001 				if (nWink>18000) nWink-=18000;
//STRIP001 				if ((nWink>=3000 && nWink<=6000) || (nWink>=3000+9000 && nWink<=6000+9000)) {
//STRIP001 					// Andere Winkel sind zu Flach
//STRIP001 					double nSin=sin(nWink*nPi180);
//STRIP001 					long nUnrotDist=Round(nRoundedDistance*nSin);
//STRIP001 					nUnrotDist=pOutDev->LogicToPixel(Size(nUnrotDist,0)).Width();
//STRIP001 					nUnrotDist=pOutDev->PixelToLogic(Size(nUnrotDist,0)).Width();
//STRIP001 					nRoundedDistance=Round(nUnrotDist/nSin);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			if (bHorz) aPaintPos.X()+=nRoundedDistance;
//STRIP001 			if (bVert) aPaintPos.Y()+=nRoundedDistance;
//STRIP001 			if (rAnimator.nRotateAngle!=0) {
//STRIP001 				RotatePoint(aPaintPos,aZero,rAnimator.nSin,rAnimator.nCos);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		aPaintPos-=aOutputTopLeft;
//STRIP001 		aPaintPos+=aOffset;
//STRIP001 		MapMode aMap(aVirDev.GetMapMode());
//STRIP001 		aMap.SetOrigin(aPaintPos);
//STRIP001 		aVirDev.SetMapMode(aMap);
//STRIP001 		rAnimator.pMtf->Play(&aVirDev);
//STRIP001 		aMap.SetOrigin(aZero);
//STRIP001 		aVirDev.SetMapMode(aMap); // MapMode wieder zurueksetzen, sonst geht das DrawOutDev spaeter schief
//STRIP001 	}
//STRIP001 
//STRIP001 // see #68462#
//STRIP001 //	if (pPageView!=NULL) {
//STRIP001 //		const SdrView& rView=pPageView->GetView();
//STRIP001 //		if (rView.IsShownXorVisible(pOutDev)) {
//STRIP001 //			Point aPaintPos;
//STRIP001 //			aPaintPos-=aOutputTopLeft;
//STRIP001 //			aPaintPos+=aOffset;
//STRIP001 //			MapMode aMap(aVirDev.GetMapMode());
//STRIP001 //			aMap.SetOrigin(aPaintPos);
//STRIP001 //			aVirDev.SetMapMode(aMap);
//STRIP001 //			rView.ToggleShownXor(&aVirDev,NULL);
//STRIP001 //			aMap.SetOrigin(aZero);
//STRIP001 //			aVirDev.SetMapMode(aMap); // MapMode wieder zurueksetzen, sonst geht das DrawOutDev spaeter schief
//STRIP001 //		}
//STRIP001 //	}
//STRIP001 	Paint(rAnimator,*pOutDev);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpMtfAnimationInfo::Restart()
//STRIP001 {
//STRIP001 	bPause=FALSE;
//STRIP001 	bReady=FALSE;
//STRIP001 	bBackSaved=FALSE;
//STRIP001 	bBackTrack=FALSE;
//STRIP001 	bNeu=TRUE;
//STRIP001 	nLoopNum=0;
//STRIP001 	nLoopStep=0;
//STRIP001 }
//STRIP001 
////////////////////////////////////////////////////////////////////////////////////////////////////

///*N*/ ImpSdrMtfAnimator::ImpSdrMtfAnimator():
///*N*/ 	aInfoList(1024,16,16),
///*N*/ 	pMtf(NULL),
///*N*/ 	nRotateAngle(0),
///*N*/ 	nSin(0.0),
///*N*/ 	nCos(0.0),
///*N*/ 	bClipRegion(FALSE),
///*N*/ 	eAniKind(SDRTEXTANI_NONE),
///*N*/ 	eDirection(SDRTEXTANI_LEFT),
///*N*/ 	bStartInside(FALSE),
///*N*/ 	bStopInside(FALSE),
///*N*/ 	nMaxCount(0),
///*N*/ 	nDelay(0),
///*N*/ 	nAmount(0)
///*N*/ {
///*N*/ 	aTimer.SetTimeoutHdl(LINK(this,ImpSdrMtfAnimator,ImpTimerHdl));
///*N*/ }

///*N*/ ImpSdrMtfAnimator::~ImpSdrMtfAnimator()
///*N*/ {
///*N*/ 	ImpClearInfoList();
///*N*/ 	if (pMtf!=NULL) delete pMtf;
///*N*/ }

//STRIP001 ULONG ImpSdrMtfAnimator::FindInfo(const OutputDevice& rOut, const Point& rOffset, long nExtraData) const
//STRIP001 {
//STRIP001 	ULONG nAnz=GetInfoCount();
//STRIP001 	for (ULONG nNum=0; nNum<nAnz; nNum++) {
//STRIP001 		const ImpMtfAnimationInfo* pInfo=GetInfo(nNum);
//STRIP001 		if (pInfo->pOutDev==&rOut && pInfo->aOffset==rOffset && pInfo->nExtraData==nExtraData) {
//STRIP001 			return nNum;
//STRIP001 		}
//STRIP001 
//STRIP001 	}
//STRIP001 	return CONTAINER_ENTRY_NOTFOUND;
//STRIP001 }

///*N*/ void ImpSdrMtfAnimator::ImpClearInfoList()
///*N*/ {
///*N*/ 	ULONG nAnz=GetInfoCount();
///*N*/ 	for (ULONG nNum=nAnz; nNum>0;) {
///*N*/ 		nNum--;
///*N*/ 		RemoveInfo(nNum);
///*N*/ 	}
///*N*/ }

///*N*/ IMPL_LINK(ImpSdrMtfAnimator,ImpTimerHdl,AutoTimer*,pTimer)
///*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	aNotifyLink.Call(this);
//STRIP001 	ULONG nAnz=GetInfoCount();
//STRIP001 	for (ULONG nNum=0; nNum<nAnz; nNum++) {
//STRIP001 		ImpMtfAnimationInfo* pInfo=GetInfo(nNum);
//STRIP001 		if (!pInfo->bPause) pInfo->AnimateOneStep(*this);
//STRIP001 	}
//STRIP001 	if (nAnz==0) aTimer.Stop();
///*N*/ 	return 0;
///*N*/ }

//STRIP001 void ImpSdrMtfAnimator::SetGDIMetaFile(GDIMetaFile* pMetaFile)
//STRIP001 {
//STRIP001 	if (pMtf!=NULL) delete pMtf;
//STRIP001 	pMtf=pMetaFile;
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrMtfAnimator::SetRotateAngle(long nWink)
//STRIP001 {
//STRIP001 	if (nRotateAngle!=nWink) {
//STRIP001 		nRotateAngle=nWink;
//STRIP001 		double a=nWink*nPi180;
//STRIP001 		nSin=sin(a);
//STRIP001 		nCos=cos(a);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrMtfAnimator::SetAttributes(const SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	eAniKind    =((SdrTextAniKindItem       &)rSet.Get(SDRATTR_TEXT_ANIKIND       )).GetValue();
//STRIP001 	eDirection  =((SdrTextAniDirectionItem  &)rSet.Get(SDRATTR_TEXT_ANIDIRECTION  )).GetValue();
//STRIP001 	bStartInside=((SdrTextAniStartInsideItem&)rSet.Get(SDRATTR_TEXT_ANISTARTINSIDE)).GetValue();
//STRIP001 	bStopInside =((SdrTextAniStopInsideItem &)rSet.Get(SDRATTR_TEXT_ANISTOPINSIDE )).GetValue();
//STRIP001 	nMaxCount   =((SdrTextAniCountItem      &)rSet.Get(SDRATTR_TEXT_ANICOUNT      )).GetValue();
//STRIP001 	nDelay      =((SdrTextAniDelayItem      &)rSet.Get(SDRATTR_TEXT_ANIDELAY      )).GetValue();
//STRIP001 	nAmount     =((SdrTextAniAmountItem     &)rSet.Get(SDRATTR_TEXT_ANIAMOUNT     )).GetValue();
//STRIP001 }
//STRIP001 
//STRIP001 ImpMtfAnimationInfo* ImpSdrMtfAnimator::Start(OutputDevice& rOutDev, const Point& rOffset, long nExtraData)
//STRIP001 {
//STRIP001 	ImpMtfAnimationInfo* pInfo=NULL;
//STRIP001 	ULONG nPos=FindInfo(rOutDev,rOffset,nExtraData);
//STRIP001 	if (nPos==CONTAINER_ENTRY_NOTFOUND) {
//STRIP001 		pInfo=new ImpMtfAnimationInfo;
//STRIP001 		pInfo->pOutDev=&rOutDev;
//STRIP001 		pInfo->aOffset=rOffset;
//STRIP001 		pInfo->nExtraData=nExtraData;
//STRIP001 		ImpInsertInfo(pInfo);
//STRIP001 	} else {
//STRIP001 		pInfo=GetInfo(nPos);
//STRIP001 	}
//STRIP001 	pInfo->Restart();
//STRIP001 	long nTimeout=nDelay;
//STRIP001 	if (nTimeout==0) {
//STRIP001 		if (eAniKind==SDRTEXTANI_BLINK) nTimeout=250;
//STRIP001 		else nTimeout=50;
//STRIP001 	}
//STRIP001 	aTimer.SetTimeout(nTimeout);
//STRIP001 	aTimer.Start();
//STRIP001 	return pInfo;
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrMtfAnimator::Stop()
//STRIP001 {
//STRIP001 	ImpClearInfoList();
//STRIP001 	aTimer.Stop();
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrMtfAnimator::Stop(OutputDevice& rOutDev)
//STRIP001 {
//STRIP001 	ULONG nAnz=GetInfoCount();
//STRIP001 	for (ULONG nNum=nAnz; nNum>0;) {
//STRIP001 		nNum--;
//STRIP001 		ImpMtfAnimationInfo* pInfo=GetInfo(nNum);
//STRIP001 		if (pInfo->pOutDev==&rOutDev) RemoveInfo(nNum);
//STRIP001 	}
//STRIP001 	if (GetInfoCount()==0) aTimer.Stop();
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrMtfAnimator::Stop(OutputDevice& rOutDev, const Point& rOffset)
//STRIP001 {
//STRIP001 	ULONG nAnz=GetInfoCount();
//STRIP001 	for (ULONG nNum=nAnz; nNum>0;) {
//STRIP001 		nNum--;
//STRIP001 		ImpMtfAnimationInfo* pInfo=GetInfo(nNum);
//STRIP001 		if (pInfo->pOutDev==&rOutDev && pInfo->aOffset==rOffset) RemoveInfo(nNum);
//STRIP001 	}
//STRIP001 	if (GetInfoCount()==0) aTimer.Stop();
//STRIP001 }

}
