/*************************************************************************
 *
 *  $RCSfile: sw_unovwr.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:06:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _UNOTOOLS_CHARCLASS_HXX
// auto strip #include <unotools/charclass.hxx>
// auto strip #endif
// auto strip #ifndef _UNOTOOLS_TRANSLITERATIONWRAPPER_HXX
// auto strip #include <unotools/transliterationwrapper.hxx>
// auto strip #endif
// auto strip #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>			// fuer die UndoIds
// auto strip #endif
#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _UNDOBJ_HXX
// auto strip #include <undobj.hxx>
// auto strip #endif
#ifndef _ROLBCK_HXX
#include <rolbck.hxx>
#endif
// auto strip #ifndef _ACORRECT_HXX
// auto strip #include <acorrect.hxx>
// auto strip #endif
#ifndef _DOCARY_HXX
#include <docary.hxx>
#endif
// auto strip #ifndef _LEGACYBINFILTERMGR_HXX
// auto strip #include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
// auto strip #endif
namespace binfilter {

using namespace ::com::sun::star::i18n;
using namespace ::com::sun::star::uno;

//------------------------------------------------------------------

// zwei Zugriffs-Funktionen
//STRIP001 inline SwPosition* IterPt( SwUndoIter& rUIter )
//STRIP001 {	return rUIter.pAktPam->GetPoint();	}
//STRIP001 inline SwPosition* IterMk( SwUndoIter& rUIter )
//STRIP001 {	return rUIter.pAktPam->GetMark();	}

//STRIP001 inline SwDoc& SwUndoIter::GetDoc() const { return *pAktPam->GetDoc(); }

//------------------------------------------------------------


// OVERWRITE


//STRIP001 SwUndoOverwrite::SwUndoOverwrite( SwDoc* pDoc, SwPosition& rPos,
//STRIP001 									sal_Unicode cIns )
//STRIP001 	: SwUndo(UNDO_OVERWRITE), bGroup( FALSE ), pRedlSaveData( 0 )
//STRIP001 {
//STRIP001 #ifdef COMPACT
//STRIP001 	pDoc->DelUndoGroups();
//STRIP001 #endif
//STRIP001 
//STRIP001 	if( !pDoc->IsIgnoreRedline() && pDoc->GetRedlineTbl().Count() )
//STRIP001 	{
//STRIP001 		SwPaM aPam( rPos.nNode, rPos.nContent.GetIndex(),
//STRIP001 					rPos.nNode, rPos.nContent.GetIndex()+1 );
//STRIP001 		pRedlSaveData = new SwRedlineSaveDatas;
//STRIP001 		if( !FillSaveData( aPam, *pRedlSaveData, FALSE ))
//STRIP001 			delete pRedlSaveData, pRedlSaveData = 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	nSttNode = rPos.nNode.GetIndex();
//STRIP001 	nSttCntnt = rPos.nContent.GetIndex();
//STRIP001 
//STRIP001 	SwTxtNode* pTxtNd = rPos.nNode.GetNode().GetTxtNode();
//STRIP001 	ASSERT( pTxtNd, "Overwrite nicht im TextNode?" );
//STRIP001 
//STRIP001 	bInsChar = TRUE;
//STRIP001 	xub_StrLen nTxtNdLen = pTxtNd->GetTxt().Len();
//STRIP001 	if( nSttCntnt < nTxtNdLen )		// kein reines Einfuegen ?
//STRIP001 	{
//STRIP001 		aDelStr.Insert( pTxtNd->GetTxt().GetChar( nSttCntnt ) );
//STRIP001 		if( !pHistory )
//STRIP001 			pHistory = new SwHistory;
//STRIP001 		SwRegHistory aRHst( *pTxtNd, pHistory );
//STRIP001 		pHistory->CopyAttr( pTxtNd->GetpSwpHints(), nSttNode, 0,
//STRIP001 							nTxtNdLen, FALSE );
//STRIP001 		rPos.nContent++;
//STRIP001 		bInsChar = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bOldExpFlg = pTxtNd->IsIgnoreDontExpand();
//STRIP001 	pTxtNd->SetIgnoreDontExpand( TRUE );
//STRIP001 
//STRIP001 	pTxtNd->Insert( cIns, rPos.nContent );
//STRIP001 	aInsStr.Insert( cIns );
//STRIP001 
//STRIP001 	if( !bInsChar )
//STRIP001 	{
//STRIP001 		const SwIndex aTmpIndex( rPos.nContent, -2 );
//STRIP001 		pTxtNd->Erase( aTmpIndex, 1 );
//STRIP001 	}
//STRIP001 	pTxtNd->SetIgnoreDontExpand( bOldExpFlg );
//STRIP001 }

//STRIP001 SwUndoOverwrite::~SwUndoOverwrite()
//STRIP001 {
//STRIP001 	delete pRedlSaveData;
//STRIP001 }

//STRIP001 BOOL SwUndoOverwrite::CanGrouping( SwDoc* pDoc, SwPosition& rPos,
//STRIP001 									sal_Unicode cIns )
//STRIP001 {
//STRIP001 ///  ?? was ist mit nur eingefuegten Charaktern ???
//STRIP001 
//STRIP001 	// es kann nur das Loeschen von einzelnen char's zusammengefasst werden
//STRIP001 	if( rPos.nNode != nSttNode || !aInsStr.Len()  ||
//STRIP001 		( !bGroup && aInsStr.Len() != 1 ))
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	// ist der Node ueberhaupt ein TextNode?
//STRIP001 	SwTxtNode * pDelTxtNd = rPos.nNode.GetNode().GetTxtNode();
//STRIP001 	if( !pDelTxtNd ||
//STRIP001 		( pDelTxtNd->GetTxt().Len() != rPos.nContent.GetIndex() &&
//STRIP001 			rPos.nContent.GetIndex() != ( nSttCntnt + aInsStr.Len() )))
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	CharClass& rCC = GetAppCharClass();
//STRIP001 
//STRIP001 	// befrage das einzufuegende Charakter
//STRIP001 	if( ( CH_TXTATR_BREAKWORD == cIns && CH_TXTATR_INWORD == cIns ) ||
//STRIP001 		rCC.isLetterNumeric( String( cIns ), 0 ) !=
//STRIP001 		rCC.isLetterNumeric( aInsStr, aInsStr.Len()-1 ) )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	{
//STRIP001 		SwRedlineSaveDatas* pTmpSav = new SwRedlineSaveDatas;
//STRIP001 		SwPaM aPam( rPos.nNode, rPos.nContent.GetIndex(),
//STRIP001 					rPos.nNode, rPos.nContent.GetIndex()+1 );
//STRIP001 
//STRIP001 		if( !FillSaveData( aPam, *pTmpSav, FALSE ))
//STRIP001 			delete pTmpSav, pTmpSav = 0;
//STRIP001 
//STRIP001 		BOOL bOk = ( !pRedlSaveData && !pTmpSav ) ||
//STRIP001 				   ( pRedlSaveData && pTmpSav &&
//STRIP001 						SwUndo::CanRedlineGroup( *pRedlSaveData, *pTmpSav,
//STRIP001 							nSttCntnt > rPos.nContent.GetIndex() ));
//STRIP001 		delete pTmpSav;
//STRIP001 		if( !bOk )
//STRIP001 			return FALSE;
//STRIP001 
//STRIP001 		pDoc->DeleteRedline( aPam, FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	// Ok, die beiden 'Overwrites' koennen zusammen gefasst werden, also
//STRIP001 	// 'verschiebe' das enstprechende Zeichen
//STRIP001 	if( !bInsChar )
//STRIP001 	{
//STRIP001 		if( rPos.nContent.GetIndex() < pDelTxtNd->GetTxt().Len() )
//STRIP001 		{
//STRIP001 			aDelStr.Insert( pDelTxtNd->GetTxt().GetChar(rPos.nContent.GetIndex()) );
//STRIP001 			rPos.nContent++;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			bInsChar = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bOldExpFlg = pDelTxtNd->IsIgnoreDontExpand();
//STRIP001 	pDelTxtNd->SetIgnoreDontExpand( TRUE );
//STRIP001 
//STRIP001 	pDelTxtNd->Insert( cIns, rPos.nContent );
//STRIP001 	aInsStr.Insert( cIns );
//STRIP001 
//STRIP001 	if( !bInsChar )
//STRIP001 	{
//STRIP001 		const SwIndex aTmpIndex( rPos.nContent, -2 );
//STRIP001 		pDelTxtNd->Erase( aTmpIndex, 1 );
//STRIP001 	}
//STRIP001 	pDelTxtNd->SetIgnoreDontExpand( bOldExpFlg );
//STRIP001 
//STRIP001 	bGroup = TRUE;
//STRIP001 	return TRUE;
//STRIP001 }





//STRIP001 void SwUndoOverwrite::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SwPaM* pAktPam = rUndoIter.pAktPam;
//STRIP001 	SwDoc* pDoc = pAktPam->GetDoc();
//STRIP001 	pAktPam->DeleteMark();
//STRIP001 	pAktPam->GetPoint()->nNode = nSttNode;
//STRIP001 	SwTxtNode* pTxtNd = pAktPam->GetNode()->GetTxtNode();
//STRIP001 	ASSERT( pTxtNd, "Overwrite nicht im TextNode?" );
//STRIP001 	SwIndex& rIdx = pAktPam->GetPoint()->nContent;
//STRIP001 	rIdx.Assign( pTxtNd, nSttCntnt );
//STRIP001 
//STRIP001 	SwAutoCorrExceptWord* pACEWord = pDoc->GetAutoCorrExceptWord();
//STRIP001 	if( pACEWord )
//STRIP001 	{
//STRIP001 		if( 1 == aInsStr.Len() && 1 == aDelStr.Len() )
//STRIP001 			pACEWord->CheckChar( *pAktPam->GetPoint(), aDelStr.GetChar( 0 ) );
//STRIP001 		pDoc->SetAutoCorrExceptWord( 0 );
//STRIP001 	}
//STRIP001 
//STRIP001 	// wurde nicht nur ueberschieben sondern auch geinsertet, so loesche
//STRIP001 	// den Ueberhang
//STRIP001 	if( aInsStr.Len() > aDelStr.Len() )
//STRIP001 	{
//STRIP001 		rIdx += aDelStr.Len();
//STRIP001 		pTxtNd->Erase( rIdx, aInsStr.Len() - aDelStr.Len() );
//STRIP001 		rIdx = nSttCntnt;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aDelStr.Len() )
//STRIP001 	{
//STRIP001 		String aTmpStr( '1' );
//STRIP001 		sal_Unicode* pTmpStr = aTmpStr.GetBufferAccess();
//STRIP001 
//STRIP001 		BOOL bOldExpFlg = pTxtNd->IsIgnoreDontExpand();
//STRIP001 		pTxtNd->SetIgnoreDontExpand( TRUE );
//STRIP001 
//STRIP001 		rIdx++;
//STRIP001 		for( xub_StrLen n = 0; n < aDelStr.Len(); n++  )
//STRIP001 		{
//STRIP001 			// einzeln, damit die Attribute stehen bleiben !!!
//STRIP001 			*pTmpStr = aDelStr.GetChar( n );
//STRIP001 			pTxtNd->Insert( aTmpStr, rIdx /*???, SETATTR_NOTXTATRCHR*/ );
//STRIP001 			rIdx -= 2;
//STRIP001 			pTxtNd->Erase( rIdx, 1 );
//STRIP001 			rIdx += 2;
//STRIP001 		}
//STRIP001 		pTxtNd->SetIgnoreDontExpand( bOldExpFlg );
//STRIP001 		rIdx--;
//STRIP001 	}
//STRIP001 	if( pHistory )
//STRIP001 	{
//STRIP001 		if( pTxtNd->GetpSwpHints() )
//STRIP001     		pTxtNd->ClearSwpHintsArr( FALSE, FALSE );
//STRIP001 		pHistory->TmpRollback( pDoc, 0, FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pAktPam->GetMark()->nContent.GetIndex() != nSttCntnt )
//STRIP001 	{
//STRIP001 		pAktPam->SetMark();
//STRIP001 		pAktPam->GetMark()->nContent = nSttCntnt;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pRedlSaveData )
//STRIP001 		SetSaveData( *pDoc, *pRedlSaveData );
//STRIP001 }


//STRIP001 void SwUndoOverwrite::Repeat( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	rUndoIter.pLastUndoObj = this;
//STRIP001 	SwPaM* pAktPam = rUndoIter.pAktPam;
//STRIP001 	if( !aInsStr.Len() || pAktPam->HasMark() )
//STRIP001 		return;
//STRIP001 
//STRIP001 	SwDoc& rDoc = *pAktPam->GetDoc();
//STRIP001 
//STRIP001 	BOOL bGroupUndo = rDoc.DoesGroupUndo();
//STRIP001 	rDoc.DoGroupUndo( FALSE );
//STRIP001 	rDoc.Overwrite( *pAktPam, aInsStr.GetChar( 0 ));
//STRIP001 	rDoc.DoGroupUndo( bGroupUndo );
//STRIP001 	for( xub_StrLen n = 1; n < aInsStr.Len(); ++n )
//STRIP001 		rDoc.Overwrite( *pAktPam, aInsStr.GetChar( n ) );
//STRIP001 }



//STRIP001 void SwUndoOverwrite::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SwPaM* pAktPam = rUndoIter.pAktPam;
//STRIP001 	SwDoc* pDoc = pAktPam->GetDoc();
//STRIP001 	pAktPam->DeleteMark();
//STRIP001 	pAktPam->GetPoint()->nNode = nSttNode;
//STRIP001 	SwTxtNode* pTxtNd = pAktPam->GetNode()->GetTxtNode();
//STRIP001 	ASSERT( pTxtNd, "Overwrite nicht im TextNode?" );
//STRIP001 	SwIndex& rIdx = pAktPam->GetPoint()->nContent;
//STRIP001 
//STRIP001 	if( pRedlSaveData )
//STRIP001 	{
//STRIP001 		rIdx.Assign( pTxtNd, nSttCntnt );
//STRIP001 		pAktPam->SetMark();
//STRIP001 		pAktPam->GetMark()->nContent += aInsStr.Len();
//STRIP001 		pDoc->DeleteRedline( *pAktPam, FALSE );
//STRIP001 		pAktPam->DeleteMark();
//STRIP001 	}
//STRIP001 	rIdx.Assign( pTxtNd, aDelStr.Len() ? nSttCntnt+1 : nSttCntnt );
//STRIP001 
//STRIP001 	BOOL bOldExpFlg = pTxtNd->IsIgnoreDontExpand();
//STRIP001 	pTxtNd->SetIgnoreDontExpand( TRUE );
//STRIP001 
//STRIP001 	for( xub_StrLen n = 0; n < aInsStr.Len(); n++  )
//STRIP001 	{
//STRIP001 		// einzeln, damit die Attribute stehen bleiben !!!
//STRIP001 		pTxtNd->Insert( aInsStr.GetChar( n ), rIdx );
//STRIP001 		if( n < aDelStr.Len() )
//STRIP001 		{
//STRIP001 			rIdx -= 2;
//STRIP001 			pTxtNd->Erase( rIdx, 1 );
//STRIP001 			rIdx += n+1 < aDelStr.Len() ? 2 : 1;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	pTxtNd->SetIgnoreDontExpand( bOldExpFlg );
//STRIP001 
//STRIP001 	// alte Anfangs-Position vom UndoNodes-Array zurueckholen
//STRIP001 	if( pHistory )
//STRIP001 		pHistory->SetTmpEnd( pHistory->Count() );
//STRIP001 	if( pAktPam->GetMark()->nContent.GetIndex() != nSttCntnt )
//STRIP001 	{
//STRIP001 		pAktPam->SetMark();
//STRIP001 		pAktPam->GetMark()->nContent = nSttCntnt;
//STRIP001 	}
//STRIP001 }

//------------------------------------------------------------

//STRIP001 struct _UndoTransliterate_Data
//STRIP001 {
//STRIP001 	String sText;
//STRIP001 	_UndoTransliterate_Data* pNext;
//STRIP001 	SwHistory* pHistory;
//STRIP001 	Sequence <long>* pOffsets;
//STRIP001 	ULONG nNdIdx;
//STRIP001 	xub_StrLen nStart, nLen;
//STRIP001 
//STRIP001 	_UndoTransliterate_Data( ULONG nNd, xub_StrLen nStt, xub_StrLen nStrLen,
//STRIP001 								const String& rTxt )
//STRIP001 		: pNext( 0 ), pOffsets( 0 ), pHistory( 0 ), sText( rTxt ),
//STRIP001 		nStart( nStt ), nNdIdx( nNd ), nLen( nStrLen )
//STRIP001 	{}
//STRIP001 	~_UndoTransliterate_Data() { delete pOffsets; delete pHistory; }
//STRIP001 
//STRIP001 	void SetChangeAtNode( SwDoc& rDoc );
//STRIP001 };

//STRIP001 SwUndoTransliterate::SwUndoTransliterate( const SwPaM& rPam,
//STRIP001 							const utl::TransliterationWrapper& rTrans )
//STRIP001 	: SwUndo( UNDO_TRANSLITERATE ), SwUndRng( rPam ),
//STRIP001 	nType( rTrans.getType() ), pData( 0 ), pLastData( 0 )
//STRIP001 {
//STRIP001 }

//STRIP001 SwUndoTransliterate::~SwUndoTransliterate()
//STRIP001 {
//STRIP001 	_UndoTransliterate_Data* pD = pData;
//STRIP001 	while( pD )
//STRIP001 	{
//STRIP001 		pData = pD;
//STRIP001 		pD = pD->pNext;
//STRIP001 		delete pData;
//STRIP001 	}
//STRIP001 }

//STRIP001 void SwUndoTransliterate::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SwDoc& rDoc = rUndoIter.GetDoc();
//STRIP001 	BOOL bUndo = rDoc.DoesUndo();
//STRIP001 	rDoc.DoUndo( FALSE );
//STRIP001 
//STRIP001 	for( _UndoTransliterate_Data* pD = pData; pD; pD = pD->pNext )
//STRIP001 		pD->SetChangeAtNode( rDoc );
//STRIP001 
//STRIP001 	rDoc.DoUndo( bUndo );
//STRIP001 	SetPaM( rUndoIter, TRUE );
//STRIP001 }

//STRIP001 void SwUndoTransliterate::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 /* ??? */	rUndoIter.SetUpdateAttr( TRUE );
//STRIP001 
//STRIP001 	SetPaM( *rUndoIter.pAktPam );
//STRIP001 	Repeat( rUndoIter );
//STRIP001 }

//STRIP001 void SwUndoTransliterate::Repeat( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SwPaM& rPam = *rUndoIter.pAktPam;
//STRIP001 	SwDoc& rDoc = rUndoIter.GetDoc();
//STRIP001 
//STRIP001 	utl::TransliterationWrapper aTrans(
//STRIP001 						::legacy_binfilters::getLegacyProcessServiceFactory(), nType );
//STRIP001 	rDoc.TransliterateText( rPam, aTrans );
//STRIP001 
//STRIP001 	rUndoIter.pLastUndoObj = this;
//STRIP001 }

//STRIP001 void SwUndoTransliterate::AddChanges( const SwTxtNode& rTNd,
//STRIP001 					xub_StrLen nStart, xub_StrLen nLen,
//STRIP001 		 			::com::sun::star::uno::Sequence <long>& rOffsets )
//STRIP001 {
//STRIP001 	long nOffsLen = rOffsets.getLength();
//STRIP001 	_UndoTransliterate_Data* pNew = new _UndoTransliterate_Data(
//STRIP001 						rTNd.GetIndex(), nStart, (xub_StrLen)nOffsLen,
//STRIP001 						rTNd.GetTxt().Copy( nStart, nLen ));
//STRIP001 	if( pData )
//STRIP001 		pLastData->pNext = pNew;
//STRIP001 	else
//STRIP001 		pData = pNew;
//STRIP001 	pLastData = pNew;
//STRIP001 
//STRIP001 	const long* pOffsets = rOffsets.getConstArray();
//STRIP001 	// where did we need less memory ?
//STRIP001 	// check for 1-1 mappings:
//STRIP001 	BOOL bOneToOne = TRUE;
//STRIP001 	const long* p = pOffsets;
//STRIP001 	for( long n = 0; n < nOffsLen; ++n, ++p )
//STRIP001 		if( *p != ( nStart + n ))
//STRIP001 		{
//STRIP001 			// create the Offset array
//STRIP001 			pNew->pOffsets = new Sequence <long> ( nLen );
//STRIP001 			long* pIdx = pNew->pOffsets->getArray();
//STRIP001 			p = pOffsets;
//STRIP001 			long nMyOff, nNewVal = nStart;
//STRIP001 			for( n = 0, nMyOff = nStart; n < nOffsLen; ++p, ++n, ++nMyOff )
//STRIP001 			{
//STRIP001 				if( *p < nMyOff )
//STRIP001 				{
//STRIP001 					// something is deleted
//STRIP001 					nMyOff = *p;
//STRIP001 					*(pIdx-1) = nNewVal++;
//STRIP001 				}
//STRIP001 				else if( *p > nMyOff )
//STRIP001 				{
//STRIP001 					for( ; *p > nMyOff; ++nMyOff )
//STRIP001 						*pIdx++ = nNewVal;
//STRIP001 					--nMyOff;
//STRIP001 					--n;
//STRIP001 					--p;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					*pIdx++ = nNewVal++;
//STRIP001 			}
//STRIP001 
//STRIP001 			// and then we need to save the attributes/bookmarks
//STRIP001 			// but this data must moved every time to the last in the chain!
//STRIP001 			_UndoTransliterate_Data* pD = pData;
//STRIP001 			while( pD != pNew )
//STRIP001 			{
//STRIP001 				if( pD->nNdIdx == pNew->nNdIdx && pD->pHistory )
//STRIP001 				{
//STRIP001 					// same node and have a history?
//STRIP001 					pNew->pHistory = pD->pHistory;
//STRIP001 					pD->pHistory = 0;
//STRIP001 					break;		    // more can't exist
//STRIP001 				}
//STRIP001 				pD = pD->pNext;
//STRIP001 			}
//STRIP001 
//STRIP001 			if( !pNew->pHistory )
//STRIP001 			{
//STRIP001 				pNew->pHistory = new SwHistory;
//STRIP001 				SwRegHistory aRHst( rTNd, pNew->pHistory );
//STRIP001 				pNew->pHistory->CopyAttr( rTNd.GetpSwpHints(),
//STRIP001 						pNew->nNdIdx, 0, rTNd.GetTxt().Len(), FALSE );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 }

//STRIP001 void _UndoTransliterate_Data::SetChangeAtNode( SwDoc& rDoc )
//STRIP001 {
//STRIP001 	SwTxtNode* pTNd = rDoc.GetNodes()[ nNdIdx ]->GetTxtNode();
//STRIP001 	if( pTNd )
//STRIP001 	{
//STRIP001 		Sequence <long> aOffsets( pOffsets ? pOffsets->getLength() : nLen );
//STRIP001 		if( pOffsets )
//STRIP001 			aOffsets = *pOffsets;
//STRIP001 		else
//STRIP001 		{
//STRIP001 			long* p = aOffsets.getArray();
//STRIP001 			for( xub_StrLen n = 0; n < nLen; ++n, ++p )
//STRIP001 				*p = n + nStart;
//STRIP001 		}
//STRIP001 		pTNd->ReplaceTextOnly( nStart, nLen, sText, aOffsets );
//STRIP001 
//STRIP001 		if( pHistory )
//STRIP001 		{
//STRIP001 			if( pTNd->GetpSwpHints() )
//STRIP001     			pTNd->ClearSwpHintsArr( FALSE, FALSE );
//STRIP001 			pHistory->TmpRollback( &rDoc, 0, FALSE );
//STRIP001 			pHistory->SetTmpEnd( pHistory->Count() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
