#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:24:37 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..$/..
PRJ=..$/..$/..

PRJNAME=binfilter
TARGET=sw_html

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

# --- Settings -----------------------------------------------------

#.INCLUDE :  $(PRJ)$/inc$/swpre.mk
.INCLUDE :  $(PRJ)$/inc$/bf_sw$/swpre.mk
.INCLUDE :  settings.mk
#.INCLUDE :  $(PRJ)$/inc$/sw.mk
.INCLUDE :  $(PRJ)$/inc$/bf_sw$/sw.mk
INC+= -I$(PRJ)$/inc$/bf_sw

.IF "$(mydebug)" != ""
CDEFS=$(CDEFS) -Dmydebug
.ENDIF

# --- Files --------------------------------------------------------

SLOFILES =  \
        $(SLO)$/sw_css1atr.obj \
        $(SLO)$/sw_css1kywd.obj \
        $(SLO)$/sw_htmlatr.obj \
        $(SLO)$/sw_htmlbas.obj \
        $(SLO)$/sw_htmlcss1.obj \
        $(SLO)$/sw_htmlctxt.obj \
        $(SLO)$/sw_htmldraw.obj \
        $(SLO)$/sw_htmlfld.obj \
        $(SLO)$/sw_htmlfldw.obj \
        $(SLO)$/sw_htmlfly.obj \
        $(SLO)$/sw_htmlflyt.obj \
        $(SLO)$/sw_htmlform.obj \
        $(SLO)$/sw_htmlforw.obj \
        $(SLO)$/sw_htmlftn.obj \
        $(SLO)$/sw_htmlgrin.obj \
        $(SLO)$/sw_htmlnum.obj \
        $(SLO)$/sw_htmlplug.obj \
        $(SLO)$/sw_htmlsect.obj \
        $(SLO)$/sw_htmltab.obj \
        $(SLO)$/sw_htmltabw.obj \
        $(SLO)$/sw_parcss1.obj \
        $(SLO)$/sw_svxcss1.obj \
        $(SLO)$/sw_swhtml.obj \
        $(SLO)$/sw_wrthtml.obj \
        $(SLO)$/sw_SwAppletImpl.obj \

EXCEPTIONSFILES = \
		$(SLO)$/sw_htmlsect.obj

# --- Tagets -------------------------------------------------------

.INCLUDE :  target.mk

