/*************************************************************************
 *
 *  $RCSfile: sw_cfgitems.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef __SBX_SBXVARIABLE_HXX //autogen
//STRIP001 #include <svtools/sbxvar.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SVX_SVXIDS_HRC //autogen
//STRIP001 #include <bf_svx/svxids.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SVX_SVXENUM_HXX //autogen
//STRIP001 #include <bf_svx/svxenum.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 #include "viewopt.hxx"
//STRIP001 #include "swtypes.hxx"
//STRIP001 #include "cmdid.h"
//STRIP001 #include "prtopt.hxx"
//STRIP001 #include "cfgitems.hxx"
//STRIP001 #include "crstate.hxx"
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 TYPEINIT1_AUTOFACTORY(SwDocDisplayItem, SfxPoolItem)
//STRIP001 TYPEINIT1_AUTOFACTORY(SwElemItem, SfxPoolItem)
//STRIP001 TYPEINIT1_AUTOFACTORY(SwAddPrinterItem, SfxPoolItem)
//STRIP001 TYPEINIT1_AUTOFACTORY(SwShadowCursorItem, SfxPoolItem)


//STRIP001 SwDocDisplayItem::SwDocDisplayItem( USHORT nWhich ) :
//STRIP001 		SfxPoolItem(nWhich),
//STRIP001 		aIndexBackgrndCol(COL_GRAY)
//STRIP001 {
//STRIP001 	bParagraphEnd	  	=
//STRIP001 	bTab 				=
//STRIP001 	bSpace				=
//STRIP001 	bNonbreakingSpace	=
//STRIP001 	bSoftHyphen			=
//STRIP001 	bHiddenText			=
//STRIP001 	bManualBreak 		=
//STRIP001     bShowHiddenPara     = FALSE;
//STRIP001 
//STRIP001 };

/*------------OS 12.01.95 -------------------------------------------
	Item fuer Einstellungsdialog, Seite Dokumentansicht
--------------------------------------------------------------------*/

//STRIP001 SwDocDisplayItem::SwDocDisplayItem( const SwDocDisplayItem& rDocDisplayItem ):
//STRIP001 			SfxPoolItem(rDocDisplayItem)
//STRIP001 {
//STRIP001 	*this = rDocDisplayItem;
//STRIP001 };

/*----------------------- -------------------------------------------

--------------------------------------------------------------------*/

//STRIP001 SwDocDisplayItem::SwDocDisplayItem(const SwViewOption& rVOpt, USHORT nWhich ) :
//STRIP001 			SfxPoolItem( nWhich )
//STRIP001 {
//STRIP001 	bParagraphEnd	  	= rVOpt.IsParagraph(TRUE);
//STRIP001 	bTab 				= rVOpt.IsTab(TRUE);
//STRIP001 	bSpace				= rVOpt.IsBlank(TRUE);
//STRIP001 	bNonbreakingSpace	= rVOpt.IsHardBlank();
//STRIP001 	bSoftHyphen			= rVOpt.IsSoftHyph();
//STRIP001 	bHiddenText			= rVOpt.IsHidden();
//STRIP001 	bManualBreak 		= rVOpt.IsLineBreak(TRUE);
//STRIP001     bShowHiddenPara     = rVOpt.IsShowHiddenPara();
//STRIP001 
//STRIP001 }
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SfxPoolItem* SwDocDisplayItem::Clone( SfxItemPool*	) const
//STRIP001 {
//STRIP001 	return new SwDocDisplayItem( *this );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 int SwDocDisplayItem::operator==( const SfxPoolItem& rAttr ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( SfxPoolItem::operator==(rAttr), "unterschiedliche Typen" );
//STRIP001 
//STRIP001 	const SwDocDisplayItem& rItem = (SwDocDisplayItem&)rAttr;
//STRIP001 
//STRIP001 	return (  bParagraphEnd	  	  	== rItem.bParagraphEnd	  	 &&
//STRIP001 			  bTab 				  	== rItem.bTab 				 &&
//STRIP001 			  bSpace				== rItem.bSpace				 &&
//STRIP001 			  bNonbreakingSpace	  	== rItem.bNonbreakingSpace	 &&
//STRIP001 			  bSoftHyphen		  	== rItem.bSoftHyphen		 &&
//STRIP001 			  bHiddenText		  	== rItem.bHiddenText		 &&
//STRIP001 			  bManualBreak 		  	== rItem.bManualBreak 		 &&
//STRIP001               bShowHiddenPara       == rItem.bShowHiddenPara );
//STRIP001 }


/*-----------------31.08.96 14.14-------------------

--------------------------------------------------*/


//STRIP001 void  SwDocDisplayItem::operator=( const SwDocDisplayItem& rDocDisplayItem)
//STRIP001 {
//STRIP001 	bParagraphEnd	  	= rDocDisplayItem.bParagraphEnd	  		;
//STRIP001 	bTab 				= rDocDisplayItem.bTab 					;
//STRIP001 	bSpace				= rDocDisplayItem.bSpace				;
//STRIP001 	bNonbreakingSpace	= rDocDisplayItem.bNonbreakingSpace		;
//STRIP001 	bSoftHyphen			= rDocDisplayItem.bSoftHyphen			;
//STRIP001 	bHiddenText			= rDocDisplayItem.bHiddenText			;
//STRIP001 	bManualBreak 		= rDocDisplayItem.bManualBreak 			;
//STRIP001     bShowHiddenPara     = rDocDisplayItem.bShowHiddenPara       ;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/
//STRIP001 void SwDocDisplayItem::FillViewOptions( SwViewOption& rVOpt) const
//STRIP001 {
//STRIP001 	rVOpt.SetParagraph	(bParagraphEnd		);
//STRIP001 	rVOpt.SetTab		(bTab				);
//STRIP001 	rVOpt.SetBlank		(bSpace				);
//STRIP001 	rVOpt.SetHardBlank	(bNonbreakingSpace	);
//STRIP001 	rVOpt.SetSoftHyph	(bSoftHyphen		);
//STRIP001 	rVOpt.SetHidden		(bHiddenText		);
//STRIP001 	rVOpt.SetLineBreak	(bManualBreak 		);
//STRIP001     rVOpt.SetShowHiddenPara(bShowHiddenPara );
//STRIP001 }


/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/
//STRIP001 SwElemItem::SwElemItem( USHORT nWhich ) :
//STRIP001 	SfxPoolItem(nWhich)
//STRIP001 {
//STRIP001 	bHorzScrollbar =
//STRIP001 	bVertScrollbar =
//STRIP001     bAnyRuler =
//STRIP001     bHorzRuler     =
//STRIP001 	bVertRuler	   =
//STRIP001     bVertRulerRight=
//STRIP001 	bCrosshair	   =
//STRIP001 	bHandles	   =
//STRIP001 	bBigHandles 	=
//STRIP001     bSmoothScroll  =
//STRIP001 	bTable				=
//STRIP001 	bGraphic 			=
//STRIP001 	bDrawing 			=
//STRIP001 	bFieldName			=
//STRIP001     bNotes              = FALSE;
//STRIP001 }
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SwElemItem::SwElemItem( const SwElemItem& rElemItem ):
//STRIP001 			SfxPoolItem(rElemItem)
//STRIP001 {
//STRIP001 	*this = rElemItem;
//STRIP001 }
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SwElemItem::SwElemItem(const SwViewOption& rVOpt, USHORT nWhich) :
//STRIP001 			SfxPoolItem( nWhich )
//STRIP001 {
//STRIP001 	bHorzScrollbar	= rVOpt.IsViewHScrollBar();
//STRIP001 	bVertScrollbar	= rVOpt.IsViewVScrollBar();
//STRIP001     bAnyRuler       = rVOpt.IsViewAnyRuler();
//STRIP001     bHorzRuler      = rVOpt.IsViewHRuler(TRUE);
//STRIP001     bVertRuler      = rVOpt.IsViewVRuler(TRUE);
//STRIP001     bVertRulerRight = rVOpt.IsVRulerRight();
//STRIP001 	bCrosshair		= rVOpt.IsCrossHair();
//STRIP001 	bHandles		= rVOpt.IsSolidMarkHdl();
//STRIP001 	bBigHandles     = rVOpt.IsBigMarkHdl();
//STRIP001 	bSmoothScroll	= rVOpt.IsSmoothScroll();
//STRIP001 	bTable				= rVOpt.IsTable();
//STRIP001 	bGraphic 			= rVOpt.IsGraphic();
//STRIP001 	bDrawing 			= rVOpt.IsDraw() && rVOpt.IsControl();
//STRIP001 	bFieldName			= rVOpt.IsFldName();
//STRIP001 	bNotes				= rVOpt.IsPostIts();
//STRIP001 
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SfxPoolItem* SwElemItem::Clone( SfxItemPool* ) const
//STRIP001 {
//STRIP001 	return new SwElemItem( *this );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 int SwElemItem::operator==( const SfxPoolItem& rAttr ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( SfxPoolItem::operator==(rAttr), "unterschiedliche Typen" );
//STRIP001 
//STRIP001 	const SwElemItem& rItem = (SwElemItem&)rAttr;
//STRIP001 
//STRIP001 	return (	bHorzScrollbar	== rItem.bHorzScrollbar &&
//STRIP001 				bVertScrollbar	== rItem.bVertScrollbar &&
//STRIP001                 bAnyRuler       == rItem.bAnyRuler &&
//STRIP001                 bHorzRuler      == rItem.bHorzRuler     &&
//STRIP001 				bVertRuler		== rItem.bVertRuler		&&
//STRIP001                 bVertRulerRight == rItem.bVertRulerRight&&
//STRIP001 				bCrosshair		== rItem.bCrosshair		&&
//STRIP001 				bHandles		== rItem.bHandles		&&
//STRIP001 				bBigHandles  	== rItem.bBigHandles    &&
//STRIP001                 bSmoothScroll   == rItem.bSmoothScroll  &&
//STRIP001                 bTable                == rItem.bTable              &&
//STRIP001                 bGraphic              == rItem.bGraphic            &&
//STRIP001                 bDrawing              == rItem.bDrawing            &&
//STRIP001                 bFieldName            == rItem.bFieldName          &&
//STRIP001                 bNotes                == rItem.bNotes             );
//STRIP001 }

/*-----------------31.08.96 14.13-------------------

--------------------------------------------------*/


//STRIP001 void  SwElemItem::operator=( const SwElemItem& rElemItem)
//STRIP001 {
//STRIP001 	bHorzScrollbar	= rElemItem.  bHorzScrollbar	;
//STRIP001 	bVertScrollbar	= rElemItem.  bVertScrollbar	;
//STRIP001     bAnyRuler       = rElemItem.  bAnyRuler;
//STRIP001     bHorzRuler      = rElemItem.  bHorzRuler        ;
//STRIP001 	bVertRuler		= rElemItem.  bVertRuler		;
//STRIP001     bVertRulerRight = rElemItem.  bVertRulerRight   ;
//STRIP001 	bCrosshair		= rElemItem.  bCrosshair		;
//STRIP001 	bHandles		= rElemItem.  bHandles			;
//STRIP001 	bBigHandles  	= rElemItem.  bBigHandles 		;
//STRIP001 	bSmoothScroll	= rElemItem.  bSmoothScroll		;
//STRIP001     bTable              = rElemItem.bTable                ;
//STRIP001     bGraphic            = rElemItem.bGraphic              ;
//STRIP001     bDrawing            = rElemItem.bDrawing              ;
//STRIP001     bFieldName          = rElemItem.bFieldName            ;
//STRIP001     bNotes              = rElemItem.bNotes                ;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 void SwElemItem::FillViewOptions( SwViewOption& rVOpt) const
//STRIP001 {
//STRIP001 	rVOpt.SetViewHScrollBar(bHorzScrollbar );
//STRIP001 	rVOpt.SetViewVScrollBar(bVertScrollbar );
//STRIP001     rVOpt.SetViewAnyRuler(bAnyRuler);
//STRIP001     rVOpt.SetViewHRuler(bHorzRuler    );
//STRIP001     rVOpt.SetViewVRuler(bVertRuler    );
//STRIP001     rVOpt.SetVRulerRight(bVertRulerRight );
//STRIP001 	rVOpt.SetCrossHair(bCrosshair	  );
//STRIP001 	rVOpt.SetSolidMarkHdl(bHandles	  );
//STRIP001 	rVOpt.SetBigMarkHdl(bBigHandles );
//STRIP001 	rVOpt.SetSmoothScroll(bSmoothScroll);
//STRIP001 	rVOpt.SetTable		(bTable			   	);
//STRIP001 	rVOpt.SetGraphic	(bGraphic 		   	);
//STRIP001 	rVOpt.SetDraw		(bDrawing 			);
//STRIP001 	rVOpt.SetControl	(bDrawing 			);
//STRIP001 	rVOpt.SetFldName	(bFieldName			);
//STRIP001 	rVOpt.SetPostIts	(bNotes				);
//STRIP001 }


/*--------------------------------------------------------------------
	Beschreibung: CopyCTOR
 --------------------------------------------------------------------*/

//STRIP001 SwAddPrinterItem::SwAddPrinterItem( const SwAddPrinterItem& rAddPrinterItem ):
//STRIP001 			SfxPoolItem(rAddPrinterItem)
//STRIP001 {
//STRIP001     *((SwPrintData*)this) = rAddPrinterItem;
//STRIP001 };

/*--------------------------------------------------------------------
	Beschreibung: CTOR fuer leeres Item
 --------------------------------------------------------------------*/

//STRIP001 SwAddPrinterItem::SwAddPrinterItem( USHORT nWhich):
//STRIP001                 SfxPoolItem(nWhich)
//STRIP001 {
//STRIP001 }
/*--------------------------------------------------------------------
	Beschreibung: CTOR aus SwPrintOptions
 --------------------------------------------------------------------*/

//STRIP001 SwAddPrinterItem::SwAddPrinterItem( USHORT nWhich, const SwPrintData& rPrtData ) :
//STRIP001 	SfxPoolItem(nWhich)
//STRIP001 {
//STRIP001     SwPrintData::operator=(rPrtData);
//STRIP001 }
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SfxPoolItem* SwAddPrinterItem::Clone( SfxItemPool* ) const
//STRIP001 {
//STRIP001 	return new SwAddPrinterItem( *this );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 int SwAddPrinterItem::operator==( const SfxPoolItem& rAttr ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( SfxPoolItem::operator==(rAttr), "unterschiedliche Typen" );
//STRIP001 
//STRIP001 	const SwAddPrinterItem& rItem = (SwAddPrinterItem&)rAttr;
//STRIP001 
//STRIP001     return  SwPrintData::operator==(rItem);
//STRIP001 }
/*-----------------03.11.97 10:00-------------------
 Item fuer Einstellungsdialog, ShadowCursorSeite
--------------------------------------------------*/

//STRIP001 SwShadowCursorItem::SwShadowCursorItem( USHORT nWhich )
//STRIP001 	: SfxPoolItem( nWhich ),
//STRIP001     bOn( FALSE ), eMode( FILL_TAB )
//STRIP001 {
//STRIP001 }

//STRIP001 SwShadowCursorItem::SwShadowCursorItem( const SwShadowCursorItem& rCpy )
//STRIP001 	: SfxPoolItem( rCpy.Which() ),
//STRIP001     bOn( rCpy.IsOn() ),
//STRIP001     eMode( rCpy.GetMode() )
//STRIP001 {
//STRIP001 }

//STRIP001 SwShadowCursorItem::SwShadowCursorItem( const SwViewOption& rVOpt, USHORT nWhich )
//STRIP001 	: SfxPoolItem( nWhich ),
//STRIP001 	bOn( rVOpt.IsShadowCursor() ),
//STRIP001     eMode( rVOpt.GetShdwCrsrFillMode() )
//STRIP001 {
//STRIP001 }

//STRIP001 SfxPoolItem* SwShadowCursorItem::Clone( SfxItemPool* ) const
//STRIP001 {
//STRIP001 	return new SwShadowCursorItem( *this );
//STRIP001 }

//STRIP001 int SwShadowCursorItem::operator==( const SfxPoolItem& rCmp ) const
//STRIP001 {
//STRIP001 	return	IsOn() == ((SwShadowCursorItem&)rCmp).IsOn() &&
//STRIP001             GetMode() == ((SwShadowCursorItem&)rCmp).GetMode();
//STRIP001 }

//STRIP001 void SwShadowCursorItem::operator=( const SwShadowCursorItem& rCpy )
//STRIP001 {
//STRIP001 	SetOn( rCpy.IsOn() );
//STRIP001 	SetMode( rCpy.GetMode() );
//STRIP001 }


//STRIP001 void SwShadowCursorItem::FillViewOptions( SwViewOption& rVOpt ) const
//STRIP001 {
//STRIP001 	rVOpt.SetShadowCursor( bOn );
//STRIP001 	rVOpt.SetShdwCrsrFillMode( eMode );
//STRIP001 }

//STRIP001 #ifndef PRODUCT
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SwTestItem::SwTestItem( const SwTestItem& rTestItem ):
//STRIP001 			SfxPoolItem(rTestItem)
//STRIP001 {
//STRIP001 	bTest1=rTestItem.bTest1;
//STRIP001 	bTest2=rTestItem.bTest2;
//STRIP001 	bTest3=rTestItem.bTest3;
//STRIP001 	bTest4=rTestItem.bTest4;
//STRIP001 	bTest5=rTestItem.bTest5;
//STRIP001 	bTest6=rTestItem.bTest6;
//STRIP001 	bTest7=rTestItem.bTest7;
//STRIP001 	bTest8=rTestItem.bTest8;
//STRIP001 	bTest9=rTestItem.bTest9;
//STRIP001 	bTest10=rTestItem.bTest10;
//STRIP001 };

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 SfxPoolItem* SwTestItem::Clone( SfxItemPool* ) const
//STRIP001 {
//STRIP001 	return new SwTestItem( *this );
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 int SwTestItem::operator==( const SfxPoolItem& rAttr ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( SfxPoolItem::operator==(rAttr), "unterschiedliche Typen" );
//STRIP001 
//STRIP001 	const SwTestItem& rItem = (const SwTestItem&) rAttr;
//STRIP001 
//STRIP001 	return ( bTest1==rItem.bTest1&&
//STRIP001 			 bTest2==rItem.bTest2&&
//STRIP001 			 bTest3==rItem.bTest3&&
//STRIP001 			 bTest4==rItem.bTest4&&
//STRIP001 			 bTest5==rItem.bTest5&&
//STRIP001 			 bTest6==rItem.bTest6&&
//STRIP001 			 bTest7==rItem.bTest7&&
//STRIP001 			 bTest8==rItem.bTest8&&
//STRIP001 			 bTest9==rItem.bTest9&&
//STRIP001 			 bTest10==rItem.bTest10);
//STRIP001 }

//STRIP001 #endif



}
