/*************************************************************************
 *
 *  $RCSfile: sw_DropDownFieldDialog.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDBAS_HXX
//STRIP001 #include <fldbas.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDMGR_HXX
//STRIP001 #include <fldmgr.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _MSGBOX_HXX 
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SW_DROPDOWNFIELDDIALOG_HXX
//STRIP001 #include <DropDownFieldDialog.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDDROPDOWN_HXX
//STRIP001 #include <flddropdown.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDUI_HRC
//STRIP001 #include <fldui.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _SW_DROPDOWNFIELDDIALOG_HRC
//STRIP001 #include <DropDownFieldDialog.hrc>
//STRIP001 #endif

/*--------------------------------------------------------------------
	Beschreibung: Feldeinfuegen bearbeiten
 --------------------------------------------------------------------*/

//STRIP001 sw::DropDownFieldDialog::DropDownFieldDialog( Window *pParent, SwWrtShell &rS,
//STRIP001 							  SwField* pField, BOOL bNextButton ) :
//STRIP001 
//STRIP001     SvxStandardDialog(pParent,  SW_RES(DLG_FLD_DROPDOWN)),
//STRIP001     aItemsFL(       this, ResId( FL_ITEMS       )),
//STRIP001     aListItemsLB(   this, ResId( LB_LISTITEMS   )),
//STRIP001     aOKPB(          this, ResId( PB_OK          )),
//STRIP001     aCancelPB(      this, ResId( PB_CANCEL      )),
//STRIP001     aNextPB(        this, ResId( PB_NEXT        )),
//STRIP001     aHelpPB(        this, ResId( PB_HELP        )),
//STRIP001     aEditPB(        this, ResId( PB_EDIT        )),
//STRIP001     pDropField(0),
//STRIP001     rSh( rS )
//STRIP001 {
//STRIP001     Link aButtonLk = LINK(this, DropDownFieldDialog, ButtonHdl);
//STRIP001     aEditPB.SetClickHdl(aButtonLk);
//STRIP001 	if( bNextButton )
//STRIP001 	{
//STRIP001         aNextPB.Show();
//STRIP001         aNextPB.SetClickHdl(aButtonLk);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001         long nDiff = aCancelPB.GetPosPixel().Y() - aOKPB.GetPosPixel().Y();
//STRIP001         Point aPos = aHelpPB.GetPosPixel();
//STRIP001 		aPos.Y() -= nDiff;
//STRIP001         aHelpPB.SetPosPixel(aPos);
//STRIP001 	}
//STRIP001     if( RES_DROPDOWN == pField->GetTyp()->Which() )
//STRIP001     {   
//STRIP001 		//
//STRIP001         pDropField = (SwDropDownField*)pField;
//STRIP001         String sTitle = GetText();
//STRIP001         sTitle += pDropField->GetPar2();
//STRIP001         SetText(sTitle);
//STRIP001         Sequence<OUString> aItems = pDropField->GetItemSequence();
//STRIP001         const OUString* pArray = aItems.getConstArray();
//STRIP001         for(sal_Int32 i = 0; i < aItems.getLength(); i++)
//STRIP001             aListItemsLB.InsertEntry(pArray[i]);
//STRIP001         aListItemsLB.SelectEntry(pDropField->GetSelectedItem());
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bEnable = !rSh.IsCrsrReadonly();
//STRIP001     aOKPB.Enable( bEnable );
//STRIP001 
//STRIP001     aListItemsLB.GrabFocus();
//STRIP001 	FreeResource();
//STRIP001 }
//STRIP001 
//STRIP001 sw::DropDownFieldDialog::~DropDownFieldDialog()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001      
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void sw::DropDownFieldDialog::Apply()
//STRIP001 {
//STRIP001     if(pDropField)
//STRIP001     {        
//STRIP001         String sSelect = aListItemsLB.GetSelectEntry();
//STRIP001         if(pDropField->GetPar1() != sSelect)
//STRIP001         {        
//STRIP001             rSh.StartAllAction();
//STRIP001             pDropField->SetPar1(sSelect);
//STRIP001             rSh.SwEditShell::UpdateFlds(*pDropField);
//STRIP001             rSh.SetUndoNoResetModified();
//STRIP001             rSh.EndAllAction();
//STRIP001         }
//STRIP001     }
//STRIP001 }
//STRIP001 /* -----------------17.06.2003 10:50-----------------
//STRIP001 
//STRIP001  --------------------------------------------------*/
//STRIP001 IMPL_LINK(sw::DropDownFieldDialog, ButtonHdl, PushButton*, pButton)
//STRIP001 {
//STRIP001     EndDialog(&aNextPB == pButton ? RET_OK : RET_YES );
//STRIP001 	return 0;
//STRIP001 }

}
