/*************************************************************************
 *
 *  $RCSfile: glosbib.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:58:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _GLOSBIB_HXX
#define _GLOSBIB_HXX

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

// auto strip #ifndef _SVX_STDDLG_HXX //autogen
// auto strip #include <bf_svx/stddlg.hxx>
// auto strip #endif

// auto strip #ifndef _LSTBOX_HXX //autogen
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif

#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif

// auto strip #ifndef _BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif

// auto strip #ifndef _SV_FIXED_HXX
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
class SvStrings; 
namespace binfilter {

//STRIP001 class SwGlossaryHdl;


class FEdit : public Edit
{
	public:
		FEdit(Window * pParent, const ResId& rResId) :
			Edit(pParent, rResId){}

//STRIP001 	virtual void KeyInput( const KeyEvent& rKEvent );
};
/* -----------------------------08.02.00 15:04--------------------------------

 ---------------------------------------------------------------------------*/
struct GlosBibUserData
{
	String sPath;
	String sGroupName;
	String sGroupTitle;
};
class SwGlossaryGroupTLB : public SvTabListBox
{
public:
	SwGlossaryGroupTLB(Window* pParent, const ResId& rResId) :
		SvTabListBox(pParent, rResId) {}

//STRIP001 	virtual void 	RequestHelp( const HelpEvent& rHEvt );
//STRIP001 	void			Clear();
};

//STRIP001 class SwGlossaryGroupDlg : public SvxStandardDialog
//STRIP001 {
//STRIP001 
//STRIP001 	FEdit 				aNameED;
//STRIP001 	ListBox				aPathLB;
//STRIP001 	SwGlossaryGroupTLB 	aGroupTLB;
//STRIP001 
//STRIP001 	OKButton 		aOkPB;
//STRIP001 	CancelButton 	aCancelPB;
//STRIP001 	HelpButton		aHelpPB;
//STRIP001 	PushButton		aNewPB;
//STRIP001 	PushButton		aDelPB;
//STRIP001 	PushButton		aRenamePB;
//STRIP001     FixedText       aBibFT;
//STRIP001     FixedText       aPathFT;
//STRIP001     FixedText       aSelectFT;
//STRIP001 
//STRIP001 	SvStrings*		pRemovedArr;
//STRIP001 	SvStrings*		pInsertedArr;
//STRIP001 	SvStrings*		pRenamedArr;
//STRIP001 
//STRIP001 	SwGlossaryHdl 	*pGlosHdl;
//STRIP001 
//STRIP001 	String 			sCreatedGroup;
//STRIP001 
//STRIP001 	BOOL			IsDeleteAllowed(const String &rGroup);
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void Apply();
//STRIP001 	DECL_LINK( SelectHdl, SvTabListBox* );
//STRIP001 	DECL_LINK( NewHdl, Button* );
//STRIP001 	DECL_LINK( DeleteHdl, Button*  );
//STRIP001 	DECL_LINK( ModifyHdl, Edit* );
//STRIP001 	DECL_LINK( RenameHdl, Button*  );
//STRIP001 
//STRIP001 public:
//STRIP001 	SwGlossaryGroupDlg(Window * pParent,
//STRIP001 						const SvStrings* pPathArr,
//STRIP001 						SwGlossaryHdl *pGlosHdl);
//STRIP001 	~SwGlossaryGroupDlg();
//STRIP001 
//STRIP001 	const String&		GetCreatedGroupName() const {return sCreatedGroup;}
//STRIP001 };


} //namespace binfilter
#endif

