/*************************************************************************
 *
 *  $RCSfile: sw_chartins.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:21:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#define _CHARTINS_CXX

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _SCHDLL0_HXX
// auto strip #include <bf_sch/schdll0.hxx>
// auto strip #endif
// auto strip #ifndef _SCH_DLL_HXX //autogen
// auto strip #include <bf_sch/schdll.hxx>
// auto strip #endif
// auto strip #ifndef _SCH_MEMCHRT_HXX
// auto strip #include <bf_sch/memchrt.hxx>
// auto strip #endif

// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
#ifndef _VIEW_HXX
#include <view.hxx>
#endif
#ifndef _CHARTINS_HXX
#include <chartins.hxx>
#endif
// auto strip #ifndef _TABLEMGR_HXX
// auto strip #include <tablemgr.hxx>
// auto strip #endif
// auto strip #ifndef _FRMFMT_HXX
// auto strip #include <frmfmt.hxx>
// auto strip #endif
// auto strip #ifndef _SWTABLE_HXX
// auto strip #include <swtable.hxx>
// auto strip #endif
// auto strip #ifndef _TBLSEL_HXX
// auto strip #include <tblsel.hxx>
// auto strip #endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _CHARTINS_HRC
#include <chartins.hrc>
#endif
namespace binfilter {




/*N*/ SFX_IMPL_MODELESSDIALOG( SwInsertChartChild, SID_INSERT_DIAGRAM )


/*------------------------------------------------------------------------
	Beschreibung: AutoPilot fuer StarChart
------------------------------------------------------------------------*/


//STRIP001 SwInsertChartDlg::SwInsertChartDlg( SfxBindings* pBindings,
//STRIP001 									SfxChildWindow* pChild,
//STRIP001 									Window *pParent,
//STRIP001 									SwWrtShell* pSh ) :
//STRIP001 	SfxModelessDialog( pBindings, pChild, pParent, SW_RES(DLG_INSERT_CHART) ),
//STRIP001 	aTextFt		(this, SW_RES(FT_TEXT    )),
//STRIP001 	aRangeEd    (this, SW_RES(ED_RANGE	 )),
//STRIP001 	aRangeFt	(this, SW_RES(FT_RANGE    )),
//STRIP001 	aFinish		(this, SW_RES(BT_FINISH   )),
//STRIP001 	aHelp		(this, SW_RES(BT_HELP     )),
//STRIP001 	aCancel		(this, SW_RES(BT_CANCEL   )),
//STRIP001     aHLine      (this, SW_RES(FL_HLINE   )),
//STRIP001 	aPrev		(this, SW_RES(BT_PREV	 )),
//STRIP001 	aNext		(this, SW_RES(BT_NEXT	 )),
//STRIP001 	aFirstRow 	(this, SW_RES(CB_FIRST_ROW)),
//STRIP001 	aFirstCol	(this, SW_RES(CB_FIRST_COL)),
//STRIP001     aFL1     (this, SW_RES(FL_1       )),
//STRIP001 	pChartDlg(0),
//STRIP001 	pWrtShell(pSh),
//STRIP001 	pInItemSet(0),
//STRIP001 	pOutItemSet(0),
//STRIP001 	pChartData(0),
//STRIP001 	bUpdateChartData(TRUE),
//STRIP001 	bChartInserted(FALSE),
//STRIP001 	bChildOpen(FALSE)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	pSh->Push();
//STRIP001 
//STRIP001 	aRangeEd.   SetModifyHdl(LINK(this,	SwInsertChartDlg, ModifyHdl));
//STRIP001 	aNext.		SetClickHdl(LINK(this,	SwInsertChartDlg, NextHdl));
//STRIP001 	aFinish.	SetClickHdl(LINK(this,	SwInsertChartDlg, FinishHdl));
//STRIP001 	aCancel.	SetClickHdl(LINK(this,	SwInsertChartDlg, CloseHdl));
//STRIP001 	aFirstRow.	SetClickHdl(LINK(this, 	SwInsertChartDlg, ClickHdl));
//STRIP001 	aFirstCol.	SetClickHdl(LINK(this, 	SwInsertChartDlg, ClickHdl));
//STRIP001 
//STRIP001 	if( pWrtShell->IsCrsrInTbl() )
//STRIP001 	{
//STRIP001 		SwFrmFmt* pTblFmt = pWrtShell->GetTableFmt();
//STRIP001 		aAktTableName = pTblFmt->GetName();
//STRIP001 		if( !pWrtShell->IsTableMode() )
//STRIP001 		{
//STRIP001 			pWrtShell->GetView().GetViewFrame()->GetDispatcher()->
//STRIP001 					Execute(FN_TABLE_SELECT_ALL, SFX_CALLMODE_SYNCHRON);
//STRIP001 		}
//STRIP001 
//STRIP001 		pWrtShell->UpdateChartData( aAktTableName, pChartData );
//STRIP001 
//STRIP001 		String sText( String::CreateFromAscii("<.>") );
//STRIP001 		sText.Insert( pWrtShell->GetBoxNms(), 2);
//STRIP001 		sText.Insert( aAktTableName, 1 );
//STRIP001 		if(sText.GetTokenCount(':') == 2)
//STRIP001 			aRangeEd.SetText(sText);
//STRIP001 
//STRIP001 		ModifyHdl( &aRangeEd );
//STRIP001 	}
//STRIP001 	pInItemSet =  new SfxItemSet( pWrtShell->GetAttrPool(),
//STRIP001 											CHATTR_START, CHATTR_END, 0 );
//STRIP001 	pOutItemSet =  new SfxItemSet( pWrtShell->GetAttrPool(),
//STRIP001 											CHATTR_START, CHATTR_END, 0 );
//STRIP001 	SFX_APP()->LockDispatcher(TRUE);
//STRIP001 	pWrtShell->SelTblCells( LINK( this, SwInsertChartDlg,
//STRIP001 											SelTblCellsNotify) );
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 __EXPORT SwInsertChartDlg::~SwInsertChartDlg()
//STRIP001 {
//STRIP001 	SfxApplication* pSfxApp = SFX_APP();
//STRIP001 	if(pSfxApp->IsDispatcherLocked())
//STRIP001 		pSfxApp->LockDispatcher(FALSE);
//STRIP001 	pWrtShell->EndSelTblCells();
//STRIP001 	pWrtShell->Pop(bChartInserted);
//STRIP001 	delete pInItemSet;
//STRIP001 	delete pOutItemSet;
//STRIP001 	delete pChartDlg;
//STRIP001 	delete pChartData;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 BOOL SwInsertChartDlg::Close()
//STRIP001 {
//STRIP001 	SFX_APP()->LockDispatcher(FALSE);
//STRIP001 	return SfxModelessDialog::Close();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 void SwInsertChartDlg::Activate()
//STRIP001 {
//STRIP001 	SfxModelessDialog::Activate();
//STRIP001 
//STRIP001 	if ( bChildOpen && pChartDlg )
//STRIP001 	{
//STRIP001 		//	#107337# The ChildWindow's "hidden" state is reset if the view is activated,
//STRIP001 		//	so it is hidden again on activating if the child dialog is open.
//STRIP001 
//STRIP001 		SfxViewFrame* pVFrame = pWrtShell->GetView().GetViewFrame();
//STRIP001 		pVFrame->ShowChildWindow(SID_INSERT_DIAGRAM, FALSE);
//STRIP001 
//STRIP001 		pChartDlg->GrabFocus();		// child dialog should have focus
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 //OS: WNTMSCI4 optimiert sonst SetPosPixel und Hide weg!
//STRIP001 #pragma optimize("",off)
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK( SwInsertChartDlg, NextHdl, Button *, pBtn )
//STRIP001 {
//STRIP001 
//STRIP001 	if ( bUpdateChartData )
//STRIP001 		UpdateData();
//STRIP001 
//STRIP001 	if(!pChartDlg)
//STRIP001 	{
//STRIP001 		pChartDlg = SchDLL::CreateAutoPilotDlg( GetParent(),	pChartData,
//STRIP001 									 *pInItemSet, *pOutItemSet, TRUE);
//STRIP001 	}
//STRIP001 	else if(bUpdateChartData)
//STRIP001 	{
//STRIP001 		SchDLL::ChangeChartData(pChartDlg,
//STRIP001 							pChartData);
//STRIP001 	}
//STRIP001 	bUpdateChartData = FALSE;
//STRIP001 	pChartDlg->SetPosPixel(GetPosPixel());
//STRIP001 	SfxViewFrame* pVFrame = pWrtShell->GetView().GetViewFrame();
//STRIP001 	pVFrame->ShowChildWindow(SID_INSERT_DIAGRAM, FALSE);
//STRIP001 	bChildOpen = TRUE;
//STRIP001 	USHORT nResult = pChartDlg->Execute();
//STRIP001 	bChildOpen = FALSE;
//STRIP001 	switch( nResult )
//STRIP001 	{
//STRIP001 		case RET_OK:
//STRIP001 			FinishHdl( &aFinish );
//STRIP001 		break;
//STRIP001 		case RET_CANCEL:
//STRIP001 			SetPosPixel(pChartDlg->GetPosPixel());
//STRIP001 			Close();
//STRIP001 		break;
//STRIP001 		default:
//STRIP001 			SetPosPixel(pChartDlg->GetPosPixel());
//STRIP001 			pVFrame->ShowChildWindow(SID_INSERT_DIAGRAM, TRUE);
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 #pragma optimize("",on)
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK( SwInsertChartDlg, FinishHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	pWrtShell->GotoTable(aAktTableName);
//STRIP001 	pWrtShell->GetView().GetViewFrame()->ToTop();
//STRIP001 	SwWrtShell* pShell = pWrtShell; // Member auf den Stack wg. Close()
//STRIP001 	SfxItemSet* pOutSet = pOutItemSet;
//STRIP001 	pOutItemSet = 0;
//STRIP001 	bChartInserted = TRUE;
//STRIP001 	BOOL bCrsrInTbl = pShell->IsCrsrInTbl() != 0;
//STRIP001 	BOOL bTblCplx = pShell->IsTblComplexForChart();
//STRIP001 	if( bCrsrInTbl && !bTblCplx && bUpdateChartData )
//STRIP001 		UpdateData();
//STRIP001 	SchMemChart *pChData = pChartData; // Member auf den Stack wg. Close() -> aber erst nach UpdateData()
//STRIP001 	pChartData = 0;
//STRIP001 
//STRIP001 	Close();
//STRIP001 
//STRIP001 	if( bCrsrInTbl && !bTblCplx )
//STRIP001 	{
//STRIP001 		SwTableFUNC( pShell, FALSE ).InsertChart( *pChData, pOutSet );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pShell->Insert( 0, SCH_MOD()->pSchChartDocShellFactory, FALSE );
//STRIP001 	}
//STRIP001 	delete pOutSet;
//STRIP001 	delete pChData;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK( SwInsertChartDlg, ClickHdl, CheckBox *, EMPTYARG )
//STRIP001 {
//STRIP001 	bUpdateChartData = TRUE;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung: Handler fuer die Tabellenselektion
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwInsertChartDlg, SelTblCellsNotify, SwWrtShell *, pCaller )
//STRIP001 {
//STRIP001 	SwFrmFmt* pTblFmt = pCaller->GetTableFmt();
//STRIP001 	SwTable* pTbl = 0;
//STRIP001 	if(pTblFmt)
//STRIP001 	{
//STRIP001 		SwClientIter aIter(*pTblFmt);
//STRIP001 		pTbl = (SwTable*)aIter.First(TYPE(SwTable));
//STRIP001 		DBG_ASSERT(pTbl, "keine Tabelle gefunden")
//STRIP001 	}
//STRIP001 	if( pTbl && !pCaller->IsTblComplexForChart() )
//STRIP001 	{
//STRIP001 		String sCommand = String::CreateFromAscii("<.>");
//STRIP001 		sCommand.Insert(pCaller->GetBoxNms(),2);
//STRIP001 		aAktTableName = pTblFmt->GetName();
//STRIP001 		sCommand.Insert(pTblFmt->GetName(), 1);
//STRIP001 		aRangeEd.SetText(sCommand);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aRangeEd.SetText(aEmptyStr);
//STRIP001 	}
//STRIP001 	ModifyHdl( &aRangeEd );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwInsertChartDlg, CloseHdl, Button*, EMPTYARG )
//STRIP001 {
//STRIP001 	Close();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001 	Beschreibung: Handler fuer Edit
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwInsertChartDlg, ModifyHdl, Edit*, pEdit )
//STRIP001 {
//STRIP001 //	hier muss getestet werden, ob mit dem aktuellen Eintrag eine
//STRIP001 // 	gueltige Selektion einer Tabelle aufgebaut werden kann
//STRIP001 
//STRIP001 	BOOL bCorrect = FALSE;
//STRIP001 	BOOL bFinish = FALSE;
//STRIP001 	BOOL bChkFirstRow = TRUE, bChkFirstCol = TRUE;
//STRIP001 
//STRIP001 	String sContent = pEdit->GetText();
//STRIP001 	if( !sContent.Len() )
//STRIP001 	{
//STRIP001 		bCorrect = pWrtShell->IsCrsrInTbl() != 0;
//STRIP001 		aAktTableName = sContent;
//STRIP001 		bFinish = TRUE;
//STRIP001 	}
//STRIP001 	else if( sContent.GetChar( 0 ) == '<'	&&
//STRIP001 		sContent.GetTokenCount(':') == 2	&&
//STRIP001 		sContent.GetChar( sContent.Len() - 1 ) == '>')
//STRIP001 	{
//STRIP001 		USHORT nFndPos = sContent.Search( '.' );
//STRIP001 		String aTable( sContent.Copy( 1, nFndPos - 1 ));
//STRIP001 		SwFrmFmt* pFmt = pWrtShell->GetTableFmt();
//STRIP001 		if( ( pFmt && pFmt->GetName() == aTable ) ||
//STRIP001 			pWrtShell->GotoTable( aTable ) )
//STRIP001 		{
//STRIP001 			aAktTableName = aTable;
//STRIP001 
//STRIP001 			sContent.Erase( 0, nFndPos + 1 );
//STRIP001 			sContent.Erase( sContent.Len() - 1 );
//STRIP001 
//STRIP001 			SwTable* pTable = SwTable::FindTable( pWrtShell->GetTableFmt() );
//STRIP001 			SwChartLines aLines;
//STRIP001 			if( !pTable->IsTblComplexForChart( sContent, &aLines ))
//STRIP001 			{
//STRIP001 				bChkFirstCol = 1 < aLines[ 0 ]->Count();
//STRIP001 				bChkFirstRow = 1 < aLines.Count();
//STRIP001 
//STRIP001 				bFinish = bCorrect = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	aNext.Enable( bCorrect );
//STRIP001 	aFinish.Enable( bFinish );
//STRIP001 
//STRIP001 	if( bChkFirstRow != aFirstRow.IsEnabled() )
//STRIP001 	{
//STRIP001 		if( bChkFirstRow )
//STRIP001 			aFirstRow.Check( aFirstRow.GetSavedValue() );
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aFirstRow.SaveValue();
//STRIP001 			aFirstRow.Check( FALSE );
//STRIP001 		}
//STRIP001 
//STRIP001 		aFirstRow.Enable( bChkFirstRow );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bChkFirstCol != aFirstCol.IsEnabled() )
//STRIP001 	{
//STRIP001 		if( bChkFirstCol )
//STRIP001 			aFirstCol.Check( aFirstCol.GetSavedValue() );
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aFirstCol.SaveValue();
//STRIP001 			aFirstCol.Check( FALSE );
//STRIP001 		}
//STRIP001 
//STRIP001 		aFirstCol.Enable( bChkFirstCol );
//STRIP001 	}
//STRIP001 
//STRIP001 	bUpdateChartData = TRUE;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 void SwInsertChartDlg::UpdateData()
//STRIP001 {
//STRIP001 	if( !pChartData )
//STRIP001 		pWrtShell->UpdateChartData( aAktTableName, pChartData );
//STRIP001 
//STRIP001 	if( pChartData )
//STRIP001 	{
//STRIP001 		String aData = aFirstRow.IsChecked() ? '1' : '0';
//STRIP001 		aData += aFirstCol.IsChecked() ? '1': '0';
//STRIP001 		pChartData->SomeData2() = aData;
//STRIP001 		aData = aRangeEd.GetText();
//STRIP001 		aData.Erase(1, aAktTableName.Len() +1 );
//STRIP001 		pChartData->SomeData1() = aData;
//STRIP001 		pWrtShell->UpdateChartData( aAktTableName, pChartData );
//STRIP001 	}
//STRIP001 }


/*------------------------------------------------------------------------
	Beschreibung:
------------------------------------------------------------------------*/


/*N*/ SwInsertChartChild::SwInsertChartChild(Window* pParent,
/*N*/ 						USHORT nId,
/*N*/ 						SfxBindings* pBindings,
/*N*/ 						SfxChildWinInfo* pInfo ) :
/*N*/ 						SfxChildWindow( pParent, nId )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 
//STRIP001 	SwView *pView = ::GetActiveView();
//STRIP001 	SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 
//STRIP001 	pWindow = new SwInsertChartDlg( pBindings, this, pParent, &rSh );
//STRIP001 	pWindow->SetPosPixel(pInfo->aPos);
//STRIP001 	pWindow->Show();
//STRIP001 
/*N*/ }


//STRIP001 void __EXPORT AutoEdit::KeyInput( const KeyEvent& rEvt )
//STRIP001 {
//STRIP001 	USHORT nCode = rEvt.GetKeyCode().GetCode();
//STRIP001 	if( nCode != KEY_SPACE )
//STRIP001 		Edit::KeyInput( rEvt );
//STRIP001 }




}
