/*************************************************************************
 *
 *  $RCSfile: sw_delete.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:58:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _CRSSKIP_HXX
//STRIP001 #include <crsskip.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWCRSR_HXX
//STRIP001 #include <swcrsr.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 inline void SwWrtShell::OpenMark()
//STRIP001 {
//STRIP001 	StartAllAction();
//STRIP001 	ResetCursorStack();
//STRIP001 	KillPams();
//STRIP001 	SetMark();
//STRIP001 }
//STRIP001 
//STRIP001 inline void SwWrtShell::CloseMark( BOOL bOkFlag )
//STRIP001 {
//STRIP001 	if( bOkFlag )
//STRIP001 		UpdateAttr();
//STRIP001 	else
//STRIP001 		SwapPam();
//STRIP001 
//STRIP001 	ClearMark();
//STRIP001 	EndAllAction();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:	Zeile loeschen
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelLine()
//STRIP001 {
//STRIP001 	ACT_KONTEXT(this);
//STRIP001 	ResetCursorStack();
//STRIP001 		// alten Cursor merken
//STRIP001 	Push();
//STRIP001 	ClearMark();
//STRIP001 	SwCrsrShell::LeftMargin();
//STRIP001 	SetMark();
//STRIP001 	SwCrsrShell::RightMargin();
//STRIP001 //Warum soll hier noch ein Zeichen in der naechsten Zeile geloescht werden?
//STRIP001 //	if(!IsEndOfPara())
//STRIP001 //		SwCrsrShell::Right();
//STRIP001 	long nRet = Delete();
//STRIP001 	Pop(FALSE);
//STRIP001 	if( nRet )
//STRIP001 		UpdateAttr();
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelToStartOfLine()
//STRIP001 {
//STRIP001 	OpenMark();
//STRIP001 	SwCrsrShell::LeftMargin();
//STRIP001 	long nRet = Delete();
//STRIP001 	CloseMark( 0 != nRet );
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelToEndOfLine()
//STRIP001 {
//STRIP001 	OpenMark();
//STRIP001 	SwCrsrShell::RightMargin();
//STRIP001 	long nRet = Delete();
//STRIP001 	CloseMark( 0 != nRet );
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelLeft()
//STRIP001 {
//STRIP001 	// wenns denn ein Fly ist, wech damit
//STRIP001 	int nSelType = GetSelectionType();
//STRIP001 	const int nCmp = SEL_FRM | SEL_GRF | SEL_OLE | SEL_DRW;
//STRIP001 	if( nCmp & nSelType )
//STRIP001 	{
//STRIP001         /*  #108205# Remember object's position. */
//STRIP001         Point aTmpPt = GetObjRect().TopLeft();
//STRIP001 
//STRIP001 		DelSelectedObj();
//STRIP001         
//STRIP001         /*  #108205# Set cursor to remembered position. */
//STRIP001         SetCrsr(&aTmpPt);
//STRIP001 
//STRIP001 		LeaveSelFrmMode();
//STRIP001 		UnSelectFrm();
//STRIP001 
//STRIP001 		nSelType = GetSelectionType();
//STRIP001 		if ( nCmp & nSelType )
//STRIP001 		{
//STRIP001 			EnterSelFrmMode();
//STRIP001 			GotoNextFly();
//STRIP001 		}
//STRIP001 
//STRIP001 		return 1L;
//STRIP001 	}
//STRIP001 
//STRIP001 	// wenn eine Selektion existiert, diese loeschen.
//STRIP001 	if ( IsSelection() )
//STRIP001 	{
//STRIP001 		 //OS: wieder einmal Basic: ACT_KONTEXT muss vor
//STRIP001 		//EnterStdMode verlassen werden!
//STRIP001 		{
//STRIP001 			ACT_KONTEXT(this);
//STRIP001 			ResetCursorStack();
//STRIP001 			Delete();
//STRIP001 			UpdateAttr();
//STRIP001 		}
//STRIP001 		EnterStdMode();
//STRIP001 		return 1L;
//STRIP001 	}
//STRIP001 
//STRIP001 	// JP 29.06.95: nie eine davor stehende Tabelle loeschen.
//STRIP001 	BOOL bSwap = FALSE;
//STRIP001 	const SwTableNode * pWasInTblNd = SwCrsrShell::IsCrsrInTbl();
//STRIP001 	if( SwCrsrShell::IsSttPara())
//STRIP001 	{
//STRIP001 		/* If the cursor is at the beginning of a paragraph, try to step
//STRIP001            backwards. On failure we are done. */
//STRIP001 		if( !SwCrsrShell::Left(1,CRSR_SKIP_CHARS) )
//STRIP001 			return 0;
//STRIP001 
//STRIP001 		/* If the cursor entered or left a table (or both) we are done. No step
//STRIP001            back. */
//STRIP001 		if( SwCrsrShell::IsCrsrInTbl() != pWasInTblNd )
//STRIP001 			return 0;
//STRIP001 
//STRIP001 		OpenMark();
//STRIP001 		SwCrsrShell::Right(1,CRSR_SKIP_CHARS);
//STRIP001 		SwCrsrShell::SwapPam();
//STRIP001 		bSwap = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		OpenMark();
//STRIP001 		SwCrsrShell::Left(1,CRSR_SKIP_CHARS);
//STRIP001 	}
//STRIP001 	long nRet = Delete();
//STRIP001 	if( !nRet && bSwap )
//STRIP001 		SwCrsrShell::SwapPam();
//STRIP001 	CloseMark( 0 != nRet );
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 long SwWrtShell::DelRight(BOOL bDelFrm)
//STRIP001 {
//STRIP001 		// werden verodert, wenn Tabellenselektion vorliegt;
//STRIP001 		// wird hier auf SEL_TBL umgesetzt.
//STRIP001 	long nRet = 0;
//STRIP001 	int nSelection = GetSelectionType();
//STRIP001 	if(nSelection & SwWrtShell::SEL_TBL_CELLS)
//STRIP001 		nSelection = SwWrtShell::SEL_TBL;
//STRIP001 	if(nSelection & SwWrtShell::SEL_TXT)
//STRIP001 		nSelection = SwWrtShell::SEL_TXT;
//STRIP001 
//STRIP001 	const SwTableNode * pWasInTblNd = NULL;
//STRIP001 
//STRIP001 	switch( nSelection & ~(SEL_BEZ) )
//STRIP001 	{
//STRIP001 	case SEL_TXT:
//STRIP001 	case SEL_TBL:
//STRIP001 	case SEL_NUM:
//STRIP001 			//	wenn eine Selektion existiert, diese loeschen.
//STRIP001 		if( IsSelection() )
//STRIP001 		{
//STRIP001 			//OS: wieder einmal Basic: ACT_KONTEXT muss vor
//STRIP001 			//EnterStdMode verlassen werden!
//STRIP001 			{
//STRIP001 				ACT_KONTEXT(this);
//STRIP001 				ResetCursorStack();
//STRIP001 				Delete();
//STRIP001 				UpdateAttr();
//STRIP001 			}
//STRIP001 			EnterStdMode();
//STRIP001 			nRet = 1L;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		pWasInTblNd = IsCrsrInTbl();
//STRIP001         
//STRIP001 		if( SEL_TXT & nSelection && SwCrsrShell::IsSttPara() &&
//STRIP001 			SwCrsrShell::IsEndPara() && !IsCrsrInTbl() &&
//STRIP001 			SwCrsrShell::Right(1,CRSR_SKIP_CHARS) )
//STRIP001 		{
//STRIP001 			BOOL bDelFull = 0 != IsCrsrInTbl();
//STRIP001 			SwCrsrShell::Left(1,CRSR_SKIP_CHARS);
//STRIP001 
//STRIP001 			if( bDelFull )
//STRIP001 			{
//STRIP001 				DelFullPara();
//STRIP001 				UpdateAttr();
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else 
//STRIP001         {
//STRIP001             /* #108049# Save the startnode of the current cell */
//STRIP001             const SwStartNode * pSNdOld;
//STRIP001             pSNdOld = GetSwCrsr()->GetNode()->
//STRIP001                 FindTableBoxStartNode();
//STRIP001 
//STRIP001             if (SwCrsrShell::IsEndPara() &&
//STRIP001                 SwCrsrShell::Right(1, CRSR_SKIP_CHARS))
//STRIP001             {
//STRIP001                 if (IsCrsrInTbl() || (pWasInTblNd != IsCrsrInTbl()))
//STRIP001                 {
//STRIP001                     /* #108049# Save the startnode of the current
//STRIP001                         cell. May be different to pSNdOld as we have
//STRIP001                         moved. */
//STRIP001                     const SwStartNode * pSNdNew = GetSwCrsr()
//STRIP001                         ->GetNode()->FindTableBoxStartNode();
//STRIP001                     
//STRIP001                     /* #108049# Only move instead of deleting if we
//STRIP001                         have moved to a different cell */
//STRIP001                     if (pSNdOld != pSNdNew)
//STRIP001                         break;
//STRIP001                 }
//STRIP001 
//STRIP001                 SwCrsrShell::Left(1, CRSR_SKIP_CHARS);
//STRIP001 
//STRIP001             }
//STRIP001         }
//STRIP001 
//STRIP001 		OpenMark();
//STRIP001 		SwCrsrShell::Right(1,CRSR_SKIP_CELLS);
//STRIP001 		nRet = Delete();
//STRIP001 		CloseMark( 0 != nRet );
//STRIP001 		break;
//STRIP001 
//STRIP001 	case SEL_FRM:
//STRIP001 	case SEL_GRF:
//STRIP001 	case SEL_OLE:
//STRIP001 	case SEL_DRW:
//STRIP001 	case SEL_DRW_TXT:
//STRIP001 	case SEL_DRW_FORM:
//STRIP001         {
//STRIP001             /*  #108205# Remember object's position. */
//STRIP001             Point aTmpPt = GetObjRect().TopLeft();
//STRIP001 
//STRIP001             DelSelectedObj();
//STRIP001             
//STRIP001             /*  #108205# Set cursor to remembered position. */
//STRIP001             SetCrsr(&aTmpPt);
//STRIP001 
//STRIP001             LeaveSelFrmMode();
//STRIP001             UnSelectFrm();
//STRIP001         }
//STRIP001 
//STRIP001 		if( IsFrmSelected() )
//STRIP001 		{
//STRIP001 			nSelection = GetSelectionType();
//STRIP001 			if ( SEL_FRM & nSelection || SEL_GRF & nSelection ||
//STRIP001 				SEL_OLE & nSelection || SEL_DRW & nSelection )
//STRIP001 			{
//STRIP001 				EnterSelFrmMode();
//STRIP001 				GotoNextFly();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		nRet = 1;
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelToEndOfPara()
//STRIP001 {
//STRIP001 	ACT_KONTEXT(this);
//STRIP001 	ResetCursorStack();
//STRIP001 	Push();
//STRIP001 	SetMark();
//STRIP001 	if( !MovePara(fnParaCurr,fnParaEnd))
//STRIP001 	{
//STRIP001 		Pop(FALSE);
//STRIP001 		return 0;
//STRIP001 	}
//STRIP001 	long nRet = Delete();
//STRIP001 	Pop(FALSE);
//STRIP001 	if( nRet )
//STRIP001 		UpdateAttr();
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelToStartOfPara()
//STRIP001 {
//STRIP001 	ACT_KONTEXT(this);
//STRIP001 	ResetCursorStack();
//STRIP001 	Push();
//STRIP001 	SetMark();
//STRIP001 	if( !MovePara(fnParaCurr,fnParaStart))
//STRIP001 	{
//STRIP001 		Pop(FALSE);
//STRIP001 		return 0;
//STRIP001 	}
//STRIP001 	long nRet = Delete();
//STRIP001 	Pop(FALSE);
//STRIP001 	if( nRet )
//STRIP001 		UpdateAttr();
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 /*
//STRIP001  * alle Loeschoperationen sollten mit Find statt mit
//STRIP001  * Nxt-/PrvDelim arbeiten, da letzteren mit Wrap Around arbeiten
//STRIP001  * -- das ist wohl nicht gewuenscht.
//STRIP001  */
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelToStartOfSentence()
//STRIP001 {
//STRIP001 	if(IsStartOfDoc())
//STRIP001 		return 0;
//STRIP001 	OpenMark();
//STRIP001 	long nRet = _BwdSentence() ? Delete() : 0;
//STRIP001 	CloseMark( 0 != nRet );
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelToEndOfSentence()
//STRIP001 {
//STRIP001 	if(IsEndOfDoc())
//STRIP001 		return 0;
//STRIP001 	OpenMark();
//STRIP001 	long nRet = _FwdSentence() ? Delete() : 0;
//STRIP001 	CloseMark( 0 != nRet );
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelNxtWord()
//STRIP001 {
//STRIP001 	if(IsEndOfDoc())
//STRIP001 		return 0;
//STRIP001 	ACT_KONTEXT(this);
//STRIP001 	ResetCursorStack();
//STRIP001 	EnterStdMode();
//STRIP001 	SetMark();
//STRIP001 	if(IsEndWrd())
//STRIP001 		_NxtWrd();
//STRIP001 	if(IsSttWrd() || IsEndPara())
//STRIP001 		_NxtWrd();
//STRIP001 	else
//STRIP001 		_EndWrd();
//STRIP001 
//STRIP001 	long nRet = Delete();
//STRIP001 	if( nRet )
//STRIP001 		UpdateAttr();
//STRIP001 	else
//STRIP001 		SwapPam();
//STRIP001 	ClearMark();
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 long SwWrtShell::DelPrvWord()
//STRIP001 {
//STRIP001 	if(IsStartOfDoc())
//STRIP001 		return 0;
//STRIP001 	ACT_KONTEXT(this);
//STRIP001 	ResetCursorStack();
//STRIP001 	EnterStdMode();
//STRIP001 	SetMark();
//STRIP001 	if( !IsSttWrd() || !_PrvWrd() )
//STRIP001 	{
//STRIP001 		if( IsEndWrd() )
//STRIP001 		{
//STRIP001 			if( _PrvWrd() )
//STRIP001 			{
//STRIP001 				// skip over all-1 spaces
//STRIP001 				short n = -1;
//STRIP001 				while( ' ' == GetChar( FALSE, n ))
//STRIP001 					--n;
//STRIP001 
//STRIP001 				if( ++n )
//STRIP001 					ExtendSelection( FALSE, -n );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( IsSttPara())
//STRIP001 			_PrvWrd();
//STRIP001 		else
//STRIP001 			_SttWrd();
//STRIP001 	}
//STRIP001 	long nRet = Delete();
//STRIP001 	if( nRet )
//STRIP001 		UpdateAttr();
//STRIP001 	else
//STRIP001 		SwapPam();
//STRIP001 	ClearMark();
//STRIP001 	return nRet;
//STRIP001 }




}
