/*************************************************************************
 *
 *  $RCSfile: docvor.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:26:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFXDOCVOR_HXX
#define _SFXDOCVOR_HXX


#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif

#include "bf_sfx2/objsh.hxx"
#include "bf_sfx2/orgmgr.hxx"
namespace binfilter {

//=========================================================================

class SfxDocumentTemplates;
class Path;

//=========================================================================

#ifndef _SFX_HXX

//STRIP001 class SfxOrganizeDlg_Impl;

//STRIP001 class SfxOrganizeListBox_Impl: public SvTreeListBox
//STRIP001 {
//STRIP001 	enum BMPTYPE			{ BMPTYPE_FOLDER, BMPTYPE_DOC };
//STRIP001 
//STRIP001 friend class SfxOrganizeDlg_Impl;
//STRIP001 
//STRIP001 	Image					aOpenedFolderBmp;
//STRIP001 	Image					aClosedFolderBmp;
//STRIP001 	Image					aOpenedDocBmp;
//STRIP001 	Image					aClosedDocBmp;
//STRIP001 
//STRIP001 	Image					aOpenedFolderBmpHC;
//STRIP001 	Image					aClosedFolderBmpHC;
//STRIP001 	Image					aOpenedDocBmpHC;
//STRIP001 	Image					aClosedDocBmpHC;
//STRIP001 
//STRIP001 	SfxOrganizeMgr*			pMgr;
//STRIP001 	SfxOrganizeDlg_Impl*	pDlg;
//STRIP001 
//STRIP001 	static BOOL				bDropMoveOk;
//STRIP001 
//STRIP001 	DECL_LINK( OnAsyncExecuteDrop, ExecuteDropEvent* );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual BOOL EditingEntry( SvLBoxEntry* pEntry, Selection & );
//STRIP001 	virtual BOOL EditedEntry( SvLBoxEntry* pEntry, const String& rNewText );
//STRIP001 	virtual BOOL NotifyMoving(SvLBoxEntry *pSource,
//STRIP001 							SvLBoxEntry* pTarget,
//STRIP001 							SvLBoxEntry *&pNewParent, ULONG &);
//STRIP001 	virtual BOOL NotifyCopying(SvLBoxEntry *pSource,
//STRIP001 							SvLBoxEntry* pTarget,
//STRIP001 							SvLBoxEntry *&pNewParent, ULONG &);
//STRIP001 	virtual void RequestingChilds( SvLBoxEntry* pParent );
//STRIP001 	virtual long ExpandingHdl();
//STRIP001 	virtual BOOL Select( SvLBoxEntry* pEntry, BOOL bSelect=TRUE );

	// new d&d
//STRIP001 	virtual DragDropMode	NotifyStartDrag( TransferDataContainer&, SvLBoxEntry* );
//STRIP001 	virtual BOOL			NotifyAcceptDrop( SvLBoxEntry* );
//STRIP001 	virtual sal_Int8		AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	virtual sal_Int8		ExecuteDrop( const ExecuteDropEvent& rEvt );

//STRIP001 public:
//STRIP001 	enum DataEnum	{ VIEW_TEMPLATES, VIEW_FILES } eViewType;
//STRIP001 
//STRIP001 	SfxOrganizeListBox_Impl( SfxOrganizeDlg_Impl* pDlg, Window* pParent, WinBits, DataEnum );
//STRIP001 
//STRIP001 	DataEnum	GetViewType() const { return eViewType; }
//STRIP001 	void		SetViewType(DataEnum eType) { eViewType = eType; }
//STRIP001 
//STRIP001 	void SetMgr(SfxOrganizeMgr *pM) { pMgr = pM; }
//STRIP001 	void Reset();
//STRIP001 	inline void SetBitmaps(
//STRIP001 					const Image &rOFolderBmp, const Image &rCFolderBmp, const Image &rODocBmp, const Image &rCDocBmp,
//STRIP001 					const Image &rOFolderBmpHC, const Image &rCFolderBmpHC, const Image &rODocBmpHC, const Image &rCDocBmpHC );
//STRIP001 	const Image &GetClosedBmp(USHORT nLevel) const;
//STRIP001 	const Image &GetOpenedBmp(USHORT nLevel) const;
//STRIP001 
//STRIP001 	virtual PopupMenu*	CreateContextMenu();
//STRIP001 
//STRIP001 private:
//STRIP001 	BOOL IsStandard_Impl( SvLBoxEntry *) const;
//STRIP001 	BOOL MoveOrCopyTemplates(SvLBox *pSourceBox,
//STRIP001 							SvLBoxEntry *pSource,
//STRIP001 							SvLBoxEntry* pTarget,
//STRIP001 							SvLBoxEntry *&pNewParent,
//STRIP001 							ULONG &rIdx,
//STRIP001 							BOOL bCopy);
//STRIP001 	BOOL MoveOrCopyContents(SvLBox *pSourceBox,
//STRIP001 							SvLBoxEntry *pSource,
//STRIP001 							SvLBoxEntry* pTarget,
//STRIP001 							SvLBoxEntry *&pNewParent,
//STRIP001 							ULONG &rIdx,
//STRIP001 							BOOL bCopy);
//STRIP001 	inline USHORT		GetDocLevel() const;
//STRIP001 	SfxObjectShellRef	GetObjectShell( const Path& );
//STRIP001 	BOOL				IsUniqName_Impl( const String &rText,
//STRIP001 										 SvLBoxEntry* pParent, SvLBoxEntry* pEntry = 0 ) const;
//STRIP001 	USHORT				GetLevelCount_Impl( SvLBoxEntry* pParent ) const;

//STRIP001 	SvLBoxEntry*		InsertEntryByBmpType( const XubString& rText, BMPTYPE eBmpType,
//STRIP001 							SvLBoxEntry* pParent = NULL, BOOL bChildsOnDemand = FALSE,
//STRIP001 							ULONG nPos = LIST_APPEND, void* pUserData = NULL );
//STRIP001 };

#endif // _SFX_HXX

//=========================================================================

//STRIP001 class SfxTemplateOrganizeDlg : public ModalDialog
//STRIP001 {
//STRIP001 friend class SfxOrganizeListBox_Impl;

//STRIP001 	class SfxOrganizeDlg_Impl *pImp;

//	virtual void	DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 public:
//STRIP001 	SfxTemplateOrganizeDlg(Window * pParent, SfxDocumentTemplates* = 0);
//STRIP001 	~SfxTemplateOrganizeDlg();
//STRIP001 
//STRIP001 #define RET_EDIT_STYLE       100
//STRIP001 
//STRIP001 	virtual short Execute();
//STRIP001 };
//STRIP001 
}//end of namespace binfilter
#endif
