/*************************************************************************
 *
 *  $RCSfile: backgrnd.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:08:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_BACKGRND_HXX
#define _SVX_BACKGRND_HXX

// include ---------------------------------------------------------------

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _GRAPH_HXX //autogen
#include <vcl/graph.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
// auto strip #ifndef _SVX_DLG_CTRL_HXX
// auto strip #include <bf_svx/dlgctrl.hxx>
// auto strip #endif
namespace binfilter {

// Absatzvorlage
#define PARA_DEST_PARA	0
#define PARA_DEST_CHAR  1

// class SvxBackgroundTabPage --------------------------------------------
/*
{k:\svx\prototyp\dialog\backgrnd.bmp}
	[Beschreibung]
	Mit dieser TabPage kann eine Brush (z.B. fuer die Hintergrundfarbe eines
	Rahmens) eingestellt werden.
	[Items]
	<SvxBrushItem>:     <SID_ATTR_BRUSH>;
*/

//------------------------------------------------------------------------
// forwards:

//STRIP001 class BackgroundPreviewImpl;
//STRIP001 class SvxOpenGraphicDialog;
//STRIP001 struct SvxBackgroundTable_Impl;
//STRIP001 struct SvxBackgroundPara_Impl;
//STRIP001 struct SvxBackgroundPage_Impl;
//STRIP001 class SvxBrushItem;
//------------------------------------------------------------------------

//STRIP001 class SvxBackgroundTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	static SfxTabPage*  Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 	static USHORT*      GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL        FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual void        Reset( const SfxItemSet& rSet );
//STRIP001 	virtual void        FillUserData();
//STRIP001 	virtual void        PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void                ShowSelector(); // Umschalt-ListBox aktivieren
//STRIP001 	void                ShowTblControl(); // fuer den Writer (Zellen/Zeilen/Tabelle)
//STRIP001 	void                ShowParaControl(BOOL bCharOnly = FALSE); // fuer den Writer (Absatz/Zeichen)
//STRIP001     void                EnableTransparency(BOOL bColor, BOOL bGraphic);
//STRIP001 protected:
//STRIP001 	virtual int         DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxBackgroundTabPage( Window* pParent, const SfxItemSet& rCoreSet );
//STRIP001 	~SvxBackgroundTabPage();
//STRIP001 
//STRIP001 	// Hintergrundfarbe ------------------------------------
//STRIP001 	Window					aBorderWin;
//STRIP001 	ValueSet                aBackgroundColorSet;
//STRIP001     FixedLine               aBackgroundColorBox;
//STRIP001 	BackgroundPreviewImpl*  pPreviewWin1;
//STRIP001     //color transparency
//STRIP001     FixedText               aColTransFT;
//STRIP001     MetricField             aColTransMF;
//STRIP001     // Hintergrund-Bitmap ----------------------------------
//STRIP001 	PushButton              aBtnBrowse;
//STRIP001 	CheckBox                aBtnLink;
//STRIP001 	CheckBox                aBtnPreview;
//STRIP001 	FixedInfo               aFtFile;
//STRIP001     FixedLine               aGbFile;
//STRIP001 	RadioButton             aBtnPosition;
//STRIP001 	RadioButton             aBtnArea;
//STRIP001 	RadioButton             aBtnTile;
//STRIP001 	SvxRectCtl              aWndPosition;
//STRIP001     FixedLine               aGbPosition;
//STRIP001     //transparency of graphics
//STRIP001     FixedLine               aGraphTransFL;
//STRIP001     MetricField             aGraphTransMF;
//STRIP001 
//STRIP001     BackgroundPreviewImpl*  pPreviewWin2;
//STRIP001     // Selektor --------------------------------------------
//STRIP001 	FixedText               aSelectTxt;
//STRIP001 	ListBox                 aLbSelect;
//STRIP001 	const String            aStrBrowse;
//STRIP001 	const String            aStrUnlinked;
//STRIP001 
//STRIP001 	// DDListBox fuer Writer -------------------------------
//STRIP001 
//STRIP001 	FixedText               aTblDesc;
//STRIP001 	ListBox                 aTblLBox;
//STRIP001 	ListBox					aParaLBox;
//STRIP001 
//STRIP001 	//------------------------------------------------------
//STRIP001 	Color		aBgdColor;
//STRIP001 	USHORT		nHtmlMode;
//STRIP001 	BOOL        bAllowShowSelector	: 1;
//STRIP001 	BOOL        bIsGraphicValid		: 1;
//STRIP001 	BOOL		bLinkOnly			: 1;
//STRIP001     BOOL        bResized            : 1;
//STRIP001     BOOL        bColTransparency    : 1;
//STRIP001     BOOL        bGraphTransparency  : 1;
//STRIP001     Graphic     aBgdGraphic;
//STRIP001 	String      aBgdGraphicPath;
//STRIP001 	String      aBgdGraphicFilter;
//STRIP001 
//STRIP001 	SvxBackgroundPage_Impl* pPageImpl;
//STRIP001 	SvxOpenGraphicDialog* pImportDlg;
//STRIP001 
//STRIP001 	// Items fuer Sw-Tabelle muessen gesammelt werden
//STRIP001 	SvxBackgroundTable_Impl*	pTableBck_Impl;
//STRIP001 	// auch fuer die Absatzvorlage
//STRIP001 	SvxBackgroundPara_Impl*	pParaBck_Impl;
//STRIP001 
//STRIP001 #ifdef _SVX_BACKGRND_CXX
//STRIP001 	void                FillColorValueSets_Impl();
//STRIP001 	void                ShowColorUI_Impl();
//STRIP001 	void                ShowBitmapUI_Impl();
//STRIP001 	BOOL                LoadLinkedGraphic_Impl();
//STRIP001 	void                RaiseLoadError_Impl();
//STRIP001 	void                SetGraphicPosition_Impl( SvxGraphicPosition ePos );
//STRIP001 	SvxGraphicPosition  GetGraphicPosition_Impl();
//STRIP001 	void				FillControls_Impl(const SvxBrushItem& rBgdAttr,
//STRIP001 											const String& rUserData);
//STRIP001 	BOOL 				FillItemSetWithWallpaperItem( SfxItemSet& rCoreSet, USHORT nSlot);
//STRIP001 	void				ResetFromWallpaperItem( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	DECL_LINK( LoadTimerHdl_Impl, Timer* );
//STRIP001 	DECL_LINK( SelectHdl_Impl, ListBox* );
//STRIP001 	DECL_LINK( BrowseHdl_Impl, PushButton* );
//STRIP001 	DECL_LINK( RadioClickHdl_Impl, RadioButton* );
//STRIP001 	DECL_LINK( FileClickHdl_Impl, CheckBox* );
//STRIP001 	DECL_LINK( BackgroundColorHdl_Impl, ValueSet* );
//STRIP001 	DECL_LINK( TblDestinationHdl_Impl, ListBox* );
//STRIP001 	DECL_LINK( ParaDestinationHdl_Impl, ListBox* );
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SVX_BACKGRND_HXX

