/*************************************************************************
 *
 *  $RCSfile: contdlg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONTDLG_HXX_
#define _CONTDLG_HXX_

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX //autogen
#include <bf_sfx2/childwin.hxx>
#endif
namespace binfilter {

/*************************************************************************
|*
|* Ableitung vom SfxChildWindow als "Behaelter" fuer Float
|*
\************************************************************************/

//STRIP001 class Graphic;

class SvxContourDlgChildWindow : public SfxChildWindow
{
 public:

	SvxContourDlgChildWindow( Window*, USHORT, SfxBindings*, SfxChildWinInfo* );

	SFX_DECL_CHILDWINDOW( SvxContourDlgChildWindow );

//STRIP001 	static void UpdateContourDlg( const Graphic& rGraphic, BOOL bGraphicLinked,
//STRIP001 								  const PolyPolygon* pPolyPoly = NULL,
//STRIP001 								  void* pEditingObj = NULL );
};

#ifndef _REDUCED_ContourDlg_HXX_
#define _REDUCED_CONTDLG_HXX_

//STRIP001 class SvxSuperContourDlg;

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 class SvxContourDlgItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SvxSuperContourDlg&	rDlg;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void		StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						SvxContourDlgItem( USHORT nId, SvxSuperContourDlg& rDlg, SfxBindings& rBindings );
//STRIP001 };

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 class SvxContourDlg : public SfxFloatingWindow
//STRIP001 {
//STRIP001 	SvxSuperContourDlg*	pSuperClass;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	void				SetSuperClass( SvxSuperContourDlg& rSuperClass ) { pSuperClass = &rSuperClass; }
//STRIP001 
//STRIP001 #endif // __PRIVATE
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						SvxContourDlg( SfxBindings *pBindings, SfxChildWindow *pCW,
//STRIP001 									   Window* pParent, const ResId& rResId );
//STRIP001 						~SvxContourDlg();
//STRIP001 
//STRIP001 	void				SetExecState( BOOL bEnable );
//STRIP001 
//STRIP001 	void				SetGraphic( const Graphic& rGraphic );
//STRIP001 	void				SetGraphicLinked( BOOL bLinked );
//STRIP001 	const Graphic&		GetGraphic() const;
//STRIP001 	BOOL				IsGraphicChanged() const;
//STRIP001 
//STRIP001 	void				SetPolyPolygon( const PolyPolygon& rPolyPoly );
//STRIP001 	PolyPolygon			GetPolyPolygon();
//STRIP001 
//STRIP001 	void				SetEditingObject( void* pObj );
//STRIP001 	const void*			GetEditingObject() const;
//STRIP001 
//STRIP001 	void				Update( const Graphic& rGraphic, BOOL bGraphicLinked,
//STRIP001 								const PolyPolygon* pPolyPoly = NULL, void* pEditingObj = NULL );
//STRIP001 
//STRIP001 	static PolyPolygon	CreateAutoContour( 	const Graphic& rGraphic,
//STRIP001 											const Rectangle* pRect = NULL,
//STRIP001 											const ULONG nFlags = 0L );
//STRIP001 	static void			ScaleContour( PolyPolygon& rContour, const Graphic& rGraphic,
//STRIP001 									  const MapUnit eUnit, const Size& rDisplaySize );
//STRIP001 };

/*************************************************************************
|*
|* Defines
|*
\************************************************************************/

//STRIP001 #define SVXCONTOURDLG() ( (SvxContourDlg*) ( SfxViewFrame::Current()->GetChildWindow( 	\
//STRIP001 						  SvxContourDlgChildWindow::GetChildWindowId() )-> 	\
//STRIP001 						  GetWindow() ) )

#endif // _REDUCED_CONTDLG_HXX_
}//end of namespace binfilter
#endif // _CONTDLG_HXX_

