/*************************************************************************
 *
 *  $RCSfile: postdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:26:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_POSTDLG_HXX
#define _SVX_POSTDLG_HXX

// include ---------------------------------------------------------------

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _IMAGEBTN_HXX //autogen
#include <vcl/imagebtn.hxx>
#endif
#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
// auto strip #ifndef _BASEDLGS_HXX //autogen
// auto strip #include <bf_sfx2/basedlgs.hxx>
// auto strip #endif

// auto strip #ifndef _SVEDIT_HXX //autogen
// auto strip #include <svtools/svmedit.hxx>
// auto strip #endif
namespace binfilter {

// class SvxPostItDialog -------------------------------------------------
/*
	{k:\svx\prototyp\dialog\memo.bmp}

	[Beschreibung]
	In diesem Dialog kann eine Notiz erstellt oder bearbeitet werden. Wenn die
	Applikation eine Liste von Notizen haelt, kann mit Hilfe von Links, ueber
	diese Liste iteriert werden.

	[Items]
	<SvxPostitAuthorItem><SID_ATTR_POSTIT_AUTHOR>
	<SvxPostitDateItem><SID_ATTR_POSTIT_DATE>
	<SvxPostitTextItem><SID_ATTR_POSTIT_TEXT>
*/

//STRIP001 class SvxPostItDialog : public SfxModalDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxPostItDialog( Window* pParent, const SfxItemSet& rCoreSet,
//STRIP001 					 BOOL bPrevNext = FALSE, BOOL bRedline = FALSE );
//STRIP001 	~SvxPostItDialog();
//STRIP001 
//STRIP001 	static USHORT*      GetRanges();
//STRIP001 	const SfxItemSet*   GetOutputItemSet() const { return pOutSet; }
//STRIP001 
//STRIP001 	Link                GetPrevHdl() const { return aPrevHdlLink; }
//STRIP001 	void                SetPrevHdl( const Link& rLink )
//STRIP001 							{ aPrevHdlLink = rLink; }
//STRIP001 	Link                GetNextHdl() const { return aNextHdlLink; }
//STRIP001 	void                SetNextHdl( const Link& rLink )
//STRIP001 							{ aNextHdlLink = rLink; }
//STRIP001 
//STRIP001 	void				EnableTravel(BOOL bNext, BOOL bPrev);
//STRIP001 	inline String		GetNote() { return aEditED.GetText(); }
//STRIP001 	inline void			SetNote(const String& rTxt) { aEditED.SetText(rTxt); }
//STRIP001 
//STRIP001 	void				ShowLastAuthor(const String& rAuthor, const String& rDate);
//STRIP001 	inline void			DontChangeAuthor()	{ aAuthorBtn.Enable(FALSE); }
//STRIP001 	inline void			HideAuthor()		{ aAuthorBtn.Hide(); }
//STRIP001 	inline void			SetReadonlyPostIt(BOOL bDisable)
//STRIP001 							{
//STRIP001 								aOKBtn.Enable( !bDisable );
//STRIP001 								aEditED.SetReadOnly( bDisable );
//STRIP001 								aAuthorBtn.Enable( !bDisable );
//STRIP001 							}
//STRIP001 	inline BOOL 		IsOkEnabled() const { return aOKBtn.IsEnabled(); }
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine           aPostItFL;
//STRIP001     FixedText           aLastEditLabelFT;
//STRIP001 	FixedInfo           aLastEditFT;
//STRIP001 
//STRIP001 	FixedText           aEditFT;
//STRIP001 	MultiLineEdit       aEditED;
//STRIP001 
//STRIP001     FixedText           aAuthorFT;
//STRIP001     PushButton          aAuthorBtn;
//STRIP001 
//STRIP001     OKButton            aOKBtn;
//STRIP001 	CancelButton        aCancelBtn;
//STRIP001 	HelpButton          aHelpBtn;
//STRIP001 
//STRIP001     ImageButton         aPrevBtn;
//STRIP001 	ImageButton         aNextBtn;
//STRIP001 
//STRIP001 	const SfxItemSet&   rSet;
//STRIP001 	SfxItemSet*         pOutSet;
//STRIP001 
//STRIP001 	Link                aPrevHdlLink;
//STRIP001 	Link                aNextHdlLink;
//STRIP001 
//STRIP001 #ifdef _SVX_POSTDLG_CXX
//STRIP001 	DECL_LINK( Stamp, Button* );
//STRIP001 	DECL_LINK( OKHdl, Button* );
//STRIP001 	DECL_LINK( PrevHdl, Button* );
//STRIP001 	DECL_LINK( NextHdl, Button* );
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif

