/*************************************************************************
 *
 *  $RCSfile: transfrm.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:32:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_TRANSFRM_HXX
#define _SVX_TRANSFRM_HXX

// include ---------------------------------------------------------------

// auto strip #include <bf_svx/dlgctrl.hxx>

// auto strip #ifndef _FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
namespace binfilter {
class SdrView;

/*************************************************************************
|*
|* Transform-Tab-Dialog
|*
\************************************************************************/

/** put this into the nAnchorTypes parameter of the SvxTransformTabDialog c'tor
	to disable the size controls */
//STRIP001 const USHORT SVX_OBJ_NORESIZE = 0x0100;
//STRIP001 
//STRIP001 /** put this into the nAnchorTypes parameter of the SvxTransformTabDialog c'tor
//STRIP001 	to disable the protect controls */
//STRIP001 const USHORT SVX_OBJ_NOPROTECT = 0x0200;
//STRIP001 
//STRIP001 class SvxTransformTabDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	const SdrView*		pView;
//STRIP001 
//STRIP001 	USHORT				nAnchorCtrls;
//STRIP001 
//STRIP001 	virtual void		PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 			SvxTransformTabDialog( Window* pParent, const SfxItemSet* pAttr,
//STRIP001 							const SdrView* pView,
//STRIP001 							USHORT nAnchorTypes = 0);
//STRIP001 			~SvxTransformTabDialog();
//STRIP001 };
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* position and size tab page
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 class SvxPositionSizeTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	// position
//STRIP001 	FixedLine			maFlPosition;
//STRIP001 	FixedText			maFtPosX;
//STRIP001 	MetricField			maMtrPosX;
//STRIP001 	FixedText			maFtPosY;
//STRIP001 	MetricField			maMtrPosY;
//STRIP001 	FixedText			maFtPosReference;
//STRIP001 	SvxRectCtl			maCtlPos;
//STRIP001 
//STRIP001 	// size
//STRIP001 	FixedLine			maFlSize;
//STRIP001 	FixedText			maFtWidth;
//STRIP001 	MetricField			maMtrWidth;
//STRIP001 	FixedText			maFtHeight;
//STRIP001 	MetricField			maMtrHeight;
//STRIP001 	CheckBox   			maCbxScale;
//STRIP001 	FixedText			maFtSizeReference;
//STRIP001 	SvxRectCtl			maCtlSize;
//STRIP001 
//STRIP001 	// anchor
//STRIP001 	FixedLine			maAnchorBox;
//STRIP001 	FixedText			maFtAnchor;
//STRIP001 	ListBox				maDdLbAnchor;
//STRIP001 
//STRIP001 	// protect
//STRIP001 	FixedLine			maFlProtect;
//STRIP001 	TriStateBox			maTsbPosProtect;
//STRIP001 	TriStateBox			maTsbSizeProtect;
//STRIP001 
//STRIP001 	// adjust
//STRIP001 	FixedLine			maFlAdjust;
//STRIP001 	TriStateBox         maTsbAutoGrowWidth;
//STRIP001 	TriStateBox         maTsbAutoGrowHeight;
//STRIP001 
//STRIP001 	// ???
//STRIP001 	FixedText 			maFtOrient;
//STRIP001 	ListBox				maDdLbOrient;
//STRIP001 	
//STRIP001 	FixedLine			maFlDivider;
//STRIP001 
//STRIP001 private:
//STRIP001 	const SfxItemSet&	mrOutAttrs;
//STRIP001 
//STRIP001 	const SdrView*		mpView;
//STRIP001 	Rectangle			maRect;
//STRIP001 	Rectangle			maWorkArea;
//STRIP001 
//STRIP001 	Point				maAnchorPos;
//STRIP001 	SfxMapUnit			mePoolUnit;
//STRIP001 	FieldUnit			meDlgUnit;
//STRIP001 	MapUnit				meMapUnit;
//STRIP001     TriState			mnProtectSizeState;
//STRIP001 	bool				mbPageDisabled;
//STRIP001 	bool				mbProtectDisabled;
//STRIP001 	bool				mbSizeDisabled;
//STRIP001 
//STRIP001 	// frome size
//STRIP001 	UINT32				mlOldWidth;
//STRIP001 	UINT32				mlOldHeight;
//STRIP001 	RECT_POINT			meRP;
//STRIP001 
//STRIP001 	//------------------------------------
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( ChangePosProtectHdl, void * );
//STRIP001 	DECL_LINK( ChangeSizeProtectHdl, void * );
//STRIP001 	DECL_LINK( ChangePosXHdl, void * );
//STRIP001 	DECL_LINK( ChangePosYHdl, void * );
//STRIP001 	DECL_LINK( SetAnchorHdl, ListBox * );
//STRIP001 	DECL_LINK( SetOrientHdl, ListBox * );
//STRIP001 
//STRIP001 	void SetMinMaxPosition();
//STRIP001 	void GetTopLeftPosition( INT32& rX, INT32& rY, const Rectangle& rRect );
//STRIP001 #endif
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( ChangeWidthHdl, void * );
//STRIP001 	DECL_LINK( ChangeHeightHdl, void * );
//STRIP001 	DECL_LINK( ClickSizeProtectHdl, void * );
//STRIP001 	DECL_LINK( ClickAutoHdl, void * );
//STRIP001 
//STRIP001     void 		DisableSizeControls();
//STRIP001 	void		SetMaxSize( Rectangle aRect );
//STRIP001 	Rectangle	GetRect();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxPositionSizeTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	static SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	static USHORT*	   GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void 		 Construct();
//STRIP001 	void		 SetView( const SdrView* pSdrView ) { mpView = pSdrView; }
//STRIP001 
//STRIP001 	void		 ShowAnchorCtrls(USHORT nAnchorCtrls); // Writer-spezifische Controls anzeigen
//STRIP001 	virtual void FillUserData();
//STRIP001 
//STRIP001 	void		DisableResize();
//STRIP001 	void		DisableProtect();
//STRIP001 };
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Drehwinkel-Tab-Page
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 class SvxAngleTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine			aFlPosition;
//STRIP001 	FixedText			aFtPosX;
//STRIP001 	MetricField			aMtrPosX;
//STRIP001 	FixedText			aFtPosY;
//STRIP001 	MetricField			aMtrPosY;
//STRIP001 	FixedText			aFtPosPresets;
//STRIP001 	SvxRectCtl			aCtlRect;
//STRIP001 
//STRIP001 	FixedLine			aFlAngle;
//STRIP001 	FixedText			aFtAngle;
//STRIP001 	MetricField			aMtrAngle;
//STRIP001 	FixedText			aFtAnglePresets;
//STRIP001 	SvxRectCtl			aCtlAngle;
//STRIP001 
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 
//STRIP001 	const SdrView*		pView;
//STRIP001 	Rectangle			aRect;
//STRIP001 
//STRIP001 	Point				aAnchorPos;
//STRIP001 	SfxMapUnit			ePoolUnit;
//STRIP001 	FieldUnit			eDlgUnit;
//STRIP001 	MapUnit				eMapUnit;
//STRIP001 	//------------------------------------
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( ModifiedHdl, void * );
//STRIP001 #endif
//STRIP001 public:
//STRIP001 		 SvxAngleTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	static SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	static USHORT*	   GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void 		 Construct();
//STRIP001 	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
//STRIP001 };
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Schraegstellen/Eckenradius-Tab-Page
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 class SvxSlantTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine			aFlRadius;
//STRIP001 	FixedText			aFtRadius;
//STRIP001 	MetricField			aMtrRadius;
//STRIP001 	//TriStateBox			aTsbVertical;
//STRIP001 	FixedLine			aFlAngle;
//STRIP001 	FixedText			aFtAngle;
//STRIP001 	MetricField			aMtrAngle;
//STRIP001 	//SvxRectCtl			aCtlAngle;
//STRIP001 
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 
//STRIP001 	const SdrView*		pView;
//STRIP001 	Rectangle			aRect;
//STRIP001 
//STRIP001 	SfxMapUnit			ePoolUnit;
//STRIP001 	FieldUnit			eDlgUnit;
//STRIP001 	MapUnit				eMapUnit;
//STRIP001 	//------------------------------------
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( ModifiedHdl, void * );
//STRIP001 #endif
//STRIP001 public:
//STRIP001 		 SvxSlantTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	static SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	static USHORT*	   GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void 		 Construct();
//STRIP001 	void		 SetView( const SdrView* pSdrView ) { pView = pSdrView; }
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_TRANSFRM_HXX

