/*************************************************************************
 *
 *  $RCSfile: offmgr_osplcfg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2004/05/05 16:39:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SFX_HRC
#include <bf_sfx2/sfx.hrc>
#endif
#ifndef _SFXEVENT_HXX //autogen
#include <bf_sfx2/event.hxx>
#endif
#ifndef _SFX_SFXUNO_HXX
#include <bf_sfx2/sfxuno.hxx>
#endif
#include <comphelper/processfactory.hxx>

#ifndef _UNO_LINGU_HXX
#include <bf_svx/unolingu.hxx>
#endif
#ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
#include <com/sun/star/frame/XStorable.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUSTIC2_XDICTIONARYLIST_HPP_
#include <com/sun/star/linguistic2/XDictionaryList.hpp>
#endif

#ifndef _OFF_SPLNOTE_HXX
#include "splnote.hxx"
#endif
#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {
using namespace rtl;
using namespace comphelper;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::linguistic2;

///////////////////////////////////////////////////////////////////////////

/*N*/SpellNotifier::SpellNotifier( SfxBroadcaster& rBC )
/*N*/{
/*?*/DBG_BF_ASSERT(0, "STRIP"); //STRIP001 	StartListening( rBC );
/*N*/}
 
/*N*/SpellNotifier::~SpellNotifier()
/*N*/{
/*?*/	DBG_BF_ASSERT(0, "STRIP"); EndListeningAll();
/*N*/}
 
//STRIP001 void SpellNotifier::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
//STRIP001 {
//STRIP001 	SfxEventHint* pEventHint = PTR_CAST(SfxEventHint,&rHint);
//STRIP001 	if( pEventHint &&
//STRIP001 		( SFX_EVENT_SAVEDOC == pEventHint->GetEventId() ||
//STRIP001 		  SFX_EVENT_SAVEASDOC == pEventHint->GetEventId() ) )
//STRIP001 	{
//STRIP001  		Reference< XMultiServiceFactory >  xMgr( ::legacy_binfilters::getLegacyProcessServiceFactory() );
//STRIP001 		Reference< XDictionaryList >  xDicList(  SvxGetDictionaryList(), UNO_QUERY );
//STRIP001 
//STRIP001 		if (xDicList.is())
//STRIP001 		{
//STRIP001 			Sequence< Reference< XDictionary >  >	aDicts =
//STRIP001 					xDicList->getDictionaries();
//STRIP001 			const Reference< XDictionary >  *pDic = aDicts.getConstArray();
//STRIP001 			sal_Int32	nCount  = aDicts.getLength();
//STRIP001 
//STRIP001 			for (sal_Int32 i = 0;  i < nCount;  i++)
//STRIP001 			{
//STRIP001 				Reference< XStorable >  xStor( pDic[i], UNO_QUERY );
//STRIP001 				if (xStor.is())
//STRIP001 				{
//STRIP001 					if (xStor->hasLocation())
//STRIP001 						xStor->store();
//STRIP001 					else
//STRIP001 					{
//STRIP001 						DBG_ERROR("dictionary has no location to save it");
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

///////////////////////////////////////////////////////////////////////////


}
