/*************************************************************************
 *
 *  $RCSfile: sc_refundo.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:15:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// -----------------------------------------------------------------------

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

#include "refundo.hxx"
// auto strip #include "undobase.hxx"
// auto strip #include "document.hxx"
// auto strip #include "dbcolect.hxx"
// auto strip #include "rangenam.hxx"
// auto strip #include "pivot.hxx"
// auto strip #include "chartarr.hxx"
// auto strip #include "stlpool.hxx"
// auto strip #include "conditio.hxx"
// auto strip #include "detdata.hxx"
// auto strip #include "prnsave.hxx"
// auto strip #include "chartlis.hxx"
// auto strip #include "dpobject.hxx"
// auto strip #include "areasave.hxx"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 ScRefUndoData::ScRefUndoData( const ScDocument* pDoc )
//STRIP001 {
//STRIP001 	ScDBCollection* pOldDBColl = pDoc->GetDBCollection();
//STRIP001 	pDBCollection = pOldDBColl ? new ScDBCollection(*pOldDBColl) : NULL;
//STRIP001 
//STRIP001 	ScRangeName* pOldRanges = ((ScDocument*)pDoc)->GetRangeName();			//! const
//STRIP001 	pRangeName = pOldRanges ? new ScRangeName(*pOldRanges) : NULL;
//STRIP001 
//STRIP001 	pPrintRanges = pDoc->CreatePrintRangeSaver();		// neu erzeugt
//STRIP001 
//STRIP001 	ScPivotCollection* pOldPivot = pDoc->GetPivotCollection();
//STRIP001 	pPivotCollection = pOldPivot ? new ScPivotCollection(*pOldPivot) : NULL;
//STRIP001 	//!	bei Pivot nur Bereiche merken ???
//STRIP001 
//STRIP001 	ScDPCollection* pOldDP = ((ScDocument*)pDoc)->GetDPCollection();		//! const
//STRIP001 	pDPCollection = pOldDP ? new ScDPCollection(*pOldDP) : NULL;
//STRIP001 
//STRIP001 	ScConditionalFormatList* pOldCond = pDoc->GetCondFormList();
//STRIP001 	pCondFormList = pOldCond ? new ScConditionalFormatList(*pOldCond) : NULL;
//STRIP001 
//STRIP001 	ScDetOpList* pOldDetOp = pDoc->GetDetOpList();
//STRIP001 	pDetOpList = pOldDetOp ? new ScDetOpList(*pOldDetOp) : 0;
//STRIP001 
//STRIP001 	ScChartListenerCollection* pOldChartListenerCollection =
//STRIP001 		pDoc->GetChartListenerCollection();
//STRIP001 	pChartListenerCollection = pOldChartListenerCollection ?
//STRIP001 		new ScChartListenerCollection( *pOldChartListenerCollection ) : NULL;
//STRIP001 
//STRIP001 	pAreaLinks = ScAreaLinkSaveCollection::CreateFromDoc(pDoc);		// returns NULL if empty
//STRIP001 }

//STRIP001 ScRefUndoData::~ScRefUndoData()
//STRIP001 {
//STRIP001 	delete pDBCollection;
//STRIP001 	delete pRangeName;
//STRIP001 	delete pPrintRanges;
//STRIP001 	delete pPivotCollection;
//STRIP001 	delete pDPCollection;
//STRIP001 	delete pCondFormList;
//STRIP001 	delete pDetOpList;
//STRIP001 	delete pChartListenerCollection;
//STRIP001 	delete pAreaLinks;
//STRIP001 }

//STRIP001 void ScRefUndoData::DeleteUnchanged( const ScDocument* pDoc )
//STRIP001 {
//STRIP001 	if (pDBCollection)
//STRIP001 	{
//STRIP001 		ScDBCollection* pNewDBColl = pDoc->GetDBCollection();
//STRIP001 		if ( pNewDBColl && *pDBCollection == *pNewDBColl )
//STRIP001 			DELETEZ(pDBCollection);
//STRIP001 	}
//STRIP001 	if (pRangeName)
//STRIP001 	{
//STRIP001 		ScRangeName* pNewRanges = ((ScDocument*)pDoc)->GetRangeName();		//! const
//STRIP001 		if ( pNewRanges && *pRangeName == *pNewRanges )
//STRIP001 			DELETEZ(pRangeName);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pPrintRanges)
//STRIP001 	{
//STRIP001 		ScPrintRangeSaver* pNewRanges = pDoc->CreatePrintRangeSaver();
//STRIP001 		if ( pNewRanges && *pPrintRanges == *pNewRanges )
//STRIP001 			DELETEZ(pPrintRanges);
//STRIP001 		delete pNewRanges;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pPivotCollection)
//STRIP001 	{
//STRIP001 		ScPivotCollection* pNewPivot = pDoc->GetPivotCollection();
//STRIP001 		if ( pNewPivot && *pPivotCollection == *pNewPivot )
//STRIP001 			DELETEZ(pPivotCollection);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pDPCollection)
//STRIP001 	{
//STRIP001 		ScDPCollection* pNewDP = ((ScDocument*)pDoc)->GetDPCollection();	//! const
//STRIP001 		if ( pNewDP && pDPCollection->RefsEqual(*pNewDP) )
//STRIP001 			DELETEZ(pDPCollection);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pCondFormList)
//STRIP001 	{
//STRIP001 		ScConditionalFormatList* pNewCond = pDoc->GetCondFormList();
//STRIP001 		if ( pNewCond && *pCondFormList == *pNewCond )
//STRIP001 			DELETEZ(pCondFormList);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pDetOpList)
//STRIP001 	{
//STRIP001 		ScDetOpList* pNewDetOp = pDoc->GetDetOpList();
//STRIP001 		if ( pNewDetOp && *pDetOpList == *pNewDetOp )
//STRIP001 			DELETEZ(pDetOpList);
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pChartListenerCollection )
//STRIP001 	{
//STRIP001 		ScChartListenerCollection* pNewChartListenerCollection =
//STRIP001 			pDoc->GetChartListenerCollection();
//STRIP001 		if ( pNewChartListenerCollection &&
//STRIP001 				*pChartListenerCollection == *pNewChartListenerCollection )
//STRIP001 			DELETEZ( pChartListenerCollection );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pAreaLinks)
//STRIP001 	{
//STRIP001 		if ( pAreaLinks->IsEqual( pDoc ) )
//STRIP001 			DELETEZ(pAreaLinks);
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScRefUndoData::DoUndo( ScDocument* pDoc, BOOL bUndoRefFirst )
//STRIP001 {
//STRIP001 	if (pDBCollection)
//STRIP001 		pDoc->SetDBCollection( new ScDBCollection(*pDBCollection) );
//STRIP001 	if (pRangeName)
//STRIP001 		pDoc->SetRangeName( new ScRangeName(*pRangeName) );
//STRIP001 
//STRIP001 	if (pPrintRanges)
//STRIP001 		pDoc->RestorePrintRanges(*pPrintRanges);
//STRIP001 
//STRIP001 	if (pPivotCollection)
//STRIP001 		pDoc->SetPivotCollection( new ScPivotCollection(*pPivotCollection) );
//STRIP001 
//STRIP001 	if (pDPCollection)
//STRIP001 	{
//STRIP001 		ScDPCollection* pDocDP = pDoc->GetDPCollection();
//STRIP001 		if (pDocDP)
//STRIP001 			pDPCollection->WriteRefsTo( *pDocDP );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pCondFormList)
//STRIP001 		pDoc->SetCondFormList( new ScConditionalFormatList(*pCondFormList) );
//STRIP001 	if (pDetOpList)
//STRIP001 		pDoc->SetDetOpList( new ScDetOpList(*pDetOpList) );
//STRIP001 
//STRIP001 	// #65055# bUndoRefFirst ist bSetChartRangeLists
//STRIP001 	if ( pChartListenerCollection )
//STRIP001 		pDoc->SetChartListenerCollection( new ScChartListenerCollection(
//STRIP001 			*pChartListenerCollection ), bUndoRefFirst );
//STRIP001 
//STRIP001 	if (pDBCollection || pRangeName)
//STRIP001 	{
//STRIP001 		BOOL bOldAutoCalc = pDoc->GetAutoCalc();
//STRIP001 		pDoc->SetAutoCalc( FALSE );	// Mehrfachberechnungen vermeiden
//STRIP001 		pDoc->CompileAll();
//STRIP001 		pDoc->SetDirty();
//STRIP001 		pDoc->SetAutoCalc( bOldAutoCalc );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pAreaLinks)
//STRIP001 		pAreaLinks->Restore( pDoc );
//STRIP001 }




}
