/*************************************************************************
 *
 *  $RCSfile: sc_undostyl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:17:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <svtools/itemset.hxx>
// auto strip #include <vcl/virdev.hxx>

// auto strip #include "undostyl.hxx"
// auto strip #include "docsh.hxx"
// auto strip #include "stlpool.hxx"
// auto strip #include "printfun.hxx"
#include "scmod.hxx"
// auto strip #include "inputhdl.hxx"
#include "globstr.hrc"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 TYPEINIT1(ScUndoModifyStyle, ScSimpleUndo);
//STRIP001 TYPEINIT1(ScUndoApplyPageStyle, ScSimpleUndo);

// -----------------------------------------------------------------------
//
//		modify style (cell or page style)
//

//STRIP001 ScStyleSaveData::ScStyleSaveData() :
//STRIP001 	pItems( NULL )
//STRIP001 {
//STRIP001 }

//STRIP001 ScStyleSaveData::ScStyleSaveData( const ScStyleSaveData& rOther ) :
//STRIP001 	aName( rOther.aName ),
//STRIP001 	aParent( rOther.aParent )
//STRIP001 {
//STRIP001 	if (rOther.pItems)
//STRIP001 		pItems = new SfxItemSet( *rOther.pItems );
//STRIP001 	else
//STRIP001 		pItems = NULL;
//STRIP001 }

//STRIP001 ScStyleSaveData::~ScStyleSaveData()
//STRIP001 {
//STRIP001 	delete pItems;
//STRIP001 }

//STRIP001 ScStyleSaveData& ScStyleSaveData::operator=( const ScStyleSaveData& rOther )
//STRIP001 {
//STRIP001 	aName   = rOther.aName;
//STRIP001 	aParent = rOther.aParent;
//STRIP001 
//STRIP001 	delete pItems;
//STRIP001 	if (rOther.pItems)
//STRIP001 		pItems = new SfxItemSet( *rOther.pItems );
//STRIP001 	else
//STRIP001 		pItems = NULL;
//STRIP001 
//STRIP001 	return *this;
//STRIP001 }

//STRIP001 void ScStyleSaveData::InitFromStyle( const SfxStyleSheetBase* pSource )
//STRIP001 {
//STRIP001 	if ( pSource )
//STRIP001 	{
//STRIP001 		aName   = pSource->GetName();
//STRIP001 		aParent = pSource->GetParent();
//STRIP001 		delete pItems;
//STRIP001 		pItems = new SfxItemSet( ((SfxStyleSheetBase*)pSource)->GetItemSet() );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		*this = ScStyleSaveData();		// empty
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 ScUndoModifyStyle::ScUndoModifyStyle( ScDocShell* pDocSh, SfxStyleFamily eFam,
//STRIP001 					const ScStyleSaveData& rOld, const ScStyleSaveData& rNew ) :
//STRIP001 	ScSimpleUndo( pDocSh ),
//STRIP001 	eFamily( eFam ),
//STRIP001 	aOldData( rOld ),
//STRIP001 	aNewData( rNew )
//STRIP001 {
//STRIP001 }

//STRIP001 ScUndoModifyStyle::~ScUndoModifyStyle()
//STRIP001 {
//STRIP001 }

//STRIP001 String ScUndoModifyStyle::GetComment() const
//STRIP001 {
//STRIP001 	USHORT nId = (eFamily == SFX_STYLE_FAMILY_PARA) ?
//STRIP001 								STR_UNDO_EDITCELLSTYLE :
//STRIP001 								STR_UNDO_EDITPAGESTYLE;
//STRIP001 	return ScGlobal::GetRscString( nId );
//STRIP001 }

//STRIP001 void lcl_DocStyleChanged( ScDocument* pDoc, SfxStyleSheetBase* pStyle, BOOL bRemoved )
//STRIP001 {
//STRIP001 	//!	move to document or docshell
//STRIP001 
//STRIP001 	VirtualDevice aVDev;
//STRIP001 	Point aLogic = aVDev.LogicToPixel( Point(1000,1000), MAP_TWIP );
//STRIP001 	double nPPTX = aLogic.X() / 1000.0;
//STRIP001 	double nPPTY = aLogic.Y() / 1000.0;
//STRIP001 	Fraction aZoom(1,1);
//STRIP001 	pDoc->StyleSheetChanged( pStyle, bRemoved, &aVDev, nPPTX, nPPTY, aZoom, aZoom );
//STRIP001 
//STRIP001 	ScInputHandler* pHdl = SC_MOD()->GetInputHdl();
//STRIP001 	if (pHdl)
//STRIP001 		pHdl->ForgetLastPattern();
//STRIP001 }

// static
//STRIP001 void ScUndoModifyStyle::DoChange( ScDocShell* pDocSh, const String& rName,
//STRIP001 									SfxStyleFamily eStyleFamily, const ScStyleSaveData& rData )
//STRIP001 {
//STRIP001 	ScDocument* pDoc = pDocSh->GetDocument();
//STRIP001 	ScStyleSheetPool* pStlPool = pDoc->GetStyleSheetPool();
//STRIP001 	String aNewName = rData.GetName();
//STRIP001 	BOOL bDelete = ( aNewName.Len() == 0 );			// no new name -> delete style
//STRIP001 	BOOL bNew = ( rName.Len() == 0 && !bDelete );	// creating new style
//STRIP001 
//STRIP001 	SfxStyleSheetBase* pStyle = NULL;
//STRIP001 	if ( rName.Len() )
//STRIP001 	{
//STRIP001 		// find old style to modify
//STRIP001 		pStyle = pStlPool->Find( rName, eStyleFamily );
//STRIP001 		DBG_ASSERT( pStyle, "style not found" );
//STRIP001 
//STRIP001 		if ( pStyle && !bDelete )
//STRIP001 		{
//STRIP001 			// set new name
//STRIP001 			pStyle->SetName( aNewName );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( !bDelete )
//STRIP001 	{
//STRIP001 		// create style (with new name)
//STRIP001 		pStyle = &pStlPool->Make( aNewName, eStyleFamily, SFXSTYLEBIT_USERDEF );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pStyle )
//STRIP001 	{
//STRIP001 		if ( bDelete )
//STRIP001 		{
//STRIP001 			if ( eStyleFamily == SFX_STYLE_FAMILY_PARA )
//STRIP001 				lcl_DocStyleChanged( pDoc, pStyle, TRUE );		// TRUE: remove usage of style
//STRIP001 			else
//STRIP001 				pDoc->RemovePageStyleInUse( rName );
//STRIP001 
//STRIP001 			// delete style
//STRIP001 			pStlPool->Erase( pStyle );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// modify style
//STRIP001 
//STRIP001 			String aNewParent = rData.GetParent();
//STRIP001 			if ( aNewParent != pStyle->GetParent() )
//STRIP001 				pStyle->SetParent( aNewParent );
//STRIP001 
//STRIP001 			SfxItemSet& rStyleSet = pStyle->GetItemSet();
//STRIP001 			const SfxItemSet* pNewSet = rData.GetItems();
//STRIP001 			DBG_ASSERT( pNewSet, "no ItemSet for style" );
//STRIP001 			if (pNewSet)
//STRIP001 				rStyleSet.Set( *pNewSet, FALSE );
//STRIP001 
//STRIP001 			if ( eStyleFamily == SFX_STYLE_FAMILY_PARA )
//STRIP001 			{
//STRIP001 				lcl_DocStyleChanged( pDoc, pStyle, FALSE );		// cell styles: row heights
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// page styles
//STRIP001 
//STRIP001 				if ( bNew && aNewName != rName )
//STRIP001 					pDoc->RenamePageStyleInUse( rName, aNewName );
//STRIP001 
//STRIP001 				if (pNewSet)
//STRIP001 					pDoc->ModifyStyleSheet( *pStyle, *pNewSet );
//STRIP001 
//STRIP001 				pDocSh->PageStyleModified( aNewName, TRUE );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	pDocSh->PostPaint( 0,0,0, MAXCOL,MAXROW,MAXTAB, PAINT_GRID|PAINT_LEFT );
//STRIP001 
//STRIP001 	//!	undo/redo document modifications for deleted styles
//STRIP001 	//!	undo/redo modifications of number formatter
//STRIP001 }

//STRIP001 void ScUndoModifyStyle::Undo()
//STRIP001 {
//STRIP001 	BeginUndo();
//STRIP001 	DoChange( pDocShell, aNewData.GetName(), eFamily, aOldData );
//STRIP001 	EndUndo();
//STRIP001 }

//STRIP001 void ScUndoModifyStyle::Redo()
//STRIP001 {
//STRIP001 	BeginRedo();
//STRIP001 	DoChange( pDocShell, aOldData.GetName(), eFamily, aNewData );
//STRIP001 	EndRedo();
//STRIP001 }

//STRIP001 void ScUndoModifyStyle::Repeat(SfxRepeatTarget& rTarget)
//STRIP001 {
//STRIP001 }

//STRIP001 BOOL ScUndoModifyStyle::CanRepeat(SfxRepeatTarget& rTarget) const
//STRIP001 {
//STRIP001 	return FALSE;		// no repeat possible
//STRIP001 }

// -----------------------------------------------------------------------
//
//		apply page style
//

//STRIP001 ScUndoApplyPageStyle::ScUndoApplyPageStyle( ScDocShell* pDocSh, USHORT nT,
//STRIP001 					const String& rOld, const String& rNew ) :
//STRIP001 	ScSimpleUndo( pDocSh ),
//STRIP001 	nTab( nT ),
//STRIP001 	aOldStyle( rOld ),
//STRIP001 	aNewStyle( rNew )
//STRIP001 {
//STRIP001 }

//STRIP001 ScUndoApplyPageStyle::~ScUndoApplyPageStyle()
//STRIP001 {
//STRIP001 }

//STRIP001 String ScUndoApplyPageStyle::GetComment() const
//STRIP001 {
//STRIP001 	return ScGlobal::GetRscString( STR_UNDO_APPLYPAGESTYLE );
//STRIP001 }

//STRIP001 void ScUndoApplyPageStyle::Undo()
//STRIP001 {
//STRIP001 	BeginUndo();
//STRIP001 
//STRIP001 	pDocShell->GetDocument()->SetPageStyle( nTab, aOldStyle );
//STRIP001 
//STRIP001 	ScPrintFunc( pDocShell, pDocShell->GetPrinter(), nTab ).UpdatePages();
//STRIP001 	EndUndo();
//STRIP001 }

//STRIP001 void ScUndoApplyPageStyle::Redo()
//STRIP001 {
//STRIP001 	BeginRedo();
//STRIP001 
//STRIP001 	pDocShell->GetDocument()->SetPageStyle( nTab, aNewStyle );
//STRIP001 
//STRIP001 	ScPrintFunc( pDocShell, pDocShell->GetPrinter(), nTab ).UpdatePages();
//STRIP001 	EndRedo();
//STRIP001 }

//STRIP001 void ScUndoApplyPageStyle::Repeat(SfxRepeatTarget& rTarget)
//STRIP001 {
//STRIP001 	//!	set same page style to current tab
//STRIP001 }

//STRIP001 BOOL ScUndoApplyPageStyle::CanRepeat(SfxRepeatTarget& rTarget) const
//STRIP001 {
//STRIP001 	return FALSE;
//STRIP001 }


}
