/*************************************************************************
 *
 *  $RCSfile: sc_cellsh2.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:26:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

#define _BIGINT_HXX
//#define _BASEDLGS_HXX ***
#define _CACHESTR_HXX
//#define _CLIP_HXX
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _DLGCFG_HXX
#define _DYNARR_HXX
#define _EXTATTR_HXX
//#define _FILTER_HXX
#define _FONTDLG_HXX
#define _MACRODLG_HXX
#define _MODALDLG_HXX
#define _MOREBUTTON_HXX
#define _OUTLINER_HXX
#define _PASSWD_HXX
//#define _PRNDLG_HXX
#define _POLY_HXX
#define _PRVWIN_HXX
#define _QUEUE_HXX
//#define _RULER_HXX
#define _SCRWIN_HXX
#define _SOUND_HXX
#define _STACK_HXX
//#define _STATUS_HXX ***
#define _STDMENU_HXX
#define _TABBAR_HXX
//#define _TREELIST_HXX
#define _SFXBASIC_HXX
#define _SFX_DOCFILE_HXX
//#define _SFX_DOCFILT_HXX
#define _SFX_DOCINF_HXX
#define _SFX_DOCSH_HXX
#define _SFX_TEMPLDLG_HXX
#define _SFXSTBMGR_HXX
#define _SFXTBXMGR_HXX
#define _SFXIMGMGR_HXX
#define _SFXFILEDLG_HXX
#define _SFXIMGMGR_HXX
#define _SFXIPFRM_HXX
#define _SFX_MACRO_HXX
#define _SFXMNUITEM_HXX
#define _SFXMNUMGR_HXX
#define _SFXMULTISEL_HXX
#define _SFXSTBITEM_HXX
#define _SFXTBXCTRL_HXX

#define _SI_DLL_HXX
#define _SIDLL_HXX
#define _SI_NOITEMS
#define _SI_NOOTHERFORMS
#define _SI_NOSBXCONTROLS
#define _SINOSBXCONTROLS
#define _SI_NODRW		  //
#define _SI_NOCONTROL

#define _SVBOXITM_HXX
//#define _SVCONTNR_HXX
#define _SVDATTR_HXX
#define _SVDXOUT_HXX
#define _SVDEC_HXX
#define _SVDIO_HXX
#define _SVDLAYER_HXX
#define _SVDRAG_HXX
#define _SVINCVW_HXX
#define _SV_MULTISEL_HXX
#define _SVRTV_HXX
#define _SVTABBX_HXX


#define _SVX_DAILDLL_HXX
#define _SVX_HYPHEN_HXX
#define _SVX_IMPGRF_HXX
#define _SVX_OPTITEMS_HXX
#define _SVX_OPTGERL_HXX
#define _SVX_OPTSAVE_HXX
#define _SVX_OPTSPELL_HXX
#define _SVX_OPTPATH_HXX
#define _SVX_OPTLINGU_HXX
#define _SVX_RULER_HXX
#define _SVX_RULRITEM_HXX
#define _SVX_SPLWRAP_HXX
#define _SVX_SPLDLG_HXX
#define _SVX_THESDLG_HXX


// INCLUDE ---------------------------------------------------------------

#include "scitems.hxx"
// auto strip #include <bf_sfx2/app.hxx>
#include <bf_sfx2/request.hxx>
// auto strip #include <svtools/aeitem.hxx>
// auto strip #include <svtools/sbxcore.hxx>
#include <svtools/whiter.hxx>
// auto strip #include <svtools/zforlist.hxx>
#include <bf_offmgr/sbaitems.hxx>
#include <bf_offmgr/sbasltid.hrc>
// auto strip #include <vcl/msgbox.hxx>

// auto strip #include <com/sun/star/frame/FrameSearchFlag.hpp>
// auto strip #include <com/sun/star/sdbc/XResultSet.hpp>

#include "cellsh.hxx"
#include "tabvwsh.hxx"
#include "bf_sc.hrc"
#include "globstr.hrc"
// auto strip #include "global.hxx"
// auto strip #include "scmod.hxx"
#include "docsh.hxx"
// auto strip #include "document.hxx"
// auto strip #include "uiitems.hxx"
// auto strip #include "dbfunc.hxx"
// auto strip #include "dbdocfun.hxx"
// auto strip #include "lbseldlg.hxx"
// auto strip #include "sortdlg.hxx"
// auto strip #include "filtdlg.hxx"
#include "dbnamdlg.hxx"
// auto strip #include "subtdlg.hxx"
// auto strip #include "reffact.hxx"
// auto strip #include "pvlaydlg.hxx"
// auto strip #include "validat.hxx"
// auto strip #include "scresid.hxx"
// auto strip #include "validate.hxx"
// auto strip #include "pivot.hxx"
// auto strip #include "dpobject.hxx"
// auto strip #include "dapitype.hxx"
// auto strip #include "dapidata.hxx"
// auto strip #include "dpsdbtab.hxx"		// ScImportSourceDesc
// auto strip #include "dpshttab.hxx"		// ScSheetSourceDesc

using namespace ::com::sun::star;
namespace binfilter {

//#include "strindlg.hxx"		//! Test !!!!!

//static ScArea aPivotSource; 		//! wohin? (ueber den Dialog retten)


#define IS_AVAILABLE(WhichId,ppItem) \
    (pReqArgs->GetItemState((WhichId), TRUE, ppItem ) == SFX_ITEM_SET)

//------------------------------------------------------------------

//STRIP001 void ScCellShell::ExecuteDB( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScTabViewShell*	pTabViewShell  	= GetViewData()->GetViewShell();
//STRIP001 	USHORT nSlotId = rReq.GetSlot();
//STRIP001 	const SfxItemSet*	pReqArgs	= rReq.GetArgs();
//STRIP001 	SfxApplication*		pSfxApp		= SFX_APP();
//STRIP001 	ScModule*			pScMod		= SC_MOD();
//STRIP001 
//STRIP001 	pTabViewShell->HideListBox();					// Autofilter-DropDown-Listbox
//STRIP001 
//STRIP001 	if ( GetViewData()->HasEditView( GetViewData()->GetActivePart() ) )
//STRIP001 	{
//STRIP001 		pScMod->InputEnterHandler();
//STRIP001 		pTabViewShell->UpdateInputHandler();
//STRIP001 	}
//STRIP001 
//STRIP001 	switch ( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_VIEW_DATA_SOURCE_BROWSER:
//STRIP001 			{
//STRIP001 				//	check if database beamer is open
//STRIP001 
//STRIP001 				SfxViewFrame* pViewFrame = pTabViewShell->GetViewFrame();
//STRIP001 				BOOL bWasOpen = FALSE;
//STRIP001 				{
//STRIP001 					uno::Reference<frame::XFrame> xFrame = pViewFrame->GetFrame()->GetFrameInterface();
//STRIP001 					uno::Reference<frame::XFrame> xBeamerFrame = xFrame->findFrame(
//STRIP001 														::rtl::OUString::createFromAscii("_beamer"),
//STRIP001 														frame::FrameSearchFlag::CHILDREN);
//STRIP001 					if ( xBeamerFrame.is() )
//STRIP001 						bWasOpen = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				if ( bWasOpen )
//STRIP001 				{
//STRIP001 					//	close database beamer: just forward to SfxViewFrame
//STRIP001 
//STRIP001 					pViewFrame->ExecuteSlot( rReq );
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					//	show database beamer: SfxViewFrame call must be synchronous
//STRIP001 
//STRIP001 					pViewFrame->ExecuteSlot( rReq, (BOOL) FALSE );		// FALSE = synchronous
//STRIP001 
//STRIP001 					//	select current database in database beamer
//STRIP001 
//STRIP001 					ScImportParam aImportParam;
//STRIP001 					ScDBData* pDBData = pTabViewShell->GetDBData(TRUE,SC_DB_OLD);		// don't create if none found
//STRIP001 					if (pDBData)
//STRIP001 						pDBData->GetImportParam( aImportParam );
//STRIP001 
//STRIP001 					ScDBDocFunc::ShowInBeamer( aImportParam, pTabViewShell->GetViewFrame() );
//STRIP001 				}
//STRIP001 				rReq.Done();		// needed because it's a toggle slot
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_REIMPORT_DATA:
//STRIP001 			{
//STRIP001 				BOOL bOk = FALSE;
//STRIP001 				ScDBData* pDBData = pTabViewShell->GetDBData(TRUE,SC_DB_OLD);
//STRIP001 				if (pDBData)
//STRIP001 				{
//STRIP001 					ScImportParam aImportParam;
//STRIP001 					pDBData->GetImportParam( aImportParam );
//STRIP001 					if (aImportParam.bImport && !pDBData->HasImportSelection())
//STRIP001 					{
//STRIP001 						pTabViewShell->ImportData( aImportParam );
//STRIP001 						pDBData->SetImportParam( aImportParam );	//! Undo ??
//STRIP001 						bOk = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				if (!bOk && ! rReq.IsAPI() )
//STRIP001 					pTabViewShell->ErrorMessage(STR_REIMPORT_EMPTY);
//STRIP001 
//STRIP001 				if( bOk )
//STRIP001 					rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_REFRESH_DBAREA:
//STRIP001 			{
//STRIP001 				ScDBData* pDBData = pTabViewShell->GetDBData(TRUE,SC_DB_OLD);
//STRIP001 				if (pDBData)
//STRIP001 				{
//STRIP001 					//	Import wiederholen wie SID_REIMPORT_DATA
//STRIP001 
//STRIP001 					BOOL bContinue = TRUE;
//STRIP001 					ScImportParam aImportParam;
//STRIP001 					pDBData->GetImportParam( aImportParam );
//STRIP001 					if (aImportParam.bImport && !pDBData->HasImportSelection())
//STRIP001 					{
//STRIP001 						bContinue = pTabViewShell->ImportData( aImportParam );
//STRIP001 						pDBData->SetImportParam( aImportParam );	//! Undo ??
//STRIP001 
//STRIP001 						//	markieren (Groesse kann sich geaendert haben)
//STRIP001 						ScRange aNewRange;
//STRIP001 						pDBData->GetArea(aNewRange);
//STRIP001 						pTabViewShell->MarkRange(aNewRange);
//STRIP001 					}
//STRIP001 
//STRIP001 					if ( bContinue )		// #41905# Fehler beim Import -> Abbruch
//STRIP001 					{
//STRIP001 						//	interne Operationen, wenn welche gespeichert
//STRIP001 
//STRIP001 						if ( pDBData->HasQueryParam() || pDBData->HasSortParam() ||
//STRIP001 														  pDBData->HasSubTotalParam() )
//STRIP001 							pTabViewShell->RepeatDB();
//STRIP001 
//STRIP001 						//	Pivottabellen die den Bereich als Quelldaten haben
//STRIP001 
//STRIP001 						ScRange aRange;
//STRIP001 						pDBData->GetArea(aRange);
//STRIP001 						GetViewData()->GetDocShell()->RefreshPivotTables(aRange);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SBA_BRW_INSERT:
//STRIP001 			{
//STRIP001 				if (pReqArgs)
//STRIP001 				{
//STRIP001 					const SfxStringItem &rDBNameItem = (const SfxStringItem&)
//STRIP001 														pReqArgs->Get(SID_ATTR_SBA_DATABASE);
//STRIP001 					const SfxStringItem &rStatementItem = (const SfxStringItem&)
//STRIP001 														pReqArgs->Get(SID_ATTR_SBA_STATEMENT);
//STRIP001 					const SbaSelectionItem &rSelectionItem = (const SbaSelectionItem&)
//STRIP001 														pReqArgs->Get(SID_ATTR_SBA_SELECTION);
//STRIP001 
//STRIP001 					DBG_ASSERT( rDBNameItem.ISA(SfxStringItem), "invalid argument type" );
//STRIP001 					DBG_ASSERT( rStatementItem.ISA(SfxStringItem), "invalid argument type" );
//STRIP001 					DBG_ASSERT( rSelectionItem.ISA(SbaSelectionItem), "invalid argument type" );
//STRIP001 
//STRIP001 					ScViewData* pViewData	= GetViewData();
//STRIP001 					ScImportParam aImParam;
//STRIP001 					aImParam.nCol1 = aImParam.nCol2 = pViewData->GetCurX();
//STRIP001 					aImParam.nRow1 = aImParam.nRow2 = pViewData->GetCurY();
//STRIP001 					aImParam.bImport = TRUE;
//STRIP001 					aImParam.aDBName = rDBNameItem.GetValue();
//STRIP001 					aImParam.aStatement = rStatementItem.GetValue();
//STRIP001 
//STRIP001                     ::com::sun::star::uno::Reference<
//STRIP001                         ::com::sun::star::sdbc::XResultSet > xResultSet;
//STRIP001 
//STRIP001                     ScDBDocFunc( *pViewData->GetDocShell() ).DoImport(
//STRIP001                             pViewData->GetTabNo(), aImParam, xResultSet,
//STRIP001                             rSelectionItem.GetSelectionList(), TRUE, TRUE );
//STRIP001 
//STRIP001 					rReq.Done();
//STRIP001 				}
//STRIP001 				else
//STRIP001 					DBG_ERROR( "arguments expected" );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SUBTOTALS:
//STRIP001 			{
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 				if ( pArgs )
//STRIP001 				{
//STRIP001 					pTabViewShell->DoSubTotals( ((const ScSubTotalItem&) pArgs->Get( SCITEM_SUBTDATA )).
//STRIP001 									GetSubTotalData() );
//STRIP001 					rReq.Done();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					ScSubTotalDlg*	pDlg = NULL;
//STRIP001 					ScSubTotalParam aSubTotalParam;
//STRIP001 					SfxItemSet		aArgSet( GetPool(), SCITEM_SUBTDATA, SCITEM_SUBTDATA );
//STRIP001 
//STRIP001 					ScDBData* pDBData = pTabViewShell->GetDBData();
//STRIP001 					pDBData->GetSubTotalParam( aSubTotalParam );
//STRIP001 					aSubTotalParam.bRemoveOnly = FALSE;
//STRIP001 
//STRIP001 					aArgSet.Put( ScSubTotalItem( SCITEM_SUBTDATA, GetViewData(), &aSubTotalParam ) );
//STRIP001 					pDlg = new ScSubTotalDlg( pTabViewShell->GetDialogParent(), &aArgSet );
//STRIP001 					pDlg->SetCurPageId(1);
//STRIP001 
//STRIP001 					short bResult = pDlg->Execute();
//STRIP001 
//STRIP001 					if ( (bResult == RET_OK) || (bResult == SCRET_REMOVE) )
//STRIP001 					{
//STRIP001 						const SfxItemSet* pOutSet = NULL;
//STRIP001 
//STRIP001 						if ( bResult == RET_OK )
//STRIP001 						{
//STRIP001 							pOutSet = pDlg->GetOutputItemSet();
//STRIP001 							aSubTotalParam =
//STRIP001 								((const ScSubTotalItem&)
//STRIP001 									pOutSet->Get( SCITEM_SUBTDATA )).
//STRIP001 										GetSubTotalData();
//STRIP001 						}
//STRIP001 						else // if (bResult == SCRET_REMOVE)
//STRIP001 						{
//STRIP001 							pOutSet = &aArgSet;
//STRIP001 							aSubTotalParam.bRemoveOnly = TRUE;
//STRIP001 							aSubTotalParam.bReplace    = TRUE;
//STRIP001 							aArgSet.Put( ScSubTotalItem( SCITEM_SUBTDATA,
//STRIP001 														 GetViewData(),
//STRIP001 														 &aSubTotalParam ) );
//STRIP001 						}
//STRIP001 
//STRIP001 						pTabViewShell->DoSubTotals( aSubTotalParam );
//STRIP001 						rReq.Done( *pOutSet );
//STRIP001 					}
//STRIP001 					delete pDlg;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SORT_DESCENDING:
//STRIP001 		case SID_SORT_ASCENDING:
//STRIP001 			{
//STRIP001 				SfxItemSet	aArgSet( GetPool(), SCITEM_SORTDATA, SCITEM_SORTDATA );
//STRIP001 				ScSortParam aSortParam;
//STRIP001 				ScDBData*	pDBData = pTabViewShell->GetDBData();
//STRIP001 
//STRIP001 				pDBData->GetSortParam( aSortParam );
//STRIP001 				aSortParam.bHasHeader		= FALSE;
//STRIP001 				aSortParam.bByRow			= TRUE;
//STRIP001 				aSortParam.bCaseSens		= FALSE;
//STRIP001 				aSortParam.bIncludePattern	= FALSE;
//STRIP001 				aSortParam.bInplace 		= TRUE;
//STRIP001 				aSortParam.bDoSort[0]		= TRUE;
//STRIP001 				aSortParam.nField[0]		= aSortParam.nCol1;
//STRIP001 				aSortParam.bAscending[0]	= (nSlotId == SID_SORT_ASCENDING);
//STRIP001 
//STRIP001 				for ( USHORT i=1; i<MAXSORT; i++ )
//STRIP001 					aSortParam.bDoSort[i] = FALSE;
//STRIP001 
//STRIP001 				aArgSet.Put( ScSortItem( SCITEM_SORTDATA, GetViewData(), &aSortParam ) );
//STRIP001 
//STRIP001 				pTabViewShell->UISort( aSortParam );		// Teilergebnisse bei Bedarf neu
//STRIP001 
//STRIP001                 rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SORT:
//STRIP001 			{
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 				if ( pArgs )		// Basic
//STRIP001 				{
//STRIP001 					ScSortParam aSortParam;
//STRIP001 					ScDBData* pDBData = pTabViewShell->GetDBData();
//STRIP001 					pDBData->GetSortParam( aSortParam );
//STRIP001 					aSortParam.bInplace = TRUE;				// von Basic immer
//STRIP001 
//STRIP001 					const SfxPoolItem* pItem;
//STRIP001 					if ( pArgs->GetItemState( SID_SORT_BYROW, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bByRow = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 					if ( pArgs->GetItemState( SID_SORT_HASHEADER, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bHasHeader = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 					if ( pArgs->GetItemState( SID_SORT_CASESENS, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bCaseSens = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 					if ( pArgs->GetItemState( SID_SORT_ATTRIBS, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bIncludePattern = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 					if ( pArgs->GetItemState( SID_SORT_USERDEF, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 					{
//STRIP001 						USHORT nUserIndex = ((const SfxUInt16Item*)pItem)->GetValue();
//STRIP001 						aSortParam.bUserDef = ( nUserIndex != 0 );
//STRIP001 						if ( nUserIndex )
//STRIP001 							aSortParam.nUserIndex = nUserIndex - 1;		// Basic: 1-basiert
//STRIP001 					}
//STRIP001 
//STRIP001 					USHORT nField0 = 0;
//STRIP001 					if ( pArgs->GetItemState( FN_PARAM_1, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						nField0 = ((const SfxUInt16Item*)pItem)->GetValue();
//STRIP001 					aSortParam.bDoSort[0] = ( nField0 != 0 );
//STRIP001 					aSortParam.nField[0] = nField0 ? (nField0-1) : 0;
//STRIP001 					if ( pArgs->GetItemState( FN_PARAM_2, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bAscending[0] = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 					USHORT nField1 = 0;
//STRIP001 					if ( pArgs->GetItemState( FN_PARAM_3, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						nField1 = ((const SfxUInt16Item*)pItem)->GetValue();
//STRIP001 					aSortParam.bDoSort[1] = ( nField1 != 0 );
//STRIP001 					aSortParam.nField[1] = nField1 ? (nField1-1) : 0;
//STRIP001 					if ( pArgs->GetItemState( FN_PARAM_4, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bAscending[1] = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 					USHORT nField2 = 0;
//STRIP001 					if ( pArgs->GetItemState( FN_PARAM_5, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						nField2 = ((const SfxUInt16Item*)pItem)->GetValue();
//STRIP001 					aSortParam.bDoSort[2] = ( nField2 != 0 );
//STRIP001 					aSortParam.nField[2] = nField2 ? (nField2-1) : 0;
//STRIP001 					if ( pArgs->GetItemState( FN_PARAM_6, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 						aSortParam.bAscending[2] = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 
//STRIP001 					// Teilergebnisse bei Bedarf neu
//STRIP001 					pTabViewShell->UISort( aSortParam );
//STRIP001 					rReq.Done();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					ScSortDlg*	pDlg = NULL;
//STRIP001 					ScSortParam aSortParam;
//STRIP001 					SfxItemSet	aArgSet( GetPool(), SCITEM_SORTDATA, SCITEM_SORTDATA );
//STRIP001 
//STRIP001 					ScDBData* pDBData = pTabViewShell->GetDBData();
//STRIP001 					pDBData->GetSortParam( aSortParam );
//STRIP001 
//STRIP001 					aArgSet.Put( ScSortItem( SCITEM_SORTDATA, GetViewData(), &aSortParam ) );
//STRIP001 					pDlg = new ScSortDlg( pTabViewShell->GetDialogParent(), &aArgSet );
//STRIP001 					pDlg->SetCurPageId(1);
//STRIP001 
//STRIP001 					if ( pDlg->Execute() == RET_OK )
//STRIP001 					{
//STRIP001 						const SfxItemSet* pOutSet = pDlg->GetOutputItemSet();
//STRIP001 						const ScSortParam& rOutParam = ((const ScSortItem&)
//STRIP001 									   pOutSet->Get( SCITEM_SORTDATA )).GetSortData();
//STRIP001 
//STRIP001 						// Teilergebnisse bei Bedarf neu
//STRIP001 						pTabViewShell->UISort( rOutParam );
//STRIP001 
//STRIP001 						if ( rOutParam.bInplace )
//STRIP001 						{
//STRIP001 							rReq.AppendItem( SfxBoolItem( SID_SORT_BYROW,
//STRIP001 												rOutParam.bByRow ) );
//STRIP001 							rReq.AppendItem( SfxBoolItem( SID_SORT_HASHEADER,
//STRIP001 												rOutParam.bHasHeader ) );
//STRIP001 							rReq.AppendItem( SfxBoolItem( SID_SORT_CASESENS,
//STRIP001 												rOutParam.bCaseSens ) );
//STRIP001 							rReq.AppendItem( SfxBoolItem( SID_SORT_ATTRIBS,
//STRIP001 												rOutParam.bIncludePattern ) );
//STRIP001 							USHORT nUser = rOutParam.bUserDef ? ( rOutParam.nUserIndex + 1 ) : 0;
//STRIP001 							rReq.AppendItem( SfxUInt16Item( SID_SORT_USERDEF, nUser ) );
//STRIP001 							if ( rOutParam.bDoSort[0] )
//STRIP001 							{
//STRIP001 								rReq.AppendItem( SfxUInt16Item( FN_PARAM_1,
//STRIP001 													rOutParam.nField[0] + 1 ) );
//STRIP001 								rReq.AppendItem( SfxBoolItem( FN_PARAM_2,
//STRIP001 													rOutParam.bAscending[0] ) );
//STRIP001 							}
//STRIP001 							if ( rOutParam.bDoSort[1] )
//STRIP001 							{
//STRIP001 								rReq.AppendItem( SfxUInt16Item( FN_PARAM_3,
//STRIP001 													rOutParam.nField[1] + 1 ) );
//STRIP001 								rReq.AppendItem( SfxBoolItem( FN_PARAM_4,
//STRIP001 													rOutParam.bAscending[1] ) );
//STRIP001 							}
//STRIP001 							if ( rOutParam.bDoSort[2] )
//STRIP001 							{
//STRIP001 								rReq.AppendItem( SfxUInt16Item( FN_PARAM_5,
//STRIP001 													rOutParam.nField[2] + 1 ) );
//STRIP001 								rReq.AppendItem( SfxBoolItem( FN_PARAM_6,
//STRIP001 													rOutParam.bAscending[2] ) );
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						rReq.Done();
//STRIP001 					}
//STRIP001 
//STRIP001 					delete pDlg;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;

/*
			{

				USHORT			nId  = ScPivotLayoutWrapper::GetChildWindowId();
				SfxChildWindow* pWnd = pSfxApp->GetChildWindow( nId );

				pScMod->SetRefDialog( nId, pWnd ? FALSE : TRUE );

			}
			break;
*/

//STRIP001 		case SID_FILTER:
//STRIP001 			{
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 				if ( pArgs )
//STRIP001 				{
//STRIP001 					DBG_ERROR("SID_FILTER with arguments?");
//STRIP001 					pTabViewShell->Query( ((const ScQueryItem&)
//STRIP001 							pArgs->Get( SCITEM_QUERYDATA )).GetQueryData(), NULL, TRUE );
//STRIP001 					rReq.Done();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					USHORT			nId  = ScFilterDlgWrapper::GetChildWindowId();
//STRIP001 					SfxViewFrame* pViewFrm = pTabViewShell->GetViewFrame();
//STRIP001 					SfxChildWindow* pWnd = pViewFrm->GetChildWindow( nId );
//STRIP001 
//STRIP001 					pScMod->SetRefDialog( nId, pWnd ? FALSE : TRUE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SPECIAL_FILTER:
//STRIP001 			{
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 				if ( pArgs )
//STRIP001 				{
//STRIP001 					DBG_ERROR("SID_SPECIAL_FILTER with arguments?");
//STRIP001 					pTabViewShell->Query( ((const ScQueryItem&)
//STRIP001 							pArgs->Get( SCITEM_QUERYDATA )).GetQueryData(), NULL, TRUE );
//STRIP001 					rReq.Done();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					USHORT			nId  = ScSpecialFilterDlgWrapper::GetChildWindowId();
//STRIP001 					SfxViewFrame* pViewFrm = pTabViewShell->GetViewFrame();
//STRIP001 					SfxChildWindow* pWnd = pViewFrm->GetChildWindow( nId );
//STRIP001 
//STRIP001 					pScMod->SetRefDialog( nId, pWnd ? FALSE : TRUE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FID_FILTER_OK:
//STRIP001 			{
//STRIP001 				const SfxItemSet*  pOutSet = rReq.GetArgs();
//STRIP001 				const ScQueryItem& rItem   = (const ScQueryItem&)
//STRIP001 											 pOutSet->Get( SCITEM_QUERYDATA );
//STRIP001 
//STRIP001 				USHORT nCurTab = GetViewData()->GetTabNo();
//STRIP001 				USHORT nRefTab = GetViewData()->GetRefTabNo();
//STRIP001 
//STRIP001 				// Wenn RefInput auf andere Tabelle als Datentabelle umgeschaltet
//STRIP001 				// hat wieder zurueckschalten:
//STRIP001 
//STRIP001 				if ( nCurTab != nRefTab )
//STRIP001 				{
//STRIP001 					pTabViewShell->SetTabNo( nRefTab );
//STRIP001 					pTabViewShell->PaintExtras();
//STRIP001 				}
//STRIP001 
//STRIP001 				ScRange aAdvSource;
//STRIP001 				if (rItem.GetAdvancedQuerySource(aAdvSource))
//STRIP001 					pTabViewShell->Query( rItem.GetQueryData(), &aAdvSource, TRUE );
//STRIP001 				else
//STRIP001 					pTabViewShell->Query( rItem.GetQueryData(), NULL, TRUE );
//STRIP001 				rReq.Done( *pOutSet );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_UNFILTER:
//STRIP001 			{
//STRIP001 				ScQueryParam aParam;
//STRIP001 				ScDBData*	 pDBData = pTabViewShell->GetDBData();
//STRIP001 
//STRIP001 				pDBData->GetQueryParam( aParam );
//STRIP001 				USHORT nEC = aParam.GetEntryCount();
//STRIP001 				for (USHORT i=0; i<nEC; i++)
//STRIP001 					aParam.GetEntry(i).bDoQuery = FALSE;
//STRIP001 				aParam.bDuplicate = TRUE;
//STRIP001 				pTabViewShell->Query( aParam, NULL, TRUE );
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_AUTO_FILTER:
//STRIP001 			pTabViewShell->ToggleAutoFilter();
//STRIP001 			rReq.Done();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_AUTOFILTER_HIDE:
//STRIP001 			pTabViewShell->HideAutoFilter();
//STRIP001 			rReq.Done();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_PIVOT_TABLE:
//STRIP001 			{
//STRIP001 				const SfxPoolItem* pItem;
//STRIP001 				if ( pReqArgs && SFX_ITEM_SET ==
//STRIP001 						pReqArgs->GetItemState( SCITEM_PIVOTDATA, TRUE, &pItem ) )
//STRIP001 				{
//STRIP001 					USHORT nCurTab = GetViewData()->GetTabNo();
//STRIP001 					USHORT nRefTab = GetViewData()->GetRefTabNo();
//STRIP001 
//STRIP001 					// Wenn RefInput auf andere Tabelle als Datentabelle umgeschaltet
//STRIP001 					// hat wieder zurueckschalten:
//STRIP001 
//STRIP001 					if ( nCurTab != nRefTab )
//STRIP001 					{
//STRIP001 						pTabViewShell->SetTabNo( nRefTab );
//STRIP001 						pTabViewShell->PaintExtras();
//STRIP001 					}
//STRIP001 
//STRIP001 					const ScDPObject* pDPObject = pTabViewShell->GetDialogDPObject();
//STRIP001 					if ( pDPObject )
//STRIP001 					{
//STRIP001 						const ScPivotItem* pPItem = (const ScPivotItem*)pItem;
//STRIP001 						pTabViewShell->MakePivotTable(
//STRIP001 											pPItem->GetData(),
//STRIP001 											pPItem->GetDestRange(),
//STRIP001 											pPItem->IsNewSheet(),
//STRIP001 											*pDPObject );
//STRIP001 					}
//STRIP001 					rReq.Done();
//STRIP001 				}
//STRIP001 				else if (rReq.IsAPI())
//STRIP001 					SbxBase::SetError(SbxERR_BAD_PARAMETER);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_OPENDLG_PIVOTTABLE:
//STRIP001 			{
//STRIP001 				ScViewData* pViewData = GetViewData();
//STRIP001 				ScDocument* pDoc = pViewData->GetDocument();
//STRIP001 
//STRIP001 				ScDPObject* pNewDPObject = NULL;
//STRIP001 
//STRIP001 				// ScPivot is no longer used...
//STRIP001 				ScDPObject* pDPObj = pDoc->GetDPAtCursor(
//STRIP001 											pViewData->GetCurX(), pViewData->GetCurY(),
//STRIP001 											pViewData->GetTabNo() );
//STRIP001 				if ( pDPObj )	// on an existing table?
//STRIP001 				{
//STRIP001 					pNewDPObject = new ScDPObject( *pDPObj );
//STRIP001 				}
//STRIP001 				else	 		// create new table
//STRIP001 				{
//STRIP001 					//	select database range or data
//STRIP001 					pTabViewShell->GetDBData( TRUE, SC_DB_OLD );
//STRIP001 					const ScMarkData& rMark = GetViewData()->GetMarkData();
//STRIP001 					if ( !rMark.IsMarked() && !rMark.IsMultiMarked() )
//STRIP001 						pTabViewShell->MarkDataArea( FALSE );
//STRIP001 
//STRIP001 					//	output to cursor position for non-sheet data
//STRIP001 					ScAddress aDestPos( pViewData->GetCurX(), pViewData->GetCurY(),
//STRIP001 											pViewData->GetTabNo() );
//STRIP001 
//STRIP001 					//	first select type of source data
//STRIP001 
//STRIP001 					BOOL bEnableExt = ScDPObject::HasRegisteredSources();
//STRIP001 					ScDataPilotSourceTypeDlg* pTypeDlg = new ScDataPilotSourceTypeDlg(
//STRIP001 												pTabViewShell->GetDialogParent(), bEnableExt );
//STRIP001 					if ( pTypeDlg->Execute() == RET_OK )
//STRIP001 					{
//STRIP001 						if ( pTypeDlg->IsExternal() )
//STRIP001 						{
//STRIP001 							uno::Sequence<rtl::OUString> aSources = ScDPObject::GetRegisteredSources();
//STRIP001 							ScDataPilotServiceDlg* pServDlg = new ScDataPilotServiceDlg(
//STRIP001 												pTabViewShell->GetDialogParent(), aSources );
//STRIP001 							if ( pServDlg->Execute() == RET_OK )
//STRIP001 							{
//STRIP001 								ScDPServiceDesc aServDesc( 
//STRIP001 										pServDlg->GetServiceName(),
//STRIP001 										pServDlg->GetParSource(),
//STRIP001 										pServDlg->GetParName(),
//STRIP001 										pServDlg->GetParUser(),
//STRIP001 										pServDlg->GetParPass() );
//STRIP001 								pNewDPObject = new ScDPObject( pDoc );
//STRIP001 								pNewDPObject->SetServiceData( aServDesc );
//STRIP001 							}
//STRIP001 							delete pServDlg;
//STRIP001 						}
//STRIP001 						else if ( pTypeDlg->IsDatabase() )
//STRIP001 						{
//STRIP001 							ScDataPilotDatabaseDlg* pDataDlg = new ScDataPilotDatabaseDlg(
//STRIP001 															pTabViewShell->GetDialogParent() );
//STRIP001 							if ( pDataDlg->Execute() == RET_OK )
//STRIP001 							{
//STRIP001 								ScImportSourceDesc aImpDesc;
//STRIP001 								pDataDlg->GetValues( aImpDesc );
//STRIP001 								pNewDPObject = new ScDPObject( pDoc );
//STRIP001 								pNewDPObject->SetImportDesc( aImpDesc );
//STRIP001 							}
//STRIP001 							delete pDataDlg;
//STRIP001 						}
//STRIP001 						else		// selection
//STRIP001 						{
//STRIP001 							//!	use database ranges (select before type dialog?)
//STRIP001 							ScRange aRange;
//STRIP001 							if ( GetViewData()->GetSimpleArea( aRange ) )
//STRIP001 							{
//STRIP001 								BOOL bOK = TRUE;
//STRIP001 								if ( pDoc->HasSubTotalCells( aRange ) )
//STRIP001 								{
//STRIP001 									//	confirm selection if it contains SubTotal cells
//STRIP001 
//STRIP001 									QueryBox aBox( pTabViewShell->GetDialogParent(),
//STRIP001 													WinBits(WB_YES_NO | WB_DEF_YES),
//STRIP001 													ScGlobal::GetRscString(STR_DATAPILOT_SUBTOTAL) );
//STRIP001 									if (aBox.Execute() == RET_NO)
//STRIP001 										bOK = FALSE;
//STRIP001 								}
//STRIP001 								if (bOK)
//STRIP001 								{
//STRIP001 									ScSheetSourceDesc aShtDesc;
//STRIP001 									aShtDesc.aSourceRange = aRange;
//STRIP001 									pNewDPObject = new ScDPObject( pDoc );
//STRIP001 									pNewDPObject->SetSheetDesc( aShtDesc );
//STRIP001 
//STRIP001 									//	output below source data
//STRIP001 									if ( aRange.aEnd.Row()+2 <= MAXROW - 4 )
//STRIP001 										aDestPos = ScAddress( aRange.aStart.Col(),
//STRIP001 																aRange.aEnd.Row()+2,
//STRIP001 																aRange.aStart.Tab() );
//STRIP001 								}
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 					delete pTypeDlg;
//STRIP001 
//STRIP001 					if ( pNewDPObject )
//STRIP001 						pNewDPObject->SetOutRange( aDestPos );
//STRIP001 
//STRIP001 #if 0
//STRIP001 					ScDBData*	pDBData = pTabViewShell->GetDBData();
//STRIP001 					String		aErrMsg;
//STRIP001 
//STRIP001 					pDBData->GetArea( nTab, nCol1, nRow1, nCol2, nRow2 );
//STRIP001 
//STRIP001 					bAreaOk = TRUE;
//STRIP001 					if ( nRow2-nRow1 < 1 )
//STRIP001 					{
//STRIP001 						// "mindestens eine Datenzeile"
//STRIP001 						pTabViewShell->ErrorMessage(STR_PIVOT_INVALID_DBAREA);
//STRIP001 						bAreaOk = FALSE;
//STRIP001 					}
//STRIP001 					else if (!pDBData->HasHeader())
//STRIP001 					{
//STRIP001 						if ( MessBox( pTabViewShell->GetDialogParent(), WinBits(WB_YES_NO | WB_DEF_YES),
//STRIP001 								ScGlobal::GetRscString( STR_MSSG_DOSUBTOTALS_0 ),		// "StarCalc"
//STRIP001 								ScGlobal::GetRscString( STR_MSSG_MAKEAUTOFILTER_0 ) 	// Koepfe aus erster Zeile?
//STRIP001 							).Execute() == RET_YES )
//STRIP001 						{
//STRIP001 							pDBData->SetHeader( TRUE ); 	//! Undo ??
//STRIP001 						}
//STRIP001 						else
//STRIP001 							bAreaOk = FALSE;
//STRIP001 					}
//STRIP001 #endif
//STRIP001 				}
//STRIP001 
//STRIP001 				pTabViewShell->SetDialogDPObject( pNewDPObject );	// is copied
//STRIP001 				if ( pNewDPObject )
//STRIP001 				{
//STRIP001 					//	start layout dialog
//STRIP001 
//STRIP001 					USHORT nId  = ScPivotLayoutWrapper::GetChildWindowId();
//STRIP001 					SfxViewFrame* pViewFrm = pTabViewShell->GetViewFrame();
//STRIP001 					SfxChildWindow* pWnd = pViewFrm->GetChildWindow( nId );
//STRIP001 					pScMod->SetRefDialog( nId, pWnd ? FALSE : TRUE );
//STRIP001 				}
//STRIP001 				delete pNewDPObject;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DEFINE_DBNAME:
//STRIP001 			{
//STRIP001 
//STRIP001 				USHORT			nId  = ScDbNameDlgWrapper::GetChildWindowId();
//STRIP001 				SfxViewFrame* pViewFrm = pTabViewShell->GetViewFrame();
//STRIP001 				SfxChildWindow* pWnd = pViewFrm->GetChildWindow( nId );
//STRIP001 
//STRIP001 				pScMod->SetRefDialog( nId, pWnd ? FALSE : TRUE );
//STRIP001 
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SELECT_DB:
//STRIP001 			{
//STRIP001 				if ( pReqArgs )
//STRIP001 				{
//STRIP001 					const SfxStringItem* pItem =
//STRIP001 						(const SfxStringItem*)&pReqArgs->Get( SID_SELECT_DB );
//STRIP001 
//STRIP001 					if( pItem )
//STRIP001 					{
//STRIP001 						pTabViewShell->GotoDBArea( pItem->GetValue() );
//STRIP001 						rReq.Done();
//STRIP001 					}
//STRIP001 					else
//STRIP001 						DBG_ERROR("NULL");
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					ScDocument* 	pDoc   = GetViewData()->GetDocument();
//STRIP001 					ScDBCollection* pDBCol = pDoc->GetDBCollection();
//STRIP001 
//STRIP001 					if ( pDBCol )
//STRIP001 					{
//STRIP001 						const String	aStrNoName( ScGlobal::GetRscString(STR_DB_NONAME) );
//STRIP001 						List			aList;
//STRIP001 						USHORT			nDBCount = pDBCol->GetCount();
//STRIP001 						ScDBData*		pDbData  = NULL;
//STRIP001 						String*			pDBName  = NULL;
//STRIP001 
//STRIP001 						for ( USHORT i=0; i < nDBCount; i++ )
//STRIP001 						{
//STRIP001 							pDbData = (ScDBData*)(pDBCol->At( i ));
//STRIP001 							if ( pDbData )
//STRIP001 							{
//STRIP001 								pDBName = new String;
//STRIP001 								pDbData->GetName( *pDBName );
//STRIP001 
//STRIP001 								if ( *pDBName != aStrNoName )
//STRIP001 									aList.Insert( pDBName );
//STRIP001 								else
//STRIP001 									DELETEZ(pDBName);
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						ScSelEntryDlg* pDlg =
//STRIP001 							new ScSelEntryDlg( pTabViewShell->GetDialogParent(), RID_SCDLG_SELECTDB,
//STRIP001 											   String(ScResId(SCSTR_SELECTDB)),
//STRIP001 											   String(ScResId(SCSTR_AREAS)),
//STRIP001 											   aList );
//STRIP001 
//STRIP001 						if ( pDlg->Execute() == RET_OK )
//STRIP001 						{
//STRIP001 							String aName = pDlg->GetSelectEntry();
//STRIP001 							pTabViewShell->GotoDBArea( aName );
//STRIP001 							rReq.AppendItem( SfxStringItem( SID_SELECT_DB, aName ) );
//STRIP001 							rReq.Done();
//STRIP001 						}
//STRIP001 
//STRIP001 						delete pDlg;
//STRIP001 
//STRIP001 						void* pEntry = aList.First();
//STRIP001 						while ( pEntry )
//STRIP001 						{
//STRIP001 							delete (String*) aList.Remove( pEntry );
//STRIP001 							pEntry = aList.Next();
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FID_VALIDATION:
//STRIP001 			{
//STRIP001 				const SfxPoolItem* pItem;
//STRIP001 				const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 				if ( pArgs )
//STRIP001 				{
//STRIP001 					DBG_ERROR("spaeter...");
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					SfxItemSet aArgSet( GetPool(), FID_VALID_MODE, FID_VALID_ERRTEXT );
//STRIP001 
//STRIP001 					ScValidationMode eMode = SC_VALID_ANY;
//STRIP001 					ScConditionMode eOper = SC_COND_EQUAL;
//STRIP001 					String aExpr1, aExpr2;
//STRIP001 					BOOL bBlank = TRUE;
//STRIP001 					BOOL bShowHelp = FALSE;
//STRIP001 					String aHelpTitle, aHelpText;
//STRIP001 					BOOL bShowError = FALSE;
//STRIP001 					ScValidErrorStyle eErrStyle = SC_VALERR_STOP;
//STRIP001 					String aErrTitle, aErrText;
//STRIP001 
//STRIP001 					ScDocument* pDoc = GetViewData()->GetDocument();
//STRIP001 					USHORT nCurX = GetViewData()->GetCurX();
//STRIP001 					USHORT nCurY = GetViewData()->GetCurY();
//STRIP001 					USHORT nTab = GetViewData()->GetTabNo();
//STRIP001 					ScAddress aCursorPos( nCurX, nCurY, nTab );
//STRIP001 					ULONG nIndex = ((SfxUInt32Item*)pDoc->GetAttr(
//STRIP001 								nCurX, nCurY, nTab, ATTR_VALIDDATA ))->GetValue();
//STRIP001 					if ( nIndex )
//STRIP001 					{
//STRIP001 						const ScValidationData*	pOldData = pDoc->GetValidationEntry( nIndex );
//STRIP001 						if ( pOldData )
//STRIP001 						{
//STRIP001 							eMode = pOldData->GetDataMode();
//STRIP001 							eOper = pOldData->GetOperation();
//STRIP001 							ULONG nNumFmt = 0;
//STRIP001 							if ( eMode == SC_VALID_DATE || eMode == SC_VALID_TIME )
//STRIP001 							{
//STRIP001 								short nType = ( eMode == SC_VALID_DATE ) ? NUMBERFORMAT_DATE
//STRIP001 																		 : NUMBERFORMAT_TIME;
//STRIP001 								nNumFmt = pDoc->GetFormatTable()->GetStandardFormat(
//STRIP001 																	nType, ScGlobal::eLnge );
//STRIP001 							}
//STRIP001 							aExpr1 = pOldData->GetExpression( aCursorPos, 0, nNumFmt );
//STRIP001 							aExpr2 = pOldData->GetExpression( aCursorPos, 1, nNumFmt );
//STRIP001 							bBlank = pOldData->IsIgnoreBlank();
//STRIP001 
//STRIP001 							bShowHelp = pOldData->GetInput( aHelpTitle, aHelpText );
//STRIP001 							bShowError = pOldData->GetErrMsg( aErrTitle, aErrText, eErrStyle );
//STRIP001 
//STRIP001 							aArgSet.Put( SfxAllEnumItem( FID_VALID_MODE,		eMode ) );
//STRIP001 							aArgSet.Put( SfxAllEnumItem( FID_VALID_CONDMODE,	eOper ) );
//STRIP001 							aArgSet.Put( SfxStringItem(	 FID_VALID_VALUE1,		aExpr1 ) );
//STRIP001 							aArgSet.Put( SfxStringItem(	 FID_VALID_VALUE2,		aExpr2 ) );
//STRIP001 							aArgSet.Put( SfxBoolItem(	 FID_VALID_BLANK,		bBlank ) );
//STRIP001 							aArgSet.Put( SfxBoolItem(	 FID_VALID_SHOWHELP,	bShowHelp ) );
//STRIP001 							aArgSet.Put( SfxStringItem(	 FID_VALID_HELPTITLE,	aHelpTitle ) );
//STRIP001 							aArgSet.Put( SfxStringItem(	 FID_VALID_HELPTEXT,	aHelpText ) );
//STRIP001 							aArgSet.Put( SfxBoolItem(	 FID_VALID_SHOWERR,		bShowError ) );
//STRIP001 							aArgSet.Put( SfxAllEnumItem( FID_VALID_ERRSTYLE,	eErrStyle ) );
//STRIP001 							aArgSet.Put( SfxStringItem(  FID_VALID_ERRTITLE,	aErrTitle ) );
//STRIP001 							aArgSet.Put( SfxStringItem(  FID_VALID_ERRTEXT,		aErrText ) );
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001 					ScValidationDlg* pDlg = new ScValidationDlg( NULL, &aArgSet );
//STRIP001 					if ( pDlg->Execute() == RET_OK )
//STRIP001 					{
//STRIP001 						const SfxItemSet* pOutSet = pDlg->GetOutputItemSet();
//STRIP001 
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_MODE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							eMode = (ScValidationMode) ((const SfxAllEnumItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_CONDMODE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							eOper = (ScConditionMode) ((const SfxAllEnumItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_VALUE1, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							aExpr1 = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_VALUE2, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							aExpr2 = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_BLANK, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							bBlank = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_SHOWHELP, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							bShowHelp = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_HELPTITLE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							aHelpTitle = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_HELPTEXT, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							aHelpText = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001 
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_SHOWERR, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							bShowError = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_ERRSTYLE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							eErrStyle = (ScValidErrorStyle) ((const SfxAllEnumItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_ERRTITLE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							aErrTitle = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001 						if ( pOutSet->GetItemState( FID_VALID_ERRTEXT, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 							aErrText = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001 
//STRIP001 						USHORT nTab = GetViewData()->GetTabNo();
//STRIP001 						ScValidationData aData( eMode, eOper, aExpr1, aExpr2, pDoc, aCursorPos );
//STRIP001 						aData.SetIgnoreBlank( bBlank );
//STRIP001 
//STRIP001 						aData.SetInput(aHelpTitle, aHelpText);		// sets bShowInput to TRUE
//STRIP001 						if (!bShowHelp)
//STRIP001 							aData.ResetInput();						// reset only bShowInput
//STRIP001 
//STRIP001 						aData.SetError(aErrTitle, aErrText, eErrStyle);	// sets bShowError to TRUE
//STRIP001 						if (!bShowError)
//STRIP001 							aData.ResetError();						// reset only bShowError
//STRIP001 
//STRIP001 						pTabViewShell->SetValidation( aData );
//STRIP001 						rReq.Done( *pOutSet );
//STRIP001 					}
//STRIP001 					delete pDlg;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 }

/*M*/ void __EXPORT ScCellShell::GetDBState( SfxItemSet& rSet )
/*M*/ {
/*M*/ 	ScTabViewShell*	pTabViewShell  	= GetViewData()->GetViewShell();
/*M*/ 	ScViewData* pViewData	= GetViewData();
/*M*/ 	ScDocShell*	pDocSh		= pViewData->GetDocShell();
/*M*/ 	ScDocument* pDoc		= pDocSh->GetDocument();
/*M*/ 	USHORT		nPosX		= pViewData->GetCurX();
/*M*/ 	USHORT		nPosY		= pViewData->GetCurY();
/*M*/ 	USHORT		nTab		= pViewData->GetTabNo();
/*M*/ 
/*M*/ 	BOOL bAutoFilter;
/*M*/ 	BOOL bAutoFilterTested = FALSE;
/*M*/ 
/*M*/ 	SfxWhichIter aIter(rSet);
/*M*/ 	USHORT nWhich = aIter.FirstWhich();
/*M*/ 	while (nWhich)
/*M*/ 	{
/*M*/ 		switch (nWhich)
/*M*/ 		{
/*M*/ 			case SID_REFRESH_DBAREA:
/*M*/ 				{
/*M*/ 					//	importierte Daten ohne Selektion
/*M*/ 					//	oder Filter,Sortierung,Teilergebis (auch ohne Import)
/*M*/ 					BOOL bOk = FALSE;
/*M*/ 					ScDBData* pDBData = pTabViewShell->GetDBData(FALSE,SC_DB_OLD);
/*M*/ 					if (pDBData && pDoc->GetChangeTrack() == NULL)
/*M*/ 					{
/*M*/ 						if ( pDBData->HasImportParam() )
/*M*/ 							bOk = !pDBData->HasImportSelection();
/*M*/ 						else
/*M*/ 						{
/*M*/ 							bOk = pDBData->HasQueryParam() ||
/*M*/ 								  pDBData->HasSortParam() ||
/*M*/ 								  pDBData->HasSubTotalParam();
/*M*/ 							if (!bOk)
/*M*/ 							{
/*M*/ 								DBG_BF_ASSERT(0, "STRIP"); //STRIP001 //	Pivottabelle mit den Daten als Quellbereich ?
//STRIP001 /*M*/ 								ScRange aDataRange;
//STRIP001 /*M*/ 								pDBData->GetArea(aDataRange);
//STRIP001 /*M*/ 								ScPivotCollection* pPivotCollection = pDoc->GetPivotCollection();
//STRIP001 /*M*/ 								USHORT nCount = pPivotCollection ? pPivotCollection->GetCount() : 0;
//STRIP001 /*M*/ 								for (USHORT i=0; i<nCount; i++)
//STRIP001 /*M*/ 								{
//STRIP001 /*M*/ 									ScPivot* pTemp = (*pPivotCollection)[i];
//STRIP001 /*M*/ 									if ( pTemp && pTemp->GetSrcArea().Intersects( aDataRange ) )
//STRIP001 /*M*/ 										bOk = TRUE;
//STRIP001 /*M*/ 								}
/*M*/ 							}
/*M*/ 						}
/*M*/ 					}
/*M*/ 					if (!bOk)
/*M*/ 						rSet.DisableItem( nWhich );
/*M*/ 				}
/*M*/ 				break;
/*M*/ 
/*M*/ 			case SID_FILTER:
/*M*/ 			case SID_SPECIAL_FILTER:
/*M*/ 				{
/*M*/ 					if (GetViewData()->IsMultiMarked())
/*M*/ 					{
/*M*/ 						rSet.DisableItem( nWhich );
/*M*/ 					}
/*M*/ 				}
/*M*/ 				break;
/*M*/ 
/*M*/ 
/*M*/ 				//Bei Redlining und Multiselektion Disablen
/*M*/ 			case SID_SORT_ASCENDING:
/*M*/ 			case SID_SORT_DESCENDING:
/*M*/ 			case SCITEM_SORTDATA:
/*M*/ 			case SCITEM_SUBTDATA:
/*M*/ 			case SID_OPENDLG_PIVOTTABLE:
/*M*/ 				{
/*M*/ 					//!	move ReadOnly check to idl flags
/*M*/ 
/*M*/ 					if ( pDocSh->IsReadOnly() || pDoc->GetChangeTrack()!=NULL ||
/*M*/ 							GetViewData()->IsMultiMarked() )
/*M*/ 					{
/*M*/ 						rSet.DisableItem( nWhich );
/*M*/ 					}
/*M*/ 				}
/*M*/ 				break;
/*M*/ 
/*M*/ 			case SID_REIMPORT_DATA:
/*M*/ 				{
/*M*/ 					//	nur importierte Daten ohne Selektion
/*M*/ 					ScDBData* pDBData = pTabViewShell->GetDBData(FALSE,SC_DB_OLD);
/*M*/ 					if (!pDBData || !pDBData->HasImportParam() || pDBData->HasImportSelection() ||
/*M*/ 						pDoc->GetChangeTrack()!=NULL)
/*M*/ 					{
/*M*/ 						rSet.DisableItem( nWhich );
/*M*/ 					}
/*M*/ 				}
/*M*/ 				break;
/*M*/ 
/*M*/ 			case SID_VIEW_DATA_SOURCE_BROWSER:
/*M*/ 				{
/*M*/ 					//	get state (BoolItem) from SfxViewFrame
/*M*/ 
/*M*/ 					pTabViewShell->GetViewFrame()->GetSlotState( nWhich, NULL, &rSet );
/*M*/ 				}
/*M*/ 				break;
/*M*/ 			case SID_SBA_BRW_INSERT:
/*M*/ 				{
/*M*/ 					//	SBA will ein BOOL-Item, damit ueberhaupt enabled
/*M*/ 
/*M*/ 					BOOL bEnable = TRUE;
/*M*/ 					rSet.Put(SfxBoolItem(nWhich, bEnable));
/*M*/ 				}
/*M*/ 				break;
/*M*/ 
/*M*/ 			case SID_AUTO_FILTER:
/*M*/ 			case SID_AUTOFILTER_HIDE:
/*M*/ 				{
/*M*/ 					if (!bAutoFilterTested)
/*M*/ 					{
/*M*/ 						bAutoFilter = pDoc->HasAutoFilter( nPosX, nPosY, nTab );
/*M*/ 						bAutoFilterTested = TRUE;
/*M*/ 					}
/*M*/ 					if ( nWhich == SID_AUTO_FILTER )
/*M*/ 					{
/*M*/ 						if (GetViewData()->IsMultiMarked())
/*M*/ 						{
/*M*/ 							rSet.DisableItem( nWhich );
/*M*/ 						}
/*M*/ 						else
/*M*/ 							rSet.Put( SfxBoolItem( nWhich, bAutoFilter ) );
/*M*/ 					}
/*M*/ 					else
/*M*/ 						if (!bAutoFilter)
/*M*/ 							rSet.DisableItem( nWhich );
/*M*/ 				}
/*M*/ 				break;
/*M*/ 
/*M*/ 			case SID_UNFILTER:
/*M*/ 				{
/*M*/ 					USHORT nStartCol, nStartRow, nStartTab;
/*M*/ 					USHORT nEndCol,   nEndRow,   nEndTab;
/*M*/ 					BOOL bAnyQuery = FALSE;
/*M*/ 
/*M*/ 					BOOL bSelected = GetViewData()->GetSimpleArea(
/*M*/ 							nStartCol, nStartRow, nStartTab, nEndCol, nEndRow, nEndTab );
/*M*/ 
/*M*/ 					if ( bSelected )
/*M*/ 					{
/*M*/ 						if (nStartCol==nEndCol && nStartRow==nEndRow)
/*M*/ 							bSelected = FALSE;
/*M*/ 					}
/*M*/ 					else
/*M*/ 					{
/*M*/ 						nStartCol = GetViewData()->GetCurX();
/*M*/ 						nStartRow = GetViewData()->GetCurY();
/*M*/ 						nStartTab = GetViewData()->GetTabNo();
/*M*/ 					}
/*M*/ 
/*M*/ 					ScDBData* pDBData = bSelected
/*M*/ 								? pDoc->GetDBAtArea( nStartTab, nStartCol, nStartRow, nEndCol, nEndRow )
/*M*/ 								: pDoc->GetDBAtCursor( nStartCol, nStartRow, nStartTab );
/*M*/ 
/*M*/ 					if ( pDBData )
/*M*/ 					{
/*M*/ 						ScQueryParam aParam;
/*M*/ 						pDBData->GetQueryParam( aParam );
/*M*/ 						if ( aParam.GetEntry(0).bDoQuery )
/*M*/ 							bAnyQuery = TRUE;
/*M*/ 					}
/*M*/ 
/*M*/ 					if ( !bAnyQuery )
/*M*/ 						rSet.DisableItem( nWhich );
/*M*/ 				}
/*M*/ 				break;
/*M*/ 		}
/*M*/ 		nWhich = aIter.NextWhich();
/*M*/ 	}
/*M*/ }



}
