/*************************************************************************
 *
 *  $RCSfile: sc_cellsh4.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:26:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

#ifdef WNT
#pragma optimize ("", off)
#endif

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_sfx2/request.hxx>

// auto strip #include "cellsh.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "global.hxx"
#include "scmod.hxx"
// auto strip #include "inputhdl.hxx"
// auto strip #include "inputwin.hxx"
#include "bf_sc.hrc"
namespace binfilter {


//------------------------------------------------------------------

#define IS_AVAILABLE(WhichId,ppItem) \
    (pReqArgs->GetItemState((WhichId), TRUE, ppItem ) == SFX_ITEM_SET)


//STRIP001 void ScCellShell::ExecuteCursor( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScTabViewShell*	pTabViewShell  	= GetViewData()->GetViewShell();
//STRIP001 	const SfxItemSet*	pReqArgs = rReq.GetArgs();
//STRIP001 	USHORT				nSlotId  = rReq.GetSlot();
//STRIP001 	short				nRepeat = 1;
//STRIP001 	BOOL				bSel = FALSE;
//STRIP001 	BOOL				bKeep = FALSE;
//STRIP001 
//STRIP001 	if ( pReqArgs != NULL )
//STRIP001 	{
//STRIP001 		const	SfxPoolItem* pItem;
//STRIP001 		if( IS_AVAILABLE( FN_PARAM_1, &pItem ) )
//STRIP001 			nRepeat = ((const SfxInt16Item*)pItem)->GetValue();
//STRIP001 		if( IS_AVAILABLE( FN_PARAM_2, &pItem ) )
//STRIP001 			bSel = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		//	evaluate locked selection mode
//STRIP001 
//STRIP001 		USHORT nLocked = pTabViewShell->GetLockedModifiers();
//STRIP001 		if ( nLocked & KEY_SHIFT )
//STRIP001 			bSel = TRUE;				// EXT
//STRIP001 		else if ( nLocked & KEY_MOD1 )
//STRIP001 		{
//STRIP001 			// ADD mode: keep the selection, start a new block when marking with shift again
//STRIP001 			bKeep = TRUE;
//STRIP001 			pTabViewShell->SetNewStartIfMarking();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// einmal extra, damit der Cursor bei ExecuteInputDirect nicht zuoft gemalt wird:
//STRIP001 	pTabViewShell->HideAllCursors();
//STRIP001 
//STRIP001 	//OS: einmal fuer alle wird doch reichen!
//STRIP001 	pTabViewShell->ExecuteInputDirect();
//STRIP001 	switch ( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_CURSORDOWN:
//STRIP001 			pTabViewShell->MoveCursorRel(	0,	nRepeat, SC_FOLLOW_LINE, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORBLKDOWN:
//STRIP001 			pTabViewShell->MoveCursorArea( 0, nRepeat, SC_FOLLOW_JUMP, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORUP:
//STRIP001 			pTabViewShell->MoveCursorRel(	0,	-nRepeat, SC_FOLLOW_LINE, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORBLKUP:
//STRIP001 			pTabViewShell->MoveCursorArea( 0, -nRepeat, SC_FOLLOW_JUMP, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORLEFT:
//STRIP001 			pTabViewShell->MoveCursorRel( -nRepeat, 0, SC_FOLLOW_LINE, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORBLKLEFT:
//STRIP001 			pTabViewShell->MoveCursorArea( -nRepeat, 0, SC_FOLLOW_JUMP, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORRIGHT:
//STRIP001 			pTabViewShell->MoveCursorRel(	nRepeat, 0, SC_FOLLOW_LINE, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORBLKRIGHT:
//STRIP001 			pTabViewShell->MoveCursorArea( nRepeat, 0, SC_FOLLOW_JUMP, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORPAGEDOWN:
//STRIP001 			pTabViewShell->MoveCursorPage(	0, nRepeat, SC_FOLLOW_FIX, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORPAGEUP:
//STRIP001 			pTabViewShell->MoveCursorPage(	0, -nRepeat, SC_FOLLOW_FIX, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORPAGERIGHT_: //XXX !!!
//STRIP001 			pTabViewShell->MoveCursorPage( nRepeat, 0, SC_FOLLOW_FIX, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORPAGELEFT_: //XXX !!!
//STRIP001 			pTabViewShell->MoveCursorPage( -nRepeat, 0, SC_FOLLOW_FIX, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ERROR("Unbekannte Message bei ViewShell (Cursor)");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 
//STRIP001 	pTabViewShell->ShowAllCursors();
//STRIP001 
//STRIP001 	rReq.AppendItem( SfxInt16Item(FN_PARAM_1, nRepeat) );
//STRIP001 	rReq.AppendItem( SfxBoolItem(FN_PARAM_2, bSel) );
//STRIP001 	rReq.Done();
//STRIP001 }

//STRIP001 void ScCellShell::GetStateCursor( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 }

//STRIP001 void ScCellShell::ExecuteCursorSel( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	const SfxItemSet*	pReqArgs = rReq.GetArgs();
//STRIP001 	USHORT				nSlotId  = rReq.GetSlot();
//STRIP001 	short				nRepeat = 1;
//STRIP001 
//STRIP001 	if ( pReqArgs != NULL )
//STRIP001 	{
//STRIP001 		const	SfxPoolItem* pItem;
//STRIP001 		if( IS_AVAILABLE( FN_PARAM_1, &pItem ) )
//STRIP001 			nRepeat = ((const SfxInt16Item*)pItem)->GetValue();
//STRIP001 	}
//STRIP001 
//STRIP001 	switch ( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_CURSORDOWN_SEL:		rReq.SetSlot( SID_CURSORDOWN );  break;
//STRIP001 		case SID_CURSORBLKDOWN_SEL:		rReq.SetSlot( SID_CURSORBLKDOWN );  break;
//STRIP001 		case SID_CURSORUP_SEL:			rReq.SetSlot( SID_CURSORUP );  break;
//STRIP001 		case SID_CURSORBLKUP_SEL:		rReq.SetSlot( SID_CURSORBLKUP );  break;
//STRIP001 		case SID_CURSORLEFT_SEL:		rReq.SetSlot( SID_CURSORLEFT );  break;
//STRIP001 		case SID_CURSORBLKLEFT_SEL:		rReq.SetSlot( SID_CURSORBLKLEFT );  break;
//STRIP001 		case SID_CURSORRIGHT_SEL:		rReq.SetSlot( SID_CURSORRIGHT );  break;
//STRIP001 		case SID_CURSORBLKRIGHT_SEL:	rReq.SetSlot( SID_CURSORBLKRIGHT );  break;
//STRIP001 		case SID_CURSORPAGEDOWN_SEL:	rReq.SetSlot( SID_CURSORPAGEDOWN );  break;
//STRIP001 		case SID_CURSORPAGEUP_SEL:		rReq.SetSlot( SID_CURSORPAGEUP );  break;
//STRIP001 		case SID_CURSORPAGERIGHT_SEL:	rReq.SetSlot( SID_CURSORPAGERIGHT_ );  break;
//STRIP001 		case SID_CURSORPAGELEFT_SEL:	rReq.SetSlot( SID_CURSORPAGELEFT_ );  break;
//STRIP001 		default:
//STRIP001 			DBG_ERROR("Unbekannte Message bei ViewShell (CursorSel)");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 	rReq.AppendItem( SfxInt16Item(FN_PARAM_1, nRepeat ) );
//STRIP001 	rReq.AppendItem( SfxBoolItem(FN_PARAM_2, TRUE) );
//STRIP001 	ExecuteSlot( rReq, GetInterface() );
//STRIP001 }

//STRIP001 void ScCellShell::ExecuteMove( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScTabViewShell*	pTabViewShell  	= GetViewData()->GetViewShell();
//STRIP001 	USHORT nSlotId  = rReq.GetSlot();
//STRIP001 
//STRIP001 	if(nSlotId != SID_CURSORTOPOFSCREEN && nSlotId != SID_CURSORENDOFSCREEN)
//STRIP001 		pTabViewShell->ExecuteInputDirect();
//STRIP001 	switch ( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_NEXT_TABLE:
//STRIP001 			pTabViewShell->SelectNextTab( 1 );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_PREV_TABLE:
//STRIP001 			pTabViewShell->SelectNextTab( -1 );
//STRIP001 			break;
//STRIP001 
//STRIP001 		//	Cursorbewegungen in Bloecken gehen nicht von Basic aus,
//STRIP001 		//	weil das ScSbxRange-Objekt bei Eingaben die Markierung veraendert
//STRIP001 
//STRIP001 		case SID_NEXT_UNPROTECT:
//STRIP001 			pTabViewShell->FindNextUnprot( FALSE, !rReq.IsAPI() );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_PREV_UNPROTECT:
//STRIP001 			pTabViewShell->FindNextUnprot( TRUE, !rReq.IsAPI() );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORENTERUP:
//STRIP001 			if (rReq.IsAPI())
//STRIP001 				pTabViewShell->MoveCursorRel( 0, -1, SC_FOLLOW_LINE, FALSE );
//STRIP001 			else
//STRIP001 				pTabViewShell->MoveCursorEnter( TRUE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORENTERDOWN:
//STRIP001 			if (rReq.IsAPI())
//STRIP001 				pTabViewShell->MoveCursorRel( 0, 1, SC_FOLLOW_LINE, FALSE );
//STRIP001 			else
//STRIP001 				pTabViewShell->MoveCursorEnter( FALSE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SELECT_COL:
//STRIP001 			pTabViewShell->MarkColumns();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SELECT_ROW:
//STRIP001 			pTabViewShell->MarkRows();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SELECT_NONE:
//STRIP001 			pTabViewShell->Unmark();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ALIGNCURSOR:
//STRIP001 			pTabViewShell->AlignToCursor( GetViewData()->GetCurX(), GetViewData()->GetCurY(), SC_FOLLOW_JUMP );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_MARKDATAAREA:
//STRIP001 			pTabViewShell->MarkDataArea();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_MARKARRAYFORMULA:
//STRIP001 			pTabViewShell->MarkMatrixFormula();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SETINPUTMODE:
//STRIP001 			SC_MOD()->SetInputMode( SC_INPUT_TABLE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_FOCUS_INPUTLINE:
//STRIP001 			{
//STRIP001 				ScInputHandler* pHdl = SC_MOD()->GetInputHdl( pTabViewShell );
//STRIP001 				if (pHdl)
//STRIP001 				{
//STRIP001 					ScInputWindow* pWin = pHdl->GetInputWindow();
//STRIP001 					if (pWin)
//STRIP001 						pWin->SwitchToTextWin();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORTOPOFSCREEN:
//STRIP001 			pTabViewShell->MoveCursorScreen( 0, -1, SC_FOLLOW_LINE, FALSE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORENDOFSCREEN:
//STRIP001 			pTabViewShell->MoveCursorScreen( 0, 1, SC_FOLLOW_LINE, FALSE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ERROR("Unbekannte Message bei ViewShell (Cursor)");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 
//STRIP001 	rReq.Done();
//STRIP001 }

//STRIP001 void ScCellShell::ExecutePageSel( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScTabViewShell*	pTabViewShell  	= GetViewData()->GetViewShell();
//STRIP001 	USHORT				nSlotId  = rReq.GetSlot();
//STRIP001 	switch ( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_CURSORHOME_SEL:		rReq.SetSlot( SID_CURSORHOME );  break;
//STRIP001 		case SID_CURSOREND_SEL:			rReq.SetSlot( SID_CURSOREND );  break;
//STRIP001 		case SID_CURSORTOPOFFILE_SEL:	rReq.SetSlot( SID_CURSORTOPOFFILE );  break;
//STRIP001 		case SID_CURSORENDOFFILE_SEL:	rReq.SetSlot( SID_CURSORENDOFFILE );  break;
//STRIP001 		default:
//STRIP001 			DBG_ERROR("Unbekannte Message bei ViewShell (ExecutePageSel)");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 	rReq.AppendItem( SfxBoolItem(FN_PARAM_2, TRUE) );
//STRIP001 	ExecuteSlot( rReq, GetInterface() );
//STRIP001 }

//STRIP001 void ScCellShell::ExecutePage( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	ScTabViewShell*	pTabViewShell  	= GetViewData()->GetViewShell();
//STRIP001 	const SfxItemSet*	pReqArgs = rReq.GetArgs();
//STRIP001 	USHORT				nSlotId  = rReq.GetSlot();
//STRIP001 	BOOL				bSel = FALSE;
//STRIP001 	BOOL				bKeep = FALSE;
//STRIP001 
//STRIP001 	if ( pReqArgs != NULL )
//STRIP001 	{
//STRIP001 		const	SfxPoolItem* pItem;
//STRIP001 		if( IS_AVAILABLE( FN_PARAM_2, &pItem ) )
//STRIP001 			bSel = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		//	evaluate locked selection mode
//STRIP001 
//STRIP001 		USHORT nLocked = pTabViewShell->GetLockedModifiers();
//STRIP001 		if ( nLocked & KEY_SHIFT )
//STRIP001 			bSel = TRUE;				// EXT
//STRIP001 		else if ( nLocked & KEY_MOD1 )
//STRIP001 		{
//STRIP001 			// ADD mode: keep the selection, start a new block when marking with shift again
//STRIP001 			bKeep = TRUE;
//STRIP001 			pTabViewShell->SetNewStartIfMarking();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	pTabViewShell->ExecuteInputDirect();
//STRIP001 	switch ( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_CURSORHOME:
//STRIP001 			pTabViewShell->MoveCursorEnd( -1, 0, SC_FOLLOW_LINE, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSOREND:
//STRIP001 			pTabViewShell->MoveCursorEnd( 1, 0, SC_FOLLOW_JUMP, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORTOPOFFILE:
//STRIP001 			pTabViewShell->MoveCursorEnd( -1, -1, SC_FOLLOW_LINE, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CURSORENDOFFILE:
//STRIP001 			pTabViewShell->MoveCursorEnd( 1, 1, SC_FOLLOW_JUMP, bSel, bKeep );
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ERROR("Unbekannte Message bei ViewShell (ExecutePage)");
//STRIP001 			return;
//STRIP001 	}
//STRIP001 
//STRIP001 	rReq.AppendItem( SfxBoolItem(FN_PARAM_2, bSel) );
//STRIP001 	rReq.Done();
//STRIP001 }




}
