/*************************************************************************
 *
 *  $RCSfile: sc_spelleng.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:34:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

#include "scitems.hxx"
// auto strip #include <bf_svx/eeitem.hxx>
#define ITEMID_FIELD EE_FEATURE_FIELD

// auto strip #include <bf_svx/langitem.hxx>
// auto strip #include <bf_svx/editobj.hxx>
// auto strip #include <bf_svx/editview.hxx>
// auto strip #include <vcl/msgbox.hxx>
// auto strip #ifndef _SV_SVAPP_HXX
// auto strip #include <vcl/svapp.hxx>
// auto strip #endif

// auto strip #include "spelleng.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "docsh.hxx"
// auto strip #include "cell.hxx"
// auto strip #include "patattr.hxx"
// auto strip #include "waitoff.hxx"
#include "globstr.hrc"
namespace binfilter {


// -----------------------------------------------------------------------

//STRIP001 BOOL lcl_HasString( ScDocument* pDoc, USHORT nCol, USHORT nRow, USHORT nTab,
//STRIP001 					const String& rString )
//STRIP001 {
//STRIP001 	String aCompStr;
//STRIP001 	pDoc->GetString( nCol, nRow, nTab, aCompStr );
//STRIP001 	return ( aCompStr == rString );		//! case-insensitive?
//STRIP001 }

//STRIP001 BOOL __EXPORT ScSpellingEngine::SpellNextDocument()
//STRIP001 {
//STRIP001 	ScDocShell* pDocSh = pViewData->GetDocShell();
//STRIP001 	ScDocument* pDoc = pDocSh->GetDocument();
//STRIP001 	ScMarkData& rMark = pViewData->GetMarkData();
//STRIP001 	ScTabViewShell* pViewShell = pViewData->GetViewShell();
//STRIP001 	ScSplitPos eWhich = pViewData->GetActivePart();
//STRIP001 	CellType eCellType;
//STRIP001 	ScBaseCell* pCell = NULL;
//STRIP001 	LanguageType eLnge = LANGUAGE_NONE;
//STRIP001 	EditTextObject* pETObject = NULL;
//STRIP001 	const SfxPoolItem* pItem = NULL;
//STRIP001 	SvxLanguageItem* pLangIt = NULL;
//STRIP001 	const ScPatternAttr* pPattern = NULL;
//STRIP001 	const ScPatternAttr* pLastPattern = NULL;
//STRIP001 	SfxItemSet*	pEditDefaults = new SfxItemSet( GetEmptyItemSet() );
//STRIP001 
//STRIP001 	if (IsModified())
//STRIP001 	{
//STRIP001 		bIsModifiedAtAll = TRUE;
//STRIP001 
//STRIP001 		String aNewStr = GetText();
//STRIP001 
//STRIP001 		BOOL bMultiTab = ( rMark.GetSelectCount() > 1 );
//STRIP001 		String aVisibleStr;
//STRIP001 		if (bMultiTab)
//STRIP001 			pDoc->GetString( nOldCol, nOldRow, nOrgTab, aVisibleStr );
//STRIP001 
//STRIP001 		USHORT nTabCount = pDoc->GetTableCount();
//STRIP001 		for ( USHORT nTab=0; nTab<nTabCount; nTab++ )
//STRIP001 		{
//STRIP001 			//	#69965# always change the cell on the visible tab,
//STRIP001 			//	on the other selected tabs only if they contain the same text
//STRIP001 
//STRIP001 			if ( nTab == nOrgTab || ( bMultiTab && rMark.GetTableSelect(nTab) &&
//STRIP001 									lcl_HasString( pDoc, nOldCol, nOldRow, nTab, aVisibleStr ) ) )
//STRIP001 			{
//STRIP001 				pDoc->GetCellType(nOldCol, nOldRow, nTab, eCellType);
//STRIP001 				pDoc->GetCell(nOldCol, nOldRow, nTab, pCell);
//STRIP001 				if (pUndoDoc && pCell)
//STRIP001 				{
//STRIP001 					ScBaseCell* pUndoCell = pCell->Clone(pUndoDoc);
//STRIP001 					pUndoDoc->PutCell(nOldCol, nOldRow, nTab, pUndoCell);
//STRIP001 				}
//STRIP001 				if (eCellType == CELLTYPE_EDIT)
//STRIP001 				{
//STRIP001 					if (pCell)
//STRIP001 					{
//STRIP001 						pETObject = CreateTextObject();
//STRIP001 						((ScEditCell*) pCell)->SetData( pETObject, GetEditTextObjectPool() );
//STRIP001 						delete pETObject;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					pDoc->SetString(nOldCol, nOldRow, nTab, aNewStr);
//STRIP001 					pDoc->GetCell(nOldCol, nOldRow, nTab, pCell);
//STRIP001 				}
//STRIP001 				if (pRedoDoc && pCell)
//STRIP001 				{
//STRIP001 					ScBaseCell* pRedoCell = pCell->Clone(pRedoDoc);
//STRIP001 					pRedoDoc->PutCell(nOldCol, nOldRow, nTab, pRedoCell);
//STRIP001 				}
//STRIP001 				pDocSh->PostPaintCell(nOldCol, nOldRow, nTab);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	pCell = NULL;
//STRIP001 	USHORT nCol, nRow;
//STRIP001 	BOOL bStop = FALSE;
//STRIP001 	BOOL bNext;
//STRIP001 	nCol = nOldCol;
//STRIP001 	if (bFirstTime)
//STRIP001 	{
//STRIP001 		bFirstTime = FALSE;
//STRIP001 		if (nOldCol == nOrgCol && nOldRow == nOrgRow)	// das erste Mal
//STRIP001 			nRow = nOldRow-1;
//STRIP001 		else
//STRIP001 			nRow = nOldRow;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nRow = nOldRow;
//STRIP001 	while (!bStop)
//STRIP001 	{
//STRIP001 		bNext = pDoc->GetNextSpellingCell(nCol, nRow, nOrgTab, bInSel, rMark);
//STRIP001 		if (bNext)
//STRIP001 		{
//STRIP001 			if (!bFirstTable &&
//STRIP001 				 (nCol > nOrgCol || (nCol == nOrgCol && nRow >= nOrgRow)))
//STRIP001 			{
//STRIP001 				pDoc->GetCellType(nOldCol, nOldRow, nOrgTab, eCellType);
//STRIP001 				if (eCellType == CELLTYPE_STRING)
//STRIP001 				{
//STRIP001 					String sOldText;
//STRIP001 					pDoc->GetString(nOldCol, nOldRow, nOrgTab, sOldText);
//STRIP001 					SetText(sOldText);
//STRIP001 				}
//STRIP001 				else if (eCellType == CELLTYPE_EDIT)
//STRIP001 				{
//STRIP001 					pDoc->GetCell(nOldCol, nOldRow, nOrgTab, pCell);
//STRIP001 					if (pCell)
//STRIP001 					{
//STRIP001 						const EditTextObject* pNewTObj = NULL;
//STRIP001 						((ScEditCell*) pCell)->GetData(pNewTObj);
//STRIP001 						if (pNewTObj)
//STRIP001 							SetText(*pNewTObj);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 					SetText(EMPTY_STRING);
//STRIP001 
//STRIP001 				{	// own scope for WaitCursorOff
//STRIP001 					ScWaitCursorOff aWaitOff( pDocSh->GetDialogParent() );
//STRIP001 					InfoBox aBox( pViewData->GetDialogParent(),
//STRIP001 						ScGlobal::GetRscString(STR_SPELLING_STOP_OK));
//STRIP001 					aBox.Execute();
//STRIP001 				}
//STRIP001 				return FALSE;
//STRIP001 			}
//STRIP001 			else if ( nCol == MAXCOL+1 )
//STRIP001 			{
//STRIP001 				if ( nOrgCol == 0 && nOrgRow == 0 )
//STRIP001 				{
//STRIP001 					pDoc->GetCellType(nOldCol, nOldRow, nOrgTab, eCellType);
//STRIP001 					if (eCellType == CELLTYPE_STRING)
//STRIP001 					{
//STRIP001 						String sOldText;
//STRIP001 						pDoc->GetString(nOldCol, nOldRow, nOrgTab, sOldText);
//STRIP001 						SetText(sOldText);
//STRIP001 					}
//STRIP001 					else if (eCellType == CELLTYPE_EDIT)
//STRIP001 					{
//STRIP001 						pDoc->GetCell(nOldCol, nOldRow, nOrgTab, pCell);
//STRIP001 						if (pCell)
//STRIP001 						{
//STRIP001 							const EditTextObject* pNewTObj = NULL;
//STRIP001 							((ScEditCell*) pCell)->GetData(pNewTObj);
//STRIP001 							if (pNewTObj)
//STRIP001 								SetText(*pNewTObj);
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 						SetText(EMPTY_STRING);
//STRIP001 
//STRIP001 					{	// own scope for WaitCursorOff
//STRIP001 						ScWaitCursorOff aWaitOff( pDocSh->GetDialogParent() );
//STRIP001 						InfoBox aBox( pViewData->GetDialogParent(),
//STRIP001 							ScGlobal::GetRscString(STR_SPELLING_STOP_OK));
//STRIP001 						aBox.Execute();
//STRIP001 					}
//STRIP001 
//STRIP001 					return FALSE;
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 										// zuerst auf letzte Zelle zuruecksetzen
//STRIP001 										// fuer Paint
//STRIP001 					pDoc->GetCellType(nOldCol, nOldRow, nOrgTab, eCellType);
//STRIP001 					if (eCellType == CELLTYPE_STRING)
//STRIP001 					{
//STRIP001 						String sOldText;
//STRIP001 						pDoc->GetString(nOldCol, nOldRow, nOrgTab, sOldText);
//STRIP001 						SetText(sOldText);
//STRIP001 					}
//STRIP001 					else if (eCellType == CELLTYPE_EDIT)
//STRIP001 					{
//STRIP001 						pDoc->GetCell(nOldCol, nOldRow, nOrgTab, pCell);
//STRIP001 						if (pCell)
//STRIP001 						{
//STRIP001 							const EditTextObject* pNewTObj = NULL;
//STRIP001 							((ScEditCell*) pCell)->GetData(pNewTObj);
//STRIP001 							if (pNewTObj)
//STRIP001 								SetText(*pNewTObj);
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 						SetText(EMPTY_STRING);
//STRIP001 
//STRIP001 					short nRet;
//STRIP001 					{	// own scope for WaitCursorOff
//STRIP001 						ScWaitCursorOff aWaitOff( pDocSh->GetDialogParent() );
//STRIP001 						nRet = MessBox( pViewData->GetDialogParent(),
//STRIP001 							WinBits(WB_YES_NO | WB_DEF_YES),
//STRIP001 							ScGlobal::GetRscString( STR_MSSG_DOSUBTOTALS_0 ),		// "StarCalc"
//STRIP001 							ScGlobal::GetRscString( STR_SPELLING_BEGIN_TAB) )	 	// Fortsetzen?
//STRIP001 								   	.Execute();
//STRIP001 					}
//STRIP001 					if (nRet == RET_YES)
//STRIP001 					{
//STRIP001 						nRow = MAXROW+2;
//STRIP001 						bFirstTable = FALSE;
//STRIP001 					}
//STRIP001 					else
//STRIP001 						return FALSE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else					// Stringzelle mit Inhalt
//STRIP001 			{
//STRIP001 				pPattern = pDoc->GetPattern(nCol, nRow, nOrgTab);
//STRIP001 				if (pPattern && pPattern != pLastPattern)
//STRIP001 				{
//STRIP001 					pPattern->FillEditItemSet( pEditDefaults );
//STRIP001 					SetDefaults( *pEditDefaults );
//STRIP001 					pLastPattern = pPattern;
//STRIP001 				}
//STRIP001 				pItem = pDoc->GetAttr(nCol, nRow, nOrgTab, ATTR_FONT_LANGUAGE);
//STRIP001 				pLangIt = PTR_CAST( SvxLanguageItem, pItem );
//STRIP001 				if (pLangIt)
//STRIP001 				{
//STRIP001 					eLnge = (LanguageType) pLangIt->GetValue();
//STRIP001 					if ( eLnge == LANGUAGE_SYSTEM )
//STRIP001                         eLnge = Application::GetSettings().GetLanguage();   // never use SYSTEM for spelling
//STRIP001 					if (eLnge != eOldLnge)
//STRIP001 					{
//STRIP001 						eOldLnge = eLnge;
//STRIP001 						SetDefaultLanguage( eLnge );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				pDoc->GetCellType(nCol, nRow, nOrgTab, eCellType);
//STRIP001 				if (eCellType == CELLTYPE_STRING)
//STRIP001 				{
//STRIP001 					String sOldText;
//STRIP001 					pDoc->GetString(nCol, nRow, nOrgTab, sOldText);
//STRIP001 					SetText(sOldText);
//STRIP001 				}
//STRIP001 				else if (eCellType == CELLTYPE_EDIT)
//STRIP001 				{
//STRIP001 					pDoc->GetCell(nCol, nRow, nOrgTab, pCell);
//STRIP001 					if (pCell)
//STRIP001 					{
//STRIP001 						const EditTextObject* pNewTObj = NULL;
//STRIP001 						((ScEditCell*) pCell)->GetData(pNewTObj);
//STRIP001 						if (pNewTObj)
//STRIP001 							SetText(*pNewTObj);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 					SetText(EMPTY_STRING);
//STRIP001 				if (HasSpellErrors())
//STRIP001 					bStop = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 			return FALSE;
//STRIP001 	}
//STRIP001 	pViewShell->AlignToCursor( nCol, nRow, SC_FOLLOW_JUMP );
//STRIP001 	pViewShell->SetCursor( nCol, nRow, TRUE );
//STRIP001 	pViewData->GetView()->MakeEditView(this, nCol, nRow );
//STRIP001 	EditView* pEditView = pViewData->GetSpellingView();
//STRIP001 	if (pEditSel)									// hoechstens beim ersten Mal
//STRIP001 	{
//STRIP001 		pEditView->SetSelection(*pEditSel);
//STRIP001 		pEditSel = NULL;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		pEditView->SetSelection(ESelection(0,0,0,0));
//STRIP001 	ClearModifyFlag();
//STRIP001 	nOldCol = nCol;
//STRIP001 	nOldRow = nRow;
//STRIP001 	delete pEditDefaults;
//STRIP001 	return TRUE;
//STRIP001 }




}
