/*************************************************************************
 *
 *  $RCSfile: sch_lightfac.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:47:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "lightfac.hxx"
// auto strip #include "glob.hxx"
namespace binfilter {



/*************************************************************************
|*
|* Licht-Faktor ermitteln
|*
\************************************************************************/

//STRIP001 SchLightFactor* GetLightFactor(const SdrObject& rObj)
//STRIP001 {
//STRIP001 	for (USHORT i = 0; i < rObj.GetUserDataCount(); i++)
//STRIP001 	{
//STRIP001 		SdrObjUserData *pData = rObj.GetUserData(i);
//STRIP001 		if (pData && pData->GetId() == SCH_LIGHTFACTOR_ID)
//STRIP001 			return (SchLightFactor*)pData;
//STRIP001 	}
//STRIP001 
//STRIP001 	return NULL;
//STRIP001 }

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchLightFactor::SchLightFactor() :
//STRIP001 	SdrObjUserData(SchInventor, SCH_LIGHTFACTOR_ID, 0),
//STRIP001 	fFactor(0.0)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchLightFactor::SchLightFactor(double fFac) :
//STRIP001 	SdrObjUserData(SchInventor, SCH_LIGHTFACTOR_ID, 0),
//STRIP001 	fFactor(fFac)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Kopier-Konstruktor
|*
\************************************************************************/

//STRIP001 SchLightFactor::SchLightFactor(const SchLightFactor& rLightFactor) :
//STRIP001 	SdrObjUserData(rLightFactor),
//STRIP001 	fFactor(rLightFactor.fFactor)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Kopie erzeugen
|*
\************************************************************************/

//STRIP001 SdrObjUserData* SchLightFactor::Clone(SdrObject *pObj) const
//STRIP001 {
//STRIP001 	return new SchLightFactor(*this);
//STRIP001 }

/*************************************************************************
|*
|* Daten in Stream schreiben
|*
\************************************************************************/

//STRIP001 void SchLightFactor::WriteData(SvStream& rOut)
//STRIP001 {
//STRIP001 	SdrObjUserData::WriteData(rOut);
//STRIP001 
//STRIP001 	rOut << fFactor;
//STRIP001 }

/*************************************************************************
|*
|* Daten aus Stream lesen
|*
\************************************************************************/

//STRIP001 void SchLightFactor::ReadData(SvStream& rIn)
//STRIP001 {
//STRIP001 	SdrObjUserData::ReadData(rIn);
//STRIP001 
//STRIP001 	rIn >> fFactor;
//STRIP001 }



}
