/*************************************************************************
 *
 *  $RCSfile: sch_tpscaley.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma optimize("",off)


#pragma hdrstop

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

// header for class Table
#ifndef _TOOLS_TABLE_HXX
#include <tools/table.hxx>
#endif
// header for class SvNumberformat
#ifndef _ZFORMAT_HXX
#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zformat.hxx>
#endif
// header for SvNumberFormatter
#ifndef _ZFORLIST_HXX
#include <svtools/zforlist.hxx>
#endif

#include "schattr.hxx"
#define ITEMID_DOUBLE	0
#ifndef _SVX_CHRTITEM_HXX //autogen
#include <bf_svx/chrtitem.hxx>
#endif

#include "schresid.hxx"
#include "strings.hrc"
#include "chtmodel.hxx"
#include "attrib.hxx"
#include "tpscaley.hxx"
#include "tpscaley.hrc"

#include "chaxis.hxx"

#include <rtl/math.hxx>
namespace binfilter {

/*************************************************************************
|*
|* Dialog zur Ausrichtung der Legende
|*
\************************************************************************/

//STRIP001 SchScaleYAxisTabPage::SchScaleYAxisTabPage(Window* pWindow,const SfxItemSet& rInAttrs) :
//STRIP001 	SfxTabPage(pWindow, SchResId(TP_SCALE_Y), rInAttrs),
//STRIP001 
//STRIP001 	pMyModel (0),
//STRIP001 	aFlScale(this, ResId(FL_SCALE_Y)),
//STRIP001 	aTxtMin (this, ResId (TXT_MIN)),
//STRIP001 	aFmtFldMin(this, ResId(EDT_MIN)),
//STRIP001 	aCbxAutoMin(this, ResId(CBX_AUTO_MIN)),
//STRIP001 	aTxtMax(this, ResId (TXT_MAX)),
//STRIP001 	aFmtFldMax(this, ResId(EDT_MAX)),
//STRIP001 	aCbxAutoMax(this, ResId(CBX_AUTO_MAX)),
//STRIP001 	aTxtMain (this, ResId (TXT_STEP_MAIN)),
//STRIP001 	aFmtFldStepMain(this, ResId(EDT_STEP_MAIN)),
//STRIP001 	aCbxAutoStepMain(this, ResId(CBX_AUTO_STEP_MAIN)),
//STRIP001 	aTxtHelp (this, ResId (TXT_STEP_HELP)),
//STRIP001 	aFmtFldStepHelp(this, ResId(EDT_STEP_HELP)),
//STRIP001 	aCbxAutoStepHelp(this, ResId(CBX_AUTO_STEP_HELP)),
//STRIP001 	aTxtOrigin (this, ResId (TXT_ORIGIN)),
//STRIP001 	aFmtFldOrigin(this, ResId(EDT_ORIGIN)),
//STRIP001 	aCbxAutoOrigin(this, ResId(CBX_AUTO_ORIGIN)),
//STRIP001 	aCbxLogarithm(this, ResId(CBX_LOGARITHM)),
//STRIP001 
//STRIP001 	aFlTicks(this,ResId(FL_TICKS)),
//STRIP001 	aCbxTicksInner(this, ResId(CBX_TICKS_INNER)),
//STRIP001 	aCbxTicksOuter(this, ResId(CBX_TICKS_OUTER)),
//STRIP001 
//STRIP001 	aFlHelpTicks(this,ResId(FL_HELPTICKS)),
//STRIP001 	aCbxHelpTicksInner(this, ResId(CBX_HELPTICKS_INNER)),
//STRIP001 	aCbxHelpTicksOuter(this, ResId(CBX_HELPTICKS_OUTER)),
//STRIP001 
//STRIP001 	fMin(0.0),
//STRIP001 	fMax(0.0),
//STRIP001 	fStepMain(0.0),
//STRIP001 	fStepHelp(0.0),
//STRIP001 	fOrigin(0.0),
//STRIP001 	nAxisType(0),
//STRIP001 	aMtStepHelp (this, ResId (MT_STEPHELP)),
//STRIP001 	rOutAttrs(rInAttrs),
//STRIP001 	pNumFormatter(NULL),
//STRIP001 	bLastStepMain(FALSE)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	SetExchangeSupport();
//STRIP001 
//STRIP001 	aCbxAutoMin.SetClickHdl(LINK(this, SchScaleYAxisTabPage, EnableValueHdl));
//STRIP001 	aCbxAutoMax.SetClickHdl(LINK(this, SchScaleYAxisTabPage, EnableValueHdl));
//STRIP001 	aCbxAutoStepMain.SetClickHdl(LINK(this, SchScaleYAxisTabPage, EnableValueHdl));
//STRIP001 	aCbxAutoStepHelp.SetClickHdl(LINK(this, SchScaleYAxisTabPage, EnableValueHdl));
//STRIP001 	aCbxAutoOrigin.SetClickHdl(LINK(this, SchScaleYAxisTabPage, EnableValueHdl));
//STRIP001 	aCbxLogarithm.SetClickHdl(LINK(this, SchScaleYAxisTabPage, HandleLogs));
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXISTYPE, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		nAxisType = (int) ((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 }

/*************************************************************************
|*
|*	Werte-Editierfelder je nach Checkbox-Markierung enablen/disablen
|*
*************************************************************************/

//STRIP001 IMPL_LINK( SchScaleYAxisTabPage, EnableValueHdl, CheckBox *, pCbx )
//STRIP001 {
//STRIP001 	if (pCbx == &aCbxAutoMin)
//STRIP001 	{
//STRIP001 		aFmtFldMin.Enable(!aCbxAutoMin.IsChecked());
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxAutoMax)
//STRIP001 	{
//STRIP001 		aFmtFldMax.Enable(!aCbxAutoMax.IsChecked());
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxAutoStepMain)
//STRIP001 	{
//STRIP001 		aFmtFldStepMain.Enable(!aCbxAutoStepMain.IsChecked());
//STRIP001 		bLastStepMain = aCbxAutoStepMain.IsChecked();
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxAutoStepHelp)
//STRIP001 	{
//STRIP001 		if (aCbxLogarithm.IsChecked ())
//STRIP001 		{
//STRIP001 			aFmtFldStepHelp.Hide ();
//STRIP001 			aMtStepHelp.Show ();
//STRIP001 			aMtStepHelp.Enable(!aCbxAutoStepHelp.IsChecked());
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aFmtFldStepHelp.Show ();
//STRIP001 			aMtStepHelp.Hide ();
//STRIP001 			aFmtFldStepHelp.Enable(!aCbxAutoStepHelp.IsChecked());
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (pCbx == &aCbxAutoOrigin)
//STRIP001 	{
//STRIP001 		aFmtFldOrigin.Enable(!aCbxAutoOrigin.IsChecked());
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/*************************************************************************
|*
|* Erzeugung
|*
\*************************************************************************/

//STRIP001 SfxTabPage* SchScaleYAxisTabPage::Create(Window* pWindow,const SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	return new SchScaleYAxisTabPage(pWindow, rOutAttrs);
//STRIP001 }

/*************************************************************************
|*
|* Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
|*
\*************************************************************************/

//STRIP001 BOOL SchScaleYAxisTabPage::FillItemSet(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	DBG_ASSERT( pNumFormatter, "No NumberFormatter available" );
//STRIP001 
//STRIP001 	long nTicks=0;
//STRIP001 	long nHelpTicks=0;
//STRIP001 
//STRIP001 	if(aCbxHelpTicksInner.IsChecked())
//STRIP001 		nHelpTicks|=CHAXIS_MARK_INNER;
//STRIP001 	if(aCbxHelpTicksOuter.IsChecked())
//STRIP001 		nHelpTicks|=CHAXIS_MARK_OUTER;
//STRIP001 	if(aCbxTicksInner.IsChecked())
//STRIP001 		nTicks|=CHAXIS_MARK_INNER;
//STRIP001 	if(aCbxTicksOuter.IsChecked())
//STRIP001 		nTicks|=CHAXIS_MARK_OUTER;
//STRIP001 
//STRIP001 	rOutAttrs.Put(SfxInt32Item(SCHATTR_AXIS_TICKS,nTicks));
//STRIP001 	rOutAttrs.Put(SfxInt32Item(SCHATTR_AXIS_HELPTICKS,nHelpTicks));
//STRIP001 
//STRIP001 	rOutAttrs.Put(SfxBoolItem(SCHATTR_AXIS_AUTO_MIN		 ,aCbxAutoMin.IsChecked()));
//STRIP001 	rOutAttrs.Put(SfxBoolItem(SCHATTR_AXIS_AUTO_MAX		 ,aCbxAutoMax.IsChecked()));
//STRIP001 	rOutAttrs.Put(SfxBoolItem(SCHATTR_AXIS_AUTO_STEP_HELP,aCbxAutoStepHelp.IsChecked()));
//STRIP001 	rOutAttrs.Put(SfxBoolItem(SCHATTR_AXIS_AUTO_ORIGIN   ,aCbxAutoOrigin.IsChecked()));
//STRIP001 	rOutAttrs.Put(SfxBoolItem(SCHATTR_AXIS_LOGARITHM     ,aCbxLogarithm.IsChecked()));
//STRIP001 	rOutAttrs.Put(SvxDoubleItem(fMax	 , SCHATTR_AXIS_MAX));
//STRIP001 	rOutAttrs.Put(SvxDoubleItem(fMin	 , SCHATTR_AXIS_MIN));
//STRIP001 	rOutAttrs.Put(SvxDoubleItem(fStepHelp, SCHATTR_AXIS_STEP_HELP));
//STRIP001 	rOutAttrs.Put(SvxDoubleItem(fOrigin	 , SCHATTR_AXIS_ORIGIN));
//STRIP001 
//STRIP001 	rOutAttrs.Put(SfxBoolItem(SCHATTR_AXIS_AUTO_STEP_MAIN,aCbxAutoStepMain.IsChecked()));
//STRIP001 	rOutAttrs.Put(SvxDoubleItem(fStepMain,SCHATTR_AXIS_STEP_MAIN));
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

/*************************************************************************
|*
|* Initialisierung
|*
\*************************************************************************/

//STRIP001 void SchScaleYAxisTabPage::Reset(const SfxItemSet& rInAttrs)
//STRIP001 {
//STRIP001 	DBG_ASSERT( pNumFormatter, "No NumberFormatter available" );
//STRIP001 
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	long nTicks=0,nHelpTicks=0;
//STRIP001 	if(rInAttrs.GetItemState(SCHATTR_AXIS_TICKS,TRUE, &pPoolItem)== SFX_ITEM_SET)
//STRIP001 		nTicks=((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 	if(rInAttrs.GetItemState(SCHATTR_AXIS_HELPTICKS,TRUE, &pPoolItem)== SFX_ITEM_SET)
//STRIP001 		nHelpTicks=((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 
//STRIP001 	aCbxHelpTicksInner.Check(nHelpTicks&CHAXIS_MARK_INNER);
//STRIP001 	aCbxHelpTicksOuter.Check(nHelpTicks&CHAXIS_MARK_OUTER);
//STRIP001 	aCbxTicksInner.Check(nTicks&CHAXIS_MARK_INNER);
//STRIP001 	aCbxTicksOuter.Check(nTicks&CHAXIS_MARK_OUTER);
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_AUTO_MIN,TRUE,&pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxAutoMin.Check(((const SfxBoolItem*)pPoolItem)->GetValue());
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_MIN,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		fMin = ((const SvxDoubleItem*)pPoolItem)->GetValue();
//STRIP001 		aFmtFldMin.SetValue( fMin );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_AUTO_MAX,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxAutoMax.Check(((const SfxBoolItem*)pPoolItem)->GetValue());
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_MAX,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		fMax = ((const SvxDoubleItem*)pPoolItem)->GetValue();
//STRIP001 		aFmtFldMax.SetValue( fMax );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_AUTO_STEP_MAIN,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxAutoStepMain.Check(((const SfxBoolItem*)pPoolItem)->GetValue());
//STRIP001 
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_STEP_MAIN,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		fStepMain = ((const SvxDoubleItem*)pPoolItem)->GetValue();
//STRIP001 		aFmtFldStepMain.SetValue( fStepMain );
//STRIP001 	}
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_AUTO_STEP_HELP,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxAutoStepHelp.Check(((const SfxBoolItem*)pPoolItem)->GetValue());
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_LOGARITHM,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxLogarithm.Check(((const SfxBoolItem*)pPoolItem)->GetValue());
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_STEP_HELP,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		fStepHelp = ((const SvxDoubleItem*)pPoolItem)->GetValue();
//STRIP001 		if (aCbxLogarithm.IsChecked ()) aMtStepHelp.SetValue ((long) fStepHelp);
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aFmtFldStepHelp.SetValue( fStepHelp );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_AUTO_ORIGIN,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aCbxAutoOrigin.Check(((const SfxBoolItem*)pPoolItem)->GetValue());
//STRIP001 	if (rInAttrs.GetItemState(SCHATTR_AXIS_ORIGIN,TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		fOrigin = ((const SvxDoubleItem*)pPoolItem)->GetValue();
//STRIP001 		aFmtFldOrigin.SetValue( fOrigin );
//STRIP001 	}
//STRIP001 
//STRIP001 	EnableValueHdl(&aCbxAutoMin);
//STRIP001 	EnableValueHdl(&aCbxAutoMax);
//STRIP001 	EnableValueHdl(&aCbxAutoStepMain);
//STRIP001 	EnableValueHdl(&aCbxAutoStepHelp);
//STRIP001 	EnableValueHdl(&aCbxAutoOrigin);
//STRIP001 	CheckLogControls ();
//STRIP001 }

/*************************************************************************
|*
|* Prueft die eingegebenen Werte
|*
\*************************************************************************/

//STRIP001 int SchScaleYAxisTabPage::DeactivatePage(SfxItemSet* pItemSet)
//STRIP001 {
//STRIP001 	ULONG nIndex = pNumFormatter->GetStandardIndex(LANGUAGE_SYSTEM);
//STRIP001 	Edit* pEdit = NULL;
//STRIP001 	USHORT nErrStrId = 0;
//STRIP001 	double fDummy;
//STRIP001 
//STRIP001 	CheckLogs ();
//STRIP001 	fMax = aFmtFldMax.GetValue();
//STRIP001 	fMin = aFmtFldMin.GetValue();
//STRIP001 	fOrigin = aFmtFldOrigin.GetValue();
//STRIP001 	fStepMain = aFmtFldStepMain.GetValue();
//STRIP001 	fStepHelp = aFmtFldStepHelp.GetValue();
//STRIP001 
//STRIP001 	// check for entries that cannot be parsed for the current number format
//STRIP001 	if ( aFmtFldMin.IsModified()
//STRIP001 		&& !aCbxAutoMin.IsChecked()
//STRIP001 		&& !pNumFormatter->IsNumberFormat(aFmtFldMin.GetText(), nIndex, fDummy))
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldMin;
//STRIP001 		nErrStrId = STR_INVALID_NUMBER;
//STRIP001 	}
//STRIP001 	else if (aFmtFldMax.IsModified() && !aCbxAutoMax.IsChecked() &&
//STRIP001 			 !pNumFormatter->IsNumberFormat(aFmtFldMax.GetText(),
//STRIP001 											nIndex, fDummy))
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldMax;
//STRIP001 		nErrStrId = STR_INVALID_NUMBER;
//STRIP001 	}
//STRIP001 	else if (aFmtFldStepMain.IsModified() && !aCbxAutoStepMain.IsChecked() &&
//STRIP001 			 !pNumFormatter->IsNumberFormat(aFmtFldStepMain.GetText(),
//STRIP001 											nIndex, fDummy))
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldStepMain;
//STRIP001 		nErrStrId = STR_INVALID_NUMBER;
//STRIP001 	}
//STRIP001 	else if (!GetHelpValue ())
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldStepHelp;
//STRIP001 		nErrStrId = STR_INVALID_NUMBER;
//STRIP001 	}
//STRIP001 	else if (aFmtFldOrigin.IsModified() && !aCbxAutoOrigin.IsChecked() &&
//STRIP001 			 !pNumFormatter->IsNumberFormat(aFmtFldOrigin.GetText(),
//STRIP001 											nIndex, fDummy))
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldOrigin;
//STRIP001 		nErrStrId = STR_INVALID_NUMBER;
//STRIP001 	}
//STRIP001 	// check for entries in invalid ranges
//STRIP001 	else if (!aCbxAutoMax.IsChecked() && !aCbxAutoMin.IsChecked() &&
//STRIP001 			 fMin >= fMax)
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldMin;
//STRIP001 		nErrStrId = STR_MINVALUE_LT_MAXVALUE;
//STRIP001 	}
//STRIP001 	else if (!aCbxAutoStepMain.IsChecked() && fStepMain <= 0.0)
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldStepMain;
//STRIP001 		nErrStrId = STR_STEP_GT_ZERO;
//STRIP001 	}
//STRIP001 	else if (!aCbxAutoStepHelp.IsChecked() && fStepHelp <= 0.0)
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldStepMain;
//STRIP001 		nErrStrId = STR_STEP_GT_ZERO;
//STRIP001 	}
//STRIP001 	else if (!aCbxAutoStepMain.IsChecked() && fStepMain > fabs( fMax - fMin ))
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldStepMain;
//STRIP001 		nErrStrId = STR_STEPMAIN_LT_MAXVALUE;
//STRIP001 	}
//STRIP001 	else if (!aCbxLogarithm.IsChecked () && !aCbxAutoStepHelp.IsChecked() && fStepHelp > fStepMain)
//STRIP001 	{
//STRIP001 		pEdit = &aFmtFldStepHelp;
//STRIP001 		nErrStrId = STR_STEPHELP_LT_STEPMAIN;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if(( ! aCbxAutoMin.IsChecked() &&
//STRIP001 			 fOrigin < fMin ) ||
//STRIP001 		   ( ! aCbxAutoMax.IsChecked() &&
//STRIP001 			 fMax < fOrigin ))
//STRIP001 		{
//STRIP001 			nErrStrId = STR_WRONG_ORIGIN;
//STRIP001 
//STRIP001 			if( ! aCbxAutoOrigin.IsChecked ())
//STRIP001 				pEdit = &aFmtFldOrigin;
//STRIP001 			else if( ! aCbxAutoMin.IsChecked())
//STRIP001 				pEdit = &aFmtFldMin;
//STRIP001 			else
//STRIP001 				pEdit = &aFmtFldMax;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nErrStrId )
//STRIP001 	{
//STRIP001 		WarningBox( this, WinBits( WB_OK ), String( SchResId( nErrStrId ))).Execute();
//STRIP001 		if( pEdit )
//STRIP001 		{
//STRIP001 			pEdit->GrabFocus();
//STRIP001 			pEdit->SetSelection( Selection( 0, SELECTION_MAX ));
//STRIP001 		}
//STRIP001 		return KEEP_PAGE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pItemSet )
//STRIP001 		FillItemSet( *pItemSet );
//STRIP001 	return LEAVE_PAGE;
//STRIP001 }

/*************************************************************************
|*
|*	pruefe die eingaben fuer logarithmische werte
|*
*************************************************************************/

//STRIP001 IMPL_LINK( SchScaleYAxisTabPage, HandleLogs, CheckBox *, pCbx )
//STRIP001 {
//STRIP001 	CheckLogs ();
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

/*************************************************************************
|*
|*	pruefe die eingaben fuer logarithmische werte
|*
*************************************************************************/

//STRIP001 void SchScaleYAxisTabPage::CheckLogs ()
//STRIP001 {
//STRIP001 	ULONG  nIndex    = pNumFormatter->GetStandardIndex(LANGUAGE_SYSTEM);
//STRIP001 	Edit   *pEdit    = NULL;
//STRIP001 	USHORT nErrStrId = 0;
//STRIP001 	String aNumStr;
//STRIP001 	Color* pDummy    = NULL;
//STRIP001 	double fDummy;
//STRIP001 
//STRIP001 	CheckLogControls ();
//STRIP001 
//STRIP001 	if (!aCbxAutoMin.IsChecked ())
//STRIP001 	{
//STRIP001 		fMin = aFmtFldMin.GetValue();
//STRIP001 		if (!pNumFormatter->IsNumberFormat(aFmtFldMin.GetText(), nIndex, fDummy))
//STRIP001 		{
//STRIP001 			pEdit = &aFmtFldMin;
//STRIP001 			nErrStrId = STR_INVALID_NUMBER;
//STRIP001 		}
//STRIP001 		else if (aCbxLogarithm.IsChecked ())
//STRIP001 			 {
//STRIP001 				 if (fMin > 1.0)
//STRIP001 				 {
//STRIP001 					 double fVal = 1.0;
//STRIP001 
//STRIP001 					 while (fVal < fMin)
//STRIP001 						 fVal *= 10.0;
//STRIP001 
//STRIP001 					 if (fVal > fMin) fVal /= 10.0;
//STRIP001 					 fMin = fVal;
//STRIP001 				 }
//STRIP001 				 else if (fMin > 0.0)
//STRIP001 					  {
//STRIP001 						  double fVal = 1.0;
//STRIP001 
//STRIP001 						  while (fVal > fMin)
//STRIP001 						  {
//STRIP001 							  fVal /= 10.0;
//STRIP001 							  if(::rtl::math::approxEqual(fVal,fMin))
//STRIP001 								  fMin=fVal; //Double-Ungenauigkeiten (last-bits) ausgleichen
//STRIP001 						  }
//STRIP001 
//STRIP001 						  fMin = fVal;
//STRIP001 					  }
//STRIP001 					  else fMin = 1.0;
//STRIP001 
//STRIP001 				 aFmtFldMin.SetValue( fMin );
//STRIP001 			 }
//STRIP001 	}
//STRIP001 	
//STRIP001 	if (!aCbxAutoMin.IsChecked ())
//STRIP001 	{
//STRIP001 		fMax = aFmtFldMax.GetValue();
//STRIP001 		if( !pNumFormatter->IsNumberFormat(aFmtFldMax.GetText(), nIndex, fDummy))
//STRIP001 		{
//STRIP001 			pEdit = &aFmtFldMax;
//STRIP001 			nErrStrId = STR_INVALID_NUMBER;
//STRIP001 		}
//STRIP001 		else if (aCbxLogarithm.IsChecked ())
//STRIP001 			 {
//STRIP001 				 if (fMax > 1.0)
//STRIP001 				 {
//STRIP001 					 double fVal = 1.0;
//STRIP001 
//STRIP001 					 while (fVal < fMax)
//STRIP001 						 fVal *= 10.0;
//STRIP001 
//STRIP001 					 fMax = fVal;
//STRIP001 				 }
//STRIP001 				 else if (fMax > 0.0)
//STRIP001 					  {
//STRIP001 						  double fVal = 1.0;
//STRIP001 
//STRIP001 						  while (fVal > fMax)
//STRIP001 							  fVal /= 10.0;
//STRIP001 
//STRIP001 						  if (fVal < fMax) fVal *= 10.0;
//STRIP001 						  fMax = fVal;
//STRIP001 					  }
//STRIP001 					  else fMax = 1.0;
//STRIP001 
//STRIP001 				 aFmtFldMax.SetValue( fMax );
//STRIP001 			 }
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bNewOrigin = FALSE;
//STRIP001 
//STRIP001 	if (aCbxAutoOrigin.IsChecked())
//STRIP001 	{
//STRIP001 		if (fMax < 0.0)
//STRIP001 		{
//STRIP001 			fOrigin = fMax;
//STRIP001 			bNewOrigin = TRUE;
//STRIP001 		}
//STRIP001 		if (fMin > 0.0)
//STRIP001 		{
//STRIP001 			fOrigin = fMin;
//STRIP001 			bNewOrigin = TRUE;
//STRIP001 		}
//STRIP001 		if ((fMax >= 0.0) && (fMin <= 0.0))
//STRIP001 		{
//STRIP001 			fOrigin = 0.0;
//STRIP001 			bNewOrigin = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aCbxLogarithm.IsChecked ())
//STRIP001 	{
//STRIP001 		fOrigin = fMin;
//STRIP001 		bNewOrigin = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bNewOrigin )
//STRIP001 	{
//STRIP001         aFmtFldOrigin.SetValue( fOrigin );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nErrStrId)
//STRIP001 	{
//STRIP001 		WarningBox(this, WinBits(WB_OK), String(SchResId(nErrStrId))).Execute();
//STRIP001 		pEdit->GrabFocus();
//STRIP001 		pEdit->SetSelection(Selection(0, SELECTION_MAX));
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|*	pruefe die eingaben fuer logarithmische werte
|*
*************************************************************************/

//STRIP001 void SchScaleYAxisTabPage::CheckLogControls ()
//STRIP001 {
//STRIP001 	double fDummy;
//STRIP001 
//STRIP001 	if (aCbxLogarithm.IsChecked ())
//STRIP001 	{
//STRIP001 		ULONG nIndex = pNumFormatter->GetStandardIndex(LANGUAGE_SYSTEM);
//STRIP001 
//STRIP001 		aFmtFldOrigin.Enable (FALSE);
//STRIP001 		aCbxAutoOrigin.Enable (FALSE);
//STRIP001 		aFmtFldStepMain.Enable (FALSE);
//STRIP001 		bLastStepMain = aCbxAutoStepMain.IsChecked();
//STRIP001 		aCbxAutoStepMain.Check();
//STRIP001 		aCbxAutoStepMain.Enable (FALSE);
//STRIP001 		aFmtFldStepHelp.Enable (FALSE);
//STRIP001 		aFmtFldStepHelp.Hide ();
//STRIP001 		aMtStepHelp.Show ();
//STRIP001 
//STRIP001 		fMin = aFmtFldMin.GetValue();
//STRIP001 		if (pNumFormatter->IsNumberFormat(aFmtFldMin.GetText(), nIndex, fDummy ))
//STRIP001 			if (fMin <= 0.0)
//STRIP001 			{
//STRIP001 				aFmtFldMin.SetValue( 1.0 );
//STRIP001 			}
//STRIP001 
//STRIP001 		aMtStepHelp.Enable (!aCbxAutoStepHelp.IsChecked ());
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aCbxAutoStepMain.Check( bLastStepMain );
//STRIP001 
//STRIP001 		aCbxAutoOrigin.Enable (TRUE);
//STRIP001 		aFmtFldOrigin.Enable (!aCbxAutoOrigin.IsChecked ());
//STRIP001 
//STRIP001 		aCbxAutoStepMain.Enable (TRUE);
//STRIP001 		aFmtFldStepMain.Enable (!aCbxAutoStepMain.IsChecked ());
//STRIP001 
//STRIP001 		aFmtFldStepHelp.Enable (!aCbxAutoStepHelp.IsChecked ());
//STRIP001 
//STRIP001 		aFmtFldStepHelp.Show ();
//STRIP001 		aMtStepHelp.Hide ();
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|*	pruefe die eingaben fuer logarithmische werte
|*
*************************************************************************/

//STRIP001 BOOL SchScaleYAxisTabPage::GetHelpValue ()
//STRIP001 {
//STRIP001 	if (aCbxLogarithm.IsChecked ())
//STRIP001 	{
//STRIP001 		if (!aCbxAutoStepHelp.IsChecked()) fStepHelp = aMtStepHelp.GetValue ();
//STRIP001 
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		ULONG nIndex = pNumFormatter->GetStandardIndex(LANGUAGE_SYSTEM);
//STRIP001 		double fDummy;
//STRIP001 
//STRIP001 		fStepHelp = aFmtFldStepHelp.GetValue();
//STRIP001 		return !(aFmtFldStepHelp.IsModified() && !aCbxAutoStepHelp.IsChecked() &&
//STRIP001 				 !pNumFormatter->IsNumberFormat(aFmtFldStepHelp.GetText(),
//STRIP001 												nIndex, fDummy));
//STRIP001 	}
//STRIP001 }

//STRIP001 void SchScaleYAxisTabPage::SetNumFormatter( SvNumberFormatter* pFormatter )
//STRIP001 {
//STRIP001 	pNumFormatter = pFormatter;
//STRIP001 	aFmtFldMax.SetFormatter( pNumFormatter );
//STRIP001 	aFmtFldMin.SetFormatter( pNumFormatter );
//STRIP001 	aFmtFldStepMain.SetFormatter( pNumFormatter );
//STRIP001 	aFmtFldStepHelp.SetFormatter( pNumFormatter );
//STRIP001 	aFmtFldOrigin.SetFormatter( pNumFormatter );
//STRIP001 	SetNumFormat();
//STRIP001 }

//STRIP001 void SchScaleYAxisTabPage::SetNumFormat()
//STRIP001 {
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	if( rOutAttrs.GetItemState( SCHATTR_AXIS_NUMFMT, TRUE, &pPoolItem ) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		ULONG nFmt = (ULONG)((const SfxInt32Item*)pPoolItem)->GetValue();
//STRIP001 		short eType = pNumFormatter->GetType( nFmt );
//STRIP001 
//STRIP001 		// change nFmt to an editable format (without loss of information)
//STRIP001 		if( eType == NUMBERFORMAT_CURRENCY )	// for currencies just display decimals
//STRIP001 		{
//STRIP001 			nFmt = pNumFormatter->GetStandardIndex();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			const SvNumberformat* pFormat = pNumFormatter->GetEntry( nFmt );
//STRIP001 			if( pFormat )
//STRIP001 			{
//STRIP001 				LanguageType eLanguage = pFormat->GetLanguage();
//STRIP001 				nFmt = pNumFormatter->GetStandardFormat( nFmt, eType, eLanguage );
//STRIP001 			}
//STRIP001 			// else: format is 'standard'
//STRIP001 		}
//STRIP001 
//STRIP001 		aFmtFldMax.SetFormatKey( nFmt );
//STRIP001 		aFmtFldMin.SetFormatKey( nFmt );
//STRIP001 		aFmtFldOrigin.SetFormatKey( nFmt );
//STRIP001 
//STRIP001 		// for steps use standard format if date or time format is chosen
//STRIP001 		if( pNumFormatter &&
//STRIP001 			( eType == NUMBERFORMAT_DATE ||
//STRIP001 			  eType == NUMBERFORMAT_TIME ||
//STRIP001 			  eType == NUMBERFORMAT_DATETIME ) )
//STRIP001 		{
//STRIP001 			nFmt = pNumFormatter->GetStandardIndex();
//STRIP001 		}
//STRIP001 
//STRIP001 		aFmtFldStepMain.SetFormatKey( nFmt );
//STRIP001 		aFmtFldStepHelp.SetFormatKey( nFmt );
//STRIP001 	}
//STRIP001 }



}
