/*************************************************************************
 *
 *  $RCSfile: sch_viewshe3.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:26:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ITEMID_COLOR			SID_ATTR_3D_LIGHTCOLOR

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

// auto strip #include "undswap.hxx"

//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
#define _SI_NOSBXCONTROLS
#define _SI_NOOTHERFORMS
#define _SI_NOCONTROL
#define _SI_NOSBXCONTROLS


#pragma hdrstop

#define ITEMID_LRSPACE			EE_PARA_LRSPACE
#define ITEMID_ULSPACE			EE_PARA_ULSPACE

#define ITEMID_SIZE 0
// auto strip #include <bf_svx/sizeitem.hxx>
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif


// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif


#ifndef _SFX_HRC
#include <bf_sfx2/sfx.hrc>
#endif

#include "schattr.hxx"

#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif

// auto strip #ifndef _SVX_CHRTITEM_HXX //autogen
// auto strip #include <bf_svx/chrtitem.hxx>
// auto strip #endif
#ifndef	_SCH_PERSISTENT_OBJECT_POINTER
# include	"SchPersistentObjectPointer.hxx"
#endif

#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
#include "glob.hrc"

// auto strip #include "viewshel.hxx"
// auto strip #include "schview.hxx"
// auto strip #include "fuinstit.hxx"
// auto strip #include "fuinsleg.hxx"
// auto strip #include "fuinsdes.hxx"
// auto strip #include "fuinsaxi.hxx"
// auto strip #include "fudgraut.hxx"
// auto strip #include "fudgrtyp.hxx"
// auto strip #include "futitle.hxx"
// auto strip #include "fulegend.hxx"
// auto strip #include "fuinssts.hxx"
// auto strip #include "fudatrow.hxx"
// auto strip #include "fudgraxi.hxx"
// auto strip #include "fudgrgri.hxx"
// auto strip #include "fudgrare.hxx"
// auto strip #include "fudgrwal.hxx"
// auto strip #include "fufloor.hxx"
// auto strip #include "unscale.hxx"
// auto strip #include "schresid.hxx"
// auto strip #include "futransform.hxx"

// auto strip #include "fubyid.hxx"
namespace binfilter {


//STRIP001 void SchViewShell::FuTemp2(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	ChartModel* pChDoc = &pChView->GetDoc();
//STRIP001 
//STRIP001 	USHORT nSId = rReq.GetSlot();
//STRIP001 	switch( nSId )
//STRIP001 	{
//STRIP001 
//STRIP001 		case SID_DIAGRAM_TITLE_MAIN :
//STRIP001 		case SID_DIAGRAM_TITLE_SUB :
//STRIP001 		case SID_DIAGRAM_TITLE_X :
//STRIP001 		case SID_DIAGRAM_TITLE_Y :
//STRIP001 		case SID_DIAGRAM_TITLE_Z :
//STRIP001 		case SID_DIAGRAM_TITLE_ALL :
//STRIP001 			pFuActual = new SchFuTitle(this, GetWindow(), pChView,
//STRIP001 									   pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_LEGEND:
//STRIP001 			pFuActual = new SchFuLegend(this, GetWindow(), pChView,
//STRIP001 										pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_INSERT_TITLE:
//STRIP001 			pFuActual = new SchFuInsertTitle(this, GetWindow(), pChView,
//STRIP001 											 pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_INSERT_CHART_LEGEND:
//STRIP001 			pFuActual = new SchFuInsertLegend(this, GetWindow(), pChView,
//STRIP001 											  pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_INSERT_DESCRIPTION:
//STRIP001 			pFuActual = new SchFuInsertDataDescr(this, GetWindow(), pChView,
//STRIP001 												 pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_INSERT_AXIS:
//STRIP001 			pFuActual = new SchFuInsertAxis( this, GetWindow(), pChView, pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_INSERT_GRIDS:
//STRIP001 			pFuActual = new SchFuInsertGrid( this, GetWindow(), pChView, pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_INSERT_STATISTICS:
//STRIP001 			pFuActual = new SchFuInsertStatistics(this, GetWindow(), pChView,
//STRIP001 												  pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_AXIS_X:
//STRIP001 		case SID_DIAGRAM_AXIS_Y:
//STRIP001 		case SID_DIAGRAM_AXIS_Z:
//STRIP001 		case SID_DIAGRAM_AXIS_A:
//STRIP001 		case SID_DIAGRAM_AXIS_B:
//STRIP001 		case SID_DIAGRAM_AXIS_C:
//STRIP001 		case SID_DIAGRAM_AXIS_ALL:
//STRIP001 			pFuActual = new SchFuDiagramAxis(this, GetWindow(), pChView,
//STRIP001 											 pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_GRID_X_MAIN:
//STRIP001 		case SID_DIAGRAM_GRID_Y_MAIN:
//STRIP001 		case SID_DIAGRAM_GRID_Z_MAIN:
//STRIP001 		case SID_DIAGRAM_GRID_X_HELP:
//STRIP001 		case SID_DIAGRAM_GRID_Y_HELP:
//STRIP001 		case SID_DIAGRAM_GRID_Z_HELP:
//STRIP001 		case SID_DIAGRAM_GRID_ALL:
//STRIP001 			pFuActual = new SchFuDiagramGrid(this, GetWindow(), pChView,
//STRIP001 											 pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_WALL:
//STRIP001 			pFuActual = new SchFuDiagramWall(this, GetWindow(), pChView,
//STRIP001 											 pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_FLOOR:
//STRIP001 			pFuActual = new SchFuDiagramFloor(this, GetWindow(), pChView,
//STRIP001 											  pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_AREA:
//STRIP001 			pFuActual = new SchFuDiagramArea(this, GetWindow(), pChView,
//STRIP001 											 pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_TYPE:
//STRIP001 			pFuActual = new SchFuDiagramType(this, GetWindow(), pChView,
//STRIP001 											 pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_AUTOFORMAT:
//STRIP001 			pFuActual = new SchFuDiagramAutoPilot(this, GetWindow(), pChView,
//STRIP001 												  pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SCALE_TEXT:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldScale = pChDoc->TextScalability ();
//STRIP001 			BOOL bNewScale = bOldScale;
//STRIP001 
//STRIP001 			SFX_REQUEST_ARG( rReq, pScaleItem, SfxBoolItem, SID_SCALE_TEXT, FALSE );
//STRIP001 
//STRIP001 			if( pScaleItem ) bNewScale = pScaleItem->GetValue();
//STRIP001 			else bNewScale = !bOldScale;
//STRIP001 
//STRIP001 			pChDoc->TextScalability () = bNewScale;
//STRIP001 
//STRIP001 			SchUndoScale* pUndo = new SchUndoScale(*pChDoc, bOldScale, bNewScale);
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_SCALE)));
//STRIP001 			GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			if( pScaleItem ) rReq.AppendItem( SfxBoolItem( SID_SCALE_TEXT, bNewScale ) );
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case SID_ROW_MOREFRONT:
//STRIP001 			{
//STRIP001 				long nRow=pChView->GetSelectedRow();
//STRIP001 				if(nRow!=-1)
//STRIP001 				{
//STRIP001 				 if(pChDoc->MoveRow(nRow,TRUE))
//STRIP001 				 {
//STRIP001 					SchUndoSwapRow *pUndo = new SchUndoSwapRow(*pChDoc,nRow-1);
//STRIP001 					pUndo->SetComment(String(SchResId(STR_UNDO_MOREFRONT)));
//STRIP001 					GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 					pChDoc->BuildChart(FALSE);
//STRIP001 				  
//STRIP001 					//	Re-mark	the data row whose index is now nRow-1.
//STRIP001 					pChView->MarkObj (pChView->GetDoc().GetDataRowGroup(nRow-1),
//STRIP001 						pChView->GetPageViewPvNum (0));
//STRIP001 				 }
//STRIP001 				}
//STRIP001 				else
//STRIP001 					DBG_ERROR("Selection Lost:SID_ROW_MOREFRONT, Chart");
//STRIP001 				Cancel();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case SID_ROW_MOREBACK:
//STRIP001 			{
//STRIP001 				long nRow=pChView->GetSelectedRow();
//STRIP001 				if(nRow!=-1)
//STRIP001 				{
//STRIP001 				 if( pChDoc->MoveRow(nRow,FALSE))
//STRIP001 				 {
//STRIP001 					SchUndoSwapRow *pUndo = new SchUndoSwapRow(*pChDoc,nRow);
//STRIP001 					pUndo->SetComment(String(SchResId(STR_UNDO_MOREBACK)));
//STRIP001 					GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 					pChDoc->BuildChart(FALSE);
//STRIP001 					
//STRIP001 					//	Re-mark	the data row whose index is now nRow+1.
//STRIP001 					pChView->MarkObj (pChView->GetDoc().GetDataRowGroup(nRow+1),
//STRIP001 						pChView->GetPageViewPvNum (0));
//STRIP001 				 }
//STRIP001 				}
//STRIP001 				else
//STRIP001 					DBG_ERROR("Selection Lost:SID_ROW_MOREBACK, Chart");
//STRIP001 				Cancel();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_STOCK_LOSS:
//STRIP001 			pFuActual = new SchFuById(this, GetWindow(), pChView,pChDoc, rReq,CHOBJID_DIAGRAM_STOCKLOSS_GROUP);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 		case SID_DIAGRAM_STOCK_PLUS:
//STRIP001 			pFuActual = new SchFuById(this, GetWindow(), pChView,pChDoc, rReq,CHOBJID_DIAGRAM_STOCKPLUS_GROUP);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001         // transform dialog: set position/size/rotation
//STRIP001         case SID_ATTR_TRANSFORM:
//STRIP001 			pFuActual = new SchFuTransform( this, GetWindow(), pChView, pChDoc, rReq );
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001             break;
//STRIP001             
//STRIP001 		default:
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }


}
