/*************************************************************************
 *
 *  $RCSfile: sch_viewshe4.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:26:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #ifndef _SVX_F3DCHILD_HXX //autogen
// auto strip #include <bf_svx/f3dchild.hxx>
// auto strip #endif

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_F3DCHILD_HXX //autogen
// auto strip #include <bf_svx/f3dchild.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PRINTER_HXX 
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_FLOAT3D_HXX
// auto strip #include <bf_svx/float3d.hxx>
// auto strip #endif


#define _SI_NOSBXCONTROLS
#define _SI_NOOTHERFORMS
#define _SI_NOCONTROL
#define _SI_NOSBXCONTROLS
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOVIEWMARKER
#define _SDR_NODRAGMETHODS
#define _SDR_NOUNDO
#define _SDR_NOXOUTDEV


#pragma hdrstop

#define ITEMID_LRSPACE			EE_PARA_LRSPACE
#define ITEMID_ULSPACE			EE_PARA_ULSPACE

#define ITEMID_SIZE 0

// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_FLOAT3D_HXX
// auto strip #include <bf_svx/float3d.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_F3DCHILD_HXX
// auto strip #include <bf_svx/f3dchild.hxx>
// auto strip #endif

#ifndef _CLIPLISTENER_HXX
#include <svtools/cliplistener.hxx>
#endif


#define _SI_NOSBXCONTROLS
#define _SI_NOOTHERFORMS
#define _SI_NOCONTROL
#define _SI_NOSBXCONTROLS
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
#define _SDR_NOVIEWMARKER
#define _SDR_NODRAGMETHODS
#define _SDR_NOUNDO
#define _SDR_NOXOUTDEV


#pragma hdrstop

#define ITEMID_LRSPACE			EE_PARA_LRSPACE
#define ITEMID_ULSPACE			EE_PARA_ULSPACE

#define ITEMID_SIZE 0

//sfxcore.hxx

#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _VIEWFAC_HXX //autogen
// auto strip #include <bf_sfx2/viewfac.hxx>
// auto strip #endif

// auto strip #include <bf_svx/sizeitem.hxx>

#ifndef _SFX_HRC
#include <bf_sfx2/sfx.hrc>
#endif
//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------
#include <svtools/style.hrc>
#include <bf_svx/dialogs.hrc>

#ifndef _SVX_F3DCHILD_HXX //autogen
#include <bf_svx/f3dchild.hxx>
#endif

#include "chwindow.hxx"
#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS

#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
#include "glob.hrc"
#include "schview.hxx"
#include "schresid.hxx"

#define _SBX_HXX 0
#include "viewshel.hxx"
#include "fusel.hxx"
// auto strip #include "dgrdata.hxx"
#include "schhids.h"

// auto strip #ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
// auto strip #include <com/sun/star/awt/XWindow.hpp>
// auto strip #endif

#include "ChXChartView.hxx"


/*************************************************************************
|*
|* SFX-Slotmap und Standardinterface deklarieren
|*
\************************************************************************/

#define SchViewShell
namespace binfilter {
#include "schslots.hxx"

/*N*/ SFX_IMPL_INTERFACE( SchViewShell, SfxViewShell, SchResId( STR_CHARTVIEWSHELL ))
/*N*/ // from macro: void SchViewShell::InitInterface_Impl()
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_TOOLS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_FULLSCREEN | SFX_VISIBILITY_SERVER,
/*N*/ 								SchResId( RID_DRAW_TOOLBOX ));
//STRIP001 /*?*/ 	SFX_FEATURED_CHILDWINDOW_REGISTRATION( SchDiagramDataWrapper::GetChildWindowId(), SCH_UI_FEATURE_OWN_DATA );
/*N*/ 	SFX_FEATURED_CHILDWINDOW_REGISTRATION( Svx3DChildWindow::GetChildWindowId(), SCH_UI_FEATURE_THREE_D );
/*N*/ }

/*N*/ SFX_IMPL_VIEWFACTORY(SchViewShell, SchResId(STR_DEFAULTVIEW))
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION(SchChartDocShell);
/*N*/ }

/*N*/ TYPEINIT1(SchViewShell, SfxViewShell);

/*************************************************************************
|*
|* gemeinsamer Initialiserungsanteil der beiden Konstruktoren
|*
\************************************************************************/

/*N*/ void SchViewShell::Construct(SchChartDocShell& rDocSh)
/*N*/ {
/*N*/ 	bUserKnowsTranslation=FALSE;
/*N*/ 	// Hilfe-ID setzen
/*N*/ 	SetHelpId( HID_SCH_VIEWSHELL_DOCUMENT );
/*N*/ 
/*N*/ 	bRepaintPossible = TRUE;
/*N*/ 	bFirstStart      = TRUE;
/*N*/ 
/*N*/     OutputDevice * pOutDev = GetWindow();
/*N*/ 	pChView          = new SchView(&rDocSh, pOutDev, this);
/*N*/ 
/*N*/ 	// Muss Namen haben, damit Basic ueber OLE funktioniert
/*N*/ 	SetName( String( RTL_CONSTASCII_USTRINGPARAM( "View" )));
/*N*/ 
/*N*/ 	SetPool(&rDocSh.GetDoc().GetPool());
/*N*/ 	SetUndoManager(rDocSh.GetUndoManager());
/*N*/ 	SetRepeatTarget(pChView);
/*N*/ 
/*N*/ 	// Initialisierungen der Zeichen-(Bildschirm-)Attribute
/*N*/ 	pChView->SetGridCoarse(Size(1000, 1000));
/*N*/ 	pChView->SetSnapGrid(Size(1000, 1000));
/*N*/ 	pChView->SetGridVisible(FALSE);
/*N*/ 	pChView->SetGridSnap(FALSE);
/*N*/ 	pChView->SetDragStripes(FALSE);
/*N*/ 	pChView->SetFrameDragSingles(TRUE);
/*N*/ 	pChView->SetNoDragXorPolys(TRUE);
/*N*/ 
/*N*/ 	SetZoom(100);
/*N*/ 	pChView->ShowPagePgNum(0, Point(0, 0));
/*N*/ 
/*N*/ 	// Darstellung von Gruppierungen disablen, dies ist
/*N*/ 	// im Chart nicht erwuenscht...
/*N*/ 	pChView->SetVisualizeEnteredGroup(FALSE);
/*N*/ 
/*N*/ 	// Selektionsfunktion starten
/*N*/ //	SfxRequest aReq(SID_TOOL_SELECT, pChView->GetDoc().GetItemPool());
/*N*/ 	SfxRequest aReq(SID_TOOL_SELECT, 0, pChView->GetDoc().GetItemPool());
/*N*/ 	FuPermanent(aReq);
/*N*/ 
/*N*/     // #109912# Transfer Arabic/Hindi Cipher setting from RefDevice to Window
/*N*/     if( pOutDev )
/*N*/     {
/*?*/         OutputDevice * pRefDev = rDocSh.GetRefDevice();
/*?*/         if( pRefDev )
/*?*/         {
/*?*/             pOutDev->SetDigitLanguage( pRefDev->GetDigitLanguage() );
/*?*/         }
/*?*/         else
/*?*/         {
/*?*/             DBG_ERROR( "No RefDevice" );
/*?*/         }
/*N*/     }
/*N*/     else
/*N*/     {
/*N*/         DBG_ERROR( "Invalid Window" );
/*N*/     }
/*N*/ 
/*N*/     // remember the UNO Controller
/*N*/     mpUNOController = new ChXChartView( this );
/*N*/ 
/*N*/ 	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow > aTmpRef;
/*N*/ 	GetViewFrame()->GetFrame()->GetFrameInterface()->setComponent( aTmpRef, mpUNOController );
/*N*/ 
/*N*/     pChView->SetSolidMarkHdl( TRUE );
/*N*/     StartListening( rDocSh );
/*N*/ }

/*************************************************************************
|*
|* Standard-Konstruktor
|*
\************************************************************************/

//STRIP001 SchViewShell::SchViewShell(SfxViewFrame* pFrame, Window* pParent) :
//STRIP001 	SfxViewShell(pFrame, SFX_VIEW_MAXIMIZE_FIRST |
//STRIP001 						 SFX_VIEW_OPTIMIZE_EACH |
//STRIP001 						 SFX_VIEW_OBJECTSIZE_EMBEDDED |
//STRIP001 						 SFX_VIEW_DISABLE_ACCELS |
//STRIP001 						 SFX_VIEW_CAN_PRINT),
//STRIP001 	pFuActual(NULL),
//STRIP001 	pFuOld(NULL),
//STRIP001 	nCurrentObjectBar(0),
//STRIP001 	bObjectBarSwitchEnabled(TRUE),
//STRIP001 	pTempFuActual(NULL),
//STRIP001 	pDocSh( (SchChartDocShell*) GetViewFrame()->GetObjectShell() ),
//STRIP001 	mpClipEvtLstnr(NULL),
//STRIP001     mp3DFlyerReference(NULL),
//STRIP001 	mbPastePossible(FALSE),
//STRIP001     mbTextPastePossible(FALSE),
//STRIP001     mpUNOController( NULL ),
//STRIP001     mbBroadcastSelectionChanges( sal_True ),
//STRIP001     mbPendingSelectionChange( sal_False )
//STRIP001 {
//STRIP001 	SchWindow* pWin = new SchWindow(&pFrame->GetWindow());
//STRIP001 	SetWindow(pWin);
//STRIP001 	pWin->SetViewShell(this);
//STRIP001 
//STRIP001 	Construct(*(SchChartDocShell*)pFrame->GetObjectShell());
//STRIP001 }

/*************************************************************************
|*
|* Standard-Konstruktor (2)
|*
\************************************************************************/

/*N*/ SchViewShell::SchViewShell(SfxViewFrame* pFrame,
/*N*/ 						   SfxViewShell* pOldShell) :
/*N*/ 	SfxViewShell(pFrame, SFX_VIEW_MAXIMIZE_FIRST |
/*N*/ 						 SFX_VIEW_OPTIMIZE_EACH |
/*N*/ 						 SFX_VIEW_OBJECTSIZE_EMBEDDED |
/*N*/ 						 SFX_VIEW_DISABLE_ACCELS |
/*N*/ 						 SFX_VIEW_CAN_PRINT),
/*N*/ 	pFuActual(NULL),
/*N*/ 	pFuOld(NULL),
/*N*/ 	nCurrentObjectBar(0),
/*N*/ 	bObjectBarSwitchEnabled(TRUE),
/*N*/ 	pTempFuActual(NULL),
/*N*/ 	pDocSh( (SchChartDocShell*) GetViewFrame()->GetObjectShell() ),
/*N*/ 	mpClipEvtLstnr(NULL),
/*N*/     mp3DFlyerReference(NULL),
/*N*/ 	mbPastePossible(FALSE),
/*N*/     mbTextPastePossible(FALSE),
/*N*/     mpUNOController( NULL ),
/*N*/     mbBroadcastSelectionChanges( sal_True ),
/*N*/     mbPendingSelectionChange( sal_False )
/*N*/ {
/*N*/ 	SchWindow* pWin = new SchWindow(&pFrame->GetWindow());
/*N*/ 	SetWindow(pWin);
/*N*/ 	pWin->SetViewShell(this);
/*N*/ 
/*N*/ 	Construct(*(SchChartDocShell*)pFrame->GetObjectShell());
/*N*/ }

/*************************************************************************
|*
|* Copy-Konstruktor
|*
\************************************************************************/

//STRIP001 SchViewShell::SchViewShell(SfxViewFrame* pFrame,
//STRIP001 						   const SchViewShell& rShell) :
//STRIP001 	SfxViewShell(pFrame, SFX_VIEW_MAXIMIZE_FIRST |
//STRIP001 						 SFX_VIEW_OPTIMIZE_EACH |
//STRIP001 						 SFX_VIEW_OBJECTSIZE_EMBEDDED |
//STRIP001 						 SFX_VIEW_DISABLE_ACCELS |
//STRIP001 						 SFX_VIEW_CAN_PRINT),
//STRIP001 	pFuActual(NULL),
//STRIP001 	pFuOld(NULL),
//STRIP001 	nCurrentObjectBar(0),
//STRIP001 	bObjectBarSwitchEnabled(TRUE),
//STRIP001 	pTempFuActual(NULL),
//STRIP001 	pDocSh( (SchChartDocShell*) GetViewFrame()->GetObjectShell() ),
//STRIP001 	mpClipEvtLstnr(NULL),
//STRIP001     mp3DFlyerReference(NULL),
//STRIP001 	mbPastePossible(FALSE),
//STRIP001     mbTextPastePossible(FALSE),
//STRIP001     mpUNOController( NULL ),
//STRIP001     mbBroadcastSelectionChanges( sal_True ),
//STRIP001     mbPendingSelectionChange( sal_False )
//STRIP001 {
//STRIP001 	SchWindow* pWin = new SchWindow(&pFrame->GetWindow());
//STRIP001 	SetWindow(pWin);
//STRIP001 	pWin->SetViewShell(this);
//STRIP001 
//STRIP001 	Construct(*(SchChartDocShell*) pFrame->GetObjectShell());
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

/*N*/ SchViewShell::~SchViewShell()
/*N*/ {
/*N*/     if( NULL != pDocSh )
/*N*/         EndListening( *pDocSh );
/*N*/ 
/*N*/     // #96642# Remove references to items within Svx3DWin
/*N*/     // (maybe do a listening sometime in Svx3DWin)
/*N*/     USHORT nId = Svx3DChildWindow::GetChildWindowId();
/*N*/     SfxChildWindow* pWindow = GetViewFrame() ? GetViewFrame()->GetChildWindow(nId) : NULL;
/*N*/     if( pWindow )
/*N*/     {
/*?*/         DBG_BF_ASSERT(0, "STRIP"); //STRIP001 Svx3DWin* p3DWin = static_cast< Svx3DWin* >( pWindow->GetWindow() );
//STRIP001 /*?*/         if( p3DWin )
//STRIP001 /*?*/             p3DWin->DocumentReload();
/*N*/     }
/*N*/ 
/*N*/ 	SwitchObjectBar(0);
/*N*/ 
/*N*/ 	// Umschaltung der ObjectBarShells unterdruecken, sonst versucht die
/*N*/ 	// sterbende Funktion eventuell die ObjectBars zu wechseln. Die
/*N*/ 	// entsprechende Shell ist aber schon vom SFX vom Dispatcher-Stack
/*N*/ 	// genommen worden.
/*N*/ 	bObjectBarSwitchEnabled = FALSE;
/*N*/ 
/*N*/ 	if (pFuActual)
/*N*/ 	{
/*N*/ 		if (pFuOld == pFuActual)
/*N*/ 			pFuOld = NULL;
/*N*/ 
/*N*/ 		pFuActual->Deactivate();
/*N*/ 		delete pFuActual;
/*N*/ 		pFuActual = NULL;
/*N*/ 	}
/*N*/ 
/*N*/ 	if (pFuOld)
/*N*/ 	{
/*?*/ 		delete pFuOld;
/*?*/ 		pFuOld = NULL;
/*N*/ 	}
/*N*/ 
/*N*/     // remove listener for system clipboard
/*N*/ 	if ( mpClipEvtLstnr )
/*N*/ 	{
/*N*/ 		mpClipEvtLstnr->AddRemoveListener( GetWindow(), FALSE );
/*N*/ 		mpClipEvtLstnr->release();
/*N*/ 	}
/*N*/ 
/*N*/ 	delete pChView;
/*N*/ 
/*N*/ 	delete GetWindow();
/*N*/ 	SetWindow( NULL );	// #76782#
/*N*/ 
/*N*/ 	// Shells fuer Object Bars loeschen
/*N*/ 	// vorm Zerstoeren der ObjectBarShells den Dispatcher flushen
/*N*/ 	GetViewFrame()->GetDispatcher()->Flush();
/*N*/ 
/*N*/ 	SfxShell* pObjBarShell = (SfxShell*)aShellTable.First();
/*N*/ 	while (pObjBarShell)
/*N*/ 	{
/*?*/ 		delete pObjBarShell;
/*?*/ 		pObjBarShell = (SfxShell*)aShellTable.Next();
/*N*/ 	}
/*N*/ }

/*************************************************************************
|*
|* Paint-Methode: das Ereignis wird vom Fenster an die Viewshell und
|* die aktuelle Funktion weitergeleitet
|*
\************************************************************************/

//STRIP001 void SchViewShell::Paint(const Rectangle& rRect)
//STRIP001 {
//STRIP001 	SchWindow        *pWin = GetWindow();
//STRIP001 	ChartModel &rDoc = ((SchChartDocShell*)GetViewFrame()->GetObjectShell())->GetDoc();
//STRIP001 
//STRIP001 	if (!rDoc.IsInitialized())
//STRIP001 	{
//STRIP001 		rDoc.Initialize();
//STRIP001 		Invalidate ();
//STRIP001 		pWin->Invalidate ();
//STRIP001 	}
//STRIP001 	else pChView->InitRedraw(pWin, Region(rRect));
//STRIP001 
//STRIP001 	if (pFuActual) pFuActual->Paint(rRect, pWin);
//STRIP001 }

/*************************************************************************
|*
|* View ermitteln
|*
\************************************************************************/

/*N*/ SchView* SchViewShell::GetView() const
/*N*/ {
/*N*/ 	return pChView;
/*N*/ }

/*************************************************************************
|*
|* Vorbereitung fuers Drucken; virtuell, wird vom SFX aufgerufen
|*
\************************************************************************/
//STRIP001 void SchViewShell::PreparePrint(PrintDialog* pPrintDialog)
//STRIP001 {
//STRIP001 }


/*************************************************************************
|*
|* Drucken; virtuell, wird vom SFX aufgerufen
|*
\************************************************************************/

//STRIP001 USHORT SchViewShell::Print(SfxProgress &rProgress,
//STRIP001 								PrintDialog* pPrintDialog)
//STRIP001 {
//STRIP001 	SfxPrinter* pPrinter = GetPrinter();
//STRIP001 
//STRIP001 	if (pPrinter)
//STRIP001 	{
//STRIP001 		BOOL bModified = ((SchChartDocShell*)GetViewFrame()->GetObjectShell())->IsModified ();
//STRIP001 
//STRIP001 		SfxViewShell::Print (rProgress, pPrintDialog);
//STRIP001 
//STRIP001 		// MapMode einstellen
//STRIP001 		MapMode aOldMap = pPrinter->GetMapMode();
//STRIP001 		pChView->GetDoc().AdjustPrinter();
//STRIP001 
//STRIP001         // tell printer if there are any transparent objects in the chart
//STRIP001         if( ! pPrinter->InitJob( GetWindow(), pChView->GetDoc().HasTransparentObjects()))
//STRIP001         {
//STRIP001             // user pressed 'Cancel'
//STRIP001             return 0;
//STRIP001         }
//STRIP001 
//STRIP001 		SchView* pPrintView = new SchView ((SchChartDocShell*)GetViewFrame()->GetObjectShell(),
//STRIP001 										   pPrinter, this);
//STRIP001 
//STRIP001 		pPrinter->StartPage();
//STRIP001 		pPrintView->ShowPagePgNum(0, Point());
//STRIP001 		pPrintView->InitRedraw(pPrinter, Region (Rectangle(Point(), pPrinter->GetOutputSize())));
//STRIP001 		pPrinter->EndPage();
//STRIP001 
//STRIP001 		delete pPrintView;
//STRIP001 		pPrinter->SetMapMode(aOldMap);
//STRIP001 		((SchChartDocShell*)GetViewFrame()->GetObjectShell())->SetModified (FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

/*************************************************************************
|*
|* Command event
|*
\************************************************************************/

//STRIP001 FASTBOOL SchViewShell::Command(const CommandEvent& rCEvt)
//STRIP001 {
//STRIP001 	BOOL bResult = FALSE;
//STRIP001 
//STRIP001 	// pop-up menu
//STRIP001 	if (rCEvt.GetCommand() == COMMAND_CONTEXTMENU && !pChView->IsAction())
//STRIP001 	{
//STRIP001 		GetWindow()->ReleaseMouse();
//STRIP001 
//STRIP001 		ChartModel& rDoc = pChView->GetDoc();
//STRIP001 		BOOL bAxisChart     = rDoc.IsAxisChart();
//STRIP001 		USHORT nRId	= 0;
//STRIP001 
//STRIP001 		if( !pChView->HasMarkedObj() )
//STRIP001 			nRId = RID_FORMAT_POPUP;
//STRIP001 		else if( rDoc.Is3DChart() )
//STRIP001 		{
//STRIP001 			if( bAxisChart )
//STRIP001 				nRId = RID_3D_POPUP;
//STRIP001 			else
//STRIP001 				nRId = RID_3D_PIE_POPUP;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if( !bAxisChart || rDoc.IsNetChart() )
//STRIP001 				nRId = RID_2D_PIE_POPUP;
//STRIP001 			else
//STRIP001 				nRId = RID_2D_POPUP;
//STRIP001 		}
//STRIP001 		if( nRId != 0 )
//STRIP001 			GetViewFrame()->GetDispatcher()->ExecutePopup( SchResId( nRId ) );
//STRIP001 
//STRIP001 		bResult = TRUE;
//STRIP001 	}
//STRIP001 	// UNIX-stlye selection clipboard usually with
//STRIP001 	// middle mouse button
//STRIP001 	else if( rCEvt.GetCommand() == COMMAND_PASTESELECTION )
//STRIP001 	{
//STRIP001 		Window* pWin = GetWindow();
//STRIP001 		TransferableDataHelper aDataHelper(
//STRIP001 			TransferableDataHelper::CreateFromSelection( pWin ) );
//STRIP001 
//STRIP001 		if( aDataHelper.GetTransferable().is())
//STRIP001 		{
//STRIP001 			Point aPos;
//STRIP001 			if( pWin )
//STRIP001 				aPos = pWin->PixelToLogic( rCEvt.GetMousePosPixel());
//STRIP001 
//STRIP001 			pChView->InsertData( aDataHelper, aPos, DND_ACTION_COPY, FALSE );
//STRIP001 		}
//STRIP001 
//STRIP001 		bResult = TRUE;
//STRIP001 	}
//STRIP001 	else if( pFuActual )
//STRIP001 		bResult = pFuActual->Command( rCEvt );
//STRIP001 
//STRIP001 	return bResult;
//STRIP001 }

/*************************************************************************
|*
|* Wird gerufen, wenn sich der Selektionszustand der View aendert
|*
\************************************************************************/

/*N*/ void SchViewShell::SelectionHasChanged()
/*N*/ {
/*N*/ 	Invalidate();
/*N*/ 
/*N*/ 	// 3d flyer window
/*N*/ 	USHORT nId = Svx3DChildWindow::GetChildWindowId();
/*N*/ 	SfxChildWindow* pWindow = GetViewFrame()->GetChildWindow( nId );
/*N*/ 	if( pWindow )
/*N*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 Svx3DWin* p3DWin = (Svx3DWin*)( pWindow->GetWindow() );
//STRIP001 /*?*/  		if( p3DWin )
//STRIP001 /*?*/  		{
//STRIP001 /*?*/  			SfxBoolItem aItem( SID_3D_STATE, TRUE );
//STRIP001 /*?*/  			GetViewFrame()->GetDispatcher()->Execute( SID_3D_STATE, SFX_CALLMODE_ASYNCHRON |
//STRIP001 /*?*/  													  SFX_CALLMODE_RECORD, &aItem, 0L );
//STRIP001 /*?*/  		}
/*N*/ 	}
/*N*/ 
/*N*/     if( mbBroadcastSelectionChanges )
/*N*/     {
/*N*/         pChView->UpdateSelectionClipboard( FALSE );
/*N*/ 
/*N*/         if( mpUNOController != NULL )
/*?*/             mpUNOController->fireSelectionChangeListener();
/*N*/ 
/*N*/         mbPendingSelectionChange = sal_False;
/*N*/     }
/*N*/     else
/*?*/         mbPendingSelectionChange = sal_True;
/*N*/ }

/*************************************************************************
|*
|* aktuellen Drucker des Dokuments zurueckgeben
|*
\************************************************************************/

/*N*/ SfxPrinter* SchViewShell::GetPrinter(BOOL bCreate)
/*N*/ {
/*N*/ 	return (*(SchChartDocShell*)GetViewFrame()->
/*N*/ 								GetObjectShell()).GetPrinter();
/*N*/ }

/*************************************************************************
|*
|* neuen Drucker fuer die Applikation setzen
|*
\************************************************************************/

//STRIP001 USHORT SchViewShell::SetPrinter(SfxPrinter* pNewPrinter, USHORT nDiffFlags)
//STRIP001 {
//STRIP001 	(*(SchChartDocShell*)GetViewFrame()->
//STRIP001 		GetObjectShell()).SetPrinter(pNewPrinter);
//STRIP001 	return 0;
//STRIP001 }

/*************************************************************************
|*
|* PrepareClose, ggfs. Texteingabe beenden, damit andere Viewshells ein
|* aktualisiertes Textobjekt vorfinden
|*
\************************************************************************/

//STRIP001 USHORT SchViewShell::PrepareClose(BOOL bUI,BOOL b) //#63638#
//STRIP001 {
//STRIP001 	USHORT nClosing=SfxViewShell::PrepareClose(bUI,b);
//STRIP001 
//STRIP001 	if(nClosing)
//STRIP001 	{
//STRIP001 		if (pFuActual && pFuActual->GetSlotID() == SID_TEXTEDIT)
//STRIP001 			pChView->EndTextEdit();
//STRIP001 	}
//STRIP001 	return nClosing;
//STRIP001 }


/** Returns TRUE if the corresponding feature is available,
    eg it returns only true if the chart is three dimensional
    and the 3d effect flyer is to be displayed
*/
/*N*/ BOOL SchViewShell::HasUIFeature( ULONG nFeature )
/*N*/ {
/*N*/     switch( nFeature )
/*N*/     {
/*N*/         case SCH_UI_FEATURE_THREE_D:
/*N*/             if( pDocSh )
/*N*/                 return pDocSh->GetDoc().IsReal3D();
/*?*/             return FALSE;
/*N*/ 
/*N*/         case SCH_UI_FEATURE_OWN_DATA:
/*N*/             // ToDo: If chart is inside Calc/Writer using external data, FALSE
/*N*/             // should be returned. It currently works in a different way (hack)
/*N*/             return TRUE;
/*N*/ 
/*?*/         default:
/*?*/             DBG_ERRORFILE( "Unknown UI Feature requested!" );
/*?*/             return FALSE;
/*N*/     }
/*N*/ }

//STRIP001 void SchViewShell::AllowSelectionChangeBroadcasts( sal_Bool bAllow )
//STRIP001 {
//STRIP001     if( bAllow != mbBroadcastSelectionChanges )
//STRIP001     {
//STRIP001         mbBroadcastSelectionChanges = bAllow;
//STRIP001         if( sal_True == mbBroadcastSelectionChanges &&
//STRIP001             sal_True == mbPendingSelectionChange )
//STRIP001         {
//STRIP001             SelectionHasChanged();
//STRIP001         }
//STRIP001     }
//STRIP001 }

// SfxListener

/*N*/ void SchViewShell::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
/*N*/ {
/*N*/     if( rHint.ISA( SchVisAreaChangedHint ) &&
/*N*/         NULL != mpUNOController )
/*N*/     {
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 /*?*/         Rectangle aRect = static_cast< const SchVisAreaChangedHint & >( rHint ).getNewRect();
//STRIP001 /*?*/         ::com::sun::star::awt::Rectangle aAwtRect(
//STRIP001 /*?*/             aRect.Left(), aRect.Top(), aRect.GetWidth(), aRect.GetHeight() );
//STRIP001 /*?*/         mpUNOController->changeVisArea( aAwtRect );
/*N*/     }
/*N*/     else
/*N*/         SfxViewShell::Notify( rBC, rHint );
/*N*/ }


// ________________________________________
//
//  SuspendSelectionChangeBroadcasting
// ________________________________________

/*?*/ SuspendSelectionChangeBroadcasting::SuspendSelectionChangeBroadcasting( SchViewShell *  pViewShell ) :
/*?*/         mpViewShell( pViewShell )
/*?*/ {
/*?*/ 	DBG_BF_ASSERT(0, "STRIP"); //STRIP001     if( mpViewShell )
//STRIP001         mpViewShell->AllowSelectionChangeBroadcasts( sal_False );    
/*?*/ }

//STRIP001 SuspendSelectionChangeBroadcasting::~SuspendSelectionChangeBroadcasting()
//STRIP001 {
//STRIP001     if( mpViewShell )
//STRIP001         mpViewShell->AllowSelectionChangeBroadcasts( sal_True );
//STRIP001 }

// __________ SchVisAreaChangedHint __________

/*N*/ TYPEINIT0( SchVisAreaChangedHint );

/*N*/ SchVisAreaChangedHint::SchVisAreaChangedHint( const Rectangle & rNewRect )
/*N*/ {
/*N*/     maNewRect = rNewRect;
/*N*/ }

//STRIP001 SchVisAreaChangedHint::SchVisAreaChangedHint()
//STRIP001 {}

/*N*/ SchVisAreaChangedHint::~SchVisAreaChangedHint()
/*N*/ {}

//STRIP001 const Rectangle &  SchVisAreaChangedHint::getNewRect() const
//STRIP001 {
//STRIP001     return  maNewRect;
//STRIP001 }
}
