/*************************************************************************
 *
 *  $RCSfile: sd_fuediglu.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:48:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SFXENUMITEM_HXX //autogen
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
#include <bf_svx/dialogs.hrc>
// auto strip #ifndef _SVDGLUE_HXX //autogen
// auto strip #include <bf_svx/svdglue.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif


#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "fuediglu.hxx"
// auto strip #include "frmview.hxx"
namespace binfilter {


//STRIP001 TYPEINIT1( FuEditGluePoints, FuDraw );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuEditGluePoints::FuEditGluePoints(SdViewShell* 	pViewSh,
//STRIP001 							 SdWindow*			pWin,
//STRIP001 							 SdView*			pView,
//STRIP001 							 SdDrawDocument*	pDoc,
//STRIP001 							 SfxRequest&		rReq) :
//STRIP001 	FuDraw(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	pViewShell->SwitchObjectBar(RID_GLUEPOINTS_TOOLBOX);
//STRIP001 	pView->SetInsGluePointMode(FALSE);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuEditGluePoints::~FuEditGluePoints()
//STRIP001 {
//STRIP001 	pView->BrkAction();
//STRIP001 	pView->UnmarkAllGluePoints();
//STRIP001 	pView->SetInsGluePointMode(FALSE);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuEditGluePoints::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	pView->SetActualWin( pWindow );
//STRIP001 
//STRIP001 	BOOL bReturn = FuDraw::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	if (pView->IsAction())
//STRIP001 	{
//STRIP001 		if (rMEvt.IsRight())
//STRIP001 			pView->BckAction();
//STRIP001 
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rMEvt.IsLeft())
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 		USHORT nHitLog = USHORT ( pWindow->PixelToLogic(Size(HITPIX,0)).Width() );
//STRIP001 		USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 		pWindow->CaptureMouse();
//STRIP001 
//STRIP001 		SdrViewEvent aVEvt;
//STRIP001 		SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 
//STRIP001 		if (eHit == SDRHIT_HANDLE)
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Handle draggen
//STRIP001 			******************************************************************/
//STRIP001 			SdrHdl* pHdl = aVEvt.pHdl;
//STRIP001 
//STRIP001 			if (pView->IsGluePointMarked(aVEvt.pObj, aVEvt.nGlueId) && rMEvt.IsShift())
//STRIP001 			{
//STRIP001 				pView->UnmarkGluePoint(aVEvt.pObj, aVEvt.nGlueId, aVEvt.pPV);
//STRIP001 				pHdl = NULL;
//STRIP001 			}
//STRIP001 
//STRIP001 			if (pHdl)
//STRIP001 			{
//STRIP001 				// Handle draggen
//STRIP001 				pView->BegDragObj(aMDPos, (OutputDevice*) NULL, aVEvt.pHdl, nDrgLog);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if (eHit == SDRHIT_MARKEDOBJECT && pView->IsInsGluePointMode())
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Klebepunkt einfuegen
//STRIP001 			******************************************************************/
//STRIP001 			pView->BegInsGluePoint(aMDPos);
//STRIP001 		}
//STRIP001 		else if (eHit == SDRHIT_MARKEDOBJECT && rMEvt.IsMod1())
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Klebepunkt selektieren
//STRIP001 			******************************************************************/
//STRIP001 			if (!rMEvt.IsShift())
//STRIP001 				pView->UnmarkAllGluePoints();
//STRIP001 
//STRIP001 			pView->BegMarkGluePoints(aMDPos, (OutputDevice*) NULL);
//STRIP001 		}
//STRIP001 		else if (eHit == SDRHIT_MARKEDOBJECT && !rMEvt.IsShift() && !rMEvt.IsMod2())
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Objekt verschieben
//STRIP001 			******************************************************************/
//STRIP001 			pView->BegDragObj(aMDPos, (OutputDevice*) NULL, NULL, nDrgLog);
//STRIP001 		}
//STRIP001 		else if (eHit == SDRHIT_GLUEPOINT)
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Klebepunkt selektieren
//STRIP001 			******************************************************************/
//STRIP001 			if (!rMEvt.IsShift())
//STRIP001 				pView->UnmarkAllGluePoints();
//STRIP001 
//STRIP001 			pView->MarkGluePoint(aVEvt.pObj, aVEvt.nGlueId, aVEvt.pPV);
//STRIP001 			SdrHdl* pHdl = pView->GetGluePointHdl(aVEvt.pObj, aVEvt.nGlueId);
//STRIP001 
//STRIP001 			if (pHdl)
//STRIP001 			{
//STRIP001 				pView->BegDragObj(aMDPos, (OutputDevice*) NULL, pHdl, nDrgLog);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Objekt selektieren oder draggen
//STRIP001 			******************************************************************/
//STRIP001 			if (!rMEvt.IsShift() && !rMEvt.IsMod2() && eHit == SDRHIT_UNMARKEDOBJECT)
//STRIP001 			{
//STRIP001 			   pView->UnmarkAllObj();
//STRIP001 			}
//STRIP001 
//STRIP001 			BOOL bMarked = FALSE;
//STRIP001 
//STRIP001 			if (!rMEvt.IsMod1())
//STRIP001 			{
//STRIP001 				if (rMEvt.IsMod2())
//STRIP001 				{
//STRIP001 					bMarked = pView->MarkNextObj(aMDPos, nHitLog, rMEvt.IsShift());
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					bMarked = pView->MarkObj(aMDPos, nHitLog, rMEvt.IsShift());
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if (bMarked &&
//STRIP001 				(!rMEvt.IsShift() || eHit == SDRHIT_MARKEDOBJECT))
//STRIP001 			{
//STRIP001 				// Objekt verschieben
//STRIP001 				pView->BegDragObj(aMDPos, (OutputDevice*) NULL, aVEvt.pHdl, nDrgLog);
//STRIP001 			}
//STRIP001 			else if (pView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				/**************************************************************
//STRIP001 				* Klebepunkt selektieren
//STRIP001 				**************************************************************/
//STRIP001 				if (!rMEvt.IsShift())
//STRIP001 					pView->UnmarkAllGluePoints();
//STRIP001 
//STRIP001 				pView->BegMarkGluePoints(aMDPos, (OutputDevice*) NULL);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				/**************************************************************
//STRIP001 				* Objekt selektieren
//STRIP001 				**************************************************************/
//STRIP001 				pView->BegMarkObj(aMDPos);
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		ForcePointer(&rMEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuEditGluePoints::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	pView->SetActualWin( pWindow );
//STRIP001 
//STRIP001 	FuDraw::MouseMove(rMEvt);
//STRIP001 
//STRIP001 	if (pView->IsAction())
//STRIP001 	{
//STRIP001 		Point aPix(rMEvt.GetPosPixel());
//STRIP001 		Point aPnt( pWindow->PixelToLogic(aPix) );
//STRIP001 		ForceScroll(aPix);
//STRIP001 		pView->MovAction(aPnt);
//STRIP001 	}
//STRIP001 
//STRIP001 	ForcePointer(&rMEvt);
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuEditGluePoints::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	pView->SetActualWin( pWindow );
//STRIP001 
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if (pView->IsAction())
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 		pView->EndAction();
//STRIP001 	}
//STRIP001 
//STRIP001 	FuDraw::MouseButtonUp(rMEvt);
//STRIP001 
//STRIP001 	USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 	Point aPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
//STRIP001 
//STRIP001 	if (Abs(aMDPos.X() - aPos.X()) < nDrgLog &&
//STRIP001 		Abs(aMDPos.Y() - aPos.Y()) < nDrgLog &&
//STRIP001 		!rMEvt.IsShift() && !rMEvt.IsMod2())
//STRIP001 	{
//STRIP001 		SdrViewEvent aVEvt;
//STRIP001 		SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 
//STRIP001 		if (eHit == SDRHIT_NONE)
//STRIP001 		{
//STRIP001 			// Klick auf der Stelle: deselektieren
//STRIP001 			pView->UnmarkAllObj();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	pWindow->ReleaseMouse();
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuEditGluePoints::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	pView->SetActualWin( pWindow );
//STRIP001 
//STRIP001 	BOOL bReturn = FuDraw::KeyInput(rKEvt);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Command-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuEditGluePoints::Command(const CommandEvent& rCEvt)
//STRIP001 {
//STRIP001 	pView->SetActualWin( pWindow );
//STRIP001 	return FuPoor::Command( rCEvt );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Funktion aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuEditGluePoints::Activate()
//STRIP001 {
//STRIP001 	pView->SetGluePointEditMode();
//STRIP001 	FuDraw::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Funktion deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuEditGluePoints::Deactivate()
//STRIP001 {
//STRIP001 	pView->SetGluePointEditMode( FALSE );
//STRIP001 	FuDraw::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Request verarbeiten
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuEditGluePoints::ReceiveRequest(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	switch (rReq.GetSlot())
//STRIP001 	{
//STRIP001 		case SID_GLUE_INSERT_POINT:
//STRIP001 		{
//STRIP001 			pView->SetInsGluePointMode(!pView->IsInsGluePointMode());
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_ESCDIR_LEFT:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsEscDir( SDRESC_LEFT,
//STRIP001 					!pView->IsMarkedGluePointsEscDir( SDRESC_LEFT ) );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_ESCDIR_RIGHT:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsEscDir( SDRESC_RIGHT,
//STRIP001 					!pView->IsMarkedGluePointsEscDir( SDRESC_RIGHT ) );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_ESCDIR_TOP:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsEscDir( SDRESC_TOP,
//STRIP001 					!pView->IsMarkedGluePointsEscDir( SDRESC_TOP ) );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_ESCDIR_BOTTOM:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsEscDir( SDRESC_BOTTOM,
//STRIP001 					!pView->IsMarkedGluePointsEscDir( SDRESC_BOTTOM ) );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_PERCENT:
//STRIP001 		{
//STRIP001 			const SfxItemSet* pSet = rReq.GetArgs();
//STRIP001 			const SfxPoolItem& rItem = pSet->Get(SID_GLUE_PERCENT);
//STRIP001 			BOOL bPercent = ((const SfxBoolItem&) rItem).GetValue();
//STRIP001 			pView->SetMarkedGluePointsPercent(bPercent);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_HORZALIGN_CENTER:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsAlign(FALSE, SDRHORZALIGN_CENTER);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_HORZALIGN_LEFT:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsAlign(FALSE, SDRHORZALIGN_LEFT);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_HORZALIGN_RIGHT:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsAlign(FALSE, SDRHORZALIGN_RIGHT);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_VERTALIGN_CENTER:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsAlign(TRUE, SDRVERTALIGN_CENTER);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_VERTALIGN_TOP:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsAlign(TRUE, SDRVERTALIGN_TOP);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GLUE_VERTALIGN_BOTTOM:
//STRIP001 		{
//STRIP001 			pView->SetMarkedGluePointsAlign(TRUE, SDRVERTALIGN_BOTTOM);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Zum Schluss Basisklasse rufen
//STRIP001 	FuPoor::ReceiveRequest(rReq);
//STRIP001 }


}
