/*************************************************************************
 *
 *  $RCSfile: mailwindow.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:39:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef INCLUDED_SFX_MAILWINDOW_HXX
#define INCLUDED_SFX_MAILWINDOW_HXX

// auto strip #include <vcl/button.hxx>	// PushButton
// auto strip #include <vcl/fixed.hxx>	// FixedText
// auto strip #include <vcl/edit.hxx>		// Edit
// auto strip #include <vcl/lstbox.hxx>	// ListBox
namespace binfilter {

// class AddressEdit_Impl ------------------------------------------------

class MailWindow_Impl;

//STRIP001 class AddressEdit_Impl : public Edit
//STRIP001 {
//STRIP001 private:
//STRIP001 	MailWindow_Impl*	mpWindow;
//STRIP001 
//STRIP001 public:
//STRIP001 	AddressEdit_Impl( MailWindow_Impl* pWin, const ResId& rResId );
//STRIP001 
//STRIP001 	virtual void		KeyInput( const KeyEvent& rKEvt );
//STRIP001 };

//STRIP001 class AddressListBox_Impl : public ListBox
//STRIP001 {
//STRIP001 private:
//STRIP001 	MailWindow_Impl*	mpWindow;
//STRIP001 
//STRIP001 public:
//STRIP001 	AddressListBox_Impl( MailWindow_Impl* pWin, const ResId& rResId );
//STRIP001 
//STRIP001 	virtual long		Notify( NotifyEvent& rNEvt );
//STRIP001 };

// class MailWindow_Impl -------------------------------------------------

class MailListener_Impl;
class SfxMailModel_Impl;
class SfxBindings;

//STRIP001 class MailWindow_Impl : public Window
//STRIP001 {
//STRIP001 private:
//STRIP001 	PushButton			aSendBtn;
//STRIP001 	PushButton			aCloseBtn;
//STRIP001 	ListBox				aRoleLB;
//STRIP001 	AddressEdit_Impl	aRoleEdit;
//STRIP001 	AddressListBox_Impl	aAddressLB;
//STRIP001 	FixedText			aSubjectFT;
//STRIP001 	Edit				aSubjectEdit;
//STRIP001 	FixedText			aFromFT;
//STRIP001 	Edit				aFromEdit;
//STRIP001 	FixedText			aPrioFT;
//STRIP001 	ListBox				aPrioLB;
//STRIP001 
//STRIP001 	Image				aSendImage;
//STRIP001 	Image				aCloseImage;
//STRIP001 	Timer				aCloseTimer;
//STRIP001 	Timer				aInitTimer;
//STRIP001 
//STRIP001 	sal_Bool			bSend;
//STRIP001 
//STRIP001 	long				n6Size;
//STRIP001 	long				nMinWidth;
//STRIP001 
//STRIP001 	SfxBindings*		pBindings;
//STRIP001 
//STRIP001 	void				FillModel( SfxMailModel_Impl& rModel );
//STRIP001 
//STRIP001 	DECL_LINK( SendHdl, PushButton* );
//STRIP001 	DECL_LINK( CloseHdl, void* );
//STRIP001 	DECL_LINK( ModifyHdl, Edit* );
//STRIP001 	DECL_LINK( InitHdl, Timer* );
//STRIP001 	DECL_LINK( ChangeHdl, MailListener_Impl* );
//STRIP001 
//STRIP001 public:
//STRIP001 	MailWindow_Impl( Window* pParent, SfxBindings* pBinds, const ResId& rResId );
//STRIP001 	~MailWindow_Impl();
//STRIP001 
//STRIP001 	virtual void		Resize();
//STRIP001 
//STRIP001 	sal_Bool			CanSend() const;
//STRIP001 	void				Send();
//STRIP001 	sal_Bool			HasSend() const { return bSend; }
//STRIP001 	void				ReceiveAddress();
//STRIP001 	void				ClearAddress();
//STRIP001 	void				DeleteAddress();
//STRIP001 };

}//end of namespace binfilter
#endif // INCLUDED_SFX_MAILWINDOW_HXX


