/*************************************************************************
 *
 *  $RCSfile: sfx2_prnmon.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:08:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _COM_SUN_STAR_VIEW_PRINTABLESTATE_HPP_
// auto strip #include <com/sun/star/view/PrintableState.hpp>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_UTIL_XCLOSEABLE_HPP_
// auto strip #include <com/sun/star/util/XCloseable.hpp>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_UTIL_XCLOSEBROADCASTER_HPP_
// auto strip #include <com/sun/star/util/XCloseBroadcaster.hpp>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_UTIL_XCLOSELISTENER_HPP_
// auto strip #include <com/sun/star/util/XCloseListener.hpp>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_UTIL_CLOSEVETOEXCEPTION_HPP_
// auto strip #include <com/sun/star/util/CloseVetoException.hpp>
// auto strip #endif

// auto strip #ifndef _SV_FIXED_HXX
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #ifndef   SVTOOLS_ASYNCLINK_HXX
// auto strip #include <svtools/asynclink.hxx>
// auto strip #endif

// auto strip #include <svtools/printwarningoptions.hxx>

#pragma hdrstop

// auto strip #include "prnmon.hxx"
// auto strip #include "viewsh.hxx"
// auto strip #include "viewfrm.hxx"
// auto strip #include "objsh.hxx"
// auto strip #include "docfile.hxx"
// auto strip #include "sfxtypes.hxx"
// auto strip #include "progress.hxx"
// auto strip #include "desrupt.hxx"
// auto strip #include "bindings.hxx"
// auto strip #include "sfxresid.hxx"
// auto strip #include "event.hxx"

#include "view.hrc"
namespace binfilter {

//------------------------------------------------------------------------

//STRIP001 #define SFX_TITLE_MAXLEN_PRINTMONITOR	22
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 struct SfxPrintMonitor_Impl: public ModelessDialog
//STRIP001 {
//STRIP001 	SfxPrintMonitor_Impl( Window *pParent );
//STRIP001 
//STRIP001 	FixedText				aDocName;
//STRIP001 	FixedText				aPrinting;
//STRIP001 	FixedText				aPrinter;
//STRIP001 	FixedText				aPrintInfo;
//STRIP001 	CancelButton			aCancel;
//STRIP001 };
//STRIP001 
//STRIP001 //-------------------------------------------------------------------------
//STRIP001 
//STRIP001 struct SfxPrintProgress_Impl : public SfxListener
//STRIP001 {
//STRIP001 	SfxPrintMonitor_Impl* 	pMonitor;
//STRIP001 	SfxViewShell*			pViewShell;
//STRIP001 	SfxPrinter* 			pPrinter;
//STRIP001 	SfxPrinter* 			pOldPrinter;
//STRIP001 	USHORT					nLastPage;
//STRIP001 	BOOL					bRunning;
//STRIP001 	BOOL					bCancel;
//STRIP001 	BOOL					bDeleteOnEndPrint;
//STRIP001 	BOOL					bShow;
//STRIP001 	BOOL					bCallbacks;
//STRIP001 	BOOL					bOldEnablePrintFile;
//STRIP001     BOOL                    bOldFlag;
//STRIP001     BOOL                    bRestoreFlag;
//STRIP001 	BOOL					bAborted;
//STRIP001     svtools::AsynchronLink  aDeleteLink;
//STRIP001     Link					aCancelHdl;
//STRIP001 
//STRIP001 private:
//STRIP001 	DECL_LINK( CancelHdl, Button * );
//STRIP001 	DECL_STATIC_LINK( SfxPrintProgress_Impl, DeleteHdl, SfxPrintProgress * );
//STRIP001 
//STRIP001 public:
//STRIP001 	SfxPrintProgress_Impl( SfxViewShell* pTheViewShell, SfxPrinter* pThePrinter );
//STRIP001 	~SfxPrintProgress_Impl();
//STRIP001 
//STRIP001 	void            		Delete( SfxPrintProgress* pAntiImpl ) { aDeleteLink.Call( pAntiImpl ); }
//STRIP001 	SfxViewShell*			GetViewShell() const { return pViewShell; }
//STRIP001 	BOOL					SetPage( USHORT nPage, const String &rPage );
//STRIP001 	virtual void            SFX_NOTIFY( SfxBroadcaster& rBC,
//STRIP001 										const TypeId& rBCType,
//STRIP001 										const SfxHint& rHint,
//STRIP001 										const TypeId& rHintType );
//STRIP001 };
//STRIP001 
//STRIP001 void SfxPrintProgress_Impl::SFX_NOTIFY( SfxBroadcaster& rBC,
//STRIP001 							const TypeId& rBCType,
//STRIP001 							const SfxHint& rHint,
//STRIP001 							const TypeId& rHintType )
//STRIP001 {
//STRIP001 	SfxPrintingHint* pPrintHint = PTR_CAST( SfxPrintingHint, &rHint );
//STRIP001 	if ( pPrintHint )
//STRIP001 	{
//STRIP001 		if ( pPrintHint->GetWhich() == -2 )
//STRIP001 			CancelHdl(0);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPrintMonitor_Impl::SfxPrintMonitor_Impl( Window* pParent ) :
//STRIP001 
//STRIP001 	ModelessDialog( pParent, SfxResId( DLG_PRINTMONITOR ) ),
//STRIP001 
//STRIP001 	aDocName	( this, ResId( FT_DOCNAME ) ),
//STRIP001 	aPrinting	( this, ResId( FT_PRINTING ) ),
//STRIP001 	aPrinter	( this, ResId( FT_PRINTER ) ),
//STRIP001 	aPrintInfo	( this, ResId( FT_PRINTINFO ) ),
//STRIP001 	aCancel		( this, ResId( PB_CANCELPRNMON ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_STATIC_LINK( SfxPrintProgress_Impl, DeleteHdl, SfxPrintProgress*, pAntiImpl )
//STRIP001 {
//STRIP001 	delete pAntiImpl;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPrintProgress_Impl::SfxPrintProgress_Impl( SfxViewShell* pTheViewShell,
//STRIP001 											  SfxPrinter* pThePrinter ) :
//STRIP001 
//STRIP001 	pViewShell			( pTheViewShell ),
//STRIP001 	pPrinter			( pThePrinter ),
//STRIP001 	pOldPrinter			( NULL ),
//STRIP001 	bRunning			( TRUE ),
//STRIP001 	bDeleteOnEndPrint	( FALSE ),
//STRIP001 	bCancel				( FALSE ),
//STRIP001 	bCallbacks			( FALSE ),
//STRIP001 	bOldEnablePrintFile	( FALSE ),
//STRIP001     bOldFlag            ( TRUE ),
//STRIP001     bRestoreFlag        ( FALSE ),
//STRIP001 	bAborted			( FALSE ),
//STRIP001 	nLastPage			( 0 ),
//STRIP001 	aDeleteLink			( STATIC_LINK( this, SfxPrintProgress_Impl, DeleteHdl ) )
//STRIP001 
//STRIP001 {
//STRIP001 	Window* pParent =
//STRIP001 		pTheViewShell->GetWindow()->IsReallyVisible() ? pTheViewShell->GetWindow() : NULL;
//STRIP001 	pMonitor = new SfxPrintMonitor_Impl( pParent );
//STRIP001 	pMonitor->aDocName.SetText(
//STRIP001 		pViewShell->GetViewFrame()->GetObjectShell()->GetTitle( SFX_TITLE_MAXLEN_PRINTMONITOR ) );
//STRIP001 	pMonitor->aPrinter.SetText( pViewShell->GetPrinter()->GetName() );
//STRIP001 	pMonitor->aCancel.SetClickHdl( LINK( this, SfxPrintProgress_Impl, CancelHdl ) );
//STRIP001 	StartListening( *pViewShell->GetObjectShell() );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPrintProgress_Impl::~SfxPrintProgress_Impl()
//STRIP001 {
//STRIP001 	EndListening( *pViewShell->GetObjectShell() );
//STRIP001 	if ( pMonitor )
//STRIP001 	{
//STRIP001 		pMonitor->Hide(); // sieht optisch besser aus, wenn alles auf einmal verschwindet
//STRIP001 		delete pMonitor;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SfxPrintProgress_Impl::SetPage( USHORT nPage, const String &rPage )
//STRIP001 {
//STRIP001 	// wurde der Druckauftrag abgebrochen?
//STRIP001 	if ( bCancel || !pMonitor )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	nLastPage = nPage;
//STRIP001 	String aStrPrintInfo = String( SfxResId( STR_PAGE ) );
//STRIP001 	if ( !rPage.Len() )
//STRIP001 		aStrPrintInfo += String::CreateFromInt32( nLastPage );
//STRIP001 	else
//STRIP001 		aStrPrintInfo += rPage;
//STRIP001 	pMonitor->aPrintInfo.SetText( aStrPrintInfo );
//STRIP001 	pMonitor->Update();
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SfxPrintProgress_Impl, CancelHdl, Button *, pButton )
//STRIP001 {
//STRIP001 	if ( pMonitor )
//STRIP001 		pMonitor->Hide();
//STRIP001 
//STRIP001 	pViewShell->GetObjectShell()->Broadcast( SfxPrintingHint( ::com::sun::star::view::PrintableState_JOB_ABORTED, NULL, NULL ) );
//STRIP001 	pViewShell->GetPrinter()->AbortJob();
//STRIP001 	bCancel = TRUE;
//STRIP001 
//STRIP001 	if ( aCancelHdl.IsSet() )
//STRIP001 		aCancelHdl.Call( this );
//STRIP001 
//STRIP001 	bAborted = TRUE;
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //--------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPrintProgress::SfxPrintProgress( SfxViewShell* pViewSh, FASTBOOL bShow )
//STRIP001 :   SfxProgress( pViewSh->GetViewFrame()->GetObjectShell(),
//STRIP001 				 String(SfxResId(STR_PRINTING)), 1, FALSE ),
//STRIP001 	pImp( new SfxPrintProgress_Impl( pViewSh, pViewSh->GetPrinter() ) )
//STRIP001 {
//STRIP001 	// Callback fuer Fehler und EndPrint setzen
//STRIP001 	pImp->pPrinter->SetEndPrintHdl(
//STRIP001 				LINK( this, SfxPrintProgress, EndPrintNotify ));
//STRIP001 	pImp->pPrinter->SetErrorHdl(
//STRIP001 				LINK( this, SfxPrintProgress, PrintErrorNotify ));
//STRIP001 	pImp->bCallbacks = TRUE;
//STRIP001 
//STRIP001 	//pImp->pViewShell->GetViewFrame()->GetFrame()->Lock_Impl(TRUE);
//STRIP001 	pImp->bShow = bShow;
//STRIP001 	Lock();
//STRIP001     if ( !SvtPrintWarningOptions().IsModifyDocumentOnPrintingAllowed() )
//STRIP001     {
//STRIP001         pImp->bRestoreFlag = TRUE;
//STRIP001         pImp->bOldFlag = pViewSh->GetObjectShell()->IsEnableSetModified();
//STRIP001         if ( pImp->bOldFlag )
//STRIP001             pViewSh->GetObjectShell()->EnableSetModified( FALSE );
//STRIP001     }
//STRIP001 }
//STRIP001 
//STRIP001 //--------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPrintProgress::~SfxPrintProgress()
//STRIP001 {
//STRIP001 	// k"onnte auch schon weg sein (in EndPrintNotify)
//STRIP001 	DELETEZ(pImp->pMonitor);
//STRIP001 
//STRIP001 	// ggf. Callbacks entfermen
//STRIP001 	if ( pImp->bCallbacks )
//STRIP001 	{
//STRIP001 		pImp->pPrinter->SetEndPrintHdl( Link() );
//STRIP001 		pImp->pPrinter->SetErrorHdl( Link() );
//STRIP001 		pImp->bCallbacks = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	// ggf. vorherigen Drucker wieder einsetzen
//STRIP001 	if ( pImp->pOldPrinter )
//STRIP001 		pImp->pViewShell->SetPrinter( pImp->pOldPrinter, SFX_PRINTER_PRINTER );
//STRIP001 	else
//STRIP001 		// ggf. vorherigen Print-To-File-Status zuruecksetzen
//STRIP001 		pImp->pViewShell->GetPrinter()->EnablePrintFile(
//STRIP001 				pImp->bOldEnablePrintFile );
//STRIP001 
//STRIP001 	// EndPrint-Notification an Frame
//STRIP001 	//pImp->pViewShell->GetViewFrame()->GetFrame()->Lock_Impl(FALSE);
//STRIP001 	if ( pImp->pViewShell->GotOwnerShip_Impl() )
//STRIP001 	{
//STRIP001         ::com::sun::star::uno::Reference < ::com::sun::star::util::XCloseable > xModel( pImp->pViewShell->GetObjectShell()->GetModel(), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 		if ( xModel.is() )
//STRIP001 		{
//STRIP001 			try
//STRIP001 			{
//STRIP001 				xModel->close( sal_True );
//STRIP001 			}
//STRIP001 			catch ( ::com::sun::star::util::CloseVetoException& )
//STRIP001 			{
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pImp;
//STRIP001 }
//STRIP001 
//STRIP001 //--------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SfxPrintProgress::SetState( ULONG nVal, ULONG nNewRange )
//STRIP001 {
//STRIP001 #ifndef MAC
//STRIP001 	// auf dem MAC kommt einer vom Betriebssystem
//STRIP001 	if ( pImp->bShow )
//STRIP001 	{
//STRIP001 		pImp->bShow = FALSE;
//STRIP001 		pImp->pMonitor->Show();
//STRIP001 		pImp->pMonitor->Update();
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	return pImp->SetPage( (USHORT)nVal, GetStateText_Impl() ) &&
//STRIP001 		   SfxProgress::SetState( nVal, nNewRange );
//STRIP001 }
//STRIP001 
//STRIP001 //--------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxPrintProgress::SetText( const String& rText )
//STRIP001 {
//STRIP001 	if ( pImp->pMonitor )
//STRIP001 	{
//STRIP001 		pImp->pMonitor->SetText( rText );
//STRIP001 		pImp->pMonitor->Update();
//STRIP001 	}
//STRIP001 	SfxProgress::SetText( rText );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SfxPrintProgress, PrintErrorNotify, void *, pvoid )
//STRIP001 {
//STRIP001 	if ( pImp->pMonitor )
//STRIP001 		pImp->pMonitor->Hide();
//STRIP001 	pImp->pPrinter->AbortJob();
//STRIP001 	InfoBox( pImp->GetViewShell()->GetWindow(),
//STRIP001 			 String( SfxResId(STR_ERROR_PRINT) ) ).Execute();
//STRIP001     if ( pImp->bRestoreFlag && pImp->pViewShell->GetObjectShell()->IsEnableSetModified() != pImp->bOldFlag )
//STRIP001         pImp->pViewShell->GetObjectShell()->EnableSetModified( pImp->bOldFlag );
//STRIP001 	pImp->GetViewShell()->GetObjectShell()->Broadcast( SfxPrintingHint( ::com::sun::star::view::PrintableState_JOB_FAILED, NULL, NULL ) );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SfxPrintProgress, PrintErrorNotify, void *, pvoid )
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SfxPrintProgress, EndPrintNotify, void *, pvoid )
//STRIP001 {
//STRIP001 	if ( pImp->pMonitor )
//STRIP001 		pImp->pMonitor->Hide();
//STRIP001 
//STRIP001 	SfxViewShell* pViewShell = pImp->pViewShell;
//STRIP001 
//STRIP001 	// Slots enablen
//STRIP001 	pViewShell->Invalidate( SID_PRINTDOC );
//STRIP001 	pViewShell->Invalidate( SID_PRINTDOCDIRECT );
//STRIP001 	pViewShell->Invalidate( SID_SETUPPRINTER );
//STRIP001 
//STRIP001 	// . . . falls der Printer im System umgestellt wurde, hier Aenderung
//STRIP001 	// nachziehen.
//STRIP001 	//! if( pMDI->IsPrinterChanged() ) pMDI->Changed( 0L );
//STRIP001 
//STRIP001 	// Callbacks rausnehmen
//STRIP001 	pImp->pPrinter->SetEndPrintHdl( Link() );
//STRIP001 	pImp->pPrinter->SetErrorHdl( Link() );
//STRIP001 	pImp->bCallbacks = FALSE;
//STRIP001 
//STRIP001 	// ggf. alten Printer wieder einsetzen
//STRIP001 	if ( pImp->pOldPrinter )
//STRIP001 	{
//STRIP001 		// Fix #59613#: niemals den aktuellen Printer synchron abschiessen !
//STRIP001 		// Da sowieso immer bDeleteOnEndPrint gesetzt wird, wird der der Drucker im
//STRIP001 		// dtor vom Printprogress ( dann aber asynchron !! ) zur"uckgesetzt.
//STRIP001 /*
//STRIP001 		pImp->pViewShell->SetPrinter( pImp->pOldPrinter, SFX_PRINTER_PRINTER );
//STRIP001 		pImp->pOldPrinter = 0;
//STRIP001 		pImp->pPrinter = 0;
//STRIP001  */
//STRIP001 	}
//STRIP001 	else
//STRIP001 		// ggf. vorherigen Print-To-File-Status zuruecksetzen
//STRIP001 		pViewShell->GetPrinter()->EnablePrintFile( pImp->bOldEnablePrintFile );
//STRIP001 
//STRIP001 	// printing in thread will kill force us to kill this instance, so get necessary data before
//STRIP001 	BOOL bRestoreFlag = pImp->bRestoreFlag;
//STRIP001 	BOOL bOldFlag = pImp->bOldFlag;
//STRIP001 	if ( pImp->bDeleteOnEndPrint )
//STRIP001 	{
//STRIP001 		DELETEZ(pImp->pMonitor);
//STRIP001 		delete this;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		DBG_ASSERT( !pImp->pOldPrinter, "Unable to restore printer!" );
//STRIP001 		pImp->bRunning = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001     if ( bRestoreFlag && pViewShell->GetObjectShell()->IsEnableSetModified() != bOldFlag )
//STRIP001         pViewShell->GetObjectShell()->EnableSetModified( TRUE );
//STRIP001 
//STRIP001 	pViewShell->GetObjectShell()->Broadcast( SfxPrintingHint( ::com::sun::star::view::PrintableState_JOB_COMPLETED, NULL, NULL ) );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxPrintProgress::DeleteOnEndPrint()
//STRIP001 {
//STRIP001 	UnLock(); // jetzt schon, wg. Drucken im Thread
//STRIP001 #ifndef WIN
//STRIP001 	// da das Drucken im 'Thread' unter Windows zu undefiniert ist bleibt der
//STRIP001 	// Print-Monitor dort stehen, auf den anderen Plattformen kann man dann
//STRIP001 	// weiterarbeiten, also kommt das Teil weg
//STRIP001 	DELETEZ( pImp->pMonitor );
//STRIP001 #endif
//STRIP001 
//STRIP001 	pImp->bDeleteOnEndPrint = TRUE;
//STRIP001 	if ( !pImp->bRunning )
//STRIP001 		delete this;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxPrintProgress::RestoreOnEndPrint( SfxPrinter *pOldPrinter,
//STRIP001 										  BOOL bOldEnablePrintFile )
//STRIP001 {
//STRIP001 	pImp->pOldPrinter = pOldPrinter;
//STRIP001 	pImp->bOldEnablePrintFile = bOldEnablePrintFile;
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxPrintProgress::RestoreOnEndPrint( SfxPrinter *pOldPrinter )
//STRIP001 {
//STRIP001 	RestoreOnEndPrint( pOldPrinter, FALSE );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxPrintProgress::SetCancelHdl( const Link& aCancelHdl )
//STRIP001 {
//STRIP001 	pImp->aCancelHdl = aCancelHdl;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SfxPrintProgress::IsAborted() const
//STRIP001 {
//STRIP001 	return pImp->bAborted;
//STRIP001 }
}
