/*************************************************************************
 *
 *  $RCSfile: svx_hldoctp.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "hyperdlg.hxx"

#ifndef _UNOTOOLS_LOCALFILEHELPER_HXX
#include <unotools/localfilehelper.hxx>
#endif
#ifndef _FILEDLGHELPER_HXX
#include <bf_sfx2/filedlghelper.hxx>
#endif

#include "hldoctp.hxx"
#include "hyperdlg.hrc"
namespace binfilter {

//STRIP001 sal_Char __READONLY_DATA sHash[]				= "#";
//STRIP001 sal_Char __READONLY_DATA sFileScheme[]			= INET_FILE_SCHEME;
//STRIP001 sal_Char __READONLY_DATA sPortalFileScheme[]    = "vnd.sun.star.wfs://";
//STRIP001 sal_Char __READONLY_DATA sNewsSRVScheme[] = "news://";
//STRIP001     // TODO news:// is nonsense
//STRIP001 sal_Char __READONLY_DATA sHTTPScheme[]    = INET_HTTP_SCHEME;
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Contructor / Destructor
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 SvxHyperlinkDocTp::SvxHyperlinkDocTp ( Window *pParent, const SfxItemSet& rItemSet)
//STRIP001 :	maGrpDocument	( this, ResId (GRP_DOCUMENT) ),
//STRIP001 	maFtPath		( this, ResId (FT_PATH_DOC) ),
//STRIP001 	maCbbPath		( this, INET_PROT_FILE ),
//STRIP001 	maBtFileopen	( this, ResId (BTN_FILEOPEN) ),
//STRIP001 	maGrpTarget		( this, ResId (GRP_TARGET) ),
//STRIP001 	maFtTarget		( this, ResId (FT_TARGET_DOC) ),
//STRIP001 	maEdTarget		( this, ResId (ED_TARGET_DOC) ),
//STRIP001 	maFtURL			( this, ResId (FT_URL) ),
//STRIP001 	maFtFullURL		( this, ResId (FT_FULL_URL) ),
//STRIP001 	maBtBrowse		( this, ResId (BTN_BROWSE) ),
//STRIP001 	mbMarkWndOpen	( FALSE ),
//STRIP001 	SvxHyperlinkTabPageBase ( pParent, SVX_RES( RID_SVXPAGE_HYPERLINK_DOCUMENT ), rItemSet )
//STRIP001 {
//STRIP001 	// Set HC bitmaps and disable display of bitmap names.
//STRIP001 	maBtBrowse.SetModeImage( Image( ResId( IMG_BROWSE_HC ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001     maBtBrowse.EnableTextDisplay (FALSE);
//STRIP001 	maBtFileopen.SetModeImage( Image( ResId( IMG_FILEOPEN_HC ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001     maBtFileopen.EnableTextDisplay (FALSE);
//STRIP001 
//STRIP001 	InitStdControls();
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	// Init URL-Box (pos&size, Open-Handler)
//STRIP001 	maCbbPath.SetPosSizePixel ( LogicToPixel( Point( COL_2, 15 ), MAP_APPFONT ),
//STRIP001 		                        LogicToPixel( Size ( 176 - COL_DIFF, 60), MAP_APPFONT ) );
//STRIP001 	maCbbPath.Show();
//STRIP001 	String aFileScheme( INET_FILE_SCHEME, RTL_TEXTENCODING_ASCII_US );
//STRIP001 	maCbbPath.SetBaseURL(aFileScheme);
//STRIP001 	maCbbPath.SetHelpId( HID_HYPERDLG_DOC_PATH );
//STRIP001 
//STRIP001 	SetExchangeSupport ();
//STRIP001 
//STRIP001 	// overload handlers
//STRIP001 	maBtFileopen.SetClickHdl ( LINK ( this, SvxHyperlinkDocTp, ClickFileopenHdl_Impl ) );
//STRIP001 	maBtBrowse.SetClickHdl   ( LINK ( this, SvxHyperlinkDocTp, ClickTargetHdl_Impl ) );
//STRIP001 	maCbbPath.SetModifyHdl   ( LINK ( this, SvxHyperlinkDocTp, ModifiedPathHdl_Impl ) );
//STRIP001 	maEdTarget.SetModifyHdl  ( LINK ( this, SvxHyperlinkDocTp, ModifiedTargetHdl_Impl ) );
//STRIP001 
//STRIP001 	maCbbPath.SetLoseFocusHdl( LINK ( this, SvxHyperlinkDocTp, LostFocusPathHdl_Impl ) );
//STRIP001 
//STRIP001 	maTimer.SetTimeoutHdl ( LINK ( this, SvxHyperlinkDocTp, TimeoutHdl_Impl ) );
//STRIP001 }
//STRIP001 
//STRIP001 SvxHyperlinkDocTp::~SvxHyperlinkDocTp ()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fill all dialog-controls except controls in groupbox "more..."
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 void SvxHyperlinkDocTp::FillDlgFields ( String& aStrURL )
//STRIP001 {
//STRIP001 	INetURLObject aURL ( aStrURL );
//STRIP001 
//STRIP001 	String aStrMark;
//STRIP001 	xub_StrLen nPos = aStrURL.SearchAscii( sHash );
//STRIP001 	// path
//STRIP001 	maCbbPath.SetText ( aStrURL.Copy( 0, ( nPos == STRING_NOTFOUND ? aStrURL.Len() : nPos ) ) );
//STRIP001 
//STRIP001 	// set target in document at editfield
//STRIP001 	if ( nPos != STRING_NOTFOUND && nPos<aStrURL.Len()-1 )
//STRIP001 		aStrMark = aStrURL.Copy( nPos+1, aStrURL.Len() );
//STRIP001 	 maEdTarget.SetText ( aStrMark );
//STRIP001 
//STRIP001 	ModifiedPathHdl_Impl ( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* retrieve current url-string
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 String SvxHyperlinkDocTp::GetCurrentURL ()
//STRIP001 {
//STRIP001 	// get data from dialog-controls
//STRIP001 	String aStrURL;
//STRIP001 	String aStrPath ( maCbbPath.GetText() );
//STRIP001 	const String aBaseURL ( maCbbPath.GetBaseURL() );
//STRIP001 	String aStrMark( maEdTarget.GetText() );
//STRIP001 
//STRIP001 	if ( aStrPath != aEmptyStr )
//STRIP001 	{
//STRIP001         INetURLObject aURL( aStrPath );
//STRIP001         if ( aURL.GetProtocol() != INET_PROT_NOT_VALID )    // maybe the path is already a valid
//STRIP001             aStrURL = aStrPath;                             // hyperlink, then we can use this path directly
//STRIP001         else
//STRIP001 		    utl::LocalFileHelper::ConvertSystemPathToURL( aStrPath, aBaseURL, aStrURL );
//STRIP001 
//STRIP001         //#105788# always create a URL even if it is not valid
//STRIP001         if( aStrURL == aEmptyStr )
//STRIP001             aStrURL = aStrPath;
//STRIP001     }
//STRIP001 
//STRIP001 	if( aStrMark != aEmptyStr )
//STRIP001 	{
//STRIP001 		aStrURL.AppendAscii( sHash ); 
//STRIP001 		aStrURL += aStrMark;
//STRIP001 	}
//STRIP001 
//STRIP001 	return aStrURL;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* retrieve and prepare data from dialog-fields
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 void SvxHyperlinkDocTp::GetCurentItemData ( String& aStrURL, String& aStrName,
//STRIP001 										    String& aStrIntName, String& aStrFrame,
//STRIP001 											SvxLinkInsertMode& eMode )
//STRIP001 {
//STRIP001 	// get data from standard-fields
//STRIP001 	aStrURL = GetCurrentURL();
//STRIP001 
//STRIP001 	if( aStrURL.EqualsIgnoreCaseAscii( sFileScheme ) ||
//STRIP001 		aStrURL.EqualsIgnoreCaseAscii( sPortalFileScheme ) )
//STRIP001 		 aStrURL=aEmptyStr;
//STRIP001 
//STRIP001 	GetDataFromCommonFields( aStrName, aStrIntName, aStrFrame, eMode );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* static method to create Tabpage
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IconChoicePage* SvxHyperlinkDocTp::Create( Window* pWindow, const SfxItemSet& rItemSet )
//STRIP001 {
//STRIP001 	return( new SvxHyperlinkDocTp( pWindow, rItemSet ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Set initial focus
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 void SvxHyperlinkDocTp::SetInitFocus()
//STRIP001 {
//STRIP001 	maCbbPath.GrabFocus();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Click on imagebutton : fileopen
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK ( SvxHyperlinkDocTp, ClickFileopenHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	// Open Fileopen-Dialog
//STRIP001    	::sfx2::FileDialogHelper aDlg( ::sfx2::FILEOPEN_SIMPLE, 0, GetParent() );
//STRIP001 	String aOldURL( GetCurrentURL() );
//STRIP001 	if( aOldURL.EqualsIgnoreCaseAscii( sFileScheme, 0, sizeof( sFileScheme ) - 1 ) ||
//STRIP001 		aOldURL.EqualsIgnoreCaseAscii( sPortalFileScheme, 0, sizeof( sFileScheme ) - 1 ) )
//STRIP001 	{
//STRIP001 		aDlg.SetDisplayDirectory( aOldURL );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aDlg.Execute() == ERRCODE_NONE )
//STRIP001 	{
//STRIP001 		String aURL( aDlg.GetPath() );
//STRIP001 		String aPath;
//STRIP001 
//STRIP001 		utl::LocalFileHelper::ConvertURLToSystemPath( aURL, aPath );
//STRIP001 
//STRIP001 		maCbbPath.SetBaseURL( aURL );
//STRIP001 		maCbbPath.SetText( aPath );
//STRIP001 
//STRIP001 		if ( aOldURL != GetCurrentURL() )
//STRIP001 			ModifiedPathHdl_Impl (NULL);
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Click on imagebutton : target
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK ( SvxHyperlinkDocTp, ClickTargetHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	if ( GetPathType ( maStrURL ) == Type_ExistsFile  ||
//STRIP001 		 maStrURL == aEmptyStr                        ||
//STRIP001 		 maStrURL.EqualsIgnoreCaseAscii( sFileScheme ) ||
//STRIP001 		 maStrURL.EqualsIgnoreCaseAscii( sPortalFileScheme ) ||
//STRIP001 		 maStrURL.SearchAscii( sHash ) == 0 )
//STRIP001 	{
//STRIP001 		mpMarkWnd->SetError( LERR_NOERROR );
//STRIP001 
//STRIP001 		EnterWait();
//STRIP001 
//STRIP001 		if ( maStrURL.EqualsIgnoreCaseAscii( sFileScheme ) ||
//STRIP001 			 maStrURL.EqualsIgnoreCaseAscii( sPortalFileScheme ) )
//STRIP001 			mpMarkWnd->RefreshTree ( aEmptyStr );
//STRIP001 		else
//STRIP001 			mpMarkWnd->RefreshTree ( maStrURL );
//STRIP001 
//STRIP001 		LeaveWait();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		mpMarkWnd->SetError( LERR_DOCNOTOPEN );
//STRIP001 
//STRIP001 	ShowMarkWnd ();
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Contens of combobox "Path" modified
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK ( SvxHyperlinkDocTp, ModifiedPathHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	maStrURL = GetCurrentURL();
//STRIP001 
//STRIP001 	maTimer.SetTimeout( 2500 );
//STRIP001 	maTimer.Start();
//STRIP001 
//STRIP001 	maFtFullURL.SetText( maStrURL );
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* If path-field was modify, to browse the new doc after timeout
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK ( SvxHyperlinkDocTp, TimeoutHdl_Impl, Timer *, EMPTYARG )
//STRIP001 {
//STRIP001 	if ( IsMarkWndVisible() && ( GetPathType( maStrURL )==Type_ExistsFile ||
//STRIP001 		                          maStrURL == aEmptyStr                   ||
//STRIP001 								  maStrURL.EqualsIgnoreCaseAscii( sFileScheme ) ) )
//STRIP001 	{
//STRIP001 		EnterWait();
//STRIP001 
//STRIP001 		if ( maStrURL.EqualsIgnoreCaseAscii( sFileScheme ) ||
//STRIP001 			 maStrURL.EqualsIgnoreCaseAscii( sPortalFileScheme ) )
//STRIP001 			mpMarkWnd->RefreshTree ( aEmptyStr );
//STRIP001 		else
//STRIP001 			mpMarkWnd->RefreshTree ( maStrURL );
//STRIP001 
//STRIP001 		LeaveWait();
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Contens of editfield "Target" modified
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK ( SvxHyperlinkDocTp, ModifiedTargetHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	maStrURL = GetCurrentURL();
//STRIP001 
//STRIP001 	if ( IsMarkWndVisible() )
//STRIP001 		mpMarkWnd->SelectEntry ( maEdTarget.GetText() );
//STRIP001 
//STRIP001 	maFtFullURL.SetText( maStrURL );
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* editfield "Target" lost focus
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK ( SvxHyperlinkDocTp, LostFocusPathHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	maStrURL = GetCurrentURL();
//STRIP001 
//STRIP001 	maFtFullURL.SetText( maStrURL );
//STRIP001 
//STRIP001 	return (0L);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Get String from Bookmark-Wnd
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 void SvxHyperlinkDocTp::SetMarkStr ( String& aStrMark )
//STRIP001 {
//STRIP001 	maEdTarget.SetText ( aStrMark );
//STRIP001 
//STRIP001 	ModifiedTargetHdl_Impl ( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* retrieve kind of pathstr
//STRIP001 |*
//STRIP001 |************************************************************************/
//STRIP001 
//STRIP001 SvxHyperlinkDocTp::EPathType SvxHyperlinkDocTp::GetPathType ( String& aStrPath )
//STRIP001 {
//STRIP001 	BOOL bExists = FALSE;
//STRIP001 	INetURLObject aURL( aStrPath, INET_PROT_FILE );
//STRIP001 
//STRIP001 	if( aURL.HasError() )
//STRIP001 		return Type_Invalid;
//STRIP001 	else
//STRIP001 		return Type_ExistsFile;
//STRIP001 
//STRIP001 	return Type_Unknown;
//STRIP001 }
}
