/*************************************************************************
 *
 *  $RCSfile: hlinettp.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:59:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_TABPAGE_INET_HYPERLINK_HXX
#define _SVX_TABPAGE_INET_HYPERLINK_HXX

// auto strip #ifndef _SVX_TAB_HYPERLINK_HXX
// auto strip #include <hyperdlg.hxx>
// auto strip #endif

// auto strip #include "hltpbase.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Tabpage : Hyperlink - Internet
|*
\************************************************************************/

//STRIP001 class SvxHyperlinkInternetTp : public SvxHyperlinkTabPageBase
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine			maGrpLinkTyp;
//STRIP001 	RadioButton         maRbtLinktypInternet;
//STRIP001 	RadioButton         maRbtLinktypFTP;
//STRIP001 	RadioButton         maRbtLinktypTelnet;
//STRIP001 	FixedText           maFtTarget;
//STRIP001 	SvxHyperURLBox		maCbbTarget;
//STRIP001 	FixedText			maFtLogin;
//STRIP001 	Edit				maEdLogin;
//STRIP001 	FixedText			maFtPassword;
//STRIP001 	Edit				maEdPassword;
//STRIP001 	CheckBox			maCbAnonymous;
//STRIP001 	ImageButton			maBtBrowse;
//STRIP001 	ImageButton			maBtTarget;
//STRIP001 
//STRIP001 	String				maStrOldUser;
//STRIP001 	String				maStrOldPassword;
//STRIP001 
//STRIP001 	BOOL				mbMarkWndOpen;
//STRIP001 
//STRIP001 	String				maStrStdDocURL;
//STRIP001 
//STRIP001     DECL_LINK (Click_SmartProtocol_Impl  , void * );	    // Radiobutton clicked: Type Internet, FTP or Telnet
//STRIP001 	DECL_LINK (ClickAnonymousHdl_Impl    , void * );		// Checkbox : Anonymer Benutzer
//STRIP001 	DECL_LINK (ClickBrowseHdl_Impl       , void * );		// Button : Browse
//STRIP001 	DECL_LINK (ClickTargetHdl_Impl       , void * );		// Button : Ziel
//STRIP001 	DECL_LINK (ModifiedLoginHdl_Impl     , void * );		// Contens of editfield "Login" modified
//STRIP001 	DECL_LINK (LostFocusTargetHdl_Impl   , void * );		// Combobox "Target" lost its focus
//STRIP001 	DECL_LINK (ModifiedTargetHdl_Impl    , void * );		// Contens of editfield "Target" modified
//STRIP001 
//STRIP001 	DECL_LINK (TimeoutHdl_Impl           , Timer * );		// Handler for timer -timeout
//STRIP001 
//STRIP001 
//STRIP001     void    SetScheme( const String& aScheme );
//STRIP001     void    RemoveImproperProtocol(const String& aProperScheme);
//STRIP001     String  GetSchemeFromButtons() const;
//STRIP001 	INetProtocol GetSmartProtocolFromButtons() const;
//STRIP001 
//STRIP001     String CreateAbsoluteURL() const;
//STRIP001 
//STRIP001     void   setAnonymousFTPUser();
//STRIP001     void   setFTPUser(const String& rUser, const String& rPassword);
//STRIP001     void   RefreshMarkWindow();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void FillDlgFields	   ( String& aStrURL );
//STRIP001 	virtual void GetCurentItemData ( String& aStrURL, String& aStrName, 
//STRIP001 		                             String& aStrIntName, String& aStrFrame, 
//STRIP001 									 SvxLinkInsertMode& eMode );
//STRIP001 	virtual BOOL ShouldOpenMarkWnd () {return ( mbMarkWndOpen && maRbtLinktypInternet.IsChecked() );}
//STRIP001 	virtual void SetMarkWndShouldOpen (BOOL bOpen) {mbMarkWndOpen=bOpen;}
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxHyperlinkInternetTp ( Window *pParent, const SfxItemSet& rItemSet);
//STRIP001 	~SvxHyperlinkInternetTp ();
//STRIP001 
//STRIP001 	static  IconChoicePage* Create( Window* pWindow, const SfxItemSet& rItemSet );
//STRIP001 
//STRIP001 	virtual void		SetMarkStr ( String& aStrMark );
//STRIP001 	virtual void		SetOnlineMode( BOOL bEnable );
//STRIP001 
//STRIP001 	virtual void		SetInitFocus();
//STRIP001 };


}//end of namespace binfilter
#endif // _SVX_TABPAGE_INET_HYPERLINK_HXX
