/*************************************************************************
 *
 *  $RCSfile: sw_fecopy.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:27:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HINTIDS_HXX
#include <hintids.hxx>
#endif

#ifdef WIN
#define NEEDED_BY_FESHVIEW
#endif

// auto strip #ifndef _GRAPH_HXX
// auto strip #include <vcl/graph.hxx>
// auto strip #endif
// auto strip #ifndef _SOT_FORMATS_HXX
// auto strip #include <sot/formats.hxx>
// auto strip #endif
// auto strip #ifndef _SVSTOR_HXX
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
// auto strip #ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
// auto strip #include <svtools/pathoptions.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWSH_HXX
// auto strip #include <bf_sfx2/viewsh.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XEXCH_HXX
// auto strip #include <bf_svx/xexch.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLASIT_HXX
// auto strip #include <bf_svx/xflasit.hxx>
// auto strip #endif
// auto strip #ifndef SVX_XFILLIT0_HXX
// auto strip #include <bf_svx/xfillit0.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLCLIT_HXX
// auto strip #include <bf_svx/xflclit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BRSHITEM_HXX
// auto strip #include <bf_svx/brshitem.hxx>
// auto strip #endif
#ifndef _SVX_SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
// auto strip #ifndef _SVDCAPT_HXX
// auto strip #include <bf_svx/svdocapt.hxx>
// auto strip #endif
#ifndef _SVDOUNO_HXX
#include <bf_svx/svdouno.hxx>
#endif
// auto strip #ifndef _SVX_FILLITEM_HXX
// auto strip #include <bf_svx/xfillit.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRP_HXX
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif
// auto strip #ifndef _XOUTBMP_HXX
// auto strip #include <bf_svx/xoutbmp.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOOLE2_HXX
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #endif
// auto strip #ifndef _FM_FMMODEL_HXX
// auto strip #include <bf_svx/fmmodel.hxx>
// auto strip #endif
// auto strip #ifndef SVX_UNOMODEL_HXX
// auto strip #include <bf_svx/unomodel.hxx>
// auto strip #endif
// auto strip #ifndef _UTL_STREAM_WRAPPER_HXX_
// auto strip #include <unotools/streamwrap.hxx>
// auto strip #endif

// auto strip #ifndef _FMTANCHR_HXX
// auto strip #include <fmtanchr.hxx>
// auto strip #endif
// auto strip #ifndef _FMTCNTNT_HXX
// auto strip #include <fmtcntnt.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _FMTORNT_HXX
// auto strip #include <fmtornt.hxx>
// auto strip #endif
// auto strip #ifndef _FMTFLCNT_HXX
// auto strip #include <fmtflcnt.hxx>
// auto strip #endif
// auto strip #ifndef _FRMFMT_HXX
// auto strip #include <frmfmt.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _TXTFRM_HXX
// auto strip #include <txtfrm.hxx>
// auto strip #endif
// auto strip #ifndef _TXTFLCNT_HXX
// auto strip #include <txtflcnt.hxx>
// auto strip #endif
// auto strip #ifndef _FESH_HXX
// auto strip #include <fesh.hxx>
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _ROOTFRM_HXX
// auto strip #include <rootfrm.hxx>
// auto strip #endif
#ifndef _CNTFRM_HXX
#include <cntfrm.hxx>
#endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _TBLSEL_HXX
// auto strip #include <tblsel.hxx>
// auto strip #endif
// auto strip #ifndef _SWTABLE_HXX
// auto strip #include <swtable.hxx>
// auto strip #endif
// auto strip #ifndef _FLYFRM_HXX
// auto strip #include <flyfrm.hxx>
// auto strip #endif
// auto strip #ifndef _PAGEFRM_HXX
// auto strip #include <pagefrm.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>
// auto strip #endif
// auto strip #ifndef _EDIMP_HXX
// auto strip #include <edimp.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>
// auto strip #endif
// auto strip #ifndef _VIEWIMP_HXX
// auto strip #include <viewimp.hxx>
// auto strip #endif
// auto strip #ifndef _DVIEW_HXX
// auto strip #include <dview.hxx>
// auto strip #endif
// auto strip #ifndef _DCONTACT_HXX
// auto strip #include <dcontact.hxx>
// auto strip #endif
// auto strip #ifndef _DFLYOBJ_HXX
// auto strip #include <dflyobj.hxx>
// auto strip #endif
// auto strip #ifndef _REDLENUM_HXX
// auto strip #include <redlenum.hxx>
// auto strip #endif
// auto strip #ifndef _DOCSH_HXX
// auto strip #include <docsh.hxx>
// auto strip #endif
namespace binfilter {


//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	FindPageFrm(), Sucht den PageFrm zum Pt, die StartPage wird hereingereicht.
//STRIP001 |*
//STRIP001 |*	Ersterstellung		MA 11. Oct. 95
//STRIP001 |*	Letzte Aenderung	MA 11. Oct. 95
//STRIP001 |
//STRIP001 |*************************************************************************/
//STRIP001 const SwFrm *FindPage( const SwFrm *pPg, const Point &rPt )
//STRIP001 {
//STRIP001 	if ( !pPg->Frm().IsInside( rPt ) )
//STRIP001 	{
//STRIP001 		const long nTop = rPt.Y();
//STRIP001 		FASTBOOL bPrvAllowed = TRUE;
//STRIP001 		FASTBOOL bNxtAllowed = TRUE;
//STRIP001 		do
//STRIP001 		{   if ( pPg->Frm().Top() > nTop && bPrvAllowed )
//STRIP001 			{
//STRIP001 				if ( pPg->GetPrev() )
//STRIP001 				{
//STRIP001 					bNxtAllowed = FALSE;
//STRIP001 					pPg = pPg->GetPrev();
//STRIP001 				}
//STRIP001 				else
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			else if ( pPg->Frm().Bottom() < nTop && bNxtAllowed )
//STRIP001 			{
//STRIP001 				if ( pPg->GetNext() )
//STRIP001 				{
//STRIP001 					bPrvAllowed = FALSE;
//STRIP001 					pPg = pPg->GetNext();
//STRIP001 				}
//STRIP001 				else
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				break;
//STRIP001 
//STRIP001 		} while ( !pPg->Frm().IsInside( rPt ) );
//STRIP001 	}
//STRIP001 	return pPg;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SwFEShell::Copy()	Copy fuer das Interne Clipboard.
//STRIP001 |*		Kopiert alle Selektionen in das Clipboard.
//STRIP001 |*
//STRIP001 |*	Ersterstellung		JP ??
//STRIP001 |*	Letzte Aenderung	MA 22. Feb. 95
//STRIP001 |
//STRIP001 |*************************************************************************/
//STRIP001 
//STRIP001 BOOL SwFEShell::Copy( SwDoc* pClpDoc, const String* pNewClpTxt )
//STRIP001 {
//STRIP001 	ASSERT( pClpDoc, "kein Clipboard-Dokument"	);
//STRIP001 
//STRIP001 	pClpDoc->DoUndo( FALSE );		// immer auf FALSE !!
//STRIP001 
//STRIP001 	// steht noch Inhalt im ClpDocument, dann muss dieser geloescht werden
//STRIP001 	SwNodeIndex aSttIdx( pClpDoc->GetNodes().GetEndOfExtras(), 2 );
//STRIP001 	SwTxtNode* pTxtNd = aSttIdx.GetNode().GetTxtNode();
//STRIP001 	if( !pTxtNd || pTxtNd->GetTxt().Len() ||
//STRIP001 		aSttIdx.GetIndex()+1 != pClpDoc->GetNodes().GetEndOfContent().GetIndex() )
//STRIP001 	{
//STRIP001 		pClpDoc->GetNodes().Delete( aSttIdx,
//STRIP001 			pClpDoc->GetNodes().GetEndOfContent().GetIndex() - aSttIdx.GetIndex() );
//STRIP001 		pTxtNd = pClpDoc->GetNodes().MakeTxtNode( aSttIdx,
//STRIP001 							(SwTxtFmtColl*)pClpDoc->GetDfltTxtFmtColl() );
//STRIP001 		aSttIdx--;
//STRIP001 	}
//STRIP001 
//STRIP001 	// stehen noch FlyFrames rum, loesche auch diese
//STRIP001 	for( USHORT n = 0; n < pClpDoc->GetSpzFrmFmts()->Count(); ++n )
//STRIP001 	{
//STRIP001 		SwFlyFrmFmt* pFly = (SwFlyFrmFmt*)(*pClpDoc->GetSpzFrmFmts())[n];
//STRIP001 		pClpDoc->DelLayoutFmt( pFly );
//STRIP001 	}
//STRIP001 	pClpDoc->GCFieldTypes();		// loesche die FieldTypes
//STRIP001 
//STRIP001 	// wurde ein String uebergeben, so kopiere diesen in das Clipboard-
//STRIP001 	// Dokument. Somit kann auch der Calculator das interne Clipboard
//STRIP001 	// benutzen.
//STRIP001 	if( pNewClpTxt )
//STRIP001 	{
//STRIP001 		pTxtNd->Insert( *pNewClpTxt, SwIndex( pTxtNd ) );
//STRIP001 		return TRUE;				// das wars.
//STRIP001 	}
//STRIP001 
//STRIP001 	pClpDoc->LockExpFlds();
//STRIP001 	pClpDoc->SetRedlineMode_intern( REDLINE_DELETE_REDLINES );
//STRIP001 	BOOL bRet;
//STRIP001 
//STRIP001 	// soll ein FlyFrame kopiert werden ?
//STRIP001 	if( IsFrmSelected() )
//STRIP001 	{
//STRIP001 		// hole das FlyFormat
//STRIP001 		SwFlyFrm* pFly = FindFlyFrm();
//STRIP001 		SwFrmFmt* pFlyFmt = pFly->GetFmt();
//STRIP001 		SwFmtAnchor aAnchor( pFlyFmt->GetAnchor() );
//STRIP001 
//STRIP001 		if ( FLY_AT_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 			 FLY_AUTO_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 			 FLY_AT_FLY == aAnchor.GetAnchorId() ||
//STRIP001 			 FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 		{
//STRIP001 			SwPosition aPos( aSttIdx );
//STRIP001 			if( FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 				aPos.nContent.Assign( pTxtNd, 0 );
//STRIP001 			aAnchor.SetAnchor( &aPos );
//STRIP001 		}
//STRIP001 		pFlyFmt = pClpDoc->CopyLayoutFmt( *pFlyFmt, aAnchor );
//STRIP001 
//STRIP001 		// sorge dafuer das das "RootFmt" als erstes im SpzArray-steht
//STRIP001 		// (Es wurden ggf. Flys in Flys kopiert.
//STRIP001 		SwSpzFrmFmts& rSpzFrmFmts = *(SwSpzFrmFmts*)pClpDoc->GetSpzFrmFmts();
//STRIP001 		if( rSpzFrmFmts[ 0 ] != pFlyFmt )
//STRIP001 		{
//STRIP001 			USHORT nPos = rSpzFrmFmts.GetPos( pFlyFmt );
//STRIP001 			ASSERT( nPos != USHRT_MAX, "Fly steht nicht im Spz-Array" );
//STRIP001 
//STRIP001 			rSpzFrmFmts.Remove( nPos );
//STRIP001 			rSpzFrmFmts.Insert( pFlyFmt, 0 );
//STRIP001 		}
//STRIP001 
//STRIP001 		if( FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 		{
//STRIP001 			// JP 13.02.99 Bug 61863: wenn eine Rahmenselektion ins Clipboard
//STRIP001 			//				gestellt wird, so muss beim Pasten auch wieder
//STRIP001 			//				eine solche vorgefunden werden. Also muss im Node
//STRIP001 			//				das kopierte TextAttribut wieder entfernt werden,
//STRIP001 			//				sonst wird es als TextSelektion erkannt
//STRIP001 			const SwIndex& rIdx = pFlyFmt->GetAnchor().GetCntntAnchor()->nContent;
//STRIP001 			SwTxtFlyCnt* pTxtFly = (SwTxtFlyCnt*)pTxtNd->GetTxtAttr(
//STRIP001 												rIdx, RES_TXTATR_FLYCNT );
//STRIP001 			if( pTxtFly )
//STRIP001 			{
//STRIP001 				((SwFmtFlyCnt&)pTxtFly->GetFlyCnt()).SetFlyFmt( 0 );
//STRIP001 				pTxtNd->Erase( rIdx, 1 );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		bRet = TRUE;
//STRIP001 	}
//STRIP001 	else if ( IsObjSelected() )
//STRIP001 	{
//STRIP001 		Size aSiz( 0, - GetDoc()->GetDrawModel()->GetPage( 0 )->
//STRIP001 						GetAllObjBoundRect().Top() );
//STRIP001 
//STRIP001 		SwPosition aPos( aSttIdx, SwIndex( pTxtNd, 0 ));
//STRIP001 		const SdrMarkList &rMrkList = Imp()->GetDrawView()->GetMarkList();
//STRIP001 		for ( USHORT i = 0; i < rMrkList.GetMarkCount(); ++i )
//STRIP001 		{
//STRIP001 			SdrObject *pObj = rMrkList.GetMark( i )->GetObj();
//STRIP001 
//STRIP001 			if( Imp()->GetDrawView()->IsGroupEntered() ||
//STRIP001 				( !pObj->GetUserCall() && pObj->GetUpGroup()) )
//STRIP001 			{
//STRIP001 				SfxItemSet aSet( pClpDoc->GetAttrPool(), aFrmFmtSetRange );
//STRIP001 
//STRIP001 				SwFmtAnchor aAnchor( FLY_AT_CNTNT );
//STRIP001 				aAnchor.SetAnchor( &aPos );
//STRIP001 				aSet.Put( aAnchor );
//STRIP001 
//STRIP001     			SdrObject* pNew = pClpDoc->CloneSdrObj( *pObj, FALSE, TRUE );
//STRIP001 
//STRIP001 //JP 07.01.00: why move??
//STRIP001 //				pNew->NbcMove( aSiz );
//STRIP001    				pClpDoc->Insert( SwPaM( aPos ), *pNew, &aSet );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SwDrawContact *pContact = (SwDrawContact*)GetUserCall( pObj );
//STRIP001 				SwFrmFmt *pFmt = pContact->GetFmt();
//STRIP001 				SwFmtAnchor aAnchor( pFmt->GetAnchor() );
//STRIP001 				if ( FLY_AT_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 					 FLY_AUTO_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 					 FLY_AT_FLY == aAnchor.GetAnchorId() ||
//STRIP001 					 FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 				{
//STRIP001 					aAnchor.SetAnchor( &aPos );
//STRIP001 				}
//STRIP001 
//STRIP001 				pClpDoc->CopyLayoutFmt( *pFmt, aAnchor );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		bRet = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		bRet = _CopySelToDoc( pClpDoc, 0 );		// kopiere die Selectionen
//STRIP001 
//STRIP001 	pClpDoc->SetRedlineMode_intern( 0 );
//STRIP001 	pClpDoc->UnlockExpFlds();
//STRIP001 	if( !pClpDoc->IsExpFldsLocked() )
//STRIP001 		pClpDoc->UpdateExpFlds();
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 const Point &lcl_FindBasePos( const SwFrm *pFrm, const Point &rPt )
//STRIP001 {
//STRIP001 	const SwFrm *pF = pFrm;
//STRIP001 	while ( pF && !pF->Frm().IsInside( rPt ) )
//STRIP001 	{
//STRIP001 		if ( pF->IsCntntFrm() )
//STRIP001 			pF = ((SwCntntFrm*)pF)->GetFollow();
//STRIP001 		else
//STRIP001 			pF = 0;
//STRIP001 	}
//STRIP001 	if ( pF )
//STRIP001 		return pF->Frm().Pos();
//STRIP001 	else
//STRIP001 		return pFrm->Frm().Pos();
//STRIP001 }
//STRIP001 
//STRIP001 BOOL lcl_SetAnchor( const SwPosition& rPos, const SwNode& rNd, SwFlyFrm* pFly,
//STRIP001 				const Point& rInsPt, SwFEShell& rDestShell, SwFmtAnchor& rAnchor,
//STRIP001 				Point& rNewPos, BOOL bCheckFlyRecur )
//STRIP001 {
//STRIP001 	BOOL bRet = TRUE;
//STRIP001 	rAnchor.SetAnchor( &rPos );
//STRIP001 	SwCntntFrm* pTmpFrm = rNd.GetCntntNode()->GetFrm( &rInsPt, 0, FALSE );
//STRIP001 	SwFlyFrm *pTmpFly = pTmpFrm->FindFlyFrm();
//STRIP001 	if( pTmpFly && bCheckFlyRecur && pFly->IsUpperOf( pTmpFly ) )
//STRIP001 		bRet = FALSE;
//STRIP001 	else if ( FLY_AT_FLY == rAnchor.GetAnchorId() )
//STRIP001 	{
//STRIP001 		if( pTmpFly )
//STRIP001 		{
//STRIP001 			const SwNodeIndex& rIdx = *pTmpFly->GetFmt()->GetCntnt().GetCntntIdx();
//STRIP001 			SwPosition aPos( rIdx );
//STRIP001 			rAnchor.SetAnchor( &aPos );
//STRIP001 			rNewPos = pTmpFly->Frm().Pos();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			rAnchor.SetType( FLY_PAGE );
//STRIP001 			rAnchor.SetPageNum( rDestShell.GetPageNumber( rInsPt ) );
//STRIP001 			const SwFrm *pPg = pTmpFrm->FindPageFrm();
//STRIP001 			rNewPos = pPg->Frm().Pos();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rNewPos = ::lcl_FindBasePos( pTmpFrm, rInsPt );
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SwFEShell::CopyDrawSel( SwFEShell* pDestShell, const Point& rSttPt,
//STRIP001 					const Point& rInsPt, BOOL bIsMove, BOOL bSelectInsert )
//STRIP001 {
//STRIP001 	BOOL bRet = TRUE;
//STRIP001 
//STRIP001 	//Die Liste muss kopiert werden, weil unten die neuen Objekte
//STRIP001 	//selektiert werden.
//STRIP001 	const SdrMarkList aMrkList( Imp()->GetDrawView()->GetMarkList() );
//STRIP001 	ULONG nMarkCount = aMrkList.GetMarkCount();
//STRIP001 	if( !pDestShell->Imp()->GetDrawView() )
//STRIP001 		// sollte mal eine erzeugt werden
//STRIP001 		pDestShell->MakeDrawView();
//STRIP001 	else if( bSelectInsert )
//STRIP001 		pDestShell->Imp()->GetDrawView()->UnmarkAll();
//STRIP001 
//STRIP001 	SdrPageView *pDestPgView = pDestShell->Imp()->GetPageView(),
//STRIP001 				*pSrcPgView = Imp()->GetPageView();
//STRIP001 	SwDrawView *pDestDrwView = pDestShell->Imp()->GetDrawView(),
//STRIP001 				*pSrcDrwView = Imp()->GetDrawView();
//STRIP001 	SwDoc* pDestDoc = pDestShell->GetDoc();
//STRIP001 
//STRIP001 	Size aSiz( rInsPt.X() - rSttPt.X(), rInsPt.Y() - rSttPt.Y() );
//STRIP001 	for( USHORT i = 0; i < nMarkCount; ++i )
//STRIP001 	{
//STRIP001 		SdrObject *pObj = aMrkList.GetMark( i )->GetObj();
//STRIP001 
//STRIP001 		SwDrawContact *pContact = (SwDrawContact*)GetUserCall( pObj );
//STRIP001 		SwFrmFmt *pFmt = pContact->GetFmt();
//STRIP001 		const SwFmtAnchor& rAnchor = pFmt->GetAnchor();
//STRIP001 
//STRIP001 		BOOL bInsWithFmt = TRUE;
//STRIP001 
//STRIP001 		if( pDestDrwView->IsGroupEntered() )
//STRIP001 		{
//STRIP001 			// in die Gruppe einfuegen, wenns aus einer betretenen Gruppe
//STRIP001 			// kommt oder das Object nicht zeichengebunden ist
//STRIP001 			if( pSrcDrwView->IsGroupEntered() ||
//STRIP001 				FLY_IN_CNTNT != rAnchor.GetAnchorId() )
//STRIP001 
//STRIP001 			{
//STRIP001 				SdrObject* pNew = pDestDoc->CloneSdrObj( *pObj, bIsMove &&
//STRIP001 										GetDoc() == pDestDoc, FALSE );
//STRIP001 				pNew->NbcMove( aSiz );
//STRIP001 				pDestDrwView->InsertObject( pNew, *pDestPgView );
//STRIP001 				bInsWithFmt = FALSE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if( bInsWithFmt )
//STRIP001 		{
//STRIP001 			SwFmtAnchor aAnchor( rAnchor );
//STRIP001 			Point aNewAnch;
//STRIP001 
//STRIP001 			if ( FLY_AT_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 					FLY_AUTO_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 					FLY_AT_FLY == aAnchor.GetAnchorId() ||
//STRIP001 					FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 			{
//STRIP001 				if ( this == pDestShell )
//STRIP001 				{
//STRIP001 					//gleiche Shell? Dann erfrage die Position an der
//STRIP001 					//uebergebenen DokumentPosition
//STRIP001 					SwPosition aPos( *GetCrsr()->GetPoint() );
//STRIP001 					Point aPt( rInsPt );
//STRIP001 					aPt -= rSttPt - pObj->GetSnapRect().TopLeft();
//STRIP001 					SwCrsrMoveState aState( MV_SETONLYTEXT );
//STRIP001 					GetLayout()->GetCrsrOfst( &aPos, aPt, &aState );
//STRIP001 					const SwNode *pNd;
//STRIP001 					if( (pNd = &aPos.nNode.GetNode())->IsNoTxtNode() )
//STRIP001 						bRet = FALSE;
//STRIP001 					else
//STRIP001 						bRet = ::lcl_SetAnchor( aPos, *pNd, 0, rInsPt,
//STRIP001 								*pDestShell, aAnchor, aNewAnch, FALSE );
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					SwPaM *pCrsr = pDestShell->GetCrsr();
//STRIP001 					if( pCrsr->GetNode()->IsNoTxtNode() )
//STRIP001 						bRet = FALSE;
//STRIP001 					else
//STRIP001 						bRet = ::lcl_SetAnchor( *pCrsr->GetPoint(),
//STRIP001 												*pCrsr->GetNode(), 0, rInsPt,
//STRIP001 												*pDestShell, aAnchor,
//STRIP001 												aNewAnch, FALSE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else if( FLY_PAGE == aAnchor.GetAnchorId() )
//STRIP001 			{
//STRIP001 				aAnchor.SetPageNum( pDestShell->GetPageNumber( rInsPt ) );
//STRIP001 				const SwFrm *pPg = ::FindPage( pDestShell->GetLayout()->Lower(), rInsPt);
//STRIP001 				aNewAnch = pPg->Frm().Pos();
//STRIP001 			}
//STRIP001 
//STRIP001 			if( bRet )
//STRIP001 			{
//STRIP001 				if( pSrcDrwView->IsGroupEntered() ||
//STRIP001 					( !pObj->GetUserCall() && pObj->GetUpGroup()) )
//STRIP001 				{
//STRIP001 					SfxItemSet aSet( pDestDoc->GetAttrPool(),aFrmFmtSetRange);
//STRIP001 					aSet.Put( aAnchor );
//STRIP001 					SdrObject* pNew = pDestDoc->CloneSdrObj( *pObj, bIsMove &&
//STRIP001 												GetDoc() == pDestDoc, TRUE );
//STRIP001 					pFmt = pDestDoc->Insert( *pDestShell->GetCrsr(),
//STRIP001 											*pNew, &aSet );
//STRIP001 				}
//STRIP001 				else
//STRIP001 					pFmt = pDestDoc->CopyLayoutFmt( *pFmt, aAnchor );
//STRIP001 
//STRIP001 				//Kann 0 sein, weil Draws in Kopf-/Fusszeilen nicht erlaubt sind.
//STRIP001 				if ( pFmt )
//STRIP001 				{
//STRIP001 					SdrObject *pNew = pFmt->FindSdrObject();
//STRIP001 					if( FLY_IN_CNTNT != aAnchor.GetAnchorId() )
//STRIP001 					{
//STRIP001 						Point aPos( rInsPt );
//STRIP001 						aPos -= aNewAnch;
//STRIP001 						aPos -= rSttPt - pObj->GetSnapRect().TopLeft();
//STRIP001 						pNew->ImpSetAnchorPos( aNewAnch );
//STRIP001 						pNew->SetRelativePos( aPos );
//STRIP001 					}
//STRIP001 					if( bSelectInsert )
//STRIP001 						pDestDrwView->MarkObj( pNew, pDestPgView );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( bIsMove && bRet )
//STRIP001 	{
//STRIP001 		if( pDestShell == this )
//STRIP001 		{
//STRIP001 			const SdrMarkList aList( pSrcDrwView->GetMarkList() );
//STRIP001 			pSrcDrwView->UnmarkAll();
//STRIP001 
//STRIP001 			ULONG nMarkCount = aMrkList.GetMarkCount();
//STRIP001 			for ( USHORT i = 0; i < nMarkCount; ++i )
//STRIP001 			{
//STRIP001 				SdrObject *pObj = aMrkList.GetMark( i )->GetObj();
//STRIP001 				pSrcDrwView->MarkObj( pObj, pSrcPgView );
//STRIP001 			}
//STRIP001 			DelSelectedObj();
//STRIP001 			nMarkCount = aList.GetMarkCount();
//STRIP001 			for ( i = 0; i < nMarkCount; ++i )
//STRIP001 			{
//STRIP001 				SdrObject *pObj = aList.GetMark( i )->GetObj();
//STRIP001 				pSrcDrwView->MarkObj( pObj, pSrcPgView );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 			DelSelectedObj();
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SwFEShell::Copy( SwFEShell* pDestShell, const Point& rSttPt,
//STRIP001 					const Point& rInsPt, BOOL bIsMove, BOOL bSelectInsert )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	ASSERT( pDestShell, "Copy ohne DestShell." );
//STRIP001 	ASSERT( this == pDestShell || !pDestShell->IsObjSelected(),
//STRIP001 			"Dest-Shell darf nie im Obj-Modus sein" );
//STRIP001 
//STRIP001 	SET_CURR_SHELL( pDestShell );
//STRIP001 
//STRIP001 	pDestShell->StartAllAction();
//STRIP001 	pDestShell->GetDoc()->LockExpFlds();
//STRIP001 
//STRIP001 	// Referenzen sollen verschoben werden.
//STRIP001 	BOOL bCopyIsMove = pDoc->IsCopyIsMove();
//STRIP001 	if( bIsMove )
//STRIP001 		// am Doc ein Flag setzen, damit in den TextNodes
//STRIP001 		pDoc->SetCopyIsMove( TRUE );
//STRIP001 
//STRIP001 	SwRedlineMode eOldRedlMode = pDestShell->GetDoc()->GetRedlineMode();
//STRIP001 	pDestShell->GetDoc()->SetRedlineMode_intern( eOldRedlMode | REDLINE_DELETE_REDLINES );
//STRIP001 
//STRIP001 	// sind Tabellen-Formeln im Bereich, dann muss erst die Tabelle
//STRIP001 	// angezeigt werden, damit die Tabellen-Formel den neuen Wert errechnen
//STRIP001 	// kann (bei Bereichen wird sich ueber das Layout die einzelnen Boxen
//STRIP001 	// besorgt)
//STRIP001 	SwFieldType* pTblFldTyp = pDestShell->GetDoc()->GetSysFldType( RES_TABLEFLD );
//STRIP001 
//STRIP001 	if( IsFrmSelected() )
//STRIP001 	{
//STRIP001 		SwFlyFrm* pFly = FindFlyFrm();
//STRIP001 		SwFrmFmt* pFlyFmt = pFly->GetFmt();
//STRIP001 		SwFmtAnchor aAnchor( pFlyFmt->GetAnchor() );
//STRIP001 		bRet = TRUE;
//STRIP001 		Point aNewAnch;
//STRIP001 
//STRIP001 		if ( FLY_AT_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 			 FLY_AUTO_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 			 FLY_AT_FLY == aAnchor.GetAnchorId() ||
//STRIP001 			 FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 		{
//STRIP001 			if ( this == pDestShell )
//STRIP001 			{
//STRIP001 				// gleiche Shell? Dann erfrage die Position an der
//STRIP001 				// uebergebenen DokumentPosition
//STRIP001 				SwPosition aPos( *GetCrsr()->GetPoint() );
//STRIP001 				Point aPt( rInsPt );
//STRIP001 				aPt -= rSttPt - pFly->Frm().Pos();
//STRIP001 				SwCrsrMoveState aState( MV_SETONLYTEXT );
//STRIP001 				GetLayout()->GetCrsrOfst( &aPos, aPt, &aState );
//STRIP001 				const SwNode *pNd;
//STRIP001 				if( (pNd = &aPos.nNode.GetNode())->IsNoTxtNode() )
//STRIP001 					bRet = FALSE;
//STRIP001 				else
//STRIP001 				{	//Nicht in sich selbst kopieren
//STRIP001 					const SwNodeIndex *pTmp = pFlyFmt->GetCntnt().GetCntntIdx();
//STRIP001 					if ( aPos.nNode > *pTmp && aPos.nNode <
//STRIP001 						pTmp->GetNode().EndOfSectionIndex() )
//STRIP001 					{
//STRIP001 						bRet = FALSE;
//STRIP001 					}
//STRIP001 					else
//STRIP001 						bRet = ::lcl_SetAnchor( aPos, *pNd, pFly, rInsPt,
//STRIP001 										*pDestShell, aAnchor, aNewAnch, TRUE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				const SwPaM *pCrsr = pDestShell->GetCrsr();
//STRIP001 				if( pCrsr->GetNode()->IsNoTxtNode() )
//STRIP001 					bRet = FALSE;
//STRIP001 				else
//STRIP001 					bRet = ::lcl_SetAnchor( *pCrsr->GetPoint(), *pCrsr->GetNode(),
//STRIP001 											pFly, rInsPt, *pDestShell, aAnchor,
//STRIP001 									aNewAnch, GetDoc() == pDestShell->GetDoc());
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( FLY_PAGE == aAnchor.GetAnchorId() )
//STRIP001 		{
//STRIP001 			aAnchor.SetPageNum( pDestShell->GetPageNumber( rInsPt ) );
//STRIP001 			const SwFrm *pPg = ::FindPage( pDestShell->GetLayout()->Lower(), rInsPt);
//STRIP001 			aNewAnch = pPg->Frm().Pos();
//STRIP001 		}
//STRIP001 		else
//STRIP001 			ASSERT( !this, "was fuer ein Anchor ist es denn?" );
//STRIP001 
//STRIP001 		if( bRet )
//STRIP001 		{
//STRIP001 			SwFrmFmt *pOldFmt = pFlyFmt;
//STRIP001 			pFlyFmt = pDestShell->GetDoc()->CopyLayoutFmt( *pFlyFmt, aAnchor );
//STRIP001 
//STRIP001 			if( FLY_IN_CNTNT != aAnchor.GetAnchorId() )
//STRIP001 			{
//STRIP001 				Point aPos( rInsPt );
//STRIP001 				aPos -= aNewAnch;
//STRIP001 				aPos -= rSttPt - pFly->Frm().Pos();
//STRIP001 				pFlyFmt->SetAttr( SwFmtHoriOrient( aPos.X(),HORI_NONE,FRAME ) );
//STRIP001 				pFlyFmt->SetAttr( SwFmtVertOrient( aPos.Y(),VERT_NONE,FRAME ) );
//STRIP001 			}
//STRIP001 
//STRIP001 			const Point aPt( pDestShell->GetCrsrDocPos() );
//STRIP001 
//STRIP001 			if( bIsMove )
//STRIP001 				GetDoc()->DelLayoutFmt( pOldFmt );
//STRIP001 
//STRIP001 			// nur selektieren wenn es in der gleichen Shell verschoben/
//STRIP001 			//	kopiert wird
//STRIP001 			if( bSelectInsert )
//STRIP001 			{
//STRIP001 				SwFlyFrm* pFlyFrm = ((SwFlyFrmFmt*)pFlyFmt)->GetFrm( &aPt, FALSE );
//STRIP001 				if( pFlyFrm )
//STRIP001 				{
//STRIP001 					//JP 12.05.98: sollte das nicht im SelectFlyFrm stehen???
//STRIP001 					pDestShell->Imp()->GetDrawView()->UnmarkAll();
//STRIP001 					pDestShell->SelectFlyFrm( *pFlyFrm, TRUE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if( this != pDestShell && !pDestShell->HasShFcs() )
//STRIP001 				pDestShell->Imp()->GetDrawView()->SetMarkHdlHidden( TRUE );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( IsObjSelected() )
//STRIP001 		bRet = CopyDrawSel( pDestShell, rSttPt, rInsPt, bIsMove, bSelectInsert );
//STRIP001 	else if( IsTableMode() )
//STRIP001 	{
//STRIP001 		// kopiere Teile aus einer Tabelle: lege eine Tabelle mit der Breite
//STRIP001 		// von der Originalen an und kopiere die selectierten Boxen.
//STRIP001 		// Die Groessen werden prozentual korrigiert.
//STRIP001 
//STRIP001 		// lasse ueber das Layout die Boxen suchen
//STRIP001 		const SwTableNode* pTblNd;
//STRIP001 		SwSelBoxes aBoxes;
//STRIP001 		GetTblSel( *this, aBoxes );
//STRIP001 		if( aBoxes.Count() &&
//STRIP001 			0 != (pTblNd = aBoxes[0]->GetSttNd()->FindTableNode()) )
//STRIP001 		{
//STRIP001 			SwPosition* pDstPos = 0;
//STRIP001 			if( this == pDestShell )
//STRIP001 			{
//STRIP001 				// gleiche Shell? Dann erzeuge einen Crsr an der
//STRIP001 				// uebergebenen DokumentPosition
//STRIP001 				pDstPos = new SwPosition( *GetCrsr()->GetPoint() );
//STRIP001 				Point aPt( rInsPt );
//STRIP001 				GetLayout()->GetCrsrOfst( pDstPos, aPt );
//STRIP001 				if( !pDstPos->nNode.GetNode().IsNoTxtNode() )
//STRIP001 					bRet = TRUE;
//STRIP001 			}
//STRIP001 			else if( !pDestShell->GetCrsr()->GetNode()->IsNoTxtNode() )
//STRIP001 			{
//STRIP001 				pDstPos = new SwPosition( *pDestShell->GetCrsr()->GetPoint() );
//STRIP001 				bRet = TRUE;
//STRIP001 			}
//STRIP001 
//STRIP001 			if( bRet )
//STRIP001 			{
//STRIP001 				if( GetDoc() == pDestShell->GetDoc() )
//STRIP001 					ParkTblCrsr();
//STRIP001 
//STRIP001 				bRet = pDestShell->GetDoc()->InsCopyOfTbl( *pDstPos, aBoxes,0,
//STRIP001 										bIsMove && this == pDestShell &&
//STRIP001 										aBoxes.Count() == pTblNd->GetTable().
//STRIP001 										GetTabSortBoxes().Count(),
//STRIP001 										this != pDestShell );
//STRIP001 
//STRIP001 				if( this != pDestShell )
//STRIP001 					*pDestShell->GetCrsr()->GetPoint() = *pDstPos;
//STRIP001 
//STRIP001 				// wieder alle geparkten Crsr erzeugen?
//STRIP001 				if( GetDoc() == pDestShell->GetDoc() )
//STRIP001 					GetCrsr();
//STRIP001 
//STRIP001 				// JP 16.04.99: Bug 64908 - InsPos setzen, damit der geparkte
//STRIP001 				//				Cursor auf die EinfuegePos. positioniert wird
//STRIP001 				if( this == pDestShell )
//STRIP001 					GetCrsrDocPos() = rInsPt;
//STRIP001 			}
//STRIP001 			delete pDstPos;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bRet = TRUE;
//STRIP001 		if( this == pDestShell )
//STRIP001 		{
//STRIP001 			// gleiche Shell? Dann erfrage die Position an der
//STRIP001 			// uebergebenen DokumentPosition
//STRIP001 			SwPosition aPos( *GetCrsr()->GetPoint() );
//STRIP001 			Point aPt( rInsPt );
//STRIP001 			GetLayout()->GetCrsrOfst( &aPos, aPt );
//STRIP001 			bRet = !aPos.nNode.GetNode().IsNoTxtNode();
//STRIP001 		}
//STRIP001 		else if( pDestShell->GetCrsr()->GetNode()->IsNoTxtNode() )
//STRIP001 			bRet = FALSE;
//STRIP001 
//STRIP001 		if( bRet )
//STRIP001 			bRet = 0 != SwEditShell::Copy( pDestShell );
//STRIP001 	}
//STRIP001 
//STRIP001 	pDestShell->GetDoc()->SetRedlineMode_intern( eOldRedlMode );
//STRIP001 	pDoc->SetCopyIsMove( bCopyIsMove );
//STRIP001 
//STRIP001 	// wurden neue Tabellenformeln eingefuegt ?
//STRIP001 	if( pTblFldTyp->GetDepends() )
//STRIP001 	{
//STRIP001 		// alte Actions beenden; die Tabellen-Frames werden angelegt und
//STRIP001 		// eine SSelection kann erzeugt werden
//STRIP001 		for( USHORT nActCnt = 0; pDestShell->ActionPend(); ++nActCnt )
//STRIP001 			pDestShell->EndAllAction();
//STRIP001 
//STRIP001 		for( ; nActCnt; --nActCnt )
//STRIP001 			pDestShell->StartAllAction();
//STRIP001 	}
//STRIP001 	pDestShell->GetDoc()->UnlockExpFlds();
//STRIP001 	pDestShell->GetDoc()->UpdateFlds();
//STRIP001 
//STRIP001 	pDestShell->EndAllAction();
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SwFEShell::Paste()	Paste fuer das Interne Clipboard.
//STRIP001 |*		Kopiert den Inhalt vom Clipboard in das Dokument.
//STRIP001 |*
//STRIP001 |*	Ersterstellung		JP ??
//STRIP001 |*	Letzte Aenderung	MA 22. Feb. 95
//STRIP001 |
//STRIP001 |*************************************************************************/
//STRIP001 
//STRIP001 BOOL SwFEShell::Paste( SwDoc* pClpDoc )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	ASSERT( pClpDoc, "kein Clipboard-Dokument"	);
//STRIP001 
//STRIP001 	// dann bis zum Ende vom Nodes Array
//STRIP001 	SwNodeIndex aIdx( pClpDoc->GetNodes().GetEndOfExtras(), 2 );
//STRIP001 	SwPaM aCpyPam( aIdx ); //DocStart
//STRIP001 
//STRIP001 	// sind Tabellen-Formeln im Bereich, dann muss erst die Tabelle
//STRIP001 	// angezeigt werden, damit die Tabellen-Formel den neuen Wert errechnen
//STRIP001 	// kann (bei Bereichen wird sich ueber das Layout die einzelnen Boxen
//STRIP001 	// besorgt)
//STRIP001 	SwFieldType* pTblFldTyp = GetDoc()->GetSysFldType( RES_TABLEFLD );
//STRIP001 
//STRIP001 	SwTableNode *pDestNd, *pSrcNd = aCpyPam.GetNode()->GetTableNode();
//STRIP001 	if( !pSrcNd )								// TabellenNode ?
//STRIP001 	{											// nicht ueberspringen!!
//STRIP001 		SwCntntNode* pCNd = aCpyPam.GetNode()->GetCntntNode();
//STRIP001 		if( pCNd )
//STRIP001 			aCpyPam.GetPoint()->nContent.Assign( pCNd, 0 );
//STRIP001 		else if( !aCpyPam.Move( fnMoveForward, fnGoNode ))
//STRIP001 			aCpyPam.Move( fnMoveBackward, fnGoNode );
//STRIP001 	}
//STRIP001 
//STRIP001 	aCpyPam.SetMark();
//STRIP001 	aCpyPam.Move( fnMoveForward, fnGoDoc );
//STRIP001 
//STRIP001 	BOOL bRet = TRUE, bDelTbl = TRUE;
//STRIP001 	StartAllAction();
//STRIP001 	GetDoc()->StartUndo( UNDO_INSGLOSSARY );
//STRIP001 	GetDoc()->LockExpFlds();
//STRIP001 
//STRIP001 	FOREACHPAM_START(this)
//STRIP001 
//STRIP001 		if( pSrcNd &&
//STRIP001 			0 != ( pDestNd = GetDoc()->IsIdxInTbl( PCURCRSR->GetPoint()->nNode )))
//STRIP001 		{
//STRIP001 			SwPosition aDestPos( *PCURCRSR->GetPoint() );
//STRIP001 
//STRIP001 			BOOL bParkTblCrsr = FALSE;
//STRIP001 			const SwStartNode* pSttNd =  PCURCRSR->GetNode()->FindTableBoxStartNode();
//STRIP001 
//STRIP001 			// Tabelle in Tabelle kopieren
//STRIP001 			// lasse ueber das Layout die Boxen suchen
//STRIP001 			SwSelBoxes aBoxes;
//STRIP001 			if( IsTableMode() )		// Tabellen-Selecktion ??
//STRIP001 			{
//STRIP001 				GetTblSel( *this, aBoxes );
//STRIP001 				ParkTblCrsr();
//STRIP001 				bParkTblCrsr = TRUE;
//STRIP001 			}
//STRIP001 			else if( !PCURCRSR->HasMark() && PCURCRSR->GetNext() == PCURCRSR &&
//STRIP001 					!pSrcNd->GetTable().IsTblComplex() )
//STRIP001 			{
//STRIP001 				// dann die Tabelle "relativ" kopieren
//STRIP001 				SwTableBox* pBox = pDestNd->GetTable().GetTblBox(
//STRIP001 										pSttNd->GetIndex() );
//STRIP001 				ASSERT( pBox, "Box steht nicht in dieser Tabelle" );
//STRIP001 				aBoxes.Insert( pBox );
//STRIP001 			}
//STRIP001 
//STRIP001 			SwNodeIndex aNdIdx( *pDestNd->EndOfSectionNode());
//STRIP001 			if( !bParkTblCrsr )
//STRIP001 			{
//STRIP001 				// erstmal aus der gesamten Tabelle raus
//STRIP001 // ????? was ist mit Tabelle alleine im Rahmen ???????
//STRIP001 				SwCntntNode* pCNd = GetDoc()->GetNodes().GoNext( &aNdIdx );
//STRIP001 				SwPosition aPos( aNdIdx, SwIndex( pCNd, 0 ));
//STRIP001 				PaMCorrAbs( SwNodeIndex( *pDestNd ),
//STRIP001 							SwNodeIndex( *pDestNd->EndOfSectionNode() ),
//STRIP001 							aPos );
//STRIP001 			}
//STRIP001 
//STRIP001 			bRet = GetDoc()->InsCopyOfTbl( aDestPos, aBoxes, &pSrcNd->GetTable(),
//STRIP001 											FALSE, FALSE );
//STRIP001 
//STRIP001 			if( bParkTblCrsr )
//STRIP001 				GetCrsr();
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// und wieder in die Box zurueck
//STRIP001 				aNdIdx = *pSttNd;
//STRIP001 				SwCntntNode* pCNd = GetDoc()->GetNodes().GoNext( &aNdIdx );
//STRIP001 				SwPosition aPos( aNdIdx, SwIndex( pCNd, 0 ));
//STRIP001 				PaMCorrAbs( PCURCRSR->GetPoint()->nNode, aPos );
//STRIP001 			}
//STRIP001 
//STRIP001 			break;		// aus der "while"-Schleife heraus
//STRIP001 		}
//STRIP001 		else if( *aCpyPam.GetPoint() == *aCpyPam.GetMark() &&
//STRIP001 				 pClpDoc->GetSpzFrmFmts()->Count() )
//STRIP001 		{
//STRIP001 			// so langsam sollte mal eine DrawView erzeugt werden
//STRIP001 			if( !Imp()->GetDrawView() )
//STRIP001 				MakeDrawView();
//STRIP001 
//STRIP001             // FME: removed for #105977#
//STRIP001             // Size aSiz( 0, GetCharRect().Top() );
//STRIP001 			for ( USHORT i = 0; i < pClpDoc->GetSpzFrmFmts()->Count(); ++i )
//STRIP001 			{
//STRIP001 				BOOL bInsWithFmt = TRUE;
//STRIP001 				const SwFrmFmt& rCpyFmt = *(*pClpDoc->GetSpzFrmFmts())[i];
//STRIP001 
//STRIP001 				if( Imp()->GetDrawView()->IsGroupEntered() &&
//STRIP001 					RES_DRAWFRMFMT == rCpyFmt.Which() &&
//STRIP001 					FLY_IN_CNTNT != rCpyFmt.GetAnchor().GetAnchorId() )
//STRIP001 				{
//STRIP001 					const SdrObject* pSdrObj = rCpyFmt.FindSdrObject();
//STRIP001 					if( pSdrObj )
//STRIP001 					{
//STRIP001 						SdrObject* pNew = GetDoc()->CloneSdrObj( *pSdrObj,
//STRIP001 															FALSE, FALSE );
//STRIP001 
//STRIP001                         // FME: removed for #105977#
//STRIP001                         // pNew->NbcMove( aSiz );
//STRIP001 
//STRIP001                         // Insert object sets any anchor position to 0.
//STRIP001                         // Therefore we calculate the absolute position here
//STRIP001                         // and after the insert the anchor of the object
//STRIP001                         // is set to the anchor of the group object.
//STRIP001                         Rectangle aSnapRect = pNew->GetSnapRect();
//STRIP001                         if( pNew->GetAnchorPos().X() || pNew->GetAnchorPos().Y() )
//STRIP001                         {
//STRIP001                             const Point aPoint( 0, 0 );
//STRIP001                             pNew->NbcSetAnchorPos( aPoint );
//STRIP001                             pNew->NbcSetSnapRect( aSnapRect );
//STRIP001                         }
//STRIP001 
//STRIP001 						Imp()->GetDrawView()->InsertObject( pNew,
//STRIP001 														*Imp()->GetPageView() );
//STRIP001 
//STRIP001                         Point aGrpAnchor( 0, 0 );
//STRIP001                         SdrObjList* pList = pNew->GetObjList();
//STRIP001                         if ( pList )
//STRIP001                         {
//STRIP001                             SdrObject* pOwner = pList->GetOwnerObj();
//STRIP001                             if ( pOwner )
//STRIP001                             {
//STRIP001                                 SdrObjGroup* pThisGroup = PTR_CAST(SdrObjGroup, pOwner);
//STRIP001                                 aGrpAnchor = pThisGroup->GetAnchorPos();
//STRIP001                             }
//STRIP001                         }
//STRIP001 
//STRIP001                         pNew->NbcSetAnchorPos( aGrpAnchor );
//STRIP001                         pNew->NbcSetSnapRect( aSnapRect );
//STRIP001 
//STRIP001 						bInsWithFmt = FALSE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				if( bInsWithFmt  )
//STRIP001 				{
//STRIP001 					SwFmtAnchor aAnchor( rCpyFmt.GetAnchor() );
//STRIP001 					if( FLY_AT_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 						FLY_AUTO_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 						FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 					{
//STRIP001 						SwPosition* pPos = PCURCRSR->GetPoint();
//STRIP001                         // #108784# allow shapes (no controls) in header/footer
//STRIP001                         if( RES_DRAWFRMFMT == rCpyFmt.Which() &&
//STRIP001                             GetDoc()->IsInHeaderFooter( pPos->nNode ) &&
//STRIP001                             CheckControlLayer( rCpyFmt.FindSdrObject() ) )
//STRIP001                             continue;
//STRIP001 
//STRIP001 						aAnchor.SetAnchor( pPos );
//STRIP001 					}
//STRIP001 					else if( FLY_PAGE == aAnchor.GetAnchorId() )
//STRIP001 					{
//STRIP001 						aAnchor.SetPageNum( GetPhyPageNum() );
//STRIP001 					}
//STRIP001 					else if( FLY_AT_FLY == aAnchor.GetAnchorId() )
//STRIP001 					{
//STRIP001 						Point aPt;
//STRIP001 						lcl_SetAnchor( *PCURCRSR->GetPoint(), *PCURCRSR->GetNode(),
//STRIP001 										0, aPt, *this, aAnchor, aPt, FALSE );
//STRIP001 					}
//STRIP001 
//STRIP001 					SwFrmFmt * pNew = GetDoc()->CopyLayoutFmt( rCpyFmt, aAnchor );
//STRIP001 
//STRIP001 					//Kann 0 sein, weil Draws in Kopf-/Fusszeilen nicht erlaubt sind.
//STRIP001 					if( pNew )
//STRIP001 					{
//STRIP001 						if( RES_FLYFRMFMT == pNew->Which() )
//STRIP001 						{
//STRIP001 							const Point aPt( GetCrsrDocPos() );
//STRIP001 							SwFlyFrm* pFlyFrm = ((SwFlyFrmFmt*)pNew)->
//STRIP001 														GetFrm( &aPt, FALSE );
//STRIP001 							if( pFlyFrm )
//STRIP001 								SelectFlyFrm( *pFlyFrm, TRUE );
//STRIP001 							// immer nur den ersten Fly-Frame nehmen; die anderen
//STRIP001 							// wurden ueber Fly in Fly ins ClipBoard kopiert !
//STRIP001 							break;
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							ASSERT( RES_DRAWFRMFMT == pNew->Which(), "Neues Format.");
//STRIP001 							SdrObject *pObj = pNew->FindSdrObject();
//STRIP001 							SwDrawView  *pDV = Imp()->GetDrawView();
//STRIP001 							pDV->MarkObj( pObj, pDV->GetPageView( pObj->GetPage() ) );
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if( bDelTbl && IsTableMode() )
//STRIP001 			{
//STRIP001 				SwEditShell::Delete();
//STRIP001 				bDelTbl = FALSE;
//STRIP001 			}
//STRIP001 
//STRIP001 			SwPosition& rInsPos = *PCURCRSR->GetPoint();
//STRIP001 			const SwStartNode* pBoxNd = rInsPos.nNode.GetNode().
//STRIP001 													FindTableBoxStartNode();
//STRIP001 			if( pBoxNd && 2 == pBoxNd->EndOfSectionIndex() -
//STRIP001 								pBoxNd->GetIndex() &&
//STRIP001 				aCpyPam.GetPoint()->nNode != aCpyPam.GetMark()->nNode )
//STRIP001 			{
//STRIP001 				// es wird mehr als 1 Node in die akt. Box kopiert. Dann
//STRIP001 				// muessen die BoxAttribute aber entfernt werden.
//STRIP001 				GetDoc()->ClearBoxNumAttrs( rInsPos.nNode );
//STRIP001 			}
//STRIP001 			pClpDoc->Copy( aCpyPam, rInsPos );
//STRIP001 			SaveTblBoxCntnt( &rInsPos );
//STRIP001 		}
//STRIP001 
//STRIP001 	FOREACHPAM_END()
//STRIP001 	GetDoc()->EndUndo( UNDO_INSGLOSSARY );
//STRIP001 
//STRIP001 	// wurden neue Tabellenformeln eingefuegt ?
//STRIP001 	if( pTblFldTyp->GetDepends() )
//STRIP001 	{
//STRIP001 		// alte Actions beenden; die Tabellen-Frames werden angelegt und
//STRIP001 		// eine Selection kann erzeugt werden
//STRIP001 		for( USHORT nActCnt = 0; ActionPend(); ++nActCnt )
//STRIP001 			EndAllAction();
//STRIP001 
//STRIP001 		for( ; nActCnt; --nActCnt )
//STRIP001 			StartAllAction();
//STRIP001 	}
//STRIP001 	GetDoc()->UnlockExpFlds();
//STRIP001 	GetDoc()->UpdateFlds();
//STRIP001 	EndAllAction();
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SwFEShell::GetDrawObjGraphic( ULONG nFmt, Graphic& rGrf ) const
//STRIP001 {
//STRIP001 	ASSERT( Imp()->HasDrawView(), "GetDrawObjGraphic without DrawView?" );
//STRIP001 	const SdrMarkList &rMrkList = Imp()->GetDrawView()->GetMarkList();
//STRIP001 	BOOL bConvert = TRUE;
//STRIP001 	if( rMrkList.GetMarkCount() )
//STRIP001 	{
//STRIP001 		if( rMrkList.GetMarkCount() == 1 &&
//STRIP001 			rMrkList.GetMark( 0 )->GetObj()->IsWriterFlyFrame() )
//STRIP001 		{
//STRIP001 			// Rahmen selektiert
//STRIP001 			if( CNT_GRF == GetCntType() )
//STRIP001 			{
//STRIP001 				Graphic aGrf( GetGraphic() );
//STRIP001 				if( SOT_FORMAT_GDIMETAFILE == nFmt )
//STRIP001 				{
//STRIP001 					if( GRAPHIC_BITMAP != aGrf.GetType() )
//STRIP001 					{
//STRIP001 						rGrf = aGrf;
//STRIP001 						bConvert = FALSE;
//STRIP001 					}
//STRIP001 					else if( GetWin() )
//STRIP001 					{
//STRIP001 						Size aSz;
//STRIP001 						Point aPt;
//STRIP001 						GetGrfSize( aSz );
//STRIP001 
//STRIP001 						VirtualDevice aVirtDev;
//STRIP001 						aVirtDev.EnableOutput( FALSE );
//STRIP001 
//STRIP001 						MapMode aTmp( GetWin()->GetMapMode() );
//STRIP001 						aTmp.SetOrigin( aPt );
//STRIP001 						aVirtDev.SetMapMode( aTmp );
//STRIP001 
//STRIP001 						GDIMetaFile aMtf;
//STRIP001 						aMtf.Record( &aVirtDev );
//STRIP001 						aGrf.Draw( &aVirtDev, aPt, aSz );
//STRIP001 						aMtf.Stop();
//STRIP001 						aMtf.SetPrefMapMode( aTmp );
//STRIP001 						aMtf.SetPrefSize( aSz );
//STRIP001 						rGrf = aMtf;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else if( GRAPHIC_BITMAP == aGrf.GetType() )
//STRIP001 				{
//STRIP001 					rGrf = aGrf;
//STRIP001 					bConvert = FALSE;
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					//fix(23806): Nicht die Originalgroesse, sondern die
//STRIP001 					//aktuelle. Anderfalls kann es passieren, dass z.B. bei
//STRIP001 					//Vektorgrafiken mal eben zig MB angefordert werden.
//STRIP001 					const Size aSz( FindFlyFrm()->Prt().SSize() );
//STRIP001 					VirtualDevice aVirtDev( *GetWin() );
//STRIP001 
//STRIP001 					MapMode aTmp( MAP_TWIP );
//STRIP001 					aVirtDev.SetMapMode( aTmp );
//STRIP001 					if( aVirtDev.SetOutputSize( aSz ) )
//STRIP001 					{
//STRIP001 						aGrf.Draw( &aVirtDev, Point(), aSz );
//STRIP001 						rGrf = aVirtDev.GetBitmap( Point(), aSz );
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						rGrf = aGrf;
//STRIP001 						bConvert = FALSE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( SOT_FORMAT_GDIMETAFILE == nFmt )
//STRIP001 			rGrf = Imp()->GetDrawView()->GetAllMarkedMetaFile();
//STRIP001 		else if( SOT_FORMAT_BITMAP == nFmt )
//STRIP001 			rGrf = Imp()->GetDrawView()->GetAllMarkedBitmap();
//STRIP001 	}
//STRIP001 	return bConvert;
//STRIP001 }
//STRIP001 
//STRIP001 void SwFEShell::Paste( SvStream& rStrm, USHORT nAction, const Point* pPt )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 	StartUndo();
//STRIP001 
//STRIP001 	SvtPathOptions aPathOpt;
//STRIP001 	FmFormModel* pModel = new FmFormModel( aPathOpt.GetPalettePath(),
//STRIP001 											0, GetDoc()->GetDocShell() );
//STRIP001 	pModel->GetItemPool().FreezeIdRanges();
//STRIP001 	pModel->SetStreamingSdrModel(TRUE);
//STRIP001 
//STRIP001 	rStrm.Seek(0);
//STRIP001 
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream > xInputStream( new utl::OInputStreamWrapper( rStrm ) );
//STRIP001 	SvxDrawingLayerImport( pModel, xInputStream );
//STRIP001 
//STRIP001 	if ( !Imp()->HasDrawView() )
//STRIP001 		Imp()->MakeDrawView();
//STRIP001 
//STRIP001 	Point aPos( pPt ? *pPt : GetCharRect().Pos() );
//STRIP001 	SdrView *pView = Imp()->GetDrawView();
//STRIP001 
//STRIP001 	//Drop auf bestehendes Objekt: Objekt ersetzen oder neu Attributieren.
//STRIP001 	if( 1 == pModel->GetPage(0)->GetObjCount() &&
//STRIP001 		1 == pView->GetMarkList().GetMarkCount() )
//STRIP001 	{
//STRIP001         // OD 10.07.2003 #110742# - replace a marked 'virtual' drawing object
//STRIP001         // by its corresponding 'master' drawing object in the mark list.
//STRIP001         SwDrawView::ReplaceMarkedDrawVirtObjs( *pView );
//STRIP001 
//STRIP001         SdrObject* pClpObj = pModel->GetPage(0)->GetObj(0);
//STRIP001 		SdrObject* pOldObj = pView->GetMarkList().GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 		if( SW_PASTESDR_SETATTR == nAction && pOldObj->IsWriterFlyFrame() )
//STRIP001 			nAction = SW_PASTESDR_REPLACE;
//STRIP001 
//STRIP001 		switch( nAction )
//STRIP001 		{
//STRIP001 		case SW_PASTESDR_REPLACE:
//STRIP001 			{
//STRIP001 				const SwFrmFmt* pFmt;
//STRIP001 				const SwFrm* pAnchor;
//STRIP001 				if( pOldObj->IsWriterFlyFrame() )
//STRIP001 				{
//STRIP001 					pFmt = FindFrmFmt( pOldObj );
//STRIP001 
//STRIP001 					Point aNullPt;
//STRIP001 					SwFlyFrm* pFlyFrm = ((SwFlyFrmFmt*)pFmt)->GetFrm( &aNullPt );
//STRIP001 					pAnchor = pFlyFrm->GetAnchor();
//STRIP001 
//STRIP001 					if( pAnchor->FindFooterOrHeader() )
//STRIP001 					{
//STRIP001 						// wenn TextRahmen in der Kopf/Fusszeile steht, dann
//STRIP001 						// nicht ersetzen, sondern nur einfuegen
//STRIP001 						nAction = SW_PASTESDR_INSERT;
//STRIP001 						break;
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				SdrObject* pNewObj = pClpObj->Clone();
//STRIP001 				Rectangle aOldObjRect( pOldObj->GetBoundRect() );
//STRIP001 				Size aOldObjSize( aOldObjRect.GetSize() );
//STRIP001 				Rectangle aNewRect( pNewObj->GetBoundRect() );
//STRIP001 				Size aNewSize( aNewRect.GetSize() );
//STRIP001 
//STRIP001 				Fraction aScaleWidth( aOldObjSize.Width(), aNewSize.Width() );
//STRIP001 				Fraction aScaleHeight( aOldObjSize.Height(), aNewSize.Height());
//STRIP001 				pNewObj->NbcResize( aNewRect.TopLeft(), aScaleWidth, aScaleHeight);
//STRIP001 
//STRIP001 				Point aVec = aOldObjRect.TopLeft() - aNewRect.TopLeft();
//STRIP001 				pNewObj->NbcMove(Size(aVec.X(), aVec.Y()));
//STRIP001 
//STRIP001                 if( pNewObj->ISA( SdrUnoObj ) )
//STRIP001                     pNewObj->SetLayer( GetDoc()->GetControlsId() );
//STRIP001                 else if( pOldObj->ISA( SdrUnoObj ) )
//STRIP001                     pNewObj->SetLayer( GetDoc()->GetHeavenId() );
//STRIP001                 else
//STRIP001                     pNewObj->SetLayer( pOldObj->GetLayer() );
//STRIP001 
//STRIP001 				if( pOldObj->IsWriterFlyFrame() )
//STRIP001 				{
//STRIP001 					// Attribute sichern und dam SdrObject setzen
//STRIP001 					SfxItemSet aFrmSet( pDoc->GetAttrPool(),
//STRIP001 											RES_SURROUND, RES_ANCHOR );
//STRIP001 					aFrmSet.Set( pFmt->GetAttrSet() );
//STRIP001 
//STRIP001 					Point aNullPt;
//STRIP001 					if( pAnchor->IsTxtFrm() && ((SwTxtFrm*)pAnchor)->IsFollow() )
//STRIP001 					{
//STRIP001 						const SwTxtFrm* pTmp = (SwTxtFrm*)pAnchor;
//STRIP001 						do {
//STRIP001 							pTmp = pTmp->FindMaster();
//STRIP001 							ASSERT( pTmp, "Where's my Master?" );
//STRIP001 						} while( pTmp->IsFollow() );
//STRIP001 						pAnchor = pTmp;
//STRIP001 					}
//STRIP001 					if( pOldObj->ISA( SdrCaptionObj ))
//STRIP001 						aNullPt = ((SdrCaptionObj*)pOldObj)->GetTailPos();
//STRIP001 					else
//STRIP001 						aNullPt = aOldObjRect.TopLeft();
//STRIP001 
//STRIP001                     Point aNewAnchor = pAnchor->GetFrmAnchorPos( ::HasWrap( pOldObj ) );
//STRIP001                     pNewObj->NbcSetRelativePos( aNullPt - aNewAnchor );
//STRIP001                     pNewObj->NbcSetAnchorPos( aNewAnchor );
//STRIP001 
//STRIP001 					UINT32 nOrdNum = pOldObj->GetOrdNum();
//STRIP001 
//STRIP001 					DelSelectedObj();
//STRIP001 
//STRIP001 					pFmt = GetDoc()->Insert( *GetCrsr(), *pNewObj, &aFrmSet );
//STRIP001 
//STRIP001 					// die Ordnungsnummer (Z-Order) noch uebertragen
//STRIP001 					// JP 04.07.98: klappt aber nicht richtig!
//STRIP001 					// pNewObj->SetOrdNum( nOrdNum );
//STRIP001 				}
//STRIP001 				else
//STRIP001 					pView->ReplaceObject( pOldObj, *Imp()->GetPageView(),
//STRIP001 											pNewObj, TRUE );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SW_PASTESDR_SETATTR:
//STRIP001 			{
//STRIP001 				SfxItemSet aSet( GetAttrPool() );
//STRIP001 //-/				pClpObj->TakeAttributes( aSet, TRUE, FALSE );
//STRIP001 				aSet.Put(pClpObj->GetItemSet());
//STRIP001 				pView->SetAttributes( aSet, FALSE );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			nAction = SW_PASTESDR_INSERT;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nAction = SW_PASTESDR_INSERT;
//STRIP001 
//STRIP001 	if( SW_PASTESDR_INSERT == nAction )
//STRIP001 	{
//STRIP001 		GetDoc()->SetNoDrawUndoObj( TRUE );
//STRIP001 
//STRIP001         sal_Bool bDesignMode = pView->IsDesignMode();
//STRIP001         if( !bDesignMode )
//STRIP001             pView->SetDesignMode( sal_True );
//STRIP001 
//STRIP001 		pView->Paste( *pModel, aPos );
//STRIP001 
//STRIP001 		ULONG nCnt = pView->GetMarkList().GetMarkCount();
//STRIP001 		if( nCnt )
//STRIP001 		{
//STRIP001 			const Point aNull( 0, 0 );
//STRIP001 			for( ULONG i=0; i < nCnt; ++i )
//STRIP001 			{
//STRIP001 				SdrObject *pObj = pView->GetMarkList().GetMark(i)->GetObj();
//STRIP001 				pObj->ImpSetAnchorPos( aNull );
//STRIP001 			}
//STRIP001 
//STRIP001 			pView->SetCurrentObj( OBJ_GRUP, SdrInventor );
//STRIP001 			if ( nCnt > 1 )
//STRIP001 				pView->GroupMarked();
//STRIP001 			SdrObject *pObj = pView->GetMarkList().GetMark(0)->GetObj();
//STRIP001             if( pObj->ISA( SdrUnoObj ) )
//STRIP001             {
//STRIP001                 pObj->SetLayer( GetDoc()->GetControlsId() );
//STRIP001                 bDesignMode = sal_True;
//STRIP001             }
//STRIP001             else
//STRIP001                 pObj->SetLayer( GetDoc()->GetHeavenId() );
//STRIP001 			const Rectangle &rSnap = pObj->GetSnapRect();
//STRIP001 			const Size aDiff( rSnap.GetWidth()/2, rSnap.GetHeight()/2 );
//STRIP001 			pView->MoveMarkedObj( aDiff );
//STRIP001 			ImpEndCreate();
//STRIP001             if( !bDesignMode )
//STRIP001                 pView->SetDesignMode( sal_False );
//STRIP001 		}
//STRIP001 		GetDoc()->SetNoDrawUndoObj( FALSE );
//STRIP001 	}
//STRIP001 	EndUndo();
//STRIP001 	EndAllAction();
//STRIP001 	delete pModel;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SwFEShell::Paste( const Graphic &rGrf )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	SdrObject* pObj;
//STRIP001 	SdrView *pView = Imp()->GetDrawView();
//STRIP001 
//STRIP001 	BOOL bRet = 1 == pView->GetMarkList().GetMarkCount() &&
//STRIP001 		(pObj = pView->GetMarkList().GetMark( 0 )->GetObj())->IsClosedObj() &&
//STRIP001 		!pObj->ISA( SdrOle2Obj );
//STRIP001 
//STRIP001 	if( bRet )
//STRIP001 	{
//STRIP001 		XOBitmap aXOBitmap( rGrf.GetBitmap() );
//STRIP001 		SfxItemSet aSet( GetAttrPool(), XATTR_FILLSTYLE, XATTR_FILLBITMAP );
//STRIP001 		aSet.Put( XFillStyleItem( XFILL_BITMAP ));
//STRIP001 		aSet.Put( XFillBitmapItem( aEmptyStr, aXOBitmap ));
//STRIP001 		pView->SetAttributes( aSet, FALSE );
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 #ifdef USED
//STRIP001 BOOL SwFEShell::Paste( SotDataObject& rObj, const Point& rPt )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	SvData aData( XFillExchangeData::RegisterClipboardFormatName() );
//STRIP001 	XFillExchangeData* pFillData = NULL;
//STRIP001 
//STRIP001 	if( rObj.GetData( &aData ) )
//STRIP001 	{
//STRIP001 		if (aData.GetData( (SvDataCopyStream**) &pFillData, XFillExchangeData::StaticType(), TRANSFER_MOVE))
//STRIP001 		{
//STRIP001 /*				BegUndo(String(SdResId(STR_UNDO_DRAGDROP)));
//STRIP001 			AddUndo(new SdrUndoAttrObj(*pPickObj));
//STRIP001 			EndUndo();*/
//STRIP001 
//STRIP001 			XFillAttrSetItem* pSetItem = pFillData->GetXFillAttrSetItem();
//STRIP001 			SfxItemSet rSet = pSetItem->GetItemSet();
//STRIP001 
//STRIP001 			XFillStyle eFill= ((XFillStyleItem&) rSet.Get(XATTR_FILLSTYLE)).GetValue();
//STRIP001 
//STRIP001 			if (eFill == XFILL_SOLID)
//STRIP001 			{
//STRIP001 				const XFillColorItem& rColItem = (XFillColorItem&) rSet.Get(XATTR_FILLCOLOR);
//STRIP001 				Color aColor = rColItem.GetValue();
//STRIP001 				String aName = rColItem.GetName();
//STRIP001 
//STRIP001 				SdrView *pSdrView = Imp()->GetDrawView();
//STRIP001 
//STRIP001 				if(pSdrView)
//STRIP001 				{
//STRIP001 					SdrObject* pPickObj = NULL;
//STRIP001 					// Ist ein Objekt getroffen worden?
//STRIP001 					SdrPageView* pPV = NULL;
//STRIP001 					pSdrView->PickObj( rPt, pPickObj, pPV);
//STRIP001 
//STRIP001 					if ( pPickObj )
//STRIP001 					{
//STRIP001 /*		                    SfxItemSet aSet(pDoc->GetPool());
//STRIP001 
//STRIP001 						BOOL bClosed = pPickObj->IsClosedObj();
//STRIP001 						SdWindow* pWin = pViewSh->GetActiveWindow();
//STRIP001 						USHORT nHitLog = USHORT ( pWin->PixelToLogic(Size(HITPIX,0)).Width() );
//STRIP001 						const long  n2HitLog = nHitLog * 2;
//STRIP001 						Point aHitPosR( aPos );
//STRIP001 						Point aHitPosL( aPos );
//STRIP001 						Point aHitPosT( aPos );
//STRIP001 						Point aHitPosB( aPos );
//STRIP001 
//STRIP001 						aHitPosR.X() += n2HitLog;
//STRIP001 						aHitPosL.X() -= n2HitLog;
//STRIP001 						aHitPosT.Y() += n2HitLog;
//STRIP001 						aHitPosB.Y() -= n2HitLog;
//STRIP001 
//STRIP001 						const SetOfByte* pVisiLayer = &GetPageViewPvNum(0)->GetVisibleLayers();
//STRIP001 
//STRIP001 						if (bClosed                                          &&
//STRIP001 							pPickObj->IsHit( aHitPosR, nHitLog, pVisiLayer ) &&
//STRIP001 							pPickObj->IsHit( aHitPosL, nHitLog, pVisiLayer ) &&
//STRIP001 							pPickObj->IsHit( aHitPosT, nHitLog, pVisiLayer ) &&
//STRIP001 							pPickObj->IsHit( aHitPosB, nHitLog, pVisiLayer ) )
//STRIP001 						{
//STRIP001 							// Flaechenfuellung
//STRIP001 							aSet.Put(XFillColorItem(aName, aColor));
//STRIP001 							aSet.Put(XFillStyleItem(XFILL_SOLID));
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							// Linienstil hinzufuegen
//STRIP001 							aSet.Put(XLineColorItem(aName, aColor));
//STRIP001 						}
//STRIP001 
//STRIP001 						// Textfarbe hinzufuegen
//STRIP001 	//                    aSet.Put(SvxColorItem(aColor, ITEMID_COLOR));
//STRIP001 
//STRIP001 						pPickObj->SetAttributes(aSet, FALSE);*/
//STRIP001 						bRet = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				if (!bRet)	// Kein DrawObjekt
//STRIP001 				{
//STRIP001 					SvxBrushItem aBrushItem(aColor, SID_ATTR_BRUSH);
//STRIP001 					SfxViewShell* pViewShell = GetSfxViewShell();
//STRIP001 					DBG_ASSERT(pViewShell, "no SfxViewShell?")
//STRIP001 					if(pViewShell)
//STRIP001 						pViewShell->GetViewFrame()->GetDispatcher()->
//STRIP001 							Execute(	SID_ATTR_BRUSH, SFX_CALLMODE_SLOT,
//STRIP001 												&aBrushItem, 0L);
//STRIP001 					bRet = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 #endif

}
