/*************************************************************************
 *
 *  $RCSfile: sw_fedesc.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:28:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>
// auto strip #endif

// auto strip #ifndef _REF_HXX
// auto strip #include <tools/ref.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _FESH_HXX
#include <fesh.hxx>
#endif
#ifndef _DOC_HXX
#include <doc.hxx>
#endif
#ifndef _PAGEFRM_HXX
#include <pagefrm.hxx>
#endif
#ifndef _ROOTFRM_HXX
#include <rootfrm.hxx>
#endif
#ifndef _CNTFRM_HXX
#include <cntfrm.hxx>
#endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _NODE_HXX
// auto strip #include <node.hxx>
// auto strip #endif
// auto strip #ifndef _FMTPDSC_HXX //autogen
// auto strip #include <fmtpdsc.hxx>
// auto strip #endif
// auto strip #ifndef _PAGEDESC_HXX
// auto strip #include <pagedesc.hxx>
// auto strip #endif
// auto strip #ifndef _TABFRM_HXX
// auto strip #include <tabfrm.hxx>
// auto strip #endif
// auto strip #ifndef _EDIMP_HXX
// auto strip #include <edimp.hxx>
// auto strip #endif
// auto strip #ifndef _SWSTYLENAMEMAPPER_HXX
// auto strip #include <SwStyleNameMapper.hxx>
// auto strip #endif
namespace binfilter {
/*************************************************************************
|*
|*	SwFEShell::GetPageDescCnt()
|*
|*	Ersterstellung		MA 25. Jan. 93
|*	Letzte Aenderung	MA 25. Jan. 93
|*
|*************************************************************************/

/*N*/ USHORT SwFEShell::GetPageDescCnt() const
/*N*/ {
/*N*/ 	return GetDoc()->GetPageDescCnt();
/*N*/ }

/*************************************************************************
|*
|*	SwFEShell::ChgCurPageDesc()
|*
|*	Ersterstellung		ST ??
|*	Letzte Aenderung	MA 01. Aug. 94
|*
|*************************************************************************/

//STRIP001 void SwFEShell::ChgCurPageDesc( const SwPageDesc& rDesc )
//STRIP001 {
//STRIP001 #ifndef PRODUCT
//STRIP001 	//Die SS veraendert keinen PageDesc, sondern setzt nur das Attribut.
//STRIP001 	//Der Pagedesc muss im Dokument vorhanden sein!
//STRIP001 	BOOL bFound = FALSE;
//STRIP001 	for ( USHORT nTst = 0; nTst < GetPageDescCnt(); ++nTst )
//STRIP001 		if ( &rDesc == &GetPageDesc( nTst ) )
//STRIP001 			bFound = TRUE;
//STRIP001 	ASSERT( bFound, "ChgCurPageDesc mit ungueltigem Descriptor." );
//STRIP001 #endif
//STRIP001 
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwPageFrm *pPage = GetCurrFrm()->FindPageFrm();
//STRIP001 	const SwFrm *pFlow;
//STRIP001 	USHORT nPageNmOffset = 0;
//STRIP001 
//STRIP001 	ASSERT( !GetCrsr()->HasMark(), "ChgCurPageDesc nur ohne Selektion!");
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	while ( pPage )
//STRIP001 	{
//STRIP001 		pFlow = pPage->FindFirstBodyCntnt();
//STRIP001 		if ( pFlow )
//STRIP001 		{
//STRIP001 			if ( pFlow->IsInTab() )
//STRIP001 				pFlow = pFlow->FindTabFrm();
//STRIP001 			const SwFmtPageDesc& rPgDesc = pFlow->GetAttrSet()->GetPageDesc();
//STRIP001 			if( rPgDesc.GetPageDesc() )
//STRIP001 			{
//STRIP001 				// wir haben ihn den Schlingel
//STRIP001 				nPageNmOffset = rPgDesc.GetNumOffset();
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		pPage = (SwPageFrm*) pPage->GetPrev();
//STRIP001 	}
//STRIP001 	if ( !pPage )
//STRIP001 	{
//STRIP001 		pPage = (SwPageFrm*) (GetLayout()->Lower());
//STRIP001 		pFlow = pPage->FindFirstBodyCntnt();
//STRIP001 		if ( !pFlow )
//STRIP001 		{
//STRIP001 			pPage   = (SwPageFrm*)pPage->GetNext();
//STRIP001 			pFlow = pPage->FindFirstBodyCntnt();
//STRIP001 			ASSERT( pFlow, "Dokuemnt ohne Inhalt?!?" );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Seitennummer mitnehmen
//STRIP001 	SwFmtPageDesc aNew( &rDesc );
//STRIP001 	aNew.SetNumOffset( nPageNmOffset );
//STRIP001 
//STRIP001 	if ( pFlow->IsInTab() )
//STRIP001 		GetDoc()->SetAttr( aNew, *(SwFmt*)pFlow->FindTabFrm()->GetFmt() );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SwPaM aPaM( *((SwCntntFrm*)pFlow)->GetNode() );
//STRIP001 		GetDoc()->Insert( aPaM, aNew );
//STRIP001 	}
//STRIP001 	EndAllActionAndCall();
//STRIP001 }

/*************************************************************************
|*
|*	SwFEShell::ChgPageDesc()
|*
|*	Ersterstellung		MA 25. Jan. 93
|*	Letzte Aenderung	MA 24. Jan. 95
|*
|*************************************************************************/

//STRIP001 void SwFEShell::ChgPageDesc( USHORT i, const SwPageDesc &rChged )
//STRIP001 {
//STRIP001 	StartAllAction();
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	GetDoc()->ChgPageDesc( i, rChged );
//STRIP001 	EndAllActionAndCall();
//STRIP001 }

/*************************************************************************
|*
|*	SwFEShell::GetPageDesc(), GetCurPageDesc()
|*
|*	Ersterstellung		MA 25. Jan. 93
|*	Letzte Aenderung	MA 23. Apr. 93
|
|*************************************************************************/

/*N*/ const SwPageDesc& SwFEShell::GetPageDesc( USHORT i ) const
/*N*/ {
/*N*/ 	return GetDoc()->GetPageDesc( i );
/*N*/ }

//STRIP001 SwPageDesc* SwFEShell::FindPageDescByName( const String& rName,
//STRIP001 											BOOL bGetFromPool,
//STRIP001 											USHORT* pPos )
//STRIP001 {
//STRIP001 	SwPageDesc* pDesc = GetDoc()->FindPageDescByName( rName, pPos );
//STRIP001 	if( !pDesc && bGetFromPool )
//STRIP001 	{
//STRIP001 		USHORT nPoolId = SwStyleNameMapper::GetPoolIdFromUIName( rName, GET_POOLID_PAGEDESC );
//STRIP001 		if( USHRT_MAX != nPoolId &&
//STRIP001 			0 != (pDesc = GetDoc()->GetPageDescFromPool( nPoolId ))
//STRIP001 			&& pPos )
//STRIP001 				// werden immer hinten angehaengt
//STRIP001 			*pPos = GetDoc()->GetPageDescCnt() - 1 ;
//STRIP001 	}
//STRIP001 	return pDesc;
//STRIP001 }

/*M*/ USHORT SwFEShell::GetMousePageDesc( const Point &rPt ) const
/*M*/ {
/*M*/     if( GetLayout() )
/*M*/     {
/*M*/         const SwPageFrm* pPage =
/*M*/             static_cast<const SwPageFrm*>( GetLayout()->Lower() );
/*M*/         if( pPage )
/*M*/         {
/*M*/             while( pPage->GetNext() && rPt.Y() > pPage->Frm().Bottom() )
/*M*/                 pPage = static_cast<const SwPageFrm*>( pPage->GetNext() );
/*M*/ 			SwDoc *pDoc = GetDoc();
/*M*/ 			for ( USHORT i = 0; i < GetDoc()->GetPageDescCnt(); ++i )
/*M*/ 			{
/*M*/ 				if ( pPage->GetPageDesc() == &pDoc->GetPageDesc(i) )
/*M*/                     return i;
/*M*/             }
/*M*/         }
/*M*/     }
/*M*/     return 0;
/*M*/ }

/*M*/ USHORT SwFEShell::GetCurPageDesc( const BOOL bCalcFrm ) const
/*M*/ {
/*M*/ 	const SwFrm *pFrm = GetCurrFrm( bCalcFrm );
/*M*/ 	if ( pFrm )
/*M*/ 	{
/*M*/ 		const SwPageFrm *pPage = pFrm->FindPageFrm();
/*M*/ 		if ( pPage )
/*M*/ 		{
/*M*/ 			SwDoc *pDoc = GetDoc();
/*M*/ 			for ( USHORT i = 0; i < GetDoc()->GetPageDescCnt(); ++i )
/*M*/ 			{
/*M*/ 				if ( pPage->GetPageDesc() == &pDoc->GetPageDesc(i) )
/*M*/ 					return i;
/*M*/ 			}
/*M*/ 		}
/*M*/ 	}
/*M*/ 	return 0;
/*M*/ }

// if inside all selection only one PageDesc, return this.
// Otherwise return 0 pointer
//STRIP001 const SwPageDesc* SwFEShell::GetSelectedPageDescs() const
//STRIP001 {
//STRIP001 	const SwCntntNode* pCNd;
//STRIP001 	const SwFrm* pMkFrm, *pPtFrm;
//STRIP001 	const SwPageDesc* pFnd, *pRetDesc = (SwPageDesc*)0xffffffff;
//STRIP001 	const Point aNulPt;
//STRIP001 
//STRIP001 	FOREACHPAM_START(this)
//STRIP001 
//STRIP001 		if( 0 != (pCNd = PCURCRSR->GetCntntNode() ) &&
//STRIP001 			0 != ( pPtFrm = pCNd->GetFrm( &aNulPt, 0, FALSE )) )
//STRIP001 			pPtFrm = pPtFrm->FindPageFrm();
//STRIP001 		else
//STRIP001 			pPtFrm = 0;
//STRIP001 
//STRIP001 		if( PCURCRSR->HasMark() &&
//STRIP001 			0 != (pCNd = PCURCRSR->GetCntntNode( FALSE ) ) &&
//STRIP001 			0 != ( pMkFrm = pCNd->GetFrm( &aNulPt, 0, FALSE )) )
//STRIP001 			pMkFrm = pMkFrm->FindPageFrm();
//STRIP001 		else
//STRIP001 			pMkFrm = pPtFrm;
//STRIP001 
//STRIP001 
//STRIP001 		if( !pMkFrm || !pPtFrm )
//STRIP001 			pFnd = 0;
//STRIP001 		else if( pMkFrm == pPtFrm )
//STRIP001 			pFnd = ((SwPageFrm*)pMkFrm)->GetPageDesc();
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// swap pointer if PtFrm before MkFrm
//STRIP001 			if( ((SwPageFrm*)pMkFrm)->GetPhyPageNum() >
//STRIP001 				((SwPageFrm*)pPtFrm)->GetPhyPageNum() )
//STRIP001 			{
//STRIP001 				const SwFrm* pTmp = pMkFrm; pMkFrm = pPtFrm; pPtFrm = pTmp;
//STRIP001 			}
//STRIP001 
//STRIP001 			// now check from MkFrm to PtFrm for equal PageDescs
//STRIP001 			pFnd = ((SwPageFrm*)pMkFrm)->GetPageDesc();
//STRIP001 			while( pFnd && pMkFrm != pPtFrm )
//STRIP001 			{
//STRIP001 				pMkFrm = pMkFrm->GetNext();
//STRIP001 				if( !pMkFrm || pFnd != ((SwPageFrm*)pMkFrm)->GetPageDesc() )
//STRIP001 					pFnd = 0;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if( (SwPageDesc*)0xffffffff == pRetDesc )
//STRIP001 			pRetDesc = pFnd;
//STRIP001 		else if( pFnd != pRetDesc )
//STRIP001 		{
//STRIP001 			pRetDesc = 0;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 	FOREACHPAM_END()
//STRIP001 
//STRIP001 	return pRetDesc;
//STRIP001 }



}
