/*************************************************************************
 *
 *  $RCSfile: sw_SwXMLBlockExport.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: aw $ $Date: 2003/12/05 15:10:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Martin Gallwey (gallwey@sun.com)
 *
 *
 ************************************************************************/
namespace binfilter {
//STRIP001 #ifndef _SW_XMLBLOCKEXPORT_HXX
//STRIP001 #include <SwXMLBlockExport.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SW_XMLTEXTBLOCKS_HXX
//STRIP001 #include <SwXMLTextBlocks.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_XMLTOKEN_HXX
//STRIP001 #include <bf_xmloff/xmltoken.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_NMSPMAP_HXX
//STRIP001 #include <bf_xmloff/nmspmap.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_XMLNMSPE_HXX
//STRIP001 #include <bf_xmloff/xmlnmspe.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 using namespace ::com::sun::star::uno;
//STRIP001 using namespace ::com::sun::star;
//STRIP001 using namespace ::binfilter::xmloff::token;
//STRIP001 using namespace ::rtl;

// #110680#
//STRIP001 SwXMLBlockListExport::SwXMLBlockListExport( 
//STRIP001 	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 	SwXMLTextBlocks & rBlocks, 
//STRIP001 	const ::rtl::OUString &rFileName,
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler> &rHandler)
//STRIP001 :	SvXMLExport( xServiceFactory, rFileName, rHandler ),
//STRIP001 	rBlockList(rBlocks)
//STRIP001 {
//STRIP001 	_GetNamespaceMap().Add( GetXMLToken ( XML_NP_BLOCK_LIST ),
//STRIP001 							GetXMLToken ( XML_N_BLOCK_LIST ), 
//STRIP001 							XML_NAMESPACE_BLOCKLIST );
//STRIP001 } 

//STRIP001 sal_uInt32 SwXMLBlockListExport::exportDoc(enum XMLTokenEnum eClass)
//STRIP001 {
//STRIP001 	GetDocHandler()->startDocument();
//STRIP001 	
//STRIP001 	AddAttribute ( XML_NAMESPACE_NONE, 
//STRIP001 			       _GetNamespaceMap().GetAttrNameByKey ( XML_NAMESPACE_BLOCKLIST ),
//STRIP001 				   _GetNamespaceMap().GetNameByKey ( XML_NAMESPACE_BLOCKLIST ) );
//STRIP001 	AddAttribute( XML_NAMESPACE_BLOCKLIST, 
//STRIP001 				  XML_LIST_NAME,
//STRIP001 				  OUString (rBlockList.GetName()));
//STRIP001 	{
//STRIP001 		SvXMLElementExport pRoot (*this, XML_NAMESPACE_BLOCKLIST, XML_BLOCK_LIST, sal_True, sal_True);
//STRIP001 		sal_uInt16 nBlocks= rBlockList.GetCount();
//STRIP001 		for ( sal_uInt16 i = 0; i < nBlocks; i++)
//STRIP001 		{
//STRIP001 			AddAttribute( XML_NAMESPACE_BLOCKLIST, 
//STRIP001 						  XML_ABBREVIATED_NAME, 
//STRIP001 						  OUString(rBlockList.GetShortName(i)));
//STRIP001 			AddAttribute( XML_NAMESPACE_BLOCKLIST,
//STRIP001 						  XML_PACKAGE_NAME, 
//STRIP001 						  OUString(rBlockList.GetPackageName(i)));
//STRIP001 			AddAttribute( XML_NAMESPACE_BLOCKLIST, 
//STRIP001 						  XML_NAME, 
//STRIP001 						  OUString(rBlockList.GetLongName(i)));
//STRIP001 			AddAttribute( XML_NAMESPACE_BLOCKLIST, 
//STRIP001 						  XML_UNFORMATTED_TEXT, 
//STRIP001 						  rBlockList.IsOnlyTextBlock(i) ? XML_TRUE : XML_FALSE );
//STRIP001 							  
//STRIP001 			SvXMLElementExport aBlock( *this, XML_NAMESPACE_BLOCKLIST, XML_BLOCK, sal_True, sal_True);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	GetDocHandler()->endDocument();
//STRIP001 	return 0;
//STRIP001 }

// #110680#
//STRIP001 SwXMLTextBlockExport::SwXMLTextBlockExport( 
//STRIP001 const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 SwXMLTextBlocks & rBlocks, 
//STRIP001 	const ::rtl::OUString &rFileName,
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler> &rHandler)
//STRIP001 :	SvXMLExport( xServiceFactory, rFileName, rHandler ),
//STRIP001 	rBlockList(rBlocks) 
//STRIP001 {
//STRIP001 	_GetNamespaceMap().Add( GetXMLToken ( XML_NP_BLOCK_LIST ),
//STRIP001 							GetXMLToken ( XML_N_BLOCK_LIST ), 
//STRIP001 							XML_NAMESPACE_BLOCKLIST );
//STRIP001 } 

//STRIP001 sal_uInt32 SwXMLTextBlockExport::exportDoc(const String &rText)
//STRIP001 {
//STRIP001 	GetDocHandler()->startDocument();
//STRIP001 	
//STRIP001 	AddAttribute ( XML_NAMESPACE_NONE, 
//STRIP001 			       _GetNamespaceMap().GetAttrNameByKey ( XML_NAMESPACE_BLOCKLIST ),
//STRIP001 				   _GetNamespaceMap().GetNameByKey ( XML_NAMESPACE_BLOCKLIST ) );
//STRIP001 	AddAttribute ( XML_NAMESPACE_NONE, 
//STRIP001 			       _GetNamespaceMap().GetAttrNameByKey ( XML_NAMESPACE_TEXT ),
//STRIP001 				   _GetNamespaceMap().GetNameByKey ( XML_NAMESPACE_TEXT ) );
//STRIP001 	AddAttribute ( XML_NAMESPACE_NONE, 
//STRIP001 			       _GetNamespaceMap().GetAttrNameByKey ( XML_NAMESPACE_OFFICE ),
//STRIP001 				   _GetNamespaceMap().GetNameByKey ( XML_NAMESPACE_OFFICE ) );
//STRIP001 	AddAttribute( XML_NAMESPACE_BLOCKLIST, 
//STRIP001 				  XML_LIST_NAME,
//STRIP001 				  OUString (rBlockList.GetName()));
//STRIP001 	{
//STRIP001 		SvXMLElementExport aDocument (*this, XML_NAMESPACE_OFFICE, XML_DOCUMENT, sal_True, sal_True);
//STRIP001 		{
//STRIP001 			SvXMLElementExport aBody (*this, XML_NAMESPACE_OFFICE, XML_BODY, sal_True, sal_True);
//STRIP001 			{
//STRIP001 				xub_StrLen nPos = 0;
//STRIP001 				do
//STRIP001 				{
//STRIP001 					String sTemp ( rText.GetToken( 0, '\015', nPos ) );
//STRIP001 				 	SvXMLElementExport aPara (*this, XML_NAMESPACE_TEXT, XML_P, sal_True, sal_False);
//STRIP001 					GetDocHandler()->characters(sTemp);
//STRIP001 				} while (STRING_NOTFOUND != nPos );
//STRIP001 			}
//STRIP001 
//STRIP001 		}
//STRIP001 	}
//STRIP001 	GetDocHandler()->endDocument();
//STRIP001 	return 0;
//STRIP001 }
}
