/*************************************************************************
 *
 *  $RCSfile: sw_SwXMLBlockImport.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: aw $ $Date: 2003/12/05 15:10:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Martin Gallwey (gallwey@sun.com)
 *
 *
 ************************************************************************/
namespace binfilter {
//STRIP001 #ifndef _SW_XMLBLOCKIMPORT_HXX
//STRIP001 #include <SwXMLBlockImport.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_NMSPMAP_HXX
//STRIP001 #include <bf_xmloff/nmspmap.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_XMLNMSPE_HXX
//STRIP001 #include <bf_xmloff/xmlnmspe.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _XMLOFF_XMLTOKEN_HXX
//STRIP001 #include <bf_xmloff/xmltoken.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SW_XMLBLOCKLIST_CONTEXT_HXX
//STRIP001 #include <SwXMLBlockListContext.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SW_XMLTEXTBLOCKS_HXX
//STRIP001 #include <SwXMLTextBlocks.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 using namespace ::com::sun::star::uno;
//STRIP001 using namespace ::com::sun::star;
//STRIP001 using namespace ::binfilter::xmloff::token;
//STRIP001 using namespace ::rtl;

//STRIP001 sal_Char __READONLY_DATA sXML_np__block_list[] = "_block-list";

// #110680#
//STRIP001 SwXMLBlockListImport::SwXMLBlockListImport( 
//STRIP001 	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 	SwXMLTextBlocks &rBlocks )
//STRIP001 :	SvXMLImport( xServiceFactory ),
//STRIP001 	rBlockList (rBlocks)
//STRIP001 {
//STRIP001 	GetNamespaceMap().Add( OUString ( RTL_CONSTASCII_USTRINGPARAM ( sXML_np__block_list ) ),
//STRIP001 						   GetXMLToken ( XML_N_BLOCK_LIST ),
//STRIP001 						   XML_NAMESPACE_BLOCKLIST );
//STRIP001 }

//STRIP001 SwXMLBlockListImport::~SwXMLBlockListImport ( void )
//STRIP001 	throw ()
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SwXMLBlockListImport::CreateContext(
//STRIP001 		sal_uInt16 nPrefix,
//STRIP001 		const OUString& rLocalName,
//STRIP001 		const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 	if ( XML_NAMESPACE_BLOCKLIST == nPrefix &&
//STRIP001 		 IsXMLToken ( rLocalName, XML_BLOCK_LIST ) )
//STRIP001 		pContext = new SwXMLBlockListContext( *this, nPrefix, rLocalName,
//STRIP001 											  xAttrList );
//STRIP001 	else
//STRIP001 		pContext = SvXMLImport::CreateContext( nPrefix, rLocalName, xAttrList ); 
//STRIP001 	return pContext;
//STRIP001 }

// #110680#
//STRIP001 SwXMLTextBlockImport::SwXMLTextBlockImport(
//STRIP001 	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceFactory,
//STRIP001 	SwXMLTextBlocks &rBlocks, 
//STRIP001 	String & rNewText, 
//STRIP001 	sal_Bool bNewTextOnly )
//STRIP001 :	SvXMLImport(xServiceFactory),
//STRIP001 	rBlockList ( rBlocks ),
//STRIP001 	bTextOnly ( bNewTextOnly ),
//STRIP001 	m_rText ( rNewText )
//STRIP001 {
//STRIP001 }

//STRIP001 SwXMLTextBlockImport::~SwXMLTextBlockImport ( void )
//STRIP001 	throw()
//STRIP001 {
//STRIP001 }

//STRIP001 SvXMLImportContext *SwXMLTextBlockImport::CreateContext(
//STRIP001 		sal_uInt16 nPrefix,
//STRIP001 		const OUString& rLocalName,
//STRIP001 		const Reference< xml::sax::XAttributeList > & xAttrList )
//STRIP001 {
//STRIP001 	SvXMLImportContext *pContext = 0;
//STRIP001 	if( XML_NAMESPACE_OFFICE == nPrefix &&
//STRIP001 		IsXMLToken ( rLocalName, bTextOnly ? XML_DOCUMENT : XML_DOCUMENT_CONTENT ) )
//STRIP001 		pContext = new SwXMLTextBlockDocumentContext( *this, nPrefix, rLocalName, xAttrList );
//STRIP001 	else
//STRIP001 		pContext = SvXMLImport::CreateContext( nPrefix, rLocalName, xAttrList ); 
//STRIP001 	return pContext;
//STRIP001 }
//STRIP001 void SAL_CALL SwXMLTextBlockImport::endDocument(void)
//STRIP001 		throw( ::com::sun::star::xml::sax::SAXException, ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 }
}
