/*************************************************************************
 *
 *  $RCSfile: sw_viewpg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:52:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _HINTIDS_HXX
//STRIP001 #include <hintids.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SV_WINDOW_HXX //autogen
//STRIP001 #include <vcl/window.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFX_PRINTER_HXX //autogen
//STRIP001 #include <bf_sfx2/printer.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFX_PROGRESS_HXX //autogen
//STRIP001 #include <bf_sfx2/progress.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _PVPRTDAT_HXX
//STRIP001 #include <pvprtdat.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOC_HXX
//STRIP001 #include <doc.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEWSH_HXX
//STRIP001 #include <viewsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _PAGEFRM_HXX
//STRIP001 #include <pagefrm.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _ROOTFRM_HXX
//STRIP001 #include <rootfrm.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEWIMP_HXX
//STRIP001 #include <viewimp.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEWOPT_HXX
//STRIP001 #include <viewopt.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWPRTOPT_HXX
//STRIP001 #include <swprtopt.hxx> // SwPrtOptions
//STRIP001 #endif
//STRIP001 #ifndef _FLDBAS_HXX
//STRIP001 #include <fldbas.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _PTQUEUE_HXX
//STRIP001 #include <ptqueue.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWREGION_HXX
//STRIP001 #include <swregion.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _HINTS_HXX
//STRIP001 #include <hints.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FNTCACHE_HXX
//STRIP001 #include <fntcache.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _STATSTR_HRC
//STRIP001 #include <statstr.hrc>	// Text fuer SfxProgress
//STRIP001 #endif
//STRIP001 #ifndef _COMCORE_HRC
//STRIP001 #include <comcore.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 const SwTwips nXFree = 4*142;        // == 0.25 cm * 4
//STRIP001 const SwTwips nYFree = 4*142;
//STRIP001 static USHORT nPrevViewXFreePix = 0;
//STRIP001 static USHORT nPrevViewYFreePix = 0;
//STRIP001 
//STRIP001 // OD 12.12.2002 #103492#
//STRIP001 SwPagePreviewLayout* ViewShell::PagePreviewLayout()
//STRIP001 {
//STRIP001     return Imp()->PagePreviewLayout();
//STRIP001 }
//STRIP001 
//STRIP001 void ViewShell::ShowPreViewSelection( sal_uInt16 nSelPage )
//STRIP001 {
//STRIP001     Imp()->InvalidateAccessiblePreViewSelection( nSelPage );
//STRIP001 }
//STRIP001 
//STRIP001 /** adjust view options for page preview
//STRIP001 
//STRIP001     OD 09.01.2003 #i6467#
//STRIP001 */
//STRIP001 void ViewShell::AdjustOptionsForPagePreview( const SwPrtOptions &_rPrintOptions )
//STRIP001 {
//STRIP001     if ( !IsPreView() )
//STRIP001     {
//STRIP001         ASSERT( false, "view shell doesn't belongs to a page preview - no adjustment of its view options");
//STRIP001         return;
//STRIP001     }
//STRIP001 
//STRIP001     PrepareForPrint( _rPrintOptions );
//STRIP001 
//STRIP001     return;
//STRIP001 }
//STRIP001 
// output print preview on printer
// OD 05.05.2003 #i14016# - consider empty pages on calculation of scaling
// and on calculation of paint offset.
//STRIP001 void ViewShell::PrintPreViewPage( SwPrtOptions& rOptions,
//STRIP001 								  USHORT nRowCol, SfxProgress& rProgress,
//STRIP001                                   const SwPagePreViewPrtData* pPrtData )
//STRIP001 {
//STRIP001 	if( !rOptions.aMulti.GetSelectCount() )
//STRIP001 		return;
//STRIP001 
//STRIP001 	// wenn kein Drucker vorhanden ist, wird nicht gedruckt
//STRIP001 	SfxPrinter* pPrt = GetPrt();
//STRIP001 	if(	!pPrt || !pPrt->GetName().Len() )
//STRIP001 		return;
//STRIP001 
//STRIP001 // schoen waers gewesen !!!	const MultiSelection& rMulti = rOptions.aMulti;
//STRIP001 	MultiSelection aMulti( rOptions.aMulti );
//STRIP001 	Range aPages( aMulti.FirstSelected(), aMulti.LastSelected() );
//STRIP001 	if ( aPages.Max() > USHRT_MAX )
//STRIP001 		aPages.Max() = USHRT_MAX;
//STRIP001 
//STRIP001 	ASSERT( aPages.Min() > 0,
//STRIP001 			"Seite 0 Drucken?" );
//STRIP001 	ASSERT( aPages.Min() <= aPages.Max(),
//STRIP001 			"MinSeite groesser MaxSeite." );
//STRIP001 
//STRIP001 	// eine neue Shell fuer den Printer erzeugen
//STRIP001 	ViewShell aShell( *this, 0 );
//STRIP001 	if ( &GetRefDev() == pPrt )
//STRIP001         aShell.mpTmpRef = new SfxPrinter( *pPrt );
//STRIP001 
//STRIP001 	SET_CURR_SHELL( &aShell );
//STRIP001 
//STRIP001 	aShell.PrepareForPrint( rOptions );
//STRIP001 
//STRIP001 	// gibt es versteckte Absatzfelder, unnoetig wenn die Absaetze bereits
//STRIP001 	// ausgeblendet sind.
//STRIP001 	int bHiddenFlds = FALSE;
//STRIP001 	SwFieldType* pFldType = 0;
//STRIP001 	if ( GetViewOptions()->IsShowHiddenPara() )
//STRIP001 	{
//STRIP001 		pFldType = GetDoc()->GetSysFldType( RES_HIDDENPARAFLD );
//STRIP001 		bHiddenFlds = 0 != pFldType->GetDepends();
//STRIP001 		if( bHiddenFlds )
//STRIP001 		{
//STRIP001 			SwMsgPoolItem aHnt( RES_HIDDENPARA_PRINT );
//STRIP001 			pFldType->Modify( &aHnt, 0);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Seiten fuers Drucken formatieren
//STRIP001 	aShell.CalcPagesForPrint( (USHORT)aPages.Max(), &rProgress );
//STRIP001 
//STRIP001 	USHORT nCopyCnt = rOptions.bCollate ? rOptions.nCopyCount : 1;
//STRIP001 	BOOL bStartJob = FALSE;
//STRIP001 
//STRIP001 	for ( USHORT nCnt = 0; nCnt < nCopyCnt; nCnt++ )
//STRIP001 	{
//STRIP001         if( rOptions.IsPrintSingleJobs() && rOptions.GetJobName().Len() &&
//STRIP001 			( bStartJob || rOptions.bJobStartet ) )
//STRIP001 		{
//STRIP001 			pPrt->EndJob();
//STRIP001 			rOptions.bJobStartet = TRUE;
//STRIP001 
//STRIP001 			// Reschedule statt Yield, da Yield keine Events abarbeitet
//STRIP001 			// und es sonst eine Endlosschleife gibt.
//STRIP001 			while( pPrt->IsPrinting() )
//STRIP001 					rProgress.Reschedule();
//STRIP001 
//STRIP001 			rOptions.MakeNextJobName();
//STRIP001 			bStartJob = pPrt->StartJob( rOptions.GetJobName() );
//STRIP001 		}
//STRIP001 
//STRIP001 		const SwPageFrm *pStPage  = (SwPageFrm*)GetLayout()->Lower();
//STRIP001 		const SwFrm		*pEndPage = pStPage;
//STRIP001 
//STRIP001 		for( USHORT i = 1; pStPage && i < (USHORT)aPages.Min(); ++i )
//STRIP001 			pStPage = (SwPageFrm*)pStPage->GetNext();
//STRIP001 
//STRIP001 		if( !pStPage )			// dann wars das
//STRIP001 		{
//STRIP001 			if( bHiddenFlds )
//STRIP001 			{
//STRIP001 				SwMsgPoolItem aHnt( RES_HIDDENPARA_PRINT );
//STRIP001 				pFldType->Modify( &aHnt, 0);
//STRIP001 				CalcPagesForPrint( (USHORT)aPages.Max() );
//STRIP001 			}
//STRIP001 			return;
//STRIP001 		}
//STRIP001 
//STRIP001 		// unsere SttPage haben wir, dann die EndPage suchen
//STRIP001 		USHORT nFirstPageNo = i;
//STRIP001 		USHORT nLastPageNo  = i;
//STRIP001 		USHORT nPageNo      = 1;
//STRIP001 
//STRIP001 		pEndPage = pStPage;
//STRIP001 
//STRIP001 		if( pStPage->GetNext() && (i != (USHORT)aPages.Max()) )
//STRIP001 		{
//STRIP001 			pEndPage = pEndPage->GetNext();
//STRIP001 			for( ++i,++nLastPageNo;
//STRIP001 				 pEndPage->GetNext() && i < (USHORT)aPages.Max(); ++i )
//STRIP001 			{
//STRIP001 				pEndPage = pEndPage->GetNext();
//STRIP001 				++nLastPageNo;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if( rOptions.bPrintReverse )
//STRIP001 		{
//STRIP001 			const SwFrm *pTmp = pStPage;
//STRIP001 			pStPage  = (SwPageFrm*)pEndPage;
//STRIP001 			pEndPage = pTmp;
//STRIP001 			nPageNo  = nLastPageNo;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			nPageNo = nFirstPageNo;
//STRIP001 
//STRIP001 		// ein Array fuer die Seiten anlegen, die auf eine Drucker-Seite
//STRIP001 		// gedruckt werden sollen.
//STRIP001 		BYTE nRow = BYTE(nRowCol >> 8), nCol = BYTE(nRowCol & 0xff);
//STRIP001 		USHORT nPages = nRow * nCol;
//STRIP001 		SwPageFrm** aPageArr = new SwPageFrm* [ nPages ];
//STRIP001 		memset( aPageArr, 0, sizeof( SwPageFrm* ) * nPages );
//STRIP001 		USHORT nCntPage = 0;
//STRIP001 
//STRIP001 		SwTwips nCalcW = 0, nCalcH = 0, nMaxRowSz = 0, nMaxColSz = 0;
//STRIP001 
//STRIP001 		MapMode aOld( pPrt->GetMapMode() );
//STRIP001 		MapMode aMapMode( MAP_TWIP );
//STRIP001 		Size aPrtSize( pPrt->PixelToLogic( pPrt->GetPaperSizePixel(), aMapMode ));
//STRIP001 		if( pPrtData )
//STRIP001 		{
//STRIP001 			aPrtSize.Width() -= pPrtData->GetLeftSpace() +
//STRIP001 								pPrtData->GetRightSpace() +
//STRIP001 								( pPrtData->GetHorzSpace() * (nCol - 1));
//STRIP001 			aPrtSize.Height() -= pPrtData->GetTopSpace() +
//STRIP001 								pPrtData->GetBottomSpace() +
//STRIP001 								( pPrtData->GetVertSpace() * (nRow - 1));
//STRIP001 		}
//STRIP001 
//STRIP001 		aMulti.Select( Range( nLastPageNo+1, USHRT_MAX ), FALSE );
//STRIP001 		USHORT nSelCount = USHORT((aMulti.GetSelectCount()+nPages-1) / nPages);
//STRIP001 		nSelCount *= nCopyCnt;
//STRIP001 		USHORT nPrintCount = 1;
//STRIP001 
//STRIP001 		const XubString aTmp( SW_RES( STR_STATSTR_PRINT ) );
//STRIP001 		rProgress.SetText( aTmp );
//STRIP001 		//HACK, damit die Anzeige nicht durcheinander kommt:
//STRIP001 		rProgress.SetState( 1, nSelCount );
//STRIP001 		rProgress.SetText( aTmp );
//STRIP001 		bStartJob = TRUE;
//STRIP001 
//STRIP001 		while( pStPage )
//STRIP001 		{
//STRIP001 			// Mag der Anwender noch ?
//STRIP001 			rProgress.Reschedule();
//STRIP001 
//STRIP001 			if ( !pPrt->IsJobActive() )
//STRIP001 				break;
//STRIP001 
//STRIP001 			if( aMulti.IsSelected( nPageNo ) )
//STRIP001 			{
//STRIP001 				if( rOptions.bPrintReverse )
//STRIP001 					aPageArr[ nPages - ++nCntPage ] = (SwPageFrm*)pStPage;
//STRIP001 				else
//STRIP001 					aPageArr[ nCntPage++ ] = (SwPageFrm*)pStPage;
//STRIP001 
//STRIP001                 // OD 05.05.2003 #i14016# - consider empty pages on calculation
//STRIP001                 // of page size, used for calculation of scaling.
//STRIP001                 Size aPageSize;
//STRIP001                 if ( pStPage->IsEmptyPage() )
//STRIP001                 {
//STRIP001                     if ( pStPage->GetPhyPageNum() % 2 == 0 )
//STRIP001                         aPageSize = pStPage->GetPrev()->Frm().SSize();
//STRIP001                     else
//STRIP001                         aPageSize = pStPage->GetNext()->Frm().SSize();
//STRIP001                 }
//STRIP001                 else
//STRIP001                 {
//STRIP001                     aPageSize = pStPage->Frm().SSize();
//STRIP001                 }
//STRIP001                 nCalcW += aPageSize.Width();
//STRIP001                 if( nCalcH < aPageSize.Height() )
//STRIP001                     nCalcH = aPageSize.Height();
//STRIP001 
//STRIP001 				if( 0 == (nCntPage % nCol ) || 			// neue Zeile
//STRIP001 					nCntPage == nPages || pStPage == pEndPage )
//STRIP001 				{
//STRIP001 					// sollte die Seite nicht gefuellt sein, so erweiter
//STRIP001 					// anhand der letzen Seite. Dadurch hat auch die
//STRIP001 					// letze Seite die richtigen Spalten/Reihen.
//STRIP001 					// BUG: 17695
//STRIP001 					if( pStPage == pEndPage && nCntPage != nPages )
//STRIP001 					{
//STRIP001 						// dann Werte mit der letzen Seite auffuellen
//STRIP001 						if( nCntPage < nCol )
//STRIP001                             nCalcW += aPageSize.Width() * (nCol - nCntPage);
//STRIP001 
//STRIP001 						BYTE nRows = (BYTE) ( nCntPage / nCol + 1 );
//STRIP001 						if( nRows < nRow )
//STRIP001 							nCalcH += ( nRow - nRows ) * nCalcH;
//STRIP001 					}
//STRIP001 
//STRIP001 					if( nMaxColSz < nCalcW )
//STRIP001 						nMaxColSz = nCalcW;
//STRIP001 					nCalcW = 0;
//STRIP001 					nMaxRowSz += nCalcH;
//STRIP001 				}
//STRIP001 
//STRIP001 				if( nCntPage == nPages || pStPage == pEndPage )
//STRIP001 				{
//STRIP001 					// den MapMode einstellen
//STRIP001 					aMapMode.SetOrigin( Point() );
//STRIP001 					{
//STRIP001 						Fraction aScX( aPrtSize.Width(), nMaxColSz );
//STRIP001 						Fraction aScY( aPrtSize.Height(), nMaxRowSz );
//STRIP001 
//STRIP001 						{
//STRIP001 							if( aScX < aScY )
//STRIP001 								aScY = aScX;
//STRIP001 
//STRIP001 							// fuer Drawing, damit diese ihre Objecte vernuenftig Painten
//STRIP001 							// koennen, auf "glatte" Prozentwerte setzen
//STRIP001 							aScY *= Fraction( 1000, 1 );
//STRIP001 							long nTmp = (long)aScY;
//STRIP001 							if( 1 < nTmp )
//STRIP001 								--nTmp;
//STRIP001 							else
//STRIP001 								nTmp = 1;
//STRIP001 							aScY = Fraction( nTmp, 1000 );
//STRIP001 							aScX = aScY;
//STRIP001 						}
//STRIP001 
//STRIP001 						aMapMode.SetScaleY( aScY );
//STRIP001 						aMapMode.SetScaleX( aScX );
//STRIP001 					}
//STRIP001 
//STRIP001 					Point aPrtOff( pPrt->PixelToLogic(
//STRIP001 										pPrt->GetPageOffsetPixel(), aMapMode ) );
//STRIP001 					long nPageHeight = (nMaxRowSz / nRow);
//STRIP001 
//STRIP001 					// dann kann das drucken losgehen
//STRIP001 					rProgress.SetState( nPrintCount++, nSelCount );
//STRIP001 
//STRIP001 					pPrt->StartPage();
//STRIP001 					Point aCalcPt;
//STRIP001 					SwPageFrm** ppTmpPg = aPageArr;
//STRIP001 
//STRIP001 					// ist das Array nicht vollsteandig gefuellt ?
//STRIP001 					if( rOptions.bPrintReverse && nCntPage != nPages )
//STRIP001 					{
//STRIP001 						// beim Rueckwaertsdruck alle Seiten nach vorne
//STRIP001 						// verschieben!
//STRIP001 						memmove( ppTmpPg, ppTmpPg + (nPages - nCntPage),
//STRIP001 									nCntPage * sizeof( SwPageFrm*) );
//STRIP001 						aPageArr[ nCntPage ] = 0;		// Endekennung
//STRIP001 					}
//STRIP001 
//STRIP001 					long nHOffs = 0, nVOffs = 0, nXStt = 0;
//STRIP001 					if( pPrtData )
//STRIP001 					{
//STRIP001 						const Fraction& rScaleX = aMapMode.GetScaleX();
//STRIP001 						const Fraction& rScaleY = aMapMode.GetScaleY();
//STRIP001 						Fraction aF( pPrtData->GetTopSpace(), 1 );
//STRIP001 						aCalcPt.Y() = aF /= rScaleY;
//STRIP001 						aF = Fraction( pPrtData->GetLeftSpace(), 1 );
//STRIP001 						nXStt = aF /= rScaleX;
//STRIP001 						aF = Fraction( pPrtData->GetVertSpace(), 1 );
//STRIP001 						nVOffs = aF /= rScaleY;
//STRIP001 						aF = Fraction( pPrtData->GetHorzSpace(), 1 );
//STRIP001 						nHOffs = aF /= rScaleX;
//STRIP001 					}
//STRIP001 
//STRIP001 					for( BYTE nR = 0; *ppTmpPg && nR < nRow; ++nR )
//STRIP001 					{
//STRIP001 						aCalcPt.X() = nXStt;
//STRIP001 						for( BYTE nC = 0; *ppTmpPg && nC < nCol; ++nC )
//STRIP001 						{
//STRIP001 							aShell.Imp()->SetFirstVisPageInvalid();
//STRIP001 							aShell.aVisArea = (*ppTmpPg)->Frm();
//STRIP001 
//STRIP001 							Point aPos( aCalcPt );
//STRIP001 							aPos -= aShell.aVisArea.Pos();
//STRIP001 							aPos -= aPrtOff;
//STRIP001 							aMapMode.SetOrigin( aPos );
//STRIP001 							pPrt->SetMapMode( aMapMode );
//STRIP001 							(*ppTmpPg)->GetUpper()->Paint( (*ppTmpPg)->Frm() );
//STRIP001                             // OD 05.05.2003 #i14016# - consider empty pages
//STRIP001                             // on calculation of the paint offset for the next page.
//STRIP001                             aCalcPt.X() += nHOffs;
//STRIP001                             if ( (*ppTmpPg)->IsEmptyPage() )
//STRIP001                             {
//STRIP001                                 if ( (*ppTmpPg)->GetPhyPageNum() % 2 == 0 )
//STRIP001                                     aCalcPt.X() += (*ppTmpPg)->GetPrev()->Frm().SSize().Width();
//STRIP001                                 else
//STRIP001                                     aCalcPt.X() += (*ppTmpPg)->GetNext()->Frm().SSize().Width();
//STRIP001                             }
//STRIP001                             else
//STRIP001                             {
//STRIP001                                 aCalcPt.X() += (*ppTmpPg)->Frm().Width();
//STRIP001                             }
//STRIP001 							++ppTmpPg;
//STRIP001 						}
//STRIP001 						aCalcPt.Y() += nVOffs + nPageHeight;
//STRIP001 					}
//STRIP001 					pPrt->EndPage();
//STRIP001 					SwPaintQueue::Repaint();
//STRIP001 
//STRIP001 					memset( aPageArr, 0, sizeof( SwPageFrm* ) * nPages );
//STRIP001                    nCntPage = 0;
//STRIP001 					nMaxRowSz = nMaxColSz = nCalcH = nCalcW = 0;
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if( pStPage == pEndPage )
//STRIP001 				pStPage = 0;
//STRIP001 			else if( rOptions.bPrintReverse )
//STRIP001 			{
//STRIP001 				--nPageNo;
//STRIP001 				pStPage = (SwPageFrm*)pStPage->GetPrev();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				++nPageNo;
//STRIP001 				pStPage = (SwPageFrm*)pStPage->GetNext();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		pPrt->SetMapMode( aOld );
//STRIP001 
//STRIP001 		if( bHiddenFlds )
//STRIP001 		{
//STRIP001 			SwMsgPoolItem aHnt( RES_HIDDENPARA_PRINT );
//STRIP001 			pFldType->Modify( &aHnt, 0);
//STRIP001 			CalcPagesForPrint( (USHORT)aPages.Max() );
//STRIP001 		}
//STRIP001         delete[] aPageArr;
//STRIP001 
//STRIP001 		if( bStartJob )
//STRIP001 			rOptions.bJobStartet = TRUE;
//STRIP001 	}
//STRIP001 	pFntCache->Flush();
//STRIP001 }
//STRIP001 
//STRIP001 // print brochure
//STRIP001 // OD 05.05.2003 #i14016# - consider empty pages on calculation of the scaling
//STRIP001 // for a page to be printed.
//STRIP001 void ViewShell::PrintProspect( SwPrtOptions& rOptions,
//STRIP001 							   SfxProgress& rProgress )
//STRIP001 {
//STRIP001 	if( !rOptions.aMulti.GetSelectCount() )
//STRIP001 		return;
//STRIP001 
//STRIP001 	// wenn kein Drucker vorhanden ist, wird nicht gedruckt
//STRIP001 	SfxPrinter* pPrt = GetPrt();
//STRIP001 	if( !pPrt || !pPrt->GetName().Len() ||
//STRIP001 		( !rOptions.bPrintLeftPage && !rOptions.bPrintRightPage ))
//STRIP001 		return;
//STRIP001 
//STRIP001 	MultiSelection aMulti( rOptions.aMulti );
//STRIP001 	Range aPages( aMulti.FirstSelected(), aMulti.LastSelected() );
//STRIP001 	if ( aPages.Max() > USHRT_MAX )
//STRIP001 		aPages.Max() = USHRT_MAX;
//STRIP001 
//STRIP001 	ASSERT( aPages.Min() > 0,
//STRIP001 			"Seite 0 Drucken?" );
//STRIP001 	ASSERT( aPages.Min() <= aPages.Max(),
//STRIP001 			"MinSeite groesser MaxSeite." );
//STRIP001 
//STRIP001 	// eine neue Shell fuer den Printer erzeugen
//STRIP001 	ViewShell aShell( *this, 0 );
//STRIP001 	if ( &GetRefDev() == pPrt )
//STRIP001         aShell.mpTmpRef = new SfxPrinter( *pPrt );
//STRIP001 
//STRIP001 	SET_CURR_SHELL( &aShell );
//STRIP001 
//STRIP001 	aShell.PrepareForPrint( rOptions );
//STRIP001 
//STRIP001 	// gibt es versteckte Absatzfelder, unnoetig wenn die Absaetze bereits
//STRIP001 	// ausgeblendet sind.
//STRIP001 	int bHiddenFlds = FALSE;
//STRIP001 	SwFieldType* pFldType = 0;
//STRIP001 	if ( GetViewOptions()->IsShowHiddenPara() )
//STRIP001 	{
//STRIP001 		pFldType = GetDoc()->GetSysFldType( RES_HIDDENPARAFLD );
//STRIP001 		bHiddenFlds = 0 != pFldType->GetDepends();
//STRIP001 		if( bHiddenFlds )
//STRIP001 		{
//STRIP001 			SwMsgPoolItem aHnt( RES_HIDDENPARA_PRINT );
//STRIP001 			pFldType->Modify( &aHnt, 0);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Seiten fuers Drucken formatieren
//STRIP001 	aShell.CalcPagesForPrint( (USHORT)aPages.Max(), &rProgress );
//STRIP001 
//STRIP001 	USHORT nCopyCnt = rOptions.bCollate ? rOptions.nCopyCount : 1;
//STRIP001 
//STRIP001 	const SwPageFrm *pStPage  = (SwPageFrm*)GetLayout()->Lower();
//STRIP001 
//STRIP001 	for( USHORT i = 1; pStPage && i < (USHORT)aPages.Min(); ++i )
//STRIP001 		pStPage = (SwPageFrm*)pStPage->GetNext();
//STRIP001 
//STRIP001 	if( !pStPage )          // dann wars das
//STRIP001 	{
//STRIP001 		if( bHiddenFlds )
//STRIP001 		{
//STRIP001 			SwMsgPoolItem aHnt( RES_HIDDENPARA_PRINT );
//STRIP001 			pFldType->Modify( &aHnt, 0);
//STRIP001 			CalcPagesForPrint( (USHORT)aPages.Max() );
//STRIP001 		}
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001 	// unsere SttPage haben wir, dann die EndPage suchen
//STRIP001 	SvPtrarr aArr( 255, 255 );
//STRIP001 	aArr.Insert( (void*)pStPage, aArr.Count() );
//STRIP001 
//STRIP001 	while( pStPage->GetNext() && i < (USHORT)aPages.Max() )
//STRIP001 	{
//STRIP001 		pStPage = (SwPageFrm*)pStPage->GetNext();
//STRIP001 		if( aMulti.IsSelected( ++i ) )
//STRIP001 			aArr.Insert( (void*)pStPage, aArr.Count() );
//STRIP001 	}
//STRIP001 
//STRIP001 	// auf Doppelseiten auffuellen
//STRIP001 	if( 1 == aArr.Count() )		// eine Seite ist ein Sonderfall
//STRIP001 		aArr.Insert( (void*)0, 1 );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		while( aArr.Count() & 3 )
//STRIP001 			aArr.Insert( (void*)0, aArr.Count() );
//STRIP001 
//STRIP001 		if( rOptions.bPrintReverse && 4 < aArr.Count() )
//STRIP001 		{
//STRIP001 			// das Array umsortieren
//STRIP001 			// Array:    1 2 3 4 5 6 7 8
//STRIP001 			// soll:	 3 4 1 2 7 8 5 6
//STRIP001 			// Algorhytmus:
//STRIP001 			// vordere Haelfte: Austausch von 2 Pointer von Vorne vor die Haelfte
//STRIP001 			// hintere Haelfte: Austausch von 2 Pointer von der Haelfte nach hinten
//STRIP001 
//STRIP001 			USHORT nHalf = aArr.Count() / 2;
//STRIP001 			USHORT nSwapCount = nHalf / 4;
//STRIP001 
//STRIP001 			VoidPtr* ppArrStt = (VoidPtr*)aArr.GetData();
//STRIP001 			VoidPtr* ppArrHalf = (VoidPtr*)aArr.GetData() + nHalf;
//STRIP001 
//STRIP001 			for( int nLoop = 0; nLoop < 2; ++nLoop )
//STRIP001 			{
//STRIP001 				for( USHORT n = 0; n < nSwapCount; ++n )
//STRIP001 				{
//STRIP001 					void* pTmp = *ppArrStt;
//STRIP001 					*ppArrStt++ = *(ppArrHalf-2);
//STRIP001 					*(ppArrHalf-2) = pTmp;
//STRIP001 
//STRIP001 					pTmp = *ppArrStt;
//STRIP001 					*ppArrStt++ = *--ppArrHalf;
//STRIP001 					*ppArrHalf-- = pTmp;
//STRIP001 				}
//STRIP001 				ppArrStt = (VoidPtr*)aArr.GetData() + nHalf;
//STRIP001 				ppArrHalf = (VoidPtr*)aArr.GetData() + aArr.Count();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bStartJob = FALSE;
//STRIP001 
//STRIP001 	for( USHORT nCnt = 0; nCnt < nCopyCnt; nCnt++ )
//STRIP001 	{
//STRIP001         if( rOptions.IsPrintSingleJobs() && rOptions.GetJobName().Len() &&
//STRIP001 			( bStartJob || rOptions.bJobStartet ) )
//STRIP001 		{
//STRIP001 			pPrt->EndJob();
//STRIP001 			rOptions.bJobStartet = TRUE;
//STRIP001 
//STRIP001 			// Reschedule statt Yield, da Yield keine Events abarbeitet
//STRIP001 			// und es sonst eine Endlosschleife gibt.
//STRIP001 			while( pPrt->IsPrinting() )
//STRIP001 					rProgress.Reschedule();
//STRIP001 
//STRIP001 			rOptions.MakeNextJobName();
//STRIP001 			bStartJob = pPrt->StartJob( rOptions.GetJobName() );
//STRIP001 		}
//STRIP001 
//STRIP001 		// dann sorge mal dafuer, das alle Seiten in der richtigen
//STRIP001 		// Reihenfolge stehen:
//STRIP001 		USHORT nSPg = 0, nEPg = aArr.Count(), nStep = 1;
//STRIP001 		if( 0 == (nEPg & 1 ))      // ungerade gibt es nicht!
//STRIP001 			--nEPg;
//STRIP001 
//STRIP001 		if( !rOptions.bPrintLeftPage )
//STRIP001 			++nStep;
//STRIP001 		else if( !rOptions.bPrintRightPage )
//STRIP001 		{
//STRIP001 			++nStep;
//STRIP001 			++nSPg, --nEPg;
//STRIP001 		}
//STRIP001 
//STRIP001 		USHORT nCntPage = (( nEPg - nSPg ) / ( 2 * nStep )) + 1;
//STRIP001 
//STRIP001 		MapMode aOld( pPrt->GetMapMode() );
//STRIP001 		MapMode aMapMode( MAP_TWIP );
//STRIP001 		Size aPrtSize( pPrt->PixelToLogic( pPrt->GetPaperSizePixel(), aMapMode ) );
//STRIP001 
//STRIP001 		const XubString aTmp( SW_RES( STR_STATSTR_PRINT ) );
//STRIP001 		rProgress.SetText( aTmp );
//STRIP001 		//HACK, damit die Anzeige nicht durcheinander kommt:
//STRIP001 		rProgress.SetState( 1, nCntPage );
//STRIP001 		rProgress.SetText( aTmp );
//STRIP001 
//STRIP001 		for( USHORT nPrintCount = 0; nSPg < nEPg &&
//STRIP001 				nPrintCount < nCntPage; ++nPrintCount )
//STRIP001 		{
//STRIP001 			// Mag der Anwender noch ?
//STRIP001 			rProgress.Reschedule();
//STRIP001 
//STRIP001 			if ( !pPrt->IsJobActive() )
//STRIP001 				break;
//STRIP001 
//STRIP001 			SwTwips nMaxRowSz, nMaxColSz;
//STRIP001 			pStPage = (SwPageFrm*)aArr[ nSPg ];
//STRIP001 			const SwPageFrm* pNxtPage = nEPg < aArr.Count()
//STRIP001 								? pNxtPage = (SwPageFrm*)aArr[ nEPg ]
//STRIP001 								: 0;
//STRIP001 
//STRIP001             // OD 05.05.2003 #i14016# - consider empty pages on calculation
//STRIP001             // of page size, used for calculation of scaling.
//STRIP001             Size aSttPageSize;
//STRIP001             if ( pStPage )
//STRIP001             {
//STRIP001                 if ( pStPage->IsEmptyPage() )
//STRIP001                 {
//STRIP001                     if ( pStPage->GetPhyPageNum() % 2 == 0 )
//STRIP001                         aSttPageSize = pStPage->GetPrev()->Frm().SSize();
//STRIP001                     else
//STRIP001                         aSttPageSize = pStPage->GetNext()->Frm().SSize();
//STRIP001                 }
//STRIP001                 else
//STRIP001                 {
//STRIP001                     aSttPageSize = pStPage->Frm().SSize();
//STRIP001                 }
//STRIP001             }
//STRIP001             Size aNxtPageSize;
//STRIP001             if ( pNxtPage )
//STRIP001             {
//STRIP001                 if ( pNxtPage->IsEmptyPage() )
//STRIP001                 {
//STRIP001                     if ( pNxtPage->GetPhyPageNum() % 2 == 0 )
//STRIP001                         aNxtPageSize = pNxtPage->GetPrev()->Frm().SSize();
//STRIP001                     else
//STRIP001                         aNxtPageSize = pNxtPage->GetNext()->Frm().SSize();
//STRIP001                 }
//STRIP001                 else
//STRIP001                 {
//STRIP001                     aNxtPageSize = pNxtPage->Frm().SSize();
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001             if( !pStPage )
//STRIP001 			{
//STRIP001                 nMaxColSz = 2 * aNxtPageSize.Width();
//STRIP001                 nMaxRowSz = aNxtPageSize.Height();
//STRIP001 			}
//STRIP001 			else if( !pNxtPage )
//STRIP001 			{
//STRIP001                 nMaxColSz = 2 * aSttPageSize.Width();
//STRIP001                 nMaxRowSz = aSttPageSize.Height();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001                 nMaxColSz = aNxtPageSize.Width() +
//STRIP001                             aSttPageSize.Width();
//STRIP001                 nMaxRowSz = Max( aNxtPageSize.Height(),
//STRIP001                                  aSttPageSize.Height() );
//STRIP001 			}
//STRIP001 
//STRIP001 			if( 0 == ( nSPg & 1 ) )		// diese muss gespiegel werden
//STRIP001 			{
//STRIP001 				const SwPageFrm* pTmp = pStPage;
//STRIP001 				pStPage = pNxtPage;
//STRIP001 				pNxtPage = pTmp;
//STRIP001 			}
//STRIP001 
//STRIP001 			// den MapMode einstellen
//STRIP001 			aMapMode.SetOrigin( Point() );
//STRIP001 			{
//STRIP001 				Fraction aScX( aPrtSize.Width(), nMaxColSz );
//STRIP001 				Fraction aScY( aPrtSize.Height(), nMaxRowSz );
//STRIP001 				if( aScX < aScY )
//STRIP001 					aScY = aScX;
//STRIP001 
//STRIP001 				{
//STRIP001 					// fuer Drawing, damit diese ihre Objecte vernuenftig Painten
//STRIP001 					// koennen, auf "glatte" Prozentwerte setzen
//STRIP001 					aScY *= Fraction( 1000, 1 );
//STRIP001 					long nTmp = (long)aScY;
//STRIP001 					if( 1 < nTmp )
//STRIP001 						--nTmp;
//STRIP001 					else
//STRIP001 						nTmp = 1;
//STRIP001 					aScY = Fraction( nTmp, 1000 );
//STRIP001 				}
//STRIP001 
//STRIP001 				aMapMode.SetScaleY( aScY );
//STRIP001 				aMapMode.SetScaleX( aScY );
//STRIP001 			}
//STRIP001 
//STRIP001 			Point aPrtOff( pPrt->PixelToLogic(
//STRIP001 								pPrt->GetPageOffsetPixel(), aMapMode ) );
//STRIP001 			Size aTmpPrtSize( pPrt->PixelToLogic(
//STRIP001 								pPrt->GetPaperSizePixel(), aMapMode ) );
//STRIP001 
//STRIP001 			// dann kann das drucken losgehen
//STRIP001 			bStartJob = TRUE;
//STRIP001 			rProgress.SetState( nPrintCount, nCntPage );
//STRIP001 
//STRIP001 			pPrt->StartPage();
//STRIP001 
//STRIP001 			Point aSttPt;
//STRIP001 			for( int nC = 0; nC < 2; ++nC )
//STRIP001 			{
//STRIP001 				if( pStPage )
//STRIP001 				{
//STRIP001 					aShell.Imp()->SetFirstVisPageInvalid();
//STRIP001 					aShell.aVisArea = pStPage->Frm();
//STRIP001 
//STRIP001 					Point aPos( aSttPt );
//STRIP001 					aPos -= aShell.aVisArea.Pos();
//STRIP001 					aPos -= aPrtOff;
//STRIP001 					aMapMode.SetOrigin( aPos );
//STRIP001 					pPrt->SetMapMode( aMapMode );
//STRIP001 					pStPage->GetUpper()->Paint( pStPage->Frm() );
//STRIP001 				}
//STRIP001 
//STRIP001 				pStPage = pNxtPage;
//STRIP001 				aSttPt.X() += aTmpPrtSize.Width() / 2;
//STRIP001 			}
//STRIP001 
//STRIP001 			pPrt->EndPage();
//STRIP001 			SwPaintQueue::Repaint();
//STRIP001 			nSPg += nStep;
//STRIP001 			nEPg -= nStep;
//STRIP001 		}
//STRIP001 		pPrt->SetMapMode( aOld );
//STRIP001 
//STRIP001 		if( bHiddenFlds )
//STRIP001 		{
//STRIP001 			SwMsgPoolItem aHnt( RES_HIDDENPARA_PRINT );
//STRIP001 			pFldType->Modify( &aHnt, 0);
//STRIP001 			CalcPagesForPrint( (USHORT)aPages.Max() );
//STRIP001 		}
//STRIP001 
//STRIP001 		if( bStartJob )
//STRIP001 			rOptions.bJobStartet = TRUE;
//STRIP001 	}
//STRIP001 	pFntCache->Flush();
//STRIP001 }
}
