/*************************************************************************
 *
 *  $RCSfile: sw_appenv.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:28:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#if STLPORT_VERSION>=321
#include <cstdarg>
#endif

#define ITEMID_BOXINFO      SID_ATTR_BORDER_INNER
#include <hintids.hxx>

// auto strip #include <bf_sfx2/request.hxx>

// auto strip #include <svtools/svmedit.hxx>
// auto strip #ifndef _APP_HXX //autogen
// auto strip #include <vcl/svapp.hxx>
// auto strip #endif
// auto strip #ifndef _WRKWIN_HXX //autogen
// auto strip #include <vcl/wrkwin.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_OBJFAC_HXX //autogen
// auto strip #include <bf_sfx2/docfac.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PRINTER_HXX //autogen
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BOXITEM_HXX //autogen
// auto strip #include <bf_svx/boxitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_LRSPITEM_HXX //autogen
// auto strip #include <bf_svx/lrspitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ULSPITEM_HXX //autogen
// auto strip #include <bf_svx/ulspitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_PBINITEM_HXX //autogen
// auto strip #include <bf_svx/pbinitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_PAPERINF_HXX
// auto strip #include <bf_svx/paperinf.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BRKITEM_HXX //autogen
// auto strip #include <bf_svx/brkitem.hxx>
// auto strip #endif
#ifndef _SBASLTID_HRC //autogen
#include <bf_offmgr/sbasltid.hrc>
#endif
// auto strip #ifndef _FMTHDFT_HXX //autogen
// auto strip #include <fmthdft.hxx>
// auto strip #endif
// auto strip #ifndef _SWWAIT_HXX
// auto strip #include <swwait.hxx>
// auto strip #endif
// auto strip #ifndef _PARATR_HXX
// auto strip #include <paratr.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
// auto strip #ifndef _VIEW_HXX
// auto strip #include <view.hxx>
// auto strip #endif
// auto strip #ifndef _DOCSH_HXX
// auto strip #include <docsh.hxx>
// auto strip #endif
// auto strip #ifndef _FRMATR_HXX
// auto strip #include <frmatr.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _DBMGR_HXX
// auto strip #include <dbmgr.hxx>
// auto strip #endif
// auto strip #ifndef _ENVLOP_HXX
// auto strip #include <envlop.hxx>
// auto strip #endif
// auto strip #ifndef _FMTCOL_HXX
// auto strip #include <fmtcol.hxx>
// auto strip #endif
// auto strip #ifndef _FRMMGR_HXX
// auto strip #include <frmmgr.hxx>
// auto strip #endif
// auto strip #ifndef _FLDMGR_HXX
// auto strip #include <fldmgr.hxx>
// auto strip #endif
// auto strip #ifndef _PAGEDESC_HXX
// auto strip #include <pagedesc.hxx>
// auto strip #endif
// auto strip #ifndef _POOLFMT_HXX
// auto strip #include <poolfmt.hxx>
// auto strip #endif
// auto strip #ifndef _EXPFLD_HXX
// auto strip #include <expfld.hxx>
// auto strip #endif
// auto strip #ifndef _SWSTYLENAMEMAPPER_HXX
// auto strip #include <SwStyleNameMapper.hxx>
// auto strip #endif
// auto strip #ifndef _CRSSKIP_HXX
// auto strip #include <crsskip.hxx>
// auto strip #endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _GLOBALS_HRC
#include <globals.hrc>
#endif
#ifndef _APP_HRC
#include <app.hrc>
#endif
#ifndef _POOLFMT_HRC
#include <poolfmt.hrc>
#endif
namespace binfilter {

#define ENV_NEWDOC		RET_OK
#define ENV_INSERT		RET_USER
#define ENV_CANCEL		SHRT_MAX


// --------------------------------------------------------------------------


// Funktion wird fuer Etiketten und Briefumschlaege benutzt!
//	im applab.cxx und appenv.cxx
//STRIP001 String InsertLabEnvText( SwWrtShell& rSh, SwFldMgr& rFldMgr, const String& rText )
//STRIP001 {
//STRIP001 	String sRet;
//STRIP001 	String aText(rText);
//STRIP001 	aText.EraseAllChars( '\r' );
//STRIP001 
//STRIP001 
//STRIP001 	USHORT nTokenPos = 0;
//STRIP001 	while( STRING_NOTFOUND != nTokenPos )
//STRIP001 	{
//STRIP001 		String aLine = aText.GetToken( 0, '\n', nTokenPos );
//STRIP001 		while ( aLine.Len() )
//STRIP001 		{
//STRIP001 			String sTmpText;
//STRIP001 			BOOL bField = FALSE;
//STRIP001 
//STRIP001 			USHORT nPos = aLine.Search( '<' );
//STRIP001 			if ( nPos )
//STRIP001 			{
//STRIP001 				sTmpText = aLine.Copy( 0, nPos );
//STRIP001 				aLine.Erase( 0, nPos );
//STRIP001 //				sTmpText = aLine.Cut( 0, nPos );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				nPos = aLine.Search( '>' );
//STRIP001 				if ( nPos == STRING_NOTFOUND )
//STRIP001 				{
//STRIP001 					sTmpText = aLine;
//STRIP001 					aLine.Erase();
//STRIP001 //					sTmpText = aLine.Cut();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					sTmpText = aLine.Copy( 0, nPos + 1);
//STRIP001 					aLine.Erase( 0, nPos + 1);
//STRIP001 //					sTmpText = aLine.Cut( 0, nPos + 1 );
//STRIP001 
//STRIP001 					// Datenbankfelder muesen mind. 3 Punkte beinhalten!
//STRIP001 					String sDBName( sTmpText.Copy( 1, sTmpText.Len() - 2));
//STRIP001 					USHORT nCnt = sDBName.GetTokenCount('.');
//STRIP001 					if (nCnt >= 3)
//STRIP001 					{
//STRIP001                         ::ReplacePoint(sDBName, TRUE);
//STRIP001                         SwInsertFld_Data aData(TYP_DBFLD, 0, sDBName, aEmptyStr, 0, &rSh );
//STRIP001                         rFldMgr.InsertFld( aData );
//STRIP001 						sRet = sDBName;
//STRIP001 						bField = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			if ( !bField )
//STRIP001 				rSh.Insert( sTmpText );
//STRIP001 		}
//STRIP001 		rSh.InsertLineBreak();
//STRIP001 	}
//STRIP001 	rSh.DelLeft();	// Letzten Linebreak wieder lschen
//STRIP001 
//STRIP001 	return sRet;
//STRIP001 }

// ----------------------------------------------------------------------------


//STRIP001 void lcl_CopyCollAttr(SwWrtShell* pOldSh, SwWrtShell* pNewSh, USHORT nCollId)
//STRIP001 {
//STRIP001 	USHORT nCollCnt = pOldSh->GetTxtFmtCollCount();
//STRIP001 	SwTxtFmtColl* pColl;
//STRIP001 	for( USHORT nCnt = 0; nCnt < nCollCnt; ++nCnt )
//STRIP001 		if(nCollId == (pColl = &pOldSh->GetTxtFmtColl(nCnt))->GetPoolFmtId())
//STRIP001 			pNewSh->GetTxtCollFromPool(nCollId)->SetAttr(pColl->GetAttrSet());
//STRIP001 }

// ----------------------------------------------------------------------------


//STRIP001 void SwModule::InsertEnv( SfxRequest& rReq )
//STRIP001 {
//STRIP001 static USHORT nTitleNo = 0;
//STRIP001 
//STRIP001 	SwDocShell		*pMyDocSh;
//STRIP001 	SfxViewFrame	*pFrame;
//STRIP001 	SwView			*pView;
//STRIP001 	SwWrtShell		*pOldSh,
//STRIP001 					*pSh;
//STRIP001 
//STRIP001 	//aktuelle Shell besorgen
//STRIP001 	pMyDocSh = (SwDocShell*) SfxObjectShell::Current();
//STRIP001 	pOldSh	 = pMyDocSh ? pMyDocSh->GetWrtShell() : 0;
//STRIP001 
//STRIP001 	// Neues Dokument erzeugen (kein Show!)
//STRIP001 	SfxObjectShellRef xDocSh( new SwDocShell( SFX_CREATE_MODE_STANDARD ) );
//STRIP001 	xDocSh->DoInitNew( 0 );
//STRIP001 	pFrame = SFX_APP()->CreateViewFrame( *xDocSh, 0, TRUE );
//STRIP001 	pView = (SwView*) pFrame->GetViewShell();
//STRIP001 	pView->AttrChangedNotify( &pView->GetWrtShell() );//Damit SelectShell gerufen wird.
//STRIP001 	pSh = pView->GetWrtShellPtr();
//STRIP001 
//STRIP001 	String aTmp( SW_RES(STR_ENV_TITLE) );
//STRIP001 	aTmp += String::CreateFromInt32( ++nTitleNo );
//STRIP001 	xDocSh->SetTitle( aTmp );
//STRIP001 
//STRIP001 	// Ggf. alte Collections "Absender" und "Empfaenger" in neues
//STRIP001 	// Dokument kopieren
//STRIP001 	if ( pOldSh )
//STRIP001 	{
//STRIP001 		::lcl_CopyCollAttr(pOldSh, pSh, RES_POOLCOLL_JAKETADRESS);
//STRIP001 		::lcl_CopyCollAttr(pOldSh, pSh, RES_POOLCOLL_SENDADRESS);
//STRIP001 	}
//STRIP001 
//STRIP001 	// SwEnvItem aus Config lesen
//STRIP001 	SwEnvCfgItem aEnvCfg;
//STRIP001 
//STRIP001 	//Haben wir schon einen Briefumschlag.
//STRIP001 	BOOL bEnvChange = FALSE;
//STRIP001 
//STRIP001 	SfxItemSet aSet(GetPool(), FN_ENVELOP, FN_ENVELOP, 0);
//STRIP001 	aSet.Put(aEnvCfg.GetItem());
//STRIP001 
//STRIP001 	SfxPrinter* pTempPrinter = pSh->GetPrt( TRUE );
//STRIP001 	if(pOldSh )
//STRIP001 	{
//STRIP001 		const SwPageDesc& rCurPageDesc = pOldSh->GetPageDesc(pOldSh->GetCurPageDesc());
//STRIP001 		String sJacket;
//STRIP001 		SwStyleNameMapper::FillUIName( RES_POOLPAGE_JAKET, sJacket );
//STRIP001 		bEnvChange = rCurPageDesc.GetName() == sJacket;
//STRIP001 		if(pOldSh->GetPrt(FALSE))
//STRIP001 		{
//STRIP001 			pSh->GetDoc()->SetJobsetup(*pOldSh->GetDoc()->GetJobsetup());
//STRIP001 			//#69563# if it isn't the same printer then the pointer has been invalidated!
//STRIP001 			pTempPrinter = pSh->GetPrt( TRUE );
//STRIP001 		}
//STRIP001 		pTempPrinter->SetPaperBin(rCurPageDesc.GetMaster().GetPaperBin().GetValue());
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	Window *pParent = pOldSh ? pOldSh->GetWin() : 0;
//STRIP001     SwEnvDlg* pDlg = NULL;
//STRIP001     short nMode = ENV_INSERT;
//STRIP001 
//STRIP001     SFX_REQUEST_ARG( rReq, pItem, SwEnvItem, FN_ENVELOP, sal_False );
//STRIP001     if ( !pItem )
//STRIP001     {
//STRIP001         pDlg = new SwEnvDlg( pParent, aSet, pOldSh, pTempPrinter, !bEnvChange);
//STRIP001         nMode = pDlg->Execute();
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         SFX_REQUEST_ARG( rReq, pBoolItem, SfxBoolItem, FN_PARAM_1, sal_False );
//STRIP001         if ( pBoolItem && pBoolItem->GetValue() )
//STRIP001             nMode = ENV_NEWDOC;
//STRIP001     }
//STRIP001 
//STRIP001     /*TODO #111050# call public made method of sfx (which was protected before!)
//STRIP001       to force missing event OnNew ... */
//STRIP001     if (nMode == ENV_NEWDOC)
//STRIP001         xDocSh->Stamp_SetActivateEvent(SFX_EVENT_CREATEDOC);
//STRIP001 
//STRIP001 	if (nMode == ENV_NEWDOC || nMode == ENV_INSERT)
//STRIP001 	{
//STRIP001 		SwWait aWait( (SwDocShell&)*xDocSh, TRUE );
//STRIP001 
//STRIP001 		// Dialog auslesen, Item in Config speichern
//STRIP001         const SwEnvItem& rItem = pItem ? *pItem : (const SwEnvItem&) pDlg->GetOutputItemSet()->Get(FN_ENVELOP);
//STRIP001 		aEnvCfg.GetItem() = rItem;
//STRIP001 		aEnvCfg.Commit();
//STRIP001 
//STRIP001 		//Wenn wir Drucken uebernehmen wir den eingestellten Jobsetup aus
//STRIP001 		//dem Dialog. Die Informationen muessen hier vor dem evtl. zerstoeren
//STRIP001 		//der neuen Shell gesetzt werden, weil deren Drucker an den Dialog
//STRIP001 		//gereicht wurde.
//STRIP001 		if ( nMode != ENV_NEWDOC )
//STRIP001 		{
//STRIP001 			ASSERT(pOldSh, "Kein Dokument - war 'Einfuegen' nicht disabled???");
//STRIP001 			SvxPaperBinItem aItem;
//STRIP001 			aItem.SetValue((BYTE)pSh->GetPrt()->GetPaperBin());
//STRIP001 			pOldSh->GetPageDescFromPool(RES_POOLPAGE_JAKET)->GetMaster().SetAttr(aItem);
//STRIP001 		}
//STRIP001 
//STRIP001 		SwWrtShell *pTmp = nMode == ENV_INSERT ? pOldSh : pSh;
//STRIP001 		const SwPageDesc* pFollow = 0;
//STRIP001 		SwTxtFmtColl *pSend = pTmp->GetTxtCollFromPool( RES_POOLCOLL_SENDADRESS ),
//STRIP001 					 *pAddr = pTmp->GetTxtCollFromPool( RES_POOLCOLL_JAKETADRESS);
//STRIP001 		const String &rSendMark = pSend->GetName();
//STRIP001 		const String &rAddrMark = pAddr->GetName();
//STRIP001 
//STRIP001 		if (nMode == ENV_INSERT)
//STRIP001 		{
//STRIP001 
//STRIP001 			SetView(&pOldSh->GetView()); // Pointer auf oberste View restaurieren
//STRIP001 
//STRIP001 			//Neues Dok wieder loeschen
//STRIP001 			xDocSh->DoClose();
//STRIP001 			pSh = pOldSh;
//STRIP001             //#i4251# selected text or objects in the document should 
//STRIP001             //not be deleted on inserting envelopes
//STRIP001             pSh->EnterStdMode();
//STRIP001 			// Los geht's (Einfuegen)
//STRIP001 			pSh->StartUndo(UIUNDO_INSERT_ENVELOPE);
//STRIP001 			pSh->StartAllAction();
//STRIP001 			pSh->SwCrsrShell::SttDoc();
//STRIP001 
//STRIP001 			if (bEnvChange)
//STRIP001 			{
//STRIP001 				// Folgevorlage: Seite 2
//STRIP001 				pFollow = pSh->GetPageDesc(pSh->GetCurPageDesc()).GetFollow();
//STRIP001 
//STRIP001 				// Text der ersten Seite loeschen
//STRIP001 				if ( !pSh->SttNxtPg(TRUE) )
//STRIP001 					pSh->EndPg(TRUE);
//STRIP001 				pSh->DelRight();
//STRIP001 				// Rahmen der ersten Seite loeschen
//STRIP001 				if( pSh->GotoFly( rSendMark ) )
//STRIP001 				{
//STRIP001 					pSh->EnterSelFrmMode();
//STRIP001 					pSh->DelRight();
//STRIP001 				}
//STRIP001 				if ( pSh->GotoFly( rAddrMark ) )
//STRIP001 				{
//STRIP001 					pSh->EnterSelFrmMode();
//STRIP001 					pSh->DelRight();
//STRIP001 				}
//STRIP001 				pSh->SwCrsrShell::SttDoc();
//STRIP001 			}
//STRIP001 			else
//STRIP001 				// Folgevorlage: Seite 1
//STRIP001 				pFollow = &pSh->GetPageDesc(pSh->GetCurPageDesc());
//STRIP001 
//STRIP001 			// Seitenumbruch einfuegen
//STRIP001 			if ( pSh->IsCrsrInTbl() )
//STRIP001 			{
//STRIP001 				pSh->SplitNode();
//STRIP001 				pSh->Right( CRSR_SKIP_CHARS, FALSE, 1, FALSE );
//STRIP001 				SfxItemSet aSet( pSh->GetAttrPool(), RES_BREAK, RES_BREAK, 0 );
//STRIP001 				aSet.Put( SvxFmtBreakItem(SVX_BREAK_PAGE_BEFORE) );
//STRIP001 				pSh->SetTblAttr( aSet );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pSh->InsertPageBreak(0, FALSE);
//STRIP001 			pSh->SwCrsrShell::SttDoc();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pFollow = &pSh->GetPageDesc(pSh->GetCurPageDesc());
//STRIP001 			// Los geht's (Drucken)
//STRIP001 			pSh->StartAllAction();
//STRIP001 			pSh->DoUndo(FALSE);
//STRIP001 
//STRIP001 			// Neue Collections "Absender" und "Empfaenger" wieder in neues
//STRIP001 			// Dokument kopieren
//STRIP001 			if ( pOldSh )
//STRIP001 			{
//STRIP001 				::lcl_CopyCollAttr(pOldSh, pSh, RES_POOLCOLL_JAKETADRESS);
//STRIP001 				::lcl_CopyCollAttr(pOldSh, pSh, RES_POOLCOLL_SENDADRESS);
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		SET_CURR_SHELL(pSh);
//STRIP001 		pSh->SetNewDoc();		// Performanceprobleme vermeiden
//STRIP001 
//STRIP001 		// Flys dieser Seite merken
//STRIP001 		SvPtrarr aFlyArr(0, 5);
//STRIP001 		if( ENV_NEWDOC != nMode && !bEnvChange )
//STRIP001 			pSh->GetPageObjs( aFlyArr );
//STRIP001 
//STRIP001 		// Page-Desc ermitteln
//STRIP001 		SwPageDesc* pDesc = pSh->GetPageDescFromPool(RES_POOLPAGE_JAKET);
//STRIP001 		SwFrmFmt&   rFmt  = pDesc->GetMaster();
//STRIP001 
//STRIP001 		Printer *pPrt = pSh->GetPrt( TRUE );
//STRIP001 
//STRIP001 		// Raender (setzen sich zusammen aus Shift-Offset und
//STRIP001 		// Ausrichtung)
//STRIP001 		Size aPaperSize = pPrt->PixelToLogic( pPrt->GetPaperSizePixel(),
//STRIP001 											  MAP_TWIP);
//STRIP001 		if ( !aPaperSize.Width() && !aPaperSize.Height() )
//STRIP001 		{
//STRIP001 			aPaperSize.Width() = lA4Width;
//STRIP001 			aPaperSize.Height()= lA4Height;
//STRIP001 		}
//STRIP001 		if ( aPaperSize.Width() > aPaperSize.Height() )
//STRIP001 			Swap( aPaperSize );
//STRIP001 
//STRIP001 		long lLeft  = rItem.lShiftRight,
//STRIP001 			 lUpper = rItem.lShiftDown;
//STRIP001 
//STRIP001 		USHORT nPageW = (USHORT) Max(rItem.lWidth, rItem.lHeight),
//STRIP001 			   nPageH = (USHORT) Min(rItem.lWidth, rItem.lHeight);
//STRIP001 
//STRIP001 		switch (rItem.eAlign)
//STRIP001 		{
//STRIP001 			case ENV_HOR_LEFT: break;
//STRIP001 			case ENV_HOR_CNTR: lLeft  += Max(0L, long(aPaperSize.Width() - nPageW)) / 2;
//STRIP001 							   break;
//STRIP001 			case ENV_HOR_RGHT: lLeft  += Max(0L, long(aPaperSize.Width() - nPageW));
//STRIP001 							   break;
//STRIP001 			case ENV_VER_LEFT: lUpper += Max(0L, long(aPaperSize.Width() - nPageH));
//STRIP001 							   break;
//STRIP001 			case ENV_VER_CNTR: lUpper += Max(0L, long(aPaperSize.Width() - nPageH)) / 2;
//STRIP001 							   break;
//STRIP001 			case ENV_VER_RGHT: break;
//STRIP001 		}
//STRIP001 		SvxLRSpaceItem aLRMargin;
//STRIP001 		SvxULSpaceItem aULMargin;
//STRIP001 		aLRMargin.SetLeft ((USHORT) lLeft );
//STRIP001 		aULMargin.SetUpper((USHORT) lUpper);
//STRIP001 		aLRMargin.SetRight(0);
//STRIP001 		aULMargin.SetLower(0);
//STRIP001 		rFmt.SetAttr(aLRMargin);
//STRIP001 		rFmt.SetAttr(aULMargin);
//STRIP001 
//STRIP001 		// Kopf-, Fusszeilen
//STRIP001 		rFmt.SetAttr(SwFmtHeader(BOOL(FALSE)));
//STRIP001 		pDesc->ChgHeaderShare(FALSE);
//STRIP001 		rFmt.SetAttr(SwFmtFooter(BOOL(FALSE)));
//STRIP001 		pDesc->ChgFooterShare(FALSE);
//STRIP001 
//STRIP001 		// Seitennumerierung
//STRIP001 		pDesc->SetUseOn(PD_ALL);
//STRIP001 
//STRIP001 		// Einstellen der Seitengroesse
//STRIP001 		rFmt.SetAttr(SwFmtFrmSize(ATT_FIX_SIZE,
//STRIP001 											nPageW + lLeft, nPageH + lUpper));
//STRIP001 
//STRIP001 		// Einstellen der Numerierungsart der Seite
//STRIP001 		SvxNumberType aType;
//STRIP001 		aType.SetNumberingType(SVX_NUM_NUMBER_NONE);
//STRIP001 		pDesc->SetNumType(aType);
//STRIP001 
//STRIP001 		// Folgevorlage
//STRIP001 		if (pFollow)
//STRIP001 			pDesc->SetFollow(pFollow);
//STRIP001 
//STRIP001 		// Landscape
//STRIP001 		pDesc->SetLandscape( rItem.eAlign >= ENV_VER_LEFT &&
//STRIP001 							 rItem.eAlign <= ENV_VER_RGHT);
//STRIP001 
//STRIP001 		// Page-Desc anwenden
//STRIP001 
//STRIP001 		USHORT nPos;
//STRIP001 		pSh->FindPageDescByName( pDesc->GetName(),
//STRIP001 									FALSE,
//STRIP001 									&nPos );
//STRIP001 
//STRIP001 
//STRIP001 		pSh->ChgPageDesc( nPos, *pDesc);
//STRIP001 		pSh->ChgCurPageDesc(*pDesc);
//STRIP001 
//STRIP001 		// Rahmen einfuegen
//STRIP001 		SwFlyFrmAttrMgr aMgr(FALSE, pSh, FRMMGR_TYPE_ENVELP);
//STRIP001 		SwFldMgr aFldMgr;
//STRIP001         aMgr.SetSizeType(ATT_VAR_SIZE);
//STRIP001 
//STRIP001         //Defaults ueberschreiben!
//STRIP001         aMgr.GetAttrSet().Put( SvxBoxItem() );
//STRIP001         aMgr.SetULSpace( 0L, 0L );
//STRIP001         aMgr.SetLRSpace( 0L, 0L );
//STRIP001 
//STRIP001 		// Absender
//STRIP001 		if (rItem.bSend)
//STRIP001 		{
//STRIP001 			pSh->SwCrsrShell::SttDoc();
//STRIP001 			aMgr.InsertFlyFrm(FLY_PAGE,
//STRIP001 				Point(rItem.lSendFromLeft + lLeft, rItem.lSendFromTop  + lUpper),
//STRIP001 				Size (rItem.lAddrFromLeft - rItem.lSendFromLeft, 0));
//STRIP001 
//STRIP001 			pSh->EnterSelFrmMode();
//STRIP001 			pSh->SetFlyName( rSendMark );
//STRIP001 			pSh->UnSelectFrm();
//STRIP001 			pSh->LeaveSelFrmMode();
//STRIP001 			pSh->SetTxtFmtColl( pSend );
//STRIP001 			InsertLabEnvText( *pSh, aFldMgr, rItem.aSendText );
//STRIP001 			aMgr.UpdateAttrMgr();
//STRIP001 		}
//STRIP001 
//STRIP001 		// Empfaenger
//STRIP001 		pSh->SwCrsrShell::SttDoc();
//STRIP001 
//STRIP001 		aMgr.InsertFlyFrm(FLY_PAGE,
//STRIP001 			Point(rItem.lAddrFromLeft + lLeft, rItem.lAddrFromTop  + lUpper),
//STRIP001 			Size (nPageW - rItem.lAddrFromLeft - 566, 0));
//STRIP001 		pSh->EnterSelFrmMode();
//STRIP001 		pSh->SetFlyName( rAddrMark );
//STRIP001 		pSh->UnSelectFrm();
//STRIP001 		pSh->LeaveSelFrmMode();
//STRIP001 		pSh->SetTxtFmtColl( pAddr );
//STRIP001 		InsertLabEnvText(*pSh, aFldMgr, rItem.aAddrText);
//STRIP001 
//STRIP001 		// Flys auf die "alten" Seiten verschieben
//STRIP001 		if (aFlyArr.Count())
//STRIP001 			pSh->SetPageObjsNewPage(aFlyArr, 1);
//STRIP001 
//STRIP001 		// Fertig
//STRIP001 		pSh->SwCrsrShell::SttDoc();
//STRIP001 
//STRIP001 		pSh->EndAllAction();
//STRIP001 
//STRIP001 		if (nMode == ENV_NEWDOC)
//STRIP001 			pSh->DoUndo(TRUE);
//STRIP001 		else
//STRIP001 			pSh->EndUndo(UIUNDO_INSERT_ENVELOPE);
//STRIP001 
//STRIP001 		if (nMode == ENV_NEWDOC)
//STRIP001 		{
//STRIP001 			pFrame->GetFrame()->Appear();
//STRIP001 
//STRIP001 			if ( rItem.aAddrText.indexOf('<') >= 0 )
//STRIP001 			{
//STRIP001 				static USHORT __READONLY_DATA aInva[] =
//STRIP001 									{
//STRIP001 										SID_SBA_BRW_UPDATE,
//STRIP001 										SID_SBA_BRW_INSERT,
//STRIP001 										SID_SBA_BRW_MERGE,
//STRIP001 										0
//STRIP001 									};
//STRIP001 				pFrame->GetBindings().Invalidate( aInva );
//STRIP001 
//STRIP001 				// Datenbankbeamer oeffnen
//STRIP001                 ShowDBObj(*pView, pSh->GetDBData());
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001         if ( !pItem )
//STRIP001         {
//STRIP001             rReq.AppendItem( rItem );
//STRIP001             if ( nMode == ENV_NEWDOC )
//STRIP001                 rReq.AppendItem( SfxBoolItem( FN_PARAM_1, TRUE ) );
//STRIP001         }
//STRIP001 
//STRIP001         rReq.Done();
//STRIP001 	}
//STRIP001 	else	//Abbruch
//STRIP001 	{
//STRIP001         rReq.Ignore();
//STRIP001 
//STRIP001 		xDocSh->DoClose();
//STRIP001 		--nTitleNo;
//STRIP001 
//STRIP001 		// Pointer auf oberste View restaurieren
//STRIP001 		if (pOldSh)
//STRIP001 			SetView(&pOldSh->GetView());
//STRIP001 	}
//STRIP001 	delete pDlg;
//STRIP001 }


}
