/*************************************************************************
 *
 *  $RCSfile: navipi.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:55:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _NAVIPI_HXX
#define _NAVIPI_HXX

// INCLUDE ---------------------------------------------------------------

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif
#ifndef _TRANSFER_HXX
#include <svtools/transfer.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX //autogen
#include <bf_sfx2/childwin.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif

#ifndef _CONTTREE_HXX
#include <conttree.hxx>
#endif
#ifndef _POPBOX_HXX
#include <popbox.hxx>
#endif
namespace binfilter {

class SwWrtShell;
class SwNavigationPI;
class SwNavigationChild;
class SfxBindings;
class NumEditAction;
class SwView;
//STRIP001 class SwNavigationConfig;
class SfxObjectShellLock;
class SfxChildWindowContext;

//-----------------------------------------------------------------------
class SwNavigationPI;
//STRIP001 class SwNavHelpToolBox : public SwHelpToolBox
//STRIP001 {
//STRIP001 	virtual void 	MouseButtonDown(const MouseEvent &rEvt);
//STRIP001 	virtual void	RequestHelp( const HelpEvent& rHEvt );
//STRIP001     public:
//STRIP001 		SwNavHelpToolBox(SwNavigationPI* pParent, const ResId &rResId);
//STRIP001 };


// CLASS -----------------------------------------------------------------
//STRIP001 class SwNavigationPI : public Window,
//STRIP001 						public SfxControllerItem, public SfxListener
//STRIP001 {
//STRIP001 	friend class SwNavigationChild;
//STRIP001 	friend class SwContentTree;
//STRIP001 	friend class SwGlobalTree;

	// --------- members -----------------------------
//STRIP001 	SwNavHelpToolBox   	aContentToolBox;
//STRIP001 	SwHelpToolBox   	aGlobalToolBox;
//STRIP001 	ImageList			aContentImageList;
//STRIP001     ImageList           aContentImageListH;
//STRIP001 	SwContentTree		aContentTree;
//STRIP001 	SwGlobalTree        aGlobalTree;
//STRIP001 	ListBox				aDocListBox;
//STRIP001 	Timer 				aPageChgTimer;
//STRIP001 	String				sContentFileName;
//STRIP001 	String				aContextArr[3];
//STRIP001 	String 				aStatusArr[4];
//STRIP001 	Point 				aBoxBottomLeft; // Pos., wenn Box unten ist

//STRIP001 	SfxObjectShellLock	*pxObjectShell;
//STRIP001 	SwView				*pContentView;
//STRIP001 	SwWrtShell			*pContentWrtShell;
//STRIP001 	SwView 				*pActContView;
//STRIP001 	SwView				*pCreateView;

//STRIP001 	SfxChildWindowContext* pContextWin;

//STRIP001 	SwNavigationConfig	*pConfig;
//STRIP001 	SfxBindings 		&rBindings;

//STRIP001 	long 	nDocLBIniHeight;
//STRIP001 	long	nWishWidth;
//STRIP001 	USHORT 	nActMark;
//STRIP001 	USHORT 	nAutoMarkIdx;
//STRIP001 	USHORT 	nRegionMode; // 0 - URL, 1 - Bereich mit Link 2 - B. ohne Link
//STRIP001 	short  	nZoomIn;
//STRIP001 	short  	nZoomOutInit;
//STRIP001 	short  	nZoomOut;

//STRIP001 	BOOL 	bSmallMode : 1;
//STRIP001 	BOOL 	bIsZoomedIn : 1;
//STRIP001 	BOOL	bPageCtrlsVisible : 1;
//STRIP001 	BOOL	bGlobalMode : 1;

	// --------- methods -----------------------------
//STRIP001 	BOOL _IsZoomedIn() const {return bIsZoomedIn;}
//STRIP001 	void _ZoomOut();
//STRIP001 	void _ZoomIn();

//STRIP001 	void FillBox();
//STRIP001 	void MakeMark();

//STRIP001 	DECL_LINK( DocListBoxSelectHdl, ListBox * );
//STRIP001 	DECL_LINK( ToolBoxSelectHdl, ToolBox * );
//STRIP001 	DECL_LINK( ToolBoxClickHdl, ToolBox * );
//STRIP001 	DECL_LINK( EditAction, NumEditAction * );
//STRIP001 	DECL_LINK( EditGetFocus, NumEditAction * );
//STRIP001 	DECL_LINK( DoneLink, SfxPoolItem * );
//STRIP001 	DECL_LINK( MenuSelectHdl, Menu * );
//STRIP001 	DECL_LINK( ChangePageHdl, Timer* );
//STRIP001 	DECL_LINK( PageEditModifyHdl, Edit* );
//STRIP001 	void UsePage(SwWrtShell *);

//STRIP001 	void MakeVisible();
//STRIP001     void InitImageList();
//STRIP001 	virtual SfxChildAlignment
//STRIP001 					CheckAlignment(SfxChildAlignment,SfxChildAlignment);

//STRIP001 protected:

//STRIP001 	virtual 		BOOL Close();
//STRIP001 	virtual 		void Resize();
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );


	// zum App-Ende rechtzeitig ObjectShellLock loslassen
//STRIP001 	virtual void	Notify( SfxBroadcaster& rBC, const SfxHint& rHint );

//STRIP001 	NumEditAction&	GetPageEdit();
//STRIP001 	BOOL			ToggleTree();
//STRIP001 	void			SetGlobalMode(BOOL bSet) {bGlobalMode = bSet;}

//STRIP001 public:
//STRIP001 	SwNavigationPI(SfxBindings*, SfxChildWindowContext*, Window*);
//STRIP001 	~SwNavigationPI();
//STRIP001 
//STRIP001 	void 			GotoPage();	// Seite anspringen; bindbare Funktion

//STRIP001 	void        	Update() { FillBox(); }
//STRIP001 	void			UpdateListBox();
//STRIP001 	void        	MoveOutline(USHORT nSource, USHORT nTarget, BOOL bWithCilds);
//STRIP001 	virtual void    StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 											const SfxPoolItem* pState );

//STRIP001 	static String 	CreateDropFileName( TransferableDataHelper& rData );
//STRIP001 	static void 	CleanEntry( String& rEntry );

//STRIP001 	USHORT			GetRegionDropMode() const {return nRegionMode;}
//STRIP001 	void			SetRegionDropMode(USHORT nNewMode);
//STRIP001 	BOOL			IsInDrag() const;

//STRIP001 	sal_Int8 		AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	sal_Int8 		ExecuteDrop( const ExecuteDropEvent& rEvt );

//STRIP001 	BOOL 			IsGlobalDoc() const;
//STRIP001 	BOOL			IsGlobalMode() const {return	bGlobalMode;}

//STRIP001     SwView*         GetCreateView() const;
//STRIP001     void            CreateNavigationTool(const Rectangle& rRect, BOOL bSetFocus);
//STRIP001 };

class SwNavigationChild : public SfxChildWindowContext
{
public:
	SwNavigationChild( Window* ,
						USHORT nId,
						SfxBindings*,
						SfxChildWinInfo*  );

	SFX_DECL_CHILDWINDOW_CONTEXT( SwNavigationChild )
};

} //namespace binfilter
#endif
