/*************************************************************************
 *
 *  $RCSfile: sw_glosbib.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:56:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #define _SVSTDARR_STRINGS
//STRIP001 
//STRIP001 #ifndef _URLOBJ_HXX
//STRIP001 #include <tools/urlobj.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _STREAM_HXX
//STRIP001 #include <tools/stream.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_HELP_HXX
//STRIP001 #include <vcl/help.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOTOOLS_TRANSLITERATIONWRAPPER_HXX
//STRIP001 #include <unotools/transliterationwrapper.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOTOOLS_TEMPFILE_HXX
//STRIP001 #include <unotools/tempfile.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include <svtools/svstdarr.hxx>
//STRIP001 #include <svtools/pathoptions.hxx>
//STRIP001 
//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOSBIB_HXX
//STRIP001 #include <glosbib.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOSHDL_HXX
//STRIP001 #include <gloshdl.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOSSARY_HXX
//STRIP001 #include <glossary.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOSDOC_HXX
//STRIP001 #include <glosdoc.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWUNOHELPER_HXX
//STRIP001 #include <swunohelper.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _GLOSBIB_HRC
//STRIP001 #include <glosbib.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _MISC_HRC
//STRIP001 #include <misc.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _HELPID_H
//STRIP001 #include <helpid.h>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 #define PATH_CASE_SENSITIVE 0x01
//STRIP001 #define PATH_READONLY 		0x02
//STRIP001 
//STRIP001 #define RENAME_TOKEN_DELIM		(sal_Unicode)1
//STRIP001 
//STRIP001 /*-----------------09.06.97 13:05-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 SwGlossaryGroupDlg::SwGlossaryGroupDlg(Window * pParent,
//STRIP001 						const SvStrings* pPathArr,
//STRIP001 						SwGlossaryHdl *pHdl) :
//STRIP001 	SvxStandardDialog(pParent, SW_RES(DLG_BIB_BASE)),
//STRIP001 
//STRIP001 	aGroupTLB(	this, SW_RES(TLB_GROUPS)),
//STRIP001 	aNameED( 	this, SW_RES(ED_NAME)),
//STRIP001 	aPathLB(	this, SW_RES(LB_PATH)),
//STRIP001     aBibFT(     this, SW_RES(FT_BIB)),
//STRIP001     aPathFT(     this, SW_RES(FT_PATH)),
//STRIP001     aSelectFT(   this, SW_RES(FT_SELECT)),
//STRIP001 	aRenamePB(	this, SW_RES(PB_RENAME)),
//STRIP001 	aNewPB(		this, SW_RES(PB_NEW)),
//STRIP001 	aDelPB(		this, SW_RES(PB_DELETE)),
//STRIP001 	aOkPB(		this, SW_RES(BT_OK)),
//STRIP001 	aCancelPB(	this, SW_RES(BT_CANCEL)),
//STRIP001 	aHelpPB(	this, SW_RES(BT_HELP)),
//STRIP001 	pRemovedArr(0),
//STRIP001 	pInsertedArr(0),
//STRIP001 	pRenamedArr(0),
//STRIP001 	pGlosHdl(pHdl)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	long nTabs[] =
//STRIP001 	{	2, // Number of Tabs
//STRIP001 		0, 160
//STRIP001 	};
//STRIP001 
//STRIP001 	aGroupTLB.SetHelpId(HID_GLOS_GROUP_TREE);
//STRIP001 	aGroupTLB.SetTabs( &nTabs[0], MAP_APPFONT );
//STRIP001 	aGroupTLB.SetWindowBits(WB_HSCROLL|WB_CLIPCHILDREN|WB_SORT);
//STRIP001 	aGroupTLB.SetSelectHdl(LINK(this, SwGlossaryGroupDlg, SelectHdl));
//STRIP001 	aGroupTLB.GetModel()->SetSortMode(SortAscending);
//STRIP001 	aNewPB.SetClickHdl(LINK(this, SwGlossaryGroupDlg, NewHdl));
//STRIP001 	aDelPB.SetClickHdl(LINK(this, SwGlossaryGroupDlg, DeleteHdl));
//STRIP001 	aNameED.SetModifyHdl(LINK(this, SwGlossaryGroupDlg, ModifyHdl));
//STRIP001 	aPathLB.SetSelectHdl(LINK(this, SwGlossaryGroupDlg, ModifyHdl));
//STRIP001 	aRenamePB.SetClickHdl(LINK(this, SwGlossaryGroupDlg, RenameHdl));
//STRIP001 	for(USHORT i = 0; i < pPathArr->Count(); i++)
//STRIP001 	{
//STRIP001 		String sPath(*(*pPathArr)[i]);
//STRIP001 		aPathLB.InsertEntry(sPath);
//STRIP001 		ULONG nCaseReadonly = 0;
//STRIP001 		utl::TempFile aTempFile(&sPath);
//STRIP001 		aTempFile.EnableKillingFile();
//STRIP001 		if(!aTempFile.IsValid())
//STRIP001 			nCaseReadonly |= PATH_READONLY;
//STRIP001 		else if( SWUnoHelper::UCB_IsCaseSensitiveFileName( aTempFile.GetURL()))
//STRIP001 			nCaseReadonly |= PATH_CASE_SENSITIVE;
//STRIP001 		aPathLB.SetEntryData(i, (void*)nCaseReadonly);
//STRIP001 	}
//STRIP001 	aPathLB.SelectEntryPos(0);
//STRIP001 	aPathLB.Enable(TRUE);
//STRIP001 
//STRIP001 	const USHORT nCount = pHdl->GetGroupCnt();
//STRIP001 	for(i = 0; i < nCount; ++i)
//STRIP001 	{
//STRIP001 		String sTitle;
//STRIP001 		String sGroup = pHdl->GetGroupName(i, &sTitle);
//STRIP001 		if(!sGroup.Len())
//STRIP001 			continue;
//STRIP001 		GlosBibUserData* pData = new GlosBibUserData;
//STRIP001 		pData->sGroupName = sGroup;
//STRIP001 		pData->sGroupTitle = sTitle;
//STRIP001 		String sTemp(sTitle);
//STRIP001 		//sGroup.GetToken(0, GLOS_DELIM)
//STRIP001 		sTemp += '\t';
//STRIP001 		pData->sPath = aPathLB.GetEntry(sGroup.GetToken(1, GLOS_DELIM).ToInt32());
//STRIP001 		sTemp += pData->sPath;
//STRIP001 		SvLBoxEntry* pEntry = aGroupTLB.InsertEntry(sTemp);
//STRIP001 		pEntry->SetUserData(pData);
//STRIP001 
//STRIP001 	}
//STRIP001 	aGroupTLB.GetModel()->Resort();
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------09.06.97 13:05-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 SwGlossaryGroupDlg::~SwGlossaryGroupDlg()
//STRIP001 {
//STRIP001 
//STRIP001 	if(pInsertedArr)
//STRIP001 	{
//STRIP001 		pInsertedArr->DeleteAndDestroy(0, pInsertedArr->Count());
//STRIP001 		delete pInsertedArr;
//STRIP001 	}
//STRIP001 	if(pRemovedArr)
//STRIP001 	{
//STRIP001 		pRemovedArr->DeleteAndDestroy(0, pRemovedArr->Count());
//STRIP001 		delete pRemovedArr;
//STRIP001 	}
//STRIP001 	if(pRenamedArr)
//STRIP001 	{
//STRIP001 		pRenamedArr->DeleteAndDestroy(0, pRenamedArr->Count());
//STRIP001 		delete pRenamedArr;
//STRIP001 	}
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------09.06.97 13:11-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 void __EXPORT SwGlossaryGroupDlg::Apply()
//STRIP001 {
//STRIP001 	if(aNewPB.IsEnabled())
//STRIP001 		NewHdl(&aNewPB);
//STRIP001 
//STRIP001 	String aActGroup = SwGlossaryDlg::GetCurrGroup();
//STRIP001 
//STRIP001 	if(pRemovedArr && pRemovedArr->Count())
//STRIP001 	{
//STRIP001 		USHORT nCount = pRemovedArr->Count();
//STRIP001 		for(USHORT i = 0; i < nCount; ++i)
//STRIP001 		{
//STRIP001 			const String* pDelEntry = (*pRemovedArr)[i];
//STRIP001 			const String sDelGroup = pDelEntry->GetToken(0, '\t');
//STRIP001 			if( sDelGroup == aActGroup )
//STRIP001 			{
//STRIP001 				//soll die aktuelle Gruppe geloescht werden, muss die akt. Gruppe
//STRIP001 				//umgesetzt werden
//STRIP001 				if(aGroupTLB.GetEntryCount())
//STRIP001 				{
//STRIP001 					SvLBoxEntry* pFirst = aGroupTLB.First();
//STRIP001 					GlosBibUserData* pUserData = (GlosBibUserData*)pFirst->GetUserData();
//STRIP001 					pGlosHdl->SetCurGroup(pUserData->sGroupName);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			String sMsg(SW_RES(STR_QUERY_DELETE_GROUP1));
//STRIP001 			String sTitle(pDelEntry->GetToken(1, '\t'));
//STRIP001 			if(sTitle.Len())
//STRIP001 				sMsg += sTitle;
//STRIP001 			else
//STRIP001 				sDelGroup.GetToken(1, GLOS_DELIM);
//STRIP001 			sMsg += SW_RESSTR(STR_QUERY_DELETE_GROUP2);
//STRIP001 			QueryBox aQuery(this->GetParent(), WB_YES_NO|WB_DEF_NO, sMsg );
//STRIP001 			if(RET_YES == aQuery.Execute())
//STRIP001 				pGlosHdl->DelGroup( sDelGroup );
//STRIP001 		}
//STRIP001 
//STRIP001 	}
//STRIP001 	//erst umbenennen, falls es schon eins gab
//STRIP001 	if(pRenamedArr && pRenamedArr->Count())
//STRIP001 	{
//STRIP001 		USHORT nCount = pRenamedArr->Count();
//STRIP001 		for(USHORT i = 0; i < nCount; ++i)
//STRIP001 		{
//STRIP001 			String * pEntry = (*pRenamedArr)[i];
//STRIP001 			xub_StrLen nStrSttPos = 0;
//STRIP001 			String sOld( pEntry->GetToken(0, RENAME_TOKEN_DELIM, nStrSttPos ) );
//STRIP001 			String sNew( pEntry->GetToken(0, RENAME_TOKEN_DELIM, nStrSttPos) );
//STRIP001 			String sTitle( pEntry->GetToken(0, RENAME_TOKEN_DELIM, nStrSttPos) );
//STRIP001 			pGlosHdl->RenameGroup(sOld, sNew, sTitle);
//STRIP001 			if(!i)
//STRIP001 				sCreatedGroup = sNew;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if(pInsertedArr && pInsertedArr->Count())
//STRIP001 	{
//STRIP001 		USHORT nCount = pInsertedArr->Count();
//STRIP001 		for(USHORT i = 0; i < nCount; ++i)
//STRIP001 		{
//STRIP001 			String sNewGroup = *(*pInsertedArr)[i];
//STRIP001 			String sNewTitle = sNewGroup.GetToken(0, GLOS_DELIM);
//STRIP001 			if( *(*pInsertedArr)[i] != aActGroup )
//STRIP001 			{
//STRIP001 				pGlosHdl->NewGroup(sNewGroup, sNewTitle);
//STRIP001 				if(!sCreatedGroup.Len())
//STRIP001 					sCreatedGroup = sNewGroup;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 /*-----------------09.06.97 13:12-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwGlossaryGroupDlg, SelectHdl, SvTabListBox*, EMPTYARG  )
//STRIP001 {
//STRIP001 	aNewPB.Enable(FALSE);
//STRIP001 	SvLBoxEntry* pEntry = aGroupTLB.FirstSelected();
//STRIP001 	if(pEntry)
//STRIP001 	{
//STRIP001 		GlosBibUserData* pUserData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 		String sEntry(pUserData->sGroupName);
//STRIP001 		String sName(aNameED.GetText());
//STRIP001 		BOOL bExists = FALSE;
//STRIP001 		ULONG nPos = aGroupTLB.GetEntryPos(sName, 0);
//STRIP001 		if( 0xffffffff > nPos)
//STRIP001 		{
//STRIP001 			SvLBoxEntry* pEntry = aGroupTLB.GetEntry(nPos);
//STRIP001 			GlosBibUserData* pFoundData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 			String sGroup = pFoundData->sGroupName;
//STRIP001 			bExists = sGroup == sEntry;
//STRIP001 		}
//STRIP001 
//STRIP001 		aRenamePB.Enable(!bExists && sName.Len());
//STRIP001 		aDelPB.Enable(IsDeleteAllowed(sEntry));
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------09.06.97 13:22-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwGlossaryGroupDlg, NewHdl, Button*, EMPTYARG )
//STRIP001 {
//STRIP001 	String sGroup(aNameED.GetText());
//STRIP001 //	sGroup.ToLower();
//STRIP001 	sGroup += GLOS_DELIM;
//STRIP001 	sGroup += String::CreateFromInt32(aPathLB.GetSelectEntryPos());
//STRIP001 	DBG_ASSERT(!pGlosHdl->FindGroupName(sGroup), "Gruppe bereits vorhanden!")
//STRIP001 	if(!pInsertedArr)
//STRIP001 		pInsertedArr = new SvStrings;
//STRIP001 	pInsertedArr->Insert(new String(sGroup), pInsertedArr->Count());
//STRIP001 	String sTemp(aNameED.GetText());
//STRIP001 //	sTemp.ToLower();
//STRIP001 	sTemp += '\t';
//STRIP001 	sTemp += aPathLB.GetSelectEntry();
//STRIP001 	SvLBoxEntry* pEntry = aGroupTLB.InsertEntry(sTemp);
//STRIP001 	GlosBibUserData* pData = new GlosBibUserData;
//STRIP001 	pData->sPath = aPathLB.GetSelectEntry();
//STRIP001 	pData->sGroupName = sGroup;
//STRIP001 	pData->sGroupTitle = aNameED.GetText();
//STRIP001 	pEntry->SetUserData(pData);
//STRIP001 	aGroupTLB.Select(pEntry);
//STRIP001 	aGroupTLB.MakeVisible(pEntry);
//STRIP001 	aGroupTLB.GetModel()->Resort();
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /*-----------------09.06.97 13:22-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwGlossaryGroupDlg, DeleteHdl, Button*, pButton  )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = aGroupTLB.FirstSelected();
//STRIP001 	if(!pEntry)
//STRIP001 	{
//STRIP001 		pButton->Enable(FALSE);
//STRIP001 		return 0;
//STRIP001 	}
//STRIP001 	GlosBibUserData* pUserData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 	String sEntry(pUserData->sGroupName);
//STRIP001 	// befindet sich der zu loeschende Name schon unter den
//STRIP001 	// den neuen - dann weg damit
//STRIP001 	BOOL bDelete = TRUE;
//STRIP001 	if(pInsertedArr && pInsertedArr->Count())
//STRIP001 	{
//STRIP001 		USHORT nCount = pInsertedArr->Count();
//STRIP001 		for(USHORT i = 0; i < nCount; ++i)
//STRIP001 		{
//STRIP001 			const String* pTemp = (*pInsertedArr)[i];
//STRIP001 			if(*pTemp == sEntry)
//STRIP001 			{
//STRIP001 				pInsertedArr->Remove(i);
//STRIP001 				bDelete = FALSE;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 		}
//STRIP001 	}
//STRIP001 	// moeglicherweise sollte es schon umbenannt werden?
//STRIP001 	if(bDelete)
//STRIP001 	{
//STRIP001 		if(pRenamedArr && pRenamedArr->Count())
//STRIP001 		{
//STRIP001 			USHORT nCount = pRenamedArr->Count();
//STRIP001 			for(USHORT i = 0; i < nCount; ++i)
//STRIP001 			{
//STRIP001 				const String* pTemp = (*pRenamedArr)[i];
//STRIP001 				String sTemp( pTemp->GetToken(0, RENAME_TOKEN_DELIM ));
//STRIP001 				if(sTemp == sEntry)
//STRIP001 				{
//STRIP001 					pRenamedArr->Remove(i);
//STRIP001 					bDelete = FALSE;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if(bDelete)
//STRIP001 	{
//STRIP001 		if(!pRemovedArr)
//STRIP001 			pRemovedArr = new SvStrings;
//STRIP001 		String sEntry(pUserData->sGroupName);
//STRIP001 		sEntry += '\t';
//STRIP001 		sEntry += pUserData->sGroupTitle;
//STRIP001 		pRemovedArr->Insert(new String(sEntry), pRemovedArr->Count());
//STRIP001 	}
//STRIP001 	delete pUserData;
//STRIP001 	aGroupTLB.GetModel()->Remove(pEntry);
//STRIP001 	if(!aGroupTLB.First())
//STRIP001 		pButton->Enable(FALSE);
//STRIP001 	//the content must be deleted - otherwise the new handler would be called in Apply()
//STRIP001 	aNameED.SetText(aEmptyStr);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /* -----------------23.11.98 12:26-------------------
//STRIP001  *
//STRIP001  * --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwGlossaryGroupDlg, RenameHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = aGroupTLB.FirstSelected();
//STRIP001 	GlosBibUserData* pUserData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 	String sEntryText(aGroupTLB.GetEntryText(pEntry));
//STRIP001 	String sEntry(pUserData->sGroupName);
//STRIP001 
//STRIP001 	String sNewName(aNameED.GetText());
//STRIP001 	String sNewTitle(sNewName);
//STRIP001 
//STRIP001 	sNewName += GLOS_DELIM;
//STRIP001 	sNewName += String::CreateFromInt32(aPathLB.GetSelectEntryPos());
//STRIP001 	DBG_ASSERT(!pGlosHdl->FindGroupName(sNewName), "Gruppe bereits vorhanden!")
//STRIP001 
//STRIP001 	// befindet sich der umzubenennende Name unter den
//STRIP001 	// den neuen - dann austauschen
//STRIP001 	BOOL bDone = FALSE;
//STRIP001 	if(pInsertedArr && pInsertedArr->Count())
//STRIP001 	{
//STRIP001 		USHORT nCount = pInsertedArr->Count();
//STRIP001 		for(USHORT i = 0; i < nCount; ++i)
//STRIP001 		{
//STRIP001 			const String* pTemp = (*pInsertedArr)[i];
//STRIP001 			if(*pTemp == sEntry)
//STRIP001 			{
//STRIP001 				pInsertedArr->Remove(i);
//STRIP001 				pInsertedArr->Insert(new String(sNewName), pInsertedArr->Count());
//STRIP001 				bDone = TRUE;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if(!bDone)
//STRIP001 	{
//STRIP001 		if(!pRenamedArr)
//STRIP001 			pRenamedArr = new SvStrings;
//STRIP001 		sEntry += RENAME_TOKEN_DELIM;
//STRIP001 		sEntry += sNewName;
//STRIP001 		sEntry += RENAME_TOKEN_DELIM;
//STRIP001 		sEntry += sNewTitle;
//STRIP001 		pRenamedArr->Insert(new String(sEntry), pRenamedArr->Count());
//STRIP001 	}
//STRIP001 	delete (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 	aGroupTLB.GetModel()->Remove(pEntry);
//STRIP001 	String sTemp(aNameED.GetText());
//STRIP001 //	sTemp.ToLower();
//STRIP001 	sTemp += '\t';
//STRIP001 	sTemp += aPathLB.GetSelectEntry();
//STRIP001 	pEntry = aGroupTLB.InsertEntry(sTemp);
//STRIP001 	GlosBibUserData* pData = new GlosBibUserData;
//STRIP001 	pData->sPath = aPathLB.GetSelectEntry();
//STRIP001 	pData->sGroupName = sNewName;
//STRIP001 	pData->sGroupTitle = sNewTitle;
//STRIP001 	pEntry->SetUserData(pData);
//STRIP001 	aGroupTLB.Select(pEntry);
//STRIP001 	aGroupTLB.MakeVisible(pEntry);
//STRIP001 	aGroupTLB.GetModel()->Resort();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /*-----------------09.06.97 13:42-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwGlossaryGroupDlg, ModifyHdl, Edit*, EMPTYARG )
//STRIP001 {
//STRIP001 	String sEntry(aNameED.GetText());
//STRIP001 //	sEntry.ToLower();
//STRIP001 	BOOL bEnableNew = TRUE;
//STRIP001 	BOOL bEnableDel = FALSE;
//STRIP001 	ULONG nCaseReadonly =
//STRIP001 			(ULONG)aPathLB.GetEntryData(aPathLB.GetSelectEntryPos());
//STRIP001 	BOOL bDirReadonly = 0 != (nCaseReadonly&PATH_READONLY);
//STRIP001 
//STRIP001 	if(!sEntry.Len() || bDirReadonly)
//STRIP001 		bEnableNew = FALSE;
//STRIP001 	else if(sEntry.Len())
//STRIP001 	{
//STRIP001 		ULONG nPos = 0xffffffff;
//STRIP001 
//STRIP001 
//STRIP001 		nPos = aGroupTLB.GetEntryPos(sEntry, 0);
//STRIP001 		//ist es nicht case sensitive muss man selbst suchen
//STRIP001 		if( 0xffffffff == nPos)
//STRIP001 		{
//STRIP001 			const ::utl::TransliterationWrapper& rSCmp = GetAppCmpStrIgnore();
//STRIP001 			for(USHORT i = 0; i < aGroupTLB.GetEntryCount(); i++)
//STRIP001 			{
//STRIP001 				String sTemp = aGroupTLB.GetEntryText( i, 0 );
//STRIP001 				ULONG nCaseReadonly = (ULONG)aPathLB.GetEntryData(
//STRIP001 					aPathLB.GetEntryPos(aGroupTLB.GetEntryText(i,1)));
//STRIP001 				BOOL bCase = 0 != (nCaseReadonly & PATH_CASE_SENSITIVE);
//STRIP001 
//STRIP001 				if( !bCase && rSCmp.isEqual( sTemp, sEntry ))
//STRIP001 				{
//STRIP001 					nPos = i;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		if( 0xffffffff > nPos)
//STRIP001 		{
//STRIP001 			bEnableNew = FALSE;
//STRIP001 			aGroupTLB.Select(aGroupTLB.GetEntry( nPos ));
//STRIP001 			aGroupTLB.MakeVisible(aGroupTLB.GetEntry( nPos ));
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SvLBoxEntry* pEntry = aGroupTLB.FirstSelected();
//STRIP001 	if(pEntry)
//STRIP001 	{
//STRIP001 		GlosBibUserData* pUserData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 		bEnableDel = IsDeleteAllowed(pUserData->sGroupName);
//STRIP001 
//STRIP001 //		String sGroup = aGroupTLB.GetEntryText(pEntry, 0);
//STRIP001 //		sGroup += GLOS_DELIM;
//STRIP001 //		sGroup += String::CreateFromInt32(aPathLB.GetEntryPos(aGroupTLB.GetEntryText(pEntry, 1)));
//STRIP001 //		bEnableDel = IsDeleteAllowed(sGroup);
//STRIP001 	}
//STRIP001 
//STRIP001 	aDelPB.Enable(bEnableDel);
//STRIP001 	aNewPB.Enable(bEnableNew);
//STRIP001 	aRenamePB.Enable(bEnableNew && pEntry);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL SwGlossaryGroupDlg::IsDeleteAllowed(const String &rGroup)
//STRIP001 {
//STRIP001 	BOOL bDel = (!pGlosHdl->IsReadOnly(&rGroup));
//STRIP001 
//STRIP001 	// OM: befindet sich der Name unter den den neuen Bereichsnamen,
//STRIP001 	// dann ist er auch loeschbar! Bei noch nicht existenten Bereichsnamen
//STRIP001 	// liefert ReadOnly naemlich TRUE.
//STRIP001 
//STRIP001 	if(pInsertedArr && pInsertedArr->Count())
//STRIP001 	{
//STRIP001 		USHORT nCount = pInsertedArr->Count();
//STRIP001 		for(USHORT i = 0; i < nCount; ++i)
//STRIP001 		{
//STRIP001 			const String* pTemp = (*pInsertedArr)[i];
//STRIP001 			if(*pTemp == rGroup)
//STRIP001 			{
//STRIP001 				bDel = TRUE;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bDel;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------18.07.97 19:06-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 void FEdit::KeyInput( const KeyEvent& rKEvent )
//STRIP001 {
//STRIP001 	KeyCode aCode = rKEvent.GetKeyCode();
//STRIP001 	if( KEYGROUP_CURSOR == aCode.GetGroup() ||
//STRIP001 		( KEYGROUP_MISC == aCode.GetGroup() &&
//STRIP001 		  KEY_DELETE >= aCode.GetCode() ) ||
//STRIP001 		SVT_SEARCHPATH_DELIMITER != rKEvent.GetCharCode() )
//STRIP001 		Edit::KeyInput( rKEvent );
//STRIP001 }
//STRIP001 /* -----------------------------08.02.00 15:07--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void 	SwGlossaryGroupTLB::RequestHelp( const HelpEvent& rHEvt )
//STRIP001 {
//STRIP001 	Point aPos( ScreenToOutputPixel( rHEvt.GetMousePosPixel() ));
//STRIP001 	SvLBoxEntry* pEntry = GetEntry( aPos );
//STRIP001 	if(pEntry)
//STRIP001 	{
//STRIP001 		SvLBoxTab* pTab;
//STRIP001 		SvLBoxItem* pItem = GetItem( pEntry, aPos.X(), &pTab );
//STRIP001 		if(pItem)
//STRIP001 		{
//STRIP001 			aPos = SvTreeListBox::GetEntryPos( pEntry );
//STRIP001 			Size aSize(pItem->GetSize( this, pEntry ));
//STRIP001 			aPos.X() = GetTabPos( pEntry, pTab );
//STRIP001 
//STRIP001 			if((aPos.X() + aSize.Width()) > GetSizePixel().Width())
//STRIP001 				aSize.Width() = GetSizePixel().Width() - aPos.X();
//STRIP001 			aPos = OutputToScreenPixel(aPos);
//STRIP001 			Rectangle aItemRect( aPos, aSize );
//STRIP001 			String sMsg;
//STRIP001 			GlosBibUserData* pData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 			sMsg = pData->sPath;
//STRIP001 			sMsg += INET_PATH_TOKEN;
//STRIP001 			sMsg += pData->sGroupName.GetToken(0, GLOS_DELIM);
//STRIP001 			sMsg += SwGlossaries::GetExtension();
//STRIP001 
//STRIP001 			Help::ShowQuickHelp( this, aItemRect, sMsg,
//STRIP001 						QUICKHELP_LEFT|QUICKHELP_VCENTER );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 /* -----------------------------08.02.00 15:08--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void	SwGlossaryGroupTLB::Clear()
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = First();
//STRIP001 	while(pEntry)
//STRIP001 	{
//STRIP001 		GlosBibUserData* pData = (GlosBibUserData*)pEntry->GetUserData();
//STRIP001 		delete pData;
//STRIP001 		pEntry = Next(pEntry);
//STRIP001 	}
//STRIP001 	SvTabListBox::Clear();
//STRIP001 }



}
