/*************************************************************************
 *
 *  $RCSfile: sw_wrtsh2.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 12:00:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>		// define ITEMIDs
// auto strip #endif

// auto strip #ifndef _SFXMACITEM_HXX //autogen
// auto strip #include <svtools/macitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXFRAME_HXX //autogen
// auto strip #include <bf_sfx2/frame.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCINF_HXX //autogen
// auto strip #include <bf_sfx2/docinf.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef SVTOOLS_URIHELPER_HXX
// auto strip #include <svtools/urihelper.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX //autogen
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTRITEM_HXX
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX //autogen
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_FCONTNR_HXX //autogen
// auto strip #include <bf_sfx2/fcontnr.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _LINKMGR_HXX //autogen
// auto strip #include <so3/linkmgr.hxx>
// auto strip #endif

// auto strip #ifndef _FMTINFMT_HXX //autogen
// auto strip #include <fmtinfmt.hxx>
// auto strip #endif
// auto strip #ifndef _FRMATR_HXX
// auto strip #include <frmatr.hxx>
// auto strip #endif
// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>  	// SET_CURR_SHELL
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
// auto strip #ifndef _DOCSH_HXX
// auto strip #include <docsh.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>       // Felder
// auto strip #endif
// auto strip #ifndef _EXPFLD_HXX
// auto strip #include <expfld.hxx>
// auto strip #endif
// auto strip #ifndef _DDEFLD_HXX
// auto strip #include <ddefld.hxx>
// auto strip #endif
// auto strip #ifndef _DOCUFLD_HXX
// auto strip #include <docufld.hxx>
// auto strip #endif
// auto strip #ifndef _REFFLD_HXX
// auto strip #include <reffld.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>
// auto strip #endif
// auto strip #ifndef _NUMRULE_HXX
// auto strip #include <numrule.hxx>   	// Numerierung
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _INPDLG_HXX
// auto strip #include <inpdlg.hxx>       // Eingabefelder
// auto strip #endif
// auto strip #ifndef _VIEWOPT_HXX
// auto strip #include <viewopt.hxx>  	// SwViewOptions
// auto strip #endif
// auto strip #ifndef _FRMFMT_HXX
// auto strip #include <frmfmt.hxx>       // fuer UpdateTable
// auto strip #endif
// auto strip #ifndef _SWTABLE_HXX
// auto strip #include <swtable.hxx>      // fuer UpdateTable
// auto strip #endif
// auto strip #ifndef _HINTS_HXX
// auto strip #include <hints.hxx>		// fuer UpdateTable
// auto strip #endif
// auto strip #ifndef _MDIEXP_HXX
// auto strip #include <mdiexp.hxx>
// auto strip #endif
// auto strip #ifndef _VIEW_HXX
// auto strip #include <view.hxx>
// auto strip #endif
// auto strip #ifndef _SWEVENT_HXX
// auto strip #include <swevent.hxx>
// auto strip #endif
// auto strip #ifndef _POOLFMT_HXX
// auto strip #include <poolfmt.hxx>
// auto strip #endif
// auto strip #ifndef _SECTION_HXX
// auto strip #include <section.hxx>
// auto strip #endif
// auto strip #ifndef _NAVICONT_HXX
// auto strip #include <navicont.hxx>
// auto strip #endif
// auto strip #ifndef _NAVIPI_HXX
// auto strip #include <navipi.hxx>
// auto strip #endif
// auto strip #ifndef _CRSSKIP_HXX
// auto strip #include <crsskip.hxx>
// auto strip #endif
// auto strip #ifndef _TXTINET_HXX
// auto strip #include <txtinet.hxx>
// auto strip #endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _WRTSH_HRC
#include <wrtsh.hrc>
#endif
// auto strip #ifndef _SW_DROPDOWNFIELDDIALOG_HXX
// auto strip #include <DropDownFieldDialog.hxx>
// auto strip #endif
#include "so3/staticbaseurl.hxx"
namespace binfilter {
/*------------------------------------------------------------------------
		Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 void SwWrtShell::Insert(SwField &rFld)
//STRIP001 {
//STRIP001 	ResetCursorStack();
//STRIP001 	if(!_CanInsert())
//STRIP001 		return;
//STRIP001 	StartAllAction();
//STRIP001 	StartUndo(UNDO_INSERT);
//STRIP001 
//STRIP001 //JP 09.06.97: Wozu die Abpruefung des FeldTypen??
//STRIP001 //			Wobei das SETREFFLD kein Feld ist und hier garnicht durchkommt!
//STRIP001 //	USHORT nType = rFld.GetTyp()->Which();
//STRIP001 //	if(HasSelection() && nType != RES_HIDDENTXTFLD && nType != RES_SETREFFLD)
//STRIP001 	if( HasSelection() )
//STRIP001 		DelRight();
//STRIP001 
//STRIP001 	SwEditShell::Insert(rFld);
//STRIP001 	EndUndo(UNDO_INSERT);
//STRIP001 	EndAllAction();
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: Felder Update anschmeissen
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwWrtShell::UpdateInputFlds( SwInputFieldList* pLst, BOOL bOnlyInSel )
//STRIP001 {
//STRIP001 	// ueber die Liste der Eingabefelder gehen und Updaten
//STRIP001 	SwInputFieldList* pTmp = pLst;
//STRIP001 	if( !pTmp )
//STRIP001 		pTmp = new SwInputFieldList( this );
//STRIP001 
//STRIP001 	if (bOnlyInSel)
//STRIP001 		pTmp->RemoveUnselectedFlds();
//STRIP001 
//STRIP001 	const USHORT nCnt = pTmp->Count();
//STRIP001 	if(nCnt)
//STRIP001 	{
//STRIP001 		pTmp->PushCrsr();
//STRIP001 
//STRIP001 		BOOL bCancel = FALSE;
//STRIP001         ByteString aDlgPos;
//STRIP001 		for( USHORT i = 0; i < nCnt && !bCancel; ++i )
//STRIP001 		{
//STRIP001 			pTmp->GotoFieldPos( i );
//STRIP001             SwField* pField = pTmp->GetField( i );
//STRIP001             if(pField->GetTyp()->Which() == RES_DROPDOWN)
//STRIP001                 bCancel = StartDropDownFldDlg( pField, TRUE, &aDlgPos );
//STRIP001             else
//STRIP001                 bCancel = StartInputFldDlg( pField, TRUE, &aDlgPos);
//STRIP001 
//STRIP001 			// Sonst Updatefehler bei Multiselektion:
//STRIP001 			pTmp->GetField( i )->GetTyp()->UpdateFlds();
//STRIP001 		}
//STRIP001 		pTmp->PopCrsr();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !pLst )
//STRIP001 		delete pTmp;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: EingabeDialog fuer ein bestimmtes Feld starten
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 BOOL SwWrtShell::StartInputFldDlg( SwField* pFld, BOOL bNextButton, ByteString* pWindowState )
//STRIP001 {
//STRIP001 //JP 14.08.96: Bug 30332 - nach Umbau der modularietaet im SFX, muss jetzt
//STRIP001 //				das TopWindow der Application benutzt werden.
//STRIP001 //	SwFldInputDlg* pDlg = new SwFldInputDlg( GetWin(), *this, pFld );
//STRIP001 
//STRIP001 	SwFldInputDlg* pDlg = new SwFldInputDlg( NULL, *this, pFld, bNextButton );
//STRIP001     if(pWindowState && pWindowState->Len())
//STRIP001         pDlg->SetWindowState(*pWindowState);
//STRIP001 	BOOL bRet = RET_CANCEL == pDlg->Execute();
//STRIP001     if(pWindowState)
//STRIP001         *pWindowState = pDlg->GetWindowState();
//STRIP001 
//STRIP001 	delete pDlg;
//STRIP001 	GetWin()->Update();
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 /* -----------------17.06.2003 10:18-----------------
//STRIP001 
//STRIP001  --------------------------------------------------*/
//STRIP001 BOOL SwWrtShell::StartDropDownFldDlg(SwField* pFld, BOOL bNextButton, ByteString* pWindowState)
//STRIP001 {
//STRIP001     sw::DropDownFieldDialog* pDlg = new sw::DropDownFieldDialog( NULL, *this, pFld, bNextButton );
//STRIP001     if(pWindowState && pWindowState->Len())
//STRIP001         pDlg->SetWindowState(*pWindowState);
//STRIP001     USHORT nRet = pDlg->Execute();
//STRIP001     if(pWindowState)
//STRIP001         *pWindowState = pDlg->GetWindowState();
//STRIP001     delete pDlg;
//STRIP001     BOOL bRet = RET_CANCEL == nRet;
//STRIP001     GetWin()->Update();
//STRIP001     if(RET_YES == nRet)
//STRIP001     {
//STRIP001         GetView().GetViewFrame()->GetDispatcher()->Execute(FN_EDIT_FIELD, SFX_CALLMODE_ASYNCHRON);
//STRIP001     }        
//STRIP001     return bRet;
//STRIP001 }            
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: Verzeichnis einfuegen Selektion loeschen
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwWrtShell::InsertTableOf(const SwTOXBase& rTOX, const SfxItemSet* pSet)
//STRIP001 {
//STRIP001 	if(!_CanInsert())
//STRIP001 		return;
//STRIP001 
//STRIP001 	if(HasSelection())
//STRIP001 		DelRight();
//STRIP001 
//STRIP001 	SwEditShell::InsertTableOf(rTOX, pSet);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: Verzeichnis Updaten Selektion loeschen
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL SwWrtShell::UpdateTableOf(const SwTOXBase& rTOX, const SfxItemSet* pSet)
//STRIP001 {
//STRIP001 	if(!_CanInsert())
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	return SwEditShell::UpdateTableOf(rTOX, pSet);
//STRIP001 }
//STRIP001 
//STRIP001 	// ein Klick aus das angegebene Feld. Der Cursor steht auf diesem.
//STRIP001 	// Fuehre die vor definierten Aktionen aus.
//STRIP001 
//STRIP001 
//STRIP001 void SwWrtShell::ClickToField( const SwField& rFld, USHORT nFilter )
//STRIP001 {
//STRIP001 	bIsInClickToEdit = TRUE;
//STRIP001 	switch( rFld.GetTyp()->Which() )
//STRIP001 	{
//STRIP001 	case RES_JUMPEDITFLD:
//STRIP001 		{
//STRIP001 			USHORT nSlotId = 0;
//STRIP001 			switch( rFld.GetFormat() )
//STRIP001 			{
//STRIP001 			case JE_FMT_TABLE:
//STRIP001 				nSlotId = FN_INSERT_TABLE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case JE_FMT_FRAME:
//STRIP001 				nSlotId = FN_INSERT_FRAME;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case JE_FMT_GRAPHIC:	nSlotId = SID_INSERT_GRAPHIC;		break;
//STRIP001 			case JE_FMT_OLE:        nSlotId = SID_INSERT_OBJECT;		break;
//STRIP001 
//STRIP001 //			case JE_FMT_TEXT:
//STRIP001 			}
//STRIP001 
//STRIP001 			Right( CRSR_SKIP_CHARS, TRUE, 1, FALSE );		// Feld selektieren
//STRIP001 
//STRIP001 			if( nSlotId )
//STRIP001 			{
//STRIP001 				StartUndo( UNDO_START );
//STRIP001 				GetView().GetViewFrame()->GetDispatcher()->Execute( nSlotId,
//STRIP001 							SFX_CALLMODE_SYNCHRON|SFX_CALLMODE_RECORD );
//STRIP001 				EndUndo( UNDO_END );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	case RES_MACROFLD:
//STRIP001 		{
//STRIP001 			const SwMacroField *pFld = (const SwMacroField*)&rFld;
//STRIP001 			String sLibName(pFld->GetLibName());
//STRIP001 			String sMacroName(pFld->GetMacroName());
//STRIP001 
//STRIP001 			if( sLibName.Len() && sMacroName.Len() )
//STRIP001 			{
//STRIP001 				String sText( rFld.GetPar2() );
//STRIP001 				String sRet( sText );
//STRIP001 				SvxMacro aMacro( sMacroName, sLibName, STARBASIC );
//STRIP001 				ExecMacro( aMacro, &sRet );
//STRIP001 
//STRIP001 				// return Wert veraendert?
//STRIP001 				if( sRet != sText )
//STRIP001 				{
//STRIP001 					StartAllAction();
//STRIP001 					((SwField&)rFld).SetPar2( sRet );
//STRIP001 					((SwField&)rFld).GetTyp()->UpdateFlds();
//STRIP001 					EndAllAction();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	case RES_GETREFFLD:
//STRIP001 		StartAllAction();
//STRIP001 		SwCrsrShell::GotoRefMark( ((SwGetRefField&)rFld).GetSetRefName(),
//STRIP001 									((SwGetRefField&)rFld).GetSubType(),
//STRIP001 									((SwGetRefField&)rFld).GetSeqNo() );
//STRIP001 		EndAllAction();
//STRIP001 		break;
//STRIP001 
//STRIP001 	case RES_INPUTFLD:
//STRIP001 		StartInputFldDlg( (SwField*)&rFld, FALSE );
//STRIP001 		break;
//STRIP001 
//STRIP001 	case RES_SETEXPFLD:
//STRIP001 		if( ((SwSetExpField&)rFld).GetInputFlag() )
//STRIP001 			StartInputFldDlg( (SwField*)&rFld, FALSE );
//STRIP001 		break;
//STRIP001     case RES_DROPDOWN :
//STRIP001         StartDropDownFldDlg( (SwField*)&rFld, FALSE );
//STRIP001     break;
//STRIP001 	}
//STRIP001 
//STRIP001 	bIsInClickToEdit = FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwWrtShell::ClickToINetAttr( const SwFmtINetFmt& rItem, USHORT nFilter )
//STRIP001 {
//STRIP001 	if( !rItem.GetValue().Len() )
//STRIP001 		return ;
//STRIP001 
//STRIP001 	bIsInClickToEdit = TRUE;
//STRIP001 
//STRIP001 	// erstmal das evt. gesetzte ObjectSelect Macro ausfuehren
//STRIP001 	const SvxMacro* pMac = rItem.GetMacro( SFX_EVENT_MOUSECLICK_OBJECT );
//STRIP001 	if( pMac )
//STRIP001 	{
//STRIP001 		SwCallMouseEvent aCallEvent;
//STRIP001 		aCallEvent.Set( &rItem );
//STRIP001 		GetDoc()->CallEvent( SFX_EVENT_MOUSECLICK_OBJECT, aCallEvent, FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	// damit die Vorlagenumsetzung sofort angezeigt wird
//STRIP001 	::LoadURL( rItem.GetValue(), this, nFilter, &rItem.GetTargetFrame() );
//STRIP001     const SwTxtINetFmt* pTxtAttr = rItem.GetTxtINetFmt();
//STRIP001     if( pTxtAttr )
//STRIP001     {
//STRIP001         ((SwTxtINetFmt*)pTxtAttr)->SetVisited( sal_True );
//STRIP001         ((SwTxtINetFmt*)pTxtAttr)->SetValidVis( sal_True );
//STRIP001     }
//STRIP001 
//STRIP001 	bIsInClickToEdit = FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 BOOL SwWrtShell::ClickToINetGrf( const Point& rDocPt, USHORT nFilter )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	String sURL;
//STRIP001 	String sTargetFrameName;
//STRIP001 	const SwFrmFmt* pFnd = IsURLGrfAtPos( rDocPt, &sURL, &sTargetFrameName );
//STRIP001 	if( pFnd && sURL.Len() )
//STRIP001 	{
//STRIP001 		bRet = TRUE;
//STRIP001 		// erstmal das evt. gesetzte ObjectSelect Macro ausfuehren
//STRIP001 		const SvxMacro* pMac = &pFnd->GetMacro().GetMacro( SFX_EVENT_MOUSECLICK_OBJECT );
//STRIP001 		if( pMac )
//STRIP001 		{
//STRIP001 			SwCallMouseEvent aCallEvent;
//STRIP001 			aCallEvent.Set( EVENT_OBJECT_URLITEM, pFnd );
//STRIP001 			GetDoc()->CallEvent( SFX_EVENT_MOUSECLICK_OBJECT, aCallEvent, FALSE );
//STRIP001 		}
//STRIP001 
//STRIP001 		::LoadURL( sURL, this, nFilter, &sTargetFrameName);
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 void LoadURL( const String& rURL, ViewShell* pVSh, USHORT nFilter,
//STRIP001 			  const String *pTargetFrameName )
//STRIP001 {
//STRIP001 	ASSERT( rURL.Len() && pVSh, "was soll hier geladen werden?" );
//STRIP001 	if( !rURL.Len() || !pVSh )
//STRIP001 		return ;
//STRIP001 
//STRIP001 	// die Shell kann auch 0 sein !!!!!
//STRIP001 	SwWrtShell *pSh = 0;
//STRIP001 	if ( pVSh && pVSh->ISA(SwCrsrShell) )
//STRIP001 	{
//STRIP001 		//Eine CrsrShell ist auch immer eine WrtShell
//STRIP001 		pSh = (SwWrtShell*)pVSh;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return;
//STRIP001 
//STRIP001 	String sTargetFrame;
//STRIP001 	if( pTargetFrameName && pTargetFrameName->Len() )
//STRIP001 		sTargetFrame = *pTargetFrameName;
//STRIP001 	else if( pSh )
//STRIP001 		sTargetFrame = pSh->GetDoc()->GetInfo()->GetDefaultTarget();
//STRIP001 
//STRIP001 	String sReferer;
//STRIP001 	SwDocShell* pDShell = pSh->GetView().GetDocShell();
//STRIP001 	if( pDShell && pDShell->GetMedium() )
//STRIP001 		sReferer = pDShell->GetMedium()->GetName();
//STRIP001 	SfxViewFrame* pViewFrm = pSh->GetView().GetViewFrame();
//STRIP001 	SfxFrameItem aView( SID_DOCFRAME, pViewFrm );
//STRIP001 	SfxStringItem aName( SID_FILE_NAME, rURL );
//STRIP001 	SfxStringItem aTargetFrameName( SID_TARGETNAME, sTargetFrame );
//STRIP001 	SfxStringItem aReferer( SID_REFERER, sReferer );
//STRIP001 
//STRIP001 	SfxBoolItem aNewView( SID_OPEN_NEW_VIEW, FALSE );
//STRIP001 	//#39076# Silent kann lt. SFX entfernt werden.
//STRIP001 //	SfxBoolItem aSilent( SID_SILENT, TRUE );
//STRIP001 	SfxBoolItem aBrowse( SID_BROWSE, TRUE );
//STRIP001 
//STRIP001 	if( nFilter & URLLOAD_NEWVIEW )
//STRIP001 		aTargetFrameName.SetValue( String::CreateFromAscii("_blank") );
//STRIP001 
//STRIP001 	const SfxPoolItem* aArr[] = {
//STRIP001 				&aName,
//STRIP001                 &aNewView, /*&aSilent,*/
//STRIP001 				&aReferer,
//STRIP001 				&aView, &aTargetFrameName,
//STRIP001 				&aBrowse,
//STRIP001 				0L
//STRIP001 	};
//STRIP001 
//STRIP001 	pViewFrm->GetDispatcher()->GetBindings()->Execute( SID_OPENDOC, aArr,
//STRIP001 			SFX_CALLMODE_ASYNCHRON|SFX_CALLMODE_RECORD );
//STRIP001 }
//STRIP001 
//STRIP001 void SwWrtShell::NavigatorPaste( const NaviContentBookmark& rBkmk,
//STRIP001 									const USHORT nAction )
//STRIP001 {
//STRIP001 	if( EXCHG_IN_ACTION_COPY == nAction )
//STRIP001 	{
//STRIP001 		// Einfuegen
//STRIP001 		String sURL = rBkmk.GetURL();
//STRIP001 		//handelt es sich um ein Sprung innerhalb des akt. Docs?
//STRIP001 		const SwDocShell* pDocShell = GetView().GetDocShell();
//STRIP001 		if(pDocShell->HasName())
//STRIP001 		{
//STRIP001 			USHORT nPos = 0;
//STRIP001 			const String rName = so3::StaticBaseUrl::SmartRelToAbs(
//STRIP001 									pDocShell->GetMedium()->GetURLObject().GetURLNoMark());
//STRIP001 
//STRIP001 			if(COMPARE_EQUAL == sURL.CompareTo(rName, rName.Len()))
//STRIP001 				sURL.Erase(0, rName.Len());
//STRIP001 		}
//STRIP001 		SwFmtINetFmt aFmt( sURL, aEmptyStr );
//STRIP001 		InsertURL( aFmt, rBkmk.GetDescription() );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SwSection aSection(	FILE_LINK_SECTION, GetUniqueSectionName( 0 ) );
//STRIP001 		String aLinkFile( rBkmk.GetURL().GetToken(0, '#') );
//STRIP001         aLinkFile += ::so3::cTokenSeperator;
//STRIP001         aLinkFile += ::so3::cTokenSeperator;
//STRIP001 		aLinkFile += rBkmk.GetURL().GetToken(1, '#');
//STRIP001 		aSection.SetLinkFileName( aLinkFile );
//STRIP001 		aSection.SetProtect( TRUE );
//STRIP001 		const SwSection* pIns = InsertSection( aSection );
//STRIP001 		if( EXCHG_IN_ACTION_MOVE == nAction && pIns )
//STRIP001 		{
//STRIP001 			aSection = *pIns;
//STRIP001 			aSection.SetLinkFileName( aEmptyStr );
//STRIP001 			aSection.SetType( CONTENT_SECTION );
//STRIP001 			aSection.SetProtect( FALSE );
//STRIP001 
//STRIP001 			// the update of content from linked section at time delete
//STRIP001 			// the undostack. Then the change of the section dont create
//STRIP001 			// any undoobject. -  BUG 69145
//STRIP001 			BOOL bDoesUndo = DoesUndo();
//STRIP001 			if( UNDO_INSSECTION != GetUndoIds() )
//STRIP001 				DoUndo( FALSE );
//STRIP001 			ChgSection( GetSectionFmtPos( *pIns->GetFmt() ), aSection );
//STRIP001 			DoUndo( bDoesUndo );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
