/*************************************************************************
 *
 *  $RCSfile: macropg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:26:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _MACROPG_HXX
#define _MACROPG_HXX

#include <bf_sfx2/basedlgs.hxx>
#include <bf_sfx2/tabdlg.hxx>

#ifndef _SFXMACITEM_HXX //autogen
#include <svtools/macitem.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
class SvStringsDtor;
class Edit;
class String;
namespace binfilter {
class _SfxMacroTabPage;

class SvTabListBox;
//class SvHeaderTabListBox;
//class FixedText;
//class MultiLineEdit;

typedef SvStringsDtor* (*FNGetRangeHdl)( _SfxMacroTabPage*, const String& rLanguage );
typedef SvStringsDtor* (*FNGetMacrosOfRangeHdl)( _SfxMacroTabPage*, const String& rLanguage, const String& rRange );

class SfxConfigGroupListBox_Impl;
class SfxConfigFunctionListBox_Impl;

class _HeaderTabListBox;
class _SfxMacroTabPage_Impl;

//STRIP001 class _SfxMacroTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 	SvxMacroTableDtor			aTbl;
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, SelectEvent_Impl, SvTabListBox * );
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, SelectGroup_Impl, ListBox * );
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, SelectMacro_Impl, ListBox * );
//STRIP001 
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, DoubleClickHdl_Impl, Control* );
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, AssignDeleteHdl_Impl, PushButton * );
//STRIP001 
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, ChangeScriptHdl_Impl, RadioButton * );
//STRIP001 	DECL_STATIC_LINK( _SfxMacroTabPage, GetFocus_Impl, Edit* );
//STRIP001 #endif
//STRIP001 protected:
//STRIP001 	_SfxMacroTabPage_Impl*		mpImpl;
//STRIP001 
//STRIP001 								_SfxMacroTabPage( Window* pParent, const ResId& rId, const SfxItemSet& rItemSet );
//STRIP001 
//STRIP001 	void						InitAndSetHandler();
//STRIP001 	void						FillEvents();
//STRIP001 	void						FillMacroList();
//STRIP001 	void						EnableButtons( const String& rLanguage );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	virtual						~_SfxMacroTabPage();
//STRIP001 
//STRIP001 	void						AddEvent( const String & rEventName, USHORT nEventId );
//STRIP001 
//STRIP001 	const SvxMacroTableDtor&	GetMacroTbl() const;
//STRIP001 	void						SetMacroTbl( const SvxMacroTableDtor& rTbl );
//STRIP001 	void						ClearMacroTbl();
//STRIP001 
//STRIP001 	virtual void				ScriptChanged( const String& rLanguage );
//STRIP001 
//STRIP001 	// zum setzen / abfragen der Links
//STRIP001 	void						SetGetRangeLink( FNGetRangeHdl pFn );
//STRIP001 	FNGetRangeHdl				GetGetRangeLink() const;
//STRIP001 	void						SetGetMacrosOfRangeLink( FNGetMacrosOfRangeHdl pFn );
//STRIP001 	FNGetMacrosOfRangeHdl		GetGetMacrosOfRangeLink() const;
//STRIP001 
//STRIP001 	// --------- Erben aus der Basis -------------
//STRIP001 	virtual	BOOL				FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void				Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void						SetReadOnly( BOOL bSet );
//STRIP001 	BOOL						IsReadOnly() const;
//STRIP001 	void						SelectEvent( const String& rEventName, USHORT nEventId );
//STRIP001 };

//STRIP001 inline const SvxMacroTableDtor& _SfxMacroTabPage::GetMacroTbl() const
//STRIP001 {
//STRIP001 	return aTbl;
//STRIP001 }

//STRIP001 inline void _SfxMacroTabPage::SetMacroTbl( const SvxMacroTableDtor& rTbl )
//STRIP001 {
//STRIP001 	aTbl = rTbl;
//STRIP001 }

//STRIP001 inline void _SfxMacroTabPage::ClearMacroTbl()
//STRIP001 {
//STRIP001 	aTbl.DelDtor();
//STRIP001 }

//STRIP001 class SfxMacroTabPage : public _SfxMacroTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	SfxMacroTabPage( Window* pParent, const ResId& rId,
//STRIP001 					const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	// --------- Erben aus der Basis -------------
//STRIP001 	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 };

//STRIP001 class SfxMacroAssignDlg : public SfxSingleTabDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 	SfxMacroAssignDlg( Window* pParent, SfxItemSet& rSet );
//STRIP001 	virtual	~SfxMacroAssignDlg();
//STRIP001 };

}//end of namespace binfilter
#endif
