/*************************************************************************
 *
 *  $RCSfile: sfxhtml.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:03:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXHTML_HXX
#define _SFXHTML_HXX

// auto strip #ifndef _PARHTML_HXX
// auto strip #include <svtools/parhtml.hxx>
// auto strip #endif
// auto strip #ifndef _SFXMACITEM_HXX //autogen
// auto strip #include <svtools/macitem.hxx>
// auto strip #endif
class ImageMap;
class SvKeyValueIterator;
namespace binfilter {

class SfxDocumentInfo;
class SfxMedium;
class SfxObjectShell;

//STRIP001 class SfxHTMLParser : public HTMLParser
//STRIP001 {
//STRIP001 	DECL_STATIC_LINK( SfxHTMLParser, FileDownloadDone, void* );
//STRIP001 
//STRIP001 	String					aScriptType;
//STRIP001 
//STRIP001 	SfxMedium*				pMedium;
//STRIP001 	SfxMedium *pDLMedium;	// Medium fuer Download von Files
//STRIP001 
//STRIP001 	USHORT nMetaTags;		// Anzahl der bisher gelesenen Meta-Tags
//STRIP001 	ScriptType eScriptType;
//STRIP001 
//STRIP001 	void GetScriptType_Impl( SvKeyValueIterator* );
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	SfxHTMLParser( SvStream& rStream, BOOL bNewDoc=TRUE, SfxMedium *pMedium=0 );
//STRIP001 
//STRIP001 	~SfxHTMLParser();
//STRIP001 
//STRIP001 public:
//STRIP001 	// Lesen der Optionen einer Image-Map
//STRIP001 	// <MAP>: TRUE = Image-Map hat einen Namen
//STRIP001 	// <AREA>: TRUE = Image-Map hat jetzt einen Bereich mehr
//STRIP001 	static BOOL ParseMapOptions(ImageMap * pImageMap,
//STRIP001 								const HTMLOptions * pOptions );
//STRIP001 	BOOL ParseMapOptions(ImageMap * pImageMap)
//STRIP001 	{ return ParseMapOptions(pImageMap, GetOptions()); }
//STRIP001 	static BOOL ParseAreaOptions(ImageMap * pImageMap,
//STRIP001 								 const HTMLOptions * pOptions,
//STRIP001 								 USHORT nEventMouseOver = 0,
//STRIP001 								 USHORT nEventMouseOut = 0 );
//STRIP001 	inline BOOL ParseAreaOptions(ImageMap * pImageMap,
//STRIP001 								 USHORT nEventMouseOver = 0,
//STRIP001 								 USHORT nEventMouseOut = 0);
//STRIP001 
//STRIP001 	// Parsen von Meta-Options in eine SfxDocumentInfo.
//STRIP001 	static BOOL ParseMetaOptions( SfxDocumentInfo*, SvKeyValueIterator*,
//STRIP001 								  const HTMLOptions*, USHORT& rMetaCnt,
//STRIP001 								  rtl_TextEncoding& rEnc );
//STRIP001 
//STRIP001 	// <TD SDVAL="..." SDNUM="...">
//STRIP001 	static double GetTableDataOptionsValNum( ULONG& nNumForm,
//STRIP001 			LanguageType& eNumLang, const String& aValStr,
//STRIP001 			const String& aNumStr, SvNumberFormatter& rFormatter );
//STRIP001 
//STRIP001     static rtl_TextEncoding GetEncodingByHttpHeader( SvKeyValueIterator *pHTTPHeader );
//STRIP001 protected:
//STRIP001 
//STRIP001 	BOOL ParseMetaOptions( SfxDocumentInfo*, SvKeyValueIterator* );
//STRIP001 
//STRIP001 	// Start eines File-Downloads. Dieser erfolgt synchron oder asynchron.
//STRIP001 	// Im synchronen Fall befindet sich der Parser nach dem Aufruf im
//STRIP001 	// Working-Zustand. Die gelesene Datei kann dann direkt mit
//STRIP001 	// FinishFileDownload abgeholt werden.
//STRIP001 	// Im asynchronen Fall befindet sich der Parser nach dem Aufruf im
//STRIP001 	// Pending-Zustand. Der Parser muss dann ueber das Continue verlassen
//STRIP001 	// werden (ohne Reschedule!). Wenn die Datei geladen ist, wird
//STRIP001 	// ein Continue mit dem uebergebenen Token aufgerufen. Die Datei kann
//STRIP001 	// dann wiederum mit FinishFileDownload abgeholt werden.
//STRIP001 	// Zum Abbrechen des Dwonloads sollte eine Shell uebergeben werden.
//STRIP001 	// Es kann nur ein einziger Download gleichzeitig existieren. Fuer jeden
//STRIP001 	// gestarteten Download muss FinshFileDownload aufgerufen werden.
//STRIP001 	void StartFileDownload( const String& rURL, int nToken,
//STRIP001 							SfxObjectShell *pSh=0 );
//STRIP001 
//STRIP001 	// Ermittelnd des MIME-Types eines zuvor downloadeten Files. Kann nur
//STRIP001 	// unmittelbar vor FinishFileDownload aufgerufen werden, nie aber
//STRIP001 	// danach.
//STRIP001 
//STRIP001 	BOOL GetFileDownloadMIME( String& rMime );
//STRIP001 
//STRIP001 	// Beenden eines asynchronen File-Downloads. Gibt TRUE zurueck, wenn
//STRIP001 	// der Download geklappt hat. Das gelesene File befindet sich dann in
//STRIP001 	// dem uebergeben String.
//STRIP001 	BOOL FinishFileDownload( String& rStr );
//STRIP001 
//STRIP001 	// Gibt TRUE zurueck, wenn ein File downloaded wurde und
//STRIP001 	// FileDownloadFinished noch nicht gerufen wurde.
//STRIP001 	BOOL ShouldFinishFileDownload() const { return pDLMedium != 0; }
//STRIP001 
//STRIP001 	SfxMedium *GetMedium() { return pMedium; }
//STRIP001 	const SfxMedium *GetMedium() const { return pMedium; }
//STRIP001 
//STRIP001 	// Default (auch ohne Iterator) ist JavaScript
//STRIP001 	ScriptType GetScriptType( SvKeyValueIterator* ) const;
//STRIP001 	const String& GetScriptTypeString( SvKeyValueIterator* ) const;
//STRIP001 
//STRIP001 	static rtl_TextEncoding GetEncodingByMIME( const String& rMime );
//STRIP001 
//STRIP001 	BOOL SetEncodingByHTTPHeader( SvKeyValueIterator *pHTTPHeader );
//STRIP001 
//STRIP001 };

//STRIP001 inline BOOL SfxHTMLParser::ParseAreaOptions(ImageMap * pImageMap,
//STRIP001 											USHORT nEventMouseOver,
//STRIP001 											USHORT nEventMouseOut)
//STRIP001 {
//STRIP001 	return ParseAreaOptions( pImageMap, GetOptions(),
//STRIP001 							 nEventMouseOver, nEventMouseOut );
//STRIP001 }

}//end of namespace binfilter
#endif
