/*************************************************************************
 *
 *  $RCSfile: labdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:17:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_LABDLG_HXX
#define _SVX_LABDLG_HXX

// include ---------------------------------------------------------------

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
// auto strip #ifndef _SFXTABDLG_HXX //autogen
// auto strip #include <bf_sfx2/tabdlg.hxx>
// auto strip #endif
namespace binfilter {
//STRIP001 class SdrView;

// class SvxCaptionTabPage -----------------------------------------------

//STRIP001 const sal_uInt16 CAPTYPE_BITMAPS_COUNT = 3;

//STRIP001 class SvxCaptionTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	ValueSet		aCT_CAPTTYPE;
//STRIP001 	FixedText		aFT_ABSTAND;
//STRIP001 	MetricField		aMF_ABSTAND;
//STRIP001 	FixedText		aFT_WINKEL;
//STRIP001 	ListBox			aLB_WINKEL;
//STRIP001 	FixedText		aFT_ANSATZ;
//STRIP001 	ListBox			aLB_ANSATZ;
//STRIP001 	FixedText		aFT_UM;
//STRIP001 	MetricField		aMF_ANSATZ;
//STRIP001 	FixedText		aFT_ANSATZ_REL;
//STRIP001 	ListBox			aLB_ANSATZ_REL;
//STRIP001 	FixedText		aFT_LAENGE;
//STRIP001 	MetricField		aMF_LAENGE;
//STRIP001 	CheckBox		aCB_LAENGE;
//STRIP001 
//STRIP001 	Image*			mpBmpCapTypes[CAPTYPE_BITMAPS_COUNT];
//STRIP001 	Image*			mpBmpCapTypesH[CAPTYPE_BITMAPS_COUNT];
//STRIP001 
//STRIP001 	String			aStrHorzList;
//STRIP001 	String			aStrVertList;
//STRIP001 
//STRIP001 	short			nCaptionType;
//STRIP001 	BOOL			bFixedAngle;
//STRIP001 	INT32			nFixedAngle;
//STRIP001 	INT32			nGap;
//STRIP001 	short			nEscDir;
//STRIP001 	BOOL			bEscRel;
//STRIP001 	INT32			nEscAbs;
//STRIP001 	INT32			nEscRel;
//STRIP001 	INT32			nLineLen;
//STRIP001 	BOOL			bFitLineLen;
//STRIP001 
//STRIP001 	USHORT			nAnsatzRelPos;
//STRIP001 	USHORT			nAnsatzTypePos;
//STRIP001 	USHORT			nWinkelTypePos;
//STRIP001 
//STRIP001 #ifdef _SVX_LABDLG_CXX
//STRIP001 	void			SetupAnsatz_Impl( USHORT nType );
//STRIP001 	void			SetupType_Impl( USHORT nType );
//STRIP001 	DECL_LINK( AnsatzSelectHdl_Impl, ListBox * );
//STRIP001 	DECL_LINK( AnsatzRelSelectHdl_Impl, ListBox * );
//STRIP001 	DECL_LINK( LineOptHdl_Impl, Button * );
//STRIP001 	DECL_LINK( SelectCaptTypeHdl_Impl, void * );
//STRIP001 #endif
//STRIP001 
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 	const SdrView*		pView;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxCaptionTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 	virtual ~SvxCaptionTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window*, const SfxItemSet& );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL 		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void 		Reset( const SfxItemSet & );
//STRIP001 	void				Construct();
//STRIP001 	void				SetView( const SdrView* pSdrView )
//STRIP001 							{ pView = pSdrView; }
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 	void FillValueSet();
//STRIP001 };

// class SvxCaptionTabDialog ---------------------------------------------

//STRIP001 class SvxCaptionTabDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 //	const SfxItemSet&	rOutAttrs;
//STRIP001 	const SdrView*		pView;
//STRIP001 	USHORT				nAnchorCtrls;
//STRIP001 
//STRIP001 	virtual void		PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 			SvxCaptionTabDialog(Window* pParent, const SdrView* pView,
//STRIP001 									USHORT nAnchorTypes = 0 );
//STRIP001 
//STRIP001 			~SvxCaptionTabDialog();
//STRIP001 };

}//end of namespace binfilter
#endif //_SVX_LABDLG_HXX

