/*************************************************************************
 *
 *  $RCSfile: paraprev.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:24:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_PARAPREV_HXX
#define _SVX_PARAPREV_HXX

// include ---------------------------------------------------------------

#ifndef _WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif

// auto strip #ifndef _SVX_SVXENUM_HXX //autogen
// auto strip #include <bf_svx/svxenum.hxx>
// auto strip #endif
namespace binfilter {

// enum ------------------------------------------------------------------

//STRIP001 enum SvxPrevLineSpace
//STRIP001 {
//STRIP001 	SVX_PREV_LINESPACE_1 = 0,
//STRIP001 	SVX_PREV_LINESPACE_15,
//STRIP001 	SVX_PREV_LINESPACE_2,
//STRIP001 	SVX_PREV_LINESPACE_PROP,
//STRIP001 	SVX_PREV_LINESPACE_MIN,
//STRIP001 	SVX_PREV_LINESPACE_DURCH
//STRIP001 };

// class SvxParaPrevWindow -----------------------------------------------

//STRIP001 class SvxParaPrevWindow : public Window
//STRIP001 {
//STRIP001 private:
//STRIP001 	Size				aWinSize;
//STRIP001 	Size				aSize;
//STRIP001 
//STRIP001 	// Einzuege
//STRIP001 	long				nLeftMargin;
//STRIP001 	long				nRightMargin;
//STRIP001 	short	   			nFirstLineOfst;
//STRIP001 	// Abstaende
//STRIP001 	USHORT				nUpper;
//STRIP001 	USHORT				nLower;
//STRIP001 	// Ausrichtung
//STRIP001 	SvxAdjust			eAdjust;
//STRIP001 #if  SUPD>352
//STRIP001 	// Letzte Zeile im Blocksatz
//STRIP001 	SvxAdjust			eLastLine;
//STRIP001 #endif
//STRIP001 	// Zeilenabstand
//STRIP001 	SvxPrevLineSpace	eLine;
//STRIP001 	USHORT				nLineVal;
//STRIP001 
//STRIP001 	String				aText;
//STRIP001 	Rectangle			Lines[9];
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 	void DrawParagraph( BOOL bAll );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxParaPrevWindow( Window* pParent, const ResId& rId );
//STRIP001 
//STRIP001 	void		SetFirstLineOfst( short nNew ) { nFirstLineOfst = nNew; }
//STRIP001 	void		SetLeftMargin( long nNew ) 	{ nLeftMargin = nNew; }
//STRIP001 	void		SetRightMargin( long nNew )	{ nRightMargin = nNew; }
//STRIP001 	void		SetUpper( USHORT nNew )			{ nUpper = nNew; }
//STRIP001 	void		SetLower( USHORT nNew )			{ nLower = nNew; }
//STRIP001 	void		SetAdjust( SvxAdjust eNew )		{ eAdjust = eNew; }
//STRIP001 #if  SUPD>352
//STRIP001 	void		SetLastLine( SvxAdjust eNew )	{ eLastLine = eNew; }
//STRIP001 #endif
//STRIP001 	void		SetLineSpace( SvxPrevLineSpace eNew, USHORT nNew = 0 )
//STRIP001 					{   eLine = eNew; nLineVal = nNew; }
//STRIP001 	void        SetText( const String& rStr )	{ aText = rStr; }
//STRIP001 	void		SetSize( Size aNew )			{ aSize = aNew; }
//STRIP001 
//STRIP001 	short		GetFirstLineOfst() const 		{ return nFirstLineOfst; }
//STRIP001 	long		GetLeftMargin() const			{ return nLeftMargin; }
//STRIP001 	long		GetRightMargin() const			{ return nRightMargin; }
//STRIP001 	USHORT		GetUpper() const				{ return nUpper; }
//STRIP001 	USHORT		GetLower() const				{ return nLower; }
//STRIP001 	SvxAdjust	GetAdjust() const				{ return eAdjust; }
//STRIP001 
//STRIP001 	SvxPrevLineSpace	GetLineEnum() const 	{ return eLine; }
//STRIP001 	USHORT				GetLineValue() const	{ return nLineVal; }
//STRIP001 	String				GetText() const			{ return aText; }
//STRIP001 	Size				GetSize() const			{ return aSize; }
//STRIP001 
//STRIP001 	void		OutputSizeChanged();
//STRIP001 
//STRIP001 	void 		Draw( BOOL bAll ) 				{ DrawParagraph( bAll ); }
//STRIP001 };

}//end of namespace binfilter
#endif

