/*************************************************************************
 *
 *  $RCSfile: splwrap.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:27:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_SPLWRAP_HXX
#define _SVX_SPLWRAP_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _SVX_SVXENUM_HXX //autogen
// auto strip #include <bf_svx/svxenum.hxx>
// auto strip #endif

// auto strip #ifndef _STRING_HXX //autogen
// auto strip #include <tools/string.hxx>
// auto strip #endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
//STRIP001 class Window;
namespace binfilter {

// forward ---------------------------------------------------------------

//STRIP008 namespace com { namespace sun { namespace star { namespace linguistic2 {
//STRIP001 	class XDictionary1;
//STRIP001 	class XSpellChecker1;
//STRIP001 	class XHyphenator;
//STRIP008 }}}}


// misc functions ---------------------------------------------------------------

void SvxPrepareAutoCorrect( String &rOldText, String &rNewText );

/*--------------------------------------------------------------------
	 Beschreibung: Der SpellWrapper
 --------------------------------------------------------------------*/

//STRIP001 class SvxSpellWrapper {
//STRIP001 private:
//STRIP001 	friend class SvxSpellCheckDialog;
//STRIP001 	friend class SvxHyphenWordDialog;
//STRIP001 
//STRIP001 	Window*		pWin;
//STRIP001 	::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::uno::XInterface > 			xLast;	// result of last spelling/hyphenation attempt
//STRIP001 	::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::linguistic2::XSpellChecker1 > xSpell;
//STRIP001 	::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::linguistic2::XHyphenator > 	xHyph;
//STRIP001 	sal_uInt16 	nOldLang; 		// Sprache merken, nur bei Aenderung SetLanguage rufen
//STRIP001 	sal_Bool 	bOtherCntnt : 1; // gesetzt => Sonderbereiche zunaechst pruefen
//STRIP001 	sal_Bool 	bDialog		: 1; // Ist pWin der Svx...Dialog?
//STRIP001 	sal_Bool 	bHyphen		: 1; // Trennen statt Spellen
//STRIP001 	sal_Bool	bAuto		: 1; // Autokorrektur vorhanden?
//STRIP001 	sal_Bool	bReverse	: 1; // Rueckwaerts Spellen
//STRIP001 	sal_Bool	bStartDone	: 1; // Vorderen Teil bereits korrigiert
//STRIP001 	sal_Bool	bEndDone	: 1; // Hinteren Teil bereits korrigiert
//STRIP001 	sal_Bool	bStartChk	: 1; // Vorderen Teil pruefen
//STRIP001 	sal_Bool	bRevAllowed : 1; // Niemals rueckwaerts spellen
//STRIP001 	sal_Bool	bAllRight	: 1; // falsche Woerter in geignetes Woerterbuch
//STRIP001 							 // aufnehmen und nicht den Dialog starten.
//STRIP001 
//STRIP001 	sal_Bool 	SpellNext();   		// naechsten Bereich anwaehlen
//STRIP001 	sal_Bool	FindSpellError(); 	// Suche nach Fehlern ( ueber Bereiche hinweg )
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxSpellWrapper( Window* pWn, 
//STRIP001 					 ::com::sun::star::uno::Reference< 
//STRIP001 					 	::com::sun::star::linguistic2::XSpellChecker1 >  &xSpellChecker,
//STRIP001 					 const sal_Bool bStart = sal_False, const sal_Bool bIsAllRight = sal_False,
//STRIP001 					 const sal_Bool bOther = sal_False, const sal_Bool bRevAllow = sal_True );
//STRIP001 	SvxSpellWrapper( Window* pWn, 
//STRIP001 					 ::com::sun::star::uno::Reference< 
//STRIP001 					 	::com::sun::star::linguistic2::XHyphenator >  &xHyphenator,
//STRIP001 					 const sal_Bool bStart = sal_False, const sal_Bool bOther = sal_False );
//STRIP001 
//STRIP001 	static sal_Int16	CheckSpellLang( 
//STRIP001 							::com::sun::star::uno::Reference< 
//STRIP001 								::com::sun::star::linguistic2::XSpellChecker1 >  xSpell, 
//STRIP001 							sal_Int16 nLang );
//STRIP001 	static sal_Int16	CheckHyphLang(
//STRIP001 							::com::sun::star::uno::Reference< 
//STRIP001 								::com::sun::star::linguistic2::XHyphenator >  xHyph, 
//STRIP001 							sal_Int16 nLang );
//STRIP001 
//STRIP001 	void 			SpellDocument();		// Rechtschreibpruefung durchfuehren
//STRIP001 	inline sal_Bool IsStartDone(){ return bStartDone; }
//STRIP001 	inline sal_Bool IsEndDone(){ return bEndDone; }
//STRIP001 	inline sal_Bool IsReverse(){ return bReverse; }
//STRIP001 	inline sal_Bool IsDialog(){ return bDialog; } // SvxSpellCheckDialog OnScreen
//STRIP001 	inline sal_Bool IsHyphen(){ return bHyphen; } // Trennen statt Spellen
//STRIP001 	inline void 	SetHyphen( const sal_Bool bNew = sal_True ){ bHyphen = bNew; }
//STRIP001 	inline ::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::linguistic2::XSpellChecker1 >  
//STRIP001 					GetXSpellChecker() { return xSpell; }
//STRIP001 	inline ::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::linguistic2::XHyphenator >  	
//STRIP001 					GetXHyphenator() 	{ return xHyph; }
//STRIP001 	inline sal_Bool				IsAllRight()		{ return bAllRight; }
//STRIP001 	inline Window* 	GetWin() { return pWin; }
//STRIP001 	// kann evtl entfallen in ONE_LINGU:
//STRIP001 	inline void 	SetOldLang( const sal_uInt16 nNew ){ nOldLang = nNew; }
//STRIP001 	// kann evtl entfallen in ONE_LINGU:
//STRIP001 	inline void 	ChangeLanguage( const sal_uInt16 nNew ) // rufe ggf. SetLanguage
//STRIP001 		{ if ( nNew != nOldLang ) { SetLanguage( nNew ); nOldLang = nNew; } }
//STRIP001 	inline void 	EnableAutoCorrect() { bAuto = sal_True; }
//STRIP001 
//STRIP001 protected:
//STRIP001 	::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::uno::XInterface > 	
//STRIP001 					 GetLast()		{ return xLast; }
//STRIP001 	void			 SetLast(const ::com::sun::star::uno::Reference< 
//STRIP001 								::com::sun::star::uno::XInterface >  &xNewLast)	
//STRIP001 							{ xLast = xNewLast; }
//STRIP001 	virtual	sal_Bool SpellMore(); 				// weitere Dokumente pruefen?
//STRIP001 	virtual	sal_Bool HasOtherCnt(); 			// gibt es ueberhaupt Sonderbereiche
//STRIP001 	virtual	void 	 SpellStart( SvxSpellArea eSpell ); // Bereich vorbereiten
//STRIP001 	virtual	sal_Bool SpellContinue();			// Bereich pruefen
//STRIP001 											// Ergebnis mit GetLast verfuegbar
//STRIP001 	virtual void ReplaceAll( const String &rNewText, sal_Int16 nLanguage );	// Wort aus Replace-Liste ersetzen
//STRIP001 	virtual void StartThesaurus( const String &rWord, sal_uInt16 nLang );	// Thesaurus starten
//STRIP001 	virtual ::com::sun::star::uno::Reference< 
//STRIP001 		::com::sun::star::linguistic2::XDictionary1 > 	
//STRIP001 				 GetAllRightDic() const;
//STRIP001 	virtual	void SpellEnd();                        // Bereich abschliessen
//STRIP001 	virtual void ScrollArea();                      // ScrollArea einstellen
//STRIP001 	// Wort ersetzen
//STRIP001 	virtual void ChangeWord( const String& rNewWord, const sal_uInt16 nLang );
//STRIP001 	virtual String GetThesWord();
//STRIP001 	// Wort via Thesaurus ersetzen
//STRIP001 	virtual void ChangeThesWord( const String& rNewWord );
//STRIP001 	virtual void SetLanguage( const sal_uInt16 nLang ); // Sprache aendern
//STRIP001 	virtual void AutoCorrect( const String& rAktStr, const String& rNewStr );
//STRIP001 	virtual void InsertHyphen( const sal_uInt16 nPos ); // Hyphen einfuegen
//STRIP001 
//STRIP001 protected:
//STRIP001 	// access methods to the relevant items of the dialog, so we do not need
//STRIP001 	// to export the dialog anymore
//STRIP001 	String			GetNewEditWord();
//STRIP001 	void			SetNewEditWord( const String& _rNew );
//STRIP001 };

}//end of namespace binfilter
#endif

