/*************************************************************************
 *
 *  $RCSfile: svdibrow.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:29:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVDIBROW_HXX
#define _SVDIBROW_HXX

// auto strip #ifndef _SVX_BRWBOX_HXX //autogen
// auto strip #include <svtools/brwbox.hxx>
// auto strip #endif

// auto strip #ifndef _SV_EDIT_HXX //autogen
// auto strip #include <vcl/edit.hxx>
// auto strip #endif

// auto strip #ifndef _SV_FLOATWIN_HXX //autogen
// auto strip #include <vcl/floatwin.hxx>
// auto strip #endif
class SfxItemSet;
namespace binfilter {

class ImpItemListRow;
class BrowserMouseEvent;

//STRIP001 class _SdrItemBrowserControl: public BrowseBox 
//STRIP001 {
//STRIP001 friend class ImpItemEdit;
//STRIP001 	Container aList;
//STRIP001 	long nAktPaintRow;
//STRIP001 	Edit* pEditControl;
//STRIP001 	XubString aWNamMerk;
//STRIP001 	Link aEntryChangedHdl;
//STRIP001 	Link aSetDirtyHdl;
//STRIP001 	ImpItemListRow* pAktChangeEntry;
//STRIP001 	long   nLastWhichOfs;
//STRIP001 	USHORT nLastWhich;
//STRIP001 	USHORT nLastWhichOben;
//STRIP001 	USHORT nLastWhichUnten;
//STRIP001 	FASTBOOL bWhichesButNames;
//STRIP001 	FASTBOOL bDontHideIneffectiveItems;
//STRIP001 	FASTBOOL bDontSortItems;
//STRIP001 	FASTBOOL bShowWhichIds;
//STRIP001 	FASTBOOL bShowRealValues;
//STRIP001 private:
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	void ImpCtor();
//STRIP001 	void ImpSetEntry(const ImpItemListRow& rEntry, ULONG nEntryNum);
//STRIP001 	ImpItemListRow* ImpGetEntry(ULONG nPos) const { return (ImpItemListRow*)aList.GetObject(nPos); }
//STRIP001 	void ImpSaveWhich();
//STRIP001 	void ImpRestoreWhich();
//STRIP001 #endif // __PRIVATE
//STRIP001 protected:
//STRIP001 	virtual long GetRowCount() const;
//STRIP001 	virtual BOOL SeekRow(long nRow);
//STRIP001 	virtual void PaintField(OutputDevice& rDev, const Rectangle& rRect, USHORT nColumnId) const;
//STRIP001 #if SUPD >= 345
//STRIP001 	virtual void DoubleClick(const BrowserMouseEvent&);
//STRIP001 #else
//STRIP001 	virtual void DoubleClick();
//STRIP001 #endif
//STRIP001 	virtual void KeyInput(const KeyEvent& rEvt);
//STRIP001 	virtual void Select();
//STRIP001 	virtual void SetDirty(); // wird z.B. bei Modusumschaltungen gerufen
//STRIP001 	virtual Rectangle GetFieldCharacterBounds(sal_Int32 _nRow,sal_Int32 _nColumnPos,sal_Int32 nIndex);
//STRIP001 	virtual sal_Int32 GetFieldIndexAtPoint(sal_Int32 _nRow,sal_Int32 _nColumnPos,const Point& _rPoint);
//STRIP001 public:
//STRIP001 	_SdrItemBrowserControl(Window* pParent, WinBits nBits=WB_3DLOOK|WB_BORDER|WB_TABSTOP);
//STRIP001 	virtual ~_SdrItemBrowserControl();
//STRIP001 	void Clear();
//STRIP001 	void SetAttributes(const SfxItemSet* pAttr, const SfxItemSet* p2ndSet=NULL);
//STRIP001 	ULONG GetCurrentPos() const;
//STRIP001 	USHORT GetCurrentWhich() const;
//STRIP001 	virtual FASTBOOL BegChangeEntry(ULONG nPos);
//STRIP001 	virtual FASTBOOL EndChangeEntry();
//STRIP001 	virtual void     BrkChangeEntry();
//STRIP001 	
//STRIP001 	/** GetCellText returns the text at the given position
//STRIP001 		@param	_nRow
//STRIP001 			the number of the row
//STRIP001 		@param	_nColId
//STRIP001 			the ID of the column
//STRIP001 		@return
//STRIP001 			the text out of the cell
//STRIP001 	*/
//STRIP001 	virtual String	GetCellText(long _nRow, USHORT _nColId) const;
//STRIP001 
//STRIP001 	const ImpItemListRow* GetAktChangeEntry() const { return pAktChangeEntry; }
//STRIP001 	XubString GetNewEntryValue() const                 { return pEditControl->GetText(); }
//STRIP001 	void SetEntryChangedHdl(const Link& rLink)      { aEntryChangedHdl=rLink; }
//STRIP001 	const Link& GetEntryChangedHdl() const          { return aEntryChangedHdl; }
//STRIP001 	void SetSetDirtyHdl(const Link& rLink)          { aSetDirtyHdl=rLink; }
//STRIP001 	const Link& GetSetDirtyHdl() const              { return aSetDirtyHdl; }
//STRIP001 };

#define WB_STDSIZEABLEDOCKWIN  (WB_STDDOCKWIN|WB_3DLOOK|WB_CLOSEABLE|WB_SIZEMOVE)
#define WB_STDSIZEABLEFLOATWIN (WB_STDFLOATWIN|WB_3DLOOK|WB_CLOSEABLE|WB_SIZEMOVE)

//STRIP001 class _SdrItemBrowserWindow: public FloatingWindow {
//STRIP001 	_SdrItemBrowserControl aBrowse;
//STRIP001 public:
//STRIP001 	_SdrItemBrowserWindow(Window* pParent, WinBits nBits=WB_STDSIZEABLEDOCKWIN);
//STRIP001 	virtual ~_SdrItemBrowserWindow();
//STRIP001 	virtual void Resize();
//STRIP001 	virtual void GetFocus();
//STRIP001 	void Clear()                                            { aBrowse.Clear(); }
//STRIP001 	void SetAttributes(const SfxItemSet* pAttr, const SfxItemSet* p2ndSet=NULL) { aBrowse.SetAttributes(pAttr,p2ndSet); }
//STRIP001 	void SetFloatingMode(FASTBOOL bOn) {}
//STRIP001 	const _SdrItemBrowserControl& GetBrowserControl() const { return aBrowse; }
//STRIP001 	_SdrItemBrowserControl& GetBrowserControl()             { return aBrowse; }
//STRIP001 };

class SdrView;

//STRIP001 class SdrItemBrowser: public _SdrItemBrowserWindow {
//STRIP001 	Timer aIdleTimer;
//STRIP001 	SdrView* pView;
//STRIP001 	FASTBOOL bDirty;
//STRIP001 private:
//STRIP001 	static Window* ImpGetViewWin(SdrView& rView);
//STRIP001 	DECL_LINK(IdleHdl,Timer*);
//STRIP001 	DECL_LINK(ChangedHdl,_SdrItemBrowserControl*);
//STRIP001 	DECL_LINK(SetDirtyHdl,_SdrItemBrowserControl*);
//STRIP001 public:
//STRIP001 	SdrItemBrowser(SdrView& rView);
//STRIP001 	void ForceParent();
//STRIP001 	void SetView(SdrView& rView) { pView=&rView; ForceParent(); SetDirty(); }
//STRIP001 	void SetDirty();
//STRIP001 	void Undirty();
//STRIP001 	void ForceUndirty() { if (bDirty) Undirty(); }
//STRIP001 };

}//end of namespace binfilter
#endif //_SVDIBROW_HXX


